/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC convert
 */

#ifndef _RELIABLEFILETRANSFERFACTORYSERVICE_H_
#define _RELIABLEFILETRANSFERFACTORYSERVICE_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "globus_handler.h"
#include "globus_soap_message.h"
#include "globus_xsd_type_registry.h"

#define RELIABLEFILETRANSFERFACTORYSERVICE_BASE_PATH "wsrf/services/ReliableFileTransferFactoryService"

extern xsd_QName ReliableFileTransferFactoryService_service_qname;

globus_result_t
ReliableFileTransferFactoryService_registry_add_types(
    globus_xsd_type_registry_t          registry);

globus_result_t
ReliableFileTransferFactoryService_registry_remove_types(
    globus_xsd_type_registry_t          registry);


#include "xsd_QName.h"
#include "wsrp_GetResourcePropertyResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_GetMultipleResourcePropertiesType.h"
#include "wsrp_GetMultipleResourcePropertiesResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_QueryResourcePropertiesType.h"
#include "wsrp_QueryResourcePropertiesResponseType.h"
#include "wsrp_UnknownQueryExpressionDialectFaultType.h"
#include "wsrp_UnknownQueryExpressionDialectFault.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_QueryEvaluationErrorFaultType.h"
#include "wsrp_QueryEvaluationErrorFault.h"
#include "wsrp_InvalidQueryExpressionFaultType.h"
#include "wsrp_InvalidQueryExpressionFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wstransfer_CreateReliableFileTransferInputType.h"
#include "wstransfer_CreateReliableFileTransferOutputType.h"
#include "wsbf_BaseFaultType.h"
#include "wsbf_BaseFault.h"

/* fault type declaration for the GetResourceProperty operation */

typedef enum
{
    RELIABLEFILETRANSFERFACTORYPORTTYPE_GETRESOURCEPROPERTY_NOFAULT = 0,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_GETRESOURCEPROPERTY_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_GETRESOURCEPROPERTY_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_GETRESOURCEPROPERTY_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ReliableFileTransferFactoryPortType_GetResourceProperty_fault_t;


/* qname for operation GetResourceProperty */

extern xsd_QName ReliableFileTransferFactoryPortType_GetResourceProperty_op_qname;



/* fault type declaration for the GetMultipleResourceProperties operation */

typedef enum
{
    RELIABLEFILETRANSFERFACTORYPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_NOFAULT = 0,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_fault_t;


/* qname for operation GetMultipleResourceProperties */

extern xsd_QName ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_op_qname;



/* fault type declaration for the QueryResourceProperties operation */

typedef enum
{
    RELIABLEFILETRANSFERFACTORYPORTTYPE_QUERYRESOURCEPROPERTIES_NOFAULT = 0,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWNQUERYEXPRESSIONDIALECTFAULT,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_QUERYRESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_QUERYRESOURCEPROPERTIES_QUERYEVALUATIONERRORFAULT,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDQUERYEXPRESSIONFAULT,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ReliableFileTransferFactoryPortType_QueryResourceProperties_fault_t;


/* qname for operation QueryResourceProperties */

extern xsd_QName ReliableFileTransferFactoryPortType_QueryResourceProperties_op_qname;



/* fault type declaration for the createReliableFileTransfer operation */

typedef enum
{
    RELIABLEFILETRANSFERFACTORYPORTTYPE_CREATERELIABLEFILETRANSFER_NOFAULT = 0,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_CREATERELIABLEFILETRANSFER_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERFACTORYPORTTYPE_CREATERELIABLEFILETRANSFER_CREATERELIABLEFILETRANSFERFAULT

} ReliableFileTransferFactoryPortType_createReliableFileTransfer_fault_t;


/* qname for operation createReliableFileTransfer */

extern xsd_QName ReliableFileTransferFactoryPortType_createReliableFileTransfer_op_qname;


/* ResourceProperty element QNames */

extern xsd_QName ReliableFileTransferFactoryPortType_ActiveResourceInstances_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferFactoryPortType_ActiveResourceInstances_rp_info;

extern xsd_QName ReliableFileTransferFactoryPortType_TotalNumberOfTransfers_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferFactoryPortType_TotalNumberOfTransfers_rp_info;

extern xsd_QName ReliableFileTransferFactoryPortType_TotalNumberOfActiveTransfers_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferFactoryPortType_TotalNumberOfActiveTransfers_rp_info;

extern xsd_QName ReliableFileTransferFactoryPortType_TotalNumberOfBytesTransferred_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferFactoryPortType_TotalNumberOfBytesTransferred_rp_info;

extern xsd_QName ReliableFileTransferFactoryPortType_RFTFactoryStartTime_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferFactoryPortType_RFTFactoryStartTime_rp_info;

extern xsd_QName ReliableFileTransferFactoryPortType_DelegationServiceEPR_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferFactoryPortType_DelegationServiceEPR_rp_info;

    
EXTERN_C_END

#endif
