/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _RELIABLEFILETRANSFERFACTORYSERVICE_CLIENT_H_
#define _RELIABLEFILETRANSFERFACTORYSERVICE_CLIENT_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "ReliableFileTransferFactoryService.h"
#include "wsa_EndpointReferenceType.h"
#include "globus_soap_message_attrs.h"

#define WSADDRESSING_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"

/**
 * @defgroup ReliableFileTransferFactoryService_client ReliableFileTransferFactoryService Client Bindings
 */

extern globus_module_descriptor_t ReliableFileTransferFactoryService_i_module;
/**
 * Module descriptor for the client stubs bindings for the
 * ReliableFileTransferFactoryService service.
 * @ingroup ReliableFileTransferFactoryService_client
 * @hideinitializer
 *
 * This module must be activated before calling any functions in the ReliableFileTransferFactoryService
 * client bindings API.
 */
#define RELIABLEFILETRANSFERFACTORYSERVICE_MODULE (&ReliableFileTransferFactoryService_i_module)

/**
 * @defgroup ReliableFileTransferFactoryService_client_handle Client Handle Functions and Types
 * @ingroup ReliableFileTransferFactoryService_client
 */

/**
 * Handle for the ReliableFileTransferFactoryService client.
 * @ingroup ReliableFileTransferFactoryService_client_handle
 *
 * A handle must be created by the client application before calling any
 * SOAP operation. Only one operation may be in progress per handle at
 * any given time.
 *
 * @see ReliableFileTransferFactoryService_client_init(), ReliableFileTransferFactoryService_client_destroy()
 */
typedef struct ReliableFileTransferFactoryService_client_handle_s * ReliableFileTransferFactoryService_client_handle_t;



/* Type and function declarations for the GetResourceProperty
 * operation
 */

/**
 * @defgroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation GetResourceProperty Operation
 * @ingroup ReliableFileTransferFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetResourceProperty requests of the ReliableFileTransferFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ReliableFileTransferFactoryPortType_GetResourceProperty() and ReliableFileTransferFactoryPortType_GetResourceProperty_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ReliableFileTransferFactoryPortType_GetResourceProperty_register() and
 * ReliableFileTransferFactoryPortType_GetResourceProperty_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetResourceProperty</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ReliableFileTransferFactoryPortType_GetResourceProperty_request_callback_func_t)(
    ReliableFileTransferFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetResourceProperty_epr_register_request(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    ReliableFileTransferFactoryPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetResourceProperty_register_request(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    ReliableFileTransferFactoryPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetResourceProperty</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ReliableFileTransferFactoryPortType_GetResourceProperty_response_callback_func_t)(
    ReliableFileTransferFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetResourcePropertyResponseType * GetResourcePropertyResponse,
    ReliableFileTransferFactoryPortType_GetResourceProperty_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 * Begin parsing the request for the <code>GetResourceProperty</code> operation begun
 * by an earlier call to
 * ReliableFileTransferFactoryPortType_GetResourceProperty_register_request() or
 * ReliableFileTransferFactoryPortType_GetResourceProperty_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetResourceProperty_register_response(
    ReliableFileTransferFactoryService_client_handle_t handle,
    ReliableFileTransferFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetResourceProperty_epr_register(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    ReliableFileTransferFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetResourceProperty_register(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    ReliableFileTransferFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ReliableFileTransferFactoryPortType_GetResourceProperty_epr(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    ReliableFileTransferFactoryPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ReliableFileTransferFactoryPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ReliableFileTransferFactoryPortType_GetResourceProperty(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    ReliableFileTransferFactoryPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the GetMultipleResourceProperties
 * operation
 */

/**
 * @defgroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation GetMultipleResourceProperties Operation
 * @ingroup ReliableFileTransferFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetMultipleResourceProperties requests of the ReliableFileTransferFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ReliableFileTransferFactoryPortType_GetMultipleResourceProperties() and ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_register() and
 * ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetMultipleResourceProperties</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_request_callback_func_t)(
    ReliableFileTransferFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 * Begin sending a request for the <code>GetMultipleResourceProperties</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_epr_register_request(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 * Begin sending a request for the <code>GetMultipleResourceProperties</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_register_request(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetMultipleResourceProperties</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_response_callback_func_t)(
    ReliableFileTransferFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetMultipleResourcePropertiesResponseType * GetMultipleResourcePropertiesResponse,
    ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 * Begin parsing the request for the <code>GetMultipleResourceProperties</code> operation begun
 * by an earlier call to
 * ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_register_request() or
 * ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_register_response(
    ReliableFileTransferFactoryService_client_handle_t handle,
    ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 *
 * Begin processing a request for the GetMultipleResourceProperties operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_epr_register(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 *
 * Begin processing a request for the GetMultipleResourceProperties operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_register(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 *
 * Request that an the GetMultipleResourceProperties operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetMultipleResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.

 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_epr(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    wsrp_GetMultipleResourcePropertiesResponseType * * GetMultipleResourcePropertiesResponse,
    ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_operation
 *
 * Request that an the GetMultipleResourceProperties operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetMultipleResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.

 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ReliableFileTransferFactoryPortType_GetMultipleResourceProperties(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    wsrp_GetMultipleResourcePropertiesResponseType * * GetMultipleResourcePropertiesResponse,
    ReliableFileTransferFactoryPortType_GetMultipleResourceProperties_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the QueryResourceProperties
 * operation
 */

/**
 * @defgroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation QueryResourceProperties Operation
 * @ingroup ReliableFileTransferFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making QueryResourceProperties requests of the ReliableFileTransferFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ReliableFileTransferFactoryPortType_QueryResourceProperties() and ReliableFileTransferFactoryPortType_QueryResourceProperties_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ReliableFileTransferFactoryPortType_QueryResourceProperties_register() and
 * ReliableFileTransferFactoryPortType_QueryResourceProperties_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>QueryResourceProperties</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ReliableFileTransferFactoryPortType_QueryResourceProperties_request_callback_func_t)(
    ReliableFileTransferFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 * Begin sending a request for the <code>QueryResourceProperties</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_QueryResourceProperties_epr_register_request(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    ReliableFileTransferFactoryPortType_QueryResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 * Begin sending a request for the <code>QueryResourceProperties</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_QueryResourceProperties_register_request(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    ReliableFileTransferFactoryPortType_QueryResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>QueryResourceProperties</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ReliableFileTransferFactoryPortType_QueryResourceProperties_response_callback_func_t)(
    ReliableFileTransferFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_QueryResourcePropertiesResponseType * QueryResourcePropertiesResponse,
    ReliableFileTransferFactoryPortType_QueryResourceProperties_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 * Begin parsing the request for the <code>QueryResourceProperties</code> operation begun
 * by an earlier call to
 * ReliableFileTransferFactoryPortType_QueryResourceProperties_register_request() or
 * ReliableFileTransferFactoryPortType_QueryResourceProperties_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_QueryResourceProperties_register_response(
    ReliableFileTransferFactoryService_client_handle_t handle,
    ReliableFileTransferFactoryPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 *
 * Begin processing a request for the QueryResourceProperties operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_QueryResourceProperties_epr_register(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    ReliableFileTransferFactoryPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 *
 * Begin processing a request for the QueryResourceProperties operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_QueryResourceProperties_register(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    ReliableFileTransferFactoryPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 *
 * Request that an the QueryResourceProperties operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a QueryResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.

 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ReliableFileTransferFactoryPortType_QueryResourceProperties_epr(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * * QueryResourcePropertiesResponse,
    ReliableFileTransferFactoryPortType_QueryResourceProperties_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ReliableFileTransferFactoryPortType_QueryResourceProperties_operation
 *
 * Request that an the QueryResourceProperties operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a QueryResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.

 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ReliableFileTransferFactoryPortType_QueryResourceProperties(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * * QueryResourcePropertiesResponse,
    ReliableFileTransferFactoryPortType_QueryResourceProperties_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the createReliableFileTransfer
 * operation
 */

/**
 * @defgroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation createReliableFileTransfer Operation
 * @ingroup ReliableFileTransferFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making createReliableFileTransfer requests of the ReliableFileTransferFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ReliableFileTransferFactoryPortType_createReliableFileTransfer() and ReliableFileTransferFactoryPortType_createReliableFileTransfer_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ReliableFileTransferFactoryPortType_createReliableFileTransfer_register() and
 * ReliableFileTransferFactoryPortType_createReliableFileTransfer_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>createReliableFileTransfer</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ReliableFileTransferFactoryPortType_createReliableFileTransfer_request_callback_func_t)(
    ReliableFileTransferFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 * Begin sending a request for the <code>createReliableFileTransfer</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createReliableFileTransferRequest
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_createReliableFileTransfer_epr_register_request(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wstransfer_CreateReliableFileTransferInputType * createReliableFileTransferRequest,
    ReliableFileTransferFactoryPortType_createReliableFileTransfer_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 * Begin sending a request for the <code>createReliableFileTransfer</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createReliableFileTransferRequest
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_createReliableFileTransfer_register_request(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wstransfer_CreateReliableFileTransferInputType * createReliableFileTransferRequest,
    ReliableFileTransferFactoryPortType_createReliableFileTransfer_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>createReliableFileTransfer</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param createReliableFileTransferResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ReliableFileTransferFactoryPortType_createReliableFileTransfer_response_callback_func_t)(
    ReliableFileTransferFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wstransfer_CreateReliableFileTransferOutputType * createReliableFileTransferResponse,
    ReliableFileTransferFactoryPortType_createReliableFileTransfer_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 * Begin parsing the request for the <code>createReliableFileTransfer</code> operation begun
 * by an earlier call to
 * ReliableFileTransferFactoryPortType_createReliableFileTransfer_register_request() or
 * ReliableFileTransferFactoryPortType_createReliableFileTransfer_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_createReliableFileTransfer_register_response(
    ReliableFileTransferFactoryService_client_handle_t handle,
    ReliableFileTransferFactoryPortType_createReliableFileTransfer_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 *
 * Begin processing a request for the createReliableFileTransfer operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createReliableFileTransferRequest
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_createReliableFileTransfer_epr_register(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wstransfer_CreateReliableFileTransferInputType * createReliableFileTransferRequest,
    ReliableFileTransferFactoryPortType_createReliableFileTransfer_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 *
 * Begin processing a request for the createReliableFileTransfer operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createReliableFileTransferRequest
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ReliableFileTransferFactoryPortType_createReliableFileTransfer_register(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wstransfer_CreateReliableFileTransferInputType * createReliableFileTransferRequest,
    ReliableFileTransferFactoryPortType_createReliableFileTransfer_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 *
 * Request that an the createReliableFileTransfer operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a createReliableFileTransferResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createReliableFileTransferRequest
 *     Input parameter to the operation.

 * @param createReliableFileTransferResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ReliableFileTransferFactoryPortType_createReliableFileTransfer_epr(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wstransfer_CreateReliableFileTransferInputType * createReliableFileTransferRequest,
    wstransfer_CreateReliableFileTransferOutputType * * createReliableFileTransferResponse,
    ReliableFileTransferFactoryPortType_createReliableFileTransfer_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ReliableFileTransferFactoryPortType_createReliableFileTransfer_operation
 *
 * Request that an the createReliableFileTransfer operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a createReliableFileTransferResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ReliableFileTransferFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createReliableFileTransferRequest
 *     Input parameter to the operation.

 * @param createReliableFileTransferResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ReliableFileTransferFactoryPortType_createReliableFileTransfer(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * endpoint,
    const wstransfer_CreateReliableFileTransferInputType * createReliableFileTransferRequest,
    wstransfer_CreateReliableFileTransferOutputType * * createReliableFileTransferResponse,
    ReliableFileTransferFactoryPortType_createReliableFileTransfer_fault_t * fault_type,
    xsd_any * * fault);



/**
 * Initialize a client handle
 * @ingroup ReliableFileTransferFactoryService_client_handle
 * Initialize new client handle state for use with operation-related functions.
 *
 * @param handle
 *     Pointer to the handle to initialize.
 * @param attrs
 *    Default attributes to use with this handle. This parameter may be NULL.
 *    Certain atttributes may cause different handlers to be pushed onto the
 *    default handler chain for this client.
 * @param handlers
 *    Handle chain to use with this handle. This parameter may be NULL.
 *    Typically the default handler chain used by this function is sufficient.
 */
globus_result_t
ReliableFileTransferFactoryService_client_init(
    ReliableFileTransferFactoryService_client_handle_t *  handle,
    globus_soap_message_attr_t attrs,
    globus_handler_chain_t handlers);

/**
 * Destroy a client handle
 * @ingroup ReliableFileTransferFactoryService_client_handle
 *
 * Destroys the state associated with this client handle.
 *
 * @param handle
 *     Handle to destroy.
 */
void
ReliableFileTransferFactoryService_client_destroy(
    ReliableFileTransferFactoryService_client_handle_t handle);

/**
 * Cancel the current operation associated with this handle.
 * @ingroup ReliableFileTransferFactoryService_client_handle
 * 
 * @param handle
 *     Handle which has the operation to cancel.
 */
globus_result_t
ReliableFileTransferFactoryService_client_operation_cancel(
    ReliableFileTransferFactoryService_client_handle_t handle);

/**
 * Get handle's type registry
 * @ingroup ReliableFileTransferFactoryService_client_handle
 *
 * The type registry maps XML element names to type information structures.
 * Applications may wish to get the registry from a handle to set extra
 * type mappings (for example, to set a mapping for an element which is
 * to be received as part of an extensibility element).
 *
 * @param handle
 *     The handle to query.
 * @param registry
 *     A pointer to a registry handle which will be set to the handle's
 *     registry.
 */
globus_result_t
ReliableFileTransferFactoryService_client_get_registry(
    ReliableFileTransferFactoryService_client_handle_t handle,
    globus_xsd_type_registry_t * registry);

/**
 * Get handle's handler chain
 * @ingroup ReliableFileTransferFactoryService_client_handle
 *
 * The handler chain contains information about which handlers (typically
 * SOAP header processors) will be invoked when a request is sent or a
 * response is received. Applications which want to add custom handlers at
 * run time may wish to push additional handlers onto this chain.
 *
 * @param handle
 *     The handle to query.
 * @param handlers
 *     A pointer to a handler chain which will be set to the handle's
 *     chain.
 */
globus_result_t
ReliableFileTransferFactoryService_client_get_handler_chain(
    ReliableFileTransferFactoryService_client_handle_t handle,
    globus_handler_chain_t * handlers);

/**
 * Set a SOAP attribute on a handle
 * @ingroup ReliableFileTransferFactoryService_client_handle
 *
 * Set a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * @param copy
 *     A function to copy the value. This is required if @a value will go
 *     out of scope.
 * @param destroy
 *     A function to destroy a copy of the value. Required if @a copy is set.
 * @param value
 *     The new value of the attribute.
 */
globus_result_t
ReliableFileTransferFactoryService_client_attr_set(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * prop_name,
    globus_soap_message_attr_copy_func_t copy,
    globus_soap_message_attr_destroy_func_t destroy,
    void * value);

/**
 * Remove a SOAP attribute from a handle
 * @ingroup ReliableFileTransferFactoryService_client_handle
 *
 * Remove a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
ReliableFileTransferFactoryService_client_attr_remove(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * prop_name);

/**
 * Get a SOAP attribute from a handle
 * @ingroup ReliableFileTransferFactoryService_client_handle
 *
 * Get the current value of a SOAP attribute set on a handle. 
 *
 * @param handle
 *     The handle to query.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
ReliableFileTransferFactoryService_client_attr_get(
    ReliableFileTransferFactoryService_client_handle_t handle,
    const char * prop_name);

EXTERN_C_END

#endif
