/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _SUBSCRIPTIONMANAGERSERVICE_CLIENT_H_
#define _SUBSCRIPTIONMANAGERSERVICE_CLIENT_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "SubscriptionManagerService.h"
#include "wsa_EndpointReferenceType.h"
#include "globus_soap_message_attrs.h"

#define WSADDRESSING_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"

/**
 * @defgroup SubscriptionManagerService_client SubscriptionManagerService Client Bindings
 */

extern globus_module_descriptor_t SubscriptionManagerService_i_module;
/**
 * Module descriptor for the client stubs bindings for the
 * SubscriptionManagerService service.
 * @ingroup SubscriptionManagerService_client
 * @hideinitializer
 *
 * This module must be activated before calling any functions in the SubscriptionManagerService
 * client bindings API.
 */
#define SUBSCRIPTIONMANAGERSERVICE_MODULE (&SubscriptionManagerService_i_module)

/**
 * @defgroup SubscriptionManagerService_client_handle Client Handle Functions and Types
 * @ingroup SubscriptionManagerService_client
 */

/**
 * Handle for the SubscriptionManagerService client.
 * @ingroup SubscriptionManagerService_client_handle
 *
 * A handle must be created by the client application before calling any
 * SOAP operation. Only one operation may be in progress per handle at
 * any given time.
 *
 * @see SubscriptionManagerService_client_init(), SubscriptionManagerService_client_destroy()
 */
typedef struct SubscriptionManagerService_client_handle_s * SubscriptionManagerService_client_handle_t;



/* Type and function declarations for the ResumeSubscription
 * operation
 */

/**
 * @defgroup SubscriptionManager_ResumeSubscription_operation ResumeSubscription Operation
 * @ingroup SubscriptionManagerService_client
 *
 * The functions and types in this group are used by clients which will
 * be making ResumeSubscription requests of the SubscriptionManagerService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * SubscriptionManager_ResumeSubscription() and SubscriptionManager_ResumeSubscription_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, SubscriptionManager_ResumeSubscription_register() and
 * SubscriptionManager_ResumeSubscription_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>ResumeSubscription</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* SubscriptionManager_ResumeSubscription_request_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 * Begin sending a request for the <code>ResumeSubscription</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param ResumeSubscription
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_ResumeSubscription_epr_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_ResumeSubscriptionType * ResumeSubscription,
    SubscriptionManager_ResumeSubscription_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 * Begin sending a request for the <code>ResumeSubscription</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param ResumeSubscription
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_ResumeSubscription_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsnt_ResumeSubscriptionType * ResumeSubscription,
    SubscriptionManager_ResumeSubscription_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>ResumeSubscription</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param ResumeSubscriptionResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* SubscriptionManager_ResumeSubscription_response_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsnt_ResumeSubscriptionResponseType * ResumeSubscriptionResponse,
    SubscriptionManager_ResumeSubscription_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 * Begin parsing the request for the <code>ResumeSubscription</code> operation begun
 * by an earlier call to
 * SubscriptionManager_ResumeSubscription_register_request() or
 * SubscriptionManager_ResumeSubscription_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_ResumeSubscription_register_response(
    SubscriptionManagerService_client_handle_t handle,
    SubscriptionManager_ResumeSubscription_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 *
 * Begin processing a request for the ResumeSubscription operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param ResumeSubscription
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_ResumeSubscription_epr_register(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_ResumeSubscriptionType * ResumeSubscription,
    SubscriptionManager_ResumeSubscription_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 *
 * Begin processing a request for the ResumeSubscription operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param ResumeSubscription
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_ResumeSubscription_register(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsnt_ResumeSubscriptionType * ResumeSubscription,
    SubscriptionManager_ResumeSubscription_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 *
 * Request that an the ResumeSubscription operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a ResumeSubscriptionResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param ResumeSubscription
 *     Input parameter to the operation.

 * @param ResumeSubscriptionResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_ResumeSubscription_epr(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_ResumeSubscriptionType * ResumeSubscription,
    wsnt_ResumeSubscriptionResponseType * * ResumeSubscriptionResponse,
    SubscriptionManager_ResumeSubscription_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup SubscriptionManager_ResumeSubscription_operation
 *
 * Request that an the ResumeSubscription operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a ResumeSubscriptionResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param ResumeSubscription
 *     Input parameter to the operation.

 * @param ResumeSubscriptionResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_ResumeSubscription(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsnt_ResumeSubscriptionType * ResumeSubscription,
    wsnt_ResumeSubscriptionResponseType * * ResumeSubscriptionResponse,
    SubscriptionManager_ResumeSubscription_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the PauseSubscription
 * operation
 */

/**
 * @defgroup SubscriptionManager_PauseSubscription_operation PauseSubscription Operation
 * @ingroup SubscriptionManagerService_client
 *
 * The functions and types in this group are used by clients which will
 * be making PauseSubscription requests of the SubscriptionManagerService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * SubscriptionManager_PauseSubscription() and SubscriptionManager_PauseSubscription_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, SubscriptionManager_PauseSubscription_register() and
 * SubscriptionManager_PauseSubscription_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup SubscriptionManager_PauseSubscription_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>PauseSubscription</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* SubscriptionManager_PauseSubscription_request_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup SubscriptionManager_PauseSubscription_operation
 * Begin sending a request for the <code>PauseSubscription</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param PauseSubscription
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_PauseSubscription_epr_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_PauseSubscriptionType * PauseSubscription,
    SubscriptionManager_PauseSubscription_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup SubscriptionManager_PauseSubscription_operation
 * Begin sending a request for the <code>PauseSubscription</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param PauseSubscription
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_PauseSubscription_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsnt_PauseSubscriptionType * PauseSubscription,
    SubscriptionManager_PauseSubscription_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup SubscriptionManager_PauseSubscription_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>PauseSubscription</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param PauseSubscriptionResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* SubscriptionManager_PauseSubscription_response_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsnt_PauseSubscriptionResponseType * PauseSubscriptionResponse,
    SubscriptionManager_PauseSubscription_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup SubscriptionManager_PauseSubscription_operation
 * Begin parsing the request for the <code>PauseSubscription</code> operation begun
 * by an earlier call to
 * SubscriptionManager_PauseSubscription_register_request() or
 * SubscriptionManager_PauseSubscription_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_PauseSubscription_register_response(
    SubscriptionManagerService_client_handle_t handle,
    SubscriptionManager_PauseSubscription_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup SubscriptionManager_PauseSubscription_operation
 *
 * Begin processing a request for the PauseSubscription operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param PauseSubscription
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_PauseSubscription_epr_register(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_PauseSubscriptionType * PauseSubscription,
    SubscriptionManager_PauseSubscription_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup SubscriptionManager_PauseSubscription_operation
 *
 * Begin processing a request for the PauseSubscription operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param PauseSubscription
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_PauseSubscription_register(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsnt_PauseSubscriptionType * PauseSubscription,
    SubscriptionManager_PauseSubscription_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup SubscriptionManager_PauseSubscription_operation
 *
 * Request that an the PauseSubscription operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a PauseSubscriptionResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param PauseSubscription
 *     Input parameter to the operation.

 * @param PauseSubscriptionResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_PauseSubscription_epr(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_PauseSubscriptionType * PauseSubscription,
    wsnt_PauseSubscriptionResponseType * * PauseSubscriptionResponse,
    SubscriptionManager_PauseSubscription_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup SubscriptionManager_PauseSubscription_operation
 *
 * Request that an the PauseSubscription operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a PauseSubscriptionResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param PauseSubscription
 *     Input parameter to the operation.

 * @param PauseSubscriptionResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_PauseSubscription(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsnt_PauseSubscriptionType * PauseSubscription,
    wsnt_PauseSubscriptionResponseType * * PauseSubscriptionResponse,
    SubscriptionManager_PauseSubscription_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the SetTerminationTime
 * operation
 */

/**
 * @defgroup SubscriptionManager_SetTerminationTime_operation SetTerminationTime Operation
 * @ingroup SubscriptionManagerService_client
 *
 * The functions and types in this group are used by clients which will
 * be making SetTerminationTime requests of the SubscriptionManagerService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * SubscriptionManager_SetTerminationTime() and SubscriptionManager_SetTerminationTime_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, SubscriptionManager_SetTerminationTime_register() and
 * SubscriptionManager_SetTerminationTime_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>SetTerminationTime</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* SubscriptionManager_SetTerminationTime_request_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 * Begin sending a request for the <code>SetTerminationTime</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_SetTerminationTime_epr_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    SubscriptionManager_SetTerminationTime_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 * Begin sending a request for the <code>SetTerminationTime</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_SetTerminationTime_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    SubscriptionManager_SetTerminationTime_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>SetTerminationTime</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* SubscriptionManager_SetTerminationTime_response_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrl_SetTerminationTimeResponseType * SetTerminationTimeResponse,
    SubscriptionManager_SetTerminationTime_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 * Begin parsing the request for the <code>SetTerminationTime</code> operation begun
 * by an earlier call to
 * SubscriptionManager_SetTerminationTime_register_request() or
 * SubscriptionManager_SetTerminationTime_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_SetTerminationTime_register_response(
    SubscriptionManagerService_client_handle_t handle,
    SubscriptionManager_SetTerminationTime_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 *
 * Begin processing a request for the SetTerminationTime operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_SetTerminationTime_epr_register(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    SubscriptionManager_SetTerminationTime_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 *
 * Begin processing a request for the SetTerminationTime operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_SetTerminationTime_register(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    SubscriptionManager_SetTerminationTime_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 *
 * Request that an the SetTerminationTime operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SetTerminationTimeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.

 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_SetTerminationTime_epr(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    wsrl_SetTerminationTimeResponseType * * SetTerminationTimeResponse,
    SubscriptionManager_SetTerminationTime_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup SubscriptionManager_SetTerminationTime_operation
 *
 * Request that an the SetTerminationTime operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SetTerminationTimeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.

 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_SetTerminationTime(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    wsrl_SetTerminationTimeResponseType * * SetTerminationTimeResponse,
    SubscriptionManager_SetTerminationTime_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the Destroy
 * operation
 */

/**
 * @defgroup SubscriptionManager_Destroy_operation Destroy Operation
 * @ingroup SubscriptionManagerService_client
 *
 * The functions and types in this group are used by clients which will
 * be making Destroy requests of the SubscriptionManagerService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * SubscriptionManager_Destroy() and SubscriptionManager_Destroy_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, SubscriptionManager_Destroy_register() and
 * SubscriptionManager_Destroy_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup SubscriptionManager_Destroy_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>Destroy</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* SubscriptionManager_Destroy_request_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup SubscriptionManager_Destroy_operation
 * Begin sending a request for the <code>Destroy</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_Destroy_epr_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    SubscriptionManager_Destroy_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup SubscriptionManager_Destroy_operation
 * Begin sending a request for the <code>Destroy</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_Destroy_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    SubscriptionManager_Destroy_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup SubscriptionManager_Destroy_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>Destroy</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* SubscriptionManager_Destroy_response_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrl_DestroyResponseType * DestroyResponse,
    SubscriptionManager_Destroy_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup SubscriptionManager_Destroy_operation
 * Begin parsing the request for the <code>Destroy</code> operation begun
 * by an earlier call to
 * SubscriptionManager_Destroy_register_request() or
 * SubscriptionManager_Destroy_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_Destroy_register_response(
    SubscriptionManagerService_client_handle_t handle,
    SubscriptionManager_Destroy_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup SubscriptionManager_Destroy_operation
 *
 * Begin processing a request for the Destroy operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_Destroy_epr_register(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    SubscriptionManager_Destroy_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup SubscriptionManager_Destroy_operation
 *
 * Begin processing a request for the Destroy operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_Destroy_register(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    SubscriptionManager_Destroy_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup SubscriptionManager_Destroy_operation
 *
 * Request that an the Destroy operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a DestroyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.

 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_Destroy_epr(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    wsrl_DestroyResponseType * * DestroyResponse,
    SubscriptionManager_Destroy_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup SubscriptionManager_Destroy_operation
 *
 * Request that an the Destroy operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a DestroyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.

 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_Destroy(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    wsrl_DestroyResponseType * * DestroyResponse,
    SubscriptionManager_Destroy_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the GetResourceProperty
 * operation
 */

/**
 * @defgroup SubscriptionManager_GetResourceProperty_operation GetResourceProperty Operation
 * @ingroup SubscriptionManagerService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetResourceProperty requests of the SubscriptionManagerService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * SubscriptionManager_GetResourceProperty() and SubscriptionManager_GetResourceProperty_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, SubscriptionManager_GetResourceProperty_register() and
 * SubscriptionManager_GetResourceProperty_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetResourceProperty</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* SubscriptionManager_GetResourceProperty_request_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_GetResourceProperty_epr_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    SubscriptionManager_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_GetResourceProperty_register_request(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    SubscriptionManager_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetResourceProperty</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* SubscriptionManager_GetResourceProperty_response_callback_func_t)(
    SubscriptionManagerService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetResourcePropertyResponseType * GetResourcePropertyResponse,
    SubscriptionManager_GetResourceProperty_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 * Begin parsing the request for the <code>GetResourceProperty</code> operation begun
 * by an earlier call to
 * SubscriptionManager_GetResourceProperty_register_request() or
 * SubscriptionManager_GetResourceProperty_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_GetResourceProperty_register_response(
    SubscriptionManagerService_client_handle_t handle,
    SubscriptionManager_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_GetResourceProperty_epr_register(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    SubscriptionManager_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
SubscriptionManager_GetResourceProperty_register(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    SubscriptionManager_GetResourceProperty_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_GetResourceProperty_epr(
    SubscriptionManagerService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    SubscriptionManager_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup SubscriptionManager_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #SubscriptionManagerService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
SubscriptionManager_GetResourceProperty(
    SubscriptionManagerService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    SubscriptionManager_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);



/**
 * Initialize a client handle
 * @ingroup SubscriptionManagerService_client_handle
 * Initialize new client handle state for use with operation-related functions.
 *
 * @param handle
 *     Pointer to the handle to initialize.
 * @param attrs
 *    Default attributes to use with this handle. This parameter may be NULL.
 *    Certain atttributes may cause different handlers to be pushed onto the
 *    default handler chain for this client.
 * @param handlers
 *    Handle chain to use with this handle. This parameter may be NULL.
 *    Typically the default handler chain used by this function is sufficient.
 */
globus_result_t
SubscriptionManagerService_client_init(
    SubscriptionManagerService_client_handle_t *  handle,
    globus_soap_message_attr_t attrs,
    globus_handler_chain_t handlers);

/**
 * Destroy a client handle
 * @ingroup SubscriptionManagerService_client_handle
 *
 * Destroys the state associated with this client handle.
 *
 * @param handle
 *     Handle to destroy.
 */
void
SubscriptionManagerService_client_destroy(
    SubscriptionManagerService_client_handle_t handle);

/**
 * Cancel the current operation associated with this handle.
 * @ingroup SubscriptionManagerService_client_handle
 * 
 * @param handle
 *     Handle which has the operation to cancel.
 */
globus_result_t
SubscriptionManagerService_client_operation_cancel(
    SubscriptionManagerService_client_handle_t handle);

/**
 * Get handle's type registry
 * @ingroup SubscriptionManagerService_client_handle
 *
 * The type registry maps XML element names to type information structures.
 * Applications may wish to get the registry from a handle to set extra
 * type mappings (for example, to set a mapping for an element which is
 * to be received as part of an extensibility element).
 *
 * @param handle
 *     The handle to query.
 * @param registry
 *     A pointer to a registry handle which will be set to the handle's
 *     registry.
 */
globus_result_t
SubscriptionManagerService_client_get_registry(
    SubscriptionManagerService_client_handle_t handle,
    globus_xsd_type_registry_t * registry);

/**
 * Get handle's handler chain
 * @ingroup SubscriptionManagerService_client_handle
 *
 * The handler chain contains information about which handlers (typically
 * SOAP header processors) will be invoked when a request is sent or a
 * response is received. Applications which want to add custom handlers at
 * run time may wish to push additional handlers onto this chain.
 *
 * @param handle
 *     The handle to query.
 * @param handlers
 *     A pointer to a handler chain which will be set to the handle's
 *     chain.
 */
globus_result_t
SubscriptionManagerService_client_get_handler_chain(
    SubscriptionManagerService_client_handle_t handle,
    globus_handler_chain_t * handlers);

/**
 * Set a SOAP attribute on a handle
 * @ingroup SubscriptionManagerService_client_handle
 *
 * Set a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * @param copy
 *     A function to copy the value. This is required if @a value will go
 *     out of scope.
 * @param destroy
 *     A function to destroy a copy of the value. Required if @a copy is set.
 * @param value
 *     The new value of the attribute.
 */
globus_result_t
SubscriptionManagerService_client_attr_set(
    SubscriptionManagerService_client_handle_t handle,
    const char * prop_name,
    globus_soap_message_attr_copy_func_t copy,
    globus_soap_message_attr_destroy_func_t destroy,
    void * value);

/**
 * Remove a SOAP attribute from a handle
 * @ingroup SubscriptionManagerService_client_handle
 *
 * Remove a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
SubscriptionManagerService_client_attr_remove(
    SubscriptionManagerService_client_handle_t handle,
    const char * prop_name);

/**
 * Get a SOAP attribute from a handle
 * @ingroup SubscriptionManagerService_client_handle
 *
 * Get the current value of a SOAP attribute set on a handle. 
 *
 * @param handle
 *     The handle to query.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
SubscriptionManagerService_client_attr_get(
    SubscriptionManagerService_client_handle_t handle,
    const char * prop_name);

EXTERN_C_END

#endif
