/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


#ifndef _GLOBUS_WS_ADDRESSING_H_
#define _GLOBUS_WS_ADDRESSING_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#define GLOBUS_HANDLER_WS_ADDRESSING_LIB "globus_handler_ws_addressing"
#define GLOBUS_HANDLER_WS_ADDRESSING_MODULE "ws_addressing"
#define GLOBUS_HANDLER_WS_ADDRESSING_CLIENT "globus_handler_ws_addressing_client"
#define GLOBUS_HANDLER_WS_ADDRESSING_SERVER "globus_handler_ws_addressing_server"

#define WSADDRESSING_NS                 "http://schemas.xmlsoap.org/ws/2004/03/addressing"

#define WSADDRESSING_ANON_NS            WSADDRESSING_NS"/role/anonymous"
#define WSADDRESSING_FAULT_NS           WSADDRESSING_NS"/fault"
#define WSADDRESSING_RU_NS              WSADDRESSING_NS"/id/unspecified"

#define WSADDR_EPR_KEY                  WSADDRESSING_NS"#EndpointReference"
#define WSADDR_OUTBOUND_MESSAGE_ID_KEY  WSADDRESSING_NS"#OutboundMessageID"
#define WSADDR_DESTINATION_KEY          WSADDRESSING_NS"#Destination"
#define WSADDR_ACTION_REQUEST_KEY       WSADDRESSING_NS"#ActionRequest"
#define WSADDR_SOURCE_ENDPOINT_KEY      WSADDRESSING_NS"#SourceEndpoint"
#define WSADDR_REPLY_ENDPOINT_KEY       WSADDRESSING_NS"#ReplyEndpoint"
#define WSADDR_FAULT_ENDPOINT_KEY       WSADDRESSING_NS"#FaultEndpoint"
#define WSADDR_MESSAGE_ID_KEY           WSADDRESSING_NS"#MessageID"
#define WSADDR_ACTION_RESPONSE_KEY      WSADDRESSING_NS"#ActionResponse"
#define WSADDR_REQUEST_ENDPOINT_KEY     WSADDRESSING_NS"#RequestEndpoint"
#define WSADDR_INBOUND_MESSAGE_ID_KEY   WSADDRESSING_NS"#InboundMessageID"
#define WSADDR_RELATES_TO_KEY           WSADDRESSING_NS"#RelatesTo"
#define WSADDR_OUTBOUND_EPR_KEY         WSADDRESSING_NS"#OutboundEPR"

#include "xsd_QName.h"

EXTERN_C_END

#endif
