/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSGRAM_INVALIDCREDENTIALSFAULTTYPE_H_
#define _WSGRAM_INVALIDCREDENTIALSFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsgram_InvalidCredentialsFaultType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/gram/job/faults}InvalidCredentialsFaultType element.
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
typedef struct wsgram_InvalidCredentialsFaultType_s wsgram_InvalidCredentialsFaultType;
/**
 * The wsgram_InvalidCredentialsFaultType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/gram/job/faults}InvalidCredentialsFaultType element.
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
typedef wsgram_InvalidCredentialsFaultType * wsgram_InvalidCredentialsFaultType_o;

/**
 * Namespace of the wsgram_InvalidCredentialsFaultType complex type
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
#define WSGRAM_INVALIDCREDENTIALSFAULTTYPE_NS "http://www.globus.org/namespaces/2004/10/gram/job/faults"
/**
 * Local part of the QName of the wsgram_InvalidCredentialsFaultType complex type
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
#define WSGRAM_INVALIDCREDENTIALSFAULTTYPE_LOCAL "InvalidCredentialsFaultType"

/**
 * QName of the wsgram_InvalidCredentialsFaultType complex type
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
extern xsd_QName wsgram_InvalidCredentialsFaultType_qname;
/**
 * Type information for serializing and deserializing wsgram_InvalidCredentialsFaultType elements
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
extern struct globus_xsd_type_info_s wsgram_InvalidCredentialsFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsgram_InvalidCredentialsFaultType
 * elements
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
extern struct globus_xsd_type_info_s wsgram_InvalidCredentialsFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsgram_InvalidCredentialsFaultType without surrounding elements
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
extern struct globus_xsd_type_info_s wsgram_InvalidCredentialsFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsgram_StateEnumeration.h"
#include "xsd_string.h"
#include "xsd_int.h"
#include "wsgram_InvalidCredentialsFaultType_array.h"

/**
 * @defgroup wsgram_InvalidCredentialsFaultType Complex type: wsgram_InvalidCredentialsFaultType
 * @ingroup types
 */

/**
 * C structure for the wsgram_InvalidCredentialsFaultType complex type
 * @ingroup wsgram_InvalidCredentialsFaultType
 */
struct wsgram_InvalidCredentialsFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;
    /** wsgram_StateEnumeration subelement */
    wsgram_StateEnumeration stateWhenFailureOccurred;
    /** xsd_string subelement */
    xsd_string command;
    /** xsd_int subelement */
    xsd_int gt2ErrorCode;

};

/**
 * Initialize a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 *
 * Allocates a new wsgram_InvalidCredentialsFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsgram_InvalidCredentialsFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_init(
    wsgram_InvalidCredentialsFaultType ** inst);

/**
 * Destroy a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 *
 * Frees a wsgram_InvalidCredentialsFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsgram_InvalidCredentialsFaultType_destroy(
    wsgram_InvalidCredentialsFaultType * inst);

/**
 * Copy a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 *
 * Perform a deep copy of a wsgram_InvalidCredentialsFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsgram_InvalidCredentialsFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsgram_InvalidCredentialsFaultType to be copied.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_copy(
    wsgram_InvalidCredentialsFaultType ** dest,
    const wsgram_InvalidCredentialsFaultType * src);

/**
 * Initialize the contents of a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 *
 * Initialize the contents of a wsgram_InvalidCredentialsFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsgram_InvalidCredentialsFaultType_init(). The contents may be freed
 * by calling wsgram_InvalidCredentialsFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsgram_InvalidCredentialsFaultType.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_init_contents(
    wsgram_InvalidCredentialsFaultType * instance);

/**
 * Destroy the contents of a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 *
 * Destroy the subelements and attributes of the given wsgram_InvalidCredentialsFaultType. 
 *
 * @param inst
 *     Pointer to a wsgram_InvalidCredentialsFaultType instance to destroy.
 */
void
wsgram_InvalidCredentialsFaultType_destroy_contents(
    wsgram_InvalidCredentialsFaultType * inst);

/**
 * Copy the contents of a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 *
 * Perform a deep copy of the contents of a wsgram_InvalidCredentialsFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsgram_InvalidCredentialsFaultType to be copied.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_copy_contents(
    wsgram_InvalidCredentialsFaultType * dest,
    const wsgram_InvalidCredentialsFaultType * src);

/**
 * Serialize a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType_array
 * Serialize a wsgram_InvalidCredentialsFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsgram_InvalidCredentialsFaultType.
 * @param val
 *     The wsgram_InvalidCredentialsFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_serialize(
    xsd_QName *                         element_name,
    wsgram_InvalidCredentialsFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType_array
 * Serialize a wsgram_InvalidCredentialsFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsgram_InvalidCredentialsFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsgram_InvalidCredentialsFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 * Deserialize an element containing a wsgram_InvalidCredentialsFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsgram_InvalidCredentialsFaultType.
 * @param val
 *     Pointer to the wsgram_InvalidCredentialsFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_deserialize(
    xsd_QName *                         element_name,
    wsgram_InvalidCredentialsFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 * Deserialize a wsgram_InvalidCredentialsFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsgram_InvalidCredentialsFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsgram_InvalidCredentialsFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsgram_InvalidCredentialsFaultType
 * @ingroup wsgram_InvalidCredentialsFaultType
 * Deserialize the next element if it contains a wsgram_InvalidCredentialsFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsgram_InvalidCredentialsFaultType.
 * @param instance
 *     Pointer to the <code>wsgram_InvalidCredentialsFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_InvalidCredentialsFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsgram_InvalidCredentialsFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsgram_InvalidCredentialsFaultType_init_wrapper(
    void **                             object);
    
void
wsgram_InvalidCredentialsFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsgram_InvalidCredentialsFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsgram_InvalidCredentialsFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsgram_InvalidCredentialsFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsgram_InvalidCredentialsFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsgram_InvalidCredentialsFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_InvalidCredentialsFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_InvalidCredentialsFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_InvalidCredentialsFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
