/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDL-to-C Converter
 */

#ifndef _WSGRAM_JOBTYPEENUMERATION_H_
#define _WSGRAM_JOBTYPEENUMERATION_H_

#include "globus_common.h"

/**
 * @defgroup wsgram_JobTypeEnumeration Simple Type: wsgram_JobTypeEnumeration
 * @ingroup types
 */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */


#include "xsd_string.h"

/**
 * @ingroup wsgram_JobTypeEnumeration
 */
typedef xsd_string wsgram_JobTypeEnumeration;

extern xsd_string wsgram_JobTypeEnumeration_mpi;
extern xsd_string wsgram_JobTypeEnumeration_single;
extern xsd_string wsgram_JobTypeEnumeration_multiple;
extern xsd_string wsgram_JobTypeEnumeration_condor;

/**
 * Optional wsgram_JobTypeEnumeration element
 * @ingroup wsgram_JobTypeEnumeration
 */
typedef wsgram_JobTypeEnumeration * wsgram_JobTypeEnumeration_o;

/**
 * Array of wsgram_JobTypeEnumeration elements
 * @ingroup wsgram_JobTypeEnumeration
 *
 * This structure type is used represent an array of
 * wsgram_JobTypeEnumeration elements.
 *
 * Arrays are allocated by wsgram_JobTypeEnumeration_array_init() and freed by calling
 * wsgram_JobTypeEnumeration_array_destroy(). Elements may be added to an array by calling
 * wsgram_JobTypeEnumeration_array_push().
 */
typedef struct wsgram_JobTypeEnumeration_array_s
{
    /** Dynamic array of elements */
    wsgram_JobTypeEnumeration * elements;
    /** Number of elements in this array */
    int                                 length;
} wsgram_JobTypeEnumeration_array;

/**
 * Namespace of the wsgram_JobTypeEnumeration complex type
 * @ingroup wsgram_JobTypeEnumeration
 */
#define WSGRAM_JOBTYPEENUMERATION_NS "http://www.globus.org/namespaces/2004/10/gram/job/description"
/**
 * Local part of the QName of the wsgram_JobTypeEnumeration complex type
 * @ingroup wsgram_JobTypeEnumeration
 */
#define WSGRAM_JOBTYPEENUMERATION_LOCAL "JobTypeEnumeration"

/**
 * QName of the wsgram_JobTypeEnumeration complex type
 * @ingroup wsgram_JobTypeEnumeration
 */
extern xsd_QName wsgram_JobTypeEnumeration_qname;
/**
 * Type information for serializing and deserializing wsgram_JobTypeEnumeration elements
 * @ingroup wsgram_JobTypeEnumeration
 */
extern struct globus_xsd_type_info_s wsgram_JobTypeEnumeration_info;
/**
 * Type information for serializing and deserializing arrays of wsgram_JobTypeEnumeration
 * elements
 * @ingroup wsgram_JobTypeEnumeration
 */
extern struct globus_xsd_type_info_s wsgram_JobTypeEnumeration_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsgram_JobTypeEnumeration without surrounding elements
 * @ingroup wsgram_JobTypeEnumeration
 */
extern struct globus_xsd_type_info_s wsgram_JobTypeEnumeration_contents_info;

/**
 * Initialize a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Allocates a new wsgram_JobTypeEnumeration and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsgram_JobTypeEnumeration_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsgram_JobTypeEnumeration_init(
    wsgram_JobTypeEnumeration ** inst);

/**
 * Destroy a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Frees a wsgram_JobTypeEnumeration. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsgram_JobTypeEnumeration_destroy(
    wsgram_JobTypeEnumeration * inst);

/**
 * Copy a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Perform a deep copy of a wsgram_JobTypeEnumeration.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsgram_JobTypeEnumeration structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsgram_JobTypeEnumeration to be copied.
 */
globus_result_t
wsgram_JobTypeEnumeration_copy(
    wsgram_JobTypeEnumeration ** dest,
    const wsgram_JobTypeEnumeration * src);

/**
 * Initialize the contents of a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Initialize the contents of a wsgram_JobTypeEnumeration. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsgram_JobTypeEnumeration_init(). The contents may be freed
 * by calling wsgram_JobTypeEnumeration_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsgram_JobTypeEnumeration.
 */
globus_result_t
wsgram_JobTypeEnumeration_init_contents(
    wsgram_JobTypeEnumeration * instance);

/**
 * Destroy the contents of a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Destroy the subelements and attributes of the given wsgram_JobTypeEnumeration. 
 *
 * @param inst
 *     Pointer to a wsgram_JobTypeEnumeration instance to destroy.
 */
void
wsgram_JobTypeEnumeration_destroy_contents(
    wsgram_JobTypeEnumeration * inst);

/**
 * Copy the contents of a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Perform a deep copy of the contents of a wsgram_JobTypeEnumeration.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsgram_JobTypeEnumeration to be copied.
 */
globus_result_t
wsgram_JobTypeEnumeration_copy_contents(
    wsgram_JobTypeEnumeration * dest,
    const wsgram_JobTypeEnumeration * src);

/**
 * Initialize an array of wsgram_JobTypeEnumeration elements.
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Allocates a new array of 0 elements. When this array is no longer used,
 * it should be freed by calling 
 * wsgram_JobTypeEnumeration_array_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated array instance.
 */
globus_result_t
wsgram_JobTypeEnumeration_array_init(
    wsgram_JobTypeEnumeration_array ** inst);

/**
 * Destroy an array of wsgram_JobTypeEnumeration elements.
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Frees an array of wsgram_JobTypeEnumeration elements. The contents of each element
 * element in the array be destroyed by calling
 * wsgram_JobTypeEnumeration_destroy_contents().
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wsgram_JobTypeEnumeration_array_destroy(
    wsgram_JobTypeEnumeration_array * inst);

/**
 * Copy an array of wsgram_JobTypeEnumeration elements
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Perform a deep copy of an array of wsgram_JobTypeEnumeration elements.
 * The @a dest array will be allocated, and then a copy of the contents
 * of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wsgram_JobTypeEnumeration_array_copy(
    wsgram_JobTypeEnumeration_array ** dest,
    const wsgram_JobTypeEnumeration_array * src);

/**
 * Initialize the contents of an array of wsgram_JobTypeEnumeration elements
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Initialize the contents of an array of wsgram_JobTypeEnumeration elements. Used
 * when the array is allocated on the stack or by a some allocator besides
 * wsgram_JobTypeEnumeration_array_init(). The contents of the array may be freed
 * by calling wsgram_JobTypeEnumeration_array_destroy_contents().
 *
 * @param inst
 *     Pointer to an allocated but uninitialized array.
 */
globus_result_t
wsgram_JobTypeEnumeration_array_init_contents(
    wsgram_JobTypeEnumeration_array * inst);

/**
 * Destroy the contents of an array of wsgram_JobTypeEnumeration elements
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Destroy the elements in an array of wsgram_JobTypeEnumeration elements. The contents of
 * each element in the array be destroyed by calling
 * wsgram_JobTypeEnumeration_destroy_contents() and the array will be reset to be empty.
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wsgram_JobTypeEnumeration_array_destroy_contents(
    wsgram_JobTypeEnumeration_array * inst);

/**
 * Copy the contents of an array of wsgram_JobTypeEnumeration elements
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Perform a deep copy of an array of wsgram_JobTypeEnumeration elements.
 * The @a dest array must be allocated before making this call.
 * A copy of the contents of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wsgram_JobTypeEnumeration_array_copy_contents(
    wsgram_JobTypeEnumeration_array * dest,
    const wsgram_JobTypeEnumeration_array * src);

/**
 * Append a new wsgram_JobTypeEnumeration to an array
 * @ingroup wsgram_JobTypeEnumeration
 *
 * Allocate and initialize a new wsgram_JobTypeEnumeration structure, adding it
 * to the end of the given @a array.
 * 
 * @param array
 *     Array to be appended to.
 *
 * @return This function returns the newly allocated element.
 */
wsgram_JobTypeEnumeration *
wsgram_JobTypeEnumeration_array_push(
    wsgram_JobTypeEnumeration_array * array);

/**
 * Serialize a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration_array
 * Serialize a wsgram_JobTypeEnumeration structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsgram_JobTypeEnumeration.
 * @param val
 *     The wsgram_JobTypeEnumeration to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_serialize(
    xsd_QName *                         element_name,
    wsgram_JobTypeEnumeration * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration_array
 * Serialize a wsgram_JobTypeEnumeration structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsgram_JobTypeEnumeration to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_serialize_contents(
    xsd_QName *                         element_name,
    wsgram_JobTypeEnumeration * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 * Deserialize an element containing a wsgram_JobTypeEnumeration element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsgram_JobTypeEnumeration.
 * @param val
 *     Pointer to the wsgram_JobTypeEnumeration which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_deserialize(
    xsd_QName *                         element_name,
    wsgram_JobTypeEnumeration * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 * Deserialize a wsgram_JobTypeEnumeration whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsgram_JobTypeEnumeration which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_deserialize_contents(
    xsd_QName *                         element_name,
    wsgram_JobTypeEnumeration * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 * Deserialize the next element if it contains a wsgram_JobTypeEnumeration.
 *
 * @param element_name
 *     The name of the element which should enclose the wsgram_JobTypeEnumeration.
 * @param instance
 *     Pointer to the <code>wsgram_JobTypeEnumeration *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_deserialize_pointer(
    xsd_QName *                         element_name,
    wsgram_JobTypeEnumeration ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize an array of wsgram_JobTypeEnumeration elements
 * @ingroup wsgram_JobTypeEnumeration
 * Serialize an element containing an array of wsgram_JobTypeEnumeration elements.
 *
 * @param element
 *     The name of the element which will contain the array.
 * @param array_instance
 *     The array to serialize
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_array_serialize(
    xsd_QName *                         element,
    wsgram_JobTypeEnumeration_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an array of wsgram_JobTypeEnumeration elements
 * @ingroup wsgram_JobTypeEnumeration
 * Deserialize an element containing an array of wsgram_JobTypeEnumeration elements.
 *
 * @param element
 *     The name of the element which should enclose the array.
 * @param array_instance
 *     The array to deserialize into
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_array_deserialize(
    xsd_QName *                         element,
    wsgram_JobTypeEnumeration_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);



/**
 * Serialize an attribute of type wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration_array
 * Serialize a wsgram_JobTypeEnumeration as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsgram_JobTypeEnumeration.
 * @param val
 *     The wsgram_JobTypeEnumeration to serialize.
 * @param message
 *     The handle to serialize the attribute on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_serialize_attribute(
    xsd_QName *                         attr_qname,
    wsgram_JobTypeEnumeration * val,
    globus_soap_message_handle_t        handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an attribute of type wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 * Deserialize a wsgram_JobTypeEnumeration as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsgram_JobTypeEnumeration.
 * @param instance
 *     Pointer to the wsgram_JobTypeEnumeration which will be initialized with the
 *     value of the attribute.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_deserialize_attribute(
    xsd_QName *                         attr_qname,
    wsgram_JobTypeEnumeration * instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional attribute of type wsgram_JobTypeEnumeration
 * @ingroup wsgram_JobTypeEnumeration
 * Try to deserialize a wsgram_JobTypeEnumeration as an attribute of the current element
 * if it is present. The attribute's name is defined by @ attr_qname.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsgram_JobTypeEnumeration.
 * @param instance
 *     Pointer to the wsgram_JobTypeEnumeration which will be allocated and initialized
 *     with the value of the attribute if it is present.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsgram_JobTypeEnumeration_deserialize_attribute_pointer(
    xsd_QName *                         attr_qname,
    wsgram_JobTypeEnumeration ** instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);


#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
globus_result_t
wsgram_JobTypeEnumeration_init_wrapper(
    void **                             object);
    
void
wsgram_JobTypeEnumeration_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsgram_JobTypeEnumeration_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);
    
globus_result_t
wsgram_JobTypeEnumeration_init_contents_wrapper(
    void  *                             object);
    
void
wsgram_JobTypeEnumeration_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsgram_JobTypeEnumeration_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);
    
globus_result_t
wsgram_JobTypeEnumeration_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_JobTypeEnumeration_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_JobTypeEnumeration_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_JobTypeEnumeration_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_JobTypeEnumeration_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_JobTypeEnumeration_array_init_wrapper(
    void **                             arr);
    
void
wsgram_JobTypeEnumeration_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsgram_JobTypeEnumeration_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);
globus_result_t
wsgram_JobTypeEnumeration_array_init_contents_wrapper(
    void *                              arr);
    
void
wsgram_JobTypeEnumeration_array_destroy_contents_wrapper(
    void *                              arr);
    
globus_result_t
wsgram_JobTypeEnumeration_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);
    
globus_result_t
wsgram_JobTypeEnumeration_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

void *
wsgram_JobTypeEnumeration_array_push_wrapper(
    void * array);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
