/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_COMPUTINGELEMENTTYPE_H_
#define _WSMDS_COMPUTINGELEMENTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_ComputingElementType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}ComputingElementType element.
 * @ingroup wsmds_ComputingElementType
 */
typedef struct wsmds_ComputingElementType_s wsmds_ComputingElementType;
/**
 * The wsmds_ComputingElementType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}ComputingElementType element.
 * @ingroup wsmds_ComputingElementType
 */
typedef wsmds_ComputingElementType * wsmds_ComputingElementType_o;

/**
 * Namespace of the wsmds_ComputingElementType complex type
 * @ingroup wsmds_ComputingElementType
 */
#define WSMDS_COMPUTINGELEMENTTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_ComputingElementType complex type
 * @ingroup wsmds_ComputingElementType
 */
#define WSMDS_COMPUTINGELEMENTTYPE_LOCAL "ComputingElementType"

/**
 * QName of the wsmds_ComputingElementType complex type
 * @ingroup wsmds_ComputingElementType
 */
extern xsd_QName wsmds_ComputingElementType_qname;
/**
 * Type information for serializing and deserializing wsmds_ComputingElementType elements
 * @ingroup wsmds_ComputingElementType
 */
extern struct globus_xsd_type_info_s wsmds_ComputingElementType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_ComputingElementType
 * elements
 * @ingroup wsmds_ComputingElementType
 */
extern struct globus_xsd_type_info_s wsmds_ComputingElementType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_ComputingElementType without surrounding elements
 * @ingroup wsmds_ComputingElementType
 */
extern struct globus_xsd_type_info_s wsmds_ComputingElementType_contents_info;


#include "wsmds_InfoType.h"
#include "wsmds_StateType.h"
#include "wsmds_PolicyType.h"
#include "wsmds_JobType_array.h"
#include "wsmds_AccessControlBaseType.h"
#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_anyURI.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "wsmds_ComputingElementType_array.h"

/**
 * @defgroup wsmds_ComputingElementType Complex type: wsmds_ComputingElementType
 * @ingroup types
 */

/**
 * C structure for the wsmds_ComputingElementType complex type
 * @ingroup wsmds_ComputingElementType
 */
struct wsmds_ComputingElementType_s
{
   /** Optional wsmds_InfoType subelement */
    wsmds_InfoType_o Info;
   /** Optional wsmds_StateType subelement */
    wsmds_StateType_o State;
   /** Optional wsmds_PolicyType subelement */
    wsmds_PolicyType_o Policy;
   /** Array of [0 .. Infinity] wsmds_JobType elements */
    wsmds_JobType_array Job;
   /** Optional wsmds_AccessControlBaseType subelement */
    wsmds_AccessControlBaseType_o AccessControlBase;
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_anyURI_o _InformationServiceURL;
    xsd_string_o _Name;
    xsd_string_o _UniqueID;

};

/**
 * Initialize a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 *
 * Allocates a new wsmds_ComputingElementType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_ComputingElementType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_ComputingElementType_init(
    wsmds_ComputingElementType ** inst);

/**
 * Destroy a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 *
 * Frees a wsmds_ComputingElementType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_ComputingElementType_destroy(
    wsmds_ComputingElementType * inst);

/**
 * Copy a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 *
 * Perform a deep copy of a wsmds_ComputingElementType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_ComputingElementType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_ComputingElementType to be copied.
 */
globus_result_t
wsmds_ComputingElementType_copy(
    wsmds_ComputingElementType ** dest,
    const wsmds_ComputingElementType * src);

/**
 * Initialize the contents of a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 *
 * Initialize the contents of a wsmds_ComputingElementType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_ComputingElementType_init(). The contents may be freed
 * by calling wsmds_ComputingElementType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_ComputingElementType.
 */
globus_result_t
wsmds_ComputingElementType_init_contents(
    wsmds_ComputingElementType * instance);

/**
 * Destroy the contents of a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 *
 * Destroy the subelements and attributes of the given wsmds_ComputingElementType. 
 *
 * @param inst
 *     Pointer to a wsmds_ComputingElementType instance to destroy.
 */
void
wsmds_ComputingElementType_destroy_contents(
    wsmds_ComputingElementType * inst);

/**
 * Copy the contents of a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 *
 * Perform a deep copy of the contents of a wsmds_ComputingElementType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_ComputingElementType to be copied.
 */
globus_result_t
wsmds_ComputingElementType_copy_contents(
    wsmds_ComputingElementType * dest,
    const wsmds_ComputingElementType * src);

/**
 * Serialize a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType_array
 * Serialize a wsmds_ComputingElementType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_ComputingElementType.
 * @param val
 *     The wsmds_ComputingElementType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_ComputingElementType_serialize(
    xsd_QName *                         element_name,
    wsmds_ComputingElementType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType_array
 * Serialize a wsmds_ComputingElementType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_ComputingElementType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_ComputingElementType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_ComputingElementType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 * Deserialize an element containing a wsmds_ComputingElementType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_ComputingElementType.
 * @param val
 *     Pointer to the wsmds_ComputingElementType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_ComputingElementType_deserialize(
    xsd_QName *                         element_name,
    wsmds_ComputingElementType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 * Deserialize a wsmds_ComputingElementType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_ComputingElementType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_ComputingElementType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_ComputingElementType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_ComputingElementType
 * @ingroup wsmds_ComputingElementType
 * Deserialize the next element if it contains a wsmds_ComputingElementType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_ComputingElementType.
 * @param instance
 *     Pointer to the <code>wsmds_ComputingElementType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_ComputingElementType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_ComputingElementType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_ComputingElementType_init_wrapper(
    void **                             object);
    
void
wsmds_ComputingElementType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_ComputingElementType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_ComputingElementType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_ComputingElementType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_ComputingElementType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_ComputingElementType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_ComputingElementType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_ComputingElementType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_ComputingElementType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
