/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_FILESYSTEMTYPE_H_
#define _WSMDS_FILESYSTEMTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_FileSystemType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}FileSystemType element.
 * @ingroup wsmds_FileSystemType
 */
typedef struct wsmds_FileSystemType_s wsmds_FileSystemType;
/**
 * The wsmds_FileSystemType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}FileSystemType element.
 * @ingroup wsmds_FileSystemType
 */
typedef wsmds_FileSystemType * wsmds_FileSystemType_o;

/**
 * Namespace of the wsmds_FileSystemType complex type
 * @ingroup wsmds_FileSystemType
 */
#define WSMDS_FILESYSTEMTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_FileSystemType complex type
 * @ingroup wsmds_FileSystemType
 */
#define WSMDS_FILESYSTEMTYPE_LOCAL "FileSystemType"

/**
 * QName of the wsmds_FileSystemType complex type
 * @ingroup wsmds_FileSystemType
 */
extern xsd_QName wsmds_FileSystemType_qname;
/**
 * Type information for serializing and deserializing wsmds_FileSystemType elements
 * @ingroup wsmds_FileSystemType
 */
extern struct globus_xsd_type_info_s wsmds_FileSystemType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_FileSystemType
 * elements
 * @ingroup wsmds_FileSystemType
 */
extern struct globus_xsd_type_info_s wsmds_FileSystemType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_FileSystemType without surrounding elements
 * @ingroup wsmds_FileSystemType
 */
extern struct globus_xsd_type_info_s wsmds_FileSystemType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_long.h"
#include "xsd_string.h"
#include "xsd_boolean.h"
#include "xsd_string.h"
#include "xsd_long.h"
#include "xsd_string.h"
#include "wsmds_FileSystemType_array.h"

/**
 * @defgroup wsmds_FileSystemType Complex type: wsmds_FileSystemType
 * @ingroup types
 */

/**
 * C structure for the wsmds_FileSystemType complex type
 * @ingroup wsmds_FileSystemType
 */
struct wsmds_FileSystemType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_long_o _AvailableSpace;
    xsd_string_o _Name;
    xsd_boolean_o _ReadOnly;
    xsd_string_o _Root;
    xsd_long_o _Size;
    xsd_string_o _Type;

};

/**
 * Initialize a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 *
 * Allocates a new wsmds_FileSystemType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_FileSystemType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_FileSystemType_init(
    wsmds_FileSystemType ** inst);

/**
 * Destroy a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 *
 * Frees a wsmds_FileSystemType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_FileSystemType_destroy(
    wsmds_FileSystemType * inst);

/**
 * Copy a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 *
 * Perform a deep copy of a wsmds_FileSystemType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_FileSystemType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_FileSystemType to be copied.
 */
globus_result_t
wsmds_FileSystemType_copy(
    wsmds_FileSystemType ** dest,
    const wsmds_FileSystemType * src);

/**
 * Initialize the contents of a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 *
 * Initialize the contents of a wsmds_FileSystemType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_FileSystemType_init(). The contents may be freed
 * by calling wsmds_FileSystemType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_FileSystemType.
 */
globus_result_t
wsmds_FileSystemType_init_contents(
    wsmds_FileSystemType * instance);

/**
 * Destroy the contents of a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 *
 * Destroy the subelements and attributes of the given wsmds_FileSystemType. 
 *
 * @param inst
 *     Pointer to a wsmds_FileSystemType instance to destroy.
 */
void
wsmds_FileSystemType_destroy_contents(
    wsmds_FileSystemType * inst);

/**
 * Copy the contents of a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 *
 * Perform a deep copy of the contents of a wsmds_FileSystemType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_FileSystemType to be copied.
 */
globus_result_t
wsmds_FileSystemType_copy_contents(
    wsmds_FileSystemType * dest,
    const wsmds_FileSystemType * src);

/**
 * Serialize a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType_array
 * Serialize a wsmds_FileSystemType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_FileSystemType.
 * @param val
 *     The wsmds_FileSystemType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_FileSystemType_serialize(
    xsd_QName *                         element_name,
    wsmds_FileSystemType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType_array
 * Serialize a wsmds_FileSystemType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_FileSystemType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_FileSystemType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_FileSystemType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 * Deserialize an element containing a wsmds_FileSystemType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_FileSystemType.
 * @param val
 *     Pointer to the wsmds_FileSystemType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_FileSystemType_deserialize(
    xsd_QName *                         element_name,
    wsmds_FileSystemType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 * Deserialize a wsmds_FileSystemType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_FileSystemType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_FileSystemType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_FileSystemType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_FileSystemType
 * @ingroup wsmds_FileSystemType
 * Deserialize the next element if it contains a wsmds_FileSystemType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_FileSystemType.
 * @param instance
 *     Pointer to the <code>wsmds_FileSystemType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_FileSystemType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_FileSystemType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_FileSystemType_init_wrapper(
    void **                             object);
    
void
wsmds_FileSystemType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_FileSystemType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_FileSystemType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_FileSystemType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_FileSystemType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_FileSystemType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_FileSystemType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_FileSystemType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_FileSystemType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
