/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_FILETYPE_H_
#define _WSMDS_FILETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_FileType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}FileType element.
 * @ingroup wsmds_FileType
 */
typedef struct wsmds_FileType_s wsmds_FileType;
/**
 * The wsmds_FileType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}FileType element.
 * @ingroup wsmds_FileType
 */
typedef wsmds_FileType * wsmds_FileType_o;

/**
 * Namespace of the wsmds_FileType complex type
 * @ingroup wsmds_FileType
 */
#define WSMDS_FILETYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_FileType complex type
 * @ingroup wsmds_FileType
 */
#define WSMDS_FILETYPE_LOCAL "FileType"

/**
 * QName of the wsmds_FileType complex type
 * @ingroup wsmds_FileType
 */
extern xsd_QName wsmds_FileType_qname;
/**
 * Type information for serializing and deserializing wsmds_FileType elements
 * @ingroup wsmds_FileType
 */
extern struct globus_xsd_type_info_s wsmds_FileType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_FileType
 * elements
 * @ingroup wsmds_FileType
 */
extern struct globus_xsd_type_info_s wsmds_FileType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_FileType without surrounding elements
 * @ingroup wsmds_FileType
 */
extern struct globus_xsd_type_info_s wsmds_FileType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_dateTime.h"
#include "xsd_dateTime.h"
#include "xsd_dateTime.h"
#include "xsd_duration.h"
#include "xsd_dateTime.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_long.h"
#include "wsmds_FileType_array.h"

/**
 * @defgroup wsmds_FileType Complex type: wsmds_FileType
 * @ingroup types
 */

/**
 * C structure for the wsmds_FileType complex type
 * @ingroup wsmds_FileType
 */
struct wsmds_FileType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_dateTime_o _CreationDate;
    xsd_dateTime_o _LastAccessed;
    xsd_dateTime_o _LastModified;
    xsd_duration_o _Latency;
    xsd_dateTime_o _LifeTime;
    xsd_string_o _Name;
    xsd_string_o _Owner;
    xsd_long_o _Size;

};

/**
 * Initialize a wsmds_FileType
 * @ingroup wsmds_FileType
 *
 * Allocates a new wsmds_FileType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_FileType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_FileType_init(
    wsmds_FileType ** inst);

/**
 * Destroy a wsmds_FileType
 * @ingroup wsmds_FileType
 *
 * Frees a wsmds_FileType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_FileType_destroy(
    wsmds_FileType * inst);

/**
 * Copy a wsmds_FileType
 * @ingroup wsmds_FileType
 *
 * Perform a deep copy of a wsmds_FileType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_FileType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_FileType to be copied.
 */
globus_result_t
wsmds_FileType_copy(
    wsmds_FileType ** dest,
    const wsmds_FileType * src);

/**
 * Initialize the contents of a wsmds_FileType
 * @ingroup wsmds_FileType
 *
 * Initialize the contents of a wsmds_FileType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_FileType_init(). The contents may be freed
 * by calling wsmds_FileType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_FileType.
 */
globus_result_t
wsmds_FileType_init_contents(
    wsmds_FileType * instance);

/**
 * Destroy the contents of a wsmds_FileType
 * @ingroup wsmds_FileType
 *
 * Destroy the subelements and attributes of the given wsmds_FileType. 
 *
 * @param inst
 *     Pointer to a wsmds_FileType instance to destroy.
 */
void
wsmds_FileType_destroy_contents(
    wsmds_FileType * inst);

/**
 * Copy the contents of a wsmds_FileType
 * @ingroup wsmds_FileType
 *
 * Perform a deep copy of the contents of a wsmds_FileType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_FileType to be copied.
 */
globus_result_t
wsmds_FileType_copy_contents(
    wsmds_FileType * dest,
    const wsmds_FileType * src);

/**
 * Serialize a wsmds_FileType
 * @ingroup wsmds_FileType_array
 * Serialize a wsmds_FileType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_FileType.
 * @param val
 *     The wsmds_FileType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_FileType_serialize(
    xsd_QName *                         element_name,
    wsmds_FileType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_FileType
 * @ingroup wsmds_FileType_array
 * Serialize a wsmds_FileType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_FileType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_FileType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_FileType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_FileType
 * @ingroup wsmds_FileType
 * Deserialize an element containing a wsmds_FileType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_FileType.
 * @param val
 *     Pointer to the wsmds_FileType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_FileType_deserialize(
    xsd_QName *                         element_name,
    wsmds_FileType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_FileType
 * @ingroup wsmds_FileType
 * Deserialize a wsmds_FileType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_FileType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_FileType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_FileType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_FileType
 * @ingroup wsmds_FileType
 * Deserialize the next element if it contains a wsmds_FileType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_FileType.
 * @param instance
 *     Pointer to the <code>wsmds_FileType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_FileType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_FileType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_FileType_init_wrapper(
    void **                             object);
    
void
wsmds_FileType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_FileType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_FileType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_FileType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_FileType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_FileType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_FileType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_FileType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_FileType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
