/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_LOCALFILESYSTEMTYPE_H_
#define _WSMDS_LOCALFILESYSTEMTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_LocalFileSystemType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}LocalFileSystemType element.
 * @ingroup wsmds_LocalFileSystemType
 */
typedef struct wsmds_LocalFileSystemType_s wsmds_LocalFileSystemType;
/**
 * The wsmds_LocalFileSystemType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}LocalFileSystemType element.
 * @ingroup wsmds_LocalFileSystemType
 */
typedef wsmds_LocalFileSystemType * wsmds_LocalFileSystemType_o;

/**
 * Namespace of the wsmds_LocalFileSystemType complex type
 * @ingroup wsmds_LocalFileSystemType
 */
#define WSMDS_LOCALFILESYSTEMTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_LocalFileSystemType complex type
 * @ingroup wsmds_LocalFileSystemType
 */
#define WSMDS_LOCALFILESYSTEMTYPE_LOCAL "LocalFileSystemType"

/**
 * QName of the wsmds_LocalFileSystemType complex type
 * @ingroup wsmds_LocalFileSystemType
 */
extern xsd_QName wsmds_LocalFileSystemType_qname;
/**
 * Type information for serializing and deserializing wsmds_LocalFileSystemType elements
 * @ingroup wsmds_LocalFileSystemType
 */
extern struct globus_xsd_type_info_s wsmds_LocalFileSystemType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_LocalFileSystemType
 * elements
 * @ingroup wsmds_LocalFileSystemType
 */
extern struct globus_xsd_type_info_s wsmds_LocalFileSystemType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_LocalFileSystemType without surrounding elements
 * @ingroup wsmds_LocalFileSystemType
 */
extern struct globus_xsd_type_info_s wsmds_LocalFileSystemType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_long.h"
#include "xsd_string.h"
#include "xsd_boolean.h"
#include "xsd_string.h"
#include "xsd_long.h"
#include "xsd_string.h"
#include "wsmds_DirectoryType_array.h"
#include "wsmds_LocalFileSystemType_array.h"

/**
 * @defgroup wsmds_LocalFileSystemType Complex type: wsmds_LocalFileSystemType
 * @ingroup types
 */

/**
 * C structure for the wsmds_LocalFileSystemType complex type
 * @ingroup wsmds_LocalFileSystemType
 */
struct wsmds_LocalFileSystemType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_long_o _AvailableSpace;
    xsd_string_o _Name;
    xsd_boolean_o _ReadOnly;
    xsd_string_o _Root;
    xsd_long_o _Size;
    xsd_string_o _Type;
   /** Array of [0 .. Infinity] wsmds_DirectoryType elements */
    wsmds_DirectoryType_array export;

};

/**
 * Initialize a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 *
 * Allocates a new wsmds_LocalFileSystemType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_LocalFileSystemType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_LocalFileSystemType_init(
    wsmds_LocalFileSystemType ** inst);

/**
 * Destroy a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 *
 * Frees a wsmds_LocalFileSystemType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_LocalFileSystemType_destroy(
    wsmds_LocalFileSystemType * inst);

/**
 * Copy a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 *
 * Perform a deep copy of a wsmds_LocalFileSystemType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_LocalFileSystemType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_LocalFileSystemType to be copied.
 */
globus_result_t
wsmds_LocalFileSystemType_copy(
    wsmds_LocalFileSystemType ** dest,
    const wsmds_LocalFileSystemType * src);

/**
 * Initialize the contents of a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 *
 * Initialize the contents of a wsmds_LocalFileSystemType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_LocalFileSystemType_init(). The contents may be freed
 * by calling wsmds_LocalFileSystemType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_LocalFileSystemType.
 */
globus_result_t
wsmds_LocalFileSystemType_init_contents(
    wsmds_LocalFileSystemType * instance);

/**
 * Destroy the contents of a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 *
 * Destroy the subelements and attributes of the given wsmds_LocalFileSystemType. 
 *
 * @param inst
 *     Pointer to a wsmds_LocalFileSystemType instance to destroy.
 */
void
wsmds_LocalFileSystemType_destroy_contents(
    wsmds_LocalFileSystemType * inst);

/**
 * Copy the contents of a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 *
 * Perform a deep copy of the contents of a wsmds_LocalFileSystemType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_LocalFileSystemType to be copied.
 */
globus_result_t
wsmds_LocalFileSystemType_copy_contents(
    wsmds_LocalFileSystemType * dest,
    const wsmds_LocalFileSystemType * src);

/**
 * Serialize a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType_array
 * Serialize a wsmds_LocalFileSystemType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_LocalFileSystemType.
 * @param val
 *     The wsmds_LocalFileSystemType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_LocalFileSystemType_serialize(
    xsd_QName *                         element_name,
    wsmds_LocalFileSystemType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType_array
 * Serialize a wsmds_LocalFileSystemType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_LocalFileSystemType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_LocalFileSystemType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_LocalFileSystemType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 * Deserialize an element containing a wsmds_LocalFileSystemType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_LocalFileSystemType.
 * @param val
 *     Pointer to the wsmds_LocalFileSystemType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_LocalFileSystemType_deserialize(
    xsd_QName *                         element_name,
    wsmds_LocalFileSystemType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 * Deserialize a wsmds_LocalFileSystemType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_LocalFileSystemType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_LocalFileSystemType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_LocalFileSystemType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_LocalFileSystemType
 * @ingroup wsmds_LocalFileSystemType
 * Deserialize the next element if it contains a wsmds_LocalFileSystemType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_LocalFileSystemType.
 * @param instance
 *     Pointer to the <code>wsmds_LocalFileSystemType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_LocalFileSystemType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_LocalFileSystemType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_LocalFileSystemType_init_wrapper(
    void **                             object);
    
void
wsmds_LocalFileSystemType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_LocalFileSystemType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_LocalFileSystemType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_LocalFileSystemType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_LocalFileSystemType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_LocalFileSystemType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_LocalFileSystemType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_LocalFileSystemType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_LocalFileSystemType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
