/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_NETWORKADAPTERTYPE_H_
#define _WSMDS_NETWORKADAPTERTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_NetworkAdapterType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}NetworkAdapterType element.
 * @ingroup wsmds_NetworkAdapterType
 */
typedef struct wsmds_NetworkAdapterType_s wsmds_NetworkAdapterType;
/**
 * The wsmds_NetworkAdapterType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}NetworkAdapterType element.
 * @ingroup wsmds_NetworkAdapterType
 */
typedef wsmds_NetworkAdapterType * wsmds_NetworkAdapterType_o;

/**
 * Namespace of the wsmds_NetworkAdapterType complex type
 * @ingroup wsmds_NetworkAdapterType
 */
#define WSMDS_NETWORKADAPTERTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_NetworkAdapterType complex type
 * @ingroup wsmds_NetworkAdapterType
 */
#define WSMDS_NETWORKADAPTERTYPE_LOCAL "NetworkAdapterType"

/**
 * QName of the wsmds_NetworkAdapterType complex type
 * @ingroup wsmds_NetworkAdapterType
 */
extern xsd_QName wsmds_NetworkAdapterType_qname;
/**
 * Type information for serializing and deserializing wsmds_NetworkAdapterType elements
 * @ingroup wsmds_NetworkAdapterType
 */
extern struct globus_xsd_type_info_s wsmds_NetworkAdapterType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_NetworkAdapterType
 * elements
 * @ingroup wsmds_NetworkAdapterType
 */
extern struct globus_xsd_type_info_s wsmds_NetworkAdapterType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_NetworkAdapterType without surrounding elements
 * @ingroup wsmds_NetworkAdapterType
 */
extern struct globus_xsd_type_info_s wsmds_NetworkAdapterType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_string.h"
#include "xsd_boolean.h"
#include "xsd_int.h"
#include "xsd_string.h"
#include "xsd_boolean.h"
#include "wsmds_NetworkAdapterType_array.h"

/**
 * @defgroup wsmds_NetworkAdapterType Complex type: wsmds_NetworkAdapterType
 * @ingroup types
 */

/**
 * C structure for the wsmds_NetworkAdapterType complex type
 * @ingroup wsmds_NetworkAdapterType
 */
struct wsmds_NetworkAdapterType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_string_o _IPAddress;
    xsd_boolean_o _InboundIP;
    xsd_int_o _MTU;
    xsd_string_o _Name;
    xsd_boolean_o _OutboundIP;

};

/**
 * Initialize a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 *
 * Allocates a new wsmds_NetworkAdapterType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_NetworkAdapterType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_NetworkAdapterType_init(
    wsmds_NetworkAdapterType ** inst);

/**
 * Destroy a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 *
 * Frees a wsmds_NetworkAdapterType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_NetworkAdapterType_destroy(
    wsmds_NetworkAdapterType * inst);

/**
 * Copy a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 *
 * Perform a deep copy of a wsmds_NetworkAdapterType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_NetworkAdapterType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_NetworkAdapterType to be copied.
 */
globus_result_t
wsmds_NetworkAdapterType_copy(
    wsmds_NetworkAdapterType ** dest,
    const wsmds_NetworkAdapterType * src);

/**
 * Initialize the contents of a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 *
 * Initialize the contents of a wsmds_NetworkAdapterType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_NetworkAdapterType_init(). The contents may be freed
 * by calling wsmds_NetworkAdapterType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_NetworkAdapterType.
 */
globus_result_t
wsmds_NetworkAdapterType_init_contents(
    wsmds_NetworkAdapterType * instance);

/**
 * Destroy the contents of a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 *
 * Destroy the subelements and attributes of the given wsmds_NetworkAdapterType. 
 *
 * @param inst
 *     Pointer to a wsmds_NetworkAdapterType instance to destroy.
 */
void
wsmds_NetworkAdapterType_destroy_contents(
    wsmds_NetworkAdapterType * inst);

/**
 * Copy the contents of a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 *
 * Perform a deep copy of the contents of a wsmds_NetworkAdapterType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_NetworkAdapterType to be copied.
 */
globus_result_t
wsmds_NetworkAdapterType_copy_contents(
    wsmds_NetworkAdapterType * dest,
    const wsmds_NetworkAdapterType * src);

/**
 * Serialize a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType_array
 * Serialize a wsmds_NetworkAdapterType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_NetworkAdapterType.
 * @param val
 *     The wsmds_NetworkAdapterType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_NetworkAdapterType_serialize(
    xsd_QName *                         element_name,
    wsmds_NetworkAdapterType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType_array
 * Serialize a wsmds_NetworkAdapterType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_NetworkAdapterType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_NetworkAdapterType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_NetworkAdapterType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 * Deserialize an element containing a wsmds_NetworkAdapterType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_NetworkAdapterType.
 * @param val
 *     Pointer to the wsmds_NetworkAdapterType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_NetworkAdapterType_deserialize(
    xsd_QName *                         element_name,
    wsmds_NetworkAdapterType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 * Deserialize a wsmds_NetworkAdapterType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_NetworkAdapterType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_NetworkAdapterType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_NetworkAdapterType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_NetworkAdapterType
 * @ingroup wsmds_NetworkAdapterType
 * Deserialize the next element if it contains a wsmds_NetworkAdapterType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_NetworkAdapterType.
 * @param instance
 *     Pointer to the <code>wsmds_NetworkAdapterType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_NetworkAdapterType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_NetworkAdapterType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_NetworkAdapterType_init_wrapper(
    void **                             object);
    
void
wsmds_NetworkAdapterType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_NetworkAdapterType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_NetworkAdapterType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_NetworkAdapterType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_NetworkAdapterType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_NetworkAdapterType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_NetworkAdapterType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_NetworkAdapterType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_NetworkAdapterType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
