/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_STATETYPE_H_
#define _WSMDS_STATETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_StateType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}StateType element.
 * @ingroup wsmds_StateType
 */
typedef struct wsmds_StateType_s wsmds_StateType;
/**
 * The wsmds_StateType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}StateType element.
 * @ingroup wsmds_StateType
 */
typedef wsmds_StateType * wsmds_StateType_o;

/**
 * Namespace of the wsmds_StateType complex type
 * @ingroup wsmds_StateType
 */
#define WSMDS_STATETYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_StateType complex type
 * @ingroup wsmds_StateType
 */
#define WSMDS_STATETYPE_LOCAL "StateType"

/**
 * QName of the wsmds_StateType complex type
 * @ingroup wsmds_StateType
 */
extern xsd_QName wsmds_StateType_qname;
/**
 * Type information for serializing and deserializing wsmds_StateType elements
 * @ingroup wsmds_StateType
 */
extern struct globus_xsd_type_info_s wsmds_StateType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_StateType
 * elements
 * @ingroup wsmds_StateType
 */
extern struct globus_xsd_type_info_s wsmds_StateType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_StateType without surrounding elements
 * @ingroup wsmds_StateType
 */
extern struct globus_xsd_type_info_s wsmds_StateType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_string.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "wsmds_StateType_array.h"

/**
 * @defgroup wsmds_StateType Complex type: wsmds_StateType
 * @ingroup types
 */

/**
 * C structure for the wsmds_StateType complex type
 * @ingroup wsmds_StateType
 */
struct wsmds_StateType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_int_o _EstimatedResponseTime;
    xsd_int_o _FreeCPUs;
    xsd_int_o _RunningJobs;
    xsd_string_o _Status;
    xsd_int_o _TotalJobs;
    xsd_int_o _WaitingJobs;
    xsd_int_o _WorstResponseTime;

};

/**
 * Initialize a wsmds_StateType
 * @ingroup wsmds_StateType
 *
 * Allocates a new wsmds_StateType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_StateType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_StateType_init(
    wsmds_StateType ** inst);

/**
 * Destroy a wsmds_StateType
 * @ingroup wsmds_StateType
 *
 * Frees a wsmds_StateType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_StateType_destroy(
    wsmds_StateType * inst);

/**
 * Copy a wsmds_StateType
 * @ingroup wsmds_StateType
 *
 * Perform a deep copy of a wsmds_StateType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_StateType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_StateType to be copied.
 */
globus_result_t
wsmds_StateType_copy(
    wsmds_StateType ** dest,
    const wsmds_StateType * src);

/**
 * Initialize the contents of a wsmds_StateType
 * @ingroup wsmds_StateType
 *
 * Initialize the contents of a wsmds_StateType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_StateType_init(). The contents may be freed
 * by calling wsmds_StateType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_StateType.
 */
globus_result_t
wsmds_StateType_init_contents(
    wsmds_StateType * instance);

/**
 * Destroy the contents of a wsmds_StateType
 * @ingroup wsmds_StateType
 *
 * Destroy the subelements and attributes of the given wsmds_StateType. 
 *
 * @param inst
 *     Pointer to a wsmds_StateType instance to destroy.
 */
void
wsmds_StateType_destroy_contents(
    wsmds_StateType * inst);

/**
 * Copy the contents of a wsmds_StateType
 * @ingroup wsmds_StateType
 *
 * Perform a deep copy of the contents of a wsmds_StateType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_StateType to be copied.
 */
globus_result_t
wsmds_StateType_copy_contents(
    wsmds_StateType * dest,
    const wsmds_StateType * src);

/**
 * Serialize a wsmds_StateType
 * @ingroup wsmds_StateType_array
 * Serialize a wsmds_StateType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_StateType.
 * @param val
 *     The wsmds_StateType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_StateType_serialize(
    xsd_QName *                         element_name,
    wsmds_StateType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_StateType
 * @ingroup wsmds_StateType_array
 * Serialize a wsmds_StateType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_StateType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_StateType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_StateType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_StateType
 * @ingroup wsmds_StateType
 * Deserialize an element containing a wsmds_StateType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_StateType.
 * @param val
 *     Pointer to the wsmds_StateType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_StateType_deserialize(
    xsd_QName *                         element_name,
    wsmds_StateType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_StateType
 * @ingroup wsmds_StateType
 * Deserialize a wsmds_StateType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_StateType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_StateType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_StateType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_StateType
 * @ingroup wsmds_StateType
 * Deserialize the next element if it contains a wsmds_StateType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_StateType.
 * @param instance
 *     Pointer to the <code>wsmds_StateType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_StateType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_StateType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_StateType_init_wrapper(
    void **                             object);
    
void
wsmds_StateType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_StateType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_StateType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_StateType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_StateType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_StateType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_StateType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_StateType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_StateType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
