/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDL-to-C Converter
 */

#ifndef _DS_CRYPTOBINARY_H_
#define _DS_CRYPTOBINARY_H_

#include "globus_common.h"

/**
 * @defgroup ds_CryptoBinary Simple Type: ds_CryptoBinary
 * @ingroup types
 */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */


#include "xsd_base64Binary.h"

/**
 * @ingroup ds_CryptoBinary
 */
typedef xsd_base64Binary ds_CryptoBinary;


/**
 * Optional ds_CryptoBinary element
 * @ingroup ds_CryptoBinary
 */
typedef ds_CryptoBinary * ds_CryptoBinary_o;

/**
 * Array of ds_CryptoBinary elements
 * @ingroup ds_CryptoBinary
 *
 * This structure type is used represent an array of
 * ds_CryptoBinary elements.
 *
 * Arrays are allocated by ds_CryptoBinary_array_init() and freed by calling
 * ds_CryptoBinary_array_destroy(). Elements may be added to an array by calling
 * ds_CryptoBinary_array_push().
 */
typedef struct ds_CryptoBinary_array_s
{
    /** Dynamic array of elements */
    ds_CryptoBinary * elements;
    /** Number of elements in this array */
    int                                 length;
} ds_CryptoBinary_array;

/**
 * Namespace of the ds_CryptoBinary complex type
 * @ingroup ds_CryptoBinary
 */
#define DS_CRYPTOBINARY_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_CryptoBinary complex type
 * @ingroup ds_CryptoBinary
 */
#define DS_CRYPTOBINARY_LOCAL "CryptoBinary"

/**
 * QName of the ds_CryptoBinary complex type
 * @ingroup ds_CryptoBinary
 */
extern xsd_QName ds_CryptoBinary_qname;
/**
 * Type information for serializing and deserializing ds_CryptoBinary elements
 * @ingroup ds_CryptoBinary
 */
extern struct globus_xsd_type_info_s ds_CryptoBinary_info;
/**
 * Type information for serializing and deserializing arrays of ds_CryptoBinary
 * elements
 * @ingroup ds_CryptoBinary
 */
extern struct globus_xsd_type_info_s ds_CryptoBinary_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_CryptoBinary without surrounding elements
 * @ingroup ds_CryptoBinary
 */
extern struct globus_xsd_type_info_s ds_CryptoBinary_contents_info;

/**
 * Initialize a ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 *
 * Allocates a new ds_CryptoBinary and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_CryptoBinary_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_CryptoBinary_init(
    ds_CryptoBinary ** inst);

/**
 * Destroy a ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 *
 * Frees a ds_CryptoBinary. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_CryptoBinary_destroy(
    ds_CryptoBinary * inst);

/**
 * Copy a ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 *
 * Perform a deep copy of a ds_CryptoBinary.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_CryptoBinary structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_CryptoBinary to be copied.
 */
globus_result_t
ds_CryptoBinary_copy(
    ds_CryptoBinary ** dest,
    const ds_CryptoBinary * src);

/**
 * Initialize the contents of a ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 *
 * Initialize the contents of a ds_CryptoBinary. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_CryptoBinary_init(). The contents may be freed
 * by calling ds_CryptoBinary_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_CryptoBinary.
 */
globus_result_t
ds_CryptoBinary_init_contents(
    ds_CryptoBinary * instance);

/**
 * Destroy the contents of a ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 *
 * Destroy the subelements and attributes of the given ds_CryptoBinary. 
 *
 * @param inst
 *     Pointer to a ds_CryptoBinary instance to destroy.
 */
void
ds_CryptoBinary_destroy_contents(
    ds_CryptoBinary * inst);

/**
 * Copy the contents of a ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 *
 * Perform a deep copy of the contents of a ds_CryptoBinary.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_CryptoBinary to be copied.
 */
globus_result_t
ds_CryptoBinary_copy_contents(
    ds_CryptoBinary * dest,
    const ds_CryptoBinary * src);

/**
 * Initialize an array of ds_CryptoBinary elements.
 * @ingroup ds_CryptoBinary
 *
 * Allocates a new array of 0 elements. When this array is no longer used,
 * it should be freed by calling 
 * ds_CryptoBinary_array_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated array instance.
 */
globus_result_t
ds_CryptoBinary_array_init(
    ds_CryptoBinary_array ** inst);

/**
 * Destroy an array of ds_CryptoBinary elements.
 * @ingroup ds_CryptoBinary
 *
 * Frees an array of ds_CryptoBinary elements. The contents of each element
 * element in the array be destroyed by calling
 * ds_CryptoBinary_destroy_contents().
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
ds_CryptoBinary_array_destroy(
    ds_CryptoBinary_array * inst);

/**
 * Copy an array of ds_CryptoBinary elements
 * @ingroup ds_CryptoBinary
 *
 * Perform a deep copy of an array of ds_CryptoBinary elements.
 * The @a dest array will be allocated, and then a copy of the contents
 * of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
ds_CryptoBinary_array_copy(
    ds_CryptoBinary_array ** dest,
    const ds_CryptoBinary_array * src);

/**
 * Initialize the contents of an array of ds_CryptoBinary elements
 * @ingroup ds_CryptoBinary
 *
 * Initialize the contents of an array of ds_CryptoBinary elements. Used
 * when the array is allocated on the stack or by a some allocator besides
 * ds_CryptoBinary_array_init(). The contents of the array may be freed
 * by calling ds_CryptoBinary_array_destroy_contents().
 *
 * @param inst
 *     Pointer to an allocated but uninitialized array.
 */
globus_result_t
ds_CryptoBinary_array_init_contents(
    ds_CryptoBinary_array * inst);

/**
 * Destroy the contents of an array of ds_CryptoBinary elements
 * @ingroup ds_CryptoBinary
 *
 * Destroy the elements in an array of ds_CryptoBinary elements. The contents of
 * each element in the array be destroyed by calling
 * ds_CryptoBinary_destroy_contents() and the array will be reset to be empty.
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
ds_CryptoBinary_array_destroy_contents(
    ds_CryptoBinary_array * inst);

/**
 * Copy the contents of an array of ds_CryptoBinary elements
 * @ingroup ds_CryptoBinary
 *
 * Perform a deep copy of an array of ds_CryptoBinary elements.
 * The @a dest array must be allocated before making this call.
 * A copy of the contents of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
ds_CryptoBinary_array_copy_contents(
    ds_CryptoBinary_array * dest,
    const ds_CryptoBinary_array * src);

/**
 * Append a new ds_CryptoBinary to an array
 * @ingroup ds_CryptoBinary
 *
 * Allocate and initialize a new ds_CryptoBinary structure, adding it
 * to the end of the given @a array.
 * 
 * @param array
 *     Array to be appended to.
 *
 * @return This function returns the newly allocated element.
 */
ds_CryptoBinary *
ds_CryptoBinary_array_push(
    ds_CryptoBinary_array * array);

/**
 * Serialize a ds_CryptoBinary
 * @ingroup ds_CryptoBinary_array
 * Serialize a ds_CryptoBinary structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_CryptoBinary.
 * @param val
 *     The ds_CryptoBinary to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_CryptoBinary_serialize(
    xsd_QName *                         element_name,
    ds_CryptoBinary * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_CryptoBinary
 * @ingroup ds_CryptoBinary_array
 * Serialize a ds_CryptoBinary structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_CryptoBinary to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_CryptoBinary_serialize_contents(
    xsd_QName *                         element_name,
    ds_CryptoBinary * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 * Deserialize an element containing a ds_CryptoBinary element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_CryptoBinary.
 * @param val
 *     Pointer to the ds_CryptoBinary which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_CryptoBinary_deserialize(
    xsd_QName *                         element_name,
    ds_CryptoBinary * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 * Deserialize a ds_CryptoBinary whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_CryptoBinary which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_CryptoBinary_deserialize_contents(
    xsd_QName *                         element_name,
    ds_CryptoBinary * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 * Deserialize the next element if it contains a ds_CryptoBinary.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_CryptoBinary.
 * @param instance
 *     Pointer to the <code>ds_CryptoBinary *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_CryptoBinary_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_CryptoBinary ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize an array of ds_CryptoBinary elements
 * @ingroup ds_CryptoBinary
 * Serialize an element containing an array of ds_CryptoBinary elements.
 *
 * @param element
 *     The name of the element which will contain the array.
 * @param array_instance
 *     The array to serialize
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_CryptoBinary_array_serialize(
    xsd_QName *                         element,
    ds_CryptoBinary_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an array of ds_CryptoBinary elements
 * @ingroup ds_CryptoBinary
 * Deserialize an element containing an array of ds_CryptoBinary elements.
 *
 * @param element
 *     The name of the element which should enclose the array.
 * @param array_instance
 *     The array to deserialize into
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_CryptoBinary_array_deserialize(
    xsd_QName *                         element,
    ds_CryptoBinary_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);



/**
 * Serialize an attribute of type ds_CryptoBinary
 * @ingroup ds_CryptoBinary_array
 * Serialize a ds_CryptoBinary as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a ds_CryptoBinary.
 * @param val
 *     The ds_CryptoBinary to serialize.
 * @param message
 *     The handle to serialize the attribute on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_CryptoBinary_serialize_attribute(
    xsd_QName *                         attr_qname,
    ds_CryptoBinary * val,
    globus_soap_message_handle_t        handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an attribute of type ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 * Deserialize a ds_CryptoBinary as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a ds_CryptoBinary.
 * @param instance
 *     Pointer to the ds_CryptoBinary which will be initialized with the
 *     value of the attribute.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_CryptoBinary_deserialize_attribute(
    xsd_QName *                         attr_qname,
    ds_CryptoBinary * instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional attribute of type ds_CryptoBinary
 * @ingroup ds_CryptoBinary
 * Try to deserialize a ds_CryptoBinary as an attribute of the current element
 * if it is present. The attribute's name is defined by @ attr_qname.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a ds_CryptoBinary.
 * @param instance
 *     Pointer to the ds_CryptoBinary which will be allocated and initialized
 *     with the value of the attribute if it is present.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_CryptoBinary_deserialize_attribute_pointer(
    xsd_QName *                         attr_qname,
    ds_CryptoBinary ** instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);


#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
globus_result_t
ds_CryptoBinary_init_wrapper(
    void **                             object);
    
void
ds_CryptoBinary_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_CryptoBinary_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);
    
globus_result_t
ds_CryptoBinary_init_contents_wrapper(
    void  *                             object);
    
void
ds_CryptoBinary_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_CryptoBinary_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);
    
globus_result_t
ds_CryptoBinary_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_CryptoBinary_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_CryptoBinary_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_CryptoBinary_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_CryptoBinary_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_CryptoBinary_array_init_wrapper(
    void **                             arr);
    
void
ds_CryptoBinary_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
ds_CryptoBinary_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);
globus_result_t
ds_CryptoBinary_array_init_contents_wrapper(
    void *                              arr);
    
void
ds_CryptoBinary_array_destroy_contents_wrapper(
    void *                              arr);
    
globus_result_t
ds_CryptoBinary_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);
    
globus_result_t
ds_CryptoBinary_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

void *
ds_CryptoBinary_array_push_wrapper(
    void * array);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
