/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_DIGESTMETHODTYPE_H_
#define _DS_DIGESTMETHODTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_DigestMethodType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}DigestMethodType element.
 * @ingroup ds_DigestMethodType
 */
typedef struct ds_DigestMethodType_s ds_DigestMethodType;
/**
 * The ds_DigestMethodType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}DigestMethodType element.
 * @ingroup ds_DigestMethodType
 */
typedef ds_DigestMethodType * ds_DigestMethodType_o;

/**
 * Namespace of the ds_DigestMethodType complex type
 * @ingroup ds_DigestMethodType
 */
#define DS_DIGESTMETHODTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_DigestMethodType complex type
 * @ingroup ds_DigestMethodType
 */
#define DS_DIGESTMETHODTYPE_LOCAL "DigestMethodType"

/**
 * QName of the ds_DigestMethodType complex type
 * @ingroup ds_DigestMethodType
 */
extern xsd_QName ds_DigestMethodType_qname;
/**
 * Type information for serializing and deserializing ds_DigestMethodType elements
 * @ingroup ds_DigestMethodType
 */
extern struct globus_xsd_type_info_s ds_DigestMethodType_info;
/**
 * Type information for serializing and deserializing arrays of ds_DigestMethodType
 * elements
 * @ingroup ds_DigestMethodType
 */
extern struct globus_xsd_type_info_s ds_DigestMethodType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_DigestMethodType without surrounding elements
 * @ingroup ds_DigestMethodType
 */
extern struct globus_xsd_type_info_s ds_DigestMethodType_contents_info;


#include "xsd_any.h"
#include "xsd_anyURI.h"
#include "ds_DigestMethodType_array.h"

/**
 * @defgroup ds_DigestMethodType Complex type: ds_DigestMethodType
 * @ingroup types
 */

/**
 * C structure for the ds_DigestMethodType complex type
 * @ingroup ds_DigestMethodType
 */
struct ds_DigestMethodType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyURI _Algorithm;

};

/**
 * Initialize a ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 *
 * Allocates a new ds_DigestMethodType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_DigestMethodType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_DigestMethodType_init(
    ds_DigestMethodType ** inst);

/**
 * Destroy a ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 *
 * Frees a ds_DigestMethodType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_DigestMethodType_destroy(
    ds_DigestMethodType * inst);

/**
 * Copy a ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 *
 * Perform a deep copy of a ds_DigestMethodType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_DigestMethodType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_DigestMethodType to be copied.
 */
globus_result_t
ds_DigestMethodType_copy(
    ds_DigestMethodType ** dest,
    const ds_DigestMethodType * src);

/**
 * Initialize the contents of a ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 *
 * Initialize the contents of a ds_DigestMethodType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_DigestMethodType_init(). The contents may be freed
 * by calling ds_DigestMethodType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_DigestMethodType.
 */
globus_result_t
ds_DigestMethodType_init_contents(
    ds_DigestMethodType * instance);

/**
 * Destroy the contents of a ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 *
 * Destroy the subelements and attributes of the given ds_DigestMethodType. 
 *
 * @param inst
 *     Pointer to a ds_DigestMethodType instance to destroy.
 */
void
ds_DigestMethodType_destroy_contents(
    ds_DigestMethodType * inst);

/**
 * Copy the contents of a ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 *
 * Perform a deep copy of the contents of a ds_DigestMethodType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_DigestMethodType to be copied.
 */
globus_result_t
ds_DigestMethodType_copy_contents(
    ds_DigestMethodType * dest,
    const ds_DigestMethodType * src);

/**
 * Serialize a ds_DigestMethodType
 * @ingroup ds_DigestMethodType_array
 * Serialize a ds_DigestMethodType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_DigestMethodType.
 * @param val
 *     The ds_DigestMethodType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_DigestMethodType_serialize(
    xsd_QName *                         element_name,
    ds_DigestMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_DigestMethodType
 * @ingroup ds_DigestMethodType_array
 * Serialize a ds_DigestMethodType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_DigestMethodType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_DigestMethodType_serialize_contents(
    xsd_QName *                         element_name,
    ds_DigestMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 * Deserialize an element containing a ds_DigestMethodType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_DigestMethodType.
 * @param val
 *     Pointer to the ds_DigestMethodType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_DigestMethodType_deserialize(
    xsd_QName *                         element_name,
    ds_DigestMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 * Deserialize a ds_DigestMethodType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_DigestMethodType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_DigestMethodType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_DigestMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_DigestMethodType
 * @ingroup ds_DigestMethodType
 * Deserialize the next element if it contains a ds_DigestMethodType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_DigestMethodType.
 * @param instance
 *     Pointer to the <code>ds_DigestMethodType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_DigestMethodType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_DigestMethodType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_DigestMethodType_init_wrapper(
    void **                             object);
    
void
ds_DigestMethodType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_DigestMethodType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_DigestMethodType_init_contents_wrapper(
    void *                              object);
    
void
ds_DigestMethodType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_DigestMethodType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_DigestMethodType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_DigestMethodType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_DigestMethodType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_DigestMethodType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
