/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_MANIFESTTYPE_H_
#define _DS_MANIFESTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_ManifestType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}ManifestType element.
 * @ingroup ds_ManifestType
 */
typedef struct ds_ManifestType_s ds_ManifestType;
/**
 * The ds_ManifestType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}ManifestType element.
 * @ingroup ds_ManifestType
 */
typedef ds_ManifestType * ds_ManifestType_o;

/**
 * Namespace of the ds_ManifestType complex type
 * @ingroup ds_ManifestType
 */
#define DS_MANIFESTTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_ManifestType complex type
 * @ingroup ds_ManifestType
 */
#define DS_MANIFESTTYPE_LOCAL "ManifestType"

/**
 * QName of the ds_ManifestType complex type
 * @ingroup ds_ManifestType
 */
extern xsd_QName ds_ManifestType_qname;
/**
 * Type information for serializing and deserializing ds_ManifestType elements
 * @ingroup ds_ManifestType
 */
extern struct globus_xsd_type_info_s ds_ManifestType_info;
/**
 * Type information for serializing and deserializing arrays of ds_ManifestType
 * elements
 * @ingroup ds_ManifestType
 */
extern struct globus_xsd_type_info_s ds_ManifestType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_ManifestType without surrounding elements
 * @ingroup ds_ManifestType
 */
extern struct globus_xsd_type_info_s ds_ManifestType_contents_info;


#include "ds_ReferenceType_array.h"
#include "xsd_ID.h"
#include "ds_ManifestType_array.h"

/**
 * @defgroup ds_ManifestType Complex type: ds_ManifestType
 * @ingroup types
 */

/**
 * C structure for the ds_ManifestType complex type
 * @ingroup ds_ManifestType
 */
struct ds_ManifestType_s
{
   /** Array of [1 .. Infinity] ds_ReferenceType elements */
    ds_ReferenceType_array Reference;
    xsd_ID_o _Id;

};

/**
 * Initialize a ds_ManifestType
 * @ingroup ds_ManifestType
 *
 * Allocates a new ds_ManifestType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_ManifestType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_ManifestType_init(
    ds_ManifestType ** inst);

/**
 * Destroy a ds_ManifestType
 * @ingroup ds_ManifestType
 *
 * Frees a ds_ManifestType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_ManifestType_destroy(
    ds_ManifestType * inst);

/**
 * Copy a ds_ManifestType
 * @ingroup ds_ManifestType
 *
 * Perform a deep copy of a ds_ManifestType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_ManifestType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_ManifestType to be copied.
 */
globus_result_t
ds_ManifestType_copy(
    ds_ManifestType ** dest,
    const ds_ManifestType * src);

/**
 * Initialize the contents of a ds_ManifestType
 * @ingroup ds_ManifestType
 *
 * Initialize the contents of a ds_ManifestType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_ManifestType_init(). The contents may be freed
 * by calling ds_ManifestType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_ManifestType.
 */
globus_result_t
ds_ManifestType_init_contents(
    ds_ManifestType * instance);

/**
 * Destroy the contents of a ds_ManifestType
 * @ingroup ds_ManifestType
 *
 * Destroy the subelements and attributes of the given ds_ManifestType. 
 *
 * @param inst
 *     Pointer to a ds_ManifestType instance to destroy.
 */
void
ds_ManifestType_destroy_contents(
    ds_ManifestType * inst);

/**
 * Copy the contents of a ds_ManifestType
 * @ingroup ds_ManifestType
 *
 * Perform a deep copy of the contents of a ds_ManifestType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_ManifestType to be copied.
 */
globus_result_t
ds_ManifestType_copy_contents(
    ds_ManifestType * dest,
    const ds_ManifestType * src);

/**
 * Serialize a ds_ManifestType
 * @ingroup ds_ManifestType_array
 * Serialize a ds_ManifestType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_ManifestType.
 * @param val
 *     The ds_ManifestType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_ManifestType_serialize(
    xsd_QName *                         element_name,
    ds_ManifestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_ManifestType
 * @ingroup ds_ManifestType_array
 * Serialize a ds_ManifestType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_ManifestType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_ManifestType_serialize_contents(
    xsd_QName *                         element_name,
    ds_ManifestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_ManifestType
 * @ingroup ds_ManifestType
 * Deserialize an element containing a ds_ManifestType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_ManifestType.
 * @param val
 *     Pointer to the ds_ManifestType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ManifestType_deserialize(
    xsd_QName *                         element_name,
    ds_ManifestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_ManifestType
 * @ingroup ds_ManifestType
 * Deserialize a ds_ManifestType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_ManifestType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ManifestType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_ManifestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_ManifestType
 * @ingroup ds_ManifestType
 * Deserialize the next element if it contains a ds_ManifestType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_ManifestType.
 * @param instance
 *     Pointer to the <code>ds_ManifestType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ManifestType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_ManifestType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_ManifestType_init_wrapper(
    void **                             object);
    
void
ds_ManifestType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_ManifestType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_ManifestType_init_contents_wrapper(
    void *                              object);
    
void
ds_ManifestType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_ManifestType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_ManifestType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_ManifestType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_ManifestType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_ManifestType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
