/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_PGPDATATYPE_H_
#define _DS_PGPDATATYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_PGPDataType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}PGPDataType element.
 * @ingroup ds_PGPDataType
 */
typedef struct ds_PGPDataType_s ds_PGPDataType;
/**
 * The ds_PGPDataType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}PGPDataType element.
 * @ingroup ds_PGPDataType
 */
typedef ds_PGPDataType * ds_PGPDataType_o;

/**
 * Namespace of the ds_PGPDataType complex type
 * @ingroup ds_PGPDataType
 */
#define DS_PGPDATATYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_PGPDataType complex type
 * @ingroup ds_PGPDataType
 */
#define DS_PGPDATATYPE_LOCAL "PGPDataType"

/**
 * QName of the ds_PGPDataType complex type
 * @ingroup ds_PGPDataType
 */
extern xsd_QName ds_PGPDataType_qname;
/**
 * Type information for serializing and deserializing ds_PGPDataType elements
 * @ingroup ds_PGPDataType
 */
extern struct globus_xsd_type_info_s ds_PGPDataType_info;
/**
 * Type information for serializing and deserializing arrays of ds_PGPDataType
 * elements
 * @ingroup ds_PGPDataType
 */
extern struct globus_xsd_type_info_s ds_PGPDataType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_PGPDataType without surrounding elements
 * @ingroup ds_PGPDataType
 */
extern struct globus_xsd_type_info_s ds_PGPDataType_contents_info;


#include "ds_PGPDataType_choice.h"
#include "ds_PGPDataType_array.h"

/**
 * @defgroup ds_PGPDataType Complex type: ds_PGPDataType
 * @ingroup types
 */

/**
 * C structure for the ds_PGPDataType complex type
 * @ingroup ds_PGPDataType
 */
struct ds_PGPDataType_s
{
    /** ds_PGPDataType_choice subelement */
    ds_PGPDataType_choice choice_value;

};

/**
 * Initialize a ds_PGPDataType
 * @ingroup ds_PGPDataType
 *
 * Allocates a new ds_PGPDataType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_PGPDataType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_PGPDataType_init(
    ds_PGPDataType ** inst);

/**
 * Destroy a ds_PGPDataType
 * @ingroup ds_PGPDataType
 *
 * Frees a ds_PGPDataType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_PGPDataType_destroy(
    ds_PGPDataType * inst);

/**
 * Copy a ds_PGPDataType
 * @ingroup ds_PGPDataType
 *
 * Perform a deep copy of a ds_PGPDataType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_PGPDataType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_PGPDataType to be copied.
 */
globus_result_t
ds_PGPDataType_copy(
    ds_PGPDataType ** dest,
    const ds_PGPDataType * src);

/**
 * Initialize the contents of a ds_PGPDataType
 * @ingroup ds_PGPDataType
 *
 * Initialize the contents of a ds_PGPDataType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_PGPDataType_init(). The contents may be freed
 * by calling ds_PGPDataType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_PGPDataType.
 */
globus_result_t
ds_PGPDataType_init_contents(
    ds_PGPDataType * instance);

/**
 * Destroy the contents of a ds_PGPDataType
 * @ingroup ds_PGPDataType
 *
 * Destroy the subelements and attributes of the given ds_PGPDataType. 
 *
 * @param inst
 *     Pointer to a ds_PGPDataType instance to destroy.
 */
void
ds_PGPDataType_destroy_contents(
    ds_PGPDataType * inst);

/**
 * Copy the contents of a ds_PGPDataType
 * @ingroup ds_PGPDataType
 *
 * Perform a deep copy of the contents of a ds_PGPDataType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_PGPDataType to be copied.
 */
globus_result_t
ds_PGPDataType_copy_contents(
    ds_PGPDataType * dest,
    const ds_PGPDataType * src);

/**
 * Serialize a ds_PGPDataType
 * @ingroup ds_PGPDataType_array
 * Serialize a ds_PGPDataType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_PGPDataType.
 * @param val
 *     The ds_PGPDataType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_PGPDataType_serialize(
    xsd_QName *                         element_name,
    ds_PGPDataType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_PGPDataType
 * @ingroup ds_PGPDataType_array
 * Serialize a ds_PGPDataType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_PGPDataType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_PGPDataType_serialize_contents(
    xsd_QName *                         element_name,
    ds_PGPDataType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_PGPDataType
 * @ingroup ds_PGPDataType
 * Deserialize an element containing a ds_PGPDataType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_PGPDataType.
 * @param val
 *     Pointer to the ds_PGPDataType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_PGPDataType_deserialize(
    xsd_QName *                         element_name,
    ds_PGPDataType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_PGPDataType
 * @ingroup ds_PGPDataType
 * Deserialize a ds_PGPDataType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_PGPDataType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_PGPDataType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_PGPDataType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_PGPDataType
 * @ingroup ds_PGPDataType
 * Deserialize the next element if it contains a ds_PGPDataType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_PGPDataType.
 * @param instance
 *     Pointer to the <code>ds_PGPDataType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_PGPDataType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_PGPDataType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_PGPDataType_init_wrapper(
    void **                             object);
    
void
ds_PGPDataType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_PGPDataType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_PGPDataType_init_contents_wrapper(
    void *                              object);
    
void
ds_PGPDataType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_PGPDataType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_PGPDataType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_PGPDataType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_PGPDataType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_PGPDataType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
