/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_RSAKEYVALUETYPE_H_
#define _DS_RSAKEYVALUETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_RSAKeyValueType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}RSAKeyValueType element.
 * @ingroup ds_RSAKeyValueType
 */
typedef struct ds_RSAKeyValueType_s ds_RSAKeyValueType;
/**
 * The ds_RSAKeyValueType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}RSAKeyValueType element.
 * @ingroup ds_RSAKeyValueType
 */
typedef ds_RSAKeyValueType * ds_RSAKeyValueType_o;

/**
 * Namespace of the ds_RSAKeyValueType complex type
 * @ingroup ds_RSAKeyValueType
 */
#define DS_RSAKEYVALUETYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_RSAKeyValueType complex type
 * @ingroup ds_RSAKeyValueType
 */
#define DS_RSAKEYVALUETYPE_LOCAL "RSAKeyValueType"

/**
 * QName of the ds_RSAKeyValueType complex type
 * @ingroup ds_RSAKeyValueType
 */
extern xsd_QName ds_RSAKeyValueType_qname;
/**
 * Type information for serializing and deserializing ds_RSAKeyValueType elements
 * @ingroup ds_RSAKeyValueType
 */
extern struct globus_xsd_type_info_s ds_RSAKeyValueType_info;
/**
 * Type information for serializing and deserializing arrays of ds_RSAKeyValueType
 * elements
 * @ingroup ds_RSAKeyValueType
 */
extern struct globus_xsd_type_info_s ds_RSAKeyValueType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_RSAKeyValueType without surrounding elements
 * @ingroup ds_RSAKeyValueType
 */
extern struct globus_xsd_type_info_s ds_RSAKeyValueType_contents_info;


#include "ds_CryptoBinary.h"
#include "ds_CryptoBinary.h"
#include "ds_RSAKeyValueType_array.h"

/**
 * @defgroup ds_RSAKeyValueType Complex type: ds_RSAKeyValueType
 * @ingroup types
 */

/**
 * C structure for the ds_RSAKeyValueType complex type
 * @ingroup ds_RSAKeyValueType
 */
struct ds_RSAKeyValueType_s
{
    /** ds_CryptoBinary subelement */
    ds_CryptoBinary Modulus;
    /** ds_CryptoBinary subelement */
    ds_CryptoBinary Exponent;

};

/**
 * Initialize a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 *
 * Allocates a new ds_RSAKeyValueType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_RSAKeyValueType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_RSAKeyValueType_init(
    ds_RSAKeyValueType ** inst);

/**
 * Destroy a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 *
 * Frees a ds_RSAKeyValueType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_RSAKeyValueType_destroy(
    ds_RSAKeyValueType * inst);

/**
 * Copy a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 *
 * Perform a deep copy of a ds_RSAKeyValueType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_RSAKeyValueType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_RSAKeyValueType to be copied.
 */
globus_result_t
ds_RSAKeyValueType_copy(
    ds_RSAKeyValueType ** dest,
    const ds_RSAKeyValueType * src);

/**
 * Initialize the contents of a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 *
 * Initialize the contents of a ds_RSAKeyValueType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_RSAKeyValueType_init(). The contents may be freed
 * by calling ds_RSAKeyValueType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_RSAKeyValueType.
 */
globus_result_t
ds_RSAKeyValueType_init_contents(
    ds_RSAKeyValueType * instance);

/**
 * Destroy the contents of a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 *
 * Destroy the subelements and attributes of the given ds_RSAKeyValueType. 
 *
 * @param inst
 *     Pointer to a ds_RSAKeyValueType instance to destroy.
 */
void
ds_RSAKeyValueType_destroy_contents(
    ds_RSAKeyValueType * inst);

/**
 * Copy the contents of a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 *
 * Perform a deep copy of the contents of a ds_RSAKeyValueType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_RSAKeyValueType to be copied.
 */
globus_result_t
ds_RSAKeyValueType_copy_contents(
    ds_RSAKeyValueType * dest,
    const ds_RSAKeyValueType * src);

/**
 * Serialize a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType_array
 * Serialize a ds_RSAKeyValueType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_RSAKeyValueType.
 * @param val
 *     The ds_RSAKeyValueType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_RSAKeyValueType_serialize(
    xsd_QName *                         element_name,
    ds_RSAKeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType_array
 * Serialize a ds_RSAKeyValueType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_RSAKeyValueType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_RSAKeyValueType_serialize_contents(
    xsd_QName *                         element_name,
    ds_RSAKeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 * Deserialize an element containing a ds_RSAKeyValueType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_RSAKeyValueType.
 * @param val
 *     Pointer to the ds_RSAKeyValueType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_RSAKeyValueType_deserialize(
    xsd_QName *                         element_name,
    ds_RSAKeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 * Deserialize a ds_RSAKeyValueType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_RSAKeyValueType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_RSAKeyValueType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_RSAKeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_RSAKeyValueType
 * @ingroup ds_RSAKeyValueType
 * Deserialize the next element if it contains a ds_RSAKeyValueType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_RSAKeyValueType.
 * @param instance
 *     Pointer to the <code>ds_RSAKeyValueType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_RSAKeyValueType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_RSAKeyValueType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_RSAKeyValueType_init_wrapper(
    void **                             object);
    
void
ds_RSAKeyValueType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_RSAKeyValueType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_RSAKeyValueType_init_contents_wrapper(
    void *                              object);
    
void
ds_RSAKeyValueType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_RSAKeyValueType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_RSAKeyValueType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_RSAKeyValueType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_RSAKeyValueType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_RSAKeyValueType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
