/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_REFERENCETYPE_H_
#define _DS_REFERENCETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_ReferenceType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}ReferenceType element.
 * @ingroup ds_ReferenceType
 */
typedef struct ds_ReferenceType_s ds_ReferenceType;
/**
 * The ds_ReferenceType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}ReferenceType element.
 * @ingroup ds_ReferenceType
 */
typedef ds_ReferenceType * ds_ReferenceType_o;

/**
 * Namespace of the ds_ReferenceType complex type
 * @ingroup ds_ReferenceType
 */
#define DS_REFERENCETYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_ReferenceType complex type
 * @ingroup ds_ReferenceType
 */
#define DS_REFERENCETYPE_LOCAL "ReferenceType"

/**
 * QName of the ds_ReferenceType complex type
 * @ingroup ds_ReferenceType
 */
extern xsd_QName ds_ReferenceType_qname;
/**
 * Type information for serializing and deserializing ds_ReferenceType elements
 * @ingroup ds_ReferenceType
 */
extern struct globus_xsd_type_info_s ds_ReferenceType_info;
/**
 * Type information for serializing and deserializing arrays of ds_ReferenceType
 * elements
 * @ingroup ds_ReferenceType
 */
extern struct globus_xsd_type_info_s ds_ReferenceType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_ReferenceType without surrounding elements
 * @ingroup ds_ReferenceType
 */
extern struct globus_xsd_type_info_s ds_ReferenceType_contents_info;


#include "ds_TransformsType.h"
#include "ds_DigestMethodType.h"
#include "ds_DigestValueType.h"
#include "xsd_ID.h"
#include "xsd_anyURI.h"
#include "xsd_anyURI.h"
#include "ds_ReferenceType_array.h"

/**
 * @defgroup ds_ReferenceType Complex type: ds_ReferenceType
 * @ingroup types
 */

/**
 * C structure for the ds_ReferenceType complex type
 * @ingroup ds_ReferenceType
 */
struct ds_ReferenceType_s
{
   /** Optional ds_TransformsType subelement */
    ds_TransformsType_o Transforms;
    /** ds_DigestMethodType subelement */
    ds_DigestMethodType DigestMethod;
    /** ds_DigestValueType subelement */
    ds_DigestValueType DigestValue;
    xsd_ID_o _Id;
    xsd_anyURI_o _Type;
    xsd_anyURI_o _URI;

};

/**
 * Initialize a ds_ReferenceType
 * @ingroup ds_ReferenceType
 *
 * Allocates a new ds_ReferenceType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_ReferenceType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_ReferenceType_init(
    ds_ReferenceType ** inst);

/**
 * Destroy a ds_ReferenceType
 * @ingroup ds_ReferenceType
 *
 * Frees a ds_ReferenceType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_ReferenceType_destroy(
    ds_ReferenceType * inst);

/**
 * Copy a ds_ReferenceType
 * @ingroup ds_ReferenceType
 *
 * Perform a deep copy of a ds_ReferenceType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_ReferenceType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_ReferenceType to be copied.
 */
globus_result_t
ds_ReferenceType_copy(
    ds_ReferenceType ** dest,
    const ds_ReferenceType * src);

/**
 * Initialize the contents of a ds_ReferenceType
 * @ingroup ds_ReferenceType
 *
 * Initialize the contents of a ds_ReferenceType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_ReferenceType_init(). The contents may be freed
 * by calling ds_ReferenceType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_ReferenceType.
 */
globus_result_t
ds_ReferenceType_init_contents(
    ds_ReferenceType * instance);

/**
 * Destroy the contents of a ds_ReferenceType
 * @ingroup ds_ReferenceType
 *
 * Destroy the subelements and attributes of the given ds_ReferenceType. 
 *
 * @param inst
 *     Pointer to a ds_ReferenceType instance to destroy.
 */
void
ds_ReferenceType_destroy_contents(
    ds_ReferenceType * inst);

/**
 * Copy the contents of a ds_ReferenceType
 * @ingroup ds_ReferenceType
 *
 * Perform a deep copy of the contents of a ds_ReferenceType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_ReferenceType to be copied.
 */
globus_result_t
ds_ReferenceType_copy_contents(
    ds_ReferenceType * dest,
    const ds_ReferenceType * src);

/**
 * Serialize a ds_ReferenceType
 * @ingroup ds_ReferenceType_array
 * Serialize a ds_ReferenceType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_ReferenceType.
 * @param val
 *     The ds_ReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_ReferenceType_serialize(
    xsd_QName *                         element_name,
    ds_ReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_ReferenceType
 * @ingroup ds_ReferenceType_array
 * Serialize a ds_ReferenceType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_ReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_ReferenceType_serialize_contents(
    xsd_QName *                         element_name,
    ds_ReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_ReferenceType
 * @ingroup ds_ReferenceType
 * Deserialize an element containing a ds_ReferenceType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_ReferenceType.
 * @param val
 *     Pointer to the ds_ReferenceType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ReferenceType_deserialize(
    xsd_QName *                         element_name,
    ds_ReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_ReferenceType
 * @ingroup ds_ReferenceType
 * Deserialize a ds_ReferenceType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_ReferenceType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ReferenceType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_ReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_ReferenceType
 * @ingroup ds_ReferenceType
 * Deserialize the next element if it contains a ds_ReferenceType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_ReferenceType.
 * @param instance
 *     Pointer to the <code>ds_ReferenceType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ReferenceType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_ReferenceType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_ReferenceType_init_wrapper(
    void **                             object);
    
void
ds_ReferenceType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_ReferenceType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_ReferenceType_init_contents_wrapper(
    void *                              object);
    
void
ds_ReferenceType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_ReferenceType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_ReferenceType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_ReferenceType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_ReferenceType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_ReferenceType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
