/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_SPKIDATATYPE_H_
#define _DS_SPKIDATATYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_SPKIDataType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}SPKIDataType element.
 * @ingroup ds_SPKIDataType
 */
typedef struct ds_SPKIDataType_s ds_SPKIDataType;
/**
 * The ds_SPKIDataType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}SPKIDataType element.
 * @ingroup ds_SPKIDataType
 */
typedef ds_SPKIDataType * ds_SPKIDataType_o;

/**
 * Namespace of the ds_SPKIDataType complex type
 * @ingroup ds_SPKIDataType
 */
#define DS_SPKIDATATYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_SPKIDataType complex type
 * @ingroup ds_SPKIDataType
 */
#define DS_SPKIDATATYPE_LOCAL "SPKIDataType"

/**
 * QName of the ds_SPKIDataType complex type
 * @ingroup ds_SPKIDataType
 */
extern xsd_QName ds_SPKIDataType_qname;
/**
 * Type information for serializing and deserializing ds_SPKIDataType elements
 * @ingroup ds_SPKIDataType
 */
extern struct globus_xsd_type_info_s ds_SPKIDataType_info;
/**
 * Type information for serializing and deserializing arrays of ds_SPKIDataType
 * elements
 * @ingroup ds_SPKIDataType
 */
extern struct globus_xsd_type_info_s ds_SPKIDataType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_SPKIDataType without surrounding elements
 * @ingroup ds_SPKIDataType
 */
extern struct globus_xsd_type_info_s ds_SPKIDataType_contents_info;


#include "xsd_base64Binary.h"
#include "xsd_any.h"
#include "ds_SPKIDataType_array.h"

/**
 * @defgroup ds_SPKIDataType Complex type: ds_SPKIDataType
 * @ingroup types
 */

/**
 * C structure for the ds_SPKIDataType complex type
 * @ingroup ds_SPKIDataType
 */
struct ds_SPKIDataType_s
{
    /** xsd_base64Binary subelement */
    xsd_base64Binary SPKISexp;
   /** Optional xsd_any subelement */
    xsd_any_o any;

};

/**
 * Initialize a ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 *
 * Allocates a new ds_SPKIDataType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_SPKIDataType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_SPKIDataType_init(
    ds_SPKIDataType ** inst);

/**
 * Destroy a ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 *
 * Frees a ds_SPKIDataType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_SPKIDataType_destroy(
    ds_SPKIDataType * inst);

/**
 * Copy a ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 *
 * Perform a deep copy of a ds_SPKIDataType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_SPKIDataType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_SPKIDataType to be copied.
 */
globus_result_t
ds_SPKIDataType_copy(
    ds_SPKIDataType ** dest,
    const ds_SPKIDataType * src);

/**
 * Initialize the contents of a ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 *
 * Initialize the contents of a ds_SPKIDataType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_SPKIDataType_init(). The contents may be freed
 * by calling ds_SPKIDataType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_SPKIDataType.
 */
globus_result_t
ds_SPKIDataType_init_contents(
    ds_SPKIDataType * instance);

/**
 * Destroy the contents of a ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 *
 * Destroy the subelements and attributes of the given ds_SPKIDataType. 
 *
 * @param inst
 *     Pointer to a ds_SPKIDataType instance to destroy.
 */
void
ds_SPKIDataType_destroy_contents(
    ds_SPKIDataType * inst);

/**
 * Copy the contents of a ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 *
 * Perform a deep copy of the contents of a ds_SPKIDataType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_SPKIDataType to be copied.
 */
globus_result_t
ds_SPKIDataType_copy_contents(
    ds_SPKIDataType * dest,
    const ds_SPKIDataType * src);

/**
 * Serialize a ds_SPKIDataType
 * @ingroup ds_SPKIDataType_array
 * Serialize a ds_SPKIDataType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_SPKIDataType.
 * @param val
 *     The ds_SPKIDataType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SPKIDataType_serialize(
    xsd_QName *                         element_name,
    ds_SPKIDataType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_SPKIDataType
 * @ingroup ds_SPKIDataType_array
 * Serialize a ds_SPKIDataType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_SPKIDataType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SPKIDataType_serialize_contents(
    xsd_QName *                         element_name,
    ds_SPKIDataType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 * Deserialize an element containing a ds_SPKIDataType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SPKIDataType.
 * @param val
 *     Pointer to the ds_SPKIDataType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SPKIDataType_deserialize(
    xsd_QName *                         element_name,
    ds_SPKIDataType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 * Deserialize a ds_SPKIDataType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_SPKIDataType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SPKIDataType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_SPKIDataType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_SPKIDataType
 * @ingroup ds_SPKIDataType
 * Deserialize the next element if it contains a ds_SPKIDataType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SPKIDataType.
 * @param instance
 *     Pointer to the <code>ds_SPKIDataType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SPKIDataType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_SPKIDataType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_SPKIDataType_init_wrapper(
    void **                             object);
    
void
ds_SPKIDataType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_SPKIDataType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_SPKIDataType_init_contents_wrapper(
    void *                              object);
    
void
ds_SPKIDataType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_SPKIDataType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_SPKIDataType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SPKIDataType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SPKIDataType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SPKIDataType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
