/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_SIGNATUREPROPERTYTYPE_H_
#define _DS_SIGNATUREPROPERTYTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_SignaturePropertyType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}SignaturePropertyType element.
 * @ingroup ds_SignaturePropertyType
 */
typedef struct ds_SignaturePropertyType_s ds_SignaturePropertyType;
/**
 * The ds_SignaturePropertyType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}SignaturePropertyType element.
 * @ingroup ds_SignaturePropertyType
 */
typedef ds_SignaturePropertyType * ds_SignaturePropertyType_o;

/**
 * Namespace of the ds_SignaturePropertyType complex type
 * @ingroup ds_SignaturePropertyType
 */
#define DS_SIGNATUREPROPERTYTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_SignaturePropertyType complex type
 * @ingroup ds_SignaturePropertyType
 */
#define DS_SIGNATUREPROPERTYTYPE_LOCAL "SignaturePropertyType"

/**
 * QName of the ds_SignaturePropertyType complex type
 * @ingroup ds_SignaturePropertyType
 */
extern xsd_QName ds_SignaturePropertyType_qname;
/**
 * Type information for serializing and deserializing ds_SignaturePropertyType elements
 * @ingroup ds_SignaturePropertyType
 */
extern struct globus_xsd_type_info_s ds_SignaturePropertyType_info;
/**
 * Type information for serializing and deserializing arrays of ds_SignaturePropertyType
 * elements
 * @ingroup ds_SignaturePropertyType
 */
extern struct globus_xsd_type_info_s ds_SignaturePropertyType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_SignaturePropertyType without surrounding elements
 * @ingroup ds_SignaturePropertyType
 */
extern struct globus_xsd_type_info_s ds_SignaturePropertyType_contents_info;


#include "ds_SignaturePropertyType_choice.h"
#include "xsd_ID.h"
#include "xsd_anyURI.h"
#include "ds_SignaturePropertyType_array.h"

/**
 * @defgroup ds_SignaturePropertyType Complex type: ds_SignaturePropertyType
 * @ingroup types
 */

/**
 * C structure for the ds_SignaturePropertyType complex type
 * @ingroup ds_SignaturePropertyType
 */
struct ds_SignaturePropertyType_s
{
   /** Array of [1 .. Infinity] ds_SignaturePropertyType_choice elements */
    ds_SignaturePropertyType_choice_array choice_value;
    xsd_ID_o _Id;
    xsd_anyURI _Target;

};

/**
 * Initialize a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 *
 * Allocates a new ds_SignaturePropertyType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_SignaturePropertyType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_SignaturePropertyType_init(
    ds_SignaturePropertyType ** inst);

/**
 * Destroy a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 *
 * Frees a ds_SignaturePropertyType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_SignaturePropertyType_destroy(
    ds_SignaturePropertyType * inst);

/**
 * Copy a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 *
 * Perform a deep copy of a ds_SignaturePropertyType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_SignaturePropertyType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_SignaturePropertyType to be copied.
 */
globus_result_t
ds_SignaturePropertyType_copy(
    ds_SignaturePropertyType ** dest,
    const ds_SignaturePropertyType * src);

/**
 * Initialize the contents of a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 *
 * Initialize the contents of a ds_SignaturePropertyType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_SignaturePropertyType_init(). The contents may be freed
 * by calling ds_SignaturePropertyType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_SignaturePropertyType.
 */
globus_result_t
ds_SignaturePropertyType_init_contents(
    ds_SignaturePropertyType * instance);

/**
 * Destroy the contents of a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 *
 * Destroy the subelements and attributes of the given ds_SignaturePropertyType. 
 *
 * @param inst
 *     Pointer to a ds_SignaturePropertyType instance to destroy.
 */
void
ds_SignaturePropertyType_destroy_contents(
    ds_SignaturePropertyType * inst);

/**
 * Copy the contents of a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 *
 * Perform a deep copy of the contents of a ds_SignaturePropertyType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_SignaturePropertyType to be copied.
 */
globus_result_t
ds_SignaturePropertyType_copy_contents(
    ds_SignaturePropertyType * dest,
    const ds_SignaturePropertyType * src);

/**
 * Serialize a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType_array
 * Serialize a ds_SignaturePropertyType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_SignaturePropertyType.
 * @param val
 *     The ds_SignaturePropertyType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignaturePropertyType_serialize(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType_array
 * Serialize a ds_SignaturePropertyType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_SignaturePropertyType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignaturePropertyType_serialize_contents(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 * Deserialize an element containing a ds_SignaturePropertyType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignaturePropertyType.
 * @param val
 *     Pointer to the ds_SignaturePropertyType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignaturePropertyType_deserialize(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 * Deserialize a ds_SignaturePropertyType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_SignaturePropertyType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignaturePropertyType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 * Deserialize the next element if it contains a ds_SignaturePropertyType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignaturePropertyType.
 * @param instance
 *     Pointer to the <code>ds_SignaturePropertyType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignaturePropertyType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_SignaturePropertyType_init_wrapper(
    void **                             object);
    
void
ds_SignaturePropertyType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_SignaturePropertyType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignaturePropertyType_init_contents_wrapper(
    void *                              object);
    
void
ds_SignaturePropertyType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_SignaturePropertyType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignaturePropertyType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignaturePropertyType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignaturePropertyType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignaturePropertyType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
