/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_SIGNATUREPROPERTYTYPE_CHOICE_H_
#define _DS_SIGNATUREPROPERTYTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum ds_SignaturePropertyType_e
{
    ds_SignaturePropertyType_undefined,
    ds_SignaturePropertyType_any

};

/**
 * @defgroup ds_SignaturePropertyType_choice Complex choice type: ds_SignaturePropertyType
 * @ingroup ds_SignaturePropertyType
 */

/**
 * Enumeration of the types of values which the ds_SignaturePropertyType_choice
 * structure may take on.
 * @ingroup ds_SignaturePropertyType_choice
 */
typedef enum ds_SignaturePropertyType_e ds_SignaturePropertyType_enum;
/**
 * Union of the values which the ds_SignaturePropertyType_choice structure
 * contains
 * @ingroup ds_SignaturePropertyType_choice
 */
typedef union ds_SignaturePropertyType_u ds_SignaturePropertyType_union;
/**
 * The ds_SignaturePropertyType complex type, which represents the various values
 * possible by the choice used by the
 * {http://www.w3.org/2000/09/xmldsig#}choice 61 element.
 * @ingroup ds_SignaturePropertyType_choice
 */
typedef struct ds_SignaturePropertyType_choice_s ds_SignaturePropertyType_choice;
/**
 * The ds_SignaturePropertyType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://www.w3.org/2000/09/xmldsig#}choice 61 element.
 * @ingroup ds_SignaturePropertyType
 */
typedef ds_SignaturePropertyType_choice * ds_SignaturePropertyType_choice_o;

typedef struct ds_SignaturePropertyType_choice_array_s
{
    ds_SignaturePropertyType_choice * elements;
    int                                 length;
} ds_SignaturePropertyType_choice_array;

#define DS_SIGNATUREPROPERTYTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
#define DS_SIGNATUREPROPERTYTYPE_LOCAL "SignaturePropertyType"

extern xsd_QName ds_SignaturePropertyType_choice_qname;
extern struct globus_xsd_type_info_s ds_SignaturePropertyType_choice_info;
extern struct globus_xsd_type_info_s ds_SignaturePropertyType_choice_contents_info;
extern struct globus_xsd_type_info_s ds_SignaturePropertyType_choice_array_info;


#include "xsd_any.h"

union ds_SignaturePropertyType_u
{
    /** xsd_any subelement */
    xsd_any any;

};

struct ds_SignaturePropertyType_choice_s
{
    ds_SignaturePropertyType_enum type;
    ds_SignaturePropertyType_union value;
};

globus_result_t
ds_SignaturePropertyType_choice_init(
    ds_SignaturePropertyType_choice ** inst);

void
ds_SignaturePropertyType_choice_destroy(
    ds_SignaturePropertyType_choice * inst);

globus_result_t
ds_SignaturePropertyType_choice_copy(
    ds_SignaturePropertyType_choice ** dest,
    const ds_SignaturePropertyType_choice * src);

globus_result_t
ds_SignaturePropertyType_choice_init_contents(
    ds_SignaturePropertyType_choice * instance);

void
ds_SignaturePropertyType_choice_destroy_contents(
    ds_SignaturePropertyType_choice * inst);

globus_result_t
ds_SignaturePropertyType_choice_copy_contents(
    ds_SignaturePropertyType_choice * dest,
    const ds_SignaturePropertyType_choice * src);
    
globus_result_t
ds_SignaturePropertyType_choice_array_init(
    ds_SignaturePropertyType_choice_array ** inst);

void
ds_SignaturePropertyType_choice_array_destroy(
    ds_SignaturePropertyType_choice_array * inst);

globus_result_t
ds_SignaturePropertyType_choice_array_copy(
    ds_SignaturePropertyType_choice_array ** dest,
    const ds_SignaturePropertyType_choice_array * src);

globus_result_t
ds_SignaturePropertyType_choice_array_init_contents(
    ds_SignaturePropertyType_choice_array * inst);

void
ds_SignaturePropertyType_choice_array_destroy_contents(
    ds_SignaturePropertyType_choice_array * inst);

globus_result_t
ds_SignaturePropertyType_choice_array_copy_contents(
    ds_SignaturePropertyType_choice_array * dest,
    const ds_SignaturePropertyType_choice_array * src);

ds_SignaturePropertyType_choice *
ds_SignaturePropertyType_choice_array_push(
    ds_SignaturePropertyType_choice_array * array);

globus_result_t
ds_SignaturePropertyType_choice_serialize(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignaturePropertyType_choice_serialize_contents(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignaturePropertyType_choice_deserialize(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignaturePropertyType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignaturePropertyType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_SignaturePropertyType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignaturePropertyType_choice_array_serialize(
    xsd_QName *                         element,
    ds_SignaturePropertyType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignaturePropertyType_choice_array_deserialize(
    xsd_QName *                         element,
    ds_SignaturePropertyType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignaturePropertyType_choice_init_wrapper(
    void **                             object);
    
void
ds_SignaturePropertyType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_SignaturePropertyType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignaturePropertyType_choice_init_contents_wrapper(
    void *                              object);
    
void
ds_SignaturePropertyType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_SignaturePropertyType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignaturePropertyType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignaturePropertyType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignaturePropertyType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignaturePropertyType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignaturePropertyType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignaturePropertyType_choice_array_init_wrapper(
    void **                             arr);
    
void
ds_SignaturePropertyType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
ds_SignaturePropertyType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
ds_SignaturePropertyType_choice_array_init_contents_wrapper(
    void *                              arr);

void
ds_SignaturePropertyType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
ds_SignaturePropertyType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
ds_SignaturePropertyType_choice_array_push_wrapper(
    void * array);

globus_result_t
ds_SignaturePropertyType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
