/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_SIGNATUREVALUETYPE_H_
#define _DS_SIGNATUREVALUETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_SignatureValueType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}SignatureValueType element.
 * @ingroup ds_SignatureValueType
 */
typedef struct ds_SignatureValueType_s ds_SignatureValueType;
/**
 * The ds_SignatureValueType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}SignatureValueType element.
 * @ingroup ds_SignatureValueType
 */
typedef ds_SignatureValueType * ds_SignatureValueType_o;

/**
 * Namespace of the ds_SignatureValueType complex type
 * @ingroup ds_SignatureValueType
 */
#define DS_SIGNATUREVALUETYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_SignatureValueType complex type
 * @ingroup ds_SignatureValueType
 */
#define DS_SIGNATUREVALUETYPE_LOCAL "SignatureValueType"

/**
 * QName of the ds_SignatureValueType complex type
 * @ingroup ds_SignatureValueType
 */
extern xsd_QName ds_SignatureValueType_qname;
/**
 * Type information for serializing and deserializing ds_SignatureValueType elements
 * @ingroup ds_SignatureValueType
 */
extern struct globus_xsd_type_info_s ds_SignatureValueType_info;
/**
 * Type information for serializing and deserializing arrays of ds_SignatureValueType
 * elements
 * @ingroup ds_SignatureValueType
 */
extern struct globus_xsd_type_info_s ds_SignatureValueType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_SignatureValueType without surrounding elements
 * @ingroup ds_SignatureValueType
 */
extern struct globus_xsd_type_info_s ds_SignatureValueType_contents_info;


#include "xsd_base64Binary.h"
#include "xsd_ID.h"
#include "ds_SignatureValueType_array.h"

/**
 * @defgroup ds_SignatureValueType Complex type: ds_SignatureValueType
 * @ingroup types
 */

/**
 * C structure for the ds_SignatureValueType complex type
 * @ingroup ds_SignatureValueType
 */
struct ds_SignatureValueType_s
{
    /** xsd_base64Binary subelement */
    xsd_base64Binary base_value;
    xsd_ID_o _Id;

};

/**
 * Initialize a ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 *
 * Allocates a new ds_SignatureValueType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_SignatureValueType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_SignatureValueType_init(
    ds_SignatureValueType ** inst);

/**
 * Destroy a ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 *
 * Frees a ds_SignatureValueType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_SignatureValueType_destroy(
    ds_SignatureValueType * inst);

/**
 * Copy a ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 *
 * Perform a deep copy of a ds_SignatureValueType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_SignatureValueType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_SignatureValueType to be copied.
 */
globus_result_t
ds_SignatureValueType_copy(
    ds_SignatureValueType ** dest,
    const ds_SignatureValueType * src);

/**
 * Initialize the contents of a ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 *
 * Initialize the contents of a ds_SignatureValueType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_SignatureValueType_init(). The contents may be freed
 * by calling ds_SignatureValueType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_SignatureValueType.
 */
globus_result_t
ds_SignatureValueType_init_contents(
    ds_SignatureValueType * instance);

/**
 * Destroy the contents of a ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 *
 * Destroy the subelements and attributes of the given ds_SignatureValueType. 
 *
 * @param inst
 *     Pointer to a ds_SignatureValueType instance to destroy.
 */
void
ds_SignatureValueType_destroy_contents(
    ds_SignatureValueType * inst);

/**
 * Copy the contents of a ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 *
 * Perform a deep copy of the contents of a ds_SignatureValueType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_SignatureValueType to be copied.
 */
globus_result_t
ds_SignatureValueType_copy_contents(
    ds_SignatureValueType * dest,
    const ds_SignatureValueType * src);

/**
 * Serialize a ds_SignatureValueType
 * @ingroup ds_SignatureValueType_array
 * Serialize a ds_SignatureValueType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_SignatureValueType.
 * @param val
 *     The ds_SignatureValueType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignatureValueType_serialize(
    xsd_QName *                         element_name,
    ds_SignatureValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_SignatureValueType
 * @ingroup ds_SignatureValueType_array
 * Serialize a ds_SignatureValueType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_SignatureValueType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignatureValueType_serialize_contents(
    xsd_QName *                         element_name,
    ds_SignatureValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 * Deserialize an element containing a ds_SignatureValueType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignatureValueType.
 * @param val
 *     Pointer to the ds_SignatureValueType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureValueType_deserialize(
    xsd_QName *                         element_name,
    ds_SignatureValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 * Deserialize a ds_SignatureValueType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_SignatureValueType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureValueType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_SignatureValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_SignatureValueType
 * @ingroup ds_SignatureValueType
 * Deserialize the next element if it contains a ds_SignatureValueType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignatureValueType.
 * @param instance
 *     Pointer to the <code>ds_SignatureValueType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureValueType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_SignatureValueType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_SignatureValueType_init_wrapper(
    void **                             object);
    
void
ds_SignatureValueType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_SignatureValueType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignatureValueType_init_contents_wrapper(
    void *                              object);
    
void
ds_SignatureValueType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_SignatureValueType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignatureValueType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignatureValueType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignatureValueType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignatureValueType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
