/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_TRANSFORMSTYPE_H_
#define _DS_TRANSFORMSTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_TransformsType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}TransformsType element.
 * @ingroup ds_TransformsType
 */
typedef struct ds_TransformsType_s ds_TransformsType;
/**
 * The ds_TransformsType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}TransformsType element.
 * @ingroup ds_TransformsType
 */
typedef ds_TransformsType * ds_TransformsType_o;

/**
 * Namespace of the ds_TransformsType complex type
 * @ingroup ds_TransformsType
 */
#define DS_TRANSFORMSTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_TransformsType complex type
 * @ingroup ds_TransformsType
 */
#define DS_TRANSFORMSTYPE_LOCAL "TransformsType"

/**
 * QName of the ds_TransformsType complex type
 * @ingroup ds_TransformsType
 */
extern xsd_QName ds_TransformsType_qname;
/**
 * Type information for serializing and deserializing ds_TransformsType elements
 * @ingroup ds_TransformsType
 */
extern struct globus_xsd_type_info_s ds_TransformsType_info;
/**
 * Type information for serializing and deserializing arrays of ds_TransformsType
 * elements
 * @ingroup ds_TransformsType
 */
extern struct globus_xsd_type_info_s ds_TransformsType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_TransformsType without surrounding elements
 * @ingroup ds_TransformsType
 */
extern struct globus_xsd_type_info_s ds_TransformsType_contents_info;


#include "ds_TransformType_array.h"
#include "ds_TransformsType_array.h"

/**
 * @defgroup ds_TransformsType Complex type: ds_TransformsType
 * @ingroup types
 */

/**
 * C structure for the ds_TransformsType complex type
 * @ingroup ds_TransformsType
 */
struct ds_TransformsType_s
{
   /** Array of [1 .. Infinity] ds_TransformType elements */
    ds_TransformType_array Transform;

};

/**
 * Initialize a ds_TransformsType
 * @ingroup ds_TransformsType
 *
 * Allocates a new ds_TransformsType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_TransformsType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_TransformsType_init(
    ds_TransformsType ** inst);

/**
 * Destroy a ds_TransformsType
 * @ingroup ds_TransformsType
 *
 * Frees a ds_TransformsType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_TransformsType_destroy(
    ds_TransformsType * inst);

/**
 * Copy a ds_TransformsType
 * @ingroup ds_TransformsType
 *
 * Perform a deep copy of a ds_TransformsType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_TransformsType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_TransformsType to be copied.
 */
globus_result_t
ds_TransformsType_copy(
    ds_TransformsType ** dest,
    const ds_TransformsType * src);

/**
 * Initialize the contents of a ds_TransformsType
 * @ingroup ds_TransformsType
 *
 * Initialize the contents of a ds_TransformsType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_TransformsType_init(). The contents may be freed
 * by calling ds_TransformsType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_TransformsType.
 */
globus_result_t
ds_TransformsType_init_contents(
    ds_TransformsType * instance);

/**
 * Destroy the contents of a ds_TransformsType
 * @ingroup ds_TransformsType
 *
 * Destroy the subelements and attributes of the given ds_TransformsType. 
 *
 * @param inst
 *     Pointer to a ds_TransformsType instance to destroy.
 */
void
ds_TransformsType_destroy_contents(
    ds_TransformsType * inst);

/**
 * Copy the contents of a ds_TransformsType
 * @ingroup ds_TransformsType
 *
 * Perform a deep copy of the contents of a ds_TransformsType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_TransformsType to be copied.
 */
globus_result_t
ds_TransformsType_copy_contents(
    ds_TransformsType * dest,
    const ds_TransformsType * src);

/**
 * Serialize a ds_TransformsType
 * @ingroup ds_TransformsType_array
 * Serialize a ds_TransformsType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_TransformsType.
 * @param val
 *     The ds_TransformsType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_TransformsType_serialize(
    xsd_QName *                         element_name,
    ds_TransformsType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_TransformsType
 * @ingroup ds_TransformsType_array
 * Serialize a ds_TransformsType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_TransformsType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_TransformsType_serialize_contents(
    xsd_QName *                         element_name,
    ds_TransformsType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_TransformsType
 * @ingroup ds_TransformsType
 * Deserialize an element containing a ds_TransformsType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_TransformsType.
 * @param val
 *     Pointer to the ds_TransformsType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_TransformsType_deserialize(
    xsd_QName *                         element_name,
    ds_TransformsType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_TransformsType
 * @ingroup ds_TransformsType
 * Deserialize a ds_TransformsType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_TransformsType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_TransformsType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_TransformsType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_TransformsType
 * @ingroup ds_TransformsType
 * Deserialize the next element if it contains a ds_TransformsType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_TransformsType.
 * @param instance
 *     Pointer to the <code>ds_TransformsType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_TransformsType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_TransformsType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_TransformsType_init_wrapper(
    void **                             object);
    
void
ds_TransformsType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_TransformsType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_TransformsType_init_contents_wrapper(
    void *                              object);
    
void
ds_TransformsType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_TransformsType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_TransformsType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformsType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformsType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformsType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
