/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_X509ISSUERSERIALTYPE_H_
#define _DS_X509ISSUERSERIALTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_X509IssuerSerialType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}X509IssuerSerialType element.
 * @ingroup ds_X509IssuerSerialType
 */
typedef struct ds_X509IssuerSerialType_s ds_X509IssuerSerialType;
/**
 * The ds_X509IssuerSerialType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}X509IssuerSerialType element.
 * @ingroup ds_X509IssuerSerialType
 */
typedef ds_X509IssuerSerialType * ds_X509IssuerSerialType_o;

/**
 * Namespace of the ds_X509IssuerSerialType complex type
 * @ingroup ds_X509IssuerSerialType
 */
#define DS_X509ISSUERSERIALTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_X509IssuerSerialType complex type
 * @ingroup ds_X509IssuerSerialType
 */
#define DS_X509ISSUERSERIALTYPE_LOCAL "X509IssuerSerialType"

/**
 * QName of the ds_X509IssuerSerialType complex type
 * @ingroup ds_X509IssuerSerialType
 */
extern xsd_QName ds_X509IssuerSerialType_qname;
/**
 * Type information for serializing and deserializing ds_X509IssuerSerialType elements
 * @ingroup ds_X509IssuerSerialType
 */
extern struct globus_xsd_type_info_s ds_X509IssuerSerialType_info;
/**
 * Type information for serializing and deserializing arrays of ds_X509IssuerSerialType
 * elements
 * @ingroup ds_X509IssuerSerialType
 */
extern struct globus_xsd_type_info_s ds_X509IssuerSerialType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_X509IssuerSerialType without surrounding elements
 * @ingroup ds_X509IssuerSerialType
 */
extern struct globus_xsd_type_info_s ds_X509IssuerSerialType_contents_info;


#include "xsd_string.h"
#include "xsd_integer.h"
#include "ds_X509IssuerSerialType_array.h"

/**
 * @defgroup ds_X509IssuerSerialType Complex type: ds_X509IssuerSerialType
 * @ingroup types
 */

/**
 * C structure for the ds_X509IssuerSerialType complex type
 * @ingroup ds_X509IssuerSerialType
 */
struct ds_X509IssuerSerialType_s
{
    /** xsd_string subelement */
    xsd_string X509IssuerName;
    /** xsd_integer subelement */
    xsd_integer X509SerialNumber;

};

/**
 * Initialize a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 *
 * Allocates a new ds_X509IssuerSerialType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_X509IssuerSerialType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_X509IssuerSerialType_init(
    ds_X509IssuerSerialType ** inst);

/**
 * Destroy a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 *
 * Frees a ds_X509IssuerSerialType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_X509IssuerSerialType_destroy(
    ds_X509IssuerSerialType * inst);

/**
 * Copy a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 *
 * Perform a deep copy of a ds_X509IssuerSerialType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_X509IssuerSerialType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_X509IssuerSerialType to be copied.
 */
globus_result_t
ds_X509IssuerSerialType_copy(
    ds_X509IssuerSerialType ** dest,
    const ds_X509IssuerSerialType * src);

/**
 * Initialize the contents of a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 *
 * Initialize the contents of a ds_X509IssuerSerialType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_X509IssuerSerialType_init(). The contents may be freed
 * by calling ds_X509IssuerSerialType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_X509IssuerSerialType.
 */
globus_result_t
ds_X509IssuerSerialType_init_contents(
    ds_X509IssuerSerialType * instance);

/**
 * Destroy the contents of a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 *
 * Destroy the subelements and attributes of the given ds_X509IssuerSerialType. 
 *
 * @param inst
 *     Pointer to a ds_X509IssuerSerialType instance to destroy.
 */
void
ds_X509IssuerSerialType_destroy_contents(
    ds_X509IssuerSerialType * inst);

/**
 * Copy the contents of a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 *
 * Perform a deep copy of the contents of a ds_X509IssuerSerialType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_X509IssuerSerialType to be copied.
 */
globus_result_t
ds_X509IssuerSerialType_copy_contents(
    ds_X509IssuerSerialType * dest,
    const ds_X509IssuerSerialType * src);

/**
 * Serialize a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType_array
 * Serialize a ds_X509IssuerSerialType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_X509IssuerSerialType.
 * @param val
 *     The ds_X509IssuerSerialType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_X509IssuerSerialType_serialize(
    xsd_QName *                         element_name,
    ds_X509IssuerSerialType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType_array
 * Serialize a ds_X509IssuerSerialType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_X509IssuerSerialType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_X509IssuerSerialType_serialize_contents(
    xsd_QName *                         element_name,
    ds_X509IssuerSerialType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 * Deserialize an element containing a ds_X509IssuerSerialType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_X509IssuerSerialType.
 * @param val
 *     Pointer to the ds_X509IssuerSerialType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_X509IssuerSerialType_deserialize(
    xsd_QName *                         element_name,
    ds_X509IssuerSerialType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 * Deserialize a ds_X509IssuerSerialType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_X509IssuerSerialType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_X509IssuerSerialType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_X509IssuerSerialType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_X509IssuerSerialType
 * @ingroup ds_X509IssuerSerialType
 * Deserialize the next element if it contains a ds_X509IssuerSerialType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_X509IssuerSerialType.
 * @param instance
 *     Pointer to the <code>ds_X509IssuerSerialType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_X509IssuerSerialType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_X509IssuerSerialType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_X509IssuerSerialType_init_wrapper(
    void **                             object);
    
void
ds_X509IssuerSerialType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_X509IssuerSerialType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_X509IssuerSerialType_init_contents_wrapper(
    void *                              object);
    
void
ds_X509IssuerSerialType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_X509IssuerSerialType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_X509IssuerSerialType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_X509IssuerSerialType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_X509IssuerSerialType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_X509IssuerSerialType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
