/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_X509ISSUERSERIALTYPE_ARRAY_H_
#define _DS_X509ISSUERSERIALTYPE_ARRAY_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

/* This is documented in the ds_X509IssuerSerialType header. */

extern xsd_QName ds_X509IssuerSerialType_qname;

#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * Array of ds_X509IssuerSerialType elements
 * @ingroup ds_X509IssuerSerialType
 *
 * This structure type is used represent an array of
 * ds_X509IssuerSerialType elements.
 *
 * Arrays are allocated by ds_X509IssuerSerialType_array_init() and freed by calling
 * ds_X509IssuerSerialType_array_destroy(). Elements may be added to an array by calling
 * ds_X509IssuerSerialType_array_push().
 */
typedef struct ds_X509IssuerSerialType_array_s
{
    /** Dynamic array of elements */
    struct ds_X509IssuerSerialType_s * elements;
    /** Number of elements in this array */
    int length;
} ds_X509IssuerSerialType_array;

/**
 * Initialize an array of ds_X509IssuerSerialType elements.
 * @ingroup ds_X509IssuerSerialType
 *
 * Allocates a new array of 0 elements. When this array is no longer used,
 * it should be freed by calling 
 * ds_X509IssuerSerialType_array_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated array instance.
 */
globus_result_t
ds_X509IssuerSerialType_array_init(
    ds_X509IssuerSerialType_array ** inst);

/**
 * Destroy an array of ds_X509IssuerSerialType elements.
 * @ingroup ds_X509IssuerSerialType
 *
 * Frees an array of ds_X509IssuerSerialType elements. The contents of each element
 * element in the array be destroyed by calling
 * ds_X509IssuerSerialType_destroy_contents().
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
ds_X509IssuerSerialType_array_destroy(
    ds_X509IssuerSerialType_array * inst);

/**
 * Copy an array of ds_X509IssuerSerialType elements
 * @ingroup ds_X509IssuerSerialType
 *
 * Perform a deep copy of an array of ds_X509IssuerSerialType elements.
 * The @a dest array will be allocated, and then a copy of the contents
 * of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
ds_X509IssuerSerialType_array_copy(
    ds_X509IssuerSerialType_array ** dest,
    const ds_X509IssuerSerialType_array * src);

/**
 * Initialize the contents of an array of ds_X509IssuerSerialType elements
 * @ingroup ds_X509IssuerSerialType
 *
 * Initialize the contents of an array of ds_X509IssuerSerialType elements. Used
 * when the array is allocated on the stack or by a some allocator besides
 * ds_X509IssuerSerialType_array_init(). The contents of the array may be freed
 * by calling ds_X509IssuerSerialType_array_destroy_contents().
 *
 * @param inst
 *     Pointer to an allocated but uninitialized array.
 */
globus_result_t
ds_X509IssuerSerialType_array_init_contents(
    ds_X509IssuerSerialType_array * inst);

/**
 * Destroy the contents of an array of ds_X509IssuerSerialType elements
 * @ingroup ds_X509IssuerSerialType
 *
 * Destroy the elements in an array of ds_X509IssuerSerialType elements. The contents of
 * each element in the array be destroyed by calling
 * ds_X509IssuerSerialType_destroy_contents() and the array will be reset to be empty.
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
ds_X509IssuerSerialType_array_destroy_contents(
    ds_X509IssuerSerialType_array * inst);

/**
 * Copy the contents of an array of ds_X509IssuerSerialType elements
 * @ingroup ds_X509IssuerSerialType
 *
 * Perform a deep copy of an array of ds_X509IssuerSerialType elements.
 * The @a dest array must be allocated before making this call.
 * A copy of the contents of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
ds_X509IssuerSerialType_array_copy_contents(
    ds_X509IssuerSerialType_array * dest,
    const ds_X509IssuerSerialType_array * src);

/**
 * Append a new ds_X509IssuerSerialType to an array
 * @ingroup ds_X509IssuerSerialType
 *
 * Allocate and initialize a new ds_X509IssuerSerialType structure, adding it
 * to the end of the given @a array.
 * 
 * @param array
 *     Array to be appended to.
 *
 * @return This function returns the newly allocated element.
 */
struct ds_X509IssuerSerialType_s *
ds_X509IssuerSerialType_array_push(
    ds_X509IssuerSerialType_array * array);

/**
 * Serialize an array of ds_X509IssuerSerialType elements
 * @ingroup ds_X509IssuerSerialType
 * Serialize an element containing an array of ds_X509IssuerSerialType elements.
 *
 * @param element
 *     The name of the element which will contain the array.
 * @param array_instance
 *     The array to serialize
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_X509IssuerSerialType_array_serialize(
    xsd_QName *                         element,
    ds_X509IssuerSerialType_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an array of ds_X509IssuerSerialType elements
 * @ingroup ds_X509IssuerSerialType
 * Deserialize an element containing an array of ds_X509IssuerSerialType elements.
 *
 * @param element
 *     The name of the element which should enclose the array.
 * @param array_instance
 *     The array to deserialize into
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_X509IssuerSerialType_array_deserialize(
    xsd_QName *                         element,
    ds_X509IssuerSerialType_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

    

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
void *
ds_X509IssuerSerialType_array_push_wrapper(
    void * array);

globus_result_t
ds_X509IssuerSerialType_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_X509IssuerSerialType_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_X509IssuerSerialType_array_init_wrapper(
    void **                             arr);
    
void
ds_X509IssuerSerialType_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
ds_X509IssuerSerialType_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
ds_X509IssuerSerialType_array_init_contents_wrapper(
    void *                              arr);
    
void
ds_X509IssuerSerialType_array_destroy_contents_wrapper(
    void *                              arr);
    
globus_result_t
ds_X509IssuerSerialType_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */
    
#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
