/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSA_RELATIONSHIP_H_
#define _WSA_RELATIONSHIP_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsa_Relationship complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/03/addressing}Relationship element.
 * @ingroup wsa_Relationship
 */
typedef struct wsa_Relationship_s wsa_Relationship;
/**
 * The wsa_Relationship_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/03/addressing}Relationship element.
 * @ingroup wsa_Relationship
 */
typedef wsa_Relationship * wsa_Relationship_o;

/**
 * Namespace of the wsa_Relationship complex type
 * @ingroup wsa_Relationship
 */
#define WSA_RELATIONSHIP_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"
/**
 * Local part of the QName of the wsa_Relationship complex type
 * @ingroup wsa_Relationship
 */
#define WSA_RELATIONSHIP_LOCAL "Relationship"

/**
 * QName of the wsa_Relationship complex type
 * @ingroup wsa_Relationship
 */
extern xsd_QName wsa_Relationship_qname;
/**
 * Type information for serializing and deserializing wsa_Relationship elements
 * @ingroup wsa_Relationship
 */
extern struct globus_xsd_type_info_s wsa_Relationship_info;
/**
 * Type information for serializing and deserializing arrays of wsa_Relationship
 * elements
 * @ingroup wsa_Relationship
 */
extern struct globus_xsd_type_info_s wsa_Relationship_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsa_Relationship without surrounding elements
 * @ingroup wsa_Relationship
 */
extern struct globus_xsd_type_info_s wsa_Relationship_contents_info;


#include "xsd_anyURI.h"
#include "xsd_anyAttributes.h"
#include "xsd_QName.h"
#include "wsa_Relationship_array.h"

/**
 * @defgroup wsa_Relationship Complex type: wsa_Relationship
 * @ingroup types
 */

/**
 * C structure for the wsa_Relationship complex type
 * @ingroup wsa_Relationship
 */
struct wsa_Relationship_s
{
    /** xsd_anyURI subelement */
    xsd_anyURI base_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_QName_o _RelationshipType;

};

/**
 * Initialize a wsa_Relationship
 * @ingroup wsa_Relationship
 *
 * Allocates a new wsa_Relationship and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsa_Relationship_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsa_Relationship_init(
    wsa_Relationship ** inst);

/**
 * Destroy a wsa_Relationship
 * @ingroup wsa_Relationship
 *
 * Frees a wsa_Relationship. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsa_Relationship_destroy(
    wsa_Relationship * inst);

/**
 * Copy a wsa_Relationship
 * @ingroup wsa_Relationship
 *
 * Perform a deep copy of a wsa_Relationship.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsa_Relationship structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsa_Relationship to be copied.
 */
globus_result_t
wsa_Relationship_copy(
    wsa_Relationship ** dest,
    const wsa_Relationship * src);

/**
 * Initialize the contents of a wsa_Relationship
 * @ingroup wsa_Relationship
 *
 * Initialize the contents of a wsa_Relationship. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsa_Relationship_init(). The contents may be freed
 * by calling wsa_Relationship_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsa_Relationship.
 */
globus_result_t
wsa_Relationship_init_contents(
    wsa_Relationship * instance);

/**
 * Destroy the contents of a wsa_Relationship
 * @ingroup wsa_Relationship
 *
 * Destroy the subelements and attributes of the given wsa_Relationship. 
 *
 * @param inst
 *     Pointer to a wsa_Relationship instance to destroy.
 */
void
wsa_Relationship_destroy_contents(
    wsa_Relationship * inst);

/**
 * Copy the contents of a wsa_Relationship
 * @ingroup wsa_Relationship
 *
 * Perform a deep copy of the contents of a wsa_Relationship.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsa_Relationship to be copied.
 */
globus_result_t
wsa_Relationship_copy_contents(
    wsa_Relationship * dest,
    const wsa_Relationship * src);

/**
 * Serialize a wsa_Relationship
 * @ingroup wsa_Relationship_array
 * Serialize a wsa_Relationship structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsa_Relationship.
 * @param val
 *     The wsa_Relationship to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_Relationship_serialize(
    xsd_QName *                         element_name,
    wsa_Relationship * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsa_Relationship
 * @ingroup wsa_Relationship_array
 * Serialize a wsa_Relationship structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsa_Relationship to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_Relationship_serialize_contents(
    xsd_QName *                         element_name,
    wsa_Relationship * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_Relationship
 * @ingroup wsa_Relationship
 * Deserialize an element containing a wsa_Relationship element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_Relationship.
 * @param val
 *     Pointer to the wsa_Relationship which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_Relationship_deserialize(
    xsd_QName *                         element_name,
    wsa_Relationship * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_Relationship
 * @ingroup wsa_Relationship
 * Deserialize a wsa_Relationship whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsa_Relationship which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_Relationship_deserialize_contents(
    xsd_QName *                         element_name,
    wsa_Relationship * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsa_Relationship
 * @ingroup wsa_Relationship
 * Deserialize the next element if it contains a wsa_Relationship.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_Relationship.
 * @param instance
 *     Pointer to the <code>wsa_Relationship *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_Relationship_deserialize_pointer(
    xsd_QName *                         element_name,
    wsa_Relationship ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsa_Relationship_init_wrapper(
    void **                             object);
    
void
wsa_Relationship_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsa_Relationship_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsa_Relationship_init_contents_wrapper(
    void *                              object);
    
void
wsa_Relationship_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsa_Relationship_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsa_Relationship_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_Relationship_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_Relationship_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsa_Relationship_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
