/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSA_SERVICENAMETYPE_H_
#define _WSA_SERVICENAMETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsa_ServiceNameType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/03/addressing}ServiceNameType element.
 * @ingroup wsa_ServiceNameType
 */
typedef struct wsa_ServiceNameType_s wsa_ServiceNameType;
/**
 * The wsa_ServiceNameType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/03/addressing}ServiceNameType element.
 * @ingroup wsa_ServiceNameType
 */
typedef wsa_ServiceNameType * wsa_ServiceNameType_o;

/**
 * Namespace of the wsa_ServiceNameType complex type
 * @ingroup wsa_ServiceNameType
 */
#define WSA_SERVICENAMETYPE_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"
/**
 * Local part of the QName of the wsa_ServiceNameType complex type
 * @ingroup wsa_ServiceNameType
 */
#define WSA_SERVICENAMETYPE_LOCAL "ServiceNameType"

/**
 * QName of the wsa_ServiceNameType complex type
 * @ingroup wsa_ServiceNameType
 */
extern xsd_QName wsa_ServiceNameType_qname;
/**
 * Type information for serializing and deserializing wsa_ServiceNameType elements
 * @ingroup wsa_ServiceNameType
 */
extern struct globus_xsd_type_info_s wsa_ServiceNameType_info;
/**
 * Type information for serializing and deserializing arrays of wsa_ServiceNameType
 * elements
 * @ingroup wsa_ServiceNameType
 */
extern struct globus_xsd_type_info_s wsa_ServiceNameType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsa_ServiceNameType without surrounding elements
 * @ingroup wsa_ServiceNameType
 */
extern struct globus_xsd_type_info_s wsa_ServiceNameType_contents_info;


#include "xsd_QName.h"
#include "xsd_anyAttributes.h"
#include "xsd_NCName.h"
#include "wsa_ServiceNameType_array.h"

/**
 * @defgroup wsa_ServiceNameType Complex type: wsa_ServiceNameType
 * @ingroup types
 */

/**
 * C structure for the wsa_ServiceNameType complex type
 * @ingroup wsa_ServiceNameType
 */
struct wsa_ServiceNameType_s
{
    /** xsd_QName subelement */
    xsd_QName base_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_NCName_o _PortName;

};

/**
 * Initialize a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 *
 * Allocates a new wsa_ServiceNameType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsa_ServiceNameType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsa_ServiceNameType_init(
    wsa_ServiceNameType ** inst);

/**
 * Destroy a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 *
 * Frees a wsa_ServiceNameType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsa_ServiceNameType_destroy(
    wsa_ServiceNameType * inst);

/**
 * Copy a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 *
 * Perform a deep copy of a wsa_ServiceNameType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsa_ServiceNameType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsa_ServiceNameType to be copied.
 */
globus_result_t
wsa_ServiceNameType_copy(
    wsa_ServiceNameType ** dest,
    const wsa_ServiceNameType * src);

/**
 * Initialize the contents of a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 *
 * Initialize the contents of a wsa_ServiceNameType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsa_ServiceNameType_init(). The contents may be freed
 * by calling wsa_ServiceNameType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsa_ServiceNameType.
 */
globus_result_t
wsa_ServiceNameType_init_contents(
    wsa_ServiceNameType * instance);

/**
 * Destroy the contents of a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 *
 * Destroy the subelements and attributes of the given wsa_ServiceNameType. 
 *
 * @param inst
 *     Pointer to a wsa_ServiceNameType instance to destroy.
 */
void
wsa_ServiceNameType_destroy_contents(
    wsa_ServiceNameType * inst);

/**
 * Copy the contents of a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 *
 * Perform a deep copy of the contents of a wsa_ServiceNameType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsa_ServiceNameType to be copied.
 */
globus_result_t
wsa_ServiceNameType_copy_contents(
    wsa_ServiceNameType * dest,
    const wsa_ServiceNameType * src);

/**
 * Serialize a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType_array
 * Serialize a wsa_ServiceNameType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsa_ServiceNameType.
 * @param val
 *     The wsa_ServiceNameType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_ServiceNameType_serialize(
    xsd_QName *                         element_name,
    wsa_ServiceNameType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType_array
 * Serialize a wsa_ServiceNameType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsa_ServiceNameType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_ServiceNameType_serialize_contents(
    xsd_QName *                         element_name,
    wsa_ServiceNameType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 * Deserialize an element containing a wsa_ServiceNameType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_ServiceNameType.
 * @param val
 *     Pointer to the wsa_ServiceNameType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_ServiceNameType_deserialize(
    xsd_QName *                         element_name,
    wsa_ServiceNameType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 * Deserialize a wsa_ServiceNameType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsa_ServiceNameType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_ServiceNameType_deserialize_contents(
    xsd_QName *                         element_name,
    wsa_ServiceNameType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsa_ServiceNameType
 * @ingroup wsa_ServiceNameType
 * Deserialize the next element if it contains a wsa_ServiceNameType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_ServiceNameType.
 * @param instance
 *     Pointer to the <code>wsa_ServiceNameType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_ServiceNameType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsa_ServiceNameType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsa_ServiceNameType_init_wrapper(
    void **                             object);
    
void
wsa_ServiceNameType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsa_ServiceNameType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsa_ServiceNameType_init_contents_wrapper(
    void *                              object);
    
void
wsa_ServiceNameType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsa_ServiceNameType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsa_ServiceNameType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_ServiceNameType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_ServiceNameType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsa_ServiceNameType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
