/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSBF_ERRORCODETYPE_H_
#define _WSBF_ERRORCODETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsbf_ErrorCodeType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd}complexType 2 element.
 * @ingroup wsbf_ErrorCodeType
 */
typedef struct wsbf_ErrorCodeType_s wsbf_ErrorCodeType;
/**
 * The wsbf_ErrorCodeType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd}complexType 2 element.
 * @ingroup wsbf_ErrorCodeType
 */
typedef wsbf_ErrorCodeType * wsbf_ErrorCodeType_o;

/**
 * Namespace of the wsbf_ErrorCodeType complex type
 * @ingroup wsbf_ErrorCodeType
 */
#define WSBF_ERRORCODETYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsbf_ErrorCodeType complex type
 * @ingroup wsbf_ErrorCodeType
 */
#define WSBF_ERRORCODETYPE_LOCAL "ErrorCodeType"

/**
 * QName of the wsbf_ErrorCodeType complex type
 * @ingroup wsbf_ErrorCodeType
 */
extern xsd_QName wsbf_ErrorCodeType_qname;
/**
 * Type information for serializing and deserializing wsbf_ErrorCodeType elements
 * @ingroup wsbf_ErrorCodeType
 */
extern struct globus_xsd_type_info_s wsbf_ErrorCodeType_info;
/**
 * Type information for serializing and deserializing arrays of wsbf_ErrorCodeType
 * elements
 * @ingroup wsbf_ErrorCodeType
 */
extern struct globus_xsd_type_info_s wsbf_ErrorCodeType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsbf_ErrorCodeType without surrounding elements
 * @ingroup wsbf_ErrorCodeType
 */
extern struct globus_xsd_type_info_s wsbf_ErrorCodeType_contents_info;


#include "xsd_anyType.h"
#include "xsd_anyURI.h"
#include "xsd_anyAttributes.h"
#include "wsbf_ErrorCodeType_array.h"

/**
 * @defgroup wsbf_ErrorCodeType Complex type: wsbf_ErrorCodeType
 * @ingroup types
 */

/**
 * C structure for the wsbf_ErrorCodeType complex type
 * @ingroup wsbf_ErrorCodeType
 */
struct wsbf_ErrorCodeType_s
{
    /** xsd_anyType subelement */
    xsd_anyType base_value;
    xsd_anyURI _dialect;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 *
 * Allocates a new wsbf_ErrorCodeType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsbf_ErrorCodeType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsbf_ErrorCodeType_init(
    wsbf_ErrorCodeType ** inst);

/**
 * Destroy a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 *
 * Frees a wsbf_ErrorCodeType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsbf_ErrorCodeType_destroy(
    wsbf_ErrorCodeType * inst);

/**
 * Copy a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 *
 * Perform a deep copy of a wsbf_ErrorCodeType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsbf_ErrorCodeType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsbf_ErrorCodeType to be copied.
 */
globus_result_t
wsbf_ErrorCodeType_copy(
    wsbf_ErrorCodeType ** dest,
    const wsbf_ErrorCodeType * src);

/**
 * Initialize the contents of a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 *
 * Initialize the contents of a wsbf_ErrorCodeType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsbf_ErrorCodeType_init(). The contents may be freed
 * by calling wsbf_ErrorCodeType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsbf_ErrorCodeType.
 */
globus_result_t
wsbf_ErrorCodeType_init_contents(
    wsbf_ErrorCodeType * instance);

/**
 * Destroy the contents of a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 *
 * Destroy the subelements and attributes of the given wsbf_ErrorCodeType. 
 *
 * @param inst
 *     Pointer to a wsbf_ErrorCodeType instance to destroy.
 */
void
wsbf_ErrorCodeType_destroy_contents(
    wsbf_ErrorCodeType * inst);

/**
 * Copy the contents of a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 *
 * Perform a deep copy of the contents of a wsbf_ErrorCodeType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsbf_ErrorCodeType to be copied.
 */
globus_result_t
wsbf_ErrorCodeType_copy_contents(
    wsbf_ErrorCodeType * dest,
    const wsbf_ErrorCodeType * src);

/**
 * Serialize a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType_array
 * Serialize a wsbf_ErrorCodeType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsbf_ErrorCodeType.
 * @param val
 *     The wsbf_ErrorCodeType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsbf_ErrorCodeType_serialize(
    xsd_QName *                         element_name,
    wsbf_ErrorCodeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType_array
 * Serialize a wsbf_ErrorCodeType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsbf_ErrorCodeType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsbf_ErrorCodeType_serialize_contents(
    xsd_QName *                         element_name,
    wsbf_ErrorCodeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 * Deserialize an element containing a wsbf_ErrorCodeType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsbf_ErrorCodeType.
 * @param val
 *     Pointer to the wsbf_ErrorCodeType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_ErrorCodeType_deserialize(
    xsd_QName *                         element_name,
    wsbf_ErrorCodeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 * Deserialize a wsbf_ErrorCodeType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsbf_ErrorCodeType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_ErrorCodeType_deserialize_contents(
    xsd_QName *                         element_name,
    wsbf_ErrorCodeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsbf_ErrorCodeType
 * @ingroup wsbf_ErrorCodeType
 * Deserialize the next element if it contains a wsbf_ErrorCodeType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsbf_ErrorCodeType.
 * @param instance
 *     Pointer to the <code>wsbf_ErrorCodeType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_ErrorCodeType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsbf_ErrorCodeType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsbf_ErrorCodeType_init_wrapper(
    void **                             object);
    
void
wsbf_ErrorCodeType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsbf_ErrorCodeType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsbf_ErrorCodeType_init_contents_wrapper(
    void *                              object);
    
void
wsbf_ErrorCodeType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsbf_ErrorCodeType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsbf_ErrorCodeType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsbf_ErrorCodeType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsbf_ErrorCodeType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsbf_ErrorCodeType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
