/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSC_DERIVEDKEYTOKENTYPE_H_
#define _WSC_DERIVEDKEYTOKENTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsc_DerivedKeyTokenType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/sc}DerivedKeyTokenType element.
 * @ingroup wsc_DerivedKeyTokenType
 */
typedef struct wsc_DerivedKeyTokenType_s wsc_DerivedKeyTokenType;
/**
 * The wsc_DerivedKeyTokenType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/sc}DerivedKeyTokenType element.
 * @ingroup wsc_DerivedKeyTokenType
 */
typedef wsc_DerivedKeyTokenType * wsc_DerivedKeyTokenType_o;

/**
 * Namespace of the wsc_DerivedKeyTokenType complex type
 * @ingroup wsc_DerivedKeyTokenType
 */
#define WSC_DERIVEDKEYTOKENTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/sc"
/**
 * Local part of the QName of the wsc_DerivedKeyTokenType complex type
 * @ingroup wsc_DerivedKeyTokenType
 */
#define WSC_DERIVEDKEYTOKENTYPE_LOCAL "DerivedKeyTokenType"

/**
 * QName of the wsc_DerivedKeyTokenType complex type
 * @ingroup wsc_DerivedKeyTokenType
 */
extern xsd_QName wsc_DerivedKeyTokenType_qname;
/**
 * Type information for serializing and deserializing wsc_DerivedKeyTokenType elements
 * @ingroup wsc_DerivedKeyTokenType
 */
extern struct globus_xsd_type_info_s wsc_DerivedKeyTokenType_info;
/**
 * Type information for serializing and deserializing arrays of wsc_DerivedKeyTokenType
 * elements
 * @ingroup wsc_DerivedKeyTokenType
 */
extern struct globus_xsd_type_info_s wsc_DerivedKeyTokenType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsc_DerivedKeyTokenType without surrounding elements
 * @ingroup wsc_DerivedKeyTokenType
 */
extern struct globus_xsd_type_info_s wsc_DerivedKeyTokenType_contents_info;


#include "wsse_SecurityTokenReferenceType.h"
#include "wsc_PropertiesType.h"
#include "wsc_DerivedKeyTokenType_choice.h"
#include "xsd_unsignedLong.h"
#include "xsd_string.h"
#include "xsd_base64Binary.h"
#include "xsd_anyURI.h"
#include "xsd_ID.h"
#include "wsc_DerivedKeyTokenType_array.h"

/**
 * @defgroup wsc_DerivedKeyTokenType Complex type: wsc_DerivedKeyTokenType
 * @ingroup types
 */

/**
 * C structure for the wsc_DerivedKeyTokenType complex type
 * @ingroup wsc_DerivedKeyTokenType
 */
struct wsc_DerivedKeyTokenType_s
{
   /** Optional wsse_SecurityTokenReferenceType subelement */
    wsse_SecurityTokenReferenceType_o SecurityTokenReference;
   /** Optional wsc_PropertiesType subelement */
    wsc_PropertiesType_o Properties;
    /** wsc_DerivedKeyTokenType_choice subelement */
    wsc_DerivedKeyTokenType_choice choice_value;
   /** Optional xsd_unsignedLong subelement */
    xsd_unsignedLong_o Length;
   /** Optional xsd_string subelement */
    xsd_string_o Label;
   /** Optional xsd_base64Binary subelement */
    xsd_base64Binary_o Nonce;
    xsd_anyURI_o _Algorithm;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 *
 * Allocates a new wsc_DerivedKeyTokenType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsc_DerivedKeyTokenType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsc_DerivedKeyTokenType_init(
    wsc_DerivedKeyTokenType ** inst);

/**
 * Destroy a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 *
 * Frees a wsc_DerivedKeyTokenType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsc_DerivedKeyTokenType_destroy(
    wsc_DerivedKeyTokenType * inst);

/**
 * Copy a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 *
 * Perform a deep copy of a wsc_DerivedKeyTokenType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsc_DerivedKeyTokenType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsc_DerivedKeyTokenType to be copied.
 */
globus_result_t
wsc_DerivedKeyTokenType_copy(
    wsc_DerivedKeyTokenType ** dest,
    const wsc_DerivedKeyTokenType * src);

/**
 * Initialize the contents of a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 *
 * Initialize the contents of a wsc_DerivedKeyTokenType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsc_DerivedKeyTokenType_init(). The contents may be freed
 * by calling wsc_DerivedKeyTokenType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsc_DerivedKeyTokenType.
 */
globus_result_t
wsc_DerivedKeyTokenType_init_contents(
    wsc_DerivedKeyTokenType * instance);

/**
 * Destroy the contents of a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 *
 * Destroy the subelements and attributes of the given wsc_DerivedKeyTokenType. 
 *
 * @param inst
 *     Pointer to a wsc_DerivedKeyTokenType instance to destroy.
 */
void
wsc_DerivedKeyTokenType_destroy_contents(
    wsc_DerivedKeyTokenType * inst);

/**
 * Copy the contents of a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 *
 * Perform a deep copy of the contents of a wsc_DerivedKeyTokenType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsc_DerivedKeyTokenType to be copied.
 */
globus_result_t
wsc_DerivedKeyTokenType_copy_contents(
    wsc_DerivedKeyTokenType * dest,
    const wsc_DerivedKeyTokenType * src);

/**
 * Serialize a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType_array
 * Serialize a wsc_DerivedKeyTokenType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsc_DerivedKeyTokenType.
 * @param val
 *     The wsc_DerivedKeyTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsc_DerivedKeyTokenType_serialize(
    xsd_QName *                         element_name,
    wsc_DerivedKeyTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType_array
 * Serialize a wsc_DerivedKeyTokenType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsc_DerivedKeyTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsc_DerivedKeyTokenType_serialize_contents(
    xsd_QName *                         element_name,
    wsc_DerivedKeyTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 * Deserialize an element containing a wsc_DerivedKeyTokenType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsc_DerivedKeyTokenType.
 * @param val
 *     Pointer to the wsc_DerivedKeyTokenType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsc_DerivedKeyTokenType_deserialize(
    xsd_QName *                         element_name,
    wsc_DerivedKeyTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 * Deserialize a wsc_DerivedKeyTokenType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsc_DerivedKeyTokenType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsc_DerivedKeyTokenType_deserialize_contents(
    xsd_QName *                         element_name,
    wsc_DerivedKeyTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsc_DerivedKeyTokenType
 * @ingroup wsc_DerivedKeyTokenType
 * Deserialize the next element if it contains a wsc_DerivedKeyTokenType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsc_DerivedKeyTokenType.
 * @param instance
 *     Pointer to the <code>wsc_DerivedKeyTokenType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsc_DerivedKeyTokenType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsc_DerivedKeyTokenType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsc_DerivedKeyTokenType_init_wrapper(
    void **                             object);
    
void
wsc_DerivedKeyTokenType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsc_DerivedKeyTokenType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsc_DerivedKeyTokenType_init_contents_wrapper(
    void *                              object);
    
void
wsc_DerivedKeyTokenType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsc_DerivedKeyTokenType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsc_DerivedKeyTokenType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsc_DerivedKeyTokenType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsc_DerivedKeyTokenType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsc_DerivedKeyTokenType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
