/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSC_SECURITYCONTEXTTOKENTYPE_H_
#define _WSC_SECURITYCONTEXTTOKENTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsc_SecurityContextTokenType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/sc}SecurityContextTokenType element.
 * @ingroup wsc_SecurityContextTokenType
 */
typedef struct wsc_SecurityContextTokenType_s wsc_SecurityContextTokenType;
/**
 * The wsc_SecurityContextTokenType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/sc}SecurityContextTokenType element.
 * @ingroup wsc_SecurityContextTokenType
 */
typedef wsc_SecurityContextTokenType * wsc_SecurityContextTokenType_o;

/**
 * Namespace of the wsc_SecurityContextTokenType complex type
 * @ingroup wsc_SecurityContextTokenType
 */
#define WSC_SECURITYCONTEXTTOKENTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/sc"
/**
 * Local part of the QName of the wsc_SecurityContextTokenType complex type
 * @ingroup wsc_SecurityContextTokenType
 */
#define WSC_SECURITYCONTEXTTOKENTYPE_LOCAL "SecurityContextTokenType"

/**
 * QName of the wsc_SecurityContextTokenType complex type
 * @ingroup wsc_SecurityContextTokenType
 */
extern xsd_QName wsc_SecurityContextTokenType_qname;
/**
 * Type information for serializing and deserializing wsc_SecurityContextTokenType elements
 * @ingroup wsc_SecurityContextTokenType
 */
extern struct globus_xsd_type_info_s wsc_SecurityContextTokenType_info;
/**
 * Type information for serializing and deserializing arrays of wsc_SecurityContextTokenType
 * elements
 * @ingroup wsc_SecurityContextTokenType
 */
extern struct globus_xsd_type_info_s wsc_SecurityContextTokenType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsc_SecurityContextTokenType without surrounding elements
 * @ingroup wsc_SecurityContextTokenType
 */
extern struct globus_xsd_type_info_s wsc_SecurityContextTokenType_contents_info;


#include "xsd_anyURI.h"
#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "wsc_SecurityContextTokenType_array.h"

/**
 * @defgroup wsc_SecurityContextTokenType Complex type: wsc_SecurityContextTokenType
 * @ingroup types
 */

/**
 * C structure for the wsc_SecurityContextTokenType complex type
 * @ingroup wsc_SecurityContextTokenType
 */
struct wsc_SecurityContextTokenType_s
{
    /** xsd_anyURI subelement */
    xsd_anyURI Identifier;
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 *
 * Allocates a new wsc_SecurityContextTokenType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsc_SecurityContextTokenType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsc_SecurityContextTokenType_init(
    wsc_SecurityContextTokenType ** inst);

/**
 * Destroy a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 *
 * Frees a wsc_SecurityContextTokenType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsc_SecurityContextTokenType_destroy(
    wsc_SecurityContextTokenType * inst);

/**
 * Copy a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 *
 * Perform a deep copy of a wsc_SecurityContextTokenType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsc_SecurityContextTokenType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsc_SecurityContextTokenType to be copied.
 */
globus_result_t
wsc_SecurityContextTokenType_copy(
    wsc_SecurityContextTokenType ** dest,
    const wsc_SecurityContextTokenType * src);

/**
 * Initialize the contents of a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 *
 * Initialize the contents of a wsc_SecurityContextTokenType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsc_SecurityContextTokenType_init(). The contents may be freed
 * by calling wsc_SecurityContextTokenType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsc_SecurityContextTokenType.
 */
globus_result_t
wsc_SecurityContextTokenType_init_contents(
    wsc_SecurityContextTokenType * instance);

/**
 * Destroy the contents of a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 *
 * Destroy the subelements and attributes of the given wsc_SecurityContextTokenType. 
 *
 * @param inst
 *     Pointer to a wsc_SecurityContextTokenType instance to destroy.
 */
void
wsc_SecurityContextTokenType_destroy_contents(
    wsc_SecurityContextTokenType * inst);

/**
 * Copy the contents of a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 *
 * Perform a deep copy of the contents of a wsc_SecurityContextTokenType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsc_SecurityContextTokenType to be copied.
 */
globus_result_t
wsc_SecurityContextTokenType_copy_contents(
    wsc_SecurityContextTokenType * dest,
    const wsc_SecurityContextTokenType * src);

/**
 * Serialize a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType_array
 * Serialize a wsc_SecurityContextTokenType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsc_SecurityContextTokenType.
 * @param val
 *     The wsc_SecurityContextTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsc_SecurityContextTokenType_serialize(
    xsd_QName *                         element_name,
    wsc_SecurityContextTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType_array
 * Serialize a wsc_SecurityContextTokenType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsc_SecurityContextTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsc_SecurityContextTokenType_serialize_contents(
    xsd_QName *                         element_name,
    wsc_SecurityContextTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 * Deserialize an element containing a wsc_SecurityContextTokenType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsc_SecurityContextTokenType.
 * @param val
 *     Pointer to the wsc_SecurityContextTokenType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsc_SecurityContextTokenType_deserialize(
    xsd_QName *                         element_name,
    wsc_SecurityContextTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 * Deserialize a wsc_SecurityContextTokenType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsc_SecurityContextTokenType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsc_SecurityContextTokenType_deserialize_contents(
    xsd_QName *                         element_name,
    wsc_SecurityContextTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsc_SecurityContextTokenType
 * @ingroup wsc_SecurityContextTokenType
 * Deserialize the next element if it contains a wsc_SecurityContextTokenType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsc_SecurityContextTokenType.
 * @param instance
 *     Pointer to the <code>wsc_SecurityContextTokenType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsc_SecurityContextTokenType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsc_SecurityContextTokenType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsc_SecurityContextTokenType_init_wrapper(
    void **                             object);
    
void
wsc_SecurityContextTokenType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsc_SecurityContextTokenType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsc_SecurityContextTokenType_init_contents_wrapper(
    void *                              object);
    
void
wsc_SecurityContextTokenType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsc_SecurityContextTokenType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsc_SecurityContextTokenType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsc_SecurityContextTokenType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsc_SecurityContextTokenType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsc_SecurityContextTokenType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
