/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSNT_INVALIDTOPICEXPRESSIONFAULTTYPE_H_
#define _WSNT_INVALIDTOPICEXPRESSIONFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsnt_InvalidTopicExpressionFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}InvalidTopicExpressionFaultType element.
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
typedef struct wsnt_InvalidTopicExpressionFaultType_s wsnt_InvalidTopicExpressionFaultType;
/**
 * The wsnt_InvalidTopicExpressionFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}InvalidTopicExpressionFaultType element.
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
typedef wsnt_InvalidTopicExpressionFaultType * wsnt_InvalidTopicExpressionFaultType_o;

/**
 * Namespace of the wsnt_InvalidTopicExpressionFaultType complex type
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
#define WSNT_INVALIDTOPICEXPRESSIONFAULTTYPE_NS "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsnt_InvalidTopicExpressionFaultType complex type
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
#define WSNT_INVALIDTOPICEXPRESSIONFAULTTYPE_LOCAL "InvalidTopicExpressionFaultType"

/**
 * QName of the wsnt_InvalidTopicExpressionFaultType complex type
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
extern xsd_QName wsnt_InvalidTopicExpressionFaultType_qname;
/**
 * Type information for serializing and deserializing wsnt_InvalidTopicExpressionFaultType elements
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
extern struct globus_xsd_type_info_s wsnt_InvalidTopicExpressionFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsnt_InvalidTopicExpressionFaultType
 * elements
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
extern struct globus_xsd_type_info_s wsnt_InvalidTopicExpressionFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsnt_InvalidTopicExpressionFaultType without surrounding elements
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
extern struct globus_xsd_type_info_s wsnt_InvalidTopicExpressionFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsnt_InvalidTopicExpressionFaultType_array.h"

/**
 * @defgroup wsnt_InvalidTopicExpressionFaultType Complex type: wsnt_InvalidTopicExpressionFaultType
 * @ingroup types
 */

/**
 * C structure for the wsnt_InvalidTopicExpressionFaultType complex type
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 */
struct wsnt_InvalidTopicExpressionFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 *
 * Allocates a new wsnt_InvalidTopicExpressionFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsnt_InvalidTopicExpressionFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_init(
    wsnt_InvalidTopicExpressionFaultType ** inst);

/**
 * Destroy a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 *
 * Frees a wsnt_InvalidTopicExpressionFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsnt_InvalidTopicExpressionFaultType_destroy(
    wsnt_InvalidTopicExpressionFaultType * inst);

/**
 * Copy a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 *
 * Perform a deep copy of a wsnt_InvalidTopicExpressionFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsnt_InvalidTopicExpressionFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsnt_InvalidTopicExpressionFaultType to be copied.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_copy(
    wsnt_InvalidTopicExpressionFaultType ** dest,
    const wsnt_InvalidTopicExpressionFaultType * src);

/**
 * Initialize the contents of a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 *
 * Initialize the contents of a wsnt_InvalidTopicExpressionFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsnt_InvalidTopicExpressionFaultType_init(). The contents may be freed
 * by calling wsnt_InvalidTopicExpressionFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsnt_InvalidTopicExpressionFaultType.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_init_contents(
    wsnt_InvalidTopicExpressionFaultType * instance);

/**
 * Destroy the contents of a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 *
 * Destroy the subelements and attributes of the given wsnt_InvalidTopicExpressionFaultType. 
 *
 * @param inst
 *     Pointer to a wsnt_InvalidTopicExpressionFaultType instance to destroy.
 */
void
wsnt_InvalidTopicExpressionFaultType_destroy_contents(
    wsnt_InvalidTopicExpressionFaultType * inst);

/**
 * Copy the contents of a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 *
 * Perform a deep copy of the contents of a wsnt_InvalidTopicExpressionFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsnt_InvalidTopicExpressionFaultType to be copied.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_copy_contents(
    wsnt_InvalidTopicExpressionFaultType * dest,
    const wsnt_InvalidTopicExpressionFaultType * src);

/**
 * Serialize a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType_array
 * Serialize a wsnt_InvalidTopicExpressionFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsnt_InvalidTopicExpressionFaultType.
 * @param val
 *     The wsnt_InvalidTopicExpressionFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_serialize(
    xsd_QName *                         element_name,
    wsnt_InvalidTopicExpressionFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType_array
 * Serialize a wsnt_InvalidTopicExpressionFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsnt_InvalidTopicExpressionFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsnt_InvalidTopicExpressionFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 * Deserialize an element containing a wsnt_InvalidTopicExpressionFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_InvalidTopicExpressionFaultType.
 * @param val
 *     Pointer to the wsnt_InvalidTopicExpressionFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_deserialize(
    xsd_QName *                         element_name,
    wsnt_InvalidTopicExpressionFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 * Deserialize a wsnt_InvalidTopicExpressionFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsnt_InvalidTopicExpressionFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsnt_InvalidTopicExpressionFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsnt_InvalidTopicExpressionFaultType
 * @ingroup wsnt_InvalidTopicExpressionFaultType
 * Deserialize the next element if it contains a wsnt_InvalidTopicExpressionFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_InvalidTopicExpressionFaultType.
 * @param instance
 *     Pointer to the <code>wsnt_InvalidTopicExpressionFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_InvalidTopicExpressionFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsnt_InvalidTopicExpressionFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsnt_InvalidTopicExpressionFaultType_init_wrapper(
    void **                             object);
    
void
wsnt_InvalidTopicExpressionFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsnt_InvalidTopicExpressionFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_InvalidTopicExpressionFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsnt_InvalidTopicExpressionFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsnt_InvalidTopicExpressionFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_InvalidTopicExpressionFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_InvalidTopicExpressionFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_InvalidTopicExpressionFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsnt_InvalidTopicExpressionFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
