/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSNT_NOCURRENTMESSAGEONTOPICFAULTTYPE_H_
#define _WSNT_NOCURRENTMESSAGEONTOPICFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsnt_NoCurrentMessageOnTopicFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}NoCurrentMessageOnTopicFaultType element.
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
typedef struct wsnt_NoCurrentMessageOnTopicFaultType_s wsnt_NoCurrentMessageOnTopicFaultType;
/**
 * The wsnt_NoCurrentMessageOnTopicFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}NoCurrentMessageOnTopicFaultType element.
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
typedef wsnt_NoCurrentMessageOnTopicFaultType * wsnt_NoCurrentMessageOnTopicFaultType_o;

/**
 * Namespace of the wsnt_NoCurrentMessageOnTopicFaultType complex type
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
#define WSNT_NOCURRENTMESSAGEONTOPICFAULTTYPE_NS "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsnt_NoCurrentMessageOnTopicFaultType complex type
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
#define WSNT_NOCURRENTMESSAGEONTOPICFAULTTYPE_LOCAL "NoCurrentMessageOnTopicFaultType"

/**
 * QName of the wsnt_NoCurrentMessageOnTopicFaultType complex type
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
extern xsd_QName wsnt_NoCurrentMessageOnTopicFaultType_qname;
/**
 * Type information for serializing and deserializing wsnt_NoCurrentMessageOnTopicFaultType elements
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
extern struct globus_xsd_type_info_s wsnt_NoCurrentMessageOnTopicFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsnt_NoCurrentMessageOnTopicFaultType
 * elements
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
extern struct globus_xsd_type_info_s wsnt_NoCurrentMessageOnTopicFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsnt_NoCurrentMessageOnTopicFaultType without surrounding elements
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
extern struct globus_xsd_type_info_s wsnt_NoCurrentMessageOnTopicFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsnt_NoCurrentMessageOnTopicFaultType_array.h"

/**
 * @defgroup wsnt_NoCurrentMessageOnTopicFaultType Complex type: wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup types
 */

/**
 * C structure for the wsnt_NoCurrentMessageOnTopicFaultType complex type
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 */
struct wsnt_NoCurrentMessageOnTopicFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 *
 * Allocates a new wsnt_NoCurrentMessageOnTopicFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsnt_NoCurrentMessageOnTopicFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_init(
    wsnt_NoCurrentMessageOnTopicFaultType ** inst);

/**
 * Destroy a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 *
 * Frees a wsnt_NoCurrentMessageOnTopicFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsnt_NoCurrentMessageOnTopicFaultType_destroy(
    wsnt_NoCurrentMessageOnTopicFaultType * inst);

/**
 * Copy a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 *
 * Perform a deep copy of a wsnt_NoCurrentMessageOnTopicFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsnt_NoCurrentMessageOnTopicFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsnt_NoCurrentMessageOnTopicFaultType to be copied.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_copy(
    wsnt_NoCurrentMessageOnTopicFaultType ** dest,
    const wsnt_NoCurrentMessageOnTopicFaultType * src);

/**
 * Initialize the contents of a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 *
 * Initialize the contents of a wsnt_NoCurrentMessageOnTopicFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsnt_NoCurrentMessageOnTopicFaultType_init(). The contents may be freed
 * by calling wsnt_NoCurrentMessageOnTopicFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsnt_NoCurrentMessageOnTopicFaultType.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_init_contents(
    wsnt_NoCurrentMessageOnTopicFaultType * instance);

/**
 * Destroy the contents of a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 *
 * Destroy the subelements and attributes of the given wsnt_NoCurrentMessageOnTopicFaultType. 
 *
 * @param inst
 *     Pointer to a wsnt_NoCurrentMessageOnTopicFaultType instance to destroy.
 */
void
wsnt_NoCurrentMessageOnTopicFaultType_destroy_contents(
    wsnt_NoCurrentMessageOnTopicFaultType * inst);

/**
 * Copy the contents of a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 *
 * Perform a deep copy of the contents of a wsnt_NoCurrentMessageOnTopicFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsnt_NoCurrentMessageOnTopicFaultType to be copied.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_copy_contents(
    wsnt_NoCurrentMessageOnTopicFaultType * dest,
    const wsnt_NoCurrentMessageOnTopicFaultType * src);

/**
 * Serialize a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType_array
 * Serialize a wsnt_NoCurrentMessageOnTopicFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsnt_NoCurrentMessageOnTopicFaultType.
 * @param val
 *     The wsnt_NoCurrentMessageOnTopicFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_serialize(
    xsd_QName *                         element_name,
    wsnt_NoCurrentMessageOnTopicFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType_array
 * Serialize a wsnt_NoCurrentMessageOnTopicFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsnt_NoCurrentMessageOnTopicFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsnt_NoCurrentMessageOnTopicFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 * Deserialize an element containing a wsnt_NoCurrentMessageOnTopicFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_NoCurrentMessageOnTopicFaultType.
 * @param val
 *     Pointer to the wsnt_NoCurrentMessageOnTopicFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_deserialize(
    xsd_QName *                         element_name,
    wsnt_NoCurrentMessageOnTopicFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 * Deserialize a wsnt_NoCurrentMessageOnTopicFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsnt_NoCurrentMessageOnTopicFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsnt_NoCurrentMessageOnTopicFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsnt_NoCurrentMessageOnTopicFaultType
 * @ingroup wsnt_NoCurrentMessageOnTopicFaultType
 * Deserialize the next element if it contains a wsnt_NoCurrentMessageOnTopicFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_NoCurrentMessageOnTopicFaultType.
 * @param instance
 *     Pointer to the <code>wsnt_NoCurrentMessageOnTopicFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsnt_NoCurrentMessageOnTopicFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_init_wrapper(
    void **                             object);
    
void
wsnt_NoCurrentMessageOnTopicFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsnt_NoCurrentMessageOnTopicFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsnt_NoCurrentMessageOnTopicFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
