/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSNT_NOTIFICATIONMESSAGEHOLDERTYPE_H_
#define _WSNT_NOTIFICATIONMESSAGEHOLDERTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsnt_NotificationMessageHolderType complex type, which represents the
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}NotificationMessageHolderType element.
 * @ingroup wsnt_NotificationMessageHolderType
 */
typedef struct wsnt_NotificationMessageHolderType_s wsnt_NotificationMessageHolderType;
/**
 * The wsnt_NotificationMessageHolderType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}NotificationMessageHolderType element.
 * @ingroup wsnt_NotificationMessageHolderType
 */
typedef wsnt_NotificationMessageHolderType * wsnt_NotificationMessageHolderType_o;

/**
 * Namespace of the wsnt_NotificationMessageHolderType complex type
 * @ingroup wsnt_NotificationMessageHolderType
 */
#define WSNT_NOTIFICATIONMESSAGEHOLDERTYPE_NS "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsnt_NotificationMessageHolderType complex type
 * @ingroup wsnt_NotificationMessageHolderType
 */
#define WSNT_NOTIFICATIONMESSAGEHOLDERTYPE_LOCAL "NotificationMessageHolderType"

/**
 * QName of the wsnt_NotificationMessageHolderType complex type
 * @ingroup wsnt_NotificationMessageHolderType
 */
extern xsd_QName wsnt_NotificationMessageHolderType_qname;
/**
 * Type information for serializing and deserializing wsnt_NotificationMessageHolderType elements
 * @ingroup wsnt_NotificationMessageHolderType
 */
extern struct globus_xsd_type_info_s wsnt_NotificationMessageHolderType_info;
/**
 * Type information for serializing and deserializing arrays of wsnt_NotificationMessageHolderType
 * elements
 * @ingroup wsnt_NotificationMessageHolderType
 */
extern struct globus_xsd_type_info_s wsnt_NotificationMessageHolderType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsnt_NotificationMessageHolderType without surrounding elements
 * @ingroup wsnt_NotificationMessageHolderType
 */
extern struct globus_xsd_type_info_s wsnt_NotificationMessageHolderType_contents_info;


#include "wsnt_TopicExpressionType.h"
#include "wsa_EndpointReferenceType.h"
#include "xsd_anyType.h"
#include "wsnt_NotificationMessageHolderType_array.h"

/**
 * @defgroup wsnt_NotificationMessageHolderType Complex type: wsnt_NotificationMessageHolderType
 * @ingroup types
 */

/**
 * C structure for the wsnt_NotificationMessageHolderType complex type
 * @ingroup wsnt_NotificationMessageHolderType
 */
struct wsnt_NotificationMessageHolderType_s
{
    /** wsnt_TopicExpressionType subelement */
    wsnt_TopicExpressionType Topic;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o ProducerReference;
    /** xsd_anyType subelement */
    xsd_anyType Message;

};

/**
 * Initialize a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 *
 * Allocates a new wsnt_NotificationMessageHolderType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsnt_NotificationMessageHolderType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsnt_NotificationMessageHolderType_init(
    wsnt_NotificationMessageHolderType ** inst);

/**
 * Destroy a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 *
 * Frees a wsnt_NotificationMessageHolderType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsnt_NotificationMessageHolderType_destroy(
    wsnt_NotificationMessageHolderType * inst);

/**
 * Copy a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 *
 * Perform a deep copy of a wsnt_NotificationMessageHolderType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsnt_NotificationMessageHolderType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsnt_NotificationMessageHolderType to be copied.
 */
globus_result_t
wsnt_NotificationMessageHolderType_copy(
    wsnt_NotificationMessageHolderType ** dest,
    const wsnt_NotificationMessageHolderType * src);

/**
 * Initialize the contents of a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 *
 * Initialize the contents of a wsnt_NotificationMessageHolderType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsnt_NotificationMessageHolderType_init(). The contents may be freed
 * by calling wsnt_NotificationMessageHolderType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsnt_NotificationMessageHolderType.
 */
globus_result_t
wsnt_NotificationMessageHolderType_init_contents(
    wsnt_NotificationMessageHolderType * instance);

/**
 * Destroy the contents of a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 *
 * Destroy the subelements and attributes of the given wsnt_NotificationMessageHolderType. 
 *
 * @param inst
 *     Pointer to a wsnt_NotificationMessageHolderType instance to destroy.
 */
void
wsnt_NotificationMessageHolderType_destroy_contents(
    wsnt_NotificationMessageHolderType * inst);

/**
 * Copy the contents of a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 *
 * Perform a deep copy of the contents of a wsnt_NotificationMessageHolderType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsnt_NotificationMessageHolderType to be copied.
 */
globus_result_t
wsnt_NotificationMessageHolderType_copy_contents(
    wsnt_NotificationMessageHolderType * dest,
    const wsnt_NotificationMessageHolderType * src);

/**
 * Serialize a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType_array
 * Serialize a wsnt_NotificationMessageHolderType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsnt_NotificationMessageHolderType.
 * @param val
 *     The wsnt_NotificationMessageHolderType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_NotificationMessageHolderType_serialize(
    xsd_QName *                         element_name,
    wsnt_NotificationMessageHolderType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType_array
 * Serialize a wsnt_NotificationMessageHolderType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsnt_NotificationMessageHolderType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_NotificationMessageHolderType_serialize_contents(
    xsd_QName *                         element_name,
    wsnt_NotificationMessageHolderType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 * Deserialize an element containing a wsnt_NotificationMessageHolderType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_NotificationMessageHolderType.
 * @param val
 *     Pointer to the wsnt_NotificationMessageHolderType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NotificationMessageHolderType_deserialize(
    xsd_QName *                         element_name,
    wsnt_NotificationMessageHolderType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 * Deserialize a wsnt_NotificationMessageHolderType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsnt_NotificationMessageHolderType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NotificationMessageHolderType_deserialize_contents(
    xsd_QName *                         element_name,
    wsnt_NotificationMessageHolderType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsnt_NotificationMessageHolderType
 * @ingroup wsnt_NotificationMessageHolderType
 * Deserialize the next element if it contains a wsnt_NotificationMessageHolderType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_NotificationMessageHolderType.
 * @param instance
 *     Pointer to the <code>wsnt_NotificationMessageHolderType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NotificationMessageHolderType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsnt_NotificationMessageHolderType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsnt_NotificationMessageHolderType_init_wrapper(
    void **                             object);
    
void
wsnt_NotificationMessageHolderType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsnt_NotificationMessageHolderType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_NotificationMessageHolderType_init_contents_wrapper(
    void *                              object);
    
void
wsnt_NotificationMessageHolderType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsnt_NotificationMessageHolderType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_NotificationMessageHolderType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_NotificationMessageHolderType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_NotificationMessageHolderType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsnt_NotificationMessageHolderType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
