/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSNT_SUBSCRIPTIONMANAGERRPTYPE_H_
#define _WSNT_SUBSCRIPTIONMANAGERRPTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsnt_SubscriptionManagerRPType complex type, which represents the
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}complexType 10 element.
 * @ingroup wsnt_SubscriptionManagerRPType
 */
typedef struct wsnt_SubscriptionManagerRPType_s wsnt_SubscriptionManagerRPType;
/**
 * The wsnt_SubscriptionManagerRPType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}complexType 10 element.
 * @ingroup wsnt_SubscriptionManagerRPType
 */
typedef wsnt_SubscriptionManagerRPType * wsnt_SubscriptionManagerRPType_o;

/**
 * Namespace of the wsnt_SubscriptionManagerRPType complex type
 * @ingroup wsnt_SubscriptionManagerRPType
 */
#define WSNT_SUBSCRIPTIONMANAGERRPTYPE_NS "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsnt_SubscriptionManagerRPType complex type
 * @ingroup wsnt_SubscriptionManagerRPType
 */
#define WSNT_SUBSCRIPTIONMANAGERRPTYPE_LOCAL "SubscriptionManagerRPType"

/**
 * QName of the wsnt_SubscriptionManagerRPType complex type
 * @ingroup wsnt_SubscriptionManagerRPType
 */
extern xsd_QName wsnt_SubscriptionManagerRPType_qname;
/**
 * Type information for serializing and deserializing wsnt_SubscriptionManagerRPType elements
 * @ingroup wsnt_SubscriptionManagerRPType
 */
extern struct globus_xsd_type_info_s wsnt_SubscriptionManagerRPType_info;
/**
 * Type information for serializing and deserializing arrays of wsnt_SubscriptionManagerRPType
 * elements
 * @ingroup wsnt_SubscriptionManagerRPType
 */
extern struct globus_xsd_type_info_s wsnt_SubscriptionManagerRPType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsnt_SubscriptionManagerRPType without surrounding elements
 * @ingroup wsnt_SubscriptionManagerRPType
 */
extern struct globus_xsd_type_info_s wsnt_SubscriptionManagerRPType_contents_info;


#include "xsd_dateTime.h"
#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsnt_TopicExpressionType.h"
#include "xsd_boolean.h"
#include "wsrp_QueryExpressionType.h"
#include "wsrp_QueryExpressionType.h"
#include "xsd_anyType.h"
#include "xsd_dateTime.h"
#include "wsnt_SubscriptionManagerRPType_array.h"

/**
 * @defgroup wsnt_SubscriptionManagerRPType Complex type: wsnt_SubscriptionManagerRPType
 * @ingroup types
 */

/**
 * C structure for the wsnt_SubscriptionManagerRPType complex type
 * @ingroup wsnt_SubscriptionManagerRPType
 */
struct wsnt_SubscriptionManagerRPType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime CurrentTime;
    /** xsd_dateTime subelement */
    xsd_dateTime TerminationTime;
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType ConsumerReference;
    /** wsnt_TopicExpressionType subelement */
    wsnt_TopicExpressionType TopicExpression;
    /** xsd_boolean subelement */
    xsd_boolean UseNotify;
   /** Optional wsrp_QueryExpressionType subelement */
    wsrp_QueryExpressionType_o Precondition;
   /** Optional wsrp_QueryExpressionType subelement */
    wsrp_QueryExpressionType_o Selector;
   /** Optional xsd_anyType subelement */
    xsd_anyType_o SubscriptionPolicy;
   /** Optional xsd_dateTime subelement */
    xsd_dateTime_o CreationTime;

};

/**
 * Initialize a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 *
 * Allocates a new wsnt_SubscriptionManagerRPType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsnt_SubscriptionManagerRPType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_init(
    wsnt_SubscriptionManagerRPType ** inst);

/**
 * Destroy a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 *
 * Frees a wsnt_SubscriptionManagerRPType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsnt_SubscriptionManagerRPType_destroy(
    wsnt_SubscriptionManagerRPType * inst);

/**
 * Copy a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 *
 * Perform a deep copy of a wsnt_SubscriptionManagerRPType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsnt_SubscriptionManagerRPType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsnt_SubscriptionManagerRPType to be copied.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_copy(
    wsnt_SubscriptionManagerRPType ** dest,
    const wsnt_SubscriptionManagerRPType * src);

/**
 * Initialize the contents of a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 *
 * Initialize the contents of a wsnt_SubscriptionManagerRPType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsnt_SubscriptionManagerRPType_init(). The contents may be freed
 * by calling wsnt_SubscriptionManagerRPType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsnt_SubscriptionManagerRPType.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_init_contents(
    wsnt_SubscriptionManagerRPType * instance);

/**
 * Destroy the contents of a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 *
 * Destroy the subelements and attributes of the given wsnt_SubscriptionManagerRPType. 
 *
 * @param inst
 *     Pointer to a wsnt_SubscriptionManagerRPType instance to destroy.
 */
void
wsnt_SubscriptionManagerRPType_destroy_contents(
    wsnt_SubscriptionManagerRPType * inst);

/**
 * Copy the contents of a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 *
 * Perform a deep copy of the contents of a wsnt_SubscriptionManagerRPType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsnt_SubscriptionManagerRPType to be copied.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_copy_contents(
    wsnt_SubscriptionManagerRPType * dest,
    const wsnt_SubscriptionManagerRPType * src);

/**
 * Serialize a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType_array
 * Serialize a wsnt_SubscriptionManagerRPType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsnt_SubscriptionManagerRPType.
 * @param val
 *     The wsnt_SubscriptionManagerRPType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_serialize(
    xsd_QName *                         element_name,
    wsnt_SubscriptionManagerRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType_array
 * Serialize a wsnt_SubscriptionManagerRPType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsnt_SubscriptionManagerRPType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_serialize_contents(
    xsd_QName *                         element_name,
    wsnt_SubscriptionManagerRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 * Deserialize an element containing a wsnt_SubscriptionManagerRPType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_SubscriptionManagerRPType.
 * @param val
 *     Pointer to the wsnt_SubscriptionManagerRPType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_deserialize(
    xsd_QName *                         element_name,
    wsnt_SubscriptionManagerRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 * Deserialize a wsnt_SubscriptionManagerRPType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsnt_SubscriptionManagerRPType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_deserialize_contents(
    xsd_QName *                         element_name,
    wsnt_SubscriptionManagerRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsnt_SubscriptionManagerRPType
 * @ingroup wsnt_SubscriptionManagerRPType
 * Deserialize the next element if it contains a wsnt_SubscriptionManagerRPType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_SubscriptionManagerRPType.
 * @param instance
 *     Pointer to the <code>wsnt_SubscriptionManagerRPType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_SubscriptionManagerRPType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsnt_SubscriptionManagerRPType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsnt_SubscriptionManagerRPType_init_wrapper(
    void **                             object);
    
void
wsnt_SubscriptionManagerRPType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsnt_SubscriptionManagerRPType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_SubscriptionManagerRPType_init_contents_wrapper(
    void *                              object);
    
void
wsnt_SubscriptionManagerRPType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsnt_SubscriptionManagerRPType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_SubscriptionManagerRPType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_SubscriptionManagerRPType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_SubscriptionManagerRPType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsnt_SubscriptionManagerRPType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
