/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_COMPOSITORCONTENT_GROUP_CHOICE_H_
#define _WSP_COMPOSITORCONTENT_GROUP_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum wsp_CompositorContent_group_e
{
    wsp_CompositorContent_group_undefined,
    wsp_CompositorContent_group_OneOrMore,
    wsp_CompositorContent_group_All,
    wsp_CompositorContent_group_ExactlyOne,
    wsp_CompositorContent_group_PolicyReference,
    wsp_CompositorContent_group_PolicyAssertions,
    wsp_CompositorContent_group_any

};

/**
 * @defgroup wsp_CompositorContent_group_choice Complex choice type: wsp_CompositorContent_group
 * @ingroup wsp_CompositorContent_group
 */

/**
 * Enumeration of the types of values which the wsp_CompositorContent_group_choice
 * structure may take on.
 * @ingroup wsp_CompositorContent_group_choice
 */
typedef enum wsp_CompositorContent_group_e wsp_CompositorContent_group_enum;
/**
 * Union of the values which the wsp_CompositorContent_group_choice structure
 * contains
 * @ingroup wsp_CompositorContent_group_choice
 */
typedef union wsp_CompositorContent_group_u wsp_CompositorContent_group_union;
/**
 * The wsp_CompositorContent_group complex type, which represents the various values
 * possible by the choice used by the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}choice 7 element.
 * @ingroup wsp_CompositorContent_group_choice
 */
typedef struct wsp_CompositorContent_group_choice_s wsp_CompositorContent_group_choice;
/**
 * The wsp_CompositorContent_group_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}choice 7 element.
 * @ingroup wsp_CompositorContent_group
 */
typedef wsp_CompositorContent_group_choice * wsp_CompositorContent_group_choice_o;

typedef struct wsp_CompositorContent_group_choice_array_s
{
    wsp_CompositorContent_group_choice * elements;
    int                                 length;
} wsp_CompositorContent_group_choice_array;

#define WSP_COMPOSITORCONTENT_GROUP_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
#define WSP_COMPOSITORCONTENT_GROUP_LOCAL "CompositorContent_group"

extern xsd_QName wsp_CompositorContent_group_choice_qname;
extern struct globus_xsd_type_info_s wsp_CompositorContent_group_choice_info;
extern struct globus_xsd_type_info_s wsp_CompositorContent_group_choice_contents_info;
extern struct globus_xsd_type_info_s wsp_CompositorContent_group_choice_array_info;


#include "wsp_Compositor.h"
#include "wsp_Compositor.h"
#include "wsp_Compositor.h"
#include "wsp_PolicyReferenceType.h"
#include "wsp_PolicyAssertions_group.h"
#include "xsd_any.h"

union wsp_CompositorContent_group_u
{
    /** wsp_Compositor subelement */
    wsp_Compositor OneOrMore;
    /** wsp_Compositor subelement */
    wsp_Compositor All;
    /** wsp_Compositor subelement */
    wsp_Compositor ExactlyOne;
    /** wsp_PolicyReferenceType subelement */
    wsp_PolicyReferenceType PolicyReference;
    /** wsp_PolicyAssertions_group subelement */
    wsp_PolicyAssertions_group PolicyAssertions;
    /** xsd_any subelement */
    xsd_any any;

};

struct wsp_CompositorContent_group_choice_s
{
    wsp_CompositorContent_group_enum type;
    wsp_CompositorContent_group_union value;
};

globus_result_t
wsp_CompositorContent_group_choice_init(
    wsp_CompositorContent_group_choice ** inst);

void
wsp_CompositorContent_group_choice_destroy(
    wsp_CompositorContent_group_choice * inst);

globus_result_t
wsp_CompositorContent_group_choice_copy(
    wsp_CompositorContent_group_choice ** dest,
    const wsp_CompositorContent_group_choice * src);

globus_result_t
wsp_CompositorContent_group_choice_init_contents(
    wsp_CompositorContent_group_choice * instance);

void
wsp_CompositorContent_group_choice_destroy_contents(
    wsp_CompositorContent_group_choice * inst);

globus_result_t
wsp_CompositorContent_group_choice_copy_contents(
    wsp_CompositorContent_group_choice * dest,
    const wsp_CompositorContent_group_choice * src);
    
globus_result_t
wsp_CompositorContent_group_choice_array_init(
    wsp_CompositorContent_group_choice_array ** inst);

void
wsp_CompositorContent_group_choice_array_destroy(
    wsp_CompositorContent_group_choice_array * inst);

globus_result_t
wsp_CompositorContent_group_choice_array_copy(
    wsp_CompositorContent_group_choice_array ** dest,
    const wsp_CompositorContent_group_choice_array * src);

globus_result_t
wsp_CompositorContent_group_choice_array_init_contents(
    wsp_CompositorContent_group_choice_array * inst);

void
wsp_CompositorContent_group_choice_array_destroy_contents(
    wsp_CompositorContent_group_choice_array * inst);

globus_result_t
wsp_CompositorContent_group_choice_array_copy_contents(
    wsp_CompositorContent_group_choice_array * dest,
    const wsp_CompositorContent_group_choice_array * src);

wsp_CompositorContent_group_choice *
wsp_CompositorContent_group_choice_array_push(
    wsp_CompositorContent_group_choice_array * array);

globus_result_t
wsp_CompositorContent_group_choice_serialize(
    xsd_QName *                         element_name,
    wsp_CompositorContent_group_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_CompositorContent_group_choice_serialize_contents(
    xsd_QName *                         element_name,
    wsp_CompositorContent_group_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_CompositorContent_group_choice_deserialize(
    xsd_QName *                         element_name,
    wsp_CompositorContent_group_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_CompositorContent_group_choice_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_CompositorContent_group_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_CompositorContent_group_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_CompositorContent_group_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_CompositorContent_group_choice_array_serialize(
    xsd_QName *                         element,
    wsp_CompositorContent_group_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_CompositorContent_group_choice_array_deserialize(
    xsd_QName *                         element,
    wsp_CompositorContent_group_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_CompositorContent_group_choice_init_wrapper(
    void **                             object);
    
void
wsp_CompositorContent_group_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_CompositorContent_group_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_CompositorContent_group_choice_init_contents_wrapper(
    void *                              object);
    
void
wsp_CompositorContent_group_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_CompositorContent_group_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_CompositorContent_group_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_CompositorContent_group_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_CompositorContent_group_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_CompositorContent_group_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_CompositorContent_group_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_CompositorContent_group_choice_array_init_wrapper(
    void **                             arr);
    
void
wsp_CompositorContent_group_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsp_CompositorContent_group_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
wsp_CompositorContent_group_choice_array_init_contents_wrapper(
    void *                              arr);

void
wsp_CompositorContent_group_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
wsp_CompositorContent_group_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
wsp_CompositorContent_group_choice_array_push_wrapper(
    void * array);

globus_result_t
wsp_CompositorContent_group_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
