/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_TEXTENCODINGASSERTION_H_
#define _WSP_TEXTENCODINGASSERTION_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsp_TextEncodingAssertion complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}TextEncodingAssertion element.
 * @ingroup wsp_TextEncodingAssertion
 */
typedef struct wsp_TextEncodingAssertion_s wsp_TextEncodingAssertion;
/**
 * The wsp_TextEncodingAssertion_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}TextEncodingAssertion element.
 * @ingroup wsp_TextEncodingAssertion
 */
typedef wsp_TextEncodingAssertion * wsp_TextEncodingAssertion_o;

/**
 * Namespace of the wsp_TextEncodingAssertion complex type
 * @ingroup wsp_TextEncodingAssertion
 */
#define WSP_TEXTENCODINGASSERTION_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
/**
 * Local part of the QName of the wsp_TextEncodingAssertion complex type
 * @ingroup wsp_TextEncodingAssertion
 */
#define WSP_TEXTENCODINGASSERTION_LOCAL "TextEncodingAssertion"

/**
 * QName of the wsp_TextEncodingAssertion complex type
 * @ingroup wsp_TextEncodingAssertion
 */
extern xsd_QName wsp_TextEncodingAssertion_qname;
/**
 * Type information for serializing and deserializing wsp_TextEncodingAssertion elements
 * @ingroup wsp_TextEncodingAssertion
 */
extern struct globus_xsd_type_info_s wsp_TextEncodingAssertion_info;
/**
 * Type information for serializing and deserializing arrays of wsp_TextEncodingAssertion
 * elements
 * @ingroup wsp_TextEncodingAssertion
 */
extern struct globus_xsd_type_info_s wsp_TextEncodingAssertion_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsp_TextEncodingAssertion without surrounding elements
 * @ingroup wsp_TextEncodingAssertion
 */
extern struct globus_xsd_type_info_s wsp_TextEncodingAssertion_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_string.h"
#include "xsd_ID.h"
#include "xsd_int.h"
#include "wsp_OpenUsageType.h"
#include "wsp_TextEncodingAssertion_array.h"

/**
 * @defgroup wsp_TextEncodingAssertion Complex type: wsp_TextEncodingAssertion
 * @ingroup types
 */

/**
 * C structure for the wsp_TextEncodingAssertion complex type
 * @ingroup wsp_TextEncodingAssertion
 */
struct wsp_TextEncodingAssertion_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_string _Encoding;
    xsd_ID_o _Id;
    xsd_int_o _Preference;
    wsp_OpenUsageType_o _Usage;

};

/**
 * Initialize a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 *
 * Allocates a new wsp_TextEncodingAssertion and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsp_TextEncodingAssertion_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsp_TextEncodingAssertion_init(
    wsp_TextEncodingAssertion ** inst);

/**
 * Destroy a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 *
 * Frees a wsp_TextEncodingAssertion. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsp_TextEncodingAssertion_destroy(
    wsp_TextEncodingAssertion * inst);

/**
 * Copy a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 *
 * Perform a deep copy of a wsp_TextEncodingAssertion.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsp_TextEncodingAssertion structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsp_TextEncodingAssertion to be copied.
 */
globus_result_t
wsp_TextEncodingAssertion_copy(
    wsp_TextEncodingAssertion ** dest,
    const wsp_TextEncodingAssertion * src);

/**
 * Initialize the contents of a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 *
 * Initialize the contents of a wsp_TextEncodingAssertion. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsp_TextEncodingAssertion_init(). The contents may be freed
 * by calling wsp_TextEncodingAssertion_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsp_TextEncodingAssertion.
 */
globus_result_t
wsp_TextEncodingAssertion_init_contents(
    wsp_TextEncodingAssertion * instance);

/**
 * Destroy the contents of a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 *
 * Destroy the subelements and attributes of the given wsp_TextEncodingAssertion. 
 *
 * @param inst
 *     Pointer to a wsp_TextEncodingAssertion instance to destroy.
 */
void
wsp_TextEncodingAssertion_destroy_contents(
    wsp_TextEncodingAssertion * inst);

/**
 * Copy the contents of a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 *
 * Perform a deep copy of the contents of a wsp_TextEncodingAssertion.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsp_TextEncodingAssertion to be copied.
 */
globus_result_t
wsp_TextEncodingAssertion_copy_contents(
    wsp_TextEncodingAssertion * dest,
    const wsp_TextEncodingAssertion * src);

/**
 * Serialize a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion_array
 * Serialize a wsp_TextEncodingAssertion structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsp_TextEncodingAssertion.
 * @param val
 *     The wsp_TextEncodingAssertion to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_TextEncodingAssertion_serialize(
    xsd_QName *                         element_name,
    wsp_TextEncodingAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion_array
 * Serialize a wsp_TextEncodingAssertion structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsp_TextEncodingAssertion to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_TextEncodingAssertion_serialize_contents(
    xsd_QName *                         element_name,
    wsp_TextEncodingAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 * Deserialize an element containing a wsp_TextEncodingAssertion element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_TextEncodingAssertion.
 * @param val
 *     Pointer to the wsp_TextEncodingAssertion which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_TextEncodingAssertion_deserialize(
    xsd_QName *                         element_name,
    wsp_TextEncodingAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 * Deserialize a wsp_TextEncodingAssertion whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsp_TextEncodingAssertion which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_TextEncodingAssertion_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_TextEncodingAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsp_TextEncodingAssertion
 * @ingroup wsp_TextEncodingAssertion
 * Deserialize the next element if it contains a wsp_TextEncodingAssertion.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_TextEncodingAssertion.
 * @param instance
 *     Pointer to the <code>wsp_TextEncodingAssertion *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_TextEncodingAssertion_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_TextEncodingAssertion ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsp_TextEncodingAssertion_init_wrapper(
    void **                             object);
    
void
wsp_TextEncodingAssertion_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_TextEncodingAssertion_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_TextEncodingAssertion_init_contents_wrapper(
    void *                              object);
    
void
wsp_TextEncodingAssertion_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_TextEncodingAssertion_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_TextEncodingAssertion_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_TextEncodingAssertion_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_TextEncodingAssertion_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_TextEncodingAssertion_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
