/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRL_DESTROYRESPONSETYPE_H_
#define _WSRL_DESTROYRESPONSETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrl_DestroyResponseType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}complexType 8 element.
 * @ingroup wsrl_DestroyResponseType
 */
typedef struct wsrl_DestroyResponseType_s wsrl_DestroyResponseType;
/**
 * The wsrl_DestroyResponseType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}complexType 8 element.
 * @ingroup wsrl_DestroyResponseType
 */
typedef wsrl_DestroyResponseType * wsrl_DestroyResponseType_o;

/**
 * Namespace of the wsrl_DestroyResponseType complex type
 * @ingroup wsrl_DestroyResponseType
 */
#define WSRL_DESTROYRESPONSETYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrl_DestroyResponseType complex type
 * @ingroup wsrl_DestroyResponseType
 */
#define WSRL_DESTROYRESPONSETYPE_LOCAL "DestroyResponseType"

/**
 * QName of the wsrl_DestroyResponseType complex type
 * @ingroup wsrl_DestroyResponseType
 */
extern xsd_QName wsrl_DestroyResponseType_qname;
/**
 * Type information for serializing and deserializing wsrl_DestroyResponseType elements
 * @ingroup wsrl_DestroyResponseType
 */
extern struct globus_xsd_type_info_s wsrl_DestroyResponseType_info;
/**
 * Type information for serializing and deserializing arrays of wsrl_DestroyResponseType
 * elements
 * @ingroup wsrl_DestroyResponseType
 */
extern struct globus_xsd_type_info_s wsrl_DestroyResponseType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrl_DestroyResponseType without surrounding elements
 * @ingroup wsrl_DestroyResponseType
 */
extern struct globus_xsd_type_info_s wsrl_DestroyResponseType_contents_info;


#include "wsrl_DestroyResponseType_array.h"

/**
 * @defgroup wsrl_DestroyResponseType Complex type: wsrl_DestroyResponseType
 * @ingroup types
 */

/**
 * C structure for the wsrl_DestroyResponseType complex type
 * @ingroup wsrl_DestroyResponseType
 */
struct wsrl_DestroyResponseType_s
{

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
    /* WSDL defines type without containing elements or attributes, 
     * but C cannot have empty structs, so we add a dummy variable */
    void *                              DUMMY_VARIABLE;
#endif

};

/**
 * Initialize a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 *
 * Allocates a new wsrl_DestroyResponseType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrl_DestroyResponseType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrl_DestroyResponseType_init(
    wsrl_DestroyResponseType ** inst);

/**
 * Destroy a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 *
 * Frees a wsrl_DestroyResponseType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrl_DestroyResponseType_destroy(
    wsrl_DestroyResponseType * inst);

/**
 * Copy a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 *
 * Perform a deep copy of a wsrl_DestroyResponseType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrl_DestroyResponseType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrl_DestroyResponseType to be copied.
 */
globus_result_t
wsrl_DestroyResponseType_copy(
    wsrl_DestroyResponseType ** dest,
    const wsrl_DestroyResponseType * src);

/**
 * Initialize the contents of a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 *
 * Initialize the contents of a wsrl_DestroyResponseType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrl_DestroyResponseType_init(). The contents may be freed
 * by calling wsrl_DestroyResponseType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrl_DestroyResponseType.
 */
globus_result_t
wsrl_DestroyResponseType_init_contents(
    wsrl_DestroyResponseType * instance);

/**
 * Destroy the contents of a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 *
 * Destroy the subelements and attributes of the given wsrl_DestroyResponseType. 
 *
 * @param inst
 *     Pointer to a wsrl_DestroyResponseType instance to destroy.
 */
void
wsrl_DestroyResponseType_destroy_contents(
    wsrl_DestroyResponseType * inst);

/**
 * Copy the contents of a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 *
 * Perform a deep copy of the contents of a wsrl_DestroyResponseType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrl_DestroyResponseType to be copied.
 */
globus_result_t
wsrl_DestroyResponseType_copy_contents(
    wsrl_DestroyResponseType * dest,
    const wsrl_DestroyResponseType * src);

/**
 * Serialize a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType_array
 * Serialize a wsrl_DestroyResponseType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrl_DestroyResponseType.
 * @param val
 *     The wsrl_DestroyResponseType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_DestroyResponseType_serialize(
    xsd_QName *                         element_name,
    wsrl_DestroyResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType_array
 * Serialize a wsrl_DestroyResponseType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrl_DestroyResponseType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_DestroyResponseType_serialize_contents(
    xsd_QName *                         element_name,
    wsrl_DestroyResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 * Deserialize an element containing a wsrl_DestroyResponseType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_DestroyResponseType.
 * @param val
 *     Pointer to the wsrl_DestroyResponseType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_DestroyResponseType_deserialize(
    xsd_QName *                         element_name,
    wsrl_DestroyResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 * Deserialize a wsrl_DestroyResponseType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrl_DestroyResponseType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_DestroyResponseType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrl_DestroyResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrl_DestroyResponseType
 * @ingroup wsrl_DestroyResponseType
 * Deserialize the next element if it contains a wsrl_DestroyResponseType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_DestroyResponseType.
 * @param instance
 *     Pointer to the <code>wsrl_DestroyResponseType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_DestroyResponseType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrl_DestroyResponseType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrl_DestroyResponseType_init_wrapper(
    void **                             object);
    
void
wsrl_DestroyResponseType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrl_DestroyResponseType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_DestroyResponseType_init_contents_wrapper(
    void *                              object);
    
void
wsrl_DestroyResponseType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrl_DestroyResponseType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_DestroyResponseType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_DestroyResponseType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_DestroyResponseType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrl_DestroyResponseType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
