/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRL_UNABLETOSETTERMINATIONTIMEFAULTTYPE_H_
#define _WSRL_UNABLETOSETTERMINATIONTIMEFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrl_UnableToSetTerminationTimeFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}UnableToSetTerminationTimeFaultType element.
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
typedef struct wsrl_UnableToSetTerminationTimeFaultType_s wsrl_UnableToSetTerminationTimeFaultType;
/**
 * The wsrl_UnableToSetTerminationTimeFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}UnableToSetTerminationTimeFaultType element.
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
typedef wsrl_UnableToSetTerminationTimeFaultType * wsrl_UnableToSetTerminationTimeFaultType_o;

/**
 * Namespace of the wsrl_UnableToSetTerminationTimeFaultType complex type
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
#define WSRL_UNABLETOSETTERMINATIONTIMEFAULTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrl_UnableToSetTerminationTimeFaultType complex type
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
#define WSRL_UNABLETOSETTERMINATIONTIMEFAULTTYPE_LOCAL "UnableToSetTerminationTimeFaultType"

/**
 * QName of the wsrl_UnableToSetTerminationTimeFaultType complex type
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
extern xsd_QName wsrl_UnableToSetTerminationTimeFaultType_qname;
/**
 * Type information for serializing and deserializing wsrl_UnableToSetTerminationTimeFaultType elements
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
extern struct globus_xsd_type_info_s wsrl_UnableToSetTerminationTimeFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsrl_UnableToSetTerminationTimeFaultType
 * elements
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
extern struct globus_xsd_type_info_s wsrl_UnableToSetTerminationTimeFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrl_UnableToSetTerminationTimeFaultType without surrounding elements
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
extern struct globus_xsd_type_info_s wsrl_UnableToSetTerminationTimeFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsrl_UnableToSetTerminationTimeFaultType_array.h"

/**
 * @defgroup wsrl_UnableToSetTerminationTimeFaultType Complex type: wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup types
 */

/**
 * C structure for the wsrl_UnableToSetTerminationTimeFaultType complex type
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 */
struct wsrl_UnableToSetTerminationTimeFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 *
 * Allocates a new wsrl_UnableToSetTerminationTimeFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrl_UnableToSetTerminationTimeFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_init(
    wsrl_UnableToSetTerminationTimeFaultType ** inst);

/**
 * Destroy a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 *
 * Frees a wsrl_UnableToSetTerminationTimeFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrl_UnableToSetTerminationTimeFaultType_destroy(
    wsrl_UnableToSetTerminationTimeFaultType * inst);

/**
 * Copy a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 *
 * Perform a deep copy of a wsrl_UnableToSetTerminationTimeFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrl_UnableToSetTerminationTimeFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrl_UnableToSetTerminationTimeFaultType to be copied.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_copy(
    wsrl_UnableToSetTerminationTimeFaultType ** dest,
    const wsrl_UnableToSetTerminationTimeFaultType * src);

/**
 * Initialize the contents of a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 *
 * Initialize the contents of a wsrl_UnableToSetTerminationTimeFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrl_UnableToSetTerminationTimeFaultType_init(). The contents may be freed
 * by calling wsrl_UnableToSetTerminationTimeFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrl_UnableToSetTerminationTimeFaultType.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_init_contents(
    wsrl_UnableToSetTerminationTimeFaultType * instance);

/**
 * Destroy the contents of a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 *
 * Destroy the subelements and attributes of the given wsrl_UnableToSetTerminationTimeFaultType. 
 *
 * @param inst
 *     Pointer to a wsrl_UnableToSetTerminationTimeFaultType instance to destroy.
 */
void
wsrl_UnableToSetTerminationTimeFaultType_destroy_contents(
    wsrl_UnableToSetTerminationTimeFaultType * inst);

/**
 * Copy the contents of a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 *
 * Perform a deep copy of the contents of a wsrl_UnableToSetTerminationTimeFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrl_UnableToSetTerminationTimeFaultType to be copied.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_copy_contents(
    wsrl_UnableToSetTerminationTimeFaultType * dest,
    const wsrl_UnableToSetTerminationTimeFaultType * src);

/**
 * Serialize a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType_array
 * Serialize a wsrl_UnableToSetTerminationTimeFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrl_UnableToSetTerminationTimeFaultType.
 * @param val
 *     The wsrl_UnableToSetTerminationTimeFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_serialize(
    xsd_QName *                         element_name,
    wsrl_UnableToSetTerminationTimeFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType_array
 * Serialize a wsrl_UnableToSetTerminationTimeFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrl_UnableToSetTerminationTimeFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsrl_UnableToSetTerminationTimeFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 * Deserialize an element containing a wsrl_UnableToSetTerminationTimeFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_UnableToSetTerminationTimeFaultType.
 * @param val
 *     Pointer to the wsrl_UnableToSetTerminationTimeFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_deserialize(
    xsd_QName *                         element_name,
    wsrl_UnableToSetTerminationTimeFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 * Deserialize a wsrl_UnableToSetTerminationTimeFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrl_UnableToSetTerminationTimeFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrl_UnableToSetTerminationTimeFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrl_UnableToSetTerminationTimeFaultType
 * @ingroup wsrl_UnableToSetTerminationTimeFaultType
 * Deserialize the next element if it contains a wsrl_UnableToSetTerminationTimeFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_UnableToSetTerminationTimeFaultType.
 * @param instance
 *     Pointer to the <code>wsrl_UnableToSetTerminationTimeFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrl_UnableToSetTerminationTimeFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_init_wrapper(
    void **                             object);
    
void
wsrl_UnableToSetTerminationTimeFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsrl_UnableToSetTerminationTimeFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrl_UnableToSetTerminationTimeFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
