/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_INVALIDRESOURCEPROPERTYQNAMEFAULTTYPE_H_
#define _WSRP_INVALIDRESOURCEPROPERTYQNAMEFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_InvalidResourcePropertyQNameFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}InvalidResourcePropertyQNameFaultType element.
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
typedef struct wsrp_InvalidResourcePropertyQNameFaultType_s wsrp_InvalidResourcePropertyQNameFaultType;
/**
 * The wsrp_InvalidResourcePropertyQNameFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}InvalidResourcePropertyQNameFaultType element.
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
typedef wsrp_InvalidResourcePropertyQNameFaultType * wsrp_InvalidResourcePropertyQNameFaultType_o;

/**
 * Namespace of the wsrp_InvalidResourcePropertyQNameFaultType complex type
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
#define WSRP_INVALIDRESOURCEPROPERTYQNAMEFAULTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_InvalidResourcePropertyQNameFaultType complex type
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
#define WSRP_INVALIDRESOURCEPROPERTYQNAMEFAULTTYPE_LOCAL "InvalidResourcePropertyQNameFaultType"

/**
 * QName of the wsrp_InvalidResourcePropertyQNameFaultType complex type
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
extern xsd_QName wsrp_InvalidResourcePropertyQNameFaultType_qname;
/**
 * Type information for serializing and deserializing wsrp_InvalidResourcePropertyQNameFaultType elements
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
extern struct globus_xsd_type_info_s wsrp_InvalidResourcePropertyQNameFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_InvalidResourcePropertyQNameFaultType
 * elements
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
extern struct globus_xsd_type_info_s wsrp_InvalidResourcePropertyQNameFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_InvalidResourcePropertyQNameFaultType without surrounding elements
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
extern struct globus_xsd_type_info_s wsrp_InvalidResourcePropertyQNameFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType_array.h"

/**
 * @defgroup wsrp_InvalidResourcePropertyQNameFaultType Complex type: wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup types
 */

/**
 * C structure for the wsrp_InvalidResourcePropertyQNameFaultType complex type
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 */
struct wsrp_InvalidResourcePropertyQNameFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 *
 * Allocates a new wsrp_InvalidResourcePropertyQNameFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_InvalidResourcePropertyQNameFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_init(
    wsrp_InvalidResourcePropertyQNameFaultType ** inst);

/**
 * Destroy a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 *
 * Frees a wsrp_InvalidResourcePropertyQNameFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_InvalidResourcePropertyQNameFaultType_destroy(
    wsrp_InvalidResourcePropertyQNameFaultType * inst);

/**
 * Copy a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 *
 * Perform a deep copy of a wsrp_InvalidResourcePropertyQNameFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_InvalidResourcePropertyQNameFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_InvalidResourcePropertyQNameFaultType to be copied.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_copy(
    wsrp_InvalidResourcePropertyQNameFaultType ** dest,
    const wsrp_InvalidResourcePropertyQNameFaultType * src);

/**
 * Initialize the contents of a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 *
 * Initialize the contents of a wsrp_InvalidResourcePropertyQNameFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_InvalidResourcePropertyQNameFaultType_init(). The contents may be freed
 * by calling wsrp_InvalidResourcePropertyQNameFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_InvalidResourcePropertyQNameFaultType.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_init_contents(
    wsrp_InvalidResourcePropertyQNameFaultType * instance);

/**
 * Destroy the contents of a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 *
 * Destroy the subelements and attributes of the given wsrp_InvalidResourcePropertyQNameFaultType. 
 *
 * @param inst
 *     Pointer to a wsrp_InvalidResourcePropertyQNameFaultType instance to destroy.
 */
void
wsrp_InvalidResourcePropertyQNameFaultType_destroy_contents(
    wsrp_InvalidResourcePropertyQNameFaultType * inst);

/**
 * Copy the contents of a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 *
 * Perform a deep copy of the contents of a wsrp_InvalidResourcePropertyQNameFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_InvalidResourcePropertyQNameFaultType to be copied.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_copy_contents(
    wsrp_InvalidResourcePropertyQNameFaultType * dest,
    const wsrp_InvalidResourcePropertyQNameFaultType * src);

/**
 * Serialize a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType_array
 * Serialize a wsrp_InvalidResourcePropertyQNameFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_InvalidResourcePropertyQNameFaultType.
 * @param val
 *     The wsrp_InvalidResourcePropertyQNameFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_serialize(
    xsd_QName *                         element_name,
    wsrp_InvalidResourcePropertyQNameFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType_array
 * Serialize a wsrp_InvalidResourcePropertyQNameFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_InvalidResourcePropertyQNameFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_InvalidResourcePropertyQNameFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 * Deserialize an element containing a wsrp_InvalidResourcePropertyQNameFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_InvalidResourcePropertyQNameFaultType.
 * @param val
 *     Pointer to the wsrp_InvalidResourcePropertyQNameFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_deserialize(
    xsd_QName *                         element_name,
    wsrp_InvalidResourcePropertyQNameFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 * Deserialize a wsrp_InvalidResourcePropertyQNameFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_InvalidResourcePropertyQNameFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_InvalidResourcePropertyQNameFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_InvalidResourcePropertyQNameFaultType
 * @ingroup wsrp_InvalidResourcePropertyQNameFaultType
 * Deserialize the next element if it contains a wsrp_InvalidResourcePropertyQNameFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_InvalidResourcePropertyQNameFaultType.
 * @param instance
 *     Pointer to the <code>wsrp_InvalidResourcePropertyQNameFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_InvalidResourcePropertyQNameFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_init_wrapper(
    void **                             object);
    
void
wsrp_InvalidResourcePropertyQNameFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_InvalidResourcePropertyQNameFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_InvalidResourcePropertyQNameFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
