/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_SETRESOURCEPROPERTIESTYPE_CHOICE_H_
#define _WSRP_SETRESOURCEPROPERTIESTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum wsrp_SetResourcePropertiesType_e
{
    wsrp_SetResourcePropertiesType_undefined,
    wsrp_SetResourcePropertiesType_Insert,
    wsrp_SetResourcePropertiesType_Update,
    wsrp_SetResourcePropertiesType_Delete

};

/**
 * @defgroup wsrp_SetResourcePropertiesType_choice Complex choice type: wsrp_SetResourcePropertiesType
 * @ingroup wsrp_SetResourcePropertiesType
 */

/**
 * Enumeration of the types of values which the wsrp_SetResourcePropertiesType_choice
 * structure may take on.
 * @ingroup wsrp_SetResourcePropertiesType_choice
 */
typedef enum wsrp_SetResourcePropertiesType_e wsrp_SetResourcePropertiesType_enum;
/**
 * Union of the values which the wsrp_SetResourcePropertiesType_choice structure
 * contains
 * @ingroup wsrp_SetResourcePropertiesType_choice
 */
typedef union wsrp_SetResourcePropertiesType_u wsrp_SetResourcePropertiesType_union;
/**
 * The wsrp_SetResourcePropertiesType complex type, which represents the various values
 * possible by the choice used by the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}choice 27 element.
 * @ingroup wsrp_SetResourcePropertiesType_choice
 */
typedef struct wsrp_SetResourcePropertiesType_choice_s wsrp_SetResourcePropertiesType_choice;
/**
 * The wsrp_SetResourcePropertiesType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}choice 27 element.
 * @ingroup wsrp_SetResourcePropertiesType
 */
typedef wsrp_SetResourcePropertiesType_choice * wsrp_SetResourcePropertiesType_choice_o;

typedef struct wsrp_SetResourcePropertiesType_choice_array_s
{
    wsrp_SetResourcePropertiesType_choice * elements;
    int                                 length;
} wsrp_SetResourcePropertiesType_choice_array;

#define WSRP_SETRESOURCEPROPERTIESTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
#define WSRP_SETRESOURCEPROPERTIESTYPE_LOCAL "SetResourcePropertiesType"

extern xsd_QName wsrp_SetResourcePropertiesType_choice_qname;
extern struct globus_xsd_type_info_s wsrp_SetResourcePropertiesType_choice_info;
extern struct globus_xsd_type_info_s wsrp_SetResourcePropertiesType_choice_contents_info;
extern struct globus_xsd_type_info_s wsrp_SetResourcePropertiesType_choice_array_info;


#include "wsrp_InsertType.h"
#include "wsrp_UpdateType.h"
#include "wsrp_DeleteType.h"

union wsrp_SetResourcePropertiesType_u
{
    /** wsrp_InsertType subelement */
    wsrp_InsertType Insert;
    /** wsrp_UpdateType subelement */
    wsrp_UpdateType Update;
    /** wsrp_DeleteType subelement */
    wsrp_DeleteType Delete;

};

struct wsrp_SetResourcePropertiesType_choice_s
{
    wsrp_SetResourcePropertiesType_enum type;
    wsrp_SetResourcePropertiesType_union value;
};

globus_result_t
wsrp_SetResourcePropertiesType_choice_init(
    wsrp_SetResourcePropertiesType_choice ** inst);

void
wsrp_SetResourcePropertiesType_choice_destroy(
    wsrp_SetResourcePropertiesType_choice * inst);

globus_result_t
wsrp_SetResourcePropertiesType_choice_copy(
    wsrp_SetResourcePropertiesType_choice ** dest,
    const wsrp_SetResourcePropertiesType_choice * src);

globus_result_t
wsrp_SetResourcePropertiesType_choice_init_contents(
    wsrp_SetResourcePropertiesType_choice * instance);

void
wsrp_SetResourcePropertiesType_choice_destroy_contents(
    wsrp_SetResourcePropertiesType_choice * inst);

globus_result_t
wsrp_SetResourcePropertiesType_choice_copy_contents(
    wsrp_SetResourcePropertiesType_choice * dest,
    const wsrp_SetResourcePropertiesType_choice * src);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_array_init(
    wsrp_SetResourcePropertiesType_choice_array ** inst);

void
wsrp_SetResourcePropertiesType_choice_array_destroy(
    wsrp_SetResourcePropertiesType_choice_array * inst);

globus_result_t
wsrp_SetResourcePropertiesType_choice_array_copy(
    wsrp_SetResourcePropertiesType_choice_array ** dest,
    const wsrp_SetResourcePropertiesType_choice_array * src);

globus_result_t
wsrp_SetResourcePropertiesType_choice_array_init_contents(
    wsrp_SetResourcePropertiesType_choice_array * inst);

void
wsrp_SetResourcePropertiesType_choice_array_destroy_contents(
    wsrp_SetResourcePropertiesType_choice_array * inst);

globus_result_t
wsrp_SetResourcePropertiesType_choice_array_copy_contents(
    wsrp_SetResourcePropertiesType_choice_array * dest,
    const wsrp_SetResourcePropertiesType_choice_array * src);

wsrp_SetResourcePropertiesType_choice *
wsrp_SetResourcePropertiesType_choice_array_push(
    wsrp_SetResourcePropertiesType_choice_array * array);

globus_result_t
wsrp_SetResourcePropertiesType_choice_serialize(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertiesType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_SetResourcePropertiesType_choice_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertiesType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_SetResourcePropertiesType_choice_deserialize(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertiesType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_SetResourcePropertiesType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertiesType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_SetResourcePropertiesType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertiesType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_SetResourcePropertiesType_choice_array_serialize(
    xsd_QName *                         element,
    wsrp_SetResourcePropertiesType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_SetResourcePropertiesType_choice_array_deserialize(
    xsd_QName *                         element,
    wsrp_SetResourcePropertiesType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_SetResourcePropertiesType_choice_init_wrapper(
    void **                             object);
    
void
wsrp_SetResourcePropertiesType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_SetResourcePropertiesType_choice_init_contents_wrapper(
    void *                              object);
    
void
wsrp_SetResourcePropertiesType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_SetResourcePropertiesType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_array_init_wrapper(
    void **                             arr);
    
void
wsrp_SetResourcePropertiesType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsrp_SetResourcePropertiesType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
wsrp_SetResourcePropertiesType_choice_array_init_contents_wrapper(
    void *                              arr);

void
wsrp_SetResourcePropertiesType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
wsrp_SetResourcePropertiesType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
wsrp_SetResourcePropertiesType_choice_array_push_wrapper(
    void * array);

globus_result_t
wsrp_SetResourcePropertiesType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
