/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_SETRESOURCEPROPERTYREQUESTFAILEDFAULTTYPE_H_
#define _WSRP_SETRESOURCEPROPERTYREQUESTFAILEDFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_SetResourcePropertyRequestFailedFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}SetResourcePropertyRequestFailedFaultType element.
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
typedef struct wsrp_SetResourcePropertyRequestFailedFaultType_s wsrp_SetResourcePropertyRequestFailedFaultType;
/**
 * The wsrp_SetResourcePropertyRequestFailedFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}SetResourcePropertyRequestFailedFaultType element.
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
typedef wsrp_SetResourcePropertyRequestFailedFaultType * wsrp_SetResourcePropertyRequestFailedFaultType_o;

/**
 * Namespace of the wsrp_SetResourcePropertyRequestFailedFaultType complex type
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
#define WSRP_SETRESOURCEPROPERTYREQUESTFAILEDFAULTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_SetResourcePropertyRequestFailedFaultType complex type
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
#define WSRP_SETRESOURCEPROPERTYREQUESTFAILEDFAULTTYPE_LOCAL "SetResourcePropertyRequestFailedFaultType"

/**
 * QName of the wsrp_SetResourcePropertyRequestFailedFaultType complex type
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
extern xsd_QName wsrp_SetResourcePropertyRequestFailedFaultType_qname;
/**
 * Type information for serializing and deserializing wsrp_SetResourcePropertyRequestFailedFaultType elements
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
extern struct globus_xsd_type_info_s wsrp_SetResourcePropertyRequestFailedFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_SetResourcePropertyRequestFailedFaultType
 * elements
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
extern struct globus_xsd_type_info_s wsrp_SetResourcePropertyRequestFailedFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_SetResourcePropertyRequestFailedFaultType without surrounding elements
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
extern struct globus_xsd_type_info_s wsrp_SetResourcePropertyRequestFailedFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsrp_SetResourcePropertyRequestFailedFaultType_array.h"

/**
 * @defgroup wsrp_SetResourcePropertyRequestFailedFaultType Complex type: wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup types
 */

/**
 * C structure for the wsrp_SetResourcePropertyRequestFailedFaultType complex type
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 */
struct wsrp_SetResourcePropertyRequestFailedFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 *
 * Allocates a new wsrp_SetResourcePropertyRequestFailedFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_SetResourcePropertyRequestFailedFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_init(
    wsrp_SetResourcePropertyRequestFailedFaultType ** inst);

/**
 * Destroy a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 *
 * Frees a wsrp_SetResourcePropertyRequestFailedFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_SetResourcePropertyRequestFailedFaultType_destroy(
    wsrp_SetResourcePropertyRequestFailedFaultType * inst);

/**
 * Copy a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 *
 * Perform a deep copy of a wsrp_SetResourcePropertyRequestFailedFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_SetResourcePropertyRequestFailedFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_SetResourcePropertyRequestFailedFaultType to be copied.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_copy(
    wsrp_SetResourcePropertyRequestFailedFaultType ** dest,
    const wsrp_SetResourcePropertyRequestFailedFaultType * src);

/**
 * Initialize the contents of a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 *
 * Initialize the contents of a wsrp_SetResourcePropertyRequestFailedFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_SetResourcePropertyRequestFailedFaultType_init(). The contents may be freed
 * by calling wsrp_SetResourcePropertyRequestFailedFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_SetResourcePropertyRequestFailedFaultType.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_init_contents(
    wsrp_SetResourcePropertyRequestFailedFaultType * instance);

/**
 * Destroy the contents of a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 *
 * Destroy the subelements and attributes of the given wsrp_SetResourcePropertyRequestFailedFaultType. 
 *
 * @param inst
 *     Pointer to a wsrp_SetResourcePropertyRequestFailedFaultType instance to destroy.
 */
void
wsrp_SetResourcePropertyRequestFailedFaultType_destroy_contents(
    wsrp_SetResourcePropertyRequestFailedFaultType * inst);

/**
 * Copy the contents of a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 *
 * Perform a deep copy of the contents of a wsrp_SetResourcePropertyRequestFailedFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_SetResourcePropertyRequestFailedFaultType to be copied.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_copy_contents(
    wsrp_SetResourcePropertyRequestFailedFaultType * dest,
    const wsrp_SetResourcePropertyRequestFailedFaultType * src);

/**
 * Serialize a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType_array
 * Serialize a wsrp_SetResourcePropertyRequestFailedFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_SetResourcePropertyRequestFailedFaultType.
 * @param val
 *     The wsrp_SetResourcePropertyRequestFailedFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_serialize(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertyRequestFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType_array
 * Serialize a wsrp_SetResourcePropertyRequestFailedFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_SetResourcePropertyRequestFailedFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertyRequestFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 * Deserialize an element containing a wsrp_SetResourcePropertyRequestFailedFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_SetResourcePropertyRequestFailedFaultType.
 * @param val
 *     Pointer to the wsrp_SetResourcePropertyRequestFailedFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_deserialize(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertyRequestFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 * Deserialize a wsrp_SetResourcePropertyRequestFailedFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_SetResourcePropertyRequestFailedFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertyRequestFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_SetResourcePropertyRequestFailedFaultType
 * @ingroup wsrp_SetResourcePropertyRequestFailedFaultType
 * Deserialize the next element if it contains a wsrp_SetResourcePropertyRequestFailedFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_SetResourcePropertyRequestFailedFaultType.
 * @param instance
 *     Pointer to the <code>wsrp_SetResourcePropertyRequestFailedFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_SetResourcePropertyRequestFailedFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_init_wrapper(
    void **                             object);
    
void
wsrp_SetResourcePropertyRequestFailedFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_SetResourcePropertyRequestFailedFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_SetResourcePropertyRequestFailedFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
