/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_UPDATETYPE_H_
#define _WSRP_UPDATETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_UpdateType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}UpdateType element.
 * @ingroup wsrp_UpdateType
 */
typedef struct wsrp_UpdateType_s wsrp_UpdateType;
/**
 * The wsrp_UpdateType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}UpdateType element.
 * @ingroup wsrp_UpdateType
 */
typedef wsrp_UpdateType * wsrp_UpdateType_o;

/**
 * Namespace of the wsrp_UpdateType complex type
 * @ingroup wsrp_UpdateType
 */
#define WSRP_UPDATETYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_UpdateType complex type
 * @ingroup wsrp_UpdateType
 */
#define WSRP_UPDATETYPE_LOCAL "UpdateType"

/**
 * QName of the wsrp_UpdateType complex type
 * @ingroup wsrp_UpdateType
 */
extern xsd_QName wsrp_UpdateType_qname;
/**
 * Type information for serializing and deserializing wsrp_UpdateType elements
 * @ingroup wsrp_UpdateType
 */
extern struct globus_xsd_type_info_s wsrp_UpdateType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_UpdateType
 * elements
 * @ingroup wsrp_UpdateType
 */
extern struct globus_xsd_type_info_s wsrp_UpdateType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_UpdateType without surrounding elements
 * @ingroup wsrp_UpdateType
 */
extern struct globus_xsd_type_info_s wsrp_UpdateType_contents_info;


#include "xsd_any.h"
#include "wsrp_UpdateType_array.h"

/**
 * @defgroup wsrp_UpdateType Complex type: wsrp_UpdateType
 * @ingroup types
 */

/**
 * C structure for the wsrp_UpdateType complex type
 * @ingroup wsrp_UpdateType
 */
struct wsrp_UpdateType_s
{
   /** Array of [1 .. Infinity] xsd_any elements */
    xsd_any_array any;

};

/**
 * Initialize a wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 *
 * Allocates a new wsrp_UpdateType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_UpdateType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_UpdateType_init(
    wsrp_UpdateType ** inst);

/**
 * Destroy a wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 *
 * Frees a wsrp_UpdateType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_UpdateType_destroy(
    wsrp_UpdateType * inst);

/**
 * Copy a wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 *
 * Perform a deep copy of a wsrp_UpdateType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_UpdateType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_UpdateType to be copied.
 */
globus_result_t
wsrp_UpdateType_copy(
    wsrp_UpdateType ** dest,
    const wsrp_UpdateType * src);

/**
 * Initialize the contents of a wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 *
 * Initialize the contents of a wsrp_UpdateType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_UpdateType_init(). The contents may be freed
 * by calling wsrp_UpdateType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_UpdateType.
 */
globus_result_t
wsrp_UpdateType_init_contents(
    wsrp_UpdateType * instance);

/**
 * Destroy the contents of a wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 *
 * Destroy the subelements and attributes of the given wsrp_UpdateType. 
 *
 * @param inst
 *     Pointer to a wsrp_UpdateType instance to destroy.
 */
void
wsrp_UpdateType_destroy_contents(
    wsrp_UpdateType * inst);

/**
 * Copy the contents of a wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 *
 * Perform a deep copy of the contents of a wsrp_UpdateType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_UpdateType to be copied.
 */
globus_result_t
wsrp_UpdateType_copy_contents(
    wsrp_UpdateType * dest,
    const wsrp_UpdateType * src);

/**
 * Serialize a wsrp_UpdateType
 * @ingroup wsrp_UpdateType_array
 * Serialize a wsrp_UpdateType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_UpdateType.
 * @param val
 *     The wsrp_UpdateType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_UpdateType_serialize(
    xsd_QName *                         element_name,
    wsrp_UpdateType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_UpdateType
 * @ingroup wsrp_UpdateType_array
 * Serialize a wsrp_UpdateType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_UpdateType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_UpdateType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_UpdateType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 * Deserialize an element containing a wsrp_UpdateType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_UpdateType.
 * @param val
 *     Pointer to the wsrp_UpdateType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_UpdateType_deserialize(
    xsd_QName *                         element_name,
    wsrp_UpdateType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 * Deserialize a wsrp_UpdateType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_UpdateType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_UpdateType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_UpdateType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_UpdateType
 * @ingroup wsrp_UpdateType
 * Deserialize the next element if it contains a wsrp_UpdateType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_UpdateType.
 * @param instance
 *     Pointer to the <code>wsrp_UpdateType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_UpdateType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_UpdateType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_UpdateType_init_wrapper(
    void **                             object);
    
void
wsrp_UpdateType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_UpdateType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_UpdateType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_UpdateType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_UpdateType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_UpdateType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_UpdateType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_UpdateType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_UpdateType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
