/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_BINARYSECURITYTOKENTYPE_H_
#define _WSSE_BINARYSECURITYTOKENTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_BinarySecurityTokenType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}BinarySecurityTokenType element.
 * @ingroup wsse_BinarySecurityTokenType
 */
typedef struct wsse_BinarySecurityTokenType_s wsse_BinarySecurityTokenType;
/**
 * The wsse_BinarySecurityTokenType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}BinarySecurityTokenType element.
 * @ingroup wsse_BinarySecurityTokenType
 */
typedef wsse_BinarySecurityTokenType * wsse_BinarySecurityTokenType_o;

/**
 * Namespace of the wsse_BinarySecurityTokenType complex type
 * @ingroup wsse_BinarySecurityTokenType
 */
#define WSSE_BINARYSECURITYTOKENTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_BinarySecurityTokenType complex type
 * @ingroup wsse_BinarySecurityTokenType
 */
#define WSSE_BINARYSECURITYTOKENTYPE_LOCAL "BinarySecurityTokenType"

/**
 * QName of the wsse_BinarySecurityTokenType complex type
 * @ingroup wsse_BinarySecurityTokenType
 */
extern xsd_QName wsse_BinarySecurityTokenType_qname;
/**
 * Type information for serializing and deserializing wsse_BinarySecurityTokenType elements
 * @ingroup wsse_BinarySecurityTokenType
 */
extern struct globus_xsd_type_info_s wsse_BinarySecurityTokenType_info;
/**
 * Type information for serializing and deserializing arrays of wsse_BinarySecurityTokenType
 * elements
 * @ingroup wsse_BinarySecurityTokenType
 */
extern struct globus_xsd_type_info_s wsse_BinarySecurityTokenType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_BinarySecurityTokenType without surrounding elements
 * @ingroup wsse_BinarySecurityTokenType
 */
extern struct globus_xsd_type_info_s wsse_BinarySecurityTokenType_contents_info;


#include "xsd_string.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "xsd_anyURI.h"
#include "xsd_anyURI.h"
#include "wsse_BinarySecurityTokenType_array.h"

/**
 * @defgroup wsse_BinarySecurityTokenType Complex type: wsse_BinarySecurityTokenType
 * @ingroup types
 */

/**
 * C structure for the wsse_BinarySecurityTokenType complex type
 * @ingroup wsse_BinarySecurityTokenType
 */
struct wsse_BinarySecurityTokenType_s
{
    /** xsd_string subelement */
    xsd_string base_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;
    xsd_anyURI_o _EncodingType;
    xsd_anyURI_o _ValueType;

};

/**
 * Initialize a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 *
 * Allocates a new wsse_BinarySecurityTokenType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_BinarySecurityTokenType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_BinarySecurityTokenType_init(
    wsse_BinarySecurityTokenType ** inst);

/**
 * Destroy a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 *
 * Frees a wsse_BinarySecurityTokenType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_BinarySecurityTokenType_destroy(
    wsse_BinarySecurityTokenType * inst);

/**
 * Copy a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 *
 * Perform a deep copy of a wsse_BinarySecurityTokenType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_BinarySecurityTokenType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_BinarySecurityTokenType to be copied.
 */
globus_result_t
wsse_BinarySecurityTokenType_copy(
    wsse_BinarySecurityTokenType ** dest,
    const wsse_BinarySecurityTokenType * src);

/**
 * Initialize the contents of a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 *
 * Initialize the contents of a wsse_BinarySecurityTokenType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_BinarySecurityTokenType_init(). The contents may be freed
 * by calling wsse_BinarySecurityTokenType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_BinarySecurityTokenType.
 */
globus_result_t
wsse_BinarySecurityTokenType_init_contents(
    wsse_BinarySecurityTokenType * instance);

/**
 * Destroy the contents of a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 *
 * Destroy the subelements and attributes of the given wsse_BinarySecurityTokenType. 
 *
 * @param inst
 *     Pointer to a wsse_BinarySecurityTokenType instance to destroy.
 */
void
wsse_BinarySecurityTokenType_destroy_contents(
    wsse_BinarySecurityTokenType * inst);

/**
 * Copy the contents of a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 *
 * Perform a deep copy of the contents of a wsse_BinarySecurityTokenType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_BinarySecurityTokenType to be copied.
 */
globus_result_t
wsse_BinarySecurityTokenType_copy_contents(
    wsse_BinarySecurityTokenType * dest,
    const wsse_BinarySecurityTokenType * src);

/**
 * Serialize a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType_array
 * Serialize a wsse_BinarySecurityTokenType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_BinarySecurityTokenType.
 * @param val
 *     The wsse_BinarySecurityTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_BinarySecurityTokenType_serialize(
    xsd_QName *                         element_name,
    wsse_BinarySecurityTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType_array
 * Serialize a wsse_BinarySecurityTokenType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_BinarySecurityTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_BinarySecurityTokenType_serialize_contents(
    xsd_QName *                         element_name,
    wsse_BinarySecurityTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 * Deserialize an element containing a wsse_BinarySecurityTokenType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_BinarySecurityTokenType.
 * @param val
 *     Pointer to the wsse_BinarySecurityTokenType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_BinarySecurityTokenType_deserialize(
    xsd_QName *                         element_name,
    wsse_BinarySecurityTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 * Deserialize a wsse_BinarySecurityTokenType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_BinarySecurityTokenType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_BinarySecurityTokenType_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_BinarySecurityTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_BinarySecurityTokenType
 * @ingroup wsse_BinarySecurityTokenType
 * Deserialize the next element if it contains a wsse_BinarySecurityTokenType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_BinarySecurityTokenType.
 * @param instance
 *     Pointer to the <code>wsse_BinarySecurityTokenType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_BinarySecurityTokenType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_BinarySecurityTokenType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_BinarySecurityTokenType_init_wrapper(
    void **                             object);
    
void
wsse_BinarySecurityTokenType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_BinarySecurityTokenType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_BinarySecurityTokenType_init_contents_wrapper(
    void *                              object);
    
void
wsse_BinarySecurityTokenType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_BinarySecurityTokenType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_BinarySecurityTokenType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_BinarySecurityTokenType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_BinarySecurityTokenType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_BinarySecurityTokenType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
