/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_EMBEDDEDTYPE_CHOICE_H_
#define _WSSE_EMBEDDEDTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum wsse_EmbeddedType_e
{
    wsse_EmbeddedType_undefined,
    wsse_EmbeddedType_any

};

/**
 * @defgroup wsse_EmbeddedType_choice Complex choice type: wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 */

/**
 * Enumeration of the types of values which the wsse_EmbeddedType_choice
 * structure may take on.
 * @ingroup wsse_EmbeddedType_choice
 */
typedef enum wsse_EmbeddedType_e wsse_EmbeddedType_enum;
/**
 * Union of the values which the wsse_EmbeddedType_choice structure
 * contains
 * @ingroup wsse_EmbeddedType_choice
 */
typedef union wsse_EmbeddedType_u wsse_EmbeddedType_union;
/**
 * The wsse_EmbeddedType complex type, which represents the various values
 * possible by the choice used by the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}choice 16 element.
 * @ingroup wsse_EmbeddedType_choice
 */
typedef struct wsse_EmbeddedType_choice_s wsse_EmbeddedType_choice;
/**
 * The wsse_EmbeddedType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}choice 16 element.
 * @ingroup wsse_EmbeddedType
 */
typedef wsse_EmbeddedType_choice * wsse_EmbeddedType_choice_o;

typedef struct wsse_EmbeddedType_choice_array_s
{
    wsse_EmbeddedType_choice * elements;
    int                                 length;
} wsse_EmbeddedType_choice_array;

#define WSSE_EMBEDDEDTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
#define WSSE_EMBEDDEDTYPE_LOCAL "EmbeddedType"

extern xsd_QName wsse_EmbeddedType_choice_qname;
extern struct globus_xsd_type_info_s wsse_EmbeddedType_choice_info;
extern struct globus_xsd_type_info_s wsse_EmbeddedType_choice_contents_info;
extern struct globus_xsd_type_info_s wsse_EmbeddedType_choice_array_info;


#include "xsd_any.h"

union wsse_EmbeddedType_u
{
    /** xsd_any subelement */
    xsd_any any;

};

struct wsse_EmbeddedType_choice_s
{
    wsse_EmbeddedType_enum type;
    wsse_EmbeddedType_union value;
};

globus_result_t
wsse_EmbeddedType_choice_init(
    wsse_EmbeddedType_choice ** inst);

void
wsse_EmbeddedType_choice_destroy(
    wsse_EmbeddedType_choice * inst);

globus_result_t
wsse_EmbeddedType_choice_copy(
    wsse_EmbeddedType_choice ** dest,
    const wsse_EmbeddedType_choice * src);

globus_result_t
wsse_EmbeddedType_choice_init_contents(
    wsse_EmbeddedType_choice * instance);

void
wsse_EmbeddedType_choice_destroy_contents(
    wsse_EmbeddedType_choice * inst);

globus_result_t
wsse_EmbeddedType_choice_copy_contents(
    wsse_EmbeddedType_choice * dest,
    const wsse_EmbeddedType_choice * src);
    
globus_result_t
wsse_EmbeddedType_choice_array_init(
    wsse_EmbeddedType_choice_array ** inst);

void
wsse_EmbeddedType_choice_array_destroy(
    wsse_EmbeddedType_choice_array * inst);

globus_result_t
wsse_EmbeddedType_choice_array_copy(
    wsse_EmbeddedType_choice_array ** dest,
    const wsse_EmbeddedType_choice_array * src);

globus_result_t
wsse_EmbeddedType_choice_array_init_contents(
    wsse_EmbeddedType_choice_array * inst);

void
wsse_EmbeddedType_choice_array_destroy_contents(
    wsse_EmbeddedType_choice_array * inst);

globus_result_t
wsse_EmbeddedType_choice_array_copy_contents(
    wsse_EmbeddedType_choice_array * dest,
    const wsse_EmbeddedType_choice_array * src);

wsse_EmbeddedType_choice *
wsse_EmbeddedType_choice_array_push(
    wsse_EmbeddedType_choice_array * array);

globus_result_t
wsse_EmbeddedType_choice_serialize(
    xsd_QName *                         element_name,
    wsse_EmbeddedType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EmbeddedType_choice_serialize_contents(
    xsd_QName *                         element_name,
    wsse_EmbeddedType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EmbeddedType_choice_deserialize(
    xsd_QName *                         element_name,
    wsse_EmbeddedType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EmbeddedType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_EmbeddedType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EmbeddedType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_EmbeddedType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EmbeddedType_choice_array_serialize(
    xsd_QName *                         element,
    wsse_EmbeddedType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EmbeddedType_choice_array_deserialize(
    xsd_QName *                         element,
    wsse_EmbeddedType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EmbeddedType_choice_init_wrapper(
    void **                             object);
    
void
wsse_EmbeddedType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_EmbeddedType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_EmbeddedType_choice_init_contents_wrapper(
    void *                              object);
    
void
wsse_EmbeddedType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_EmbeddedType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_EmbeddedType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EmbeddedType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EmbeddedType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EmbeddedType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EmbeddedType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EmbeddedType_choice_array_init_wrapper(
    void **                             arr);
    
void
wsse_EmbeddedType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsse_EmbeddedType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
wsse_EmbeddedType_choice_array_init_contents_wrapper(
    void *                              arr);

void
wsse_EmbeddedType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
wsse_EmbeddedType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
wsse_EmbeddedType_choice_array_push_wrapper(
    void * array);

globus_result_t
wsse_EmbeddedType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
