/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_SECURITYHEADERTYPE_H_
#define _WSSE_SECURITYHEADERTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_SecurityHeaderType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}SecurityHeaderType element.
 * @ingroup wsse_SecurityHeaderType
 */
typedef struct wsse_SecurityHeaderType_s wsse_SecurityHeaderType;
/**
 * The wsse_SecurityHeaderType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}SecurityHeaderType element.
 * @ingroup wsse_SecurityHeaderType
 */
typedef wsse_SecurityHeaderType * wsse_SecurityHeaderType_o;

/**
 * Namespace of the wsse_SecurityHeaderType complex type
 * @ingroup wsse_SecurityHeaderType
 */
#define WSSE_SECURITYHEADERTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_SecurityHeaderType complex type
 * @ingroup wsse_SecurityHeaderType
 */
#define WSSE_SECURITYHEADERTYPE_LOCAL "SecurityHeaderType"

/**
 * QName of the wsse_SecurityHeaderType complex type
 * @ingroup wsse_SecurityHeaderType
 */
extern xsd_QName wsse_SecurityHeaderType_qname;
/**
 * Type information for serializing and deserializing wsse_SecurityHeaderType elements
 * @ingroup wsse_SecurityHeaderType
 */
extern struct globus_xsd_type_info_s wsse_SecurityHeaderType_info;
/**
 * Type information for serializing and deserializing arrays of wsse_SecurityHeaderType
 * elements
 * @ingroup wsse_SecurityHeaderType
 */
extern struct globus_xsd_type_info_s wsse_SecurityHeaderType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_SecurityHeaderType without surrounding elements
 * @ingroup wsse_SecurityHeaderType
 */
extern struct globus_xsd_type_info_s wsse_SecurityHeaderType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "wsse_SecurityHeaderType_array.h"

/**
 * @defgroup wsse_SecurityHeaderType Complex type: wsse_SecurityHeaderType
 * @ingroup types
 */

/**
 * C structure for the wsse_SecurityHeaderType complex type
 * @ingroup wsse_SecurityHeaderType
 */
struct wsse_SecurityHeaderType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 *
 * Allocates a new wsse_SecurityHeaderType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_SecurityHeaderType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_SecurityHeaderType_init(
    wsse_SecurityHeaderType ** inst);

/**
 * Destroy a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 *
 * Frees a wsse_SecurityHeaderType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_SecurityHeaderType_destroy(
    wsse_SecurityHeaderType * inst);

/**
 * Copy a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 *
 * Perform a deep copy of a wsse_SecurityHeaderType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_SecurityHeaderType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_SecurityHeaderType to be copied.
 */
globus_result_t
wsse_SecurityHeaderType_copy(
    wsse_SecurityHeaderType ** dest,
    const wsse_SecurityHeaderType * src);

/**
 * Initialize the contents of a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 *
 * Initialize the contents of a wsse_SecurityHeaderType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_SecurityHeaderType_init(). The contents may be freed
 * by calling wsse_SecurityHeaderType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_SecurityHeaderType.
 */
globus_result_t
wsse_SecurityHeaderType_init_contents(
    wsse_SecurityHeaderType * instance);

/**
 * Destroy the contents of a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 *
 * Destroy the subelements and attributes of the given wsse_SecurityHeaderType. 
 *
 * @param inst
 *     Pointer to a wsse_SecurityHeaderType instance to destroy.
 */
void
wsse_SecurityHeaderType_destroy_contents(
    wsse_SecurityHeaderType * inst);

/**
 * Copy the contents of a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 *
 * Perform a deep copy of the contents of a wsse_SecurityHeaderType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_SecurityHeaderType to be copied.
 */
globus_result_t
wsse_SecurityHeaderType_copy_contents(
    wsse_SecurityHeaderType * dest,
    const wsse_SecurityHeaderType * src);

/**
 * Serialize a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType_array
 * Serialize a wsse_SecurityHeaderType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_SecurityHeaderType.
 * @param val
 *     The wsse_SecurityHeaderType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_SecurityHeaderType_serialize(
    xsd_QName *                         element_name,
    wsse_SecurityHeaderType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType_array
 * Serialize a wsse_SecurityHeaderType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_SecurityHeaderType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_SecurityHeaderType_serialize_contents(
    xsd_QName *                         element_name,
    wsse_SecurityHeaderType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 * Deserialize an element containing a wsse_SecurityHeaderType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_SecurityHeaderType.
 * @param val
 *     Pointer to the wsse_SecurityHeaderType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_SecurityHeaderType_deserialize(
    xsd_QName *                         element_name,
    wsse_SecurityHeaderType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 * Deserialize a wsse_SecurityHeaderType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_SecurityHeaderType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_SecurityHeaderType_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_SecurityHeaderType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_SecurityHeaderType
 * @ingroup wsse_SecurityHeaderType
 * Deserialize the next element if it contains a wsse_SecurityHeaderType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_SecurityHeaderType.
 * @param instance
 *     Pointer to the <code>wsse_SecurityHeaderType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_SecurityHeaderType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_SecurityHeaderType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_SecurityHeaderType_init_wrapper(
    void **                             object);
    
void
wsse_SecurityHeaderType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_SecurityHeaderType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_SecurityHeaderType_init_contents_wrapper(
    void *                              object);
    
void
wsse_SecurityHeaderType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_SecurityHeaderType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_SecurityHeaderType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_SecurityHeaderType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_SecurityHeaderType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_SecurityHeaderType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
