/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_SECURITYTOKENREFERENCETYPE_H_
#define _WSSE_SECURITYTOKENREFERENCETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_SecurityTokenReferenceType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}SecurityTokenReferenceType element.
 * @ingroup wsse_SecurityTokenReferenceType
 */
typedef struct wsse_SecurityTokenReferenceType_s wsse_SecurityTokenReferenceType;
/**
 * The wsse_SecurityTokenReferenceType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}SecurityTokenReferenceType element.
 * @ingroup wsse_SecurityTokenReferenceType
 */
typedef wsse_SecurityTokenReferenceType * wsse_SecurityTokenReferenceType_o;

/**
 * Namespace of the wsse_SecurityTokenReferenceType complex type
 * @ingroup wsse_SecurityTokenReferenceType
 */
#define WSSE_SECURITYTOKENREFERENCETYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_SecurityTokenReferenceType complex type
 * @ingroup wsse_SecurityTokenReferenceType
 */
#define WSSE_SECURITYTOKENREFERENCETYPE_LOCAL "SecurityTokenReferenceType"

/**
 * QName of the wsse_SecurityTokenReferenceType complex type
 * @ingroup wsse_SecurityTokenReferenceType
 */
extern xsd_QName wsse_SecurityTokenReferenceType_qname;
/**
 * Type information for serializing and deserializing wsse_SecurityTokenReferenceType elements
 * @ingroup wsse_SecurityTokenReferenceType
 */
extern struct globus_xsd_type_info_s wsse_SecurityTokenReferenceType_info;
/**
 * Type information for serializing and deserializing arrays of wsse_SecurityTokenReferenceType
 * elements
 * @ingroup wsse_SecurityTokenReferenceType
 */
extern struct globus_xsd_type_info_s wsse_SecurityTokenReferenceType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_SecurityTokenReferenceType without surrounding elements
 * @ingroup wsse_SecurityTokenReferenceType
 */
extern struct globus_xsd_type_info_s wsse_SecurityTokenReferenceType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "wsse_tUsage.h"
#include "xsd_ID.h"
#include "wsse_SecurityTokenReferenceType_array.h"

/**
 * @defgroup wsse_SecurityTokenReferenceType Complex type: wsse_SecurityTokenReferenceType
 * @ingroup types
 */

/**
 * C structure for the wsse_SecurityTokenReferenceType complex type
 * @ingroup wsse_SecurityTokenReferenceType
 */
struct wsse_SecurityTokenReferenceType_s
{
    /** xsd_any subelement */
    xsd_any any;
    xsd_anyAttributes_t anyAttributes;
    wsse_tUsage_o _Usage;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 *
 * Allocates a new wsse_SecurityTokenReferenceType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_SecurityTokenReferenceType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_SecurityTokenReferenceType_init(
    wsse_SecurityTokenReferenceType ** inst);

/**
 * Destroy a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 *
 * Frees a wsse_SecurityTokenReferenceType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_SecurityTokenReferenceType_destroy(
    wsse_SecurityTokenReferenceType * inst);

/**
 * Copy a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 *
 * Perform a deep copy of a wsse_SecurityTokenReferenceType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_SecurityTokenReferenceType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_SecurityTokenReferenceType to be copied.
 */
globus_result_t
wsse_SecurityTokenReferenceType_copy(
    wsse_SecurityTokenReferenceType ** dest,
    const wsse_SecurityTokenReferenceType * src);

/**
 * Initialize the contents of a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 *
 * Initialize the contents of a wsse_SecurityTokenReferenceType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_SecurityTokenReferenceType_init(). The contents may be freed
 * by calling wsse_SecurityTokenReferenceType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_SecurityTokenReferenceType.
 */
globus_result_t
wsse_SecurityTokenReferenceType_init_contents(
    wsse_SecurityTokenReferenceType * instance);

/**
 * Destroy the contents of a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 *
 * Destroy the subelements and attributes of the given wsse_SecurityTokenReferenceType. 
 *
 * @param inst
 *     Pointer to a wsse_SecurityTokenReferenceType instance to destroy.
 */
void
wsse_SecurityTokenReferenceType_destroy_contents(
    wsse_SecurityTokenReferenceType * inst);

/**
 * Copy the contents of a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 *
 * Perform a deep copy of the contents of a wsse_SecurityTokenReferenceType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_SecurityTokenReferenceType to be copied.
 */
globus_result_t
wsse_SecurityTokenReferenceType_copy_contents(
    wsse_SecurityTokenReferenceType * dest,
    const wsse_SecurityTokenReferenceType * src);

/**
 * Serialize a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType_array
 * Serialize a wsse_SecurityTokenReferenceType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_SecurityTokenReferenceType.
 * @param val
 *     The wsse_SecurityTokenReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_SecurityTokenReferenceType_serialize(
    xsd_QName *                         element_name,
    wsse_SecurityTokenReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType_array
 * Serialize a wsse_SecurityTokenReferenceType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_SecurityTokenReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_SecurityTokenReferenceType_serialize_contents(
    xsd_QName *                         element_name,
    wsse_SecurityTokenReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 * Deserialize an element containing a wsse_SecurityTokenReferenceType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_SecurityTokenReferenceType.
 * @param val
 *     Pointer to the wsse_SecurityTokenReferenceType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_SecurityTokenReferenceType_deserialize(
    xsd_QName *                         element_name,
    wsse_SecurityTokenReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 * Deserialize a wsse_SecurityTokenReferenceType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_SecurityTokenReferenceType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_SecurityTokenReferenceType_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_SecurityTokenReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_SecurityTokenReferenceType
 * @ingroup wsse_SecurityTokenReferenceType
 * Deserialize the next element if it contains a wsse_SecurityTokenReferenceType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_SecurityTokenReferenceType.
 * @param instance
 *     Pointer to the <code>wsse_SecurityTokenReferenceType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_SecurityTokenReferenceType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_SecurityTokenReferenceType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_SecurityTokenReferenceType_init_wrapper(
    void **                             object);
    
void
wsse_SecurityTokenReferenceType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_SecurityTokenReferenceType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_SecurityTokenReferenceType_init_contents_wrapper(
    void *                              object);
    
void
wsse_SecurityTokenReferenceType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_SecurityTokenReferenceType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_SecurityTokenReferenceType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_SecurityTokenReferenceType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_SecurityTokenReferenceType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_SecurityTokenReferenceType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
