/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDL-to-C Converter
 */

#ifndef _WSSE_TUSAGE_H_
#define _WSSE_TUSAGE_H_

#include "globus_common.h"

/**
 * @defgroup wsse_tUsage Simple Type: wsse_tUsage
 * @ingroup types
 */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */


#include "xsd_anyURI.h"

/**
 * @ingroup wsse_tUsage
 */
typedef xsd_anyURI_array wsse_tUsage;

/**
 * Optional wsse_tUsage element
 * @ingroup wsse_tUsage
 */
typedef wsse_tUsage * wsse_tUsage_o;

/**
 * Array of wsse_tUsage elements
 * @ingroup wsse_tUsage
 *
 * This structure type is used represent an array of
 * wsse_tUsage elements.
 *
 * Arrays are allocated by wsse_tUsage_array_init() and freed by calling
 * wsse_tUsage_array_destroy(). Elements may be added to an array by calling
 * wsse_tUsage_array_push().
 */
typedef struct wsse_tUsage_array_s
{
    /** Dynamic array of elements */
    wsse_tUsage * elements;
    /** Number of elements in this array */
    int                                 length;
} wsse_tUsage_array;

/**
 * Namespace of the wsse_tUsage complex type
 * @ingroup wsse_tUsage
 */
#define WSSE_TUSAGE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_tUsage complex type
 * @ingroup wsse_tUsage
 */
#define WSSE_TUSAGE_LOCAL "tUsage"

/**
 * QName of the wsse_tUsage complex type
 * @ingroup wsse_tUsage
 */
extern xsd_QName wsse_tUsage_qname;
/**
 * Type information for serializing and deserializing wsse_tUsage elements
 * @ingroup wsse_tUsage
 */
extern struct globus_xsd_type_info_s wsse_tUsage_info;
/**
 * Type information for serializing and deserializing arrays of wsse_tUsage
 * elements
 * @ingroup wsse_tUsage
 */
extern struct globus_xsd_type_info_s wsse_tUsage_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_tUsage without surrounding elements
 * @ingroup wsse_tUsage
 */
extern struct globus_xsd_type_info_s wsse_tUsage_contents_info;

/**
 * Initialize a wsse_tUsage
 * @ingroup wsse_tUsage
 *
 * Allocates a new wsse_tUsage and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_tUsage_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_tUsage_init(
    wsse_tUsage ** inst);

/**
 * Destroy a wsse_tUsage
 * @ingroup wsse_tUsage
 *
 * Frees a wsse_tUsage. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_tUsage_destroy(
    wsse_tUsage * inst);

/**
 * Copy a wsse_tUsage
 * @ingroup wsse_tUsage
 *
 * Perform a deep copy of a wsse_tUsage.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_tUsage structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_tUsage to be copied.
 */
globus_result_t
wsse_tUsage_copy(
    wsse_tUsage ** dest,
    const wsse_tUsage * src);

/**
 * Initialize the contents of a wsse_tUsage
 * @ingroup wsse_tUsage
 *
 * Initialize the contents of a wsse_tUsage. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_tUsage_init(). The contents may be freed
 * by calling wsse_tUsage_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_tUsage.
 */
globus_result_t
wsse_tUsage_init_contents(
    wsse_tUsage * instance);

/**
 * Destroy the contents of a wsse_tUsage
 * @ingroup wsse_tUsage
 *
 * Destroy the subelements and attributes of the given wsse_tUsage. 
 *
 * @param inst
 *     Pointer to a wsse_tUsage instance to destroy.
 */
void
wsse_tUsage_destroy_contents(
    wsse_tUsage * inst);

/**
 * Copy the contents of a wsse_tUsage
 * @ingroup wsse_tUsage
 *
 * Perform a deep copy of the contents of a wsse_tUsage.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_tUsage to be copied.
 */
globus_result_t
wsse_tUsage_copy_contents(
    wsse_tUsage * dest,
    const wsse_tUsage * src);

/**
 * Initialize an array of wsse_tUsage elements.
 * @ingroup wsse_tUsage
 *
 * Allocates a new array of 0 elements. When this array is no longer used,
 * it should be freed by calling 
 * wsse_tUsage_array_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated array instance.
 */
globus_result_t
wsse_tUsage_array_init(
    wsse_tUsage_array ** inst);

/**
 * Destroy an array of wsse_tUsage elements.
 * @ingroup wsse_tUsage
 *
 * Frees an array of wsse_tUsage elements. The contents of each element
 * element in the array be destroyed by calling
 * wsse_tUsage_destroy_contents().
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wsse_tUsage_array_destroy(
    wsse_tUsage_array * inst);

/**
 * Copy an array of wsse_tUsage elements
 * @ingroup wsse_tUsage
 *
 * Perform a deep copy of an array of wsse_tUsage elements.
 * The @a dest array will be allocated, and then a copy of the contents
 * of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wsse_tUsage_array_copy(
    wsse_tUsage_array ** dest,
    const wsse_tUsage_array * src);

/**
 * Initialize the contents of an array of wsse_tUsage elements
 * @ingroup wsse_tUsage
 *
 * Initialize the contents of an array of wsse_tUsage elements. Used
 * when the array is allocated on the stack or by a some allocator besides
 * wsse_tUsage_array_init(). The contents of the array may be freed
 * by calling wsse_tUsage_array_destroy_contents().
 *
 * @param inst
 *     Pointer to an allocated but uninitialized array.
 */
globus_result_t
wsse_tUsage_array_init_contents(
    wsse_tUsage_array * inst);

/**
 * Destroy the contents of an array of wsse_tUsage elements
 * @ingroup wsse_tUsage
 *
 * Destroy the elements in an array of wsse_tUsage elements. The contents of
 * each element in the array be destroyed by calling
 * wsse_tUsage_destroy_contents() and the array will be reset to be empty.
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wsse_tUsage_array_destroy_contents(
    wsse_tUsage_array * inst);

/**
 * Copy the contents of an array of wsse_tUsage elements
 * @ingroup wsse_tUsage
 *
 * Perform a deep copy of an array of wsse_tUsage elements.
 * The @a dest array must be allocated before making this call.
 * A copy of the contents of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wsse_tUsage_array_copy_contents(
    wsse_tUsage_array * dest,
    const wsse_tUsage_array * src);

/**
 * Append a new wsse_tUsage to an array
 * @ingroup wsse_tUsage
 *
 * Allocate and initialize a new wsse_tUsage structure, adding it
 * to the end of the given @a array.
 * 
 * @param array
 *     Array to be appended to.
 *
 * @return This function returns the newly allocated element.
 */
wsse_tUsage *
wsse_tUsage_array_push(
    wsse_tUsage_array * array);

/**
 * Serialize a wsse_tUsage
 * @ingroup wsse_tUsage_array
 * Serialize a wsse_tUsage structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_tUsage.
 * @param val
 *     The wsse_tUsage to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_tUsage_serialize(
    xsd_QName *                         element_name,
    wsse_tUsage * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_tUsage
 * @ingroup wsse_tUsage_array
 * Serialize a wsse_tUsage structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_tUsage to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_tUsage_serialize_contents(
    xsd_QName *                         element_name,
    wsse_tUsage * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_tUsage
 * @ingroup wsse_tUsage
 * Deserialize an element containing a wsse_tUsage element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_tUsage.
 * @param val
 *     Pointer to the wsse_tUsage which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_tUsage_deserialize(
    xsd_QName *                         element_name,
    wsse_tUsage * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_tUsage
 * @ingroup wsse_tUsage
 * Deserialize a wsse_tUsage whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_tUsage which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_tUsage_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_tUsage * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_tUsage
 * @ingroup wsse_tUsage
 * Deserialize the next element if it contains a wsse_tUsage.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_tUsage.
 * @param instance
 *     Pointer to the <code>wsse_tUsage *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_tUsage_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_tUsage ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize an array of wsse_tUsage elements
 * @ingroup wsse_tUsage
 * Serialize an element containing an array of wsse_tUsage elements.
 *
 * @param element
 *     The name of the element which will contain the array.
 * @param array_instance
 *     The array to serialize
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_tUsage_array_serialize(
    xsd_QName *                         element,
    wsse_tUsage_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an array of wsse_tUsage elements
 * @ingroup wsse_tUsage
 * Deserialize an element containing an array of wsse_tUsage elements.
 *
 * @param element
 *     The name of the element which should enclose the array.
 * @param array_instance
 *     The array to deserialize into
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_tUsage_array_deserialize(
    xsd_QName *                         element,
    wsse_tUsage_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);



/**
 * Serialize an attribute of type wsse_tUsage
 * @ingroup wsse_tUsage_array
 * Serialize a wsse_tUsage as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsse_tUsage.
 * @param val
 *     The wsse_tUsage to serialize.
 * @param message
 *     The handle to serialize the attribute on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_tUsage_serialize_attribute(
    xsd_QName *                         attr_qname,
    wsse_tUsage * val,
    globus_soap_message_handle_t        handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an attribute of type wsse_tUsage
 * @ingroup wsse_tUsage
 * Deserialize a wsse_tUsage as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsse_tUsage.
 * @param instance
 *     Pointer to the wsse_tUsage which will be initialized with the
 *     value of the attribute.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_tUsage_deserialize_attribute(
    xsd_QName *                         attr_qname,
    wsse_tUsage * instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional attribute of type wsse_tUsage
 * @ingroup wsse_tUsage
 * Try to deserialize a wsse_tUsage as an attribute of the current element
 * if it is present. The attribute's name is defined by @ attr_qname.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsse_tUsage.
 * @param instance
 *     Pointer to the wsse_tUsage which will be allocated and initialized
 *     with the value of the attribute if it is present.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_tUsage_deserialize_attribute_pointer(
    xsd_QName *                         attr_qname,
    wsse_tUsage ** instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);


#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
globus_result_t
wsse_tUsage_init_wrapper(
    void **                             object);
    
void
wsse_tUsage_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_tUsage_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);
    
globus_result_t
wsse_tUsage_init_contents_wrapper(
    void  *                             object);
    
void
wsse_tUsage_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_tUsage_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);
    
globus_result_t
wsse_tUsage_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_tUsage_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_tUsage_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_tUsage_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_tUsage_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_tUsage_array_init_wrapper(
    void **                             arr);
    
void
wsse_tUsage_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsse_tUsage_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);
globus_result_t
wsse_tUsage_array_init_contents_wrapper(
    void *                              arr);
    
void
wsse_tUsage_array_destroy_contents_wrapper(
    void *                              arr);
    
globus_result_t
wsse_tUsage_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);
    
globus_result_t
wsse_tUsage_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

void *
wsse_tUsage_array_push_wrapper(
    void * array);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
