/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSEU_ATTRIBUTEDURI_H_
#define _WSSEU_ATTRIBUTEDURI_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsseu_AttributedURI complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd}AttributedURI element.
 * @ingroup wsseu_AttributedURI
 */
typedef struct wsseu_AttributedURI_s wsseu_AttributedURI;
/**
 * The wsseu_AttributedURI_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd}AttributedURI element.
 * @ingroup wsseu_AttributedURI
 */
typedef wsseu_AttributedURI * wsseu_AttributedURI_o;

/**
 * Namespace of the wsseu_AttributedURI complex type
 * @ingroup wsseu_AttributedURI
 */
#define WSSEU_ATTRIBUTEDURI_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"
/**
 * Local part of the QName of the wsseu_AttributedURI complex type
 * @ingroup wsseu_AttributedURI
 */
#define WSSEU_ATTRIBUTEDURI_LOCAL "AttributedURI"

/**
 * QName of the wsseu_AttributedURI complex type
 * @ingroup wsseu_AttributedURI
 */
extern xsd_QName wsseu_AttributedURI_qname;
/**
 * Type information for serializing and deserializing wsseu_AttributedURI elements
 * @ingroup wsseu_AttributedURI
 */
extern struct globus_xsd_type_info_s wsseu_AttributedURI_info;
/**
 * Type information for serializing and deserializing arrays of wsseu_AttributedURI
 * elements
 * @ingroup wsseu_AttributedURI
 */
extern struct globus_xsd_type_info_s wsseu_AttributedURI_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsseu_AttributedURI without surrounding elements
 * @ingroup wsseu_AttributedURI
 */
extern struct globus_xsd_type_info_s wsseu_AttributedURI_contents_info;


#include "xsd_anyURI.h"
#include "xsd_ID.h"
#include "xsd_anyAttributes.h"
#include "wsseu_AttributedURI_array.h"

/**
 * @defgroup wsseu_AttributedURI Complex type: wsseu_AttributedURI
 * @ingroup types
 */

/**
 * C structure for the wsseu_AttributedURI complex type
 * @ingroup wsseu_AttributedURI
 */
struct wsseu_AttributedURI_s
{
    /** xsd_anyURI subelement */
    xsd_anyURI base_value;
    xsd_ID_o _Id;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 *
 * Allocates a new wsseu_AttributedURI and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsseu_AttributedURI_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsseu_AttributedURI_init(
    wsseu_AttributedURI ** inst);

/**
 * Destroy a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 *
 * Frees a wsseu_AttributedURI. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsseu_AttributedURI_destroy(
    wsseu_AttributedURI * inst);

/**
 * Copy a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 *
 * Perform a deep copy of a wsseu_AttributedURI.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsseu_AttributedURI structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsseu_AttributedURI to be copied.
 */
globus_result_t
wsseu_AttributedURI_copy(
    wsseu_AttributedURI ** dest,
    const wsseu_AttributedURI * src);

/**
 * Initialize the contents of a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 *
 * Initialize the contents of a wsseu_AttributedURI. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsseu_AttributedURI_init(). The contents may be freed
 * by calling wsseu_AttributedURI_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsseu_AttributedURI.
 */
globus_result_t
wsseu_AttributedURI_init_contents(
    wsseu_AttributedURI * instance);

/**
 * Destroy the contents of a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 *
 * Destroy the subelements and attributes of the given wsseu_AttributedURI. 
 *
 * @param inst
 *     Pointer to a wsseu_AttributedURI instance to destroy.
 */
void
wsseu_AttributedURI_destroy_contents(
    wsseu_AttributedURI * inst);

/**
 * Copy the contents of a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 *
 * Perform a deep copy of the contents of a wsseu_AttributedURI.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsseu_AttributedURI to be copied.
 */
globus_result_t
wsseu_AttributedURI_copy_contents(
    wsseu_AttributedURI * dest,
    const wsseu_AttributedURI * src);

/**
 * Serialize a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI_array
 * Serialize a wsseu_AttributedURI structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsseu_AttributedURI.
 * @param val
 *     The wsseu_AttributedURI to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsseu_AttributedURI_serialize(
    xsd_QName *                         element_name,
    wsseu_AttributedURI * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI_array
 * Serialize a wsseu_AttributedURI structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsseu_AttributedURI to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsseu_AttributedURI_serialize_contents(
    xsd_QName *                         element_name,
    wsseu_AttributedURI * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 * Deserialize an element containing a wsseu_AttributedURI element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsseu_AttributedURI.
 * @param val
 *     Pointer to the wsseu_AttributedURI which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsseu_AttributedURI_deserialize(
    xsd_QName *                         element_name,
    wsseu_AttributedURI * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 * Deserialize a wsseu_AttributedURI whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsseu_AttributedURI which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsseu_AttributedURI_deserialize_contents(
    xsd_QName *                         element_name,
    wsseu_AttributedURI * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsseu_AttributedURI
 * @ingroup wsseu_AttributedURI
 * Deserialize the next element if it contains a wsseu_AttributedURI.
 *
 * @param element_name
 *     The name of the element which should enclose the wsseu_AttributedURI.
 * @param instance
 *     Pointer to the <code>wsseu_AttributedURI *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsseu_AttributedURI_deserialize_pointer(
    xsd_QName *                         element_name,
    wsseu_AttributedURI ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsseu_AttributedURI_init_wrapper(
    void **                             object);
    
void
wsseu_AttributedURI_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsseu_AttributedURI_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsseu_AttributedURI_init_contents_wrapper(
    void *                              object);
    
void
wsseu_AttributedURI_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsseu_AttributedURI_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsseu_AttributedURI_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_AttributedURI_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_AttributedURI_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_AttributedURI_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
