/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSEU_TIMESTAMPTYPE_H_
#define _WSSEU_TIMESTAMPTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsseu_TimestampType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd}TimestampType element.
 * @ingroup wsseu_TimestampType
 */
typedef struct wsseu_TimestampType_s wsseu_TimestampType;
/**
 * The wsseu_TimestampType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd}TimestampType element.
 * @ingroup wsseu_TimestampType
 */
typedef wsseu_TimestampType * wsseu_TimestampType_o;

/**
 * Namespace of the wsseu_TimestampType complex type
 * @ingroup wsseu_TimestampType
 */
#define WSSEU_TIMESTAMPTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"
/**
 * Local part of the QName of the wsseu_TimestampType complex type
 * @ingroup wsseu_TimestampType
 */
#define WSSEU_TIMESTAMPTYPE_LOCAL "TimestampType"

/**
 * QName of the wsseu_TimestampType complex type
 * @ingroup wsseu_TimestampType
 */
extern xsd_QName wsseu_TimestampType_qname;
/**
 * Type information for serializing and deserializing wsseu_TimestampType elements
 * @ingroup wsseu_TimestampType
 */
extern struct globus_xsd_type_info_s wsseu_TimestampType_info;
/**
 * Type information for serializing and deserializing arrays of wsseu_TimestampType
 * elements
 * @ingroup wsseu_TimestampType
 */
extern struct globus_xsd_type_info_s wsseu_TimestampType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsseu_TimestampType without surrounding elements
 * @ingroup wsseu_TimestampType
 */
extern struct globus_xsd_type_info_s wsseu_TimestampType_contents_info;


#include "wsseu_AttributedDateTime.h"
#include "wsseu_AttributedDateTime.h"
#include "wsseu_TimestampType_choice.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "wsseu_TimestampType_array.h"

/**
 * @defgroup wsseu_TimestampType Complex type: wsseu_TimestampType
 * @ingroup types
 */

/**
 * C structure for the wsseu_TimestampType complex type
 * @ingroup wsseu_TimestampType
 */
struct wsseu_TimestampType_s
{
   /** Optional wsseu_AttributedDateTime subelement */
    wsseu_AttributedDateTime_o Created;
   /** Optional wsseu_AttributedDateTime subelement */
    wsseu_AttributedDateTime_o Expires;
   /** Array of [0 .. Infinity] wsseu_TimestampType_choice elements */
    wsseu_TimestampType_choice_array choice_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 *
 * Allocates a new wsseu_TimestampType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsseu_TimestampType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsseu_TimestampType_init(
    wsseu_TimestampType ** inst);

/**
 * Destroy a wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 *
 * Frees a wsseu_TimestampType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsseu_TimestampType_destroy(
    wsseu_TimestampType * inst);

/**
 * Copy a wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 *
 * Perform a deep copy of a wsseu_TimestampType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsseu_TimestampType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsseu_TimestampType to be copied.
 */
globus_result_t
wsseu_TimestampType_copy(
    wsseu_TimestampType ** dest,
    const wsseu_TimestampType * src);

/**
 * Initialize the contents of a wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 *
 * Initialize the contents of a wsseu_TimestampType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsseu_TimestampType_init(). The contents may be freed
 * by calling wsseu_TimestampType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsseu_TimestampType.
 */
globus_result_t
wsseu_TimestampType_init_contents(
    wsseu_TimestampType * instance);

/**
 * Destroy the contents of a wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 *
 * Destroy the subelements and attributes of the given wsseu_TimestampType. 
 *
 * @param inst
 *     Pointer to a wsseu_TimestampType instance to destroy.
 */
void
wsseu_TimestampType_destroy_contents(
    wsseu_TimestampType * inst);

/**
 * Copy the contents of a wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 *
 * Perform a deep copy of the contents of a wsseu_TimestampType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsseu_TimestampType to be copied.
 */
globus_result_t
wsseu_TimestampType_copy_contents(
    wsseu_TimestampType * dest,
    const wsseu_TimestampType * src);

/**
 * Serialize a wsseu_TimestampType
 * @ingroup wsseu_TimestampType_array
 * Serialize a wsseu_TimestampType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsseu_TimestampType.
 * @param val
 *     The wsseu_TimestampType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsseu_TimestampType_serialize(
    xsd_QName *                         element_name,
    wsseu_TimestampType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsseu_TimestampType
 * @ingroup wsseu_TimestampType_array
 * Serialize a wsseu_TimestampType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsseu_TimestampType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsseu_TimestampType_serialize_contents(
    xsd_QName *                         element_name,
    wsseu_TimestampType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 * Deserialize an element containing a wsseu_TimestampType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsseu_TimestampType.
 * @param val
 *     Pointer to the wsseu_TimestampType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsseu_TimestampType_deserialize(
    xsd_QName *                         element_name,
    wsseu_TimestampType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 * Deserialize a wsseu_TimestampType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsseu_TimestampType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsseu_TimestampType_deserialize_contents(
    xsd_QName *                         element_name,
    wsseu_TimestampType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 * Deserialize the next element if it contains a wsseu_TimestampType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsseu_TimestampType.
 * @param instance
 *     Pointer to the <code>wsseu_TimestampType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsseu_TimestampType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsseu_TimestampType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsseu_TimestampType_init_wrapper(
    void **                             object);
    
void
wsseu_TimestampType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsseu_TimestampType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsseu_TimestampType_init_contents_wrapper(
    void *                              object);
    
void
wsseu_TimestampType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsseu_TimestampType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsseu_TimestampType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_TimestampType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_TimestampType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_TimestampType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
