/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSEU_TIMESTAMPTYPE_CHOICE_H_
#define _WSSEU_TIMESTAMPTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum wsseu_TimestampType_e
{
    wsseu_TimestampType_undefined,
    wsseu_TimestampType_any

};

/**
 * @defgroup wsseu_TimestampType_choice Complex choice type: wsseu_TimestampType
 * @ingroup wsseu_TimestampType
 */

/**
 * Enumeration of the types of values which the wsseu_TimestampType_choice
 * structure may take on.
 * @ingroup wsseu_TimestampType_choice
 */
typedef enum wsseu_TimestampType_e wsseu_TimestampType_enum;
/**
 * Union of the values which the wsseu_TimestampType_choice structure
 * contains
 * @ingroup wsseu_TimestampType_choice
 */
typedef union wsseu_TimestampType_u wsseu_TimestampType_union;
/**
 * The wsseu_TimestampType complex type, which represents the various values
 * possible by the choice used by the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd}choice 12 element.
 * @ingroup wsseu_TimestampType_choice
 */
typedef struct wsseu_TimestampType_choice_s wsseu_TimestampType_choice;
/**
 * The wsseu_TimestampType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd}choice 12 element.
 * @ingroup wsseu_TimestampType
 */
typedef wsseu_TimestampType_choice * wsseu_TimestampType_choice_o;

typedef struct wsseu_TimestampType_choice_array_s
{
    wsseu_TimestampType_choice * elements;
    int                                 length;
} wsseu_TimestampType_choice_array;

#define WSSEU_TIMESTAMPTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd"
#define WSSEU_TIMESTAMPTYPE_LOCAL "TimestampType"

extern xsd_QName wsseu_TimestampType_choice_qname;
extern struct globus_xsd_type_info_s wsseu_TimestampType_choice_info;
extern struct globus_xsd_type_info_s wsseu_TimestampType_choice_contents_info;
extern struct globus_xsd_type_info_s wsseu_TimestampType_choice_array_info;


#include "xsd_any.h"

union wsseu_TimestampType_u
{
    /** xsd_any subelement */
    xsd_any any;

};

struct wsseu_TimestampType_choice_s
{
    wsseu_TimestampType_enum type;
    wsseu_TimestampType_union value;
};

globus_result_t
wsseu_TimestampType_choice_init(
    wsseu_TimestampType_choice ** inst);

void
wsseu_TimestampType_choice_destroy(
    wsseu_TimestampType_choice * inst);

globus_result_t
wsseu_TimestampType_choice_copy(
    wsseu_TimestampType_choice ** dest,
    const wsseu_TimestampType_choice * src);

globus_result_t
wsseu_TimestampType_choice_init_contents(
    wsseu_TimestampType_choice * instance);

void
wsseu_TimestampType_choice_destroy_contents(
    wsseu_TimestampType_choice * inst);

globus_result_t
wsseu_TimestampType_choice_copy_contents(
    wsseu_TimestampType_choice * dest,
    const wsseu_TimestampType_choice * src);
    
globus_result_t
wsseu_TimestampType_choice_array_init(
    wsseu_TimestampType_choice_array ** inst);

void
wsseu_TimestampType_choice_array_destroy(
    wsseu_TimestampType_choice_array * inst);

globus_result_t
wsseu_TimestampType_choice_array_copy(
    wsseu_TimestampType_choice_array ** dest,
    const wsseu_TimestampType_choice_array * src);

globus_result_t
wsseu_TimestampType_choice_array_init_contents(
    wsseu_TimestampType_choice_array * inst);

void
wsseu_TimestampType_choice_array_destroy_contents(
    wsseu_TimestampType_choice_array * inst);

globus_result_t
wsseu_TimestampType_choice_array_copy_contents(
    wsseu_TimestampType_choice_array * dest,
    const wsseu_TimestampType_choice_array * src);

wsseu_TimestampType_choice *
wsseu_TimestampType_choice_array_push(
    wsseu_TimestampType_choice_array * array);

globus_result_t
wsseu_TimestampType_choice_serialize(
    xsd_QName *                         element_name,
    wsseu_TimestampType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_TimestampType_choice_serialize_contents(
    xsd_QName *                         element_name,
    wsseu_TimestampType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_TimestampType_choice_deserialize(
    xsd_QName *                         element_name,
    wsseu_TimestampType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_TimestampType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    wsseu_TimestampType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_TimestampType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    wsseu_TimestampType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_TimestampType_choice_array_serialize(
    xsd_QName *                         element,
    wsseu_TimestampType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_TimestampType_choice_array_deserialize(
    xsd_QName *                         element,
    wsseu_TimestampType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsseu_TimestampType_choice_init_wrapper(
    void **                             object);
    
void
wsseu_TimestampType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsseu_TimestampType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsseu_TimestampType_choice_init_contents_wrapper(
    void *                              object);
    
void
wsseu_TimestampType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsseu_TimestampType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsseu_TimestampType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_TimestampType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_TimestampType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_TimestampType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_TimestampType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsseu_TimestampType_choice_array_init_wrapper(
    void **                             arr);
    
void
wsseu_TimestampType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsseu_TimestampType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
wsseu_TimestampType_choice_array_init_contents_wrapper(
    void *                              arr);

void
wsseu_TimestampType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
wsseu_TimestampType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
wsseu_TimestampType_choice_array_push_wrapper(
    void * array);

globus_result_t
wsseu_TimestampType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
