/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSG_ADDTYPE_H_
#define _WSSG_ADDTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wssg_AddType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}complexType 17 element.
 * @ingroup wssg_AddType
 */
typedef struct wssg_AddType_s wssg_AddType;
/**
 * The wssg_AddType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}complexType 17 element.
 * @ingroup wssg_AddType
 */
typedef wssg_AddType * wssg_AddType_o;

/**
 * Namespace of the wssg_AddType complex type
 * @ingroup wssg_AddType
 */
#define WSSG_ADDTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wssg_AddType complex type
 * @ingroup wssg_AddType
 */
#define WSSG_ADDTYPE_LOCAL "AddType"

/**
 * QName of the wssg_AddType complex type
 * @ingroup wssg_AddType
 */
extern xsd_QName wssg_AddType_qname;
/**
 * Type information for serializing and deserializing wssg_AddType elements
 * @ingroup wssg_AddType
 */
extern struct globus_xsd_type_info_s wssg_AddType_info;
/**
 * Type information for serializing and deserializing arrays of wssg_AddType
 * elements
 * @ingroup wssg_AddType
 */
extern struct globus_xsd_type_info_s wssg_AddType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wssg_AddType without surrounding elements
 * @ingroup wssg_AddType
 */
extern struct globus_xsd_type_info_s wssg_AddType_contents_info;


#include "wsa_EndpointReferenceType.h"
#include "xsd_anyType.h"
#include "xsd_dateTime.h"
#include "wssg_AddType_array.h"

/**
 * @defgroup wssg_AddType Complex type: wssg_AddType
 * @ingroup types
 */

/**
 * C structure for the wssg_AddType complex type
 * @ingroup wssg_AddType
 */
struct wssg_AddType_s
{
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType MemberEPR;
    /** xsd_anyType subelement */
    xsd_anyType Content;
   /** Optional xsd_dateTime subelement */
    xsd_dateTime_o InitialTerminationTime;

};

/**
 * Initialize a wssg_AddType
 * @ingroup wssg_AddType
 *
 * Allocates a new wssg_AddType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wssg_AddType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wssg_AddType_init(
    wssg_AddType ** inst);

/**
 * Destroy a wssg_AddType
 * @ingroup wssg_AddType
 *
 * Frees a wssg_AddType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wssg_AddType_destroy(
    wssg_AddType * inst);

/**
 * Copy a wssg_AddType
 * @ingroup wssg_AddType
 *
 * Perform a deep copy of a wssg_AddType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wssg_AddType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wssg_AddType to be copied.
 */
globus_result_t
wssg_AddType_copy(
    wssg_AddType ** dest,
    const wssg_AddType * src);

/**
 * Initialize the contents of a wssg_AddType
 * @ingroup wssg_AddType
 *
 * Initialize the contents of a wssg_AddType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wssg_AddType_init(). The contents may be freed
 * by calling wssg_AddType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wssg_AddType.
 */
globus_result_t
wssg_AddType_init_contents(
    wssg_AddType * instance);

/**
 * Destroy the contents of a wssg_AddType
 * @ingroup wssg_AddType
 *
 * Destroy the subelements and attributes of the given wssg_AddType. 
 *
 * @param inst
 *     Pointer to a wssg_AddType instance to destroy.
 */
void
wssg_AddType_destroy_contents(
    wssg_AddType * inst);

/**
 * Copy the contents of a wssg_AddType
 * @ingroup wssg_AddType
 *
 * Perform a deep copy of the contents of a wssg_AddType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wssg_AddType to be copied.
 */
globus_result_t
wssg_AddType_copy_contents(
    wssg_AddType * dest,
    const wssg_AddType * src);

/**
 * Serialize a wssg_AddType
 * @ingroup wssg_AddType_array
 * Serialize a wssg_AddType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wssg_AddType.
 * @param val
 *     The wssg_AddType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_AddType_serialize(
    xsd_QName *                         element_name,
    wssg_AddType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wssg_AddType
 * @ingroup wssg_AddType_array
 * Serialize a wssg_AddType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wssg_AddType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_AddType_serialize_contents(
    xsd_QName *                         element_name,
    wssg_AddType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_AddType
 * @ingroup wssg_AddType
 * Deserialize an element containing a wssg_AddType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_AddType.
 * @param val
 *     Pointer to the wssg_AddType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_AddType_deserialize(
    xsd_QName *                         element_name,
    wssg_AddType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_AddType
 * @ingroup wssg_AddType
 * Deserialize a wssg_AddType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wssg_AddType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_AddType_deserialize_contents(
    xsd_QName *                         element_name,
    wssg_AddType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wssg_AddType
 * @ingroup wssg_AddType
 * Deserialize the next element if it contains a wssg_AddType.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_AddType.
 * @param instance
 *     Pointer to the <code>wssg_AddType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_AddType_deserialize_pointer(
    xsd_QName *                         element_name,
    wssg_AddType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wssg_AddType_init_wrapper(
    void **                             object);
    
void
wssg_AddType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wssg_AddType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wssg_AddType_init_contents_wrapper(
    void *                              object);
    
void
wssg_AddType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wssg_AddType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wssg_AddType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_AddType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_AddType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wssg_AddType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
