/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSG_ENTRYTYPE_H_
#define _WSSG_ENTRYTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wssg_EntryType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}EntryType element.
 * @ingroup wssg_EntryType
 */
typedef struct wssg_EntryType_s wssg_EntryType;
/**
 * The wssg_EntryType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}EntryType element.
 * @ingroup wssg_EntryType
 */
typedef wssg_EntryType * wssg_EntryType_o;

/**
 * Namespace of the wssg_EntryType complex type
 * @ingroup wssg_EntryType
 */
#define WSSG_ENTRYTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wssg_EntryType complex type
 * @ingroup wssg_EntryType
 */
#define WSSG_ENTRYTYPE_LOCAL "EntryType"

/**
 * QName of the wssg_EntryType complex type
 * @ingroup wssg_EntryType
 */
extern xsd_QName wssg_EntryType_qname;
/**
 * Type information for serializing and deserializing wssg_EntryType elements
 * @ingroup wssg_EntryType
 */
extern struct globus_xsd_type_info_s wssg_EntryType_info;
/**
 * Type information for serializing and deserializing arrays of wssg_EntryType
 * elements
 * @ingroup wssg_EntryType
 */
extern struct globus_xsd_type_info_s wssg_EntryType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wssg_EntryType without surrounding elements
 * @ingroup wssg_EntryType
 */
extern struct globus_xsd_type_info_s wssg_EntryType_contents_info;


#include "wsa_EndpointReferenceType.h"
#include "wsa_EndpointReferenceType.h"
#include "xsd_anyType.h"
#include "wssg_EntryType_array.h"

/**
 * @defgroup wssg_EntryType Complex type: wssg_EntryType
 * @ingroup types
 */

/**
 * C structure for the wssg_EntryType complex type
 * @ingroup wssg_EntryType
 */
struct wssg_EntryType_s
{
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType ServiceGroupEntryEPR;
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType MemberServiceEPR;
   /** Optional xsd_anyType subelement */
    xsd_anyType_o Content;

};

/**
 * Initialize a wssg_EntryType
 * @ingroup wssg_EntryType
 *
 * Allocates a new wssg_EntryType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wssg_EntryType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wssg_EntryType_init(
    wssg_EntryType ** inst);

/**
 * Destroy a wssg_EntryType
 * @ingroup wssg_EntryType
 *
 * Frees a wssg_EntryType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wssg_EntryType_destroy(
    wssg_EntryType * inst);

/**
 * Copy a wssg_EntryType
 * @ingroup wssg_EntryType
 *
 * Perform a deep copy of a wssg_EntryType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wssg_EntryType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wssg_EntryType to be copied.
 */
globus_result_t
wssg_EntryType_copy(
    wssg_EntryType ** dest,
    const wssg_EntryType * src);

/**
 * Initialize the contents of a wssg_EntryType
 * @ingroup wssg_EntryType
 *
 * Initialize the contents of a wssg_EntryType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wssg_EntryType_init(). The contents may be freed
 * by calling wssg_EntryType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wssg_EntryType.
 */
globus_result_t
wssg_EntryType_init_contents(
    wssg_EntryType * instance);

/**
 * Destroy the contents of a wssg_EntryType
 * @ingroup wssg_EntryType
 *
 * Destroy the subelements and attributes of the given wssg_EntryType. 
 *
 * @param inst
 *     Pointer to a wssg_EntryType instance to destroy.
 */
void
wssg_EntryType_destroy_contents(
    wssg_EntryType * inst);

/**
 * Copy the contents of a wssg_EntryType
 * @ingroup wssg_EntryType
 *
 * Perform a deep copy of the contents of a wssg_EntryType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wssg_EntryType to be copied.
 */
globus_result_t
wssg_EntryType_copy_contents(
    wssg_EntryType * dest,
    const wssg_EntryType * src);

/**
 * Serialize a wssg_EntryType
 * @ingroup wssg_EntryType_array
 * Serialize a wssg_EntryType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wssg_EntryType.
 * @param val
 *     The wssg_EntryType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_EntryType_serialize(
    xsd_QName *                         element_name,
    wssg_EntryType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wssg_EntryType
 * @ingroup wssg_EntryType_array
 * Serialize a wssg_EntryType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wssg_EntryType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_EntryType_serialize_contents(
    xsd_QName *                         element_name,
    wssg_EntryType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_EntryType
 * @ingroup wssg_EntryType
 * Deserialize an element containing a wssg_EntryType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_EntryType.
 * @param val
 *     Pointer to the wssg_EntryType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_EntryType_deserialize(
    xsd_QName *                         element_name,
    wssg_EntryType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_EntryType
 * @ingroup wssg_EntryType
 * Deserialize a wssg_EntryType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wssg_EntryType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_EntryType_deserialize_contents(
    xsd_QName *                         element_name,
    wssg_EntryType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wssg_EntryType
 * @ingroup wssg_EntryType
 * Deserialize the next element if it contains a wssg_EntryType.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_EntryType.
 * @param instance
 *     Pointer to the <code>wssg_EntryType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_EntryType_deserialize_pointer(
    xsd_QName *                         element_name,
    wssg_EntryType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wssg_EntryType_init_wrapper(
    void **                             object);
    
void
wssg_EntryType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wssg_EntryType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wssg_EntryType_init_contents_wrapper(
    void *                              object);
    
void
wssg_EntryType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wssg_EntryType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wssg_EntryType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_EntryType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_EntryType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wssg_EntryType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
