/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSG_SERVICEGROUPENTRYRPTYPE_H_
#define _WSSG_SERVICEGROUPENTRYRPTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wssg_ServiceGroupEntryRPType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}complexType 12 element.
 * @ingroup wssg_ServiceGroupEntryRPType
 */
typedef struct wssg_ServiceGroupEntryRPType_s wssg_ServiceGroupEntryRPType;
/**
 * The wssg_ServiceGroupEntryRPType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}complexType 12 element.
 * @ingroup wssg_ServiceGroupEntryRPType
 */
typedef wssg_ServiceGroupEntryRPType * wssg_ServiceGroupEntryRPType_o;

/**
 * Namespace of the wssg_ServiceGroupEntryRPType complex type
 * @ingroup wssg_ServiceGroupEntryRPType
 */
#define WSSG_SERVICEGROUPENTRYRPTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wssg_ServiceGroupEntryRPType complex type
 * @ingroup wssg_ServiceGroupEntryRPType
 */
#define WSSG_SERVICEGROUPENTRYRPTYPE_LOCAL "ServiceGroupEntryRPType"

/**
 * QName of the wssg_ServiceGroupEntryRPType complex type
 * @ingroup wssg_ServiceGroupEntryRPType
 */
extern xsd_QName wssg_ServiceGroupEntryRPType_qname;
/**
 * Type information for serializing and deserializing wssg_ServiceGroupEntryRPType elements
 * @ingroup wssg_ServiceGroupEntryRPType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupEntryRPType_info;
/**
 * Type information for serializing and deserializing arrays of wssg_ServiceGroupEntryRPType
 * elements
 * @ingroup wssg_ServiceGroupEntryRPType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupEntryRPType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wssg_ServiceGroupEntryRPType without surrounding elements
 * @ingroup wssg_ServiceGroupEntryRPType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupEntryRPType_contents_info;


#include "wsa_EndpointReferenceType.h"
#include "wsa_EndpointReferenceType.h"
#include "xsd_anyType.h"
#include "wssg_ServiceGroupEntryRPType_array.h"

/**
 * @defgroup wssg_ServiceGroupEntryRPType Complex type: wssg_ServiceGroupEntryRPType
 * @ingroup types
 */

/**
 * C structure for the wssg_ServiceGroupEntryRPType complex type
 * @ingroup wssg_ServiceGroupEntryRPType
 */
struct wssg_ServiceGroupEntryRPType_s
{
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType ServiceGroupEPR;
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType MemberEPR;
    /** xsd_anyType subelement */
    xsd_anyType Content;

};

/**
 * Initialize a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 *
 * Allocates a new wssg_ServiceGroupEntryRPType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wssg_ServiceGroupEntryRPType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_init(
    wssg_ServiceGroupEntryRPType ** inst);

/**
 * Destroy a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 *
 * Frees a wssg_ServiceGroupEntryRPType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wssg_ServiceGroupEntryRPType_destroy(
    wssg_ServiceGroupEntryRPType * inst);

/**
 * Copy a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 *
 * Perform a deep copy of a wssg_ServiceGroupEntryRPType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wssg_ServiceGroupEntryRPType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wssg_ServiceGroupEntryRPType to be copied.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_copy(
    wssg_ServiceGroupEntryRPType ** dest,
    const wssg_ServiceGroupEntryRPType * src);

/**
 * Initialize the contents of a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 *
 * Initialize the contents of a wssg_ServiceGroupEntryRPType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wssg_ServiceGroupEntryRPType_init(). The contents may be freed
 * by calling wssg_ServiceGroupEntryRPType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wssg_ServiceGroupEntryRPType.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_init_contents(
    wssg_ServiceGroupEntryRPType * instance);

/**
 * Destroy the contents of a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 *
 * Destroy the subelements and attributes of the given wssg_ServiceGroupEntryRPType. 
 *
 * @param inst
 *     Pointer to a wssg_ServiceGroupEntryRPType instance to destroy.
 */
void
wssg_ServiceGroupEntryRPType_destroy_contents(
    wssg_ServiceGroupEntryRPType * inst);

/**
 * Copy the contents of a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 *
 * Perform a deep copy of the contents of a wssg_ServiceGroupEntryRPType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wssg_ServiceGroupEntryRPType to be copied.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_copy_contents(
    wssg_ServiceGroupEntryRPType * dest,
    const wssg_ServiceGroupEntryRPType * src);

/**
 * Serialize a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType_array
 * Serialize a wssg_ServiceGroupEntryRPType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wssg_ServiceGroupEntryRPType.
 * @param val
 *     The wssg_ServiceGroupEntryRPType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_serialize(
    xsd_QName *                         element_name,
    wssg_ServiceGroupEntryRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType_array
 * Serialize a wssg_ServiceGroupEntryRPType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wssg_ServiceGroupEntryRPType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_serialize_contents(
    xsd_QName *                         element_name,
    wssg_ServiceGroupEntryRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 * Deserialize an element containing a wssg_ServiceGroupEntryRPType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ServiceGroupEntryRPType.
 * @param val
 *     Pointer to the wssg_ServiceGroupEntryRPType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_deserialize(
    xsd_QName *                         element_name,
    wssg_ServiceGroupEntryRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 * Deserialize a wssg_ServiceGroupEntryRPType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wssg_ServiceGroupEntryRPType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_deserialize_contents(
    xsd_QName *                         element_name,
    wssg_ServiceGroupEntryRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wssg_ServiceGroupEntryRPType
 * @ingroup wssg_ServiceGroupEntryRPType
 * Deserialize the next element if it contains a wssg_ServiceGroupEntryRPType.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ServiceGroupEntryRPType.
 * @param instance
 *     Pointer to the <code>wssg_ServiceGroupEntryRPType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupEntryRPType_deserialize_pointer(
    xsd_QName *                         element_name,
    wssg_ServiceGroupEntryRPType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wssg_ServiceGroupEntryRPType_init_wrapper(
    void **                             object);
    
void
wssg_ServiceGroupEntryRPType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wssg_ServiceGroupEntryRPType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wssg_ServiceGroupEntryRPType_init_contents_wrapper(
    void *                              object);
    
void
wssg_ServiceGroupEntryRPType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wssg_ServiceGroupEntryRPType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wssg_ServiceGroupEntryRPType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ServiceGroupEntryRPType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ServiceGroupEntryRPType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wssg_ServiceGroupEntryRPType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
