/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSG_SERVICEGROUPRPTYPE_H_
#define _WSSG_SERVICEGROUPRPTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wssg_ServiceGroupRPType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}complexType 8 element.
 * @ingroup wssg_ServiceGroupRPType
 */
typedef struct wssg_ServiceGroupRPType_s wssg_ServiceGroupRPType;
/**
 * The wssg_ServiceGroupRPType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}complexType 8 element.
 * @ingroup wssg_ServiceGroupRPType
 */
typedef wssg_ServiceGroupRPType * wssg_ServiceGroupRPType_o;

/**
 * Namespace of the wssg_ServiceGroupRPType complex type
 * @ingroup wssg_ServiceGroupRPType
 */
#define WSSG_SERVICEGROUPRPTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wssg_ServiceGroupRPType complex type
 * @ingroup wssg_ServiceGroupRPType
 */
#define WSSG_SERVICEGROUPRPTYPE_LOCAL "ServiceGroupRPType"

/**
 * QName of the wssg_ServiceGroupRPType complex type
 * @ingroup wssg_ServiceGroupRPType
 */
extern xsd_QName wssg_ServiceGroupRPType_qname;
/**
 * Type information for serializing and deserializing wssg_ServiceGroupRPType elements
 * @ingroup wssg_ServiceGroupRPType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupRPType_info;
/**
 * Type information for serializing and deserializing arrays of wssg_ServiceGroupRPType
 * elements
 * @ingroup wssg_ServiceGroupRPType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupRPType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wssg_ServiceGroupRPType without surrounding elements
 * @ingroup wssg_ServiceGroupRPType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupRPType_contents_info;


#include "wssg_MembershipContentRuleType_array.h"
#include "wssg_EntryType_array.h"
#include "wssg_ServiceGroupRPType_array.h"

/**
 * @defgroup wssg_ServiceGroupRPType Complex type: wssg_ServiceGroupRPType
 * @ingroup types
 */

/**
 * C structure for the wssg_ServiceGroupRPType complex type
 * @ingroup wssg_ServiceGroupRPType
 */
struct wssg_ServiceGroupRPType_s
{
   /** Array of [0 .. Infinity] wssg_MembershipContentRuleType elements */
    wssg_MembershipContentRuleType_array MembershipContentRule;
   /** Array of [0 .. Infinity] wssg_EntryType elements */
    wssg_EntryType_array Entry;

};

/**
 * Initialize a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 *
 * Allocates a new wssg_ServiceGroupRPType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wssg_ServiceGroupRPType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wssg_ServiceGroupRPType_init(
    wssg_ServiceGroupRPType ** inst);

/**
 * Destroy a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 *
 * Frees a wssg_ServiceGroupRPType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wssg_ServiceGroupRPType_destroy(
    wssg_ServiceGroupRPType * inst);

/**
 * Copy a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 *
 * Perform a deep copy of a wssg_ServiceGroupRPType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wssg_ServiceGroupRPType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wssg_ServiceGroupRPType to be copied.
 */
globus_result_t
wssg_ServiceGroupRPType_copy(
    wssg_ServiceGroupRPType ** dest,
    const wssg_ServiceGroupRPType * src);

/**
 * Initialize the contents of a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 *
 * Initialize the contents of a wssg_ServiceGroupRPType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wssg_ServiceGroupRPType_init(). The contents may be freed
 * by calling wssg_ServiceGroupRPType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wssg_ServiceGroupRPType.
 */
globus_result_t
wssg_ServiceGroupRPType_init_contents(
    wssg_ServiceGroupRPType * instance);

/**
 * Destroy the contents of a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 *
 * Destroy the subelements and attributes of the given wssg_ServiceGroupRPType. 
 *
 * @param inst
 *     Pointer to a wssg_ServiceGroupRPType instance to destroy.
 */
void
wssg_ServiceGroupRPType_destroy_contents(
    wssg_ServiceGroupRPType * inst);

/**
 * Copy the contents of a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 *
 * Perform a deep copy of the contents of a wssg_ServiceGroupRPType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wssg_ServiceGroupRPType to be copied.
 */
globus_result_t
wssg_ServiceGroupRPType_copy_contents(
    wssg_ServiceGroupRPType * dest,
    const wssg_ServiceGroupRPType * src);

/**
 * Serialize a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType_array
 * Serialize a wssg_ServiceGroupRPType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wssg_ServiceGroupRPType.
 * @param val
 *     The wssg_ServiceGroupRPType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ServiceGroupRPType_serialize(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType_array
 * Serialize a wssg_ServiceGroupRPType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wssg_ServiceGroupRPType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ServiceGroupRPType_serialize_contents(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 * Deserialize an element containing a wssg_ServiceGroupRPType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ServiceGroupRPType.
 * @param val
 *     Pointer to the wssg_ServiceGroupRPType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupRPType_deserialize(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 * Deserialize a wssg_ServiceGroupRPType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wssg_ServiceGroupRPType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupRPType_deserialize_contents(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wssg_ServiceGroupRPType
 * @ingroup wssg_ServiceGroupRPType
 * Deserialize the next element if it contains a wssg_ServiceGroupRPType.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ServiceGroupRPType.
 * @param instance
 *     Pointer to the <code>wssg_ServiceGroupRPType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupRPType_deserialize_pointer(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRPType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wssg_ServiceGroupRPType_init_wrapper(
    void **                             object);
    
void
wssg_ServiceGroupRPType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wssg_ServiceGroupRPType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wssg_ServiceGroupRPType_init_contents_wrapper(
    void *                              object);
    
void
wssg_ServiceGroupRPType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wssg_ServiceGroupRPType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wssg_ServiceGroupRPType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ServiceGroupRPType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ServiceGroupRPType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wssg_ServiceGroupRPType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
