/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WST_AUTHENTICATORTYPE_H_
#define _WST_AUTHENTICATORTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wst_AuthenticatorType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}AuthenticatorType element.
 * @ingroup wst_AuthenticatorType
 */
typedef struct wst_AuthenticatorType_s wst_AuthenticatorType;
/**
 * The wst_AuthenticatorType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}AuthenticatorType element.
 * @ingroup wst_AuthenticatorType
 */
typedef wst_AuthenticatorType * wst_AuthenticatorType_o;

/**
 * Namespace of the wst_AuthenticatorType complex type
 * @ingroup wst_AuthenticatorType
 */
#define WST_AUTHENTICATORTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_AuthenticatorType complex type
 * @ingroup wst_AuthenticatorType
 */
#define WST_AUTHENTICATORTYPE_LOCAL "AuthenticatorType"

/**
 * QName of the wst_AuthenticatorType complex type
 * @ingroup wst_AuthenticatorType
 */
extern xsd_QName wst_AuthenticatorType_qname;
/**
 * Type information for serializing and deserializing wst_AuthenticatorType elements
 * @ingroup wst_AuthenticatorType
 */
extern struct globus_xsd_type_info_s wst_AuthenticatorType_info;
/**
 * Type information for serializing and deserializing arrays of wst_AuthenticatorType
 * elements
 * @ingroup wst_AuthenticatorType
 */
extern struct globus_xsd_type_info_s wst_AuthenticatorType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_AuthenticatorType without surrounding elements
 * @ingroup wst_AuthenticatorType
 */
extern struct globus_xsd_type_info_s wst_AuthenticatorType_contents_info;


#include "xsd_base64Binary.h"
#include "xsd_any.h"
#include "wst_AuthenticatorType_array.h"

/**
 * @defgroup wst_AuthenticatorType Complex type: wst_AuthenticatorType
 * @ingroup types
 */

/**
 * C structure for the wst_AuthenticatorType complex type
 * @ingroup wst_AuthenticatorType
 */
struct wst_AuthenticatorType_s
{
   /** Optional xsd_base64Binary subelement */
    xsd_base64Binary_o CombinedHash;
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;

};

/**
 * Initialize a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 *
 * Allocates a new wst_AuthenticatorType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_AuthenticatorType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_AuthenticatorType_init(
    wst_AuthenticatorType ** inst);

/**
 * Destroy a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 *
 * Frees a wst_AuthenticatorType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_AuthenticatorType_destroy(
    wst_AuthenticatorType * inst);

/**
 * Copy a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 *
 * Perform a deep copy of a wst_AuthenticatorType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_AuthenticatorType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_AuthenticatorType to be copied.
 */
globus_result_t
wst_AuthenticatorType_copy(
    wst_AuthenticatorType ** dest,
    const wst_AuthenticatorType * src);

/**
 * Initialize the contents of a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 *
 * Initialize the contents of a wst_AuthenticatorType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_AuthenticatorType_init(). The contents may be freed
 * by calling wst_AuthenticatorType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_AuthenticatorType.
 */
globus_result_t
wst_AuthenticatorType_init_contents(
    wst_AuthenticatorType * instance);

/**
 * Destroy the contents of a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 *
 * Destroy the subelements and attributes of the given wst_AuthenticatorType. 
 *
 * @param inst
 *     Pointer to a wst_AuthenticatorType instance to destroy.
 */
void
wst_AuthenticatorType_destroy_contents(
    wst_AuthenticatorType * inst);

/**
 * Copy the contents of a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 *
 * Perform a deep copy of the contents of a wst_AuthenticatorType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_AuthenticatorType to be copied.
 */
globus_result_t
wst_AuthenticatorType_copy_contents(
    wst_AuthenticatorType * dest,
    const wst_AuthenticatorType * src);

/**
 * Serialize a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType_array
 * Serialize a wst_AuthenticatorType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_AuthenticatorType.
 * @param val
 *     The wst_AuthenticatorType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_AuthenticatorType_serialize(
    xsd_QName *                         element_name,
    wst_AuthenticatorType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType_array
 * Serialize a wst_AuthenticatorType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_AuthenticatorType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_AuthenticatorType_serialize_contents(
    xsd_QName *                         element_name,
    wst_AuthenticatorType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 * Deserialize an element containing a wst_AuthenticatorType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_AuthenticatorType.
 * @param val
 *     Pointer to the wst_AuthenticatorType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_AuthenticatorType_deserialize(
    xsd_QName *                         element_name,
    wst_AuthenticatorType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 * Deserialize a wst_AuthenticatorType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_AuthenticatorType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_AuthenticatorType_deserialize_contents(
    xsd_QName *                         element_name,
    wst_AuthenticatorType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_AuthenticatorType
 * @ingroup wst_AuthenticatorType
 * Deserialize the next element if it contains a wst_AuthenticatorType.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_AuthenticatorType.
 * @param instance
 *     Pointer to the <code>wst_AuthenticatorType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_AuthenticatorType_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_AuthenticatorType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wst_AuthenticatorType_init_wrapper(
    void **                             object);
    
void
wst_AuthenticatorType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_AuthenticatorType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wst_AuthenticatorType_init_contents_wrapper(
    void *                              object);
    
void
wst_AuthenticatorType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_AuthenticatorType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wst_AuthenticatorType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_AuthenticatorType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_AuthenticatorType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wst_AuthenticatorType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
