/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WST_ENCRYPTIONTYPE_H_
#define _WST_ENCRYPTIONTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wst_EncryptionType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}EncryptionType element.
 * @ingroup wst_EncryptionType
 */
typedef struct wst_EncryptionType_s wst_EncryptionType;
/**
 * The wst_EncryptionType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}EncryptionType element.
 * @ingroup wst_EncryptionType
 */
typedef wst_EncryptionType * wst_EncryptionType_o;

/**
 * Namespace of the wst_EncryptionType complex type
 * @ingroup wst_EncryptionType
 */
#define WST_ENCRYPTIONTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_EncryptionType complex type
 * @ingroup wst_EncryptionType
 */
#define WST_ENCRYPTIONTYPE_LOCAL "EncryptionType"

/**
 * QName of the wst_EncryptionType complex type
 * @ingroup wst_EncryptionType
 */
extern xsd_QName wst_EncryptionType_qname;
/**
 * Type information for serializing and deserializing wst_EncryptionType elements
 * @ingroup wst_EncryptionType
 */
extern struct globus_xsd_type_info_s wst_EncryptionType_info;
/**
 * Type information for serializing and deserializing arrays of wst_EncryptionType
 * elements
 * @ingroup wst_EncryptionType
 */
extern struct globus_xsd_type_info_s wst_EncryptionType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_EncryptionType without surrounding elements
 * @ingroup wst_EncryptionType
 */
extern struct globus_xsd_type_info_s wst_EncryptionType_contents_info;


#include "xsd_any.h"
#include "wst_EncryptionType_array.h"

/**
 * @defgroup wst_EncryptionType Complex type: wst_EncryptionType
 * @ingroup types
 */

/**
 * C structure for the wst_EncryptionType complex type
 * @ingroup wst_EncryptionType
 */
struct wst_EncryptionType_s
{
    /** xsd_any subelement */
    xsd_any any;

};

/**
 * Initialize a wst_EncryptionType
 * @ingroup wst_EncryptionType
 *
 * Allocates a new wst_EncryptionType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_EncryptionType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_EncryptionType_init(
    wst_EncryptionType ** inst);

/**
 * Destroy a wst_EncryptionType
 * @ingroup wst_EncryptionType
 *
 * Frees a wst_EncryptionType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_EncryptionType_destroy(
    wst_EncryptionType * inst);

/**
 * Copy a wst_EncryptionType
 * @ingroup wst_EncryptionType
 *
 * Perform a deep copy of a wst_EncryptionType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_EncryptionType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_EncryptionType to be copied.
 */
globus_result_t
wst_EncryptionType_copy(
    wst_EncryptionType ** dest,
    const wst_EncryptionType * src);

/**
 * Initialize the contents of a wst_EncryptionType
 * @ingroup wst_EncryptionType
 *
 * Initialize the contents of a wst_EncryptionType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_EncryptionType_init(). The contents may be freed
 * by calling wst_EncryptionType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_EncryptionType.
 */
globus_result_t
wst_EncryptionType_init_contents(
    wst_EncryptionType * instance);

/**
 * Destroy the contents of a wst_EncryptionType
 * @ingroup wst_EncryptionType
 *
 * Destroy the subelements and attributes of the given wst_EncryptionType. 
 *
 * @param inst
 *     Pointer to a wst_EncryptionType instance to destroy.
 */
void
wst_EncryptionType_destroy_contents(
    wst_EncryptionType * inst);

/**
 * Copy the contents of a wst_EncryptionType
 * @ingroup wst_EncryptionType
 *
 * Perform a deep copy of the contents of a wst_EncryptionType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_EncryptionType to be copied.
 */
globus_result_t
wst_EncryptionType_copy_contents(
    wst_EncryptionType * dest,
    const wst_EncryptionType * src);

/**
 * Serialize a wst_EncryptionType
 * @ingroup wst_EncryptionType_array
 * Serialize a wst_EncryptionType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_EncryptionType.
 * @param val
 *     The wst_EncryptionType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_EncryptionType_serialize(
    xsd_QName *                         element_name,
    wst_EncryptionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_EncryptionType
 * @ingroup wst_EncryptionType_array
 * Serialize a wst_EncryptionType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_EncryptionType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_EncryptionType_serialize_contents(
    xsd_QName *                         element_name,
    wst_EncryptionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_EncryptionType
 * @ingroup wst_EncryptionType
 * Deserialize an element containing a wst_EncryptionType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_EncryptionType.
 * @param val
 *     Pointer to the wst_EncryptionType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_EncryptionType_deserialize(
    xsd_QName *                         element_name,
    wst_EncryptionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_EncryptionType
 * @ingroup wst_EncryptionType
 * Deserialize a wst_EncryptionType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_EncryptionType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_EncryptionType_deserialize_contents(
    xsd_QName *                         element_name,
    wst_EncryptionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_EncryptionType
 * @ingroup wst_EncryptionType
 * Deserialize the next element if it contains a wst_EncryptionType.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_EncryptionType.
 * @param instance
 *     Pointer to the <code>wst_EncryptionType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_EncryptionType_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_EncryptionType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wst_EncryptionType_init_wrapper(
    void **                             object);
    
void
wst_EncryptionType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_EncryptionType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wst_EncryptionType_init_contents_wrapper(
    void *                              object);
    
void
wst_EncryptionType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_EncryptionType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wst_EncryptionType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_EncryptionType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_EncryptionType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wst_EncryptionType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
