/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WST_ENTROPYTYPE_H_
#define _WST_ENTROPYTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wst_EntropyType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}EntropyType element.
 * @ingroup wst_EntropyType
 */
typedef struct wst_EntropyType_s wst_EntropyType;
/**
 * The wst_EntropyType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}EntropyType element.
 * @ingroup wst_EntropyType
 */
typedef wst_EntropyType * wst_EntropyType_o;

/**
 * Namespace of the wst_EntropyType complex type
 * @ingroup wst_EntropyType
 */
#define WST_ENTROPYTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_EntropyType complex type
 * @ingroup wst_EntropyType
 */
#define WST_ENTROPYTYPE_LOCAL "EntropyType"

/**
 * QName of the wst_EntropyType complex type
 * @ingroup wst_EntropyType
 */
extern xsd_QName wst_EntropyType_qname;
/**
 * Type information for serializing and deserializing wst_EntropyType elements
 * @ingroup wst_EntropyType
 */
extern struct globus_xsd_type_info_s wst_EntropyType_info;
/**
 * Type information for serializing and deserializing arrays of wst_EntropyType
 * elements
 * @ingroup wst_EntropyType
 */
extern struct globus_xsd_type_info_s wst_EntropyType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_EntropyType without surrounding elements
 * @ingroup wst_EntropyType
 */
extern struct globus_xsd_type_info_s wst_EntropyType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "wst_EntropyType_array.h"

/**
 * @defgroup wst_EntropyType Complex type: wst_EntropyType
 * @ingroup types
 */

/**
 * C structure for the wst_EntropyType complex type
 * @ingroup wst_EntropyType
 */
struct wst_EntropyType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wst_EntropyType
 * @ingroup wst_EntropyType
 *
 * Allocates a new wst_EntropyType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_EntropyType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_EntropyType_init(
    wst_EntropyType ** inst);

/**
 * Destroy a wst_EntropyType
 * @ingroup wst_EntropyType
 *
 * Frees a wst_EntropyType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_EntropyType_destroy(
    wst_EntropyType * inst);

/**
 * Copy a wst_EntropyType
 * @ingroup wst_EntropyType
 *
 * Perform a deep copy of a wst_EntropyType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_EntropyType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_EntropyType to be copied.
 */
globus_result_t
wst_EntropyType_copy(
    wst_EntropyType ** dest,
    const wst_EntropyType * src);

/**
 * Initialize the contents of a wst_EntropyType
 * @ingroup wst_EntropyType
 *
 * Initialize the contents of a wst_EntropyType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_EntropyType_init(). The contents may be freed
 * by calling wst_EntropyType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_EntropyType.
 */
globus_result_t
wst_EntropyType_init_contents(
    wst_EntropyType * instance);

/**
 * Destroy the contents of a wst_EntropyType
 * @ingroup wst_EntropyType
 *
 * Destroy the subelements and attributes of the given wst_EntropyType. 
 *
 * @param inst
 *     Pointer to a wst_EntropyType instance to destroy.
 */
void
wst_EntropyType_destroy_contents(
    wst_EntropyType * inst);

/**
 * Copy the contents of a wst_EntropyType
 * @ingroup wst_EntropyType
 *
 * Perform a deep copy of the contents of a wst_EntropyType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_EntropyType to be copied.
 */
globus_result_t
wst_EntropyType_copy_contents(
    wst_EntropyType * dest,
    const wst_EntropyType * src);

/**
 * Serialize a wst_EntropyType
 * @ingroup wst_EntropyType_array
 * Serialize a wst_EntropyType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_EntropyType.
 * @param val
 *     The wst_EntropyType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_EntropyType_serialize(
    xsd_QName *                         element_name,
    wst_EntropyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_EntropyType
 * @ingroup wst_EntropyType_array
 * Serialize a wst_EntropyType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_EntropyType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_EntropyType_serialize_contents(
    xsd_QName *                         element_name,
    wst_EntropyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_EntropyType
 * @ingroup wst_EntropyType
 * Deserialize an element containing a wst_EntropyType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_EntropyType.
 * @param val
 *     Pointer to the wst_EntropyType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_EntropyType_deserialize(
    xsd_QName *                         element_name,
    wst_EntropyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_EntropyType
 * @ingroup wst_EntropyType
 * Deserialize a wst_EntropyType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_EntropyType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_EntropyType_deserialize_contents(
    xsd_QName *                         element_name,
    wst_EntropyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_EntropyType
 * @ingroup wst_EntropyType
 * Deserialize the next element if it contains a wst_EntropyType.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_EntropyType.
 * @param instance
 *     Pointer to the <code>wst_EntropyType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_EntropyType_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_EntropyType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wst_EntropyType_init_wrapper(
    void **                             object);
    
void
wst_EntropyType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_EntropyType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wst_EntropyType_init_contents_wrapper(
    void *                              object);
    
void
wst_EntropyType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_EntropyType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wst_EntropyType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_EntropyType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_EntropyType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wst_EntropyType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
