/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WST_LIFETIMETYPE_H_
#define _WST_LIFETIMETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wst_LifetimeType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}LifetimeType element.
 * @ingroup wst_LifetimeType
 */
typedef struct wst_LifetimeType_s wst_LifetimeType;
/**
 * The wst_LifetimeType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}LifetimeType element.
 * @ingroup wst_LifetimeType
 */
typedef wst_LifetimeType * wst_LifetimeType_o;

/**
 * Namespace of the wst_LifetimeType complex type
 * @ingroup wst_LifetimeType
 */
#define WST_LIFETIMETYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_LifetimeType complex type
 * @ingroup wst_LifetimeType
 */
#define WST_LIFETIMETYPE_LOCAL "LifetimeType"

/**
 * QName of the wst_LifetimeType complex type
 * @ingroup wst_LifetimeType
 */
extern xsd_QName wst_LifetimeType_qname;
/**
 * Type information for serializing and deserializing wst_LifetimeType elements
 * @ingroup wst_LifetimeType
 */
extern struct globus_xsd_type_info_s wst_LifetimeType_info;
/**
 * Type information for serializing and deserializing arrays of wst_LifetimeType
 * elements
 * @ingroup wst_LifetimeType
 */
extern struct globus_xsd_type_info_s wst_LifetimeType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_LifetimeType without surrounding elements
 * @ingroup wst_LifetimeType
 */
extern struct globus_xsd_type_info_s wst_LifetimeType_contents_info;


#include "wsseu_AttributedDateTime.h"
#include "wsseu_AttributedDateTime.h"
#include "wst_LifetimeType_array.h"

/**
 * @defgroup wst_LifetimeType Complex type: wst_LifetimeType
 * @ingroup types
 */

/**
 * C structure for the wst_LifetimeType complex type
 * @ingroup wst_LifetimeType
 */
struct wst_LifetimeType_s
{
   /** Optional wsseu_AttributedDateTime subelement */
    wsseu_AttributedDateTime_o Created;
   /** Optional wsseu_AttributedDateTime subelement */
    wsseu_AttributedDateTime_o Expires;

};

/**
 * Initialize a wst_LifetimeType
 * @ingroup wst_LifetimeType
 *
 * Allocates a new wst_LifetimeType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_LifetimeType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_LifetimeType_init(
    wst_LifetimeType ** inst);

/**
 * Destroy a wst_LifetimeType
 * @ingroup wst_LifetimeType
 *
 * Frees a wst_LifetimeType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_LifetimeType_destroy(
    wst_LifetimeType * inst);

/**
 * Copy a wst_LifetimeType
 * @ingroup wst_LifetimeType
 *
 * Perform a deep copy of a wst_LifetimeType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_LifetimeType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_LifetimeType to be copied.
 */
globus_result_t
wst_LifetimeType_copy(
    wst_LifetimeType ** dest,
    const wst_LifetimeType * src);

/**
 * Initialize the contents of a wst_LifetimeType
 * @ingroup wst_LifetimeType
 *
 * Initialize the contents of a wst_LifetimeType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_LifetimeType_init(). The contents may be freed
 * by calling wst_LifetimeType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_LifetimeType.
 */
globus_result_t
wst_LifetimeType_init_contents(
    wst_LifetimeType * instance);

/**
 * Destroy the contents of a wst_LifetimeType
 * @ingroup wst_LifetimeType
 *
 * Destroy the subelements and attributes of the given wst_LifetimeType. 
 *
 * @param inst
 *     Pointer to a wst_LifetimeType instance to destroy.
 */
void
wst_LifetimeType_destroy_contents(
    wst_LifetimeType * inst);

/**
 * Copy the contents of a wst_LifetimeType
 * @ingroup wst_LifetimeType
 *
 * Perform a deep copy of the contents of a wst_LifetimeType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_LifetimeType to be copied.
 */
globus_result_t
wst_LifetimeType_copy_contents(
    wst_LifetimeType * dest,
    const wst_LifetimeType * src);

/**
 * Serialize a wst_LifetimeType
 * @ingroup wst_LifetimeType_array
 * Serialize a wst_LifetimeType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_LifetimeType.
 * @param val
 *     The wst_LifetimeType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_LifetimeType_serialize(
    xsd_QName *                         element_name,
    wst_LifetimeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_LifetimeType
 * @ingroup wst_LifetimeType_array
 * Serialize a wst_LifetimeType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_LifetimeType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_LifetimeType_serialize_contents(
    xsd_QName *                         element_name,
    wst_LifetimeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_LifetimeType
 * @ingroup wst_LifetimeType
 * Deserialize an element containing a wst_LifetimeType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_LifetimeType.
 * @param val
 *     Pointer to the wst_LifetimeType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_LifetimeType_deserialize(
    xsd_QName *                         element_name,
    wst_LifetimeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_LifetimeType
 * @ingroup wst_LifetimeType
 * Deserialize a wst_LifetimeType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_LifetimeType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_LifetimeType_deserialize_contents(
    xsd_QName *                         element_name,
    wst_LifetimeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_LifetimeType
 * @ingroup wst_LifetimeType
 * Deserialize the next element if it contains a wst_LifetimeType.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_LifetimeType.
 * @param instance
 *     Pointer to the <code>wst_LifetimeType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_LifetimeType_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_LifetimeType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wst_LifetimeType_init_wrapper(
    void **                             object);
    
void
wst_LifetimeType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_LifetimeType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wst_LifetimeType_init_contents_wrapper(
    void *                              object);
    
void
wst_LifetimeType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_LifetimeType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wst_LifetimeType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_LifetimeType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_LifetimeType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wst_LifetimeType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
