/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDL-to-C Converter
 */

#ifndef _WST_REQUESTTYPEENUM_H_
#define _WST_REQUESTTYPEENUM_H_

#include "globus_common.h"

/**
 * @defgroup wst_RequestTypeEnum Simple Type: wst_RequestTypeEnum
 * @ingroup types
 */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */


#include "xsd_anyURI.h"

/**
 * @ingroup wst_RequestTypeEnum
 */
typedef xsd_anyURI wst_RequestTypeEnum;

extern xsd_anyURI wst_RequestTypeEnum_Issue;
extern xsd_anyURI wst_RequestTypeEnum_Renew;
extern xsd_anyURI wst_RequestTypeEnum_Validate;

/**
 * Optional wst_RequestTypeEnum element
 * @ingroup wst_RequestTypeEnum
 */
typedef wst_RequestTypeEnum * wst_RequestTypeEnum_o;

/**
 * Array of wst_RequestTypeEnum elements
 * @ingroup wst_RequestTypeEnum
 *
 * This structure type is used represent an array of
 * wst_RequestTypeEnum elements.
 *
 * Arrays are allocated by wst_RequestTypeEnum_array_init() and freed by calling
 * wst_RequestTypeEnum_array_destroy(). Elements may be added to an array by calling
 * wst_RequestTypeEnum_array_push().
 */
typedef struct wst_RequestTypeEnum_array_s
{
    /** Dynamic array of elements */
    wst_RequestTypeEnum * elements;
    /** Number of elements in this array */
    int                                 length;
} wst_RequestTypeEnum_array;

/**
 * Namespace of the wst_RequestTypeEnum complex type
 * @ingroup wst_RequestTypeEnum
 */
#define WST_REQUESTTYPEENUM_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_RequestTypeEnum complex type
 * @ingroup wst_RequestTypeEnum
 */
#define WST_REQUESTTYPEENUM_LOCAL "RequestTypeEnum"

/**
 * QName of the wst_RequestTypeEnum complex type
 * @ingroup wst_RequestTypeEnum
 */
extern xsd_QName wst_RequestTypeEnum_qname;
/**
 * Type information for serializing and deserializing wst_RequestTypeEnum elements
 * @ingroup wst_RequestTypeEnum
 */
extern struct globus_xsd_type_info_s wst_RequestTypeEnum_info;
/**
 * Type information for serializing and deserializing arrays of wst_RequestTypeEnum
 * elements
 * @ingroup wst_RequestTypeEnum
 */
extern struct globus_xsd_type_info_s wst_RequestTypeEnum_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_RequestTypeEnum without surrounding elements
 * @ingroup wst_RequestTypeEnum
 */
extern struct globus_xsd_type_info_s wst_RequestTypeEnum_contents_info;

/**
 * Initialize a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 *
 * Allocates a new wst_RequestTypeEnum and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_RequestTypeEnum_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_RequestTypeEnum_init(
    wst_RequestTypeEnum ** inst);

/**
 * Destroy a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 *
 * Frees a wst_RequestTypeEnum. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_RequestTypeEnum_destroy(
    wst_RequestTypeEnum * inst);

/**
 * Copy a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 *
 * Perform a deep copy of a wst_RequestTypeEnum.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_RequestTypeEnum structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_RequestTypeEnum to be copied.
 */
globus_result_t
wst_RequestTypeEnum_copy(
    wst_RequestTypeEnum ** dest,
    const wst_RequestTypeEnum * src);

/**
 * Initialize the contents of a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 *
 * Initialize the contents of a wst_RequestTypeEnum. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_RequestTypeEnum_init(). The contents may be freed
 * by calling wst_RequestTypeEnum_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_RequestTypeEnum.
 */
globus_result_t
wst_RequestTypeEnum_init_contents(
    wst_RequestTypeEnum * instance);

/**
 * Destroy the contents of a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 *
 * Destroy the subelements and attributes of the given wst_RequestTypeEnum. 
 *
 * @param inst
 *     Pointer to a wst_RequestTypeEnum instance to destroy.
 */
void
wst_RequestTypeEnum_destroy_contents(
    wst_RequestTypeEnum * inst);

/**
 * Copy the contents of a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 *
 * Perform a deep copy of the contents of a wst_RequestTypeEnum.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_RequestTypeEnum to be copied.
 */
globus_result_t
wst_RequestTypeEnum_copy_contents(
    wst_RequestTypeEnum * dest,
    const wst_RequestTypeEnum * src);

/**
 * Initialize an array of wst_RequestTypeEnum elements.
 * @ingroup wst_RequestTypeEnum
 *
 * Allocates a new array of 0 elements. When this array is no longer used,
 * it should be freed by calling 
 * wst_RequestTypeEnum_array_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated array instance.
 */
globus_result_t
wst_RequestTypeEnum_array_init(
    wst_RequestTypeEnum_array ** inst);

/**
 * Destroy an array of wst_RequestTypeEnum elements.
 * @ingroup wst_RequestTypeEnum
 *
 * Frees an array of wst_RequestTypeEnum elements. The contents of each element
 * element in the array be destroyed by calling
 * wst_RequestTypeEnum_destroy_contents().
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wst_RequestTypeEnum_array_destroy(
    wst_RequestTypeEnum_array * inst);

/**
 * Copy an array of wst_RequestTypeEnum elements
 * @ingroup wst_RequestTypeEnum
 *
 * Perform a deep copy of an array of wst_RequestTypeEnum elements.
 * The @a dest array will be allocated, and then a copy of the contents
 * of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wst_RequestTypeEnum_array_copy(
    wst_RequestTypeEnum_array ** dest,
    const wst_RequestTypeEnum_array * src);

/**
 * Initialize the contents of an array of wst_RequestTypeEnum elements
 * @ingroup wst_RequestTypeEnum
 *
 * Initialize the contents of an array of wst_RequestTypeEnum elements. Used
 * when the array is allocated on the stack or by a some allocator besides
 * wst_RequestTypeEnum_array_init(). The contents of the array may be freed
 * by calling wst_RequestTypeEnum_array_destroy_contents().
 *
 * @param inst
 *     Pointer to an allocated but uninitialized array.
 */
globus_result_t
wst_RequestTypeEnum_array_init_contents(
    wst_RequestTypeEnum_array * inst);

/**
 * Destroy the contents of an array of wst_RequestTypeEnum elements
 * @ingroup wst_RequestTypeEnum
 *
 * Destroy the elements in an array of wst_RequestTypeEnum elements. The contents of
 * each element in the array be destroyed by calling
 * wst_RequestTypeEnum_destroy_contents() and the array will be reset to be empty.
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wst_RequestTypeEnum_array_destroy_contents(
    wst_RequestTypeEnum_array * inst);

/**
 * Copy the contents of an array of wst_RequestTypeEnum elements
 * @ingroup wst_RequestTypeEnum
 *
 * Perform a deep copy of an array of wst_RequestTypeEnum elements.
 * The @a dest array must be allocated before making this call.
 * A copy of the contents of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wst_RequestTypeEnum_array_copy_contents(
    wst_RequestTypeEnum_array * dest,
    const wst_RequestTypeEnum_array * src);

/**
 * Append a new wst_RequestTypeEnum to an array
 * @ingroup wst_RequestTypeEnum
 *
 * Allocate and initialize a new wst_RequestTypeEnum structure, adding it
 * to the end of the given @a array.
 * 
 * @param array
 *     Array to be appended to.
 *
 * @return This function returns the newly allocated element.
 */
wst_RequestTypeEnum *
wst_RequestTypeEnum_array_push(
    wst_RequestTypeEnum_array * array);

/**
 * Serialize a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum_array
 * Serialize a wst_RequestTypeEnum structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_RequestTypeEnum.
 * @param val
 *     The wst_RequestTypeEnum to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_RequestTypeEnum_serialize(
    xsd_QName *                         element_name,
    wst_RequestTypeEnum * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum_array
 * Serialize a wst_RequestTypeEnum structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_RequestTypeEnum to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_RequestTypeEnum_serialize_contents(
    xsd_QName *                         element_name,
    wst_RequestTypeEnum * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 * Deserialize an element containing a wst_RequestTypeEnum element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_RequestTypeEnum.
 * @param val
 *     Pointer to the wst_RequestTypeEnum which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_RequestTypeEnum_deserialize(
    xsd_QName *                         element_name,
    wst_RequestTypeEnum * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 * Deserialize a wst_RequestTypeEnum whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_RequestTypeEnum which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_RequestTypeEnum_deserialize_contents(
    xsd_QName *                         element_name,
    wst_RequestTypeEnum * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 * Deserialize the next element if it contains a wst_RequestTypeEnum.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_RequestTypeEnum.
 * @param instance
 *     Pointer to the <code>wst_RequestTypeEnum *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_RequestTypeEnum_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_RequestTypeEnum ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize an array of wst_RequestTypeEnum elements
 * @ingroup wst_RequestTypeEnum
 * Serialize an element containing an array of wst_RequestTypeEnum elements.
 *
 * @param element
 *     The name of the element which will contain the array.
 * @param array_instance
 *     The array to serialize
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_RequestTypeEnum_array_serialize(
    xsd_QName *                         element,
    wst_RequestTypeEnum_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an array of wst_RequestTypeEnum elements
 * @ingroup wst_RequestTypeEnum
 * Deserialize an element containing an array of wst_RequestTypeEnum elements.
 *
 * @param element
 *     The name of the element which should enclose the array.
 * @param array_instance
 *     The array to deserialize into
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_RequestTypeEnum_array_deserialize(
    xsd_QName *                         element,
    wst_RequestTypeEnum_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);



/**
 * Serialize an attribute of type wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum_array
 * Serialize a wst_RequestTypeEnum as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wst_RequestTypeEnum.
 * @param val
 *     The wst_RequestTypeEnum to serialize.
 * @param message
 *     The handle to serialize the attribute on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_RequestTypeEnum_serialize_attribute(
    xsd_QName *                         attr_qname,
    wst_RequestTypeEnum * val,
    globus_soap_message_handle_t        handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an attribute of type wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 * Deserialize a wst_RequestTypeEnum as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wst_RequestTypeEnum.
 * @param instance
 *     Pointer to the wst_RequestTypeEnum which will be initialized with the
 *     value of the attribute.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_RequestTypeEnum_deserialize_attribute(
    xsd_QName *                         attr_qname,
    wst_RequestTypeEnum * instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional attribute of type wst_RequestTypeEnum
 * @ingroup wst_RequestTypeEnum
 * Try to deserialize a wst_RequestTypeEnum as an attribute of the current element
 * if it is present. The attribute's name is defined by @ attr_qname.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wst_RequestTypeEnum.
 * @param instance
 *     Pointer to the wst_RequestTypeEnum which will be allocated and initialized
 *     with the value of the attribute if it is present.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_RequestTypeEnum_deserialize_attribute_pointer(
    xsd_QName *                         attr_qname,
    wst_RequestTypeEnum ** instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);


#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
globus_result_t
wst_RequestTypeEnum_init_wrapper(
    void **                             object);
    
void
wst_RequestTypeEnum_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_RequestTypeEnum_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);
    
globus_result_t
wst_RequestTypeEnum_init_contents_wrapper(
    void  *                             object);
    
void
wst_RequestTypeEnum_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_RequestTypeEnum_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);
    
globus_result_t
wst_RequestTypeEnum_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_RequestTypeEnum_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_RequestTypeEnum_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_RequestTypeEnum_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_RequestTypeEnum_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_RequestTypeEnum_array_init_wrapper(
    void **                             arr);
    
void
wst_RequestTypeEnum_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wst_RequestTypeEnum_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);
globus_result_t
wst_RequestTypeEnum_array_init_contents_wrapper(
    void *                              arr);
    
void
wst_RequestTypeEnum_array_destroy_contents_wrapper(
    void *                              arr);
    
globus_result_t
wst_RequestTypeEnum_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);
    
globus_result_t
wst_RequestTypeEnum_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

void *
wst_RequestTypeEnum_array_push_wrapper(
    void * array);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
