/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WST_STATUSTYPE_H_
#define _WST_STATUSTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wst_StatusType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}StatusType element.
 * @ingroup wst_StatusType
 */
typedef struct wst_StatusType_s wst_StatusType;
/**
 * The wst_StatusType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}StatusType element.
 * @ingroup wst_StatusType
 */
typedef wst_StatusType * wst_StatusType_o;

/**
 * Namespace of the wst_StatusType complex type
 * @ingroup wst_StatusType
 */
#define WST_STATUSTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_StatusType complex type
 * @ingroup wst_StatusType
 */
#define WST_STATUSTYPE_LOCAL "StatusType"

/**
 * QName of the wst_StatusType complex type
 * @ingroup wst_StatusType
 */
extern xsd_QName wst_StatusType_qname;
/**
 * Type information for serializing and deserializing wst_StatusType elements
 * @ingroup wst_StatusType
 */
extern struct globus_xsd_type_info_s wst_StatusType_info;
/**
 * Type information for serializing and deserializing arrays of wst_StatusType
 * elements
 * @ingroup wst_StatusType
 */
extern struct globus_xsd_type_info_s wst_StatusType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_StatusType without surrounding elements
 * @ingroup wst_StatusType
 */
extern struct globus_xsd_type_info_s wst_StatusType_contents_info;


#include "wst_StatusCodeOpenEnum.h"
#include "xsd_string.h"
#include "wst_StatusType_array.h"

/**
 * @defgroup wst_StatusType Complex type: wst_StatusType
 * @ingroup types
 */

/**
 * C structure for the wst_StatusType complex type
 * @ingroup wst_StatusType
 */
struct wst_StatusType_s
{
    /** wst_StatusCodeOpenEnum subelement */
    wst_StatusCodeOpenEnum Code;
   /** Optional xsd_string subelement */
    xsd_string_o Reason;

};

/**
 * Initialize a wst_StatusType
 * @ingroup wst_StatusType
 *
 * Allocates a new wst_StatusType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_StatusType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_StatusType_init(
    wst_StatusType ** inst);

/**
 * Destroy a wst_StatusType
 * @ingroup wst_StatusType
 *
 * Frees a wst_StatusType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_StatusType_destroy(
    wst_StatusType * inst);

/**
 * Copy a wst_StatusType
 * @ingroup wst_StatusType
 *
 * Perform a deep copy of a wst_StatusType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_StatusType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_StatusType to be copied.
 */
globus_result_t
wst_StatusType_copy(
    wst_StatusType ** dest,
    const wst_StatusType * src);

/**
 * Initialize the contents of a wst_StatusType
 * @ingroup wst_StatusType
 *
 * Initialize the contents of a wst_StatusType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_StatusType_init(). The contents may be freed
 * by calling wst_StatusType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_StatusType.
 */
globus_result_t
wst_StatusType_init_contents(
    wst_StatusType * instance);

/**
 * Destroy the contents of a wst_StatusType
 * @ingroup wst_StatusType
 *
 * Destroy the subelements and attributes of the given wst_StatusType. 
 *
 * @param inst
 *     Pointer to a wst_StatusType instance to destroy.
 */
void
wst_StatusType_destroy_contents(
    wst_StatusType * inst);

/**
 * Copy the contents of a wst_StatusType
 * @ingroup wst_StatusType
 *
 * Perform a deep copy of the contents of a wst_StatusType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_StatusType to be copied.
 */
globus_result_t
wst_StatusType_copy_contents(
    wst_StatusType * dest,
    const wst_StatusType * src);

/**
 * Serialize a wst_StatusType
 * @ingroup wst_StatusType_array
 * Serialize a wst_StatusType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_StatusType.
 * @param val
 *     The wst_StatusType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_StatusType_serialize(
    xsd_QName *                         element_name,
    wst_StatusType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_StatusType
 * @ingroup wst_StatusType_array
 * Serialize a wst_StatusType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_StatusType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_StatusType_serialize_contents(
    xsd_QName *                         element_name,
    wst_StatusType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_StatusType
 * @ingroup wst_StatusType
 * Deserialize an element containing a wst_StatusType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_StatusType.
 * @param val
 *     Pointer to the wst_StatusType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_StatusType_deserialize(
    xsd_QName *                         element_name,
    wst_StatusType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_StatusType
 * @ingroup wst_StatusType
 * Deserialize a wst_StatusType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_StatusType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_StatusType_deserialize_contents(
    xsd_QName *                         element_name,
    wst_StatusType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_StatusType
 * @ingroup wst_StatusType
 * Deserialize the next element if it contains a wst_StatusType.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_StatusType.
 * @param instance
 *     Pointer to the <code>wst_StatusType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_StatusType_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_StatusType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wst_StatusType_init_wrapper(
    void **                             object);
    
void
wst_StatusType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_StatusType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wst_StatusType_init_contents_wrapper(
    void *                              object);
    
void
wst_StatusType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_StatusType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wst_StatusType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_StatusType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_StatusType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wst_StatusType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
