/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSU_CONTEXTTYPE_H_
#define _WSU_CONTEXTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsu_ContextType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}complexType 23 element.
 * @ingroup wsu_ContextType
 */
typedef struct wsu_ContextType_s wsu_ContextType;
/**
 * The wsu_ContextType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}complexType 23 element.
 * @ingroup wsu_ContextType
 */
typedef wsu_ContextType * wsu_ContextType_o;

/**
 * Namespace of the wsu_ContextType complex type
 * @ingroup wsu_ContextType
 */
#define WSU_CONTEXTTYPE_NS "http://schemas.xmlsoap.org/ws/2002/07/utility"
/**
 * Local part of the QName of the wsu_ContextType complex type
 * @ingroup wsu_ContextType
 */
#define WSU_CONTEXTTYPE_LOCAL "ContextType"

/**
 * QName of the wsu_ContextType complex type
 * @ingroup wsu_ContextType
 */
extern xsd_QName wsu_ContextType_qname;
/**
 * Type information for serializing and deserializing wsu_ContextType elements
 * @ingroup wsu_ContextType
 */
extern struct globus_xsd_type_info_s wsu_ContextType_info;
/**
 * Type information for serializing and deserializing arrays of wsu_ContextType
 * elements
 * @ingroup wsu_ContextType
 */
extern struct globus_xsd_type_info_s wsu_ContextType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsu_ContextType without surrounding elements
 * @ingroup wsu_ContextType
 */
extern struct globus_xsd_type_info_s wsu_ContextType_contents_info;


#include "wsu_AttributedDateTime.h"
#include "wsu_AttributedURI.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "xsd_any.h"
#include "wsu_ContextType_array.h"

/**
 * @defgroup wsu_ContextType Complex type: wsu_ContextType
 * @ingroup types
 */

/**
 * C structure for the wsu_ContextType complex type
 * @ingroup wsu_ContextType
 */
struct wsu_ContextType_s
{
   /** Optional wsu_AttributedDateTime subelement */
    wsu_AttributedDateTime_o Expires;
    /** wsu_AttributedURI subelement */
    wsu_AttributedURI Identifier;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;

};

/**
 * Initialize a wsu_ContextType
 * @ingroup wsu_ContextType
 *
 * Allocates a new wsu_ContextType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsu_ContextType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsu_ContextType_init(
    wsu_ContextType ** inst);

/**
 * Destroy a wsu_ContextType
 * @ingroup wsu_ContextType
 *
 * Frees a wsu_ContextType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsu_ContextType_destroy(
    wsu_ContextType * inst);

/**
 * Copy a wsu_ContextType
 * @ingroup wsu_ContextType
 *
 * Perform a deep copy of a wsu_ContextType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsu_ContextType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsu_ContextType to be copied.
 */
globus_result_t
wsu_ContextType_copy(
    wsu_ContextType ** dest,
    const wsu_ContextType * src);

/**
 * Initialize the contents of a wsu_ContextType
 * @ingroup wsu_ContextType
 *
 * Initialize the contents of a wsu_ContextType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsu_ContextType_init(). The contents may be freed
 * by calling wsu_ContextType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsu_ContextType.
 */
globus_result_t
wsu_ContextType_init_contents(
    wsu_ContextType * instance);

/**
 * Destroy the contents of a wsu_ContextType
 * @ingroup wsu_ContextType
 *
 * Destroy the subelements and attributes of the given wsu_ContextType. 
 *
 * @param inst
 *     Pointer to a wsu_ContextType instance to destroy.
 */
void
wsu_ContextType_destroy_contents(
    wsu_ContextType * inst);

/**
 * Copy the contents of a wsu_ContextType
 * @ingroup wsu_ContextType
 *
 * Perform a deep copy of the contents of a wsu_ContextType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsu_ContextType to be copied.
 */
globus_result_t
wsu_ContextType_copy_contents(
    wsu_ContextType * dest,
    const wsu_ContextType * src);

/**
 * Serialize a wsu_ContextType
 * @ingroup wsu_ContextType_array
 * Serialize a wsu_ContextType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsu_ContextType.
 * @param val
 *     The wsu_ContextType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_ContextType_serialize(
    xsd_QName *                         element_name,
    wsu_ContextType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsu_ContextType
 * @ingroup wsu_ContextType_array
 * Serialize a wsu_ContextType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsu_ContextType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_ContextType_serialize_contents(
    xsd_QName *                         element_name,
    wsu_ContextType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_ContextType
 * @ingroup wsu_ContextType
 * Deserialize an element containing a wsu_ContextType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_ContextType.
 * @param val
 *     Pointer to the wsu_ContextType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_ContextType_deserialize(
    xsd_QName *                         element_name,
    wsu_ContextType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_ContextType
 * @ingroup wsu_ContextType
 * Deserialize a wsu_ContextType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsu_ContextType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_ContextType_deserialize_contents(
    xsd_QName *                         element_name,
    wsu_ContextType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsu_ContextType
 * @ingroup wsu_ContextType
 * Deserialize the next element if it contains a wsu_ContextType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_ContextType.
 * @param instance
 *     Pointer to the <code>wsu_ContextType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_ContextType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsu_ContextType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsu_ContextType_init_wrapper(
    void **                             object);
    
void
wsu_ContextType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsu_ContextType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsu_ContextType_init_contents_wrapper(
    void *                              object);
    
void
wsu_ContextType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsu_ContextType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsu_ContextType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_ContextType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_ContextType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_ContextType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
