/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSU_RECEIVEDTYPE_H_
#define _WSU_RECEIVEDTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsu_ReceivedType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}ReceivedType element.
 * @ingroup wsu_ReceivedType
 */
typedef struct wsu_ReceivedType_s wsu_ReceivedType;
/**
 * The wsu_ReceivedType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}ReceivedType element.
 * @ingroup wsu_ReceivedType
 */
typedef wsu_ReceivedType * wsu_ReceivedType_o;

/**
 * Namespace of the wsu_ReceivedType complex type
 * @ingroup wsu_ReceivedType
 */
#define WSU_RECEIVEDTYPE_NS "http://schemas.xmlsoap.org/ws/2002/07/utility"
/**
 * Local part of the QName of the wsu_ReceivedType complex type
 * @ingroup wsu_ReceivedType
 */
#define WSU_RECEIVEDTYPE_LOCAL "ReceivedType"

/**
 * QName of the wsu_ReceivedType complex type
 * @ingroup wsu_ReceivedType
 */
extern xsd_QName wsu_ReceivedType_qname;
/**
 * Type information for serializing and deserializing wsu_ReceivedType elements
 * @ingroup wsu_ReceivedType
 */
extern struct globus_xsd_type_info_s wsu_ReceivedType_info;
/**
 * Type information for serializing and deserializing arrays of wsu_ReceivedType
 * elements
 * @ingroup wsu_ReceivedType
 */
extern struct globus_xsd_type_info_s wsu_ReceivedType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsu_ReceivedType without surrounding elements
 * @ingroup wsu_ReceivedType
 */
extern struct globus_xsd_type_info_s wsu_ReceivedType_contents_info;


#include "xsd_string.h"
#include "xsd_QName.h"
#include "xsd_ID.h"
#include "xsd_anyAttributes.h"
#include "xsd_anyURI.h"
#include "xsd_int.h"
#include "wsu_ReceivedType_array.h"

/**
 * @defgroup wsu_ReceivedType Complex type: wsu_ReceivedType
 * @ingroup types
 */

/**
 * C structure for the wsu_ReceivedType complex type
 * @ingroup wsu_ReceivedType
 */
struct wsu_ReceivedType_s
{
    /** xsd_string subelement */
    xsd_string base_value;
    xsd_QName_o _ValueType;
    xsd_ID_o _Id;
    xsd_anyAttributes_t anyAttributes;
    xsd_anyURI _Actor;
    xsd_int_o _Delay;

};

/**
 * Initialize a wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 *
 * Allocates a new wsu_ReceivedType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsu_ReceivedType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsu_ReceivedType_init(
    wsu_ReceivedType ** inst);

/**
 * Destroy a wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 *
 * Frees a wsu_ReceivedType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsu_ReceivedType_destroy(
    wsu_ReceivedType * inst);

/**
 * Copy a wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 *
 * Perform a deep copy of a wsu_ReceivedType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsu_ReceivedType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsu_ReceivedType to be copied.
 */
globus_result_t
wsu_ReceivedType_copy(
    wsu_ReceivedType ** dest,
    const wsu_ReceivedType * src);

/**
 * Initialize the contents of a wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 *
 * Initialize the contents of a wsu_ReceivedType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsu_ReceivedType_init(). The contents may be freed
 * by calling wsu_ReceivedType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsu_ReceivedType.
 */
globus_result_t
wsu_ReceivedType_init_contents(
    wsu_ReceivedType * instance);

/**
 * Destroy the contents of a wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 *
 * Destroy the subelements and attributes of the given wsu_ReceivedType. 
 *
 * @param inst
 *     Pointer to a wsu_ReceivedType instance to destroy.
 */
void
wsu_ReceivedType_destroy_contents(
    wsu_ReceivedType * inst);

/**
 * Copy the contents of a wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 *
 * Perform a deep copy of the contents of a wsu_ReceivedType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsu_ReceivedType to be copied.
 */
globus_result_t
wsu_ReceivedType_copy_contents(
    wsu_ReceivedType * dest,
    const wsu_ReceivedType * src);

/**
 * Serialize a wsu_ReceivedType
 * @ingroup wsu_ReceivedType_array
 * Serialize a wsu_ReceivedType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsu_ReceivedType.
 * @param val
 *     The wsu_ReceivedType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_ReceivedType_serialize(
    xsd_QName *                         element_name,
    wsu_ReceivedType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsu_ReceivedType
 * @ingroup wsu_ReceivedType_array
 * Serialize a wsu_ReceivedType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsu_ReceivedType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_ReceivedType_serialize_contents(
    xsd_QName *                         element_name,
    wsu_ReceivedType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 * Deserialize an element containing a wsu_ReceivedType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_ReceivedType.
 * @param val
 *     Pointer to the wsu_ReceivedType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_ReceivedType_deserialize(
    xsd_QName *                         element_name,
    wsu_ReceivedType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 * Deserialize a wsu_ReceivedType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsu_ReceivedType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_ReceivedType_deserialize_contents(
    xsd_QName *                         element_name,
    wsu_ReceivedType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsu_ReceivedType
 * @ingroup wsu_ReceivedType
 * Deserialize the next element if it contains a wsu_ReceivedType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_ReceivedType.
 * @param instance
 *     Pointer to the <code>wsu_ReceivedType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_ReceivedType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsu_ReceivedType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsu_ReceivedType_init_wrapper(
    void **                             object);
    
void
wsu_ReceivedType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsu_ReceivedType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsu_ReceivedType_init_contents_wrapper(
    void *                              object);
    
void
wsu_ReceivedType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsu_ReceivedType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsu_ReceivedType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_ReceivedType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_ReceivedType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_ReceivedType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
