/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSU_TIMESTAMPTYPE_H_
#define _WSU_TIMESTAMPTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsu_TimestampType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}TimestampType element.
 * @ingroup wsu_TimestampType
 */
typedef struct wsu_TimestampType_s wsu_TimestampType;
/**
 * The wsu_TimestampType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}TimestampType element.
 * @ingroup wsu_TimestampType
 */
typedef wsu_TimestampType * wsu_TimestampType_o;

/**
 * Namespace of the wsu_TimestampType complex type
 * @ingroup wsu_TimestampType
 */
#define WSU_TIMESTAMPTYPE_NS "http://schemas.xmlsoap.org/ws/2002/07/utility"
/**
 * Local part of the QName of the wsu_TimestampType complex type
 * @ingroup wsu_TimestampType
 */
#define WSU_TIMESTAMPTYPE_LOCAL "TimestampType"

/**
 * QName of the wsu_TimestampType complex type
 * @ingroup wsu_TimestampType
 */
extern xsd_QName wsu_TimestampType_qname;
/**
 * Type information for serializing and deserializing wsu_TimestampType elements
 * @ingroup wsu_TimestampType
 */
extern struct globus_xsd_type_info_s wsu_TimestampType_info;
/**
 * Type information for serializing and deserializing arrays of wsu_TimestampType
 * elements
 * @ingroup wsu_TimestampType
 */
extern struct globus_xsd_type_info_s wsu_TimestampType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsu_TimestampType without surrounding elements
 * @ingroup wsu_TimestampType
 */
extern struct globus_xsd_type_info_s wsu_TimestampType_contents_info;


#include "wsu_AttributedDateTime.h"
#include "wsu_AttributedDateTime.h"
#include "wsu_TimestampType_choice.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "wsu_TimestampType_array.h"

/**
 * @defgroup wsu_TimestampType Complex type: wsu_TimestampType
 * @ingroup types
 */

/**
 * C structure for the wsu_TimestampType complex type
 * @ingroup wsu_TimestampType
 */
struct wsu_TimestampType_s
{
   /** Optional wsu_AttributedDateTime subelement */
    wsu_AttributedDateTime_o Created;
   /** Optional wsu_AttributedDateTime subelement */
    wsu_AttributedDateTime_o Expires;
   /** Array of [0 .. Infinity] wsu_TimestampType_choice elements */
    wsu_TimestampType_choice_array choice_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsu_TimestampType
 * @ingroup wsu_TimestampType
 *
 * Allocates a new wsu_TimestampType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsu_TimestampType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsu_TimestampType_init(
    wsu_TimestampType ** inst);

/**
 * Destroy a wsu_TimestampType
 * @ingroup wsu_TimestampType
 *
 * Frees a wsu_TimestampType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsu_TimestampType_destroy(
    wsu_TimestampType * inst);

/**
 * Copy a wsu_TimestampType
 * @ingroup wsu_TimestampType
 *
 * Perform a deep copy of a wsu_TimestampType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsu_TimestampType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsu_TimestampType to be copied.
 */
globus_result_t
wsu_TimestampType_copy(
    wsu_TimestampType ** dest,
    const wsu_TimestampType * src);

/**
 * Initialize the contents of a wsu_TimestampType
 * @ingroup wsu_TimestampType
 *
 * Initialize the contents of a wsu_TimestampType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsu_TimestampType_init(). The contents may be freed
 * by calling wsu_TimestampType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsu_TimestampType.
 */
globus_result_t
wsu_TimestampType_init_contents(
    wsu_TimestampType * instance);

/**
 * Destroy the contents of a wsu_TimestampType
 * @ingroup wsu_TimestampType
 *
 * Destroy the subelements and attributes of the given wsu_TimestampType. 
 *
 * @param inst
 *     Pointer to a wsu_TimestampType instance to destroy.
 */
void
wsu_TimestampType_destroy_contents(
    wsu_TimestampType * inst);

/**
 * Copy the contents of a wsu_TimestampType
 * @ingroup wsu_TimestampType
 *
 * Perform a deep copy of the contents of a wsu_TimestampType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsu_TimestampType to be copied.
 */
globus_result_t
wsu_TimestampType_copy_contents(
    wsu_TimestampType * dest,
    const wsu_TimestampType * src);

/**
 * Serialize a wsu_TimestampType
 * @ingroup wsu_TimestampType_array
 * Serialize a wsu_TimestampType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsu_TimestampType.
 * @param val
 *     The wsu_TimestampType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_TimestampType_serialize(
    xsd_QName *                         element_name,
    wsu_TimestampType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsu_TimestampType
 * @ingroup wsu_TimestampType_array
 * Serialize a wsu_TimestampType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsu_TimestampType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_TimestampType_serialize_contents(
    xsd_QName *                         element_name,
    wsu_TimestampType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_TimestampType
 * @ingroup wsu_TimestampType
 * Deserialize an element containing a wsu_TimestampType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_TimestampType.
 * @param val
 *     Pointer to the wsu_TimestampType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_TimestampType_deserialize(
    xsd_QName *                         element_name,
    wsu_TimestampType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_TimestampType
 * @ingroup wsu_TimestampType
 * Deserialize a wsu_TimestampType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsu_TimestampType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_TimestampType_deserialize_contents(
    xsd_QName *                         element_name,
    wsu_TimestampType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsu_TimestampType
 * @ingroup wsu_TimestampType
 * Deserialize the next element if it contains a wsu_TimestampType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_TimestampType.
 * @param instance
 *     Pointer to the <code>wsu_TimestampType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_TimestampType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsu_TimestampType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsu_TimestampType_init_wrapper(
    void **                             object);
    
void
wsu_TimestampType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsu_TimestampType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsu_TimestampType_init_contents_wrapper(
    void *                              object);
    
void
wsu_TimestampType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsu_TimestampType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsu_TimestampType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_TimestampType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_TimestampType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_TimestampType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
