/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSU_TIMESTAMPTYPE_CHOICE_H_
#define _WSU_TIMESTAMPTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum wsu_TimestampType_e
{
    wsu_TimestampType_undefined,
    wsu_TimestampType_Received,
    wsu_TimestampType_any

};

/**
 * @defgroup wsu_TimestampType_choice Complex choice type: wsu_TimestampType
 * @ingroup wsu_TimestampType
 */

/**
 * Enumeration of the types of values which the wsu_TimestampType_choice
 * structure may take on.
 * @ingroup wsu_TimestampType_choice
 */
typedef enum wsu_TimestampType_e wsu_TimestampType_enum;
/**
 * Union of the values which the wsu_TimestampType_choice structure
 * contains
 * @ingroup wsu_TimestampType_choice
 */
typedef union wsu_TimestampType_u wsu_TimestampType_union;
/**
 * The wsu_TimestampType complex type, which represents the various values
 * possible by the choice used by the
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}choice 15 element.
 * @ingroup wsu_TimestampType_choice
 */
typedef struct wsu_TimestampType_choice_s wsu_TimestampType_choice;
/**
 * The wsu_TimestampType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}choice 15 element.
 * @ingroup wsu_TimestampType
 */
typedef wsu_TimestampType_choice * wsu_TimestampType_choice_o;

typedef struct wsu_TimestampType_choice_array_s
{
    wsu_TimestampType_choice * elements;
    int                                 length;
} wsu_TimestampType_choice_array;

#define WSU_TIMESTAMPTYPE_NS "http://schemas.xmlsoap.org/ws/2002/07/utility"
#define WSU_TIMESTAMPTYPE_LOCAL "TimestampType"

extern xsd_QName wsu_TimestampType_choice_qname;
extern struct globus_xsd_type_info_s wsu_TimestampType_choice_info;
extern struct globus_xsd_type_info_s wsu_TimestampType_choice_contents_info;
extern struct globus_xsd_type_info_s wsu_TimestampType_choice_array_info;


#include "wsu_ReceivedType.h"
#include "xsd_any.h"

union wsu_TimestampType_u
{
    /** wsu_ReceivedType subelement */
    wsu_ReceivedType Received;
    /** xsd_any subelement */
    xsd_any any;

};

struct wsu_TimestampType_choice_s
{
    wsu_TimestampType_enum type;
    wsu_TimestampType_union value;
};

globus_result_t
wsu_TimestampType_choice_init(
    wsu_TimestampType_choice ** inst);

void
wsu_TimestampType_choice_destroy(
    wsu_TimestampType_choice * inst);

globus_result_t
wsu_TimestampType_choice_copy(
    wsu_TimestampType_choice ** dest,
    const wsu_TimestampType_choice * src);

globus_result_t
wsu_TimestampType_choice_init_contents(
    wsu_TimestampType_choice * instance);

void
wsu_TimestampType_choice_destroy_contents(
    wsu_TimestampType_choice * inst);

globus_result_t
wsu_TimestampType_choice_copy_contents(
    wsu_TimestampType_choice * dest,
    const wsu_TimestampType_choice * src);
    
globus_result_t
wsu_TimestampType_choice_array_init(
    wsu_TimestampType_choice_array ** inst);

void
wsu_TimestampType_choice_array_destroy(
    wsu_TimestampType_choice_array * inst);

globus_result_t
wsu_TimestampType_choice_array_copy(
    wsu_TimestampType_choice_array ** dest,
    const wsu_TimestampType_choice_array * src);

globus_result_t
wsu_TimestampType_choice_array_init_contents(
    wsu_TimestampType_choice_array * inst);

void
wsu_TimestampType_choice_array_destroy_contents(
    wsu_TimestampType_choice_array * inst);

globus_result_t
wsu_TimestampType_choice_array_copy_contents(
    wsu_TimestampType_choice_array * dest,
    const wsu_TimestampType_choice_array * src);

wsu_TimestampType_choice *
wsu_TimestampType_choice_array_push(
    wsu_TimestampType_choice_array * array);

globus_result_t
wsu_TimestampType_choice_serialize(
    xsd_QName *                         element_name,
    wsu_TimestampType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_TimestampType_choice_serialize_contents(
    xsd_QName *                         element_name,
    wsu_TimestampType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_TimestampType_choice_deserialize(
    xsd_QName *                         element_name,
    wsu_TimestampType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_TimestampType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    wsu_TimestampType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_TimestampType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    wsu_TimestampType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_TimestampType_choice_array_serialize(
    xsd_QName *                         element,
    wsu_TimestampType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_TimestampType_choice_array_deserialize(
    xsd_QName *                         element,
    wsu_TimestampType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_TimestampType_choice_init_wrapper(
    void **                             object);
    
void
wsu_TimestampType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsu_TimestampType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsu_TimestampType_choice_init_contents_wrapper(
    void *                              object);
    
void
wsu_TimestampType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsu_TimestampType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsu_TimestampType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_TimestampType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_TimestampType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_TimestampType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_TimestampType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_TimestampType_choice_array_init_wrapper(
    void **                             arr);
    
void
wsu_TimestampType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsu_TimestampType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
wsu_TimestampType_choice_array_init_contents_wrapper(
    void *                              arr);

void
wsu_TimestampType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
wsu_TimestampType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
wsu_TimestampType_choice_array_push_wrapper(
    void * array);

globus_result_t
wsu_TimestampType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
