/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_BASEREQUESTTYPE_H_
#define _WSTRANSFER_BASEREQUESTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_BaseRequestType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}BaseRequestType element.
 * @ingroup wstransfer_BaseRequestType
 */
typedef struct wstransfer_BaseRequestType_s wstransfer_BaseRequestType;
/**
 * The wstransfer_BaseRequestType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}BaseRequestType element.
 * @ingroup wstransfer_BaseRequestType
 */
typedef wstransfer_BaseRequestType * wstransfer_BaseRequestType_o;

/**
 * Namespace of the wstransfer_BaseRequestType complex type
 * @ingroup wstransfer_BaseRequestType
 */
#define WSTRANSFER_BASEREQUESTTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_BaseRequestType complex type
 * @ingroup wstransfer_BaseRequestType
 */
#define WSTRANSFER_BASEREQUESTTYPE_LOCAL "BaseRequestType"

/**
 * QName of the wstransfer_BaseRequestType complex type
 * @ingroup wstransfer_BaseRequestType
 */
extern xsd_QName wstransfer_BaseRequestType_qname;
/**
 * Type information for serializing and deserializing wstransfer_BaseRequestType elements
 * @ingroup wstransfer_BaseRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_BaseRequestType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_BaseRequestType
 * elements
 * @ingroup wstransfer_BaseRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_BaseRequestType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_BaseRequestType without surrounding elements
 * @ingroup wstransfer_BaseRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_BaseRequestType_contents_info;


#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wstransfer_BaseRequestType_array.h"

/**
 * @defgroup wstransfer_BaseRequestType Complex type: wstransfer_BaseRequestType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_BaseRequestType complex type
 * @ingroup wstransfer_BaseRequestType
 */
struct wstransfer_BaseRequestType_s
{
   /** Optional xsd_int subelement */
    xsd_int_o concurrency;
   /** Optional xsd_int subelement */
    xsd_int_o maxAttempts;
   /** Optional xsd_dateTime subelement */
    xsd_dateTime_o finishBy;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o transferCredentialEndpoint;

};

/**
 * Initialize a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 *
 * Allocates a new wstransfer_BaseRequestType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_BaseRequestType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_BaseRequestType_init(
    wstransfer_BaseRequestType ** inst);

/**
 * Destroy a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 *
 * Frees a wstransfer_BaseRequestType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_BaseRequestType_destroy(
    wstransfer_BaseRequestType * inst);

/**
 * Copy a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 *
 * Perform a deep copy of a wstransfer_BaseRequestType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_BaseRequestType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_BaseRequestType to be copied.
 */
globus_result_t
wstransfer_BaseRequestType_copy(
    wstransfer_BaseRequestType ** dest,
    const wstransfer_BaseRequestType * src);

/**
 * Initialize the contents of a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 *
 * Initialize the contents of a wstransfer_BaseRequestType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_BaseRequestType_init(). The contents may be freed
 * by calling wstransfer_BaseRequestType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_BaseRequestType.
 */
globus_result_t
wstransfer_BaseRequestType_init_contents(
    wstransfer_BaseRequestType * instance);

/**
 * Destroy the contents of a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 *
 * Destroy the subelements and attributes of the given wstransfer_BaseRequestType. 
 *
 * @param inst
 *     Pointer to a wstransfer_BaseRequestType instance to destroy.
 */
void
wstransfer_BaseRequestType_destroy_contents(
    wstransfer_BaseRequestType * inst);

/**
 * Copy the contents of a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 *
 * Perform a deep copy of the contents of a wstransfer_BaseRequestType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_BaseRequestType to be copied.
 */
globus_result_t
wstransfer_BaseRequestType_copy_contents(
    wstransfer_BaseRequestType * dest,
    const wstransfer_BaseRequestType * src);

/**
 * Serialize a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType_array
 * Serialize a wstransfer_BaseRequestType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_BaseRequestType.
 * @param val
 *     The wstransfer_BaseRequestType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_BaseRequestType_serialize(
    xsd_QName *                         element_name,
    wstransfer_BaseRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType_array
 * Serialize a wstransfer_BaseRequestType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_BaseRequestType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_BaseRequestType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_BaseRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 * Deserialize an element containing a wstransfer_BaseRequestType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_BaseRequestType.
 * @param val
 *     Pointer to the wstransfer_BaseRequestType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_BaseRequestType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_BaseRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 * Deserialize a wstransfer_BaseRequestType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_BaseRequestType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_BaseRequestType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_BaseRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_BaseRequestType
 * @ingroup wstransfer_BaseRequestType
 * Deserialize the next element if it contains a wstransfer_BaseRequestType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_BaseRequestType.
 * @param instance
 *     Pointer to the <code>wstransfer_BaseRequestType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_BaseRequestType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_BaseRequestType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_BaseRequestType_init_wrapper(
    void **                             object);
    
void
wstransfer_BaseRequestType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_BaseRequestType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_BaseRequestType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_BaseRequestType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_BaseRequestType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_BaseRequestType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_BaseRequestType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_BaseRequestType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_BaseRequestType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
