/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_DELETETYPE_H_
#define _WSTRANSFER_DELETETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_DeleteType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}DeleteType element.
 * @ingroup wstransfer_DeleteType
 */
typedef struct wstransfer_DeleteType_s wstransfer_DeleteType;
/**
 * The wstransfer_DeleteType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}DeleteType element.
 * @ingroup wstransfer_DeleteType
 */
typedef wstransfer_DeleteType * wstransfer_DeleteType_o;

/**
 * Namespace of the wstransfer_DeleteType complex type
 * @ingroup wstransfer_DeleteType
 */
#define WSTRANSFER_DELETETYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_DeleteType complex type
 * @ingroup wstransfer_DeleteType
 */
#define WSTRANSFER_DELETETYPE_LOCAL "DeleteType"

/**
 * QName of the wstransfer_DeleteType complex type
 * @ingroup wstransfer_DeleteType
 */
extern xsd_QName wstransfer_DeleteType_qname;
/**
 * Type information for serializing and deserializing wstransfer_DeleteType elements
 * @ingroup wstransfer_DeleteType
 */
extern struct globus_xsd_type_info_s wstransfer_DeleteType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_DeleteType
 * elements
 * @ingroup wstransfer_DeleteType
 */
extern struct globus_xsd_type_info_s wstransfer_DeleteType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_DeleteType without surrounding elements
 * @ingroup wstransfer_DeleteType
 */
extern struct globus_xsd_type_info_s wstransfer_DeleteType_contents_info;


#include "xsd_int.h"
#include "xsd_string.h"
#include "wstransfer_DeleteOptionsType.h"
#include "wstransfer_DeleteType_array.h"

/**
 * @defgroup wstransfer_DeleteType Complex type: wstransfer_DeleteType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_DeleteType complex type
 * @ingroup wstransfer_DeleteType
 */
struct wstransfer_DeleteType_s
{
   /** Optional xsd_int subelement */
    xsd_int_o transferId;
    /** xsd_string subelement */
    xsd_string file;
   /** Optional wstransfer_DeleteOptionsType subelement */
    wstransfer_DeleteOptionsType_o deleteOptions;

};

/**
 * Initialize a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 *
 * Allocates a new wstransfer_DeleteType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_DeleteType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_DeleteType_init(
    wstransfer_DeleteType ** inst);

/**
 * Destroy a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 *
 * Frees a wstransfer_DeleteType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_DeleteType_destroy(
    wstransfer_DeleteType * inst);

/**
 * Copy a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 *
 * Perform a deep copy of a wstransfer_DeleteType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_DeleteType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_DeleteType to be copied.
 */
globus_result_t
wstransfer_DeleteType_copy(
    wstransfer_DeleteType ** dest,
    const wstransfer_DeleteType * src);

/**
 * Initialize the contents of a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 *
 * Initialize the contents of a wstransfer_DeleteType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_DeleteType_init(). The contents may be freed
 * by calling wstransfer_DeleteType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_DeleteType.
 */
globus_result_t
wstransfer_DeleteType_init_contents(
    wstransfer_DeleteType * instance);

/**
 * Destroy the contents of a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 *
 * Destroy the subelements and attributes of the given wstransfer_DeleteType. 
 *
 * @param inst
 *     Pointer to a wstransfer_DeleteType instance to destroy.
 */
void
wstransfer_DeleteType_destroy_contents(
    wstransfer_DeleteType * inst);

/**
 * Copy the contents of a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 *
 * Perform a deep copy of the contents of a wstransfer_DeleteType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_DeleteType to be copied.
 */
globus_result_t
wstransfer_DeleteType_copy_contents(
    wstransfer_DeleteType * dest,
    const wstransfer_DeleteType * src);

/**
 * Serialize a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType_array
 * Serialize a wstransfer_DeleteType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_DeleteType.
 * @param val
 *     The wstransfer_DeleteType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_DeleteType_serialize(
    xsd_QName *                         element_name,
    wstransfer_DeleteType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType_array
 * Serialize a wstransfer_DeleteType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_DeleteType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_DeleteType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_DeleteType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 * Deserialize an element containing a wstransfer_DeleteType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_DeleteType.
 * @param val
 *     Pointer to the wstransfer_DeleteType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_DeleteType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_DeleteType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 * Deserialize a wstransfer_DeleteType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_DeleteType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_DeleteType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_DeleteType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_DeleteType
 * @ingroup wstransfer_DeleteType
 * Deserialize the next element if it contains a wstransfer_DeleteType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_DeleteType.
 * @param instance
 *     Pointer to the <code>wstransfer_DeleteType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_DeleteType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_DeleteType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_DeleteType_init_wrapper(
    void **                             object);
    
void
wstransfer_DeleteType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_DeleteType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_DeleteType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_DeleteType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_DeleteType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_DeleteType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_DeleteType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_DeleteType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_DeleteType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
