/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_RFTAUTHENTICATIONFAULTTYPE_H_
#define _WSTRANSFER_RFTAUTHENTICATIONFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_RFTAuthenticationFaultType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}RFTAuthenticationFaultType element.
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
typedef struct wstransfer_RFTAuthenticationFaultType_s wstransfer_RFTAuthenticationFaultType;
/**
 * The wstransfer_RFTAuthenticationFaultType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}RFTAuthenticationFaultType element.
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
typedef wstransfer_RFTAuthenticationFaultType * wstransfer_RFTAuthenticationFaultType_o;

/**
 * Namespace of the wstransfer_RFTAuthenticationFaultType complex type
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
#define WSTRANSFER_RFTAUTHENTICATIONFAULTTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_RFTAuthenticationFaultType complex type
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
#define WSTRANSFER_RFTAUTHENTICATIONFAULTTYPE_LOCAL "RFTAuthenticationFaultType"

/**
 * QName of the wstransfer_RFTAuthenticationFaultType complex type
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
extern xsd_QName wstransfer_RFTAuthenticationFaultType_qname;
/**
 * Type information for serializing and deserializing wstransfer_RFTAuthenticationFaultType elements
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_RFTAuthenticationFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_RFTAuthenticationFaultType
 * elements
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_RFTAuthenticationFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_RFTAuthenticationFaultType without surrounding elements
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_RFTAuthenticationFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wstransfer_RFTAuthenticationFaultType_array.h"

/**
 * @defgroup wstransfer_RFTAuthenticationFaultType Complex type: wstransfer_RFTAuthenticationFaultType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_RFTAuthenticationFaultType complex type
 * @ingroup wstransfer_RFTAuthenticationFaultType
 */
struct wstransfer_RFTAuthenticationFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 *
 * Allocates a new wstransfer_RFTAuthenticationFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_RFTAuthenticationFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_init(
    wstransfer_RFTAuthenticationFaultType ** inst);

/**
 * Destroy a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 *
 * Frees a wstransfer_RFTAuthenticationFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_RFTAuthenticationFaultType_destroy(
    wstransfer_RFTAuthenticationFaultType * inst);

/**
 * Copy a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 *
 * Perform a deep copy of a wstransfer_RFTAuthenticationFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_RFTAuthenticationFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_RFTAuthenticationFaultType to be copied.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_copy(
    wstransfer_RFTAuthenticationFaultType ** dest,
    const wstransfer_RFTAuthenticationFaultType * src);

/**
 * Initialize the contents of a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 *
 * Initialize the contents of a wstransfer_RFTAuthenticationFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_RFTAuthenticationFaultType_init(). The contents may be freed
 * by calling wstransfer_RFTAuthenticationFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_RFTAuthenticationFaultType.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_init_contents(
    wstransfer_RFTAuthenticationFaultType * instance);

/**
 * Destroy the contents of a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 *
 * Destroy the subelements and attributes of the given wstransfer_RFTAuthenticationFaultType. 
 *
 * @param inst
 *     Pointer to a wstransfer_RFTAuthenticationFaultType instance to destroy.
 */
void
wstransfer_RFTAuthenticationFaultType_destroy_contents(
    wstransfer_RFTAuthenticationFaultType * inst);

/**
 * Copy the contents of a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 *
 * Perform a deep copy of the contents of a wstransfer_RFTAuthenticationFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_RFTAuthenticationFaultType to be copied.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_copy_contents(
    wstransfer_RFTAuthenticationFaultType * dest,
    const wstransfer_RFTAuthenticationFaultType * src);

/**
 * Serialize a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType_array
 * Serialize a wstransfer_RFTAuthenticationFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_RFTAuthenticationFaultType.
 * @param val
 *     The wstransfer_RFTAuthenticationFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_serialize(
    xsd_QName *                         element_name,
    wstransfer_RFTAuthenticationFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType_array
 * Serialize a wstransfer_RFTAuthenticationFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_RFTAuthenticationFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_RFTAuthenticationFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 * Deserialize an element containing a wstransfer_RFTAuthenticationFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_RFTAuthenticationFaultType.
 * @param val
 *     Pointer to the wstransfer_RFTAuthenticationFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_RFTAuthenticationFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 * Deserialize a wstransfer_RFTAuthenticationFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_RFTAuthenticationFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_RFTAuthenticationFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_RFTAuthenticationFaultType
 * @ingroup wstransfer_RFTAuthenticationFaultType
 * Deserialize the next element if it contains a wstransfer_RFTAuthenticationFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_RFTAuthenticationFaultType.
 * @param instance
 *     Pointer to the <code>wstransfer_RFTAuthenticationFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RFTAuthenticationFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_RFTAuthenticationFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_RFTAuthenticationFaultType_init_wrapper(
    void **                             object);
    
void
wstransfer_RFTAuthenticationFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_RFTAuthenticationFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_RFTAuthenticationFaultType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_RFTAuthenticationFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_RFTAuthenticationFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_RFTAuthenticationFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_RFTAuthenticationFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_RFTAuthenticationFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_RFTAuthenticationFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
