/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_RFTDATABASEFAULTTYPE_H_
#define _WSTRANSFER_RFTDATABASEFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_RFTDatabaseFaultType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}RFTDatabaseFaultType element.
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
typedef struct wstransfer_RFTDatabaseFaultType_s wstransfer_RFTDatabaseFaultType;
/**
 * The wstransfer_RFTDatabaseFaultType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}RFTDatabaseFaultType element.
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
typedef wstransfer_RFTDatabaseFaultType * wstransfer_RFTDatabaseFaultType_o;

/**
 * Namespace of the wstransfer_RFTDatabaseFaultType complex type
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
#define WSTRANSFER_RFTDATABASEFAULTTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_RFTDatabaseFaultType complex type
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
#define WSTRANSFER_RFTDATABASEFAULTTYPE_LOCAL "RFTDatabaseFaultType"

/**
 * QName of the wstransfer_RFTDatabaseFaultType complex type
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
extern xsd_QName wstransfer_RFTDatabaseFaultType_qname;
/**
 * Type information for serializing and deserializing wstransfer_RFTDatabaseFaultType elements
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_RFTDatabaseFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_RFTDatabaseFaultType
 * elements
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_RFTDatabaseFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_RFTDatabaseFaultType without surrounding elements
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_RFTDatabaseFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wstransfer_RFTDatabaseFaultType_array.h"

/**
 * @defgroup wstransfer_RFTDatabaseFaultType Complex type: wstransfer_RFTDatabaseFaultType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_RFTDatabaseFaultType complex type
 * @ingroup wstransfer_RFTDatabaseFaultType
 */
struct wstransfer_RFTDatabaseFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 *
 * Allocates a new wstransfer_RFTDatabaseFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_RFTDatabaseFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_init(
    wstransfer_RFTDatabaseFaultType ** inst);

/**
 * Destroy a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 *
 * Frees a wstransfer_RFTDatabaseFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_RFTDatabaseFaultType_destroy(
    wstransfer_RFTDatabaseFaultType * inst);

/**
 * Copy a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 *
 * Perform a deep copy of a wstransfer_RFTDatabaseFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_RFTDatabaseFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_RFTDatabaseFaultType to be copied.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_copy(
    wstransfer_RFTDatabaseFaultType ** dest,
    const wstransfer_RFTDatabaseFaultType * src);

/**
 * Initialize the contents of a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 *
 * Initialize the contents of a wstransfer_RFTDatabaseFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_RFTDatabaseFaultType_init(). The contents may be freed
 * by calling wstransfer_RFTDatabaseFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_RFTDatabaseFaultType.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_init_contents(
    wstransfer_RFTDatabaseFaultType * instance);

/**
 * Destroy the contents of a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 *
 * Destroy the subelements and attributes of the given wstransfer_RFTDatabaseFaultType. 
 *
 * @param inst
 *     Pointer to a wstransfer_RFTDatabaseFaultType instance to destroy.
 */
void
wstransfer_RFTDatabaseFaultType_destroy_contents(
    wstransfer_RFTDatabaseFaultType * inst);

/**
 * Copy the contents of a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 *
 * Perform a deep copy of the contents of a wstransfer_RFTDatabaseFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_RFTDatabaseFaultType to be copied.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_copy_contents(
    wstransfer_RFTDatabaseFaultType * dest,
    const wstransfer_RFTDatabaseFaultType * src);

/**
 * Serialize a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType_array
 * Serialize a wstransfer_RFTDatabaseFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_RFTDatabaseFaultType.
 * @param val
 *     The wstransfer_RFTDatabaseFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_serialize(
    xsd_QName *                         element_name,
    wstransfer_RFTDatabaseFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType_array
 * Serialize a wstransfer_RFTDatabaseFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_RFTDatabaseFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_RFTDatabaseFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 * Deserialize an element containing a wstransfer_RFTDatabaseFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_RFTDatabaseFaultType.
 * @param val
 *     Pointer to the wstransfer_RFTDatabaseFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_RFTDatabaseFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 * Deserialize a wstransfer_RFTDatabaseFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_RFTDatabaseFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_RFTDatabaseFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_RFTDatabaseFaultType
 * @ingroup wstransfer_RFTDatabaseFaultType
 * Deserialize the next element if it contains a wstransfer_RFTDatabaseFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_RFTDatabaseFaultType.
 * @param instance
 *     Pointer to the <code>wstransfer_RFTDatabaseFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RFTDatabaseFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_RFTDatabaseFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_RFTDatabaseFaultType_init_wrapper(
    void **                             object);
    
void
wstransfer_RFTDatabaseFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_RFTDatabaseFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_RFTDatabaseFaultType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_RFTDatabaseFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_RFTDatabaseFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_RFTDatabaseFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_RFTDatabaseFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_RFTDatabaseFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_RFTDatabaseFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
