/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_TRANSFERFAULTTYPE_H_
#define _WSTRANSFER_TRANSFERFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_TransferFaultType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}TransferFaultType element.
 * @ingroup wstransfer_TransferFaultType
 */
typedef struct wstransfer_TransferFaultType_s wstransfer_TransferFaultType;
/**
 * The wstransfer_TransferFaultType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}TransferFaultType element.
 * @ingroup wstransfer_TransferFaultType
 */
typedef wstransfer_TransferFaultType * wstransfer_TransferFaultType_o;

/**
 * Namespace of the wstransfer_TransferFaultType complex type
 * @ingroup wstransfer_TransferFaultType
 */
#define WSTRANSFER_TRANSFERFAULTTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_TransferFaultType complex type
 * @ingroup wstransfer_TransferFaultType
 */
#define WSTRANSFER_TRANSFERFAULTTYPE_LOCAL "TransferFaultType"

/**
 * QName of the wstransfer_TransferFaultType complex type
 * @ingroup wstransfer_TransferFaultType
 */
extern xsd_QName wstransfer_TransferFaultType_qname;
/**
 * Type information for serializing and deserializing wstransfer_TransferFaultType elements
 * @ingroup wstransfer_TransferFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_TransferFaultType
 * elements
 * @ingroup wstransfer_TransferFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_TransferFaultType without surrounding elements
 * @ingroup wstransfer_TransferFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wstransfer_TransferFaultType_array.h"

/**
 * @defgroup wstransfer_TransferFaultType Complex type: wstransfer_TransferFaultType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_TransferFaultType complex type
 * @ingroup wstransfer_TransferFaultType
 */
struct wstransfer_TransferFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 *
 * Allocates a new wstransfer_TransferFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_TransferFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_TransferFaultType_init(
    wstransfer_TransferFaultType ** inst);

/**
 * Destroy a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 *
 * Frees a wstransfer_TransferFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_TransferFaultType_destroy(
    wstransfer_TransferFaultType * inst);

/**
 * Copy a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 *
 * Perform a deep copy of a wstransfer_TransferFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_TransferFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_TransferFaultType to be copied.
 */
globus_result_t
wstransfer_TransferFaultType_copy(
    wstransfer_TransferFaultType ** dest,
    const wstransfer_TransferFaultType * src);

/**
 * Initialize the contents of a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 *
 * Initialize the contents of a wstransfer_TransferFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_TransferFaultType_init(). The contents may be freed
 * by calling wstransfer_TransferFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_TransferFaultType.
 */
globus_result_t
wstransfer_TransferFaultType_init_contents(
    wstransfer_TransferFaultType * instance);

/**
 * Destroy the contents of a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 *
 * Destroy the subelements and attributes of the given wstransfer_TransferFaultType. 
 *
 * @param inst
 *     Pointer to a wstransfer_TransferFaultType instance to destroy.
 */
void
wstransfer_TransferFaultType_destroy_contents(
    wstransfer_TransferFaultType * inst);

/**
 * Copy the contents of a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 *
 * Perform a deep copy of the contents of a wstransfer_TransferFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_TransferFaultType to be copied.
 */
globus_result_t
wstransfer_TransferFaultType_copy_contents(
    wstransfer_TransferFaultType * dest,
    const wstransfer_TransferFaultType * src);

/**
 * Serialize a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType_array
 * Serialize a wstransfer_TransferFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_TransferFaultType.
 * @param val
 *     The wstransfer_TransferFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_TransferFaultType_serialize(
    xsd_QName *                         element_name,
    wstransfer_TransferFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType_array
 * Serialize a wstransfer_TransferFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_TransferFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_TransferFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_TransferFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 * Deserialize an element containing a wstransfer_TransferFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_TransferFaultType.
 * @param val
 *     Pointer to the wstransfer_TransferFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferFaultType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_TransferFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 * Deserialize a wstransfer_TransferFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_TransferFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_TransferFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_TransferFaultType
 * @ingroup wstransfer_TransferFaultType
 * Deserialize the next element if it contains a wstransfer_TransferFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_TransferFaultType.
 * @param instance
 *     Pointer to the <code>wstransfer_TransferFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_TransferFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_TransferFaultType_init_wrapper(
    void **                             object);
    
void
wstransfer_TransferFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_TransferFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_TransferFaultType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_TransferFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_TransferFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_TransferFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_TransferFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_TransferFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_TransferFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
