/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_TRANSFERTYPE_H_
#define _WSTRANSFER_TRANSFERTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_TransferType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}TransferType element.
 * @ingroup wstransfer_TransferType
 */
typedef struct wstransfer_TransferType_s wstransfer_TransferType;
/**
 * The wstransfer_TransferType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}TransferType element.
 * @ingroup wstransfer_TransferType
 */
typedef wstransfer_TransferType * wstransfer_TransferType_o;

/**
 * Namespace of the wstransfer_TransferType complex type
 * @ingroup wstransfer_TransferType
 */
#define WSTRANSFER_TRANSFERTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_TransferType complex type
 * @ingroup wstransfer_TransferType
 */
#define WSTRANSFER_TRANSFERTYPE_LOCAL "TransferType"

/**
 * QName of the wstransfer_TransferType complex type
 * @ingroup wstransfer_TransferType
 */
extern xsd_QName wstransfer_TransferType_qname;
/**
 * Type information for serializing and deserializing wstransfer_TransferType elements
 * @ingroup wstransfer_TransferType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_TransferType
 * elements
 * @ingroup wstransfer_TransferType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_TransferType without surrounding elements
 * @ingroup wstransfer_TransferType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferType_contents_info;


#include "xsd_int.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "wstransfer_TransferStatusTypeEnumeration.h"
#include "xsd_int.h"
#include "xsd_long.h"
#include "wstransfer_RFTOptionsType.h"
#include "xsd_long.h"
#include "wstransfer_TransferType_array.h"

/**
 * @defgroup wstransfer_TransferType Complex type: wstransfer_TransferType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_TransferType complex type
 * @ingroup wstransfer_TransferType
 */
struct wstransfer_TransferType_s
{
   /** Optional xsd_int subelement */
    xsd_int_o transferId;
    /** xsd_string subelement */
    xsd_string sourceUrl;
    /** xsd_string subelement */
    xsd_string destinationUrl;
   /** Optional wstransfer_TransferStatusTypeEnumeration subelement */
    wstransfer_TransferStatusTypeEnumeration_o status;
   /** Optional xsd_int subelement */
    xsd_int_o attempts;
   /** Optional xsd_long subelement */
    xsd_long_o retry_time;
   /** Optional wstransfer_RFTOptionsType subelement */
    wstransfer_RFTOptionsType_o rftOptions;
   /** Optional xsd_long subelement */
    xsd_long_o size;

};

/**
 * Initialize a wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 *
 * Allocates a new wstransfer_TransferType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_TransferType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_TransferType_init(
    wstransfer_TransferType ** inst);

/**
 * Destroy a wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 *
 * Frees a wstransfer_TransferType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_TransferType_destroy(
    wstransfer_TransferType * inst);

/**
 * Copy a wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 *
 * Perform a deep copy of a wstransfer_TransferType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_TransferType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_TransferType to be copied.
 */
globus_result_t
wstransfer_TransferType_copy(
    wstransfer_TransferType ** dest,
    const wstransfer_TransferType * src);

/**
 * Initialize the contents of a wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 *
 * Initialize the contents of a wstransfer_TransferType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_TransferType_init(). The contents may be freed
 * by calling wstransfer_TransferType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_TransferType.
 */
globus_result_t
wstransfer_TransferType_init_contents(
    wstransfer_TransferType * instance);

/**
 * Destroy the contents of a wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 *
 * Destroy the subelements and attributes of the given wstransfer_TransferType. 
 *
 * @param inst
 *     Pointer to a wstransfer_TransferType instance to destroy.
 */
void
wstransfer_TransferType_destroy_contents(
    wstransfer_TransferType * inst);

/**
 * Copy the contents of a wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 *
 * Perform a deep copy of the contents of a wstransfer_TransferType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_TransferType to be copied.
 */
globus_result_t
wstransfer_TransferType_copy_contents(
    wstransfer_TransferType * dest,
    const wstransfer_TransferType * src);

/**
 * Serialize a wstransfer_TransferType
 * @ingroup wstransfer_TransferType_array
 * Serialize a wstransfer_TransferType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_TransferType.
 * @param val
 *     The wstransfer_TransferType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_TransferType_serialize(
    xsd_QName *                         element_name,
    wstransfer_TransferType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_TransferType
 * @ingroup wstransfer_TransferType_array
 * Serialize a wstransfer_TransferType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_TransferType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_TransferType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_TransferType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 * Deserialize an element containing a wstransfer_TransferType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_TransferType.
 * @param val
 *     Pointer to the wstransfer_TransferType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_TransferType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 * Deserialize a wstransfer_TransferType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_TransferType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_TransferType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_TransferType
 * @ingroup wstransfer_TransferType
 * Deserialize the next element if it contains a wstransfer_TransferType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_TransferType.
 * @param instance
 *     Pointer to the <code>wstransfer_TransferType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_TransferType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_TransferType_init_wrapper(
    void **                             object);
    
void
wstransfer_TransferType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_TransferType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_TransferType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_TransferType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_TransferType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_TransferType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_TransferType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_TransferType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_TransferType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
