/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _MANAGEDEXECUTABLEJOBSERVICE_CLIENT_H_
#define _MANAGEDEXECUTABLEJOBSERVICE_CLIENT_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "ManagedExecutableJobService.h"
#include "wsa_EndpointReferenceType.h"
#include "globus_soap_message_attrs.h"

#define WSADDRESSING_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"

/**
 * @defgroup ManagedExecutableJobService_client ManagedExecutableJobService Client Bindings
 */

extern globus_module_descriptor_t ManagedExecutableJobService_i_module;
/**
 * Module descriptor for the client stubs bindings for the
 * ManagedExecutableJobService service.
 * @ingroup ManagedExecutableJobService_client
 * @hideinitializer
 *
 * This module must be activated before calling any functions in the ManagedExecutableJobService
 * client bindings API.
 */
#define MANAGEDEXECUTABLEJOBSERVICE_MODULE (&ManagedExecutableJobService_i_module)

/**
 * @defgroup ManagedExecutableJobService_client_handle Client Handle Functions and Types
 * @ingroup ManagedExecutableJobService_client
 */

/**
 * Handle for the ManagedExecutableJobService client.
 * @ingroup ManagedExecutableJobService_client_handle
 *
 * A handle must be created by the client application before calling any
 * SOAP operation. Only one operation may be in progress per handle at
 * any given time.
 *
 * @see ManagedExecutableJobService_client_init(), ManagedExecutableJobService_client_destroy()
 */
typedef struct ManagedExecutableJobService_client_handle_s * ManagedExecutableJobService_client_handle_t;



/* Type and function declarations for the GetMultipleResourceProperties
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation GetMultipleResourceProperties Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetMultipleResourceProperties requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_GetMultipleResourceProperties() and ManagedExecutableJobPortType_GetMultipleResourceProperties_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_GetMultipleResourceProperties_register() and
 * ManagedExecutableJobPortType_GetMultipleResourceProperties_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetMultipleResourceProperties</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_GetMultipleResourceProperties_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 * Begin sending a request for the <code>GetMultipleResourceProperties</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetMultipleResourceProperties_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    ManagedExecutableJobPortType_GetMultipleResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 * Begin sending a request for the <code>GetMultipleResourceProperties</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetMultipleResourceProperties_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    ManagedExecutableJobPortType_GetMultipleResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetMultipleResourceProperties</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_GetMultipleResourceProperties_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetMultipleResourcePropertiesResponseType * GetMultipleResourcePropertiesResponse,
    ManagedExecutableJobPortType_GetMultipleResourceProperties_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 * Begin parsing the request for the <code>GetMultipleResourceProperties</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_GetMultipleResourceProperties_register_request() or
 * ManagedExecutableJobPortType_GetMultipleResourceProperties_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetMultipleResourceProperties_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 *
 * Begin processing a request for the GetMultipleResourceProperties operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetMultipleResourceProperties_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    ManagedExecutableJobPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 *
 * Begin processing a request for the GetMultipleResourceProperties operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetMultipleResourceProperties_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    ManagedExecutableJobPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 *
 * Request that an the GetMultipleResourceProperties operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetMultipleResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.

 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_GetMultipleResourceProperties_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    wsrp_GetMultipleResourcePropertiesResponseType * * GetMultipleResourcePropertiesResponse,
    ManagedExecutableJobPortType_GetMultipleResourceProperties_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_GetMultipleResourceProperties_operation
 *
 * Request that an the GetMultipleResourceProperties operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetMultipleResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.

 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_GetMultipleResourceProperties(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    wsrp_GetMultipleResourcePropertiesResponseType * * GetMultipleResourcePropertiesResponse,
    ManagedExecutableJobPortType_GetMultipleResourceProperties_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the QueryResourceProperties
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_QueryResourceProperties_operation QueryResourceProperties Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making QueryResourceProperties requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_QueryResourceProperties() and ManagedExecutableJobPortType_QueryResourceProperties_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_QueryResourceProperties_register() and
 * ManagedExecutableJobPortType_QueryResourceProperties_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>QueryResourceProperties</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_QueryResourceProperties_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 * Begin sending a request for the <code>QueryResourceProperties</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_QueryResourceProperties_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    ManagedExecutableJobPortType_QueryResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 * Begin sending a request for the <code>QueryResourceProperties</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_QueryResourceProperties_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    ManagedExecutableJobPortType_QueryResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>QueryResourceProperties</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_QueryResourceProperties_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_QueryResourcePropertiesResponseType * QueryResourcePropertiesResponse,
    ManagedExecutableJobPortType_QueryResourceProperties_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 * Begin parsing the request for the <code>QueryResourceProperties</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_QueryResourceProperties_register_request() or
 * ManagedExecutableJobPortType_QueryResourceProperties_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_QueryResourceProperties_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 *
 * Begin processing a request for the QueryResourceProperties operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_QueryResourceProperties_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    ManagedExecutableJobPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 *
 * Begin processing a request for the QueryResourceProperties operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_QueryResourceProperties_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    ManagedExecutableJobPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 *
 * Request that an the QueryResourceProperties operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a QueryResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.

 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_QueryResourceProperties_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * * QueryResourcePropertiesResponse,
    ManagedExecutableJobPortType_QueryResourceProperties_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_QueryResourceProperties_operation
 *
 * Request that an the QueryResourceProperties operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a QueryResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.

 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_QueryResourceProperties(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * * QueryResourcePropertiesResponse,
    ManagedExecutableJobPortType_QueryResourceProperties_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the Destroy
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_Destroy_operation Destroy Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making Destroy requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_Destroy() and ManagedExecutableJobPortType_Destroy_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_Destroy_register() and
 * ManagedExecutableJobPortType_Destroy_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>Destroy</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_Destroy_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 * Begin sending a request for the <code>Destroy</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Destroy_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    ManagedExecutableJobPortType_Destroy_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 * Begin sending a request for the <code>Destroy</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Destroy_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    ManagedExecutableJobPortType_Destroy_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>Destroy</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_Destroy_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrl_DestroyResponseType * DestroyResponse,
    ManagedExecutableJobPortType_Destroy_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 * Begin parsing the request for the <code>Destroy</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_Destroy_register_request() or
 * ManagedExecutableJobPortType_Destroy_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Destroy_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_Destroy_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 *
 * Begin processing a request for the Destroy operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Destroy_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    ManagedExecutableJobPortType_Destroy_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 *
 * Begin processing a request for the Destroy operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Destroy_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    ManagedExecutableJobPortType_Destroy_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 *
 * Request that an the Destroy operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a DestroyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.

 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_Destroy_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    wsrl_DestroyResponseType * * DestroyResponse,
    ManagedExecutableJobPortType_Destroy_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_Destroy_operation
 *
 * Request that an the Destroy operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a DestroyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.

 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_Destroy(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    wsrl_DestroyResponseType * * DestroyResponse,
    ManagedExecutableJobPortType_Destroy_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the SetTerminationTime
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_SetTerminationTime_operation SetTerminationTime Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making SetTerminationTime requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_SetTerminationTime() and ManagedExecutableJobPortType_SetTerminationTime_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_SetTerminationTime_register() and
 * ManagedExecutableJobPortType_SetTerminationTime_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>SetTerminationTime</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_SetTerminationTime_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 * Begin sending a request for the <code>SetTerminationTime</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_SetTerminationTime_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    ManagedExecutableJobPortType_SetTerminationTime_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 * Begin sending a request for the <code>SetTerminationTime</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_SetTerminationTime_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    ManagedExecutableJobPortType_SetTerminationTime_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>SetTerminationTime</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_SetTerminationTime_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrl_SetTerminationTimeResponseType * SetTerminationTimeResponse,
    ManagedExecutableJobPortType_SetTerminationTime_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 * Begin parsing the request for the <code>SetTerminationTime</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_SetTerminationTime_register_request() or
 * ManagedExecutableJobPortType_SetTerminationTime_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_SetTerminationTime_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_SetTerminationTime_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 *
 * Begin processing a request for the SetTerminationTime operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_SetTerminationTime_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    ManagedExecutableJobPortType_SetTerminationTime_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 *
 * Begin processing a request for the SetTerminationTime operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_SetTerminationTime_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    ManagedExecutableJobPortType_SetTerminationTime_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 *
 * Request that an the SetTerminationTime operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SetTerminationTimeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.

 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_SetTerminationTime_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    wsrl_SetTerminationTimeResponseType * * SetTerminationTimeResponse,
    ManagedExecutableJobPortType_SetTerminationTime_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_SetTerminationTime_operation
 *
 * Request that an the SetTerminationTime operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SetTerminationTimeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.

 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_SetTerminationTime(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    wsrl_SetTerminationTimeResponseType * * SetTerminationTimeResponse,
    ManagedExecutableJobPortType_SetTerminationTime_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the GetCurrentMessage
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_GetCurrentMessage_operation GetCurrentMessage Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetCurrentMessage requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_GetCurrentMessage() and ManagedExecutableJobPortType_GetCurrentMessage_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_GetCurrentMessage_register() and
 * ManagedExecutableJobPortType_GetCurrentMessage_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetCurrentMessage</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_GetCurrentMessage_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 * Begin sending a request for the <code>GetCurrentMessage</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetCurrentMessage
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetCurrentMessage_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    ManagedExecutableJobPortType_GetCurrentMessage_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 * Begin sending a request for the <code>GetCurrentMessage</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetCurrentMessage
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetCurrentMessage_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    ManagedExecutableJobPortType_GetCurrentMessage_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetCurrentMessage</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetCurrentMessageResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_GetCurrentMessage_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsnt_GetCurrentMessageResponseType * GetCurrentMessageResponse,
    ManagedExecutableJobPortType_GetCurrentMessage_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 * Begin parsing the request for the <code>GetCurrentMessage</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_GetCurrentMessage_register_request() or
 * ManagedExecutableJobPortType_GetCurrentMessage_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetCurrentMessage_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_GetCurrentMessage_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 *
 * Begin processing a request for the GetCurrentMessage operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetCurrentMessage
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetCurrentMessage_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    ManagedExecutableJobPortType_GetCurrentMessage_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 *
 * Begin processing a request for the GetCurrentMessage operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetCurrentMessage
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetCurrentMessage_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    ManagedExecutableJobPortType_GetCurrentMessage_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 *
 * Request that an the GetCurrentMessage operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetCurrentMessageResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetCurrentMessage
 *     Input parameter to the operation.

 * @param GetCurrentMessageResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_GetCurrentMessage_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    wsnt_GetCurrentMessageResponseType * * GetCurrentMessageResponse,
    ManagedExecutableJobPortType_GetCurrentMessage_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_GetCurrentMessage_operation
 *
 * Request that an the GetCurrentMessage operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetCurrentMessageResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetCurrentMessage
 *     Input parameter to the operation.

 * @param GetCurrentMessageResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_GetCurrentMessage(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    wsnt_GetCurrentMessageResponseType * * GetCurrentMessageResponse,
    ManagedExecutableJobPortType_GetCurrentMessage_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the Subscribe
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_Subscribe_operation Subscribe Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making Subscribe requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_Subscribe() and ManagedExecutableJobPortType_Subscribe_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_Subscribe_register() and
 * ManagedExecutableJobPortType_Subscribe_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>Subscribe</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_Subscribe_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 * Begin sending a request for the <code>Subscribe</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Subscribe
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Subscribe_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_SubscribeType * Subscribe,
    ManagedExecutableJobPortType_Subscribe_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 * Begin sending a request for the <code>Subscribe</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Subscribe
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Subscribe_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsnt_SubscribeType * Subscribe,
    ManagedExecutableJobPortType_Subscribe_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>Subscribe</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param SubscribeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_Subscribe_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsnt_SubscribeResponseType * SubscribeResponse,
    ManagedExecutableJobPortType_Subscribe_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 * Begin parsing the request for the <code>Subscribe</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_Subscribe_register_request() or
 * ManagedExecutableJobPortType_Subscribe_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Subscribe_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_Subscribe_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 *
 * Begin processing a request for the Subscribe operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Subscribe
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Subscribe_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_SubscribeType * Subscribe,
    ManagedExecutableJobPortType_Subscribe_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 *
 * Begin processing a request for the Subscribe operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Subscribe
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_Subscribe_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsnt_SubscribeType * Subscribe,
    ManagedExecutableJobPortType_Subscribe_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 *
 * Request that an the Subscribe operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SubscribeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Subscribe
 *     Input parameter to the operation.

 * @param SubscribeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_Subscribe_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_SubscribeType * Subscribe,
    wsnt_SubscribeResponseType * * SubscribeResponse,
    ManagedExecutableJobPortType_Subscribe_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_Subscribe_operation
 *
 * Request that an the Subscribe operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SubscribeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Subscribe
 *     Input parameter to the operation.

 * @param SubscribeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_Subscribe(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsnt_SubscribeType * Subscribe,
    wsnt_SubscribeResponseType * * SubscribeResponse,
    ManagedExecutableJobPortType_Subscribe_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the GetResourceProperty
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_GetResourceProperty_operation GetResourceProperty Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetResourceProperty requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_GetResourceProperty() and ManagedExecutableJobPortType_GetResourceProperty_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_GetResourceProperty_register() and
 * ManagedExecutableJobPortType_GetResourceProperty_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetResourceProperty</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_GetResourceProperty_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetResourceProperty_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    ManagedExecutableJobPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetResourceProperty_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    ManagedExecutableJobPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetResourceProperty</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_GetResourceProperty_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetResourcePropertyResponseType * GetResourcePropertyResponse,
    ManagedExecutableJobPortType_GetResourceProperty_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 * Begin parsing the request for the <code>GetResourceProperty</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_GetResourceProperty_register_request() or
 * ManagedExecutableJobPortType_GetResourceProperty_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetResourceProperty_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetResourceProperty_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    ManagedExecutableJobPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_GetResourceProperty_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    ManagedExecutableJobPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_GetResourceProperty_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    ManagedExecutableJobPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_GetResourceProperty(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    ManagedExecutableJobPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the register
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_register_operation register Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making register requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_register() and ManagedExecutableJobPortType_register_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_register_register() and
 * ManagedExecutableJobPortType_register_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_register_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>register</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_register_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_register_operation
 * Begin sending a request for the <code>register</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param registerInput
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_register_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_registerInputType * registerInput,
    ManagedExecutableJobPortType_register_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_register_operation
 * Begin sending a request for the <code>register</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param registerInput
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_register_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_registerInputType * registerInput,
    ManagedExecutableJobPortType_register_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_register_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>register</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param registerResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_register_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrendezvous_registerResponseType * registerResponse,
    ManagedExecutableJobPortType_register_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_register_operation
 * Begin parsing the request for the <code>register</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_register_register_request() or
 * ManagedExecutableJobPortType_register_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_register_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_register_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_register_operation
 *
 * Begin processing a request for the register operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param registerInput
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_register_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_registerInputType * registerInput,
    ManagedExecutableJobPortType_register_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_register_operation
 *
 * Begin processing a request for the register operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param registerInput
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_register_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_registerInputType * registerInput,
    ManagedExecutableJobPortType_register_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_register_operation
 *
 * Request that an the register operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a registerResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param registerInput
 *     Input parameter to the operation.

 * @param registerResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_register_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_registerInputType * registerInput,
    wsrendezvous_registerResponseType * * registerResponse,
    ManagedExecutableJobPortType_register_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_register_operation
 *
 * Request that an the register operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a registerResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param registerInput
 *     Input parameter to the operation.

 * @param registerResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_registerInputType * registerInput,
    wsrendezvous_registerResponseType * * registerResponse,
    ManagedExecutableJobPortType_register_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the release
 * operation
 */

/**
 * @defgroup ManagedExecutableJobPortType_release_operation release Operation
 * @ingroup ManagedExecutableJobService_client
 *
 * The functions and types in this group are used by clients which will
 * be making release requests of the ManagedExecutableJobService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * ManagedExecutableJobPortType_release() and ManagedExecutableJobPortType_release_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, ManagedExecutableJobPortType_release_register() and
 * ManagedExecutableJobPortType_release_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup ManagedExecutableJobPortType_release_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>release</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* ManagedExecutableJobPortType_release_request_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup ManagedExecutableJobPortType_release_operation
 * Begin sending a request for the <code>release</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param release
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_release_epr_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsgram_ReleaseInputType * release,
    ManagedExecutableJobPortType_release_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup ManagedExecutableJobPortType_release_operation
 * Begin sending a request for the <code>release</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param release
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_release_register_request(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsgram_ReleaseInputType * release,
    ManagedExecutableJobPortType_release_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup ManagedExecutableJobPortType_release_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>release</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param releaseResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* ManagedExecutableJobPortType_release_response_callback_func_t)(
    ManagedExecutableJobService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsgram_ReleaseOutputType * releaseResponse,
    ManagedExecutableJobPortType_release_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup ManagedExecutableJobPortType_release_operation
 * Begin parsing the request for the <code>release</code> operation begun
 * by an earlier call to
 * ManagedExecutableJobPortType_release_register_request() or
 * ManagedExecutableJobPortType_release_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_release_register_response(
    ManagedExecutableJobService_client_handle_t handle,
    ManagedExecutableJobPortType_release_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_release_operation
 *
 * Begin processing a request for the release operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param release
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_release_epr_register(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsgram_ReleaseInputType * release,
    ManagedExecutableJobPortType_release_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup ManagedExecutableJobPortType_release_operation
 *
 * Begin processing a request for the release operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param release
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
ManagedExecutableJobPortType_release_register(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsgram_ReleaseInputType * release,
    ManagedExecutableJobPortType_release_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup ManagedExecutableJobPortType_release_operation
 *
 * Request that an the release operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a releaseResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param release
 *     Input parameter to the operation.

 * @param releaseResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_release_epr(
    ManagedExecutableJobService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsgram_ReleaseInputType * release,
    wsgram_ReleaseOutputType * * releaseResponse,
    ManagedExecutableJobPortType_release_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup ManagedExecutableJobPortType_release_operation
 *
 * Request that an the release operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a releaseResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #ManagedExecutableJobService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param release
 *     Input parameter to the operation.

 * @param releaseResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
ManagedExecutableJobPortType_release(
    ManagedExecutableJobService_client_handle_t handle,
    const char * endpoint,
    const wsgram_ReleaseInputType * release,
    wsgram_ReleaseOutputType * * releaseResponse,
    ManagedExecutableJobPortType_release_fault_t * fault_type,
    xsd_any * * fault);



/**
 * Initialize a client handle
 * @ingroup ManagedExecutableJobService_client_handle
 * Initialize new client handle state for use with operation-related functions.
 *
 * @param handle
 *     Pointer to the handle to initialize.
 * @param attrs
 *    Default attributes to use with this handle. This parameter may be NULL.
 *    Certain atttributes may cause different handlers to be pushed onto the
 *    default handler chain for this client.
 * @param handlers
 *    Handle chain to use with this handle. This parameter may be NULL.
 *    Typically the default handler chain used by this function is sufficient.
 */
globus_result_t
ManagedExecutableJobService_client_init(
    ManagedExecutableJobService_client_handle_t *  handle,
    globus_soap_message_attr_t attrs,
    globus_handler_chain_t handlers);

/**
 * Destroy a client handle
 * @ingroup ManagedExecutableJobService_client_handle
 *
 * Destroys the state associated with this client handle.
 *
 * @param handle
 *     Handle to destroy.
 */
void
ManagedExecutableJobService_client_destroy(
    ManagedExecutableJobService_client_handle_t handle);

/**
 * Cancel the current operation associated with this handle.
 * @ingroup ManagedExecutableJobService_client_handle
 * 
 * @param handle
 *     Handle which has the operation to cancel.
 */
globus_result_t
ManagedExecutableJobService_client_operation_cancel(
    ManagedExecutableJobService_client_handle_t handle);

/**
 * Get handle's type registry
 * @ingroup ManagedExecutableJobService_client_handle
 *
 * The type registry maps XML element names to type information structures.
 * Applications may wish to get the registry from a handle to set extra
 * type mappings (for example, to set a mapping for an element which is
 * to be received as part of an extensibility element).
 *
 * @param handle
 *     The handle to query.
 * @param registry
 *     A pointer to a registry handle which will be set to the handle's
 *     registry.
 */
globus_result_t
ManagedExecutableJobService_client_get_registry(
    ManagedExecutableJobService_client_handle_t handle,
    globus_xsd_type_registry_t * registry);

/**
 * Get handle's handler chain
 * @ingroup ManagedExecutableJobService_client_handle
 *
 * The handler chain contains information about which handlers (typically
 * SOAP header processors) will be invoked when a request is sent or a
 * response is received. Applications which want to add custom handlers at
 * run time may wish to push additional handlers onto this chain.
 *
 * @param handle
 *     The handle to query.
 * @param handlers
 *     A pointer to a handler chain which will be set to the handle's
 *     chain.
 */
globus_result_t
ManagedExecutableJobService_client_get_handler_chain(
    ManagedExecutableJobService_client_handle_t handle,
    globus_handler_chain_t * handlers);

/**
 * Set a SOAP attribute on a handle
 * @ingroup ManagedExecutableJobService_client_handle
 *
 * Set a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * @param copy
 *     A function to copy the value. This is required if @a value will go
 *     out of scope.
 * @param destroy
 *     A function to destroy a copy of the value. Required if @a copy is set.
 * @param value
 *     The new value of the attribute.
 */
globus_result_t
ManagedExecutableJobService_client_attr_set(
    ManagedExecutableJobService_client_handle_t handle,
    const char * prop_name,
    globus_soap_message_attr_copy_func_t copy,
    globus_soap_message_attr_destroy_func_t destroy,
    void * value);

/**
 * Remove a SOAP attribute from a handle
 * @ingroup ManagedExecutableJobService_client_handle
 *
 * Remove a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
ManagedExecutableJobService_client_attr_remove(
    ManagedExecutableJobService_client_handle_t handle,
    const char * prop_name);

/**
 * Get a SOAP attribute from a handle
 * @ingroup ManagedExecutableJobService_client_handle
 *
 * Get the current value of a SOAP attribute set on a handle. 
 *
 * @param handle
 *     The handle to query.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
ManagedExecutableJobService_client_attr_get(
    ManagedExecutableJobService_client_handle_t handle,
    const char * prop_name);

EXTERN_C_END

#endif
