/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC convert
 */

#ifndef _MANAGEDMULTIJOBSERVICE_H_
#define _MANAGEDMULTIJOBSERVICE_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "globus_handler.h"
#include "globus_soap_message.h"
#include "globus_xsd_type_registry.h"

#define MANAGEDMULTIJOBSERVICE_BASE_PATH "wsrf/services/ManagedMultiJobService"

extern xsd_QName ManagedMultiJobService_service_qname;

globus_result_t
ManagedMultiJobService_registry_add_types(
    globus_xsd_type_registry_t          registry);

globus_result_t
ManagedMultiJobService_registry_remove_types(
    globus_xsd_type_registry_t          registry);


#include "wsrp_GetMultipleResourcePropertiesType.h"
#include "wsrp_GetMultipleResourcePropertiesResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_QueryResourcePropertiesType.h"
#include "wsrp_QueryResourcePropertiesResponseType.h"
#include "wsrp_UnknownQueryExpressionDialectFaultType.h"
#include "wsrp_UnknownQueryExpressionDialectFault.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_QueryEvaluationErrorFaultType.h"
#include "wsrp_QueryEvaluationErrorFault.h"
#include "wsrp_InvalidQueryExpressionFaultType.h"
#include "wsrp_InvalidQueryExpressionFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrl_DestroyType.h"
#include "wsrl_DestroyResponseType.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_ResourceNotDestroyedFaultType.h"
#include "wsrl_ResourceNotDestroyedFault.h"
#include "wsrl_SetTerminationTimeType.h"
#include "wsrl_SetTerminationTimeResponseType.h"
#include "wsrl_TerminationTimeChangeRejectedFaultType.h"
#include "wsrl_TerminationTimeChangeRejectedFault.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_UnableToSetTerminationTimeFaultType.h"
#include "wsrl_UnableToSetTerminationTimeFault.h"
#include "wsnt_GetCurrentMessageType.h"
#include "wsnt_GetCurrentMessageResponseType.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_NoCurrentMessageOnTopicFaultType.h"
#include "wsnt_NoCurrentMessageOnTopicFault.h"
#include "wsnt_InvalidTopicExpressionFaultType.h"
#include "wsnt_InvalidTopicExpressionFault.h"
#include "wsnt_TopicNotSupportedFaultType.h"
#include "wsnt_TopicNotSupportedFault.h"
#include "wsnt_SubscribeType.h"
#include "wsnt_SubscribeResponseType.h"
#include "wsnt_TopicPathDialectUnknownFaultType.h"
#include "wsnt_TopicPathDialectUnknownFault.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_SubscribeCreationFailedFaultType.h"
#include "wsnt_SubscribeCreationFailedFault.h"
#include "wsnt_InvalidTopicExpressionFaultType.h"
#include "wsnt_InvalidTopicExpressionFault.h"
#include "wsnt_TopicNotSupportedFaultType.h"
#include "wsnt_TopicNotSupportedFault.h"
#include "xsd_QName.h"
#include "wsrp_GetResourcePropertyResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrendezvous_registerInputType.h"
#include "wsrendezvous_registerResponseType.h"
#include "wsrendezvous_CapacityReachedFaultType.h"
#include "wsrendezvous_capacityReachedFault.h"
#include "wsrendezvous_RankTakenFaultType.h"
#include "wsrendezvous_rankTakenFault.h"
#include "wsgram_ReleaseInputType.h"
#include "wsgram_ReleaseOutputType.h"

/* fault type declaration for the GetMultipleResourceProperties operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    MANAGEDMULTIJOBPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT,
    MANAGEDMULTIJOBPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ManagedMultiJobPortType_GetMultipleResourceProperties_fault_t;


/* qname for operation GetMultipleResourceProperties */

extern xsd_QName ManagedMultiJobPortType_GetMultipleResourceProperties_op_qname;



/* fault type declaration for the QueryResourceProperties operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_QUERYRESOURCEPROPERTIES_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    MANAGEDMULTIJOBPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWNQUERYEXPRESSIONDIALECTFAULT,
    MANAGEDMULTIJOBPORTTYPE_QUERYRESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT,
    MANAGEDMULTIJOBPORTTYPE_QUERYRESOURCEPROPERTIES_QUERYEVALUATIONERRORFAULT,
    MANAGEDMULTIJOBPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDQUERYEXPRESSIONFAULT,
    MANAGEDMULTIJOBPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ManagedMultiJobPortType_QueryResourceProperties_fault_t;


/* qname for operation QueryResourceProperties */

extern xsd_QName ManagedMultiJobPortType_QueryResourceProperties_op_qname;



/* fault type declaration for the Destroy operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_DESTROY_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_DESTROY_UNKNOWN_FAULT = 1,
    MANAGEDMULTIJOBPORTTYPE_DESTROY_RESOURCEUNKNOWNFAULT,
    MANAGEDMULTIJOBPORTTYPE_DESTROY_RESOURCENOTDESTROYEDFAULT

} ManagedMultiJobPortType_Destroy_fault_t;


/* qname for operation Destroy */

extern xsd_QName ManagedMultiJobPortType_Destroy_op_qname;



/* fault type declaration for the SetTerminationTime operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_SETTERMINATIONTIME_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_SETTERMINATIONTIME_UNKNOWN_FAULT = 1,
    MANAGEDMULTIJOBPORTTYPE_SETTERMINATIONTIME_TERMINATIONTIMECHANGEREJECTEDFAULT,
    MANAGEDMULTIJOBPORTTYPE_SETTERMINATIONTIME_RESOURCEUNKNOWNFAULT,
    MANAGEDMULTIJOBPORTTYPE_SETTERMINATIONTIME_UNABLETOSETTERMINATIONTIMEFAULT

} ManagedMultiJobPortType_SetTerminationTime_fault_t;


/* qname for operation SetTerminationTime */

extern xsd_QName ManagedMultiJobPortType_SetTerminationTime_op_qname;



/* fault type declaration for the GetCurrentMessage operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_GETCURRENTMESSAGE_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_GETCURRENTMESSAGE_UNKNOWN_FAULT = 1,
    MANAGEDMULTIJOBPORTTYPE_GETCURRENTMESSAGE_RESOURCEUNKNOWNFAULT,
    MANAGEDMULTIJOBPORTTYPE_GETCURRENTMESSAGE_NOCURRENTMESSAGEONTOPICFAULT,
    MANAGEDMULTIJOBPORTTYPE_GETCURRENTMESSAGE_INVALIDTOPICEXPRESSIONFAULT,
    MANAGEDMULTIJOBPORTTYPE_GETCURRENTMESSAGE_TOPICNOTSUPPORTEDFAULT

} ManagedMultiJobPortType_GetCurrentMessage_fault_t;


/* qname for operation GetCurrentMessage */

extern xsd_QName ManagedMultiJobPortType_GetCurrentMessage_op_qname;



/* fault type declaration for the Subscribe operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_SUBSCRIBE_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_SUBSCRIBE_UNKNOWN_FAULT = 1,
    MANAGEDMULTIJOBPORTTYPE_SUBSCRIBE_TOPICPATHDIALECTUNKNOWNFAULT,
    MANAGEDMULTIJOBPORTTYPE_SUBSCRIBE_RESOURCEUNKNOWNFAULT,
    MANAGEDMULTIJOBPORTTYPE_SUBSCRIBE_SUBSCRIBECREATIONFAILEDFAULT,
    MANAGEDMULTIJOBPORTTYPE_SUBSCRIBE_INVALIDTOPICEXPRESSIONFAULT,
    MANAGEDMULTIJOBPORTTYPE_SUBSCRIBE_TOPICNOTSUPPORTEDFAULT

} ManagedMultiJobPortType_Subscribe_fault_t;


/* qname for operation Subscribe */

extern xsd_QName ManagedMultiJobPortType_Subscribe_op_qname;



/* fault type declaration for the GetResourceProperty operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_GETRESOURCEPROPERTY_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_GETRESOURCEPROPERTY_UNKNOWN_FAULT = 1,
    MANAGEDMULTIJOBPORTTYPE_GETRESOURCEPROPERTY_RESOURCEUNKNOWNFAULT,
    MANAGEDMULTIJOBPORTTYPE_GETRESOURCEPROPERTY_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ManagedMultiJobPortType_GetResourceProperty_fault_t;


/* qname for operation GetResourceProperty */

extern xsd_QName ManagedMultiJobPortType_GetResourceProperty_op_qname;



/* fault type declaration for the register operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_REGISTER_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_REGISTER_UNKNOWN_FAULT = 1,
    MANAGEDMULTIJOBPORTTYPE_REGISTER_CAPACITYREACHEDFAULT,
    MANAGEDMULTIJOBPORTTYPE_REGISTER_RANKTAKENFAULT

} ManagedMultiJobPortType_register_fault_t;


/* qname for operation register */

extern xsd_QName ManagedMultiJobPortType_register_op_qname;



/* fault type declaration for the release operation */

typedef enum
{
    MANAGEDMULTIJOBPORTTYPE_RELEASE_NOFAULT = 0,
    MANAGEDMULTIJOBPORTTYPE_RELEASE_UNKNOWN_FAULT = 1

} ManagedMultiJobPortType_release_fault_t;


/* qname for operation release */

extern xsd_QName ManagedMultiJobPortType_release_op_qname;


/* ResourceProperty element QNames */

extern xsd_QName ManagedMultiJobPortType_subJobEndpoint_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_subJobEndpoint_rp_info;

extern xsd_QName ManagedMultiJobPortType_serviceLevelAgreement_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_serviceLevelAgreement_rp_info;

extern xsd_QName ManagedMultiJobPortType_Capacity_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_Capacity_rp_info;

extern xsd_QName ManagedMultiJobPortType_userSubject_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_userSubject_rp_info;

extern xsd_QName ManagedMultiJobPortType_fault_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_fault_rp_info;

extern xsd_QName ManagedMultiJobPortType_TopicExpressionDialects_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_TopicExpressionDialects_rp_info;

extern xsd_QName ManagedMultiJobPortType_Topic_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_Topic_rp_info;

extern xsd_QName ManagedMultiJobPortType_TerminationTime_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_TerminationTime_rp_info;

extern xsd_QName ManagedMultiJobPortType_localUserId_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_localUserId_rp_info;

extern xsd_QName ManagedMultiJobPortType_CurrentTime_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_CurrentTime_rp_info;

extern xsd_QName ManagedMultiJobPortType_holding_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_holding_rp_info;

extern xsd_QName ManagedMultiJobPortType_RegistrantData_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_RegistrantData_rp_info;

extern xsd_QName ManagedMultiJobPortType_RendezvousCompleted_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_RendezvousCompleted_rp_info;

extern xsd_QName ManagedMultiJobPortType_FixedTopicSet_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_FixedTopicSet_rp_info;

extern xsd_QName ManagedMultiJobPortType_state_rp_qname;
extern struct globus_xsd_type_info_s ManagedMultiJobPortType_state_rp_info;

    
EXTERN_C_END

#endif
