/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC convert
 */

#ifndef _RELIABLEFILETRANSFERSERVICE_H_
#define _RELIABLEFILETRANSFERSERVICE_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "globus_handler.h"
#include "globus_soap_message.h"
#include "globus_xsd_type_registry.h"

#define RELIABLEFILETRANSFERSERVICE_BASE_PATH "wsrf/services/ReliableFileTransferService"

extern xsd_QName ReliableFileTransferService_service_qname;

globus_result_t
ReliableFileTransferService_registry_add_types(
    globus_xsd_type_registry_t          registry);

globus_result_t
ReliableFileTransferService_registry_remove_types(
    globus_xsd_type_registry_t          registry);


#include "wsnt_GetCurrentMessageType.h"
#include "wsnt_GetCurrentMessageResponseType.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_NoCurrentMessageOnTopicFaultType.h"
#include "wsnt_NoCurrentMessageOnTopicFault.h"
#include "wsnt_InvalidTopicExpressionFaultType.h"
#include "wsnt_InvalidTopicExpressionFault.h"
#include "wsnt_TopicNotSupportedFaultType.h"
#include "wsnt_TopicNotSupportedFault.h"
#include "wsnt_SubscribeType.h"
#include "wsnt_SubscribeResponseType.h"
#include "wsnt_TopicPathDialectUnknownFaultType.h"
#include "wsnt_TopicPathDialectUnknownFault.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_SubscribeCreationFailedFaultType.h"
#include "wsnt_SubscribeCreationFailedFault.h"
#include "wsnt_InvalidTopicExpressionFaultType.h"
#include "wsnt_InvalidTopicExpressionFault.h"
#include "wsnt_TopicNotSupportedFaultType.h"
#include "wsnt_TopicNotSupportedFault.h"
#include "xsd_QName.h"
#include "wsrp_GetResourcePropertyResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_GetMultipleResourcePropertiesType.h"
#include "wsrp_GetMultipleResourcePropertiesResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_QueryResourcePropertiesType.h"
#include "wsrp_QueryResourcePropertiesResponseType.h"
#include "wsrp_UnknownQueryExpressionDialectFaultType.h"
#include "wsrp_UnknownQueryExpressionDialectFault.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_QueryEvaluationErrorFaultType.h"
#include "wsrp_QueryEvaluationErrorFault.h"
#include "wsrp_InvalidQueryExpressionFaultType.h"
#include "wsrp_InvalidQueryExpressionFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrl_DestroyType.h"
#include "wsrl_DestroyResponseType.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_ResourceNotDestroyedFaultType.h"
#include "wsrl_ResourceNotDestroyedFault.h"
#include "wsrl_SetTerminationTimeType.h"
#include "wsrl_SetTerminationTimeResponseType.h"
#include "wsrl_TerminationTimeChangeRejectedFaultType.h"
#include "wsrl_TerminationTimeChangeRejectedFault.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_UnableToSetTerminationTimeFaultType.h"
#include "wsrl_UnableToSetTerminationTimeFault.h"
#include "wstransfer_cancelType.h"
#include "wstransfer_cancelResponseType.h"
#include "wstransfer_RFTDatabaseFaultType.h"
#include "wstransfer_rftDatabaseFault.h"
#include "wstransfer_getStatusSetType.h"
#include "wstransfer_getStatusSetResponseType.h"
#include "wstransfer_RFTDatabaseFaultType.h"
#include "wstransfer_rftDatabaseFault.h"
#include "wstransfer_getStatusType.h"
#include "wstransfer_getStatusResponseType.h"
#include "wstransfer_RFTDatabaseFaultType.h"
#include "wstransfer_rftDatabaseFault.h"
#include "wstransfer_startType.h"
#include "wstransfer_StartOutputType.h"
#include "wstransfer_RepeatedlyStartedFaultType.h"
#include "wstransfer_repeatedlyStartedFault.h"

/* fault type declaration for the GetCurrentMessage operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_GETCURRENTMESSAGE_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_GETCURRENTMESSAGE_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_GETCURRENTMESSAGE_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERPORTTYPE_GETCURRENTMESSAGE_NOCURRENTMESSAGEONTOPICFAULT,
    RELIABLEFILETRANSFERPORTTYPE_GETCURRENTMESSAGE_INVALIDTOPICEXPRESSIONFAULT,
    RELIABLEFILETRANSFERPORTTYPE_GETCURRENTMESSAGE_TOPICNOTSUPPORTEDFAULT

} ReliableFileTransferPortType_GetCurrentMessage_fault_t;


/* qname for operation GetCurrentMessage */

extern xsd_QName ReliableFileTransferPortType_GetCurrentMessage_op_qname;



/* fault type declaration for the Subscribe operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_SUBSCRIBE_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_SUBSCRIBE_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_SUBSCRIBE_TOPICPATHDIALECTUNKNOWNFAULT,
    RELIABLEFILETRANSFERPORTTYPE_SUBSCRIBE_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERPORTTYPE_SUBSCRIBE_SUBSCRIBECREATIONFAILEDFAULT,
    RELIABLEFILETRANSFERPORTTYPE_SUBSCRIBE_INVALIDTOPICEXPRESSIONFAULT,
    RELIABLEFILETRANSFERPORTTYPE_SUBSCRIBE_TOPICNOTSUPPORTEDFAULT

} ReliableFileTransferPortType_Subscribe_fault_t;


/* qname for operation Subscribe */

extern xsd_QName ReliableFileTransferPortType_Subscribe_op_qname;



/* fault type declaration for the GetResourceProperty operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_GETRESOURCEPROPERTY_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_GETRESOURCEPROPERTY_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_GETRESOURCEPROPERTY_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERPORTTYPE_GETRESOURCEPROPERTY_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ReliableFileTransferPortType_GetResourceProperty_fault_t;


/* qname for operation GetResourceProperty */

extern xsd_QName ReliableFileTransferPortType_GetResourceProperty_op_qname;



/* fault type declaration for the GetMultipleResourceProperties operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ReliableFileTransferPortType_GetMultipleResourceProperties_fault_t;


/* qname for operation GetMultipleResourceProperties */

extern xsd_QName ReliableFileTransferPortType_GetMultipleResourceProperties_op_qname;



/* fault type declaration for the QueryResourceProperties operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_QUERYRESOURCEPROPERTIES_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWNQUERYEXPRESSIONDIALECTFAULT,
    RELIABLEFILETRANSFERPORTTYPE_QUERYRESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERPORTTYPE_QUERYRESOURCEPROPERTIES_QUERYEVALUATIONERRORFAULT,
    RELIABLEFILETRANSFERPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDQUERYEXPRESSIONFAULT,
    RELIABLEFILETRANSFERPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT

} ReliableFileTransferPortType_QueryResourceProperties_fault_t;


/* qname for operation QueryResourceProperties */

extern xsd_QName ReliableFileTransferPortType_QueryResourceProperties_op_qname;



/* fault type declaration for the Destroy operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_DESTROY_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_DESTROY_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_DESTROY_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERPORTTYPE_DESTROY_RESOURCENOTDESTROYEDFAULT

} ReliableFileTransferPortType_Destroy_fault_t;


/* qname for operation Destroy */

extern xsd_QName ReliableFileTransferPortType_Destroy_op_qname;



/* fault type declaration for the SetTerminationTime operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_SETTERMINATIONTIME_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_SETTERMINATIONTIME_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_SETTERMINATIONTIME_TERMINATIONTIMECHANGEREJECTEDFAULT,
    RELIABLEFILETRANSFERPORTTYPE_SETTERMINATIONTIME_RESOURCEUNKNOWNFAULT,
    RELIABLEFILETRANSFERPORTTYPE_SETTERMINATIONTIME_UNABLETOSETTERMINATIONTIMEFAULT

} ReliableFileTransferPortType_SetTerminationTime_fault_t;


/* qname for operation SetTerminationTime */

extern xsd_QName ReliableFileTransferPortType_SetTerminationTime_op_qname;



/* fault type declaration for the cancel operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_CANCEL_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_CANCEL_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_CANCEL_RFTDATABASEFAULT

} ReliableFileTransferPortType_cancel_fault_t;


/* qname for operation cancel */

extern xsd_QName ReliableFileTransferPortType_cancel_op_qname;



/* fault type declaration for the getStatusSet operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_GETSTATUSSET_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_GETSTATUSSET_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_GETSTATUSSET_RFTDATABASEFAULT

} ReliableFileTransferPortType_getStatusSet_fault_t;


/* qname for operation getStatusSet */

extern xsd_QName ReliableFileTransferPortType_getStatusSet_op_qname;



/* fault type declaration for the getStatus operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_GETSTATUS_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_GETSTATUS_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_GETSTATUS_RFTDATABASEFAULT

} ReliableFileTransferPortType_getStatus_fault_t;


/* qname for operation getStatus */

extern xsd_QName ReliableFileTransferPortType_getStatus_op_qname;



/* fault type declaration for the start operation */

typedef enum
{
    RELIABLEFILETRANSFERPORTTYPE_START_NOFAULT = 0,
    RELIABLEFILETRANSFERPORTTYPE_START_UNKNOWN_FAULT = 1,
    RELIABLEFILETRANSFERPORTTYPE_START_REPEATEDLYSTARTEDFAULT

} ReliableFileTransferPortType_start_fault_t;


/* qname for operation start */

extern xsd_QName ReliableFileTransferPortType_start_op_qname;


/* ResourceProperty element QNames */

extern xsd_QName ReliableFileTransferPortType_TotalBytes_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_TotalBytes_rp_info;

extern xsd_QName ReliableFileTransferPortType_TotalTime_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_TotalTime_rp_info;

extern xsd_QName ReliableFileTransferPortType_RequestStatusProperty_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_RequestStatusProperty_rp_info;

extern xsd_QName ReliableFileTransferPortType_OverallStatusProperty_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_OverallStatusProperty_rp_info;

extern xsd_QName ReliableFileTransferPortType_Topic_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_Topic_rp_info;

extern xsd_QName ReliableFileTransferPortType_TopicExpressionDialects_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_TopicExpressionDialects_rp_info;

extern xsd_QName ReliableFileTransferPortType_TerminationTime_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_TerminationTime_rp_info;

extern xsd_QName ReliableFileTransferPortType_CurrentTime_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_CurrentTime_rp_info;

extern xsd_QName ReliableFileTransferPortType_FixedTopicSet_rp_qname;
extern struct globus_xsd_type_info_s ReliableFileTransferPortType_FixedTopicSet_rp_info;

    
EXTERN_C_END

#endif
