/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC convert
 */

#ifndef _SUBSCRIPTIONMANAGERSERVICE_H_
#define _SUBSCRIPTIONMANAGERSERVICE_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "globus_handler.h"
#include "globus_soap_message.h"
#include "globus_xsd_type_registry.h"

#define SUBSCRIPTIONMANAGERSERVICE_BASE_PATH "wsrf/services/SubscriptionManagerService"

extern xsd_QName SubscriptionManagerService_service_qname;

globus_result_t
SubscriptionManagerService_registry_add_types(
    globus_xsd_type_registry_t          registry);

globus_result_t
SubscriptionManagerService_registry_remove_types(
    globus_xsd_type_registry_t          registry);


#include "wsnt_ResumeSubscriptionType.h"
#include "wsnt_ResumeSubscriptionResponseType.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_ResumeFailedFaultType.h"
#include "wsnt_ResumeFailedFault.h"
#include "wsnt_PauseSubscriptionType.h"
#include "wsnt_PauseSubscriptionResponseType.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_PauseFailedFaultType.h"
#include "wsnt_PauseFailedFault.h"
#include "wsrl_SetTerminationTimeType.h"
#include "wsrl_SetTerminationTimeResponseType.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_TerminationTimeChangeRejectedFaultType.h"
#include "wsrl_TerminationTimeChangeRejectedFault.h"
#include "wsrl_UnableToSetTerminationTimeFaultType.h"
#include "wsrl_UnableToSetTerminationTimeFault.h"
#include "wsrl_DestroyType.h"
#include "wsrl_DestroyResponseType.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_ResourceNotDestroyedFaultType.h"
#include "wsrl_ResourceNotDestroyedFault.h"
#include "xsd_QName.h"
#include "wsrp_GetResourcePropertyResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"

/* fault type declaration for the ResumeSubscription operation */

typedef enum
{
    SUBSCRIPTIONMANAGER_RESUMESUBSCRIPTION_NOFAULT = 0,
    SUBSCRIPTIONMANAGER_RESUMESUBSCRIPTION_UNKNOWN_FAULT = 1,
    SUBSCRIPTIONMANAGER_RESUMESUBSCRIPTION_RESOURCEUNKNOWNFAULT,
    SUBSCRIPTIONMANAGER_RESUMESUBSCRIPTION_RESUMEFAILEDFAULT

} SubscriptionManager_ResumeSubscription_fault_t;


/* qname for operation ResumeSubscription */

extern xsd_QName SubscriptionManager_ResumeSubscription_op_qname;



/* fault type declaration for the PauseSubscription operation */

typedef enum
{
    SUBSCRIPTIONMANAGER_PAUSESUBSCRIPTION_NOFAULT = 0,
    SUBSCRIPTIONMANAGER_PAUSESUBSCRIPTION_UNKNOWN_FAULT = 1,
    SUBSCRIPTIONMANAGER_PAUSESUBSCRIPTION_RESOURCEUNKNOWNFAULT,
    SUBSCRIPTIONMANAGER_PAUSESUBSCRIPTION_PAUSEFAILEDFAULT

} SubscriptionManager_PauseSubscription_fault_t;


/* qname for operation PauseSubscription */

extern xsd_QName SubscriptionManager_PauseSubscription_op_qname;



/* fault type declaration for the SetTerminationTime operation */

typedef enum
{
    SUBSCRIPTIONMANAGER_SETTERMINATIONTIME_NOFAULT = 0,
    SUBSCRIPTIONMANAGER_SETTERMINATIONTIME_UNKNOWN_FAULT = 1,
    SUBSCRIPTIONMANAGER_SETTERMINATIONTIME_RESOURCEUNKNOWNFAULT,
    SUBSCRIPTIONMANAGER_SETTERMINATIONTIME_TERMINATIONTIMECHANGEREJECTEDFAULT,
    SUBSCRIPTIONMANAGER_SETTERMINATIONTIME_UNABLETOSETTERMINATIONTIMEFAULT

} SubscriptionManager_SetTerminationTime_fault_t;


/* qname for operation SetTerminationTime */

extern xsd_QName SubscriptionManager_SetTerminationTime_op_qname;



/* fault type declaration for the Destroy operation */

typedef enum
{
    SUBSCRIPTIONMANAGER_DESTROY_NOFAULT = 0,
    SUBSCRIPTIONMANAGER_DESTROY_UNKNOWN_FAULT = 1,
    SUBSCRIPTIONMANAGER_DESTROY_RESOURCEUNKNOWNFAULT,
    SUBSCRIPTIONMANAGER_DESTROY_RESOURCENOTDESTROYEDFAULT

} SubscriptionManager_Destroy_fault_t;


/* qname for operation Destroy */

extern xsd_QName SubscriptionManager_Destroy_op_qname;



/* fault type declaration for the GetResourceProperty operation */

typedef enum
{
    SUBSCRIPTIONMANAGER_GETRESOURCEPROPERTY_NOFAULT = 0,
    SUBSCRIPTIONMANAGER_GETRESOURCEPROPERTY_UNKNOWN_FAULT = 1,
    SUBSCRIPTIONMANAGER_GETRESOURCEPROPERTY_RESOURCEUNKNOWNFAULT,
    SUBSCRIPTIONMANAGER_GETRESOURCEPROPERTY_INVALIDRESOURCEPROPERTYQNAMEFAULT

} SubscriptionManager_GetResourceProperty_fault_t;


/* qname for operation GetResourceProperty */

extern xsd_QName SubscriptionManager_GetResourceProperty_op_qname;


/* ResourceProperty element QNames */

extern xsd_QName SubscriptionManager_ConsumerReference_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_ConsumerReference_rp_info;

extern xsd_QName SubscriptionManager_Selector_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_Selector_rp_info;

extern xsd_QName SubscriptionManager_UseNotify_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_UseNotify_rp_info;

extern xsd_QName SubscriptionManager_TopicExpression_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_TopicExpression_rp_info;

extern xsd_QName SubscriptionManager_SubscriptionPolicy_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_SubscriptionPolicy_rp_info;

extern xsd_QName SubscriptionManager_TerminationTime_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_TerminationTime_rp_info;

extern xsd_QName SubscriptionManager_CreationTime_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_CreationTime_rp_info;

extern xsd_QName SubscriptionManager_Precondition_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_Precondition_rp_info;

extern xsd_QName SubscriptionManager_CurrentTime_rp_qname;
extern struct globus_xsd_type_info_s SubscriptionManager_CurrentTime_rp_info;

    
EXTERN_C_END

#endif
