/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _SERVICEMETADATA_H_
#define _SERVICEMETADATA_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The serviceMetaData complex type, which represents the
 * {http://mds.globus.org/metadata/2005/02}serviceMetaData element.
 * @ingroup serviceMetaData
 */
typedef struct serviceMetaData_s serviceMetaData;
/**
 * The serviceMetaData_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/metadata/2005/02}serviceMetaData element.
 * @ingroup serviceMetaData
 */
typedef serviceMetaData * serviceMetaData_o;

/**
 * Namespace of the serviceMetaData complex type
 * @ingroup serviceMetaData
 */
#define SERVICEMETADATA_NS "http://mds.globus.org/metadata/2005/02"
/**
 * Local part of the QName of the serviceMetaData complex type
 * @ingroup serviceMetaData
 */
#define SERVICEMETADATA_LOCAL "serviceMetaData"

/**
 * QName of the serviceMetaData complex type
 * @ingroup serviceMetaData
 */
extern xsd_QName serviceMetaData_qname;
/**
 * Type information for serializing and deserializing serviceMetaData elements
 * @ingroup serviceMetaData
 */
extern struct globus_xsd_type_info_s serviceMetaData_info;
/**
 * Type information for serializing and deserializing arrays of serviceMetaData
 * elements
 * @ingroup serviceMetaData
 */
extern struct globus_xsd_type_info_s serviceMetaData_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * serviceMetaData without surrounding elements
 * @ingroup serviceMetaData
 */
extern struct globus_xsd_type_info_s serviceMetaData_contents_info;


#include "xsd_dateTime.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "serviceMetaData_array.h"

/**
 * @defgroup serviceMetaData Complex type: serviceMetaData
 * @ingroup types
 */

/**
 * C structure for the serviceMetaData complex type
 * @ingroup serviceMetaData
 */
struct serviceMetaData_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime startTime;
    /** xsd_string subelement */
    xsd_string version;
    /** xsd_string subelement */
    xsd_string serviceTypeName;

};

/**
 * Initialize a serviceMetaData
 * @ingroup serviceMetaData
 *
 * Allocates a new serviceMetaData and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * serviceMetaData_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
serviceMetaData_init(
    serviceMetaData ** inst);

/**
 * Destroy a serviceMetaData
 * @ingroup serviceMetaData
 *
 * Frees a serviceMetaData. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
serviceMetaData_destroy(
    serviceMetaData * inst);

/**
 * Copy a serviceMetaData
 * @ingroup serviceMetaData
 *
 * Perform a deep copy of a serviceMetaData.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The serviceMetaData structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source serviceMetaData to be copied.
 */
globus_result_t
serviceMetaData_copy(
    serviceMetaData ** dest,
    const serviceMetaData * src);

/**
 * Initialize the contents of a serviceMetaData
 * @ingroup serviceMetaData
 *
 * Initialize the contents of a serviceMetaData. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * serviceMetaData_init(). The contents may be freed
 * by calling serviceMetaData_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized serviceMetaData.
 */
globus_result_t
serviceMetaData_init_contents(
    serviceMetaData * instance);

/**
 * Destroy the contents of a serviceMetaData
 * @ingroup serviceMetaData
 *
 * Destroy the subelements and attributes of the given serviceMetaData. 
 *
 * @param inst
 *     Pointer to a serviceMetaData instance to destroy.
 */
void
serviceMetaData_destroy_contents(
    serviceMetaData * inst);

/**
 * Copy the contents of a serviceMetaData
 * @ingroup serviceMetaData
 *
 * Perform a deep copy of the contents of a serviceMetaData.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source serviceMetaData to be copied.
 */
globus_result_t
serviceMetaData_copy_contents(
    serviceMetaData * dest,
    const serviceMetaData * src);

/**
 * Serialize a serviceMetaData
 * @ingroup serviceMetaData_array
 * Serialize a serviceMetaData structure.
 *
 * @param element_name
 *     The name of the element which will contain the serviceMetaData.
 * @param val
 *     The serviceMetaData to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
serviceMetaData_serialize(
    xsd_QName *                         element_name,
    serviceMetaData * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a serviceMetaData
 * @ingroup serviceMetaData_array
 * Serialize a serviceMetaData structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The serviceMetaData to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
serviceMetaData_serialize_contents(
    xsd_QName *                         element_name,
    serviceMetaData * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a serviceMetaData
 * @ingroup serviceMetaData
 * Deserialize an element containing a serviceMetaData element.
 *
 * @param element_name
 *     The name of the element which should enclose the serviceMetaData.
 * @param val
 *     Pointer to the serviceMetaData which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
serviceMetaData_deserialize(
    xsd_QName *                         element_name,
    serviceMetaData * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a serviceMetaData
 * @ingroup serviceMetaData
 * Deserialize a serviceMetaData whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the serviceMetaData which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
serviceMetaData_deserialize_contents(
    xsd_QName *                         element_name,
    serviceMetaData * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional serviceMetaData
 * @ingroup serviceMetaData
 * Deserialize the next element if it contains a serviceMetaData.
 *
 * @param element_name
 *     The name of the element which should enclose the serviceMetaData.
 * @param instance
 *     Pointer to the <code>serviceMetaData *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
serviceMetaData_deserialize_pointer(
    xsd_QName *                         element_name,
    serviceMetaData ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
serviceMetaData_init_wrapper(
    void **                             object);
    
void
serviceMetaData_destroy_wrapper(
    void *                              object);
    
globus_result_t
serviceMetaData_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
serviceMetaData_init_contents_wrapper(
    void *                              object);
    
void
serviceMetaData_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
serviceMetaData_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
serviceMetaData_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
serviceMetaData_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
serviceMetaData_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
serviceMetaData_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
