/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSGRAM_FAULTRESOURCEPROPERTYTYPE_CHOICE_H_
#define _WSGRAM_FAULTRESOURCEPROPERTYTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum wsgram_FaultResourcePropertyType_e
{
    wsgram_FaultResourcePropertyType_undefined,
    wsgram_FaultResourcePropertyType_fault,
    wsgram_FaultResourcePropertyType_credentialSerializationFault,
    wsgram_FaultResourcePropertyType_insufficientCredentialsFault,
    wsgram_FaultResourcePropertyType_internalFault,
    wsgram_FaultResourcePropertyType_invalidCredentialsFault,
    wsgram_FaultResourcePropertyType_serviceLevelAgreementFault,
    wsgram_FaultResourcePropertyType_executionFailedFault,
    wsgram_FaultResourcePropertyType_filePermissionsFault,
    wsgram_FaultResourcePropertyType_invalidPathFault,
    wsgram_FaultResourcePropertyType_stagingFault,
    wsgram_FaultResourcePropertyType_unsupportedFeatureFault

};

/**
 * @defgroup wsgram_FaultResourcePropertyType_choice Complex choice type: wsgram_FaultResourcePropertyType
 * @ingroup wsgram_FaultResourcePropertyType
 */

/**
 * Enumeration of the types of values which the wsgram_FaultResourcePropertyType_choice
 * structure may take on.
 * @ingroup wsgram_FaultResourcePropertyType_choice
 */
typedef enum wsgram_FaultResourcePropertyType_e wsgram_FaultResourcePropertyType_enum;
/**
 * Union of the values which the wsgram_FaultResourcePropertyType_choice structure
 * contains
 * @ingroup wsgram_FaultResourcePropertyType_choice
 */
typedef union wsgram_FaultResourcePropertyType_u wsgram_FaultResourcePropertyType_union;
/**
 * The wsgram_FaultResourcePropertyType complex type, which represents the various values
 * possible by the choice used by the
 * {http://www.globus.org/namespaces/2004/10/gram/job/faults}choice 29 element.
 * @ingroup wsgram_FaultResourcePropertyType_choice
 */
typedef struct wsgram_FaultResourcePropertyType_choice_s wsgram_FaultResourcePropertyType_choice;
/**
 * The wsgram_FaultResourcePropertyType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://www.globus.org/namespaces/2004/10/gram/job/faults}choice 29 element.
 * @ingroup wsgram_FaultResourcePropertyType
 */
typedef wsgram_FaultResourcePropertyType_choice * wsgram_FaultResourcePropertyType_choice_o;

typedef struct wsgram_FaultResourcePropertyType_choice_array_s
{
    wsgram_FaultResourcePropertyType_choice * elements;
    int                                 length;
} wsgram_FaultResourcePropertyType_choice_array;

#define WSGRAM_FAULTRESOURCEPROPERTYTYPE_NS "http://www.globus.org/namespaces/2004/10/gram/job/faults"
#define WSGRAM_FAULTRESOURCEPROPERTYTYPE_LOCAL "FaultResourcePropertyType"

extern xsd_QName wsgram_FaultResourcePropertyType_choice_qname;
extern struct globus_xsd_type_info_s wsgram_FaultResourcePropertyType_choice_info;
extern struct globus_xsd_type_info_s wsgram_FaultResourcePropertyType_choice_contents_info;
extern struct globus_xsd_type_info_s wsgram_FaultResourcePropertyType_choice_array_info;


#include "wsgram_FaultType.h"
#include "wsgram_CredentialSerializationFaultType.h"
#include "wsgram_InsufficientCredentialsFaultType.h"
#include "wsgram_InternalFaultType.h"
#include "wsgram_InvalidCredentialsFaultType.h"
#include "wsgram_ServiceLevelAgreementFaultType.h"
#include "wsgram_ExecutionFailedFaultType.h"
#include "wsgram_FilePermissionsFaultType.h"
#include "wsgram_InvalidPathFaultType.h"
#include "wsgram_StagingFaultType.h"
#include "wsgram_UnsupportedFeatureFaultType.h"

union wsgram_FaultResourcePropertyType_u
{
    /** wsgram_FaultType subelement */
    wsgram_FaultType fault;
    /** wsgram_CredentialSerializationFaultType subelement */
    wsgram_CredentialSerializationFaultType credentialSerializationFault;
    /** wsgram_InsufficientCredentialsFaultType subelement */
    wsgram_InsufficientCredentialsFaultType insufficientCredentialsFault;
    /** wsgram_InternalFaultType subelement */
    wsgram_InternalFaultType internalFault;
    /** wsgram_InvalidCredentialsFaultType subelement */
    wsgram_InvalidCredentialsFaultType invalidCredentialsFault;
    /** wsgram_ServiceLevelAgreementFaultType subelement */
    wsgram_ServiceLevelAgreementFaultType serviceLevelAgreementFault;
    /** wsgram_ExecutionFailedFaultType subelement */
    wsgram_ExecutionFailedFaultType executionFailedFault;
    /** wsgram_FilePermissionsFaultType subelement */
    wsgram_FilePermissionsFaultType filePermissionsFault;
    /** wsgram_InvalidPathFaultType subelement */
    wsgram_InvalidPathFaultType invalidPathFault;
    /** wsgram_StagingFaultType subelement */
    wsgram_StagingFaultType stagingFault;
    /** wsgram_UnsupportedFeatureFaultType subelement */
    wsgram_UnsupportedFeatureFaultType unsupportedFeatureFault;

};

struct wsgram_FaultResourcePropertyType_choice_s
{
    wsgram_FaultResourcePropertyType_enum type;
    wsgram_FaultResourcePropertyType_union value;
};

globus_result_t
wsgram_FaultResourcePropertyType_choice_init(
    wsgram_FaultResourcePropertyType_choice ** inst);

void
wsgram_FaultResourcePropertyType_choice_destroy(
    wsgram_FaultResourcePropertyType_choice * inst);

globus_result_t
wsgram_FaultResourcePropertyType_choice_copy(
    wsgram_FaultResourcePropertyType_choice ** dest,
    const wsgram_FaultResourcePropertyType_choice * src);

globus_result_t
wsgram_FaultResourcePropertyType_choice_init_contents(
    wsgram_FaultResourcePropertyType_choice * instance);

void
wsgram_FaultResourcePropertyType_choice_destroy_contents(
    wsgram_FaultResourcePropertyType_choice * inst);

globus_result_t
wsgram_FaultResourcePropertyType_choice_copy_contents(
    wsgram_FaultResourcePropertyType_choice * dest,
    const wsgram_FaultResourcePropertyType_choice * src);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_array_init(
    wsgram_FaultResourcePropertyType_choice_array ** inst);

void
wsgram_FaultResourcePropertyType_choice_array_destroy(
    wsgram_FaultResourcePropertyType_choice_array * inst);

globus_result_t
wsgram_FaultResourcePropertyType_choice_array_copy(
    wsgram_FaultResourcePropertyType_choice_array ** dest,
    const wsgram_FaultResourcePropertyType_choice_array * src);

globus_result_t
wsgram_FaultResourcePropertyType_choice_array_init_contents(
    wsgram_FaultResourcePropertyType_choice_array * inst);

void
wsgram_FaultResourcePropertyType_choice_array_destroy_contents(
    wsgram_FaultResourcePropertyType_choice_array * inst);

globus_result_t
wsgram_FaultResourcePropertyType_choice_array_copy_contents(
    wsgram_FaultResourcePropertyType_choice_array * dest,
    const wsgram_FaultResourcePropertyType_choice_array * src);

wsgram_FaultResourcePropertyType_choice *
wsgram_FaultResourcePropertyType_choice_array_push(
    wsgram_FaultResourcePropertyType_choice_array * array);

globus_result_t
wsgram_FaultResourcePropertyType_choice_serialize(
    xsd_QName *                         element_name,
    wsgram_FaultResourcePropertyType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_FaultResourcePropertyType_choice_serialize_contents(
    xsd_QName *                         element_name,
    wsgram_FaultResourcePropertyType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_FaultResourcePropertyType_choice_deserialize(
    xsd_QName *                         element_name,
    wsgram_FaultResourcePropertyType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_FaultResourcePropertyType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    wsgram_FaultResourcePropertyType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_FaultResourcePropertyType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    wsgram_FaultResourcePropertyType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_FaultResourcePropertyType_choice_array_serialize(
    xsd_QName *                         element,
    wsgram_FaultResourcePropertyType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_FaultResourcePropertyType_choice_array_deserialize(
    xsd_QName *                         element,
    wsgram_FaultResourcePropertyType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_FaultResourcePropertyType_choice_init_wrapper(
    void **                             object);
    
void
wsgram_FaultResourcePropertyType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsgram_FaultResourcePropertyType_choice_init_contents_wrapper(
    void *                              object);
    
void
wsgram_FaultResourcePropertyType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsgram_FaultResourcePropertyType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_array_init_wrapper(
    void **                             arr);
    
void
wsgram_FaultResourcePropertyType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsgram_FaultResourcePropertyType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
wsgram_FaultResourcePropertyType_choice_array_init_contents_wrapper(
    void *                              arr);

void
wsgram_FaultResourcePropertyType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
wsgram_FaultResourcePropertyType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
wsgram_FaultResourcePropertyType_choice_array_push_wrapper(
    void * array);

globus_result_t
wsgram_FaultResourcePropertyType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
