/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSGRAM_SERVICELEVELAGREEMENTTYPE_CHOICE_H_
#define _WSGRAM_SERVICELEVELAGREEMENTTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum wsgram_ServiceLevelAgreementType_e
{
    wsgram_ServiceLevelAgreementType_undefined,
    wsgram_ServiceLevelAgreementType_job,
    wsgram_ServiceLevelAgreementType_multiJob

};

/**
 * @defgroup wsgram_ServiceLevelAgreementType_choice Complex choice type: wsgram_ServiceLevelAgreementType
 * @ingroup wsgram_ServiceLevelAgreementType
 */

/**
 * Enumeration of the types of values which the wsgram_ServiceLevelAgreementType_choice
 * structure may take on.
 * @ingroup wsgram_ServiceLevelAgreementType_choice
 */
typedef enum wsgram_ServiceLevelAgreementType_e wsgram_ServiceLevelAgreementType_enum;
/**
 * Union of the values which the wsgram_ServiceLevelAgreementType_choice structure
 * contains
 * @ingroup wsgram_ServiceLevelAgreementType_choice
 */
typedef union wsgram_ServiceLevelAgreementType_u wsgram_ServiceLevelAgreementType_union;
/**
 * The wsgram_ServiceLevelAgreementType complex type, which represents the various values
 * possible by the choice used by the
 * {http://www.globus.org/namespaces/2004/10/gram/job/description}choice 37 element.
 * @ingroup wsgram_ServiceLevelAgreementType_choice
 */
typedef struct wsgram_ServiceLevelAgreementType_choice_s wsgram_ServiceLevelAgreementType_choice;
/**
 * The wsgram_ServiceLevelAgreementType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://www.globus.org/namespaces/2004/10/gram/job/description}choice 37 element.
 * @ingroup wsgram_ServiceLevelAgreementType
 */
typedef wsgram_ServiceLevelAgreementType_choice * wsgram_ServiceLevelAgreementType_choice_o;

typedef struct wsgram_ServiceLevelAgreementType_choice_array_s
{
    wsgram_ServiceLevelAgreementType_choice * elements;
    int                                 length;
} wsgram_ServiceLevelAgreementType_choice_array;

#define WSGRAM_SERVICELEVELAGREEMENTTYPE_NS "http://www.globus.org/namespaces/2004/10/gram/job/description"
#define WSGRAM_SERVICELEVELAGREEMENTTYPE_LOCAL "ServiceLevelAgreementType"

extern xsd_QName wsgram_ServiceLevelAgreementType_choice_qname;
extern struct globus_xsd_type_info_s wsgram_ServiceLevelAgreementType_choice_info;
extern struct globus_xsd_type_info_s wsgram_ServiceLevelAgreementType_choice_contents_info;
extern struct globus_xsd_type_info_s wsgram_ServiceLevelAgreementType_choice_array_info;


#include "wsgram_JobDescriptionType.h"
#include "wsgram_MultiJobDescriptionType.h"

union wsgram_ServiceLevelAgreementType_u
{
    /** wsgram_JobDescriptionType subelement */
    wsgram_JobDescriptionType job;
    /** wsgram_MultiJobDescriptionType subelement */
    wsgram_MultiJobDescriptionType multiJob;

};

struct wsgram_ServiceLevelAgreementType_choice_s
{
    wsgram_ServiceLevelAgreementType_enum type;
    wsgram_ServiceLevelAgreementType_union value;
};

globus_result_t
wsgram_ServiceLevelAgreementType_choice_init(
    wsgram_ServiceLevelAgreementType_choice ** inst);

void
wsgram_ServiceLevelAgreementType_choice_destroy(
    wsgram_ServiceLevelAgreementType_choice * inst);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_copy(
    wsgram_ServiceLevelAgreementType_choice ** dest,
    const wsgram_ServiceLevelAgreementType_choice * src);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_init_contents(
    wsgram_ServiceLevelAgreementType_choice * instance);

void
wsgram_ServiceLevelAgreementType_choice_destroy_contents(
    wsgram_ServiceLevelAgreementType_choice * inst);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_copy_contents(
    wsgram_ServiceLevelAgreementType_choice * dest,
    const wsgram_ServiceLevelAgreementType_choice * src);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_init(
    wsgram_ServiceLevelAgreementType_choice_array ** inst);

void
wsgram_ServiceLevelAgreementType_choice_array_destroy(
    wsgram_ServiceLevelAgreementType_choice_array * inst);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_copy(
    wsgram_ServiceLevelAgreementType_choice_array ** dest,
    const wsgram_ServiceLevelAgreementType_choice_array * src);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_init_contents(
    wsgram_ServiceLevelAgreementType_choice_array * inst);

void
wsgram_ServiceLevelAgreementType_choice_array_destroy_contents(
    wsgram_ServiceLevelAgreementType_choice_array * inst);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_copy_contents(
    wsgram_ServiceLevelAgreementType_choice_array * dest,
    const wsgram_ServiceLevelAgreementType_choice_array * src);

wsgram_ServiceLevelAgreementType_choice *
wsgram_ServiceLevelAgreementType_choice_array_push(
    wsgram_ServiceLevelAgreementType_choice_array * array);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_serialize(
    xsd_QName *                         element_name,
    wsgram_ServiceLevelAgreementType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_serialize_contents(
    xsd_QName *                         element_name,
    wsgram_ServiceLevelAgreementType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_deserialize(
    xsd_QName *                         element_name,
    wsgram_ServiceLevelAgreementType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    wsgram_ServiceLevelAgreementType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    wsgram_ServiceLevelAgreementType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_serialize(
    xsd_QName *                         element,
    wsgram_ServiceLevelAgreementType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_deserialize(
    xsd_QName *                         element,
    wsgram_ServiceLevelAgreementType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_init_wrapper(
    void **                             object);
    
void
wsgram_ServiceLevelAgreementType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_init_contents_wrapper(
    void *                              object);
    
void
wsgram_ServiceLevelAgreementType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_init_wrapper(
    void **                             arr);
    
void
wsgram_ServiceLevelAgreementType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_init_contents_wrapper(
    void *                              arr);

void
wsgram_ServiceLevelAgreementType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
wsgram_ServiceLevelAgreementType_choice_array_push_wrapper(
    void * array);

globus_result_t
wsgram_ServiceLevelAgreementType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
