/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_DIRECTORYTYPE_H_
#define _WSMDS_DIRECTORYTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_DirectoryType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}DirectoryType element.
 * @ingroup wsmds_DirectoryType
 */
typedef struct wsmds_DirectoryType_s wsmds_DirectoryType;
/**
 * The wsmds_DirectoryType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}DirectoryType element.
 * @ingroup wsmds_DirectoryType
 */
typedef wsmds_DirectoryType * wsmds_DirectoryType_o;

/**
 * Namespace of the wsmds_DirectoryType complex type
 * @ingroup wsmds_DirectoryType
 */
#define WSMDS_DIRECTORYTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_DirectoryType complex type
 * @ingroup wsmds_DirectoryType
 */
#define WSMDS_DIRECTORYTYPE_LOCAL "DirectoryType"

/**
 * QName of the wsmds_DirectoryType complex type
 * @ingroup wsmds_DirectoryType
 */
extern xsd_QName wsmds_DirectoryType_qname;
/**
 * Type information for serializing and deserializing wsmds_DirectoryType elements
 * @ingroup wsmds_DirectoryType
 */
extern struct globus_xsd_type_info_s wsmds_DirectoryType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_DirectoryType
 * elements
 * @ingroup wsmds_DirectoryType
 */
extern struct globus_xsd_type_info_s wsmds_DirectoryType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_DirectoryType without surrounding elements
 * @ingroup wsmds_DirectoryType
 */
extern struct globus_xsd_type_info_s wsmds_DirectoryType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_dateTime.h"
#include "xsd_dateTime.h"
#include "xsd_dateTime.h"
#include "xsd_duration.h"
#include "xsd_dateTime.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_long.h"
#include "wsmds_FileType_array.h"
#include "wsmds_mountType_array.h"
#include "wsmds_DirectoryType_array.h"

/**
 * @defgroup wsmds_DirectoryType Complex type: wsmds_DirectoryType
 * @ingroup types
 */

/**
 * C structure for the wsmds_DirectoryType complex type
 * @ingroup wsmds_DirectoryType
 */
struct wsmds_DirectoryType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_dateTime_o _CreationDate;
    xsd_dateTime_o _LastAccessed;
    xsd_dateTime_o _LastModified;
    xsd_duration_o _Latency;
    xsd_dateTime_o _LifeTime;
    xsd_string_o _Name;
    xsd_string_o _Owner;
    xsd_long_o _Size;
   /** Array of [0 .. Infinity] wsmds_FileType elements */
    wsmds_FileType_array File;
   /** Array of [0 .. Infinity] wsmds_mountType elements */
    wsmds_mountType_array mount;

};

/**
 * Initialize a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 *
 * Allocates a new wsmds_DirectoryType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_DirectoryType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_DirectoryType_init(
    wsmds_DirectoryType ** inst);

/**
 * Destroy a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 *
 * Frees a wsmds_DirectoryType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_DirectoryType_destroy(
    wsmds_DirectoryType * inst);

/**
 * Copy a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 *
 * Perform a deep copy of a wsmds_DirectoryType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_DirectoryType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_DirectoryType to be copied.
 */
globus_result_t
wsmds_DirectoryType_copy(
    wsmds_DirectoryType ** dest,
    const wsmds_DirectoryType * src);

/**
 * Initialize the contents of a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 *
 * Initialize the contents of a wsmds_DirectoryType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_DirectoryType_init(). The contents may be freed
 * by calling wsmds_DirectoryType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_DirectoryType.
 */
globus_result_t
wsmds_DirectoryType_init_contents(
    wsmds_DirectoryType * instance);

/**
 * Destroy the contents of a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 *
 * Destroy the subelements and attributes of the given wsmds_DirectoryType. 
 *
 * @param inst
 *     Pointer to a wsmds_DirectoryType instance to destroy.
 */
void
wsmds_DirectoryType_destroy_contents(
    wsmds_DirectoryType * inst);

/**
 * Copy the contents of a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 *
 * Perform a deep copy of the contents of a wsmds_DirectoryType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_DirectoryType to be copied.
 */
globus_result_t
wsmds_DirectoryType_copy_contents(
    wsmds_DirectoryType * dest,
    const wsmds_DirectoryType * src);

/**
 * Serialize a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType_array
 * Serialize a wsmds_DirectoryType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_DirectoryType.
 * @param val
 *     The wsmds_DirectoryType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_DirectoryType_serialize(
    xsd_QName *                         element_name,
    wsmds_DirectoryType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType_array
 * Serialize a wsmds_DirectoryType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_DirectoryType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_DirectoryType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_DirectoryType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 * Deserialize an element containing a wsmds_DirectoryType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_DirectoryType.
 * @param val
 *     Pointer to the wsmds_DirectoryType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_DirectoryType_deserialize(
    xsd_QName *                         element_name,
    wsmds_DirectoryType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 * Deserialize a wsmds_DirectoryType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_DirectoryType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_DirectoryType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_DirectoryType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_DirectoryType
 * @ingroup wsmds_DirectoryType
 * Deserialize the next element if it contains a wsmds_DirectoryType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_DirectoryType.
 * @param instance
 *     Pointer to the <code>wsmds_DirectoryType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_DirectoryType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_DirectoryType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_DirectoryType_init_wrapper(
    void **                             object);
    
void
wsmds_DirectoryType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_DirectoryType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_DirectoryType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_DirectoryType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_DirectoryType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_DirectoryType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_DirectoryType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_DirectoryType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_DirectoryType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
