/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_JOBTYPE_H_
#define _WSMDS_JOBTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_JobType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}JobType element.
 * @ingroup wsmds_JobType
 */
typedef struct wsmds_JobType_s wsmds_JobType;
/**
 * The wsmds_JobType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}JobType element.
 * @ingroup wsmds_JobType
 */
typedef wsmds_JobType * wsmds_JobType_o;

/**
 * Namespace of the wsmds_JobType complex type
 * @ingroup wsmds_JobType
 */
#define WSMDS_JOBTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_JobType complex type
 * @ingroup wsmds_JobType
 */
#define WSMDS_JOBTYPE_LOCAL "JobType"

/**
 * QName of the wsmds_JobType complex type
 * @ingroup wsmds_JobType
 */
extern xsd_QName wsmds_JobType_qname;
/**
 * Type information for serializing and deserializing wsmds_JobType elements
 * @ingroup wsmds_JobType
 */
extern struct globus_xsd_type_info_s wsmds_JobType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_JobType
 * elements
 * @ingroup wsmds_JobType
 */
extern struct globus_xsd_type_info_s wsmds_JobType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_JobType without surrounding elements
 * @ingroup wsmds_JobType
 */
extern struct globus_xsd_type_info_s wsmds_JobType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "wsmds_JobType_array.h"

/**
 * @defgroup wsmds_JobType Complex type: wsmds_JobType
 * @ingroup types
 */

/**
 * C structure for the wsmds_JobType complex type
 * @ingroup wsmds_JobType
 */
struct wsmds_JobType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_string_o _GlobalID;
    xsd_string_o _GlobalOwner;
    xsd_string_o _LocalID;
    xsd_string_o _LocalOwner;
    xsd_string_o _SchedulerSpecific;
    xsd_string_o _Status;

};

/**
 * Initialize a wsmds_JobType
 * @ingroup wsmds_JobType
 *
 * Allocates a new wsmds_JobType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_JobType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_JobType_init(
    wsmds_JobType ** inst);

/**
 * Destroy a wsmds_JobType
 * @ingroup wsmds_JobType
 *
 * Frees a wsmds_JobType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_JobType_destroy(
    wsmds_JobType * inst);

/**
 * Copy a wsmds_JobType
 * @ingroup wsmds_JobType
 *
 * Perform a deep copy of a wsmds_JobType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_JobType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_JobType to be copied.
 */
globus_result_t
wsmds_JobType_copy(
    wsmds_JobType ** dest,
    const wsmds_JobType * src);

/**
 * Initialize the contents of a wsmds_JobType
 * @ingroup wsmds_JobType
 *
 * Initialize the contents of a wsmds_JobType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_JobType_init(). The contents may be freed
 * by calling wsmds_JobType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_JobType.
 */
globus_result_t
wsmds_JobType_init_contents(
    wsmds_JobType * instance);

/**
 * Destroy the contents of a wsmds_JobType
 * @ingroup wsmds_JobType
 *
 * Destroy the subelements and attributes of the given wsmds_JobType. 
 *
 * @param inst
 *     Pointer to a wsmds_JobType instance to destroy.
 */
void
wsmds_JobType_destroy_contents(
    wsmds_JobType * inst);

/**
 * Copy the contents of a wsmds_JobType
 * @ingroup wsmds_JobType
 *
 * Perform a deep copy of the contents of a wsmds_JobType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_JobType to be copied.
 */
globus_result_t
wsmds_JobType_copy_contents(
    wsmds_JobType * dest,
    const wsmds_JobType * src);

/**
 * Serialize a wsmds_JobType
 * @ingroup wsmds_JobType_array
 * Serialize a wsmds_JobType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_JobType.
 * @param val
 *     The wsmds_JobType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_JobType_serialize(
    xsd_QName *                         element_name,
    wsmds_JobType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_JobType
 * @ingroup wsmds_JobType_array
 * Serialize a wsmds_JobType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_JobType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_JobType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_JobType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_JobType
 * @ingroup wsmds_JobType
 * Deserialize an element containing a wsmds_JobType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_JobType.
 * @param val
 *     Pointer to the wsmds_JobType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_JobType_deserialize(
    xsd_QName *                         element_name,
    wsmds_JobType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_JobType
 * @ingroup wsmds_JobType
 * Deserialize a wsmds_JobType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_JobType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_JobType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_JobType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_JobType
 * @ingroup wsmds_JobType
 * Deserialize the next element if it contains a wsmds_JobType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_JobType.
 * @param instance
 *     Pointer to the <code>wsmds_JobType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_JobType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_JobType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_JobType_init_wrapper(
    void **                             object);
    
void
wsmds_JobType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_JobType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_JobType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_JobType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_JobType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_JobType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_JobType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_JobType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_JobType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
