/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_LOADTYPE_H_
#define _WSMDS_LOADTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_LoadType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}LoadType element.
 * @ingroup wsmds_LoadType
 */
typedef struct wsmds_LoadType_s wsmds_LoadType;
/**
 * The wsmds_LoadType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}LoadType element.
 * @ingroup wsmds_LoadType
 */
typedef wsmds_LoadType * wsmds_LoadType_o;

/**
 * Namespace of the wsmds_LoadType complex type
 * @ingroup wsmds_LoadType
 */
#define WSMDS_LOADTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_LoadType complex type
 * @ingroup wsmds_LoadType
 */
#define WSMDS_LOADTYPE_LOCAL "LoadType"

/**
 * QName of the wsmds_LoadType complex type
 * @ingroup wsmds_LoadType
 */
extern xsd_QName wsmds_LoadType_qname;
/**
 * Type information for serializing and deserializing wsmds_LoadType elements
 * @ingroup wsmds_LoadType
 */
extern struct globus_xsd_type_info_s wsmds_LoadType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_LoadType
 * elements
 * @ingroup wsmds_LoadType
 */
extern struct globus_xsd_type_info_s wsmds_LoadType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_LoadType without surrounding elements
 * @ingroup wsmds_LoadType
 */
extern struct globus_xsd_type_info_s wsmds_LoadType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "wsmds_LoadType_array.h"

/**
 * @defgroup wsmds_LoadType Complex type: wsmds_LoadType
 * @ingroup types
 */

/**
 * C structure for the wsmds_LoadType complex type
 * @ingroup wsmds_LoadType
 */
struct wsmds_LoadType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_int_o _Last15Min;
    xsd_int_o _Last1Min;
    xsd_int_o _Last5Min;

};

/**
 * Initialize a wsmds_LoadType
 * @ingroup wsmds_LoadType
 *
 * Allocates a new wsmds_LoadType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_LoadType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_LoadType_init(
    wsmds_LoadType ** inst);

/**
 * Destroy a wsmds_LoadType
 * @ingroup wsmds_LoadType
 *
 * Frees a wsmds_LoadType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_LoadType_destroy(
    wsmds_LoadType * inst);

/**
 * Copy a wsmds_LoadType
 * @ingroup wsmds_LoadType
 *
 * Perform a deep copy of a wsmds_LoadType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_LoadType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_LoadType to be copied.
 */
globus_result_t
wsmds_LoadType_copy(
    wsmds_LoadType ** dest,
    const wsmds_LoadType * src);

/**
 * Initialize the contents of a wsmds_LoadType
 * @ingroup wsmds_LoadType
 *
 * Initialize the contents of a wsmds_LoadType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_LoadType_init(). The contents may be freed
 * by calling wsmds_LoadType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_LoadType.
 */
globus_result_t
wsmds_LoadType_init_contents(
    wsmds_LoadType * instance);

/**
 * Destroy the contents of a wsmds_LoadType
 * @ingroup wsmds_LoadType
 *
 * Destroy the subelements and attributes of the given wsmds_LoadType. 
 *
 * @param inst
 *     Pointer to a wsmds_LoadType instance to destroy.
 */
void
wsmds_LoadType_destroy_contents(
    wsmds_LoadType * inst);

/**
 * Copy the contents of a wsmds_LoadType
 * @ingroup wsmds_LoadType
 *
 * Perform a deep copy of the contents of a wsmds_LoadType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_LoadType to be copied.
 */
globus_result_t
wsmds_LoadType_copy_contents(
    wsmds_LoadType * dest,
    const wsmds_LoadType * src);

/**
 * Serialize a wsmds_LoadType
 * @ingroup wsmds_LoadType_array
 * Serialize a wsmds_LoadType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_LoadType.
 * @param val
 *     The wsmds_LoadType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_LoadType_serialize(
    xsd_QName *                         element_name,
    wsmds_LoadType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_LoadType
 * @ingroup wsmds_LoadType_array
 * Serialize a wsmds_LoadType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_LoadType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_LoadType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_LoadType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_LoadType
 * @ingroup wsmds_LoadType
 * Deserialize an element containing a wsmds_LoadType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_LoadType.
 * @param val
 *     Pointer to the wsmds_LoadType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_LoadType_deserialize(
    xsd_QName *                         element_name,
    wsmds_LoadType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_LoadType
 * @ingroup wsmds_LoadType
 * Deserialize a wsmds_LoadType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_LoadType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_LoadType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_LoadType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_LoadType
 * @ingroup wsmds_LoadType
 * Deserialize the next element if it contains a wsmds_LoadType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_LoadType.
 * @param instance
 *     Pointer to the <code>wsmds_LoadType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_LoadType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_LoadType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_LoadType_init_wrapper(
    void **                             object);
    
void
wsmds_LoadType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_LoadType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_LoadType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_LoadType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_LoadType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_LoadType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_LoadType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_LoadType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_LoadType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
