/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_PROCESSORTYPE_H_
#define _WSMDS_PROCESSORTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_ProcessorType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}ProcessorType element.
 * @ingroup wsmds_ProcessorType
 */
typedef struct wsmds_ProcessorType_s wsmds_ProcessorType;
/**
 * The wsmds_ProcessorType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}ProcessorType element.
 * @ingroup wsmds_ProcessorType
 */
typedef wsmds_ProcessorType * wsmds_ProcessorType_o;

/**
 * Namespace of the wsmds_ProcessorType complex type
 * @ingroup wsmds_ProcessorType
 */
#define WSMDS_PROCESSORTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_ProcessorType complex type
 * @ingroup wsmds_ProcessorType
 */
#define WSMDS_PROCESSORTYPE_LOCAL "ProcessorType"

/**
 * QName of the wsmds_ProcessorType complex type
 * @ingroup wsmds_ProcessorType
 */
extern xsd_QName wsmds_ProcessorType_qname;
/**
 * Type information for serializing and deserializing wsmds_ProcessorType elements
 * @ingroup wsmds_ProcessorType
 */
extern struct globus_xsd_type_info_s wsmds_ProcessorType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_ProcessorType
 * elements
 * @ingroup wsmds_ProcessorType
 */
extern struct globus_xsd_type_info_s wsmds_ProcessorType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_ProcessorType without surrounding elements
 * @ingroup wsmds_ProcessorType
 */
extern struct globus_xsd_type_info_s wsmds_ProcessorType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "xsd_string.h"
#include "wsmds_ProcessorType_array.h"

/**
 * @defgroup wsmds_ProcessorType Complex type: wsmds_ProcessorType
 * @ingroup types
 */

/**
 * C structure for the wsmds_ProcessorType complex type
 * @ingroup wsmds_ProcessorType
 */
struct wsmds_ProcessorType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_int_o _CacheL1;
    xsd_int_o _CacheL1D;
    xsd_int_o _CacheL1I;
    xsd_int_o _CacheL2;
    xsd_int_o _ClockSpeed;
    xsd_string_o _InstructionSet;
    xsd_string_o _Model;
    xsd_string_o _OtherProcessorDescription;
    xsd_string_o _Vendor;
    xsd_string_o _Version;

};

/**
 * Initialize a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 *
 * Allocates a new wsmds_ProcessorType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_ProcessorType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_ProcessorType_init(
    wsmds_ProcessorType ** inst);

/**
 * Destroy a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 *
 * Frees a wsmds_ProcessorType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_ProcessorType_destroy(
    wsmds_ProcessorType * inst);

/**
 * Copy a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 *
 * Perform a deep copy of a wsmds_ProcessorType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_ProcessorType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_ProcessorType to be copied.
 */
globus_result_t
wsmds_ProcessorType_copy(
    wsmds_ProcessorType ** dest,
    const wsmds_ProcessorType * src);

/**
 * Initialize the contents of a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 *
 * Initialize the contents of a wsmds_ProcessorType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_ProcessorType_init(). The contents may be freed
 * by calling wsmds_ProcessorType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_ProcessorType.
 */
globus_result_t
wsmds_ProcessorType_init_contents(
    wsmds_ProcessorType * instance);

/**
 * Destroy the contents of a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 *
 * Destroy the subelements and attributes of the given wsmds_ProcessorType. 
 *
 * @param inst
 *     Pointer to a wsmds_ProcessorType instance to destroy.
 */
void
wsmds_ProcessorType_destroy_contents(
    wsmds_ProcessorType * inst);

/**
 * Copy the contents of a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 *
 * Perform a deep copy of the contents of a wsmds_ProcessorType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_ProcessorType to be copied.
 */
globus_result_t
wsmds_ProcessorType_copy_contents(
    wsmds_ProcessorType * dest,
    const wsmds_ProcessorType * src);

/**
 * Serialize a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType_array
 * Serialize a wsmds_ProcessorType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_ProcessorType.
 * @param val
 *     The wsmds_ProcessorType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_ProcessorType_serialize(
    xsd_QName *                         element_name,
    wsmds_ProcessorType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType_array
 * Serialize a wsmds_ProcessorType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_ProcessorType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_ProcessorType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_ProcessorType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 * Deserialize an element containing a wsmds_ProcessorType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_ProcessorType.
 * @param val
 *     Pointer to the wsmds_ProcessorType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_ProcessorType_deserialize(
    xsd_QName *                         element_name,
    wsmds_ProcessorType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 * Deserialize a wsmds_ProcessorType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_ProcessorType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_ProcessorType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_ProcessorType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_ProcessorType
 * @ingroup wsmds_ProcessorType
 * Deserialize the next element if it contains a wsmds_ProcessorType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_ProcessorType.
 * @param instance
 *     Pointer to the <code>wsmds_ProcessorType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_ProcessorType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_ProcessorType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_ProcessorType_init_wrapper(
    void **                             object);
    
void
wsmds_ProcessorType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_ProcessorType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_ProcessorType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_ProcessorType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_ProcessorType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_ProcessorType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_ProcessorType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_ProcessorType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_ProcessorType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
