/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSMDS_MOUNTTYPE_H_
#define _WSMDS_MOUNTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsmds_mountType complex type, which represents the
 * {http://mds.globus.org/glue/ce/1.1}complexType 61 element.
 * @ingroup wsmds_mountType
 */
typedef struct wsmds_mountType_s wsmds_mountType;
/**
 * The wsmds_mountType_o complex type, which represents an optional instance
 * of a
 * {http://mds.globus.org/glue/ce/1.1}complexType 61 element.
 * @ingroup wsmds_mountType
 */
typedef wsmds_mountType * wsmds_mountType_o;

/**
 * Namespace of the wsmds_mountType complex type
 * @ingroup wsmds_mountType
 */
#define WSMDS_MOUNTTYPE_NS "http://mds.globus.org/glue/ce/1.1"
/**
 * Local part of the QName of the wsmds_mountType complex type
 * @ingroup wsmds_mountType
 */
#define WSMDS_MOUNTTYPE_LOCAL "mountType"

/**
 * QName of the wsmds_mountType complex type
 * @ingroup wsmds_mountType
 */
extern xsd_QName wsmds_mountType_qname;
/**
 * Type information for serializing and deserializing wsmds_mountType elements
 * @ingroup wsmds_mountType
 */
extern struct globus_xsd_type_info_s wsmds_mountType_info;
/**
 * Type information for serializing and deserializing arrays of wsmds_mountType
 * elements
 * @ingroup wsmds_mountType
 */
extern struct globus_xsd_type_info_s wsmds_mountType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsmds_mountType without surrounding elements
 * @ingroup wsmds_mountType
 */
extern struct globus_xsd_type_info_s wsmds_mountType_contents_info;


#include "xsd_string.h"
#include "wsmds_mountType_array.h"

/**
 * @defgroup wsmds_mountType Complex type: wsmds_mountType
 * @ingroup types
 */

/**
 * C structure for the wsmds_mountType complex type
 * @ingroup wsmds_mountType
 */
struct wsmds_mountType_s
{
    xsd_string_o _FileSystemName;

};

/**
 * Initialize a wsmds_mountType
 * @ingroup wsmds_mountType
 *
 * Allocates a new wsmds_mountType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsmds_mountType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsmds_mountType_init(
    wsmds_mountType ** inst);

/**
 * Destroy a wsmds_mountType
 * @ingroup wsmds_mountType
 *
 * Frees a wsmds_mountType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsmds_mountType_destroy(
    wsmds_mountType * inst);

/**
 * Copy a wsmds_mountType
 * @ingroup wsmds_mountType
 *
 * Perform a deep copy of a wsmds_mountType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsmds_mountType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsmds_mountType to be copied.
 */
globus_result_t
wsmds_mountType_copy(
    wsmds_mountType ** dest,
    const wsmds_mountType * src);

/**
 * Initialize the contents of a wsmds_mountType
 * @ingroup wsmds_mountType
 *
 * Initialize the contents of a wsmds_mountType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsmds_mountType_init(). The contents may be freed
 * by calling wsmds_mountType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsmds_mountType.
 */
globus_result_t
wsmds_mountType_init_contents(
    wsmds_mountType * instance);

/**
 * Destroy the contents of a wsmds_mountType
 * @ingroup wsmds_mountType
 *
 * Destroy the subelements and attributes of the given wsmds_mountType. 
 *
 * @param inst
 *     Pointer to a wsmds_mountType instance to destroy.
 */
void
wsmds_mountType_destroy_contents(
    wsmds_mountType * inst);

/**
 * Copy the contents of a wsmds_mountType
 * @ingroup wsmds_mountType
 *
 * Perform a deep copy of the contents of a wsmds_mountType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsmds_mountType to be copied.
 */
globus_result_t
wsmds_mountType_copy_contents(
    wsmds_mountType * dest,
    const wsmds_mountType * src);

/**
 * Serialize a wsmds_mountType
 * @ingroup wsmds_mountType_array
 * Serialize a wsmds_mountType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsmds_mountType.
 * @param val
 *     The wsmds_mountType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_mountType_serialize(
    xsd_QName *                         element_name,
    wsmds_mountType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsmds_mountType
 * @ingroup wsmds_mountType_array
 * Serialize a wsmds_mountType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsmds_mountType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsmds_mountType_serialize_contents(
    xsd_QName *                         element_name,
    wsmds_mountType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_mountType
 * @ingroup wsmds_mountType
 * Deserialize an element containing a wsmds_mountType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_mountType.
 * @param val
 *     Pointer to the wsmds_mountType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_mountType_deserialize(
    xsd_QName *                         element_name,
    wsmds_mountType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsmds_mountType
 * @ingroup wsmds_mountType
 * Deserialize a wsmds_mountType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsmds_mountType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_mountType_deserialize_contents(
    xsd_QName *                         element_name,
    wsmds_mountType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsmds_mountType
 * @ingroup wsmds_mountType
 * Deserialize the next element if it contains a wsmds_mountType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsmds_mountType.
 * @param instance
 *     Pointer to the <code>wsmds_mountType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsmds_mountType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsmds_mountType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsmds_mountType_init_wrapper(
    void **                             object);
    
void
wsmds_mountType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsmds_mountType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_mountType_init_contents_wrapper(
    void *                              object);
    
void
wsmds_mountType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsmds_mountType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsmds_mountType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_mountType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsmds_mountType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsmds_mountType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
