/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_DSAKEYVALUETYPE_H_
#define _DS_DSAKEYVALUETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_DSAKeyValueType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}DSAKeyValueType element.
 * @ingroup ds_DSAKeyValueType
 */
typedef struct ds_DSAKeyValueType_s ds_DSAKeyValueType;
/**
 * The ds_DSAKeyValueType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}DSAKeyValueType element.
 * @ingroup ds_DSAKeyValueType
 */
typedef ds_DSAKeyValueType * ds_DSAKeyValueType_o;

/**
 * Namespace of the ds_DSAKeyValueType complex type
 * @ingroup ds_DSAKeyValueType
 */
#define DS_DSAKEYVALUETYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_DSAKeyValueType complex type
 * @ingroup ds_DSAKeyValueType
 */
#define DS_DSAKEYVALUETYPE_LOCAL "DSAKeyValueType"

/**
 * QName of the ds_DSAKeyValueType complex type
 * @ingroup ds_DSAKeyValueType
 */
extern xsd_QName ds_DSAKeyValueType_qname;
/**
 * Type information for serializing and deserializing ds_DSAKeyValueType elements
 * @ingroup ds_DSAKeyValueType
 */
extern struct globus_xsd_type_info_s ds_DSAKeyValueType_info;
/**
 * Type information for serializing and deserializing arrays of ds_DSAKeyValueType
 * elements
 * @ingroup ds_DSAKeyValueType
 */
extern struct globus_xsd_type_info_s ds_DSAKeyValueType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_DSAKeyValueType without surrounding elements
 * @ingroup ds_DSAKeyValueType
 */
extern struct globus_xsd_type_info_s ds_DSAKeyValueType_contents_info;


#include "ds_CryptoBinary.h"
#include "ds_CryptoBinary.h"
#include "ds_CryptoBinary.h"
#include "ds_CryptoBinary.h"
#include "ds_CryptoBinary.h"
#include "ds_CryptoBinary.h"
#include "ds_CryptoBinary.h"
#include "ds_DSAKeyValueType_array.h"

/**
 * @defgroup ds_DSAKeyValueType Complex type: ds_DSAKeyValueType
 * @ingroup types
 */

/**
 * C structure for the ds_DSAKeyValueType complex type
 * @ingroup ds_DSAKeyValueType
 */
struct ds_DSAKeyValueType_s
{
    /** ds_CryptoBinary subelement */
    ds_CryptoBinary P;
    /** ds_CryptoBinary subelement */
    ds_CryptoBinary Q;
   /** Optional ds_CryptoBinary subelement */
    ds_CryptoBinary_o G;
    /** ds_CryptoBinary subelement */
    ds_CryptoBinary Y;
   /** Optional ds_CryptoBinary subelement */
    ds_CryptoBinary_o J;
    /** ds_CryptoBinary subelement */
    ds_CryptoBinary Seed;
    /** ds_CryptoBinary subelement */
    ds_CryptoBinary PgenCounter;

};

/**
 * Initialize a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 *
 * Allocates a new ds_DSAKeyValueType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_DSAKeyValueType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_DSAKeyValueType_init(
    ds_DSAKeyValueType ** inst);

/**
 * Destroy a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 *
 * Frees a ds_DSAKeyValueType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_DSAKeyValueType_destroy(
    ds_DSAKeyValueType * inst);

/**
 * Copy a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 *
 * Perform a deep copy of a ds_DSAKeyValueType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_DSAKeyValueType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_DSAKeyValueType to be copied.
 */
globus_result_t
ds_DSAKeyValueType_copy(
    ds_DSAKeyValueType ** dest,
    const ds_DSAKeyValueType * src);

/**
 * Initialize the contents of a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 *
 * Initialize the contents of a ds_DSAKeyValueType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_DSAKeyValueType_init(). The contents may be freed
 * by calling ds_DSAKeyValueType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_DSAKeyValueType.
 */
globus_result_t
ds_DSAKeyValueType_init_contents(
    ds_DSAKeyValueType * instance);

/**
 * Destroy the contents of a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 *
 * Destroy the subelements and attributes of the given ds_DSAKeyValueType. 
 *
 * @param inst
 *     Pointer to a ds_DSAKeyValueType instance to destroy.
 */
void
ds_DSAKeyValueType_destroy_contents(
    ds_DSAKeyValueType * inst);

/**
 * Copy the contents of a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 *
 * Perform a deep copy of the contents of a ds_DSAKeyValueType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_DSAKeyValueType to be copied.
 */
globus_result_t
ds_DSAKeyValueType_copy_contents(
    ds_DSAKeyValueType * dest,
    const ds_DSAKeyValueType * src);

/**
 * Serialize a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType_array
 * Serialize a ds_DSAKeyValueType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_DSAKeyValueType.
 * @param val
 *     The ds_DSAKeyValueType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_DSAKeyValueType_serialize(
    xsd_QName *                         element_name,
    ds_DSAKeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType_array
 * Serialize a ds_DSAKeyValueType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_DSAKeyValueType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_DSAKeyValueType_serialize_contents(
    xsd_QName *                         element_name,
    ds_DSAKeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 * Deserialize an element containing a ds_DSAKeyValueType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_DSAKeyValueType.
 * @param val
 *     Pointer to the ds_DSAKeyValueType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_DSAKeyValueType_deserialize(
    xsd_QName *                         element_name,
    ds_DSAKeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 * Deserialize a ds_DSAKeyValueType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_DSAKeyValueType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_DSAKeyValueType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_DSAKeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_DSAKeyValueType
 * @ingroup ds_DSAKeyValueType
 * Deserialize the next element if it contains a ds_DSAKeyValueType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_DSAKeyValueType.
 * @param instance
 *     Pointer to the <code>ds_DSAKeyValueType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_DSAKeyValueType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_DSAKeyValueType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_DSAKeyValueType_init_wrapper(
    void **                             object);
    
void
ds_DSAKeyValueType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_DSAKeyValueType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_DSAKeyValueType_init_contents_wrapper(
    void *                              object);
    
void
ds_DSAKeyValueType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_DSAKeyValueType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_DSAKeyValueType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_DSAKeyValueType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_DSAKeyValueType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_DSAKeyValueType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
