/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_KEYINFOTYPE_H_
#define _DS_KEYINFOTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_KeyInfoType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}KeyInfoType element.
 * @ingroup ds_KeyInfoType
 */
typedef struct ds_KeyInfoType_s ds_KeyInfoType;
/**
 * The ds_KeyInfoType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}KeyInfoType element.
 * @ingroup ds_KeyInfoType
 */
typedef ds_KeyInfoType * ds_KeyInfoType_o;

/**
 * Namespace of the ds_KeyInfoType complex type
 * @ingroup ds_KeyInfoType
 */
#define DS_KEYINFOTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_KeyInfoType complex type
 * @ingroup ds_KeyInfoType
 */
#define DS_KEYINFOTYPE_LOCAL "KeyInfoType"

/**
 * QName of the ds_KeyInfoType complex type
 * @ingroup ds_KeyInfoType
 */
extern xsd_QName ds_KeyInfoType_qname;
/**
 * Type information for serializing and deserializing ds_KeyInfoType elements
 * @ingroup ds_KeyInfoType
 */
extern struct globus_xsd_type_info_s ds_KeyInfoType_info;
/**
 * Type information for serializing and deserializing arrays of ds_KeyInfoType
 * elements
 * @ingroup ds_KeyInfoType
 */
extern struct globus_xsd_type_info_s ds_KeyInfoType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_KeyInfoType without surrounding elements
 * @ingroup ds_KeyInfoType
 */
extern struct globus_xsd_type_info_s ds_KeyInfoType_contents_info;


#include "ds_KeyInfoType_choice.h"
#include "xsd_ID.h"
#include "ds_KeyInfoType_array.h"

/**
 * @defgroup ds_KeyInfoType Complex type: ds_KeyInfoType
 * @ingroup types
 */

/**
 * C structure for the ds_KeyInfoType complex type
 * @ingroup ds_KeyInfoType
 */
struct ds_KeyInfoType_s
{
   /** Array of [1 .. Infinity] ds_KeyInfoType_choice elements */
    ds_KeyInfoType_choice_array choice_value;
    xsd_ID_o _Id;

};

/**
 * Initialize a ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 *
 * Allocates a new ds_KeyInfoType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_KeyInfoType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_KeyInfoType_init(
    ds_KeyInfoType ** inst);

/**
 * Destroy a ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 *
 * Frees a ds_KeyInfoType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_KeyInfoType_destroy(
    ds_KeyInfoType * inst);

/**
 * Copy a ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 *
 * Perform a deep copy of a ds_KeyInfoType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_KeyInfoType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_KeyInfoType to be copied.
 */
globus_result_t
ds_KeyInfoType_copy(
    ds_KeyInfoType ** dest,
    const ds_KeyInfoType * src);

/**
 * Initialize the contents of a ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 *
 * Initialize the contents of a ds_KeyInfoType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_KeyInfoType_init(). The contents may be freed
 * by calling ds_KeyInfoType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_KeyInfoType.
 */
globus_result_t
ds_KeyInfoType_init_contents(
    ds_KeyInfoType * instance);

/**
 * Destroy the contents of a ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 *
 * Destroy the subelements and attributes of the given ds_KeyInfoType. 
 *
 * @param inst
 *     Pointer to a ds_KeyInfoType instance to destroy.
 */
void
ds_KeyInfoType_destroy_contents(
    ds_KeyInfoType * inst);

/**
 * Copy the contents of a ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 *
 * Perform a deep copy of the contents of a ds_KeyInfoType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_KeyInfoType to be copied.
 */
globus_result_t
ds_KeyInfoType_copy_contents(
    ds_KeyInfoType * dest,
    const ds_KeyInfoType * src);

/**
 * Serialize a ds_KeyInfoType
 * @ingroup ds_KeyInfoType_array
 * Serialize a ds_KeyInfoType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_KeyInfoType.
 * @param val
 *     The ds_KeyInfoType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_KeyInfoType_serialize(
    xsd_QName *                         element_name,
    ds_KeyInfoType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_KeyInfoType
 * @ingroup ds_KeyInfoType_array
 * Serialize a ds_KeyInfoType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_KeyInfoType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_KeyInfoType_serialize_contents(
    xsd_QName *                         element_name,
    ds_KeyInfoType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 * Deserialize an element containing a ds_KeyInfoType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_KeyInfoType.
 * @param val
 *     Pointer to the ds_KeyInfoType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_KeyInfoType_deserialize(
    xsd_QName *                         element_name,
    ds_KeyInfoType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 * Deserialize a ds_KeyInfoType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_KeyInfoType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_KeyInfoType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_KeyInfoType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 * Deserialize the next element if it contains a ds_KeyInfoType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_KeyInfoType.
 * @param instance
 *     Pointer to the <code>ds_KeyInfoType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_KeyInfoType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_KeyInfoType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_KeyInfoType_init_wrapper(
    void **                             object);
    
void
ds_KeyInfoType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_KeyInfoType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_KeyInfoType_init_contents_wrapper(
    void *                              object);
    
void
ds_KeyInfoType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_KeyInfoType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_KeyInfoType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyInfoType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyInfoType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyInfoType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
