/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_KEYINFOTYPE_CHOICE_H_
#define _DS_KEYINFOTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum ds_KeyInfoType_e
{
    ds_KeyInfoType_undefined,
    ds_KeyInfoType_KeyName,
    ds_KeyInfoType_KeyValue,
    ds_KeyInfoType_RetrievalMethod,
    ds_KeyInfoType_X509Data,
    ds_KeyInfoType_PGPData,
    ds_KeyInfoType_SPKIData,
    ds_KeyInfoType_MgmtData,
    ds_KeyInfoType_any

};

/**
 * @defgroup ds_KeyInfoType_choice Complex choice type: ds_KeyInfoType
 * @ingroup ds_KeyInfoType
 */

/**
 * Enumeration of the types of values which the ds_KeyInfoType_choice
 * structure may take on.
 * @ingroup ds_KeyInfoType_choice
 */
typedef enum ds_KeyInfoType_e ds_KeyInfoType_enum;
/**
 * Union of the values which the ds_KeyInfoType_choice structure
 * contains
 * @ingroup ds_KeyInfoType_choice
 */
typedef union ds_KeyInfoType_u ds_KeyInfoType_union;
/**
 * The ds_KeyInfoType complex type, which represents the various values
 * possible by the choice used by the
 * {http://www.w3.org/2000/09/xmldsig#}choice 28 element.
 * @ingroup ds_KeyInfoType_choice
 */
typedef struct ds_KeyInfoType_choice_s ds_KeyInfoType_choice;
/**
 * The ds_KeyInfoType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://www.w3.org/2000/09/xmldsig#}choice 28 element.
 * @ingroup ds_KeyInfoType
 */
typedef ds_KeyInfoType_choice * ds_KeyInfoType_choice_o;

typedef struct ds_KeyInfoType_choice_array_s
{
    ds_KeyInfoType_choice * elements;
    int                                 length;
} ds_KeyInfoType_choice_array;

#define DS_KEYINFOTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
#define DS_KEYINFOTYPE_LOCAL "KeyInfoType"

extern xsd_QName ds_KeyInfoType_choice_qname;
extern struct globus_xsd_type_info_s ds_KeyInfoType_choice_info;
extern struct globus_xsd_type_info_s ds_KeyInfoType_choice_contents_info;
extern struct globus_xsd_type_info_s ds_KeyInfoType_choice_array_info;


#include "xsd_string.h"
#include "ds_KeyValueType.h"
#include "ds_RetrievalMethodType.h"
#include "ds_X509DataType.h"
#include "ds_PGPDataType.h"
#include "ds_SPKIDataType.h"
#include "xsd_string.h"
#include "xsd_any.h"

union ds_KeyInfoType_u
{
    /** xsd_string subelement */
    xsd_string KeyName;
    /** ds_KeyValueType subelement */
    ds_KeyValueType KeyValue;
    /** ds_RetrievalMethodType subelement */
    ds_RetrievalMethodType RetrievalMethod;
    /** ds_X509DataType subelement */
    ds_X509DataType X509Data;
    /** ds_PGPDataType subelement */
    ds_PGPDataType PGPData;
    /** ds_SPKIDataType subelement */
    ds_SPKIDataType SPKIData;
    /** xsd_string subelement */
    xsd_string MgmtData;
    /** xsd_any subelement */
    xsd_any any;

};

struct ds_KeyInfoType_choice_s
{
    ds_KeyInfoType_enum type;
    ds_KeyInfoType_union value;
};

globus_result_t
ds_KeyInfoType_choice_init(
    ds_KeyInfoType_choice ** inst);

void
ds_KeyInfoType_choice_destroy(
    ds_KeyInfoType_choice * inst);

globus_result_t
ds_KeyInfoType_choice_copy(
    ds_KeyInfoType_choice ** dest,
    const ds_KeyInfoType_choice * src);

globus_result_t
ds_KeyInfoType_choice_init_contents(
    ds_KeyInfoType_choice * instance);

void
ds_KeyInfoType_choice_destroy_contents(
    ds_KeyInfoType_choice * inst);

globus_result_t
ds_KeyInfoType_choice_copy_contents(
    ds_KeyInfoType_choice * dest,
    const ds_KeyInfoType_choice * src);
    
globus_result_t
ds_KeyInfoType_choice_array_init(
    ds_KeyInfoType_choice_array ** inst);

void
ds_KeyInfoType_choice_array_destroy(
    ds_KeyInfoType_choice_array * inst);

globus_result_t
ds_KeyInfoType_choice_array_copy(
    ds_KeyInfoType_choice_array ** dest,
    const ds_KeyInfoType_choice_array * src);

globus_result_t
ds_KeyInfoType_choice_array_init_contents(
    ds_KeyInfoType_choice_array * inst);

void
ds_KeyInfoType_choice_array_destroy_contents(
    ds_KeyInfoType_choice_array * inst);

globus_result_t
ds_KeyInfoType_choice_array_copy_contents(
    ds_KeyInfoType_choice_array * dest,
    const ds_KeyInfoType_choice_array * src);

ds_KeyInfoType_choice *
ds_KeyInfoType_choice_array_push(
    ds_KeyInfoType_choice_array * array);

globus_result_t
ds_KeyInfoType_choice_serialize(
    xsd_QName *                         element_name,
    ds_KeyInfoType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyInfoType_choice_serialize_contents(
    xsd_QName *                         element_name,
    ds_KeyInfoType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyInfoType_choice_deserialize(
    xsd_QName *                         element_name,
    ds_KeyInfoType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyInfoType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    ds_KeyInfoType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyInfoType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_KeyInfoType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyInfoType_choice_array_serialize(
    xsd_QName *                         element,
    ds_KeyInfoType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyInfoType_choice_array_deserialize(
    xsd_QName *                         element,
    ds_KeyInfoType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyInfoType_choice_init_wrapper(
    void **                             object);
    
void
ds_KeyInfoType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_KeyInfoType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_KeyInfoType_choice_init_contents_wrapper(
    void *                              object);
    
void
ds_KeyInfoType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_KeyInfoType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_KeyInfoType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyInfoType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyInfoType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyInfoType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyInfoType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyInfoType_choice_array_init_wrapper(
    void **                             arr);
    
void
ds_KeyInfoType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
ds_KeyInfoType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
ds_KeyInfoType_choice_array_init_contents_wrapper(
    void *                              arr);

void
ds_KeyInfoType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
ds_KeyInfoType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
ds_KeyInfoType_choice_array_push_wrapper(
    void * array);

globus_result_t
ds_KeyInfoType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
