/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_KEYVALUETYPE_H_
#define _DS_KEYVALUETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_KeyValueType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}KeyValueType element.
 * @ingroup ds_KeyValueType
 */
typedef struct ds_KeyValueType_s ds_KeyValueType;
/**
 * The ds_KeyValueType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}KeyValueType element.
 * @ingroup ds_KeyValueType
 */
typedef ds_KeyValueType * ds_KeyValueType_o;

/**
 * Namespace of the ds_KeyValueType complex type
 * @ingroup ds_KeyValueType
 */
#define DS_KEYVALUETYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_KeyValueType complex type
 * @ingroup ds_KeyValueType
 */
#define DS_KEYVALUETYPE_LOCAL "KeyValueType"

/**
 * QName of the ds_KeyValueType complex type
 * @ingroup ds_KeyValueType
 */
extern xsd_QName ds_KeyValueType_qname;
/**
 * Type information for serializing and deserializing ds_KeyValueType elements
 * @ingroup ds_KeyValueType
 */
extern struct globus_xsd_type_info_s ds_KeyValueType_info;
/**
 * Type information for serializing and deserializing arrays of ds_KeyValueType
 * elements
 * @ingroup ds_KeyValueType
 */
extern struct globus_xsd_type_info_s ds_KeyValueType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_KeyValueType without surrounding elements
 * @ingroup ds_KeyValueType
 */
extern struct globus_xsd_type_info_s ds_KeyValueType_contents_info;


#include "ds_KeyValueType_choice.h"
#include "ds_KeyValueType_array.h"

/**
 * @defgroup ds_KeyValueType Complex type: ds_KeyValueType
 * @ingroup types
 */

/**
 * C structure for the ds_KeyValueType complex type
 * @ingroup ds_KeyValueType
 */
struct ds_KeyValueType_s
{
    /** ds_KeyValueType_choice subelement */
    ds_KeyValueType_choice choice_value;

};

/**
 * Initialize a ds_KeyValueType
 * @ingroup ds_KeyValueType
 *
 * Allocates a new ds_KeyValueType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_KeyValueType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_KeyValueType_init(
    ds_KeyValueType ** inst);

/**
 * Destroy a ds_KeyValueType
 * @ingroup ds_KeyValueType
 *
 * Frees a ds_KeyValueType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_KeyValueType_destroy(
    ds_KeyValueType * inst);

/**
 * Copy a ds_KeyValueType
 * @ingroup ds_KeyValueType
 *
 * Perform a deep copy of a ds_KeyValueType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_KeyValueType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_KeyValueType to be copied.
 */
globus_result_t
ds_KeyValueType_copy(
    ds_KeyValueType ** dest,
    const ds_KeyValueType * src);

/**
 * Initialize the contents of a ds_KeyValueType
 * @ingroup ds_KeyValueType
 *
 * Initialize the contents of a ds_KeyValueType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_KeyValueType_init(). The contents may be freed
 * by calling ds_KeyValueType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_KeyValueType.
 */
globus_result_t
ds_KeyValueType_init_contents(
    ds_KeyValueType * instance);

/**
 * Destroy the contents of a ds_KeyValueType
 * @ingroup ds_KeyValueType
 *
 * Destroy the subelements and attributes of the given ds_KeyValueType. 
 *
 * @param inst
 *     Pointer to a ds_KeyValueType instance to destroy.
 */
void
ds_KeyValueType_destroy_contents(
    ds_KeyValueType * inst);

/**
 * Copy the contents of a ds_KeyValueType
 * @ingroup ds_KeyValueType
 *
 * Perform a deep copy of the contents of a ds_KeyValueType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_KeyValueType to be copied.
 */
globus_result_t
ds_KeyValueType_copy_contents(
    ds_KeyValueType * dest,
    const ds_KeyValueType * src);

/**
 * Serialize a ds_KeyValueType
 * @ingroup ds_KeyValueType_array
 * Serialize a ds_KeyValueType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_KeyValueType.
 * @param val
 *     The ds_KeyValueType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_KeyValueType_serialize(
    xsd_QName *                         element_name,
    ds_KeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_KeyValueType
 * @ingroup ds_KeyValueType_array
 * Serialize a ds_KeyValueType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_KeyValueType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_KeyValueType_serialize_contents(
    xsd_QName *                         element_name,
    ds_KeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_KeyValueType
 * @ingroup ds_KeyValueType
 * Deserialize an element containing a ds_KeyValueType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_KeyValueType.
 * @param val
 *     Pointer to the ds_KeyValueType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_KeyValueType_deserialize(
    xsd_QName *                         element_name,
    ds_KeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_KeyValueType
 * @ingroup ds_KeyValueType
 * Deserialize a ds_KeyValueType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_KeyValueType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_KeyValueType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_KeyValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_KeyValueType
 * @ingroup ds_KeyValueType
 * Deserialize the next element if it contains a ds_KeyValueType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_KeyValueType.
 * @param instance
 *     Pointer to the <code>ds_KeyValueType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_KeyValueType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_KeyValueType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_KeyValueType_init_wrapper(
    void **                             object);
    
void
ds_KeyValueType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_KeyValueType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_KeyValueType_init_contents_wrapper(
    void *                              object);
    
void
ds_KeyValueType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_KeyValueType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_KeyValueType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyValueType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_KeyValueType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_KeyValueType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
