/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_OBJECTTYPE_H_
#define _DS_OBJECTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_ObjectType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}ObjectType element.
 * @ingroup ds_ObjectType
 */
typedef struct ds_ObjectType_s ds_ObjectType;
/**
 * The ds_ObjectType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}ObjectType element.
 * @ingroup ds_ObjectType
 */
typedef ds_ObjectType * ds_ObjectType_o;

/**
 * Namespace of the ds_ObjectType complex type
 * @ingroup ds_ObjectType
 */
#define DS_OBJECTTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_ObjectType complex type
 * @ingroup ds_ObjectType
 */
#define DS_OBJECTTYPE_LOCAL "ObjectType"

/**
 * QName of the ds_ObjectType complex type
 * @ingroup ds_ObjectType
 */
extern xsd_QName ds_ObjectType_qname;
/**
 * Type information for serializing and deserializing ds_ObjectType elements
 * @ingroup ds_ObjectType
 */
extern struct globus_xsd_type_info_s ds_ObjectType_info;
/**
 * Type information for serializing and deserializing arrays of ds_ObjectType
 * elements
 * @ingroup ds_ObjectType
 */
extern struct globus_xsd_type_info_s ds_ObjectType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_ObjectType without surrounding elements
 * @ingroup ds_ObjectType
 */
extern struct globus_xsd_type_info_s ds_ObjectType_contents_info;


#include "xsd_any.h"
#include "xsd_anyURI.h"
#include "xsd_ID.h"
#include "xsd_string.h"
#include "ds_ObjectType_array.h"

/**
 * @defgroup ds_ObjectType Complex type: ds_ObjectType
 * @ingroup types
 */

/**
 * C structure for the ds_ObjectType complex type
 * @ingroup ds_ObjectType
 */
struct ds_ObjectType_s
{
    /** xsd_any subelement */
    xsd_any any;
    xsd_anyURI_o _Encoding;
    xsd_ID_o _Id;
    xsd_string_o _MimeType;

};

/**
 * Initialize a ds_ObjectType
 * @ingroup ds_ObjectType
 *
 * Allocates a new ds_ObjectType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_ObjectType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_ObjectType_init(
    ds_ObjectType ** inst);

/**
 * Destroy a ds_ObjectType
 * @ingroup ds_ObjectType
 *
 * Frees a ds_ObjectType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_ObjectType_destroy(
    ds_ObjectType * inst);

/**
 * Copy a ds_ObjectType
 * @ingroup ds_ObjectType
 *
 * Perform a deep copy of a ds_ObjectType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_ObjectType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_ObjectType to be copied.
 */
globus_result_t
ds_ObjectType_copy(
    ds_ObjectType ** dest,
    const ds_ObjectType * src);

/**
 * Initialize the contents of a ds_ObjectType
 * @ingroup ds_ObjectType
 *
 * Initialize the contents of a ds_ObjectType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_ObjectType_init(). The contents may be freed
 * by calling ds_ObjectType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_ObjectType.
 */
globus_result_t
ds_ObjectType_init_contents(
    ds_ObjectType * instance);

/**
 * Destroy the contents of a ds_ObjectType
 * @ingroup ds_ObjectType
 *
 * Destroy the subelements and attributes of the given ds_ObjectType. 
 *
 * @param inst
 *     Pointer to a ds_ObjectType instance to destroy.
 */
void
ds_ObjectType_destroy_contents(
    ds_ObjectType * inst);

/**
 * Copy the contents of a ds_ObjectType
 * @ingroup ds_ObjectType
 *
 * Perform a deep copy of the contents of a ds_ObjectType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_ObjectType to be copied.
 */
globus_result_t
ds_ObjectType_copy_contents(
    ds_ObjectType * dest,
    const ds_ObjectType * src);

/**
 * Serialize a ds_ObjectType
 * @ingroup ds_ObjectType_array
 * Serialize a ds_ObjectType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_ObjectType.
 * @param val
 *     The ds_ObjectType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_ObjectType_serialize(
    xsd_QName *                         element_name,
    ds_ObjectType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_ObjectType
 * @ingroup ds_ObjectType_array
 * Serialize a ds_ObjectType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_ObjectType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_ObjectType_serialize_contents(
    xsd_QName *                         element_name,
    ds_ObjectType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_ObjectType
 * @ingroup ds_ObjectType
 * Deserialize an element containing a ds_ObjectType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_ObjectType.
 * @param val
 *     Pointer to the ds_ObjectType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ObjectType_deserialize(
    xsd_QName *                         element_name,
    ds_ObjectType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_ObjectType
 * @ingroup ds_ObjectType
 * Deserialize a ds_ObjectType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_ObjectType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ObjectType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_ObjectType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_ObjectType
 * @ingroup ds_ObjectType
 * Deserialize the next element if it contains a ds_ObjectType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_ObjectType.
 * @param instance
 *     Pointer to the <code>ds_ObjectType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_ObjectType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_ObjectType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_ObjectType_init_wrapper(
    void **                             object);
    
void
ds_ObjectType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_ObjectType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_ObjectType_init_contents_wrapper(
    void *                              object);
    
void
ds_ObjectType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_ObjectType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_ObjectType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_ObjectType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_ObjectType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_ObjectType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
