/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_RETRIEVALMETHODTYPE_H_
#define _DS_RETRIEVALMETHODTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_RetrievalMethodType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}RetrievalMethodType element.
 * @ingroup ds_RetrievalMethodType
 */
typedef struct ds_RetrievalMethodType_s ds_RetrievalMethodType;
/**
 * The ds_RetrievalMethodType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}RetrievalMethodType element.
 * @ingroup ds_RetrievalMethodType
 */
typedef ds_RetrievalMethodType * ds_RetrievalMethodType_o;

/**
 * Namespace of the ds_RetrievalMethodType complex type
 * @ingroup ds_RetrievalMethodType
 */
#define DS_RETRIEVALMETHODTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_RetrievalMethodType complex type
 * @ingroup ds_RetrievalMethodType
 */
#define DS_RETRIEVALMETHODTYPE_LOCAL "RetrievalMethodType"

/**
 * QName of the ds_RetrievalMethodType complex type
 * @ingroup ds_RetrievalMethodType
 */
extern xsd_QName ds_RetrievalMethodType_qname;
/**
 * Type information for serializing and deserializing ds_RetrievalMethodType elements
 * @ingroup ds_RetrievalMethodType
 */
extern struct globus_xsd_type_info_s ds_RetrievalMethodType_info;
/**
 * Type information for serializing and deserializing arrays of ds_RetrievalMethodType
 * elements
 * @ingroup ds_RetrievalMethodType
 */
extern struct globus_xsd_type_info_s ds_RetrievalMethodType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_RetrievalMethodType without surrounding elements
 * @ingroup ds_RetrievalMethodType
 */
extern struct globus_xsd_type_info_s ds_RetrievalMethodType_contents_info;


#include "ds_TransformsType.h"
#include "xsd_anyURI.h"
#include "xsd_anyURI.h"
#include "ds_RetrievalMethodType_array.h"

/**
 * @defgroup ds_RetrievalMethodType Complex type: ds_RetrievalMethodType
 * @ingroup types
 */

/**
 * C structure for the ds_RetrievalMethodType complex type
 * @ingroup ds_RetrievalMethodType
 */
struct ds_RetrievalMethodType_s
{
   /** Optional ds_TransformsType subelement */
    ds_TransformsType_o Transforms;
    xsd_anyURI_o _Type;
    xsd_anyURI_o _URI;

};

/**
 * Initialize a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 *
 * Allocates a new ds_RetrievalMethodType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_RetrievalMethodType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_RetrievalMethodType_init(
    ds_RetrievalMethodType ** inst);

/**
 * Destroy a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 *
 * Frees a ds_RetrievalMethodType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_RetrievalMethodType_destroy(
    ds_RetrievalMethodType * inst);

/**
 * Copy a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 *
 * Perform a deep copy of a ds_RetrievalMethodType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_RetrievalMethodType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_RetrievalMethodType to be copied.
 */
globus_result_t
ds_RetrievalMethodType_copy(
    ds_RetrievalMethodType ** dest,
    const ds_RetrievalMethodType * src);

/**
 * Initialize the contents of a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 *
 * Initialize the contents of a ds_RetrievalMethodType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_RetrievalMethodType_init(). The contents may be freed
 * by calling ds_RetrievalMethodType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_RetrievalMethodType.
 */
globus_result_t
ds_RetrievalMethodType_init_contents(
    ds_RetrievalMethodType * instance);

/**
 * Destroy the contents of a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 *
 * Destroy the subelements and attributes of the given ds_RetrievalMethodType. 
 *
 * @param inst
 *     Pointer to a ds_RetrievalMethodType instance to destroy.
 */
void
ds_RetrievalMethodType_destroy_contents(
    ds_RetrievalMethodType * inst);

/**
 * Copy the contents of a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 *
 * Perform a deep copy of the contents of a ds_RetrievalMethodType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_RetrievalMethodType to be copied.
 */
globus_result_t
ds_RetrievalMethodType_copy_contents(
    ds_RetrievalMethodType * dest,
    const ds_RetrievalMethodType * src);

/**
 * Serialize a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType_array
 * Serialize a ds_RetrievalMethodType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_RetrievalMethodType.
 * @param val
 *     The ds_RetrievalMethodType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_RetrievalMethodType_serialize(
    xsd_QName *                         element_name,
    ds_RetrievalMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType_array
 * Serialize a ds_RetrievalMethodType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_RetrievalMethodType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_RetrievalMethodType_serialize_contents(
    xsd_QName *                         element_name,
    ds_RetrievalMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 * Deserialize an element containing a ds_RetrievalMethodType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_RetrievalMethodType.
 * @param val
 *     Pointer to the ds_RetrievalMethodType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_RetrievalMethodType_deserialize(
    xsd_QName *                         element_name,
    ds_RetrievalMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 * Deserialize a ds_RetrievalMethodType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_RetrievalMethodType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_RetrievalMethodType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_RetrievalMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_RetrievalMethodType
 * @ingroup ds_RetrievalMethodType
 * Deserialize the next element if it contains a ds_RetrievalMethodType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_RetrievalMethodType.
 * @param instance
 *     Pointer to the <code>ds_RetrievalMethodType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_RetrievalMethodType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_RetrievalMethodType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_RetrievalMethodType_init_wrapper(
    void **                             object);
    
void
ds_RetrievalMethodType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_RetrievalMethodType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_RetrievalMethodType_init_contents_wrapper(
    void *                              object);
    
void
ds_RetrievalMethodType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_RetrievalMethodType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_RetrievalMethodType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_RetrievalMethodType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_RetrievalMethodType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_RetrievalMethodType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
