/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_SIGNATUREMETHODTYPE_H_
#define _DS_SIGNATUREMETHODTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_SignatureMethodType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}SignatureMethodType element.
 * @ingroup ds_SignatureMethodType
 */
typedef struct ds_SignatureMethodType_s ds_SignatureMethodType;
/**
 * The ds_SignatureMethodType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}SignatureMethodType element.
 * @ingroup ds_SignatureMethodType
 */
typedef ds_SignatureMethodType * ds_SignatureMethodType_o;

/**
 * Namespace of the ds_SignatureMethodType complex type
 * @ingroup ds_SignatureMethodType
 */
#define DS_SIGNATUREMETHODTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_SignatureMethodType complex type
 * @ingroup ds_SignatureMethodType
 */
#define DS_SIGNATUREMETHODTYPE_LOCAL "SignatureMethodType"

/**
 * QName of the ds_SignatureMethodType complex type
 * @ingroup ds_SignatureMethodType
 */
extern xsd_QName ds_SignatureMethodType_qname;
/**
 * Type information for serializing and deserializing ds_SignatureMethodType elements
 * @ingroup ds_SignatureMethodType
 */
extern struct globus_xsd_type_info_s ds_SignatureMethodType_info;
/**
 * Type information for serializing and deserializing arrays of ds_SignatureMethodType
 * elements
 * @ingroup ds_SignatureMethodType
 */
extern struct globus_xsd_type_info_s ds_SignatureMethodType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_SignatureMethodType without surrounding elements
 * @ingroup ds_SignatureMethodType
 */
extern struct globus_xsd_type_info_s ds_SignatureMethodType_contents_info;


#include "ds_HMACOutputLengthType.h"
#include "xsd_any.h"
#include "xsd_anyURI.h"
#include "ds_SignatureMethodType_array.h"

/**
 * @defgroup ds_SignatureMethodType Complex type: ds_SignatureMethodType
 * @ingroup types
 */

/**
 * C structure for the ds_SignatureMethodType complex type
 * @ingroup ds_SignatureMethodType
 */
struct ds_SignatureMethodType_s
{
   /** Optional ds_HMACOutputLengthType subelement */
    ds_HMACOutputLengthType_o HMACOutputLength;
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyURI _Algorithm;

};

/**
 * Initialize a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 *
 * Allocates a new ds_SignatureMethodType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_SignatureMethodType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_SignatureMethodType_init(
    ds_SignatureMethodType ** inst);

/**
 * Destroy a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 *
 * Frees a ds_SignatureMethodType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_SignatureMethodType_destroy(
    ds_SignatureMethodType * inst);

/**
 * Copy a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 *
 * Perform a deep copy of a ds_SignatureMethodType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_SignatureMethodType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_SignatureMethodType to be copied.
 */
globus_result_t
ds_SignatureMethodType_copy(
    ds_SignatureMethodType ** dest,
    const ds_SignatureMethodType * src);

/**
 * Initialize the contents of a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 *
 * Initialize the contents of a ds_SignatureMethodType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_SignatureMethodType_init(). The contents may be freed
 * by calling ds_SignatureMethodType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_SignatureMethodType.
 */
globus_result_t
ds_SignatureMethodType_init_contents(
    ds_SignatureMethodType * instance);

/**
 * Destroy the contents of a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 *
 * Destroy the subelements and attributes of the given ds_SignatureMethodType. 
 *
 * @param inst
 *     Pointer to a ds_SignatureMethodType instance to destroy.
 */
void
ds_SignatureMethodType_destroy_contents(
    ds_SignatureMethodType * inst);

/**
 * Copy the contents of a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 *
 * Perform a deep copy of the contents of a ds_SignatureMethodType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_SignatureMethodType to be copied.
 */
globus_result_t
ds_SignatureMethodType_copy_contents(
    ds_SignatureMethodType * dest,
    const ds_SignatureMethodType * src);

/**
 * Serialize a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType_array
 * Serialize a ds_SignatureMethodType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_SignatureMethodType.
 * @param val
 *     The ds_SignatureMethodType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignatureMethodType_serialize(
    xsd_QName *                         element_name,
    ds_SignatureMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType_array
 * Serialize a ds_SignatureMethodType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_SignatureMethodType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignatureMethodType_serialize_contents(
    xsd_QName *                         element_name,
    ds_SignatureMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 * Deserialize an element containing a ds_SignatureMethodType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignatureMethodType.
 * @param val
 *     Pointer to the ds_SignatureMethodType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureMethodType_deserialize(
    xsd_QName *                         element_name,
    ds_SignatureMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 * Deserialize a ds_SignatureMethodType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_SignatureMethodType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureMethodType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_SignatureMethodType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_SignatureMethodType
 * @ingroup ds_SignatureMethodType
 * Deserialize the next element if it contains a ds_SignatureMethodType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignatureMethodType.
 * @param instance
 *     Pointer to the <code>ds_SignatureMethodType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureMethodType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_SignatureMethodType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_SignatureMethodType_init_wrapper(
    void **                             object);
    
void
ds_SignatureMethodType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_SignatureMethodType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignatureMethodType_init_contents_wrapper(
    void *                              object);
    
void
ds_SignatureMethodType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_SignatureMethodType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignatureMethodType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignatureMethodType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignatureMethodType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignatureMethodType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
