/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_SIGNATURETYPE_H_
#define _DS_SIGNATURETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_SignatureType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}SignatureType element.
 * @ingroup ds_SignatureType
 */
typedef struct ds_SignatureType_s ds_SignatureType;
/**
 * The ds_SignatureType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}SignatureType element.
 * @ingroup ds_SignatureType
 */
typedef ds_SignatureType * ds_SignatureType_o;

/**
 * Namespace of the ds_SignatureType complex type
 * @ingroup ds_SignatureType
 */
#define DS_SIGNATURETYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_SignatureType complex type
 * @ingroup ds_SignatureType
 */
#define DS_SIGNATURETYPE_LOCAL "SignatureType"

/**
 * QName of the ds_SignatureType complex type
 * @ingroup ds_SignatureType
 */
extern xsd_QName ds_SignatureType_qname;
/**
 * Type information for serializing and deserializing ds_SignatureType elements
 * @ingroup ds_SignatureType
 */
extern struct globus_xsd_type_info_s ds_SignatureType_info;
/**
 * Type information for serializing and deserializing arrays of ds_SignatureType
 * elements
 * @ingroup ds_SignatureType
 */
extern struct globus_xsd_type_info_s ds_SignatureType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_SignatureType without surrounding elements
 * @ingroup ds_SignatureType
 */
extern struct globus_xsd_type_info_s ds_SignatureType_contents_info;


#include "ds_SignedInfoType.h"
#include "ds_SignatureValueType.h"
#include "ds_KeyInfoType.h"
#include "ds_ObjectType_array.h"
#include "xsd_ID.h"
#include "ds_SignatureType_array.h"

/**
 * @defgroup ds_SignatureType Complex type: ds_SignatureType
 * @ingroup types
 */

/**
 * C structure for the ds_SignatureType complex type
 * @ingroup ds_SignatureType
 */
struct ds_SignatureType_s
{
    /** ds_SignedInfoType subelement */
    ds_SignedInfoType SignedInfo;
    /** ds_SignatureValueType subelement */
    ds_SignatureValueType SignatureValue;
   /** Optional ds_KeyInfoType subelement */
    ds_KeyInfoType_o KeyInfo;
   /** Array of [0 .. Infinity] ds_ObjectType elements */
    ds_ObjectType_array Object;
    xsd_ID_o _Id;

};

/**
 * Initialize a ds_SignatureType
 * @ingroup ds_SignatureType
 *
 * Allocates a new ds_SignatureType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_SignatureType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_SignatureType_init(
    ds_SignatureType ** inst);

/**
 * Destroy a ds_SignatureType
 * @ingroup ds_SignatureType
 *
 * Frees a ds_SignatureType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_SignatureType_destroy(
    ds_SignatureType * inst);

/**
 * Copy a ds_SignatureType
 * @ingroup ds_SignatureType
 *
 * Perform a deep copy of a ds_SignatureType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_SignatureType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_SignatureType to be copied.
 */
globus_result_t
ds_SignatureType_copy(
    ds_SignatureType ** dest,
    const ds_SignatureType * src);

/**
 * Initialize the contents of a ds_SignatureType
 * @ingroup ds_SignatureType
 *
 * Initialize the contents of a ds_SignatureType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_SignatureType_init(). The contents may be freed
 * by calling ds_SignatureType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_SignatureType.
 */
globus_result_t
ds_SignatureType_init_contents(
    ds_SignatureType * instance);

/**
 * Destroy the contents of a ds_SignatureType
 * @ingroup ds_SignatureType
 *
 * Destroy the subelements and attributes of the given ds_SignatureType. 
 *
 * @param inst
 *     Pointer to a ds_SignatureType instance to destroy.
 */
void
ds_SignatureType_destroy_contents(
    ds_SignatureType * inst);

/**
 * Copy the contents of a ds_SignatureType
 * @ingroup ds_SignatureType
 *
 * Perform a deep copy of the contents of a ds_SignatureType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_SignatureType to be copied.
 */
globus_result_t
ds_SignatureType_copy_contents(
    ds_SignatureType * dest,
    const ds_SignatureType * src);

/**
 * Serialize a ds_SignatureType
 * @ingroup ds_SignatureType_array
 * Serialize a ds_SignatureType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_SignatureType.
 * @param val
 *     The ds_SignatureType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignatureType_serialize(
    xsd_QName *                         element_name,
    ds_SignatureType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_SignatureType
 * @ingroup ds_SignatureType_array
 * Serialize a ds_SignatureType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_SignatureType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignatureType_serialize_contents(
    xsd_QName *                         element_name,
    ds_SignatureType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignatureType
 * @ingroup ds_SignatureType
 * Deserialize an element containing a ds_SignatureType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignatureType.
 * @param val
 *     Pointer to the ds_SignatureType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureType_deserialize(
    xsd_QName *                         element_name,
    ds_SignatureType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignatureType
 * @ingroup ds_SignatureType
 * Deserialize a ds_SignatureType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_SignatureType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_SignatureType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_SignatureType
 * @ingroup ds_SignatureType
 * Deserialize the next element if it contains a ds_SignatureType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignatureType.
 * @param instance
 *     Pointer to the <code>ds_SignatureType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignatureType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_SignatureType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_SignatureType_init_wrapper(
    void **                             object);
    
void
ds_SignatureType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_SignatureType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignatureType_init_contents_wrapper(
    void *                              object);
    
void
ds_SignatureType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_SignatureType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignatureType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignatureType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignatureType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignatureType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
