/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_SIGNEDINFOTYPE_H_
#define _DS_SIGNEDINFOTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_SignedInfoType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}SignedInfoType element.
 * @ingroup ds_SignedInfoType
 */
typedef struct ds_SignedInfoType_s ds_SignedInfoType;
/**
 * The ds_SignedInfoType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}SignedInfoType element.
 * @ingroup ds_SignedInfoType
 */
typedef ds_SignedInfoType * ds_SignedInfoType_o;

/**
 * Namespace of the ds_SignedInfoType complex type
 * @ingroup ds_SignedInfoType
 */
#define DS_SIGNEDINFOTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_SignedInfoType complex type
 * @ingroup ds_SignedInfoType
 */
#define DS_SIGNEDINFOTYPE_LOCAL "SignedInfoType"

/**
 * QName of the ds_SignedInfoType complex type
 * @ingroup ds_SignedInfoType
 */
extern xsd_QName ds_SignedInfoType_qname;
/**
 * Type information for serializing and deserializing ds_SignedInfoType elements
 * @ingroup ds_SignedInfoType
 */
extern struct globus_xsd_type_info_s ds_SignedInfoType_info;
/**
 * Type information for serializing and deserializing arrays of ds_SignedInfoType
 * elements
 * @ingroup ds_SignedInfoType
 */
extern struct globus_xsd_type_info_s ds_SignedInfoType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_SignedInfoType without surrounding elements
 * @ingroup ds_SignedInfoType
 */
extern struct globus_xsd_type_info_s ds_SignedInfoType_contents_info;


#include "ds_CanonicalizationMethodType.h"
#include "ds_SignatureMethodType.h"
#include "ds_ReferenceType_array.h"
#include "xsd_ID.h"
#include "ds_SignedInfoType_array.h"

/**
 * @defgroup ds_SignedInfoType Complex type: ds_SignedInfoType
 * @ingroup types
 */

/**
 * C structure for the ds_SignedInfoType complex type
 * @ingroup ds_SignedInfoType
 */
struct ds_SignedInfoType_s
{
    /** ds_CanonicalizationMethodType subelement */
    ds_CanonicalizationMethodType CanonicalizationMethod;
    /** ds_SignatureMethodType subelement */
    ds_SignatureMethodType SignatureMethod;
   /** Array of [1 .. Infinity] ds_ReferenceType elements */
    ds_ReferenceType_array Reference;
    xsd_ID_o _Id;

};

/**
 * Initialize a ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 *
 * Allocates a new ds_SignedInfoType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_SignedInfoType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_SignedInfoType_init(
    ds_SignedInfoType ** inst);

/**
 * Destroy a ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 *
 * Frees a ds_SignedInfoType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_SignedInfoType_destroy(
    ds_SignedInfoType * inst);

/**
 * Copy a ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 *
 * Perform a deep copy of a ds_SignedInfoType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_SignedInfoType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_SignedInfoType to be copied.
 */
globus_result_t
ds_SignedInfoType_copy(
    ds_SignedInfoType ** dest,
    const ds_SignedInfoType * src);

/**
 * Initialize the contents of a ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 *
 * Initialize the contents of a ds_SignedInfoType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_SignedInfoType_init(). The contents may be freed
 * by calling ds_SignedInfoType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_SignedInfoType.
 */
globus_result_t
ds_SignedInfoType_init_contents(
    ds_SignedInfoType * instance);

/**
 * Destroy the contents of a ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 *
 * Destroy the subelements and attributes of the given ds_SignedInfoType. 
 *
 * @param inst
 *     Pointer to a ds_SignedInfoType instance to destroy.
 */
void
ds_SignedInfoType_destroy_contents(
    ds_SignedInfoType * inst);

/**
 * Copy the contents of a ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 *
 * Perform a deep copy of the contents of a ds_SignedInfoType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_SignedInfoType to be copied.
 */
globus_result_t
ds_SignedInfoType_copy_contents(
    ds_SignedInfoType * dest,
    const ds_SignedInfoType * src);

/**
 * Serialize a ds_SignedInfoType
 * @ingroup ds_SignedInfoType_array
 * Serialize a ds_SignedInfoType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_SignedInfoType.
 * @param val
 *     The ds_SignedInfoType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignedInfoType_serialize(
    xsd_QName *                         element_name,
    ds_SignedInfoType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_SignedInfoType
 * @ingroup ds_SignedInfoType_array
 * Serialize a ds_SignedInfoType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_SignedInfoType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_SignedInfoType_serialize_contents(
    xsd_QName *                         element_name,
    ds_SignedInfoType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 * Deserialize an element containing a ds_SignedInfoType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignedInfoType.
 * @param val
 *     Pointer to the ds_SignedInfoType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignedInfoType_deserialize(
    xsd_QName *                         element_name,
    ds_SignedInfoType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 * Deserialize a ds_SignedInfoType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_SignedInfoType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignedInfoType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_SignedInfoType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_SignedInfoType
 * @ingroup ds_SignedInfoType
 * Deserialize the next element if it contains a ds_SignedInfoType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_SignedInfoType.
 * @param instance
 *     Pointer to the <code>ds_SignedInfoType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_SignedInfoType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_SignedInfoType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_SignedInfoType_init_wrapper(
    void **                             object);
    
void
ds_SignedInfoType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_SignedInfoType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignedInfoType_init_contents_wrapper(
    void *                              object);
    
void
ds_SignedInfoType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_SignedInfoType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_SignedInfoType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignedInfoType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_SignedInfoType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_SignedInfoType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
