/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_TRANSFORMTYPE_H_
#define _DS_TRANSFORMTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The ds_TransformType complex type, which represents the
 * {http://www.w3.org/2000/09/xmldsig#}TransformType element.
 * @ingroup ds_TransformType
 */
typedef struct ds_TransformType_s ds_TransformType;
/**
 * The ds_TransformType_o complex type, which represents an optional instance
 * of a
 * {http://www.w3.org/2000/09/xmldsig#}TransformType element.
 * @ingroup ds_TransformType
 */
typedef ds_TransformType * ds_TransformType_o;

/**
 * Namespace of the ds_TransformType complex type
 * @ingroup ds_TransformType
 */
#define DS_TRANSFORMTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
/**
 * Local part of the QName of the ds_TransformType complex type
 * @ingroup ds_TransformType
 */
#define DS_TRANSFORMTYPE_LOCAL "TransformType"

/**
 * QName of the ds_TransformType complex type
 * @ingroup ds_TransformType
 */
extern xsd_QName ds_TransformType_qname;
/**
 * Type information for serializing and deserializing ds_TransformType elements
 * @ingroup ds_TransformType
 */
extern struct globus_xsd_type_info_s ds_TransformType_info;
/**
 * Type information for serializing and deserializing arrays of ds_TransformType
 * elements
 * @ingroup ds_TransformType
 */
extern struct globus_xsd_type_info_s ds_TransformType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * ds_TransformType without surrounding elements
 * @ingroup ds_TransformType
 */
extern struct globus_xsd_type_info_s ds_TransformType_contents_info;


#include "ds_TransformType_choice.h"
#include "xsd_anyURI.h"
#include "ds_TransformType_array.h"

/**
 * @defgroup ds_TransformType Complex type: ds_TransformType
 * @ingroup types
 */

/**
 * C structure for the ds_TransformType complex type
 * @ingroup ds_TransformType
 */
struct ds_TransformType_s
{
   /** Array of [0 .. Infinity] ds_TransformType_choice elements */
    ds_TransformType_choice_array choice_value;
    xsd_anyURI _Algorithm;

};

/**
 * Initialize a ds_TransformType
 * @ingroup ds_TransformType
 *
 * Allocates a new ds_TransformType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * ds_TransformType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
ds_TransformType_init(
    ds_TransformType ** inst);

/**
 * Destroy a ds_TransformType
 * @ingroup ds_TransformType
 *
 * Frees a ds_TransformType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
ds_TransformType_destroy(
    ds_TransformType * inst);

/**
 * Copy a ds_TransformType
 * @ingroup ds_TransformType
 *
 * Perform a deep copy of a ds_TransformType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The ds_TransformType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source ds_TransformType to be copied.
 */
globus_result_t
ds_TransformType_copy(
    ds_TransformType ** dest,
    const ds_TransformType * src);

/**
 * Initialize the contents of a ds_TransformType
 * @ingroup ds_TransformType
 *
 * Initialize the contents of a ds_TransformType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * ds_TransformType_init(). The contents may be freed
 * by calling ds_TransformType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized ds_TransformType.
 */
globus_result_t
ds_TransformType_init_contents(
    ds_TransformType * instance);

/**
 * Destroy the contents of a ds_TransformType
 * @ingroup ds_TransformType
 *
 * Destroy the subelements and attributes of the given ds_TransformType. 
 *
 * @param inst
 *     Pointer to a ds_TransformType instance to destroy.
 */
void
ds_TransformType_destroy_contents(
    ds_TransformType * inst);

/**
 * Copy the contents of a ds_TransformType
 * @ingroup ds_TransformType
 *
 * Perform a deep copy of the contents of a ds_TransformType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source ds_TransformType to be copied.
 */
globus_result_t
ds_TransformType_copy_contents(
    ds_TransformType * dest,
    const ds_TransformType * src);

/**
 * Serialize a ds_TransformType
 * @ingroup ds_TransformType_array
 * Serialize a ds_TransformType structure.
 *
 * @param element_name
 *     The name of the element which will contain the ds_TransformType.
 * @param val
 *     The ds_TransformType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_TransformType_serialize(
    xsd_QName *                         element_name,
    ds_TransformType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a ds_TransformType
 * @ingroup ds_TransformType_array
 * Serialize a ds_TransformType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The ds_TransformType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
ds_TransformType_serialize_contents(
    xsd_QName *                         element_name,
    ds_TransformType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_TransformType
 * @ingroup ds_TransformType
 * Deserialize an element containing a ds_TransformType element.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_TransformType.
 * @param val
 *     Pointer to the ds_TransformType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_TransformType_deserialize(
    xsd_QName *                         element_name,
    ds_TransformType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a ds_TransformType
 * @ingroup ds_TransformType
 * Deserialize a ds_TransformType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the ds_TransformType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_TransformType_deserialize_contents(
    xsd_QName *                         element_name,
    ds_TransformType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional ds_TransformType
 * @ingroup ds_TransformType
 * Deserialize the next element if it contains a ds_TransformType.
 *
 * @param element_name
 *     The name of the element which should enclose the ds_TransformType.
 * @param instance
 *     Pointer to the <code>ds_TransformType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
ds_TransformType_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_TransformType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
ds_TransformType_init_wrapper(
    void **                             object);
    
void
ds_TransformType_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_TransformType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_TransformType_init_contents_wrapper(
    void *                              object);
    
void
ds_TransformType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_TransformType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_TransformType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
