/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DS_TRANSFORMTYPE_CHOICE_H_
#define _DS_TRANSFORMTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum ds_TransformType_e
{
    ds_TransformType_undefined,
    ds_TransformType_any,
    ds_TransformType_XPath

};

/**
 * @defgroup ds_TransformType_choice Complex choice type: ds_TransformType
 * @ingroup ds_TransformType
 */

/**
 * Enumeration of the types of values which the ds_TransformType_choice
 * structure may take on.
 * @ingroup ds_TransformType_choice
 */
typedef enum ds_TransformType_e ds_TransformType_enum;
/**
 * Union of the values which the ds_TransformType_choice structure
 * contains
 * @ingroup ds_TransformType_choice
 */
typedef union ds_TransformType_u ds_TransformType_union;
/**
 * The ds_TransformType complex type, which represents the various values
 * possible by the choice used by the
 * {http://www.w3.org/2000/09/xmldsig#}choice 23 element.
 * @ingroup ds_TransformType_choice
 */
typedef struct ds_TransformType_choice_s ds_TransformType_choice;
/**
 * The ds_TransformType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://www.w3.org/2000/09/xmldsig#}choice 23 element.
 * @ingroup ds_TransformType
 */
typedef ds_TransformType_choice * ds_TransformType_choice_o;

typedef struct ds_TransformType_choice_array_s
{
    ds_TransformType_choice * elements;
    int                                 length;
} ds_TransformType_choice_array;

#define DS_TRANSFORMTYPE_NS "http://www.w3.org/2000/09/xmldsig#"
#define DS_TRANSFORMTYPE_LOCAL "TransformType"

extern xsd_QName ds_TransformType_choice_qname;
extern struct globus_xsd_type_info_s ds_TransformType_choice_info;
extern struct globus_xsd_type_info_s ds_TransformType_choice_contents_info;
extern struct globus_xsd_type_info_s ds_TransformType_choice_array_info;


#include "xsd_any.h"
#include "xsd_string.h"

union ds_TransformType_u
{
    /** xsd_any subelement */
    xsd_any any;
    /** xsd_string subelement */
    xsd_string XPath;

};

struct ds_TransformType_choice_s
{
    ds_TransformType_enum type;
    ds_TransformType_union value;
};

globus_result_t
ds_TransformType_choice_init(
    ds_TransformType_choice ** inst);

void
ds_TransformType_choice_destroy(
    ds_TransformType_choice * inst);

globus_result_t
ds_TransformType_choice_copy(
    ds_TransformType_choice ** dest,
    const ds_TransformType_choice * src);

globus_result_t
ds_TransformType_choice_init_contents(
    ds_TransformType_choice * instance);

void
ds_TransformType_choice_destroy_contents(
    ds_TransformType_choice * inst);

globus_result_t
ds_TransformType_choice_copy_contents(
    ds_TransformType_choice * dest,
    const ds_TransformType_choice * src);
    
globus_result_t
ds_TransformType_choice_array_init(
    ds_TransformType_choice_array ** inst);

void
ds_TransformType_choice_array_destroy(
    ds_TransformType_choice_array * inst);

globus_result_t
ds_TransformType_choice_array_copy(
    ds_TransformType_choice_array ** dest,
    const ds_TransformType_choice_array * src);

globus_result_t
ds_TransformType_choice_array_init_contents(
    ds_TransformType_choice_array * inst);

void
ds_TransformType_choice_array_destroy_contents(
    ds_TransformType_choice_array * inst);

globus_result_t
ds_TransformType_choice_array_copy_contents(
    ds_TransformType_choice_array * dest,
    const ds_TransformType_choice_array * src);

ds_TransformType_choice *
ds_TransformType_choice_array_push(
    ds_TransformType_choice_array * array);

globus_result_t
ds_TransformType_choice_serialize(
    xsd_QName *                         element_name,
    ds_TransformType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformType_choice_serialize_contents(
    xsd_QName *                         element_name,
    ds_TransformType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformType_choice_deserialize(
    xsd_QName *                         element_name,
    ds_TransformType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    ds_TransformType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    ds_TransformType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformType_choice_array_serialize(
    xsd_QName *                         element,
    ds_TransformType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformType_choice_array_deserialize(
    xsd_QName *                         element,
    ds_TransformType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
ds_TransformType_choice_init_wrapper(
    void **                             object);
    
void
ds_TransformType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
ds_TransformType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
ds_TransformType_choice_init_contents_wrapper(
    void *                              object);
    
void
ds_TransformType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
ds_TransformType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
ds_TransformType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
ds_TransformType_choice_array_init_wrapper(
    void **                             arr);
    
void
ds_TransformType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
ds_TransformType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
ds_TransformType_choice_array_init_contents_wrapper(
    void *                              arr);

void
ds_TransformType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
ds_TransformType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
ds_TransformType_choice_array_push_wrapper(
    void * array);

globus_result_t
ds_TransformType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
