/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSA_ATTRIBUTEDQNAME_H_
#define _WSA_ATTRIBUTEDQNAME_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsa_AttributedQName complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/03/addressing}AttributedQName element.
 * @ingroup wsa_AttributedQName
 */
typedef struct wsa_AttributedQName_s wsa_AttributedQName;
/**
 * The wsa_AttributedQName_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/03/addressing}AttributedQName element.
 * @ingroup wsa_AttributedQName
 */
typedef wsa_AttributedQName * wsa_AttributedQName_o;

/**
 * Namespace of the wsa_AttributedQName complex type
 * @ingroup wsa_AttributedQName
 */
#define WSA_ATTRIBUTEDQNAME_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"
/**
 * Local part of the QName of the wsa_AttributedQName complex type
 * @ingroup wsa_AttributedQName
 */
#define WSA_ATTRIBUTEDQNAME_LOCAL "AttributedQName"

/**
 * QName of the wsa_AttributedQName complex type
 * @ingroup wsa_AttributedQName
 */
extern xsd_QName wsa_AttributedQName_qname;
/**
 * Type information for serializing and deserializing wsa_AttributedQName elements
 * @ingroup wsa_AttributedQName
 */
extern struct globus_xsd_type_info_s wsa_AttributedQName_info;
/**
 * Type information for serializing and deserializing arrays of wsa_AttributedQName
 * elements
 * @ingroup wsa_AttributedQName
 */
extern struct globus_xsd_type_info_s wsa_AttributedQName_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsa_AttributedQName without surrounding elements
 * @ingroup wsa_AttributedQName
 */
extern struct globus_xsd_type_info_s wsa_AttributedQName_contents_info;


#include "xsd_QName.h"
#include "xsd_anyAttributes.h"
#include "wsa_AttributedQName_array.h"

/**
 * @defgroup wsa_AttributedQName Complex type: wsa_AttributedQName
 * @ingroup types
 */

/**
 * C structure for the wsa_AttributedQName complex type
 * @ingroup wsa_AttributedQName
 */
struct wsa_AttributedQName_s
{
    /** xsd_QName subelement */
    xsd_QName base_value;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 *
 * Allocates a new wsa_AttributedQName and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsa_AttributedQName_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsa_AttributedQName_init(
    wsa_AttributedQName ** inst);

/**
 * Destroy a wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 *
 * Frees a wsa_AttributedQName. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsa_AttributedQName_destroy(
    wsa_AttributedQName * inst);

/**
 * Copy a wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 *
 * Perform a deep copy of a wsa_AttributedQName.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsa_AttributedQName structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsa_AttributedQName to be copied.
 */
globus_result_t
wsa_AttributedQName_copy(
    wsa_AttributedQName ** dest,
    const wsa_AttributedQName * src);

/**
 * Initialize the contents of a wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 *
 * Initialize the contents of a wsa_AttributedQName. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsa_AttributedQName_init(). The contents may be freed
 * by calling wsa_AttributedQName_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsa_AttributedQName.
 */
globus_result_t
wsa_AttributedQName_init_contents(
    wsa_AttributedQName * instance);

/**
 * Destroy the contents of a wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 *
 * Destroy the subelements and attributes of the given wsa_AttributedQName. 
 *
 * @param inst
 *     Pointer to a wsa_AttributedQName instance to destroy.
 */
void
wsa_AttributedQName_destroy_contents(
    wsa_AttributedQName * inst);

/**
 * Copy the contents of a wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 *
 * Perform a deep copy of the contents of a wsa_AttributedQName.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsa_AttributedQName to be copied.
 */
globus_result_t
wsa_AttributedQName_copy_contents(
    wsa_AttributedQName * dest,
    const wsa_AttributedQName * src);

/**
 * Serialize a wsa_AttributedQName
 * @ingroup wsa_AttributedQName_array
 * Serialize a wsa_AttributedQName structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsa_AttributedQName.
 * @param val
 *     The wsa_AttributedQName to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_AttributedQName_serialize(
    xsd_QName *                         element_name,
    wsa_AttributedQName * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsa_AttributedQName
 * @ingroup wsa_AttributedQName_array
 * Serialize a wsa_AttributedQName structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsa_AttributedQName to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_AttributedQName_serialize_contents(
    xsd_QName *                         element_name,
    wsa_AttributedQName * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 * Deserialize an element containing a wsa_AttributedQName element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_AttributedQName.
 * @param val
 *     Pointer to the wsa_AttributedQName which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_AttributedQName_deserialize(
    xsd_QName *                         element_name,
    wsa_AttributedQName * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 * Deserialize a wsa_AttributedQName whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsa_AttributedQName which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_AttributedQName_deserialize_contents(
    xsd_QName *                         element_name,
    wsa_AttributedQName * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsa_AttributedQName
 * @ingroup wsa_AttributedQName
 * Deserialize the next element if it contains a wsa_AttributedQName.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_AttributedQName.
 * @param instance
 *     Pointer to the <code>wsa_AttributedQName *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_AttributedQName_deserialize_pointer(
    xsd_QName *                         element_name,
    wsa_AttributedQName ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsa_AttributedQName_init_wrapper(
    void **                             object);
    
void
wsa_AttributedQName_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsa_AttributedQName_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsa_AttributedQName_init_contents_wrapper(
    void *                              object);
    
void
wsa_AttributedQName_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsa_AttributedQName_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsa_AttributedQName_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_AttributedQName_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_AttributedQName_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsa_AttributedQName_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
