/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSA_ENDPOINTREFERENCETYPE_H_
#define _WSA_ENDPOINTREFERENCETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsa_EndpointReferenceType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/03/addressing}EndpointReferenceType element.
 * @ingroup wsa_EndpointReferenceType
 */
typedef struct wsa_EndpointReferenceType_s wsa_EndpointReferenceType;
/**
 * The wsa_EndpointReferenceType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/03/addressing}EndpointReferenceType element.
 * @ingroup wsa_EndpointReferenceType
 */
typedef wsa_EndpointReferenceType * wsa_EndpointReferenceType_o;

/**
 * Namespace of the wsa_EndpointReferenceType complex type
 * @ingroup wsa_EndpointReferenceType
 */
#define WSA_ENDPOINTREFERENCETYPE_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"
/**
 * Local part of the QName of the wsa_EndpointReferenceType complex type
 * @ingroup wsa_EndpointReferenceType
 */
#define WSA_ENDPOINTREFERENCETYPE_LOCAL "EndpointReferenceType"

/**
 * QName of the wsa_EndpointReferenceType complex type
 * @ingroup wsa_EndpointReferenceType
 */
extern xsd_QName wsa_EndpointReferenceType_qname;
/**
 * Type information for serializing and deserializing wsa_EndpointReferenceType elements
 * @ingroup wsa_EndpointReferenceType
 */
extern struct globus_xsd_type_info_s wsa_EndpointReferenceType_info;
/**
 * Type information for serializing and deserializing arrays of wsa_EndpointReferenceType
 * elements
 * @ingroup wsa_EndpointReferenceType
 */
extern struct globus_xsd_type_info_s wsa_EndpointReferenceType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsa_EndpointReferenceType without surrounding elements
 * @ingroup wsa_EndpointReferenceType
 */
extern struct globus_xsd_type_info_s wsa_EndpointReferenceType_contents_info;


#include "wsa_AttributedURI.h"
#include "wsa_ReferencePropertiesType.h"
#include "wsa_AttributedQName.h"
#include "wsa_ServiceNameType.h"
#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "wsa_EndpointReferenceType_array.h"

/**
 * @defgroup wsa_EndpointReferenceType Complex type: wsa_EndpointReferenceType
 * @ingroup types
 */

/**
 * C structure for the wsa_EndpointReferenceType complex type
 * @ingroup wsa_EndpointReferenceType
 */
struct wsa_EndpointReferenceType_s
{
    /** wsa_AttributedURI subelement */
    wsa_AttributedURI Address;
   /** Optional wsa_ReferencePropertiesType subelement */
    wsa_ReferencePropertiesType_o ReferenceProperties;
   /** Optional wsa_AttributedQName subelement */
    wsa_AttributedQName_o PortType;
   /** Optional wsa_ServiceNameType subelement */
    wsa_ServiceNameType_o ServiceName;
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 *
 * Allocates a new wsa_EndpointReferenceType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsa_EndpointReferenceType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsa_EndpointReferenceType_init(
    wsa_EndpointReferenceType ** inst);

/**
 * Destroy a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 *
 * Frees a wsa_EndpointReferenceType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsa_EndpointReferenceType_destroy(
    wsa_EndpointReferenceType * inst);

/**
 * Copy a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 *
 * Perform a deep copy of a wsa_EndpointReferenceType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsa_EndpointReferenceType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsa_EndpointReferenceType to be copied.
 */
globus_result_t
wsa_EndpointReferenceType_copy(
    wsa_EndpointReferenceType ** dest,
    const wsa_EndpointReferenceType * src);

/**
 * Initialize the contents of a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 *
 * Initialize the contents of a wsa_EndpointReferenceType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsa_EndpointReferenceType_init(). The contents may be freed
 * by calling wsa_EndpointReferenceType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsa_EndpointReferenceType.
 */
globus_result_t
wsa_EndpointReferenceType_init_contents(
    wsa_EndpointReferenceType * instance);

/**
 * Destroy the contents of a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 *
 * Destroy the subelements and attributes of the given wsa_EndpointReferenceType. 
 *
 * @param inst
 *     Pointer to a wsa_EndpointReferenceType instance to destroy.
 */
void
wsa_EndpointReferenceType_destroy_contents(
    wsa_EndpointReferenceType * inst);

/**
 * Copy the contents of a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 *
 * Perform a deep copy of the contents of a wsa_EndpointReferenceType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsa_EndpointReferenceType to be copied.
 */
globus_result_t
wsa_EndpointReferenceType_copy_contents(
    wsa_EndpointReferenceType * dest,
    const wsa_EndpointReferenceType * src);

/**
 * Serialize a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType_array
 * Serialize a wsa_EndpointReferenceType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsa_EndpointReferenceType.
 * @param val
 *     The wsa_EndpointReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_EndpointReferenceType_serialize(
    xsd_QName *                         element_name,
    wsa_EndpointReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType_array
 * Serialize a wsa_EndpointReferenceType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsa_EndpointReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_EndpointReferenceType_serialize_contents(
    xsd_QName *                         element_name,
    wsa_EndpointReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 * Deserialize an element containing a wsa_EndpointReferenceType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_EndpointReferenceType.
 * @param val
 *     Pointer to the wsa_EndpointReferenceType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_EndpointReferenceType_deserialize(
    xsd_QName *                         element_name,
    wsa_EndpointReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 * Deserialize a wsa_EndpointReferenceType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsa_EndpointReferenceType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_EndpointReferenceType_deserialize_contents(
    xsd_QName *                         element_name,
    wsa_EndpointReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsa_EndpointReferenceType
 * @ingroup wsa_EndpointReferenceType
 * Deserialize the next element if it contains a wsa_EndpointReferenceType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_EndpointReferenceType.
 * @param instance
 *     Pointer to the <code>wsa_EndpointReferenceType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_EndpointReferenceType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsa_EndpointReferenceType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsa_EndpointReferenceType_init_wrapper(
    void **                             object);
    
void
wsa_EndpointReferenceType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsa_EndpointReferenceType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsa_EndpointReferenceType_init_contents_wrapper(
    void *                              object);
    
void
wsa_EndpointReferenceType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsa_EndpointReferenceType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsa_EndpointReferenceType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_EndpointReferenceType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_EndpointReferenceType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsa_EndpointReferenceType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
