/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDL-to-C Converter
 */

#ifndef _WSA_RELATIONSHIPTYPEVALUES_H_
#define _WSA_RELATIONSHIPTYPEVALUES_H_

#include "globus_common.h"

/**
 * @defgroup wsa_RelationshipTypeValues Simple Type: wsa_RelationshipTypeValues
 * @ingroup types
 */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */


#include "xsd_QName.h"

/**
 * @ingroup wsa_RelationshipTypeValues
 */
typedef xsd_QName wsa_RelationshipTypeValues;

extern xsd_QName wsa_RelationshipTypeValues_undefined;

/**
 * Optional wsa_RelationshipTypeValues element
 * @ingroup wsa_RelationshipTypeValues
 */
typedef wsa_RelationshipTypeValues * wsa_RelationshipTypeValues_o;

/**
 * Array of wsa_RelationshipTypeValues elements
 * @ingroup wsa_RelationshipTypeValues
 *
 * This structure type is used represent an array of
 * wsa_RelationshipTypeValues elements.
 *
 * Arrays are allocated by wsa_RelationshipTypeValues_array_init() and freed by calling
 * wsa_RelationshipTypeValues_array_destroy(). Elements may be added to an array by calling
 * wsa_RelationshipTypeValues_array_push().
 */
typedef struct wsa_RelationshipTypeValues_array_s
{
    /** Dynamic array of elements */
    wsa_RelationshipTypeValues * elements;
    /** Number of elements in this array */
    int                                 length;
} wsa_RelationshipTypeValues_array;

/**
 * Namespace of the wsa_RelationshipTypeValues complex type
 * @ingroup wsa_RelationshipTypeValues
 */
#define WSA_RELATIONSHIPTYPEVALUES_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"
/**
 * Local part of the QName of the wsa_RelationshipTypeValues complex type
 * @ingroup wsa_RelationshipTypeValues
 */
#define WSA_RELATIONSHIPTYPEVALUES_LOCAL "RelationshipTypeValues"

/**
 * QName of the wsa_RelationshipTypeValues complex type
 * @ingroup wsa_RelationshipTypeValues
 */
extern xsd_QName wsa_RelationshipTypeValues_qname;
/**
 * Type information for serializing and deserializing wsa_RelationshipTypeValues elements
 * @ingroup wsa_RelationshipTypeValues
 */
extern struct globus_xsd_type_info_s wsa_RelationshipTypeValues_info;
/**
 * Type information for serializing and deserializing arrays of wsa_RelationshipTypeValues
 * elements
 * @ingroup wsa_RelationshipTypeValues
 */
extern struct globus_xsd_type_info_s wsa_RelationshipTypeValues_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsa_RelationshipTypeValues without surrounding elements
 * @ingroup wsa_RelationshipTypeValues
 */
extern struct globus_xsd_type_info_s wsa_RelationshipTypeValues_contents_info;

/**
 * Initialize a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 *
 * Allocates a new wsa_RelationshipTypeValues and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsa_RelationshipTypeValues_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsa_RelationshipTypeValues_init(
    wsa_RelationshipTypeValues ** inst);

/**
 * Destroy a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 *
 * Frees a wsa_RelationshipTypeValues. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsa_RelationshipTypeValues_destroy(
    wsa_RelationshipTypeValues * inst);

/**
 * Copy a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 *
 * Perform a deep copy of a wsa_RelationshipTypeValues.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsa_RelationshipTypeValues structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsa_RelationshipTypeValues to be copied.
 */
globus_result_t
wsa_RelationshipTypeValues_copy(
    wsa_RelationshipTypeValues ** dest,
    const wsa_RelationshipTypeValues * src);

/**
 * Initialize the contents of a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 *
 * Initialize the contents of a wsa_RelationshipTypeValues. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsa_RelationshipTypeValues_init(). The contents may be freed
 * by calling wsa_RelationshipTypeValues_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsa_RelationshipTypeValues.
 */
globus_result_t
wsa_RelationshipTypeValues_init_contents(
    wsa_RelationshipTypeValues * instance);

/**
 * Destroy the contents of a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 *
 * Destroy the subelements and attributes of the given wsa_RelationshipTypeValues. 
 *
 * @param inst
 *     Pointer to a wsa_RelationshipTypeValues instance to destroy.
 */
void
wsa_RelationshipTypeValues_destroy_contents(
    wsa_RelationshipTypeValues * inst);

/**
 * Copy the contents of a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 *
 * Perform a deep copy of the contents of a wsa_RelationshipTypeValues.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsa_RelationshipTypeValues to be copied.
 */
globus_result_t
wsa_RelationshipTypeValues_copy_contents(
    wsa_RelationshipTypeValues * dest,
    const wsa_RelationshipTypeValues * src);

/**
 * Initialize an array of wsa_RelationshipTypeValues elements.
 * @ingroup wsa_RelationshipTypeValues
 *
 * Allocates a new array of 0 elements. When this array is no longer used,
 * it should be freed by calling 
 * wsa_RelationshipTypeValues_array_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated array instance.
 */
globus_result_t
wsa_RelationshipTypeValues_array_init(
    wsa_RelationshipTypeValues_array ** inst);

/**
 * Destroy an array of wsa_RelationshipTypeValues elements.
 * @ingroup wsa_RelationshipTypeValues
 *
 * Frees an array of wsa_RelationshipTypeValues elements. The contents of each element
 * element in the array be destroyed by calling
 * wsa_RelationshipTypeValues_destroy_contents().
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wsa_RelationshipTypeValues_array_destroy(
    wsa_RelationshipTypeValues_array * inst);

/**
 * Copy an array of wsa_RelationshipTypeValues elements
 * @ingroup wsa_RelationshipTypeValues
 *
 * Perform a deep copy of an array of wsa_RelationshipTypeValues elements.
 * The @a dest array will be allocated, and then a copy of the contents
 * of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wsa_RelationshipTypeValues_array_copy(
    wsa_RelationshipTypeValues_array ** dest,
    const wsa_RelationshipTypeValues_array * src);

/**
 * Initialize the contents of an array of wsa_RelationshipTypeValues elements
 * @ingroup wsa_RelationshipTypeValues
 *
 * Initialize the contents of an array of wsa_RelationshipTypeValues elements. Used
 * when the array is allocated on the stack or by a some allocator besides
 * wsa_RelationshipTypeValues_array_init(). The contents of the array may be freed
 * by calling wsa_RelationshipTypeValues_array_destroy_contents().
 *
 * @param inst
 *     Pointer to an allocated but uninitialized array.
 */
globus_result_t
wsa_RelationshipTypeValues_array_init_contents(
    wsa_RelationshipTypeValues_array * inst);

/**
 * Destroy the contents of an array of wsa_RelationshipTypeValues elements
 * @ingroup wsa_RelationshipTypeValues
 *
 * Destroy the elements in an array of wsa_RelationshipTypeValues elements. The contents of
 * each element in the array be destroyed by calling
 * wsa_RelationshipTypeValues_destroy_contents() and the array will be reset to be empty.
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wsa_RelationshipTypeValues_array_destroy_contents(
    wsa_RelationshipTypeValues_array * inst);

/**
 * Copy the contents of an array of wsa_RelationshipTypeValues elements
 * @ingroup wsa_RelationshipTypeValues
 *
 * Perform a deep copy of an array of wsa_RelationshipTypeValues elements.
 * The @a dest array must be allocated before making this call.
 * A copy of the contents of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wsa_RelationshipTypeValues_array_copy_contents(
    wsa_RelationshipTypeValues_array * dest,
    const wsa_RelationshipTypeValues_array * src);

/**
 * Append a new wsa_RelationshipTypeValues to an array
 * @ingroup wsa_RelationshipTypeValues
 *
 * Allocate and initialize a new wsa_RelationshipTypeValues structure, adding it
 * to the end of the given @a array.
 * 
 * @param array
 *     Array to be appended to.
 *
 * @return This function returns the newly allocated element.
 */
wsa_RelationshipTypeValues *
wsa_RelationshipTypeValues_array_push(
    wsa_RelationshipTypeValues_array * array);

/**
 * Serialize a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues_array
 * Serialize a wsa_RelationshipTypeValues structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsa_RelationshipTypeValues.
 * @param val
 *     The wsa_RelationshipTypeValues to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_serialize(
    xsd_QName *                         element_name,
    wsa_RelationshipTypeValues * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues_array
 * Serialize a wsa_RelationshipTypeValues structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsa_RelationshipTypeValues to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_serialize_contents(
    xsd_QName *                         element_name,
    wsa_RelationshipTypeValues * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 * Deserialize an element containing a wsa_RelationshipTypeValues element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_RelationshipTypeValues.
 * @param val
 *     Pointer to the wsa_RelationshipTypeValues which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_deserialize(
    xsd_QName *                         element_name,
    wsa_RelationshipTypeValues * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 * Deserialize a wsa_RelationshipTypeValues whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsa_RelationshipTypeValues which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_deserialize_contents(
    xsd_QName *                         element_name,
    wsa_RelationshipTypeValues * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 * Deserialize the next element if it contains a wsa_RelationshipTypeValues.
 *
 * @param element_name
 *     The name of the element which should enclose the wsa_RelationshipTypeValues.
 * @param instance
 *     Pointer to the <code>wsa_RelationshipTypeValues *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_deserialize_pointer(
    xsd_QName *                         element_name,
    wsa_RelationshipTypeValues ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize an array of wsa_RelationshipTypeValues elements
 * @ingroup wsa_RelationshipTypeValues
 * Serialize an element containing an array of wsa_RelationshipTypeValues elements.
 *
 * @param element
 *     The name of the element which will contain the array.
 * @param array_instance
 *     The array to serialize
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_array_serialize(
    xsd_QName *                         element,
    wsa_RelationshipTypeValues_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an array of wsa_RelationshipTypeValues elements
 * @ingroup wsa_RelationshipTypeValues
 * Deserialize an element containing an array of wsa_RelationshipTypeValues elements.
 *
 * @param element
 *     The name of the element which should enclose the array.
 * @param array_instance
 *     The array to deserialize into
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_array_deserialize(
    xsd_QName *                         element,
    wsa_RelationshipTypeValues_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);



/**
 * Serialize an attribute of type wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues_array
 * Serialize a wsa_RelationshipTypeValues as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsa_RelationshipTypeValues.
 * @param val
 *     The wsa_RelationshipTypeValues to serialize.
 * @param message
 *     The handle to serialize the attribute on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_serialize_attribute(
    xsd_QName *                         attr_qname,
    wsa_RelationshipTypeValues * val,
    globus_soap_message_handle_t        handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an attribute of type wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 * Deserialize a wsa_RelationshipTypeValues as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsa_RelationshipTypeValues.
 * @param instance
 *     Pointer to the wsa_RelationshipTypeValues which will be initialized with the
 *     value of the attribute.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_deserialize_attribute(
    xsd_QName *                         attr_qname,
    wsa_RelationshipTypeValues * instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional attribute of type wsa_RelationshipTypeValues
 * @ingroup wsa_RelationshipTypeValues
 * Try to deserialize a wsa_RelationshipTypeValues as an attribute of the current element
 * if it is present. The attribute's name is defined by @ attr_qname.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsa_RelationshipTypeValues.
 * @param instance
 *     Pointer to the wsa_RelationshipTypeValues which will be allocated and initialized
 *     with the value of the attribute if it is present.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsa_RelationshipTypeValues_deserialize_attribute_pointer(
    xsd_QName *                         attr_qname,
    wsa_RelationshipTypeValues ** instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);


#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
globus_result_t
wsa_RelationshipTypeValues_init_wrapper(
    void **                             object);
    
void
wsa_RelationshipTypeValues_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsa_RelationshipTypeValues_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);
    
globus_result_t
wsa_RelationshipTypeValues_init_contents_wrapper(
    void  *                             object);
    
void
wsa_RelationshipTypeValues_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsa_RelationshipTypeValues_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);
    
globus_result_t
wsa_RelationshipTypeValues_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_RelationshipTypeValues_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_RelationshipTypeValues_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_RelationshipTypeValues_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_RelationshipTypeValues_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsa_RelationshipTypeValues_array_init_wrapper(
    void **                             arr);
    
void
wsa_RelationshipTypeValues_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsa_RelationshipTypeValues_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);
globus_result_t
wsa_RelationshipTypeValues_array_init_contents_wrapper(
    void *                              arr);
    
void
wsa_RelationshipTypeValues_array_destroy_contents_wrapper(
    void *                              arr);
    
globus_result_t
wsa_RelationshipTypeValues_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);
    
globus_result_t
wsa_RelationshipTypeValues_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

void *
wsa_RelationshipTypeValues_array_push_wrapper(
    void * array);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
