/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSBF_BASEFAULTTYPE_H_
#define _WSBF_BASEFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsbf_BaseFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd}BaseFaultType element.
 * @ingroup wsbf_BaseFaultType
 */
typedef struct wsbf_BaseFaultType_s wsbf_BaseFaultType;
/**
 * The wsbf_BaseFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd}BaseFaultType element.
 * @ingroup wsbf_BaseFaultType
 */
typedef wsbf_BaseFaultType * wsbf_BaseFaultType_o;

/**
 * Namespace of the wsbf_BaseFaultType complex type
 * @ingroup wsbf_BaseFaultType
 */
#define WSBF_BASEFAULTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsbf_BaseFaultType complex type
 * @ingroup wsbf_BaseFaultType
 */
#define WSBF_BASEFAULTTYPE_LOCAL "BaseFaultType"

/**
 * QName of the wsbf_BaseFaultType complex type
 * @ingroup wsbf_BaseFaultType
 */
extern xsd_QName wsbf_BaseFaultType_qname;
/**
 * Type information for serializing and deserializing wsbf_BaseFaultType elements
 * @ingroup wsbf_BaseFaultType
 */
extern struct globus_xsd_type_info_s wsbf_BaseFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsbf_BaseFaultType
 * elements
 * @ingroup wsbf_BaseFaultType
 */
extern struct globus_xsd_type_info_s wsbf_BaseFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsbf_BaseFaultType without surrounding elements
 * @ingroup wsbf_BaseFaultType
 */
extern struct globus_xsd_type_info_s wsbf_BaseFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsbf_BaseFaultType_array.h"

/**
 * @defgroup wsbf_BaseFaultType Complex type: wsbf_BaseFaultType
 * @ingroup types
 */

/**
 * C structure for the wsbf_BaseFaultType complex type
 * @ingroup wsbf_BaseFaultType
 */
struct wsbf_BaseFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 *
 * Allocates a new wsbf_BaseFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsbf_BaseFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsbf_BaseFaultType_init(
    wsbf_BaseFaultType ** inst);

/**
 * Destroy a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 *
 * Frees a wsbf_BaseFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsbf_BaseFaultType_destroy(
    wsbf_BaseFaultType * inst);

/**
 * Copy a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 *
 * Perform a deep copy of a wsbf_BaseFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsbf_BaseFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsbf_BaseFaultType to be copied.
 */
globus_result_t
wsbf_BaseFaultType_copy(
    wsbf_BaseFaultType ** dest,
    const wsbf_BaseFaultType * src);

/**
 * Initialize the contents of a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 *
 * Initialize the contents of a wsbf_BaseFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsbf_BaseFaultType_init(). The contents may be freed
 * by calling wsbf_BaseFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsbf_BaseFaultType.
 */
globus_result_t
wsbf_BaseFaultType_init_contents(
    wsbf_BaseFaultType * instance);

/**
 * Destroy the contents of a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 *
 * Destroy the subelements and attributes of the given wsbf_BaseFaultType. 
 *
 * @param inst
 *     Pointer to a wsbf_BaseFaultType instance to destroy.
 */
void
wsbf_BaseFaultType_destroy_contents(
    wsbf_BaseFaultType * inst);

/**
 * Copy the contents of a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 *
 * Perform a deep copy of the contents of a wsbf_BaseFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsbf_BaseFaultType to be copied.
 */
globus_result_t
wsbf_BaseFaultType_copy_contents(
    wsbf_BaseFaultType * dest,
    const wsbf_BaseFaultType * src);

/**
 * Serialize a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType_array
 * Serialize a wsbf_BaseFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsbf_BaseFaultType.
 * @param val
 *     The wsbf_BaseFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsbf_BaseFaultType_serialize(
    xsd_QName *                         element_name,
    wsbf_BaseFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType_array
 * Serialize a wsbf_BaseFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsbf_BaseFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsbf_BaseFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsbf_BaseFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 * Deserialize an element containing a wsbf_BaseFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsbf_BaseFaultType.
 * @param val
 *     Pointer to the wsbf_BaseFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_BaseFaultType_deserialize(
    xsd_QName *                         element_name,
    wsbf_BaseFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 * Deserialize a wsbf_BaseFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsbf_BaseFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_BaseFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsbf_BaseFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsbf_BaseFaultType
 * @ingroup wsbf_BaseFaultType
 * Deserialize the next element if it contains a wsbf_BaseFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsbf_BaseFaultType.
 * @param instance
 *     Pointer to the <code>wsbf_BaseFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_BaseFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsbf_BaseFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsbf_BaseFaultType_init_wrapper(
    void **                             object);
    
void
wsbf_BaseFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsbf_BaseFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsbf_BaseFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsbf_BaseFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsbf_BaseFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsbf_BaseFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsbf_BaseFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsbf_BaseFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsbf_BaseFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
