/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSBF_DESCRIPTIONTYPE_H_
#define _WSBF_DESCRIPTIONTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsbf_DescriptionType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd}complexType 5 element.
 * @ingroup wsbf_DescriptionType
 */
typedef struct wsbf_DescriptionType_s wsbf_DescriptionType;
/**
 * The wsbf_DescriptionType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd}complexType 5 element.
 * @ingroup wsbf_DescriptionType
 */
typedef wsbf_DescriptionType * wsbf_DescriptionType_o;

/**
 * Namespace of the wsbf_DescriptionType complex type
 * @ingroup wsbf_DescriptionType
 */
#define WSBF_DESCRIPTIONTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsbf_DescriptionType complex type
 * @ingroup wsbf_DescriptionType
 */
#define WSBF_DESCRIPTIONTYPE_LOCAL "DescriptionType"

/**
 * QName of the wsbf_DescriptionType complex type
 * @ingroup wsbf_DescriptionType
 */
extern xsd_QName wsbf_DescriptionType_qname;
/**
 * Type information for serializing and deserializing wsbf_DescriptionType elements
 * @ingroup wsbf_DescriptionType
 */
extern struct globus_xsd_type_info_s wsbf_DescriptionType_info;
/**
 * Type information for serializing and deserializing arrays of wsbf_DescriptionType
 * elements
 * @ingroup wsbf_DescriptionType
 */
extern struct globus_xsd_type_info_s wsbf_DescriptionType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsbf_DescriptionType without surrounding elements
 * @ingroup wsbf_DescriptionType
 */
extern struct globus_xsd_type_info_s wsbf_DescriptionType_contents_info;


#include "xsd_string.h"
#include "xsd_language.h"
#include "wsbf_DescriptionType_array.h"

/**
 * @defgroup wsbf_DescriptionType Complex type: wsbf_DescriptionType
 * @ingroup types
 */

/**
 * C structure for the wsbf_DescriptionType complex type
 * @ingroup wsbf_DescriptionType
 */
struct wsbf_DescriptionType_s
{
    /** xsd_string subelement */
    xsd_string base_value;
    xsd_language_o _lang;

};

/**
 * Initialize a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 *
 * Allocates a new wsbf_DescriptionType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsbf_DescriptionType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsbf_DescriptionType_init(
    wsbf_DescriptionType ** inst);

/**
 * Destroy a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 *
 * Frees a wsbf_DescriptionType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsbf_DescriptionType_destroy(
    wsbf_DescriptionType * inst);

/**
 * Copy a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 *
 * Perform a deep copy of a wsbf_DescriptionType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsbf_DescriptionType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsbf_DescriptionType to be copied.
 */
globus_result_t
wsbf_DescriptionType_copy(
    wsbf_DescriptionType ** dest,
    const wsbf_DescriptionType * src);

/**
 * Initialize the contents of a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 *
 * Initialize the contents of a wsbf_DescriptionType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsbf_DescriptionType_init(). The contents may be freed
 * by calling wsbf_DescriptionType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsbf_DescriptionType.
 */
globus_result_t
wsbf_DescriptionType_init_contents(
    wsbf_DescriptionType * instance);

/**
 * Destroy the contents of a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 *
 * Destroy the subelements and attributes of the given wsbf_DescriptionType. 
 *
 * @param inst
 *     Pointer to a wsbf_DescriptionType instance to destroy.
 */
void
wsbf_DescriptionType_destroy_contents(
    wsbf_DescriptionType * inst);

/**
 * Copy the contents of a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 *
 * Perform a deep copy of the contents of a wsbf_DescriptionType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsbf_DescriptionType to be copied.
 */
globus_result_t
wsbf_DescriptionType_copy_contents(
    wsbf_DescriptionType * dest,
    const wsbf_DescriptionType * src);

/**
 * Serialize a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType_array
 * Serialize a wsbf_DescriptionType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsbf_DescriptionType.
 * @param val
 *     The wsbf_DescriptionType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsbf_DescriptionType_serialize(
    xsd_QName *                         element_name,
    wsbf_DescriptionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType_array
 * Serialize a wsbf_DescriptionType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsbf_DescriptionType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsbf_DescriptionType_serialize_contents(
    xsd_QName *                         element_name,
    wsbf_DescriptionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 * Deserialize an element containing a wsbf_DescriptionType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsbf_DescriptionType.
 * @param val
 *     Pointer to the wsbf_DescriptionType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_DescriptionType_deserialize(
    xsd_QName *                         element_name,
    wsbf_DescriptionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 * Deserialize a wsbf_DescriptionType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsbf_DescriptionType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_DescriptionType_deserialize_contents(
    xsd_QName *                         element_name,
    wsbf_DescriptionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsbf_DescriptionType
 * @ingroup wsbf_DescriptionType
 * Deserialize the next element if it contains a wsbf_DescriptionType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsbf_DescriptionType.
 * @param instance
 *     Pointer to the <code>wsbf_DescriptionType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsbf_DescriptionType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsbf_DescriptionType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsbf_DescriptionType_init_wrapper(
    void **                             object);
    
void
wsbf_DescriptionType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsbf_DescriptionType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsbf_DescriptionType_init_contents_wrapper(
    void *                              object);
    
void
wsbf_DescriptionType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsbf_DescriptionType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsbf_DescriptionType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsbf_DescriptionType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsbf_DescriptionType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsbf_DescriptionType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
