/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSNT_GETCURRENTMESSAGETYPE_H_
#define _WSNT_GETCURRENTMESSAGETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsnt_GetCurrentMessageType complex type, which represents the
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}complexType 26 element.
 * @ingroup wsnt_GetCurrentMessageType
 */
typedef struct wsnt_GetCurrentMessageType_s wsnt_GetCurrentMessageType;
/**
 * The wsnt_GetCurrentMessageType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}complexType 26 element.
 * @ingroup wsnt_GetCurrentMessageType
 */
typedef wsnt_GetCurrentMessageType * wsnt_GetCurrentMessageType_o;

/**
 * Namespace of the wsnt_GetCurrentMessageType complex type
 * @ingroup wsnt_GetCurrentMessageType
 */
#define WSNT_GETCURRENTMESSAGETYPE_NS "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsnt_GetCurrentMessageType complex type
 * @ingroup wsnt_GetCurrentMessageType
 */
#define WSNT_GETCURRENTMESSAGETYPE_LOCAL "GetCurrentMessageType"

/**
 * QName of the wsnt_GetCurrentMessageType complex type
 * @ingroup wsnt_GetCurrentMessageType
 */
extern xsd_QName wsnt_GetCurrentMessageType_qname;
/**
 * Type information for serializing and deserializing wsnt_GetCurrentMessageType elements
 * @ingroup wsnt_GetCurrentMessageType
 */
extern struct globus_xsd_type_info_s wsnt_GetCurrentMessageType_info;
/**
 * Type information for serializing and deserializing arrays of wsnt_GetCurrentMessageType
 * elements
 * @ingroup wsnt_GetCurrentMessageType
 */
extern struct globus_xsd_type_info_s wsnt_GetCurrentMessageType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsnt_GetCurrentMessageType without surrounding elements
 * @ingroup wsnt_GetCurrentMessageType
 */
extern struct globus_xsd_type_info_s wsnt_GetCurrentMessageType_contents_info;


#include "wsnt_TopicExpressionType.h"
#include "wsnt_GetCurrentMessageType_array.h"

/**
 * @defgroup wsnt_GetCurrentMessageType Complex type: wsnt_GetCurrentMessageType
 * @ingroup types
 */

/**
 * C structure for the wsnt_GetCurrentMessageType complex type
 * @ingroup wsnt_GetCurrentMessageType
 */
struct wsnt_GetCurrentMessageType_s
{
    /** wsnt_TopicExpressionType subelement */
    wsnt_TopicExpressionType Topic;

};

/**
 * Initialize a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 *
 * Allocates a new wsnt_GetCurrentMessageType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsnt_GetCurrentMessageType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsnt_GetCurrentMessageType_init(
    wsnt_GetCurrentMessageType ** inst);

/**
 * Destroy a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 *
 * Frees a wsnt_GetCurrentMessageType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsnt_GetCurrentMessageType_destroy(
    wsnt_GetCurrentMessageType * inst);

/**
 * Copy a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 *
 * Perform a deep copy of a wsnt_GetCurrentMessageType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsnt_GetCurrentMessageType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsnt_GetCurrentMessageType to be copied.
 */
globus_result_t
wsnt_GetCurrentMessageType_copy(
    wsnt_GetCurrentMessageType ** dest,
    const wsnt_GetCurrentMessageType * src);

/**
 * Initialize the contents of a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 *
 * Initialize the contents of a wsnt_GetCurrentMessageType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsnt_GetCurrentMessageType_init(). The contents may be freed
 * by calling wsnt_GetCurrentMessageType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsnt_GetCurrentMessageType.
 */
globus_result_t
wsnt_GetCurrentMessageType_init_contents(
    wsnt_GetCurrentMessageType * instance);

/**
 * Destroy the contents of a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 *
 * Destroy the subelements and attributes of the given wsnt_GetCurrentMessageType. 
 *
 * @param inst
 *     Pointer to a wsnt_GetCurrentMessageType instance to destroy.
 */
void
wsnt_GetCurrentMessageType_destroy_contents(
    wsnt_GetCurrentMessageType * inst);

/**
 * Copy the contents of a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 *
 * Perform a deep copy of the contents of a wsnt_GetCurrentMessageType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsnt_GetCurrentMessageType to be copied.
 */
globus_result_t
wsnt_GetCurrentMessageType_copy_contents(
    wsnt_GetCurrentMessageType * dest,
    const wsnt_GetCurrentMessageType * src);

/**
 * Serialize a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType_array
 * Serialize a wsnt_GetCurrentMessageType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsnt_GetCurrentMessageType.
 * @param val
 *     The wsnt_GetCurrentMessageType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_GetCurrentMessageType_serialize(
    xsd_QName *                         element_name,
    wsnt_GetCurrentMessageType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType_array
 * Serialize a wsnt_GetCurrentMessageType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsnt_GetCurrentMessageType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_GetCurrentMessageType_serialize_contents(
    xsd_QName *                         element_name,
    wsnt_GetCurrentMessageType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 * Deserialize an element containing a wsnt_GetCurrentMessageType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_GetCurrentMessageType.
 * @param val
 *     Pointer to the wsnt_GetCurrentMessageType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_GetCurrentMessageType_deserialize(
    xsd_QName *                         element_name,
    wsnt_GetCurrentMessageType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 * Deserialize a wsnt_GetCurrentMessageType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsnt_GetCurrentMessageType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_GetCurrentMessageType_deserialize_contents(
    xsd_QName *                         element_name,
    wsnt_GetCurrentMessageType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsnt_GetCurrentMessageType
 * @ingroup wsnt_GetCurrentMessageType
 * Deserialize the next element if it contains a wsnt_GetCurrentMessageType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_GetCurrentMessageType.
 * @param instance
 *     Pointer to the <code>wsnt_GetCurrentMessageType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_GetCurrentMessageType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsnt_GetCurrentMessageType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsnt_GetCurrentMessageType_init_wrapper(
    void **                             object);
    
void
wsnt_GetCurrentMessageType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsnt_GetCurrentMessageType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_GetCurrentMessageType_init_contents_wrapper(
    void *                              object);
    
void
wsnt_GetCurrentMessageType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsnt_GetCurrentMessageType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_GetCurrentMessageType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_GetCurrentMessageType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_GetCurrentMessageType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsnt_GetCurrentMessageType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
