/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSNT_NOTIFYTYPE_H_
#define _WSNT_NOTIFYTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsnt_NotifyType complex type, which represents the
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}complexType 22 element.
 * @ingroup wsnt_NotifyType
 */
typedef struct wsnt_NotifyType_s wsnt_NotifyType;
/**
 * The wsnt_NotifyType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}complexType 22 element.
 * @ingroup wsnt_NotifyType
 */
typedef wsnt_NotifyType * wsnt_NotifyType_o;

/**
 * Namespace of the wsnt_NotifyType complex type
 * @ingroup wsnt_NotifyType
 */
#define WSNT_NOTIFYTYPE_NS "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsnt_NotifyType complex type
 * @ingroup wsnt_NotifyType
 */
#define WSNT_NOTIFYTYPE_LOCAL "NotifyType"

/**
 * QName of the wsnt_NotifyType complex type
 * @ingroup wsnt_NotifyType
 */
extern xsd_QName wsnt_NotifyType_qname;
/**
 * Type information for serializing and deserializing wsnt_NotifyType elements
 * @ingroup wsnt_NotifyType
 */
extern struct globus_xsd_type_info_s wsnt_NotifyType_info;
/**
 * Type information for serializing and deserializing arrays of wsnt_NotifyType
 * elements
 * @ingroup wsnt_NotifyType
 */
extern struct globus_xsd_type_info_s wsnt_NotifyType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsnt_NotifyType without surrounding elements
 * @ingroup wsnt_NotifyType
 */
extern struct globus_xsd_type_info_s wsnt_NotifyType_contents_info;


#include "wsnt_NotificationMessageHolderType_array.h"
#include "wsnt_NotifyType_array.h"

/**
 * @defgroup wsnt_NotifyType Complex type: wsnt_NotifyType
 * @ingroup types
 */

/**
 * C structure for the wsnt_NotifyType complex type
 * @ingroup wsnt_NotifyType
 */
struct wsnt_NotifyType_s
{
   /** Array of [1 .. Infinity] wsnt_NotificationMessageHolderType elements */
    wsnt_NotificationMessageHolderType_array NotificationMessage;

};

/**
 * Initialize a wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 *
 * Allocates a new wsnt_NotifyType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsnt_NotifyType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsnt_NotifyType_init(
    wsnt_NotifyType ** inst);

/**
 * Destroy a wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 *
 * Frees a wsnt_NotifyType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsnt_NotifyType_destroy(
    wsnt_NotifyType * inst);

/**
 * Copy a wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 *
 * Perform a deep copy of a wsnt_NotifyType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsnt_NotifyType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsnt_NotifyType to be copied.
 */
globus_result_t
wsnt_NotifyType_copy(
    wsnt_NotifyType ** dest,
    const wsnt_NotifyType * src);

/**
 * Initialize the contents of a wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 *
 * Initialize the contents of a wsnt_NotifyType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsnt_NotifyType_init(). The contents may be freed
 * by calling wsnt_NotifyType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsnt_NotifyType.
 */
globus_result_t
wsnt_NotifyType_init_contents(
    wsnt_NotifyType * instance);

/**
 * Destroy the contents of a wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 *
 * Destroy the subelements and attributes of the given wsnt_NotifyType. 
 *
 * @param inst
 *     Pointer to a wsnt_NotifyType instance to destroy.
 */
void
wsnt_NotifyType_destroy_contents(
    wsnt_NotifyType * inst);

/**
 * Copy the contents of a wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 *
 * Perform a deep copy of the contents of a wsnt_NotifyType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsnt_NotifyType to be copied.
 */
globus_result_t
wsnt_NotifyType_copy_contents(
    wsnt_NotifyType * dest,
    const wsnt_NotifyType * src);

/**
 * Serialize a wsnt_NotifyType
 * @ingroup wsnt_NotifyType_array
 * Serialize a wsnt_NotifyType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsnt_NotifyType.
 * @param val
 *     The wsnt_NotifyType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_NotifyType_serialize(
    xsd_QName *                         element_name,
    wsnt_NotifyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsnt_NotifyType
 * @ingroup wsnt_NotifyType_array
 * Serialize a wsnt_NotifyType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsnt_NotifyType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_NotifyType_serialize_contents(
    xsd_QName *                         element_name,
    wsnt_NotifyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 * Deserialize an element containing a wsnt_NotifyType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_NotifyType.
 * @param val
 *     Pointer to the wsnt_NotifyType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NotifyType_deserialize(
    xsd_QName *                         element_name,
    wsnt_NotifyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 * Deserialize a wsnt_NotifyType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsnt_NotifyType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NotifyType_deserialize_contents(
    xsd_QName *                         element_name,
    wsnt_NotifyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsnt_NotifyType
 * @ingroup wsnt_NotifyType
 * Deserialize the next element if it contains a wsnt_NotifyType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_NotifyType.
 * @param instance
 *     Pointer to the <code>wsnt_NotifyType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_NotifyType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsnt_NotifyType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsnt_NotifyType_init_wrapper(
    void **                             object);
    
void
wsnt_NotifyType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsnt_NotifyType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_NotifyType_init_contents_wrapper(
    void *                              object);
    
void
wsnt_NotifyType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsnt_NotifyType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_NotifyType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_NotifyType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_NotifyType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsnt_NotifyType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
