/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSNT_PAUSEFAILEDFAULTTYPE_H_
#define _WSNT_PAUSEFAILEDFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsnt_PauseFailedFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}PauseFailedFaultType element.
 * @ingroup wsnt_PauseFailedFaultType
 */
typedef struct wsnt_PauseFailedFaultType_s wsnt_PauseFailedFaultType;
/**
 * The wsnt_PauseFailedFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}PauseFailedFaultType element.
 * @ingroup wsnt_PauseFailedFaultType
 */
typedef wsnt_PauseFailedFaultType * wsnt_PauseFailedFaultType_o;

/**
 * Namespace of the wsnt_PauseFailedFaultType complex type
 * @ingroup wsnt_PauseFailedFaultType
 */
#define WSNT_PAUSEFAILEDFAULTTYPE_NS "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsnt_PauseFailedFaultType complex type
 * @ingroup wsnt_PauseFailedFaultType
 */
#define WSNT_PAUSEFAILEDFAULTTYPE_LOCAL "PauseFailedFaultType"

/**
 * QName of the wsnt_PauseFailedFaultType complex type
 * @ingroup wsnt_PauseFailedFaultType
 */
extern xsd_QName wsnt_PauseFailedFaultType_qname;
/**
 * Type information for serializing and deserializing wsnt_PauseFailedFaultType elements
 * @ingroup wsnt_PauseFailedFaultType
 */
extern struct globus_xsd_type_info_s wsnt_PauseFailedFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsnt_PauseFailedFaultType
 * elements
 * @ingroup wsnt_PauseFailedFaultType
 */
extern struct globus_xsd_type_info_s wsnt_PauseFailedFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsnt_PauseFailedFaultType without surrounding elements
 * @ingroup wsnt_PauseFailedFaultType
 */
extern struct globus_xsd_type_info_s wsnt_PauseFailedFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsnt_PauseFailedFaultType_array.h"

/**
 * @defgroup wsnt_PauseFailedFaultType Complex type: wsnt_PauseFailedFaultType
 * @ingroup types
 */

/**
 * C structure for the wsnt_PauseFailedFaultType complex type
 * @ingroup wsnt_PauseFailedFaultType
 */
struct wsnt_PauseFailedFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 *
 * Allocates a new wsnt_PauseFailedFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsnt_PauseFailedFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsnt_PauseFailedFaultType_init(
    wsnt_PauseFailedFaultType ** inst);

/**
 * Destroy a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 *
 * Frees a wsnt_PauseFailedFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsnt_PauseFailedFaultType_destroy(
    wsnt_PauseFailedFaultType * inst);

/**
 * Copy a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 *
 * Perform a deep copy of a wsnt_PauseFailedFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsnt_PauseFailedFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsnt_PauseFailedFaultType to be copied.
 */
globus_result_t
wsnt_PauseFailedFaultType_copy(
    wsnt_PauseFailedFaultType ** dest,
    const wsnt_PauseFailedFaultType * src);

/**
 * Initialize the contents of a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 *
 * Initialize the contents of a wsnt_PauseFailedFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsnt_PauseFailedFaultType_init(). The contents may be freed
 * by calling wsnt_PauseFailedFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsnt_PauseFailedFaultType.
 */
globus_result_t
wsnt_PauseFailedFaultType_init_contents(
    wsnt_PauseFailedFaultType * instance);

/**
 * Destroy the contents of a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 *
 * Destroy the subelements and attributes of the given wsnt_PauseFailedFaultType. 
 *
 * @param inst
 *     Pointer to a wsnt_PauseFailedFaultType instance to destroy.
 */
void
wsnt_PauseFailedFaultType_destroy_contents(
    wsnt_PauseFailedFaultType * inst);

/**
 * Copy the contents of a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 *
 * Perform a deep copy of the contents of a wsnt_PauseFailedFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsnt_PauseFailedFaultType to be copied.
 */
globus_result_t
wsnt_PauseFailedFaultType_copy_contents(
    wsnt_PauseFailedFaultType * dest,
    const wsnt_PauseFailedFaultType * src);

/**
 * Serialize a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType_array
 * Serialize a wsnt_PauseFailedFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsnt_PauseFailedFaultType.
 * @param val
 *     The wsnt_PauseFailedFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_PauseFailedFaultType_serialize(
    xsd_QName *                         element_name,
    wsnt_PauseFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType_array
 * Serialize a wsnt_PauseFailedFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsnt_PauseFailedFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_PauseFailedFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsnt_PauseFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 * Deserialize an element containing a wsnt_PauseFailedFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_PauseFailedFaultType.
 * @param val
 *     Pointer to the wsnt_PauseFailedFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_PauseFailedFaultType_deserialize(
    xsd_QName *                         element_name,
    wsnt_PauseFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 * Deserialize a wsnt_PauseFailedFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsnt_PauseFailedFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_PauseFailedFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsnt_PauseFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsnt_PauseFailedFaultType
 * @ingroup wsnt_PauseFailedFaultType
 * Deserialize the next element if it contains a wsnt_PauseFailedFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_PauseFailedFaultType.
 * @param instance
 *     Pointer to the <code>wsnt_PauseFailedFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_PauseFailedFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsnt_PauseFailedFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsnt_PauseFailedFaultType_init_wrapper(
    void **                             object);
    
void
wsnt_PauseFailedFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsnt_PauseFailedFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_PauseFailedFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsnt_PauseFailedFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsnt_PauseFailedFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_PauseFailedFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_PauseFailedFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_PauseFailedFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsnt_PauseFailedFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
