/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSNT_SUBSCRIBETYPE_H_
#define _WSNT_SUBSCRIBETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsnt_SubscribeType complex type, which represents the
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}complexType 1 element.
 * @ingroup wsnt_SubscribeType
 */
typedef struct wsnt_SubscribeType_s wsnt_SubscribeType;
/**
 * The wsnt_SubscribeType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd}complexType 1 element.
 * @ingroup wsnt_SubscribeType
 */
typedef wsnt_SubscribeType * wsnt_SubscribeType_o;

/**
 * Namespace of the wsnt_SubscribeType complex type
 * @ingroup wsnt_SubscribeType
 */
#define WSNT_SUBSCRIBETYPE_NS "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsnt_SubscribeType complex type
 * @ingroup wsnt_SubscribeType
 */
#define WSNT_SUBSCRIBETYPE_LOCAL "SubscribeType"

/**
 * QName of the wsnt_SubscribeType complex type
 * @ingroup wsnt_SubscribeType
 */
extern xsd_QName wsnt_SubscribeType_qname;
/**
 * Type information for serializing and deserializing wsnt_SubscribeType elements
 * @ingroup wsnt_SubscribeType
 */
extern struct globus_xsd_type_info_s wsnt_SubscribeType_info;
/**
 * Type information for serializing and deserializing arrays of wsnt_SubscribeType
 * elements
 * @ingroup wsnt_SubscribeType
 */
extern struct globus_xsd_type_info_s wsnt_SubscribeType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsnt_SubscribeType without surrounding elements
 * @ingroup wsnt_SubscribeType
 */
extern struct globus_xsd_type_info_s wsnt_SubscribeType_contents_info;


#include "wsa_EndpointReferenceType.h"
#include "wsnt_TopicExpressionType.h"
#include "xsd_boolean.h"
#include "wsrp_QueryExpressionType.h"
#include "wsrp_QueryExpressionType.h"
#include "xsd_anyType.h"
#include "xsd_dateTime.h"
#include "wsnt_SubscribeType_array.h"

/**
 * @defgroup wsnt_SubscribeType Complex type: wsnt_SubscribeType
 * @ingroup types
 */

/**
 * C structure for the wsnt_SubscribeType complex type
 * @ingroup wsnt_SubscribeType
 */
struct wsnt_SubscribeType_s
{
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType ConsumerReference;
    /** wsnt_TopicExpressionType subelement */
    wsnt_TopicExpressionType TopicExpression;
   /** Optional xsd_boolean subelement */
    xsd_boolean_o UseNotify;
   /** Optional wsrp_QueryExpressionType subelement */
    wsrp_QueryExpressionType_o Precondition;
   /** Optional wsrp_QueryExpressionType subelement */
    wsrp_QueryExpressionType_o Selector;
   /** Optional xsd_anyType subelement */
    xsd_anyType_o SubscriptionPolicy;
   /** Optional xsd_dateTime subelement */
    xsd_dateTime_o InitialTerminationTime;

};

/**
 * Initialize a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 *
 * Allocates a new wsnt_SubscribeType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsnt_SubscribeType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsnt_SubscribeType_init(
    wsnt_SubscribeType ** inst);

/**
 * Destroy a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 *
 * Frees a wsnt_SubscribeType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsnt_SubscribeType_destroy(
    wsnt_SubscribeType * inst);

/**
 * Copy a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 *
 * Perform a deep copy of a wsnt_SubscribeType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsnt_SubscribeType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsnt_SubscribeType to be copied.
 */
globus_result_t
wsnt_SubscribeType_copy(
    wsnt_SubscribeType ** dest,
    const wsnt_SubscribeType * src);

/**
 * Initialize the contents of a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 *
 * Initialize the contents of a wsnt_SubscribeType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsnt_SubscribeType_init(). The contents may be freed
 * by calling wsnt_SubscribeType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsnt_SubscribeType.
 */
globus_result_t
wsnt_SubscribeType_init_contents(
    wsnt_SubscribeType * instance);

/**
 * Destroy the contents of a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 *
 * Destroy the subelements and attributes of the given wsnt_SubscribeType. 
 *
 * @param inst
 *     Pointer to a wsnt_SubscribeType instance to destroy.
 */
void
wsnt_SubscribeType_destroy_contents(
    wsnt_SubscribeType * inst);

/**
 * Copy the contents of a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 *
 * Perform a deep copy of the contents of a wsnt_SubscribeType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsnt_SubscribeType to be copied.
 */
globus_result_t
wsnt_SubscribeType_copy_contents(
    wsnt_SubscribeType * dest,
    const wsnt_SubscribeType * src);

/**
 * Serialize a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType_array
 * Serialize a wsnt_SubscribeType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsnt_SubscribeType.
 * @param val
 *     The wsnt_SubscribeType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_SubscribeType_serialize(
    xsd_QName *                         element_name,
    wsnt_SubscribeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType_array
 * Serialize a wsnt_SubscribeType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsnt_SubscribeType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsnt_SubscribeType_serialize_contents(
    xsd_QName *                         element_name,
    wsnt_SubscribeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 * Deserialize an element containing a wsnt_SubscribeType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_SubscribeType.
 * @param val
 *     Pointer to the wsnt_SubscribeType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_SubscribeType_deserialize(
    xsd_QName *                         element_name,
    wsnt_SubscribeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 * Deserialize a wsnt_SubscribeType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsnt_SubscribeType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_SubscribeType_deserialize_contents(
    xsd_QName *                         element_name,
    wsnt_SubscribeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsnt_SubscribeType
 * @ingroup wsnt_SubscribeType
 * Deserialize the next element if it contains a wsnt_SubscribeType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsnt_SubscribeType.
 * @param instance
 *     Pointer to the <code>wsnt_SubscribeType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsnt_SubscribeType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsnt_SubscribeType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsnt_SubscribeType_init_wrapper(
    void **                             object);
    
void
wsnt_SubscribeType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsnt_SubscribeType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_SubscribeType_init_contents_wrapper(
    void *                              object);
    
void
wsnt_SubscribeType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsnt_SubscribeType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsnt_SubscribeType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_SubscribeType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsnt_SubscribeType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsnt_SubscribeType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
