/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_APPLIESTO_H_
#define _WSP_APPLIESTO_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsp_AppliesTo complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}AppliesTo element.
 * @ingroup wsp_AppliesTo
 */
typedef struct wsp_AppliesTo_s wsp_AppliesTo;
/**
 * The wsp_AppliesTo_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}AppliesTo element.
 * @ingroup wsp_AppliesTo
 */
typedef wsp_AppliesTo * wsp_AppliesTo_o;

/**
 * Namespace of the wsp_AppliesTo complex type
 * @ingroup wsp_AppliesTo
 */
#define WSP_APPLIESTO_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
/**
 * Local part of the QName of the wsp_AppliesTo complex type
 * @ingroup wsp_AppliesTo
 */
#define WSP_APPLIESTO_LOCAL "AppliesTo"

/**
 * QName of the wsp_AppliesTo complex type
 * @ingroup wsp_AppliesTo
 */
extern xsd_QName wsp_AppliesTo_qname;
/**
 * Type information for serializing and deserializing wsp_AppliesTo elements
 * @ingroup wsp_AppliesTo
 */
extern struct globus_xsd_type_info_s wsp_AppliesTo_info;
/**
 * Type information for serializing and deserializing arrays of wsp_AppliesTo
 * elements
 * @ingroup wsp_AppliesTo
 */
extern struct globus_xsd_type_info_s wsp_AppliesTo_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsp_AppliesTo without surrounding elements
 * @ingroup wsp_AppliesTo
 */
extern struct globus_xsd_type_info_s wsp_AppliesTo_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "wsp_AppliesTo_array.h"

/**
 * @defgroup wsp_AppliesTo Complex type: wsp_AppliesTo
 * @ingroup types
 */

/**
 * C structure for the wsp_AppliesTo complex type
 * @ingroup wsp_AppliesTo
 */
struct wsp_AppliesTo_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 *
 * Allocates a new wsp_AppliesTo and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsp_AppliesTo_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsp_AppliesTo_init(
    wsp_AppliesTo ** inst);

/**
 * Destroy a wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 *
 * Frees a wsp_AppliesTo. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsp_AppliesTo_destroy(
    wsp_AppliesTo * inst);

/**
 * Copy a wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 *
 * Perform a deep copy of a wsp_AppliesTo.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsp_AppliesTo structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsp_AppliesTo to be copied.
 */
globus_result_t
wsp_AppliesTo_copy(
    wsp_AppliesTo ** dest,
    const wsp_AppliesTo * src);

/**
 * Initialize the contents of a wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 *
 * Initialize the contents of a wsp_AppliesTo. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsp_AppliesTo_init(). The contents may be freed
 * by calling wsp_AppliesTo_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsp_AppliesTo.
 */
globus_result_t
wsp_AppliesTo_init_contents(
    wsp_AppliesTo * instance);

/**
 * Destroy the contents of a wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 *
 * Destroy the subelements and attributes of the given wsp_AppliesTo. 
 *
 * @param inst
 *     Pointer to a wsp_AppliesTo instance to destroy.
 */
void
wsp_AppliesTo_destroy_contents(
    wsp_AppliesTo * inst);

/**
 * Copy the contents of a wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 *
 * Perform a deep copy of the contents of a wsp_AppliesTo.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsp_AppliesTo to be copied.
 */
globus_result_t
wsp_AppliesTo_copy_contents(
    wsp_AppliesTo * dest,
    const wsp_AppliesTo * src);

/**
 * Serialize a wsp_AppliesTo
 * @ingroup wsp_AppliesTo_array
 * Serialize a wsp_AppliesTo structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsp_AppliesTo.
 * @param val
 *     The wsp_AppliesTo to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_AppliesTo_serialize(
    xsd_QName *                         element_name,
    wsp_AppliesTo * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsp_AppliesTo
 * @ingroup wsp_AppliesTo_array
 * Serialize a wsp_AppliesTo structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsp_AppliesTo to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_AppliesTo_serialize_contents(
    xsd_QName *                         element_name,
    wsp_AppliesTo * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 * Deserialize an element containing a wsp_AppliesTo element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_AppliesTo.
 * @param val
 *     Pointer to the wsp_AppliesTo which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_AppliesTo_deserialize(
    xsd_QName *                         element_name,
    wsp_AppliesTo * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 * Deserialize a wsp_AppliesTo whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsp_AppliesTo which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_AppliesTo_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_AppliesTo * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsp_AppliesTo
 * @ingroup wsp_AppliesTo
 * Deserialize the next element if it contains a wsp_AppliesTo.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_AppliesTo.
 * @param instance
 *     Pointer to the <code>wsp_AppliesTo *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_AppliesTo_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_AppliesTo ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsp_AppliesTo_init_wrapper(
    void **                             object);
    
void
wsp_AppliesTo_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_AppliesTo_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_AppliesTo_init_contents_wrapper(
    void *                              object);
    
void
wsp_AppliesTo_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_AppliesTo_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_AppliesTo_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_AppliesTo_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_AppliesTo_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_AppliesTo_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
