/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_COMPOSITOR_H_
#define _WSP_COMPOSITOR_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsp_Compositor complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}Compositor element.
 * @ingroup wsp_Compositor
 */
typedef struct wsp_Compositor_s wsp_Compositor;
/**
 * The wsp_Compositor_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}Compositor element.
 * @ingroup wsp_Compositor
 */
typedef wsp_Compositor * wsp_Compositor_o;

/**
 * Namespace of the wsp_Compositor complex type
 * @ingroup wsp_Compositor
 */
#define WSP_COMPOSITOR_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
/**
 * Local part of the QName of the wsp_Compositor complex type
 * @ingroup wsp_Compositor
 */
#define WSP_COMPOSITOR_LOCAL "Compositor"

/**
 * QName of the wsp_Compositor complex type
 * @ingroup wsp_Compositor
 */
extern xsd_QName wsp_Compositor_qname;
/**
 * Type information for serializing and deserializing wsp_Compositor elements
 * @ingroup wsp_Compositor
 */
extern struct globus_xsd_type_info_s wsp_Compositor_info;
/**
 * Type information for serializing and deserializing arrays of wsp_Compositor
 * elements
 * @ingroup wsp_Compositor
 */
extern struct globus_xsd_type_info_s wsp_Compositor_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsp_Compositor without surrounding elements
 * @ingroup wsp_Compositor
 */
extern struct globus_xsd_type_info_s wsp_Compositor_contents_info;


#include "wsp_CompositorContent_group_array.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "xsd_int.h"
#include "wsp_OpenUsageType.h"
#include "wsp_Compositor_array.h"

/**
 * @defgroup wsp_Compositor Complex type: wsp_Compositor
 * @ingroup types
 */

/**
 * C structure for the wsp_Compositor complex type
 * @ingroup wsp_Compositor
 */
struct wsp_Compositor_s
{
   /** Array of [1 .. Infinity] wsp_CompositorContent_group elements */
    wsp_CompositorContent_group_array CompositorContent;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;
    xsd_int_o _Preference;
    wsp_OpenUsageType_o _Usage;

};

/**
 * Initialize a wsp_Compositor
 * @ingroup wsp_Compositor
 *
 * Allocates a new wsp_Compositor and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsp_Compositor_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsp_Compositor_init(
    wsp_Compositor ** inst);

/**
 * Destroy a wsp_Compositor
 * @ingroup wsp_Compositor
 *
 * Frees a wsp_Compositor. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsp_Compositor_destroy(
    wsp_Compositor * inst);

/**
 * Copy a wsp_Compositor
 * @ingroup wsp_Compositor
 *
 * Perform a deep copy of a wsp_Compositor.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsp_Compositor structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsp_Compositor to be copied.
 */
globus_result_t
wsp_Compositor_copy(
    wsp_Compositor ** dest,
    const wsp_Compositor * src);

/**
 * Initialize the contents of a wsp_Compositor
 * @ingroup wsp_Compositor
 *
 * Initialize the contents of a wsp_Compositor. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsp_Compositor_init(). The contents may be freed
 * by calling wsp_Compositor_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsp_Compositor.
 */
globus_result_t
wsp_Compositor_init_contents(
    wsp_Compositor * instance);

/**
 * Destroy the contents of a wsp_Compositor
 * @ingroup wsp_Compositor
 *
 * Destroy the subelements and attributes of the given wsp_Compositor. 
 *
 * @param inst
 *     Pointer to a wsp_Compositor instance to destroy.
 */
void
wsp_Compositor_destroy_contents(
    wsp_Compositor * inst);

/**
 * Copy the contents of a wsp_Compositor
 * @ingroup wsp_Compositor
 *
 * Perform a deep copy of the contents of a wsp_Compositor.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsp_Compositor to be copied.
 */
globus_result_t
wsp_Compositor_copy_contents(
    wsp_Compositor * dest,
    const wsp_Compositor * src);

/**
 * Serialize a wsp_Compositor
 * @ingroup wsp_Compositor_array
 * Serialize a wsp_Compositor structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsp_Compositor.
 * @param val
 *     The wsp_Compositor to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_Compositor_serialize(
    xsd_QName *                         element_name,
    wsp_Compositor * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsp_Compositor
 * @ingroup wsp_Compositor_array
 * Serialize a wsp_Compositor structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsp_Compositor to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_Compositor_serialize_contents(
    xsd_QName *                         element_name,
    wsp_Compositor * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_Compositor
 * @ingroup wsp_Compositor
 * Deserialize an element containing a wsp_Compositor element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_Compositor.
 * @param val
 *     Pointer to the wsp_Compositor which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_Compositor_deserialize(
    xsd_QName *                         element_name,
    wsp_Compositor * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_Compositor
 * @ingroup wsp_Compositor
 * Deserialize a wsp_Compositor whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsp_Compositor which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_Compositor_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_Compositor * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsp_Compositor
 * @ingroup wsp_Compositor
 * Deserialize the next element if it contains a wsp_Compositor.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_Compositor.
 * @param instance
 *     Pointer to the <code>wsp_Compositor *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_Compositor_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_Compositor ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsp_Compositor_init_wrapper(
    void **                             object);
    
void
wsp_Compositor_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_Compositor_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_Compositor_init_contents_wrapper(
    void *                              object);
    
void
wsp_Compositor_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_Compositor_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_Compositor_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_Compositor_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_Compositor_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_Compositor_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
