/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_LANGUAGEASSERTION_H_
#define _WSP_LANGUAGEASSERTION_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsp_LanguageAssertion complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}LanguageAssertion element.
 * @ingroup wsp_LanguageAssertion
 */
typedef struct wsp_LanguageAssertion_s wsp_LanguageAssertion;
/**
 * The wsp_LanguageAssertion_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}LanguageAssertion element.
 * @ingroup wsp_LanguageAssertion
 */
typedef wsp_LanguageAssertion * wsp_LanguageAssertion_o;

/**
 * Namespace of the wsp_LanguageAssertion complex type
 * @ingroup wsp_LanguageAssertion
 */
#define WSP_LANGUAGEASSERTION_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
/**
 * Local part of the QName of the wsp_LanguageAssertion complex type
 * @ingroup wsp_LanguageAssertion
 */
#define WSP_LANGUAGEASSERTION_LOCAL "LanguageAssertion"

/**
 * QName of the wsp_LanguageAssertion complex type
 * @ingroup wsp_LanguageAssertion
 */
extern xsd_QName wsp_LanguageAssertion_qname;
/**
 * Type information for serializing and deserializing wsp_LanguageAssertion elements
 * @ingroup wsp_LanguageAssertion
 */
extern struct globus_xsd_type_info_s wsp_LanguageAssertion_info;
/**
 * Type information for serializing and deserializing arrays of wsp_LanguageAssertion
 * elements
 * @ingroup wsp_LanguageAssertion
 */
extern struct globus_xsd_type_info_s wsp_LanguageAssertion_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsp_LanguageAssertion without surrounding elements
 * @ingroup wsp_LanguageAssertion
 */
extern struct globus_xsd_type_info_s wsp_LanguageAssertion_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_language.h"
#include "xsd_ID.h"
#include "xsd_int.h"
#include "wsp_OpenUsageType.h"
#include "wsp_LanguageAssertion_array.h"

/**
 * @defgroup wsp_LanguageAssertion Complex type: wsp_LanguageAssertion
 * @ingroup types
 */

/**
 * C structure for the wsp_LanguageAssertion complex type
 * @ingroup wsp_LanguageAssertion
 */
struct wsp_LanguageAssertion_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_language _Language;
    xsd_ID_o _Id;
    xsd_int_o _Preference;
    wsp_OpenUsageType_o _Usage;

};

/**
 * Initialize a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 *
 * Allocates a new wsp_LanguageAssertion and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsp_LanguageAssertion_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsp_LanguageAssertion_init(
    wsp_LanguageAssertion ** inst);

/**
 * Destroy a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 *
 * Frees a wsp_LanguageAssertion. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsp_LanguageAssertion_destroy(
    wsp_LanguageAssertion * inst);

/**
 * Copy a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 *
 * Perform a deep copy of a wsp_LanguageAssertion.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsp_LanguageAssertion structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsp_LanguageAssertion to be copied.
 */
globus_result_t
wsp_LanguageAssertion_copy(
    wsp_LanguageAssertion ** dest,
    const wsp_LanguageAssertion * src);

/**
 * Initialize the contents of a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 *
 * Initialize the contents of a wsp_LanguageAssertion. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsp_LanguageAssertion_init(). The contents may be freed
 * by calling wsp_LanguageAssertion_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsp_LanguageAssertion.
 */
globus_result_t
wsp_LanguageAssertion_init_contents(
    wsp_LanguageAssertion * instance);

/**
 * Destroy the contents of a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 *
 * Destroy the subelements and attributes of the given wsp_LanguageAssertion. 
 *
 * @param inst
 *     Pointer to a wsp_LanguageAssertion instance to destroy.
 */
void
wsp_LanguageAssertion_destroy_contents(
    wsp_LanguageAssertion * inst);

/**
 * Copy the contents of a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 *
 * Perform a deep copy of the contents of a wsp_LanguageAssertion.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsp_LanguageAssertion to be copied.
 */
globus_result_t
wsp_LanguageAssertion_copy_contents(
    wsp_LanguageAssertion * dest,
    const wsp_LanguageAssertion * src);

/**
 * Serialize a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion_array
 * Serialize a wsp_LanguageAssertion structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsp_LanguageAssertion.
 * @param val
 *     The wsp_LanguageAssertion to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_LanguageAssertion_serialize(
    xsd_QName *                         element_name,
    wsp_LanguageAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion_array
 * Serialize a wsp_LanguageAssertion structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsp_LanguageAssertion to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_LanguageAssertion_serialize_contents(
    xsd_QName *                         element_name,
    wsp_LanguageAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 * Deserialize an element containing a wsp_LanguageAssertion element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_LanguageAssertion.
 * @param val
 *     Pointer to the wsp_LanguageAssertion which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_LanguageAssertion_deserialize(
    xsd_QName *                         element_name,
    wsp_LanguageAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 * Deserialize a wsp_LanguageAssertion whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsp_LanguageAssertion which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_LanguageAssertion_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_LanguageAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsp_LanguageAssertion
 * @ingroup wsp_LanguageAssertion
 * Deserialize the next element if it contains a wsp_LanguageAssertion.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_LanguageAssertion.
 * @param instance
 *     Pointer to the <code>wsp_LanguageAssertion *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_LanguageAssertion_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_LanguageAssertion ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsp_LanguageAssertion_init_wrapper(
    void **                             object);
    
void
wsp_LanguageAssertion_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_LanguageAssertion_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_LanguageAssertion_init_contents_wrapper(
    void *                              object);
    
void
wsp_LanguageAssertion_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_LanguageAssertion_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_LanguageAssertion_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_LanguageAssertion_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_LanguageAssertion_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_LanguageAssertion_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
