/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_MESSAGEPREDICATEASSERTION_H_
#define _WSP_MESSAGEPREDICATEASSERTION_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsp_MessagePredicateAssertion complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}MessagePredicateAssertion element.
 * @ingroup wsp_MessagePredicateAssertion
 */
typedef struct wsp_MessagePredicateAssertion_s wsp_MessagePredicateAssertion;
/**
 * The wsp_MessagePredicateAssertion_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}MessagePredicateAssertion element.
 * @ingroup wsp_MessagePredicateAssertion
 */
typedef wsp_MessagePredicateAssertion * wsp_MessagePredicateAssertion_o;

/**
 * Namespace of the wsp_MessagePredicateAssertion complex type
 * @ingroup wsp_MessagePredicateAssertion
 */
#define WSP_MESSAGEPREDICATEASSERTION_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
/**
 * Local part of the QName of the wsp_MessagePredicateAssertion complex type
 * @ingroup wsp_MessagePredicateAssertion
 */
#define WSP_MESSAGEPREDICATEASSERTION_LOCAL "MessagePredicateAssertion"

/**
 * QName of the wsp_MessagePredicateAssertion complex type
 * @ingroup wsp_MessagePredicateAssertion
 */
extern xsd_QName wsp_MessagePredicateAssertion_qname;
/**
 * Type information for serializing and deserializing wsp_MessagePredicateAssertion elements
 * @ingroup wsp_MessagePredicateAssertion
 */
extern struct globus_xsd_type_info_s wsp_MessagePredicateAssertion_info;
/**
 * Type information for serializing and deserializing arrays of wsp_MessagePredicateAssertion
 * elements
 * @ingroup wsp_MessagePredicateAssertion
 */
extern struct globus_xsd_type_info_s wsp_MessagePredicateAssertion_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsp_MessagePredicateAssertion without surrounding elements
 * @ingroup wsp_MessagePredicateAssertion
 */
extern struct globus_xsd_type_info_s wsp_MessagePredicateAssertion_contents_info;


#include "xsd_string.h"
#include "xsd_anyURI.h"
#include "xsd_ID.h"
#include "xsd_int.h"
#include "wsp_OpenUsageType.h"
#include "xsd_anyAttributes.h"
#include "wsp_MessagePredicateAssertion_array.h"

/**
 * @defgroup wsp_MessagePredicateAssertion Complex type: wsp_MessagePredicateAssertion
 * @ingroup types
 */

/**
 * C structure for the wsp_MessagePredicateAssertion complex type
 * @ingroup wsp_MessagePredicateAssertion
 */
struct wsp_MessagePredicateAssertion_s
{
    /** xsd_string subelement */
    xsd_string base_value;
    xsd_anyURI_o _Dialect;
    xsd_ID_o _Id;
    xsd_int_o _Preference;
    wsp_OpenUsageType_o _Usage;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 *
 * Allocates a new wsp_MessagePredicateAssertion and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsp_MessagePredicateAssertion_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsp_MessagePredicateAssertion_init(
    wsp_MessagePredicateAssertion ** inst);

/**
 * Destroy a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 *
 * Frees a wsp_MessagePredicateAssertion. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsp_MessagePredicateAssertion_destroy(
    wsp_MessagePredicateAssertion * inst);

/**
 * Copy a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 *
 * Perform a deep copy of a wsp_MessagePredicateAssertion.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsp_MessagePredicateAssertion structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsp_MessagePredicateAssertion to be copied.
 */
globus_result_t
wsp_MessagePredicateAssertion_copy(
    wsp_MessagePredicateAssertion ** dest,
    const wsp_MessagePredicateAssertion * src);

/**
 * Initialize the contents of a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 *
 * Initialize the contents of a wsp_MessagePredicateAssertion. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsp_MessagePredicateAssertion_init(). The contents may be freed
 * by calling wsp_MessagePredicateAssertion_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsp_MessagePredicateAssertion.
 */
globus_result_t
wsp_MessagePredicateAssertion_init_contents(
    wsp_MessagePredicateAssertion * instance);

/**
 * Destroy the contents of a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 *
 * Destroy the subelements and attributes of the given wsp_MessagePredicateAssertion. 
 *
 * @param inst
 *     Pointer to a wsp_MessagePredicateAssertion instance to destroy.
 */
void
wsp_MessagePredicateAssertion_destroy_contents(
    wsp_MessagePredicateAssertion * inst);

/**
 * Copy the contents of a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 *
 * Perform a deep copy of the contents of a wsp_MessagePredicateAssertion.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsp_MessagePredicateAssertion to be copied.
 */
globus_result_t
wsp_MessagePredicateAssertion_copy_contents(
    wsp_MessagePredicateAssertion * dest,
    const wsp_MessagePredicateAssertion * src);

/**
 * Serialize a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion_array
 * Serialize a wsp_MessagePredicateAssertion structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsp_MessagePredicateAssertion.
 * @param val
 *     The wsp_MessagePredicateAssertion to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_MessagePredicateAssertion_serialize(
    xsd_QName *                         element_name,
    wsp_MessagePredicateAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion_array
 * Serialize a wsp_MessagePredicateAssertion structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsp_MessagePredicateAssertion to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_MessagePredicateAssertion_serialize_contents(
    xsd_QName *                         element_name,
    wsp_MessagePredicateAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 * Deserialize an element containing a wsp_MessagePredicateAssertion element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_MessagePredicateAssertion.
 * @param val
 *     Pointer to the wsp_MessagePredicateAssertion which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_MessagePredicateAssertion_deserialize(
    xsd_QName *                         element_name,
    wsp_MessagePredicateAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 * Deserialize a wsp_MessagePredicateAssertion whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsp_MessagePredicateAssertion which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_MessagePredicateAssertion_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_MessagePredicateAssertion * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsp_MessagePredicateAssertion
 * @ingroup wsp_MessagePredicateAssertion
 * Deserialize the next element if it contains a wsp_MessagePredicateAssertion.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_MessagePredicateAssertion.
 * @param instance
 *     Pointer to the <code>wsp_MessagePredicateAssertion *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_MessagePredicateAssertion_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_MessagePredicateAssertion ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsp_MessagePredicateAssertion_init_wrapper(
    void **                             object);
    
void
wsp_MessagePredicateAssertion_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_MessagePredicateAssertion_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_MessagePredicateAssertion_init_contents_wrapper(
    void *                              object);
    
void
wsp_MessagePredicateAssertion_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_MessagePredicateAssertion_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_MessagePredicateAssertion_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_MessagePredicateAssertion_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_MessagePredicateAssertion_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_MessagePredicateAssertion_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
