/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_POLICYATTACHMENTTYPE_CHOICE_H_
#define _WSP_POLICYATTACHMENTTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum wsp_PolicyAttachmentType_e
{
    wsp_PolicyAttachmentType_undefined,
    wsp_PolicyAttachmentType_Policy,
    wsp_PolicyAttachmentType_PolicyReference

};

/**
 * @defgroup wsp_PolicyAttachmentType_choice Complex choice type: wsp_PolicyAttachmentType
 * @ingroup wsp_PolicyAttachmentType
 */

/**
 * Enumeration of the types of values which the wsp_PolicyAttachmentType_choice
 * structure may take on.
 * @ingroup wsp_PolicyAttachmentType_choice
 */
typedef enum wsp_PolicyAttachmentType_e wsp_PolicyAttachmentType_enum;
/**
 * Union of the values which the wsp_PolicyAttachmentType_choice structure
 * contains
 * @ingroup wsp_PolicyAttachmentType_choice
 */
typedef union wsp_PolicyAttachmentType_u wsp_PolicyAttachmentType_union;
/**
 * The wsp_PolicyAttachmentType complex type, which represents the various values
 * possible by the choice used by the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}choice 29 element.
 * @ingroup wsp_PolicyAttachmentType_choice
 */
typedef struct wsp_PolicyAttachmentType_choice_s wsp_PolicyAttachmentType_choice;
/**
 * The wsp_PolicyAttachmentType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}choice 29 element.
 * @ingroup wsp_PolicyAttachmentType
 */
typedef wsp_PolicyAttachmentType_choice * wsp_PolicyAttachmentType_choice_o;

typedef struct wsp_PolicyAttachmentType_choice_array_s
{
    wsp_PolicyAttachmentType_choice * elements;
    int                                 length;
} wsp_PolicyAttachmentType_choice_array;

#define WSP_POLICYATTACHMENTTYPE_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
#define WSP_POLICYATTACHMENTTYPE_LOCAL "PolicyAttachmentType"

extern xsd_QName wsp_PolicyAttachmentType_choice_qname;
extern struct globus_xsd_type_info_s wsp_PolicyAttachmentType_choice_info;
extern struct globus_xsd_type_info_s wsp_PolicyAttachmentType_choice_contents_info;
extern struct globus_xsd_type_info_s wsp_PolicyAttachmentType_choice_array_info;


#include "wsp_PolicyExpression.h"
#include "wsp_PolicyReferenceType.h"

union wsp_PolicyAttachmentType_u
{
    /** wsp_PolicyExpression subelement */
    wsp_PolicyExpression Policy;
    /** wsp_PolicyReferenceType subelement */
    wsp_PolicyReferenceType PolicyReference;

};

struct wsp_PolicyAttachmentType_choice_s
{
    wsp_PolicyAttachmentType_enum type;
    wsp_PolicyAttachmentType_union value;
};

globus_result_t
wsp_PolicyAttachmentType_choice_init(
    wsp_PolicyAttachmentType_choice ** inst);

void
wsp_PolicyAttachmentType_choice_destroy(
    wsp_PolicyAttachmentType_choice * inst);

globus_result_t
wsp_PolicyAttachmentType_choice_copy(
    wsp_PolicyAttachmentType_choice ** dest,
    const wsp_PolicyAttachmentType_choice * src);

globus_result_t
wsp_PolicyAttachmentType_choice_init_contents(
    wsp_PolicyAttachmentType_choice * instance);

void
wsp_PolicyAttachmentType_choice_destroy_contents(
    wsp_PolicyAttachmentType_choice * inst);

globus_result_t
wsp_PolicyAttachmentType_choice_copy_contents(
    wsp_PolicyAttachmentType_choice * dest,
    const wsp_PolicyAttachmentType_choice * src);
    
globus_result_t
wsp_PolicyAttachmentType_choice_array_init(
    wsp_PolicyAttachmentType_choice_array ** inst);

void
wsp_PolicyAttachmentType_choice_array_destroy(
    wsp_PolicyAttachmentType_choice_array * inst);

globus_result_t
wsp_PolicyAttachmentType_choice_array_copy(
    wsp_PolicyAttachmentType_choice_array ** dest,
    const wsp_PolicyAttachmentType_choice_array * src);

globus_result_t
wsp_PolicyAttachmentType_choice_array_init_contents(
    wsp_PolicyAttachmentType_choice_array * inst);

void
wsp_PolicyAttachmentType_choice_array_destroy_contents(
    wsp_PolicyAttachmentType_choice_array * inst);

globus_result_t
wsp_PolicyAttachmentType_choice_array_copy_contents(
    wsp_PolicyAttachmentType_choice_array * dest,
    const wsp_PolicyAttachmentType_choice_array * src);

wsp_PolicyAttachmentType_choice *
wsp_PolicyAttachmentType_choice_array_push(
    wsp_PolicyAttachmentType_choice_array * array);

globus_result_t
wsp_PolicyAttachmentType_choice_serialize(
    xsd_QName *                         element_name,
    wsp_PolicyAttachmentType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyAttachmentType_choice_serialize_contents(
    xsd_QName *                         element_name,
    wsp_PolicyAttachmentType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyAttachmentType_choice_deserialize(
    xsd_QName *                         element_name,
    wsp_PolicyAttachmentType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyAttachmentType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_PolicyAttachmentType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyAttachmentType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_PolicyAttachmentType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyAttachmentType_choice_array_serialize(
    xsd_QName *                         element,
    wsp_PolicyAttachmentType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyAttachmentType_choice_array_deserialize(
    xsd_QName *                         element,
    wsp_PolicyAttachmentType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyAttachmentType_choice_init_wrapper(
    void **                             object);
    
void
wsp_PolicyAttachmentType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_PolicyAttachmentType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_PolicyAttachmentType_choice_init_contents_wrapper(
    void *                              object);
    
void
wsp_PolicyAttachmentType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_PolicyAttachmentType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_PolicyAttachmentType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyAttachmentType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyAttachmentType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyAttachmentType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyAttachmentType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyAttachmentType_choice_array_init_wrapper(
    void **                             arr);
    
void
wsp_PolicyAttachmentType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsp_PolicyAttachmentType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
wsp_PolicyAttachmentType_choice_array_init_contents_wrapper(
    void *                              arr);

void
wsp_PolicyAttachmentType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
wsp_PolicyAttachmentType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
wsp_PolicyAttachmentType_choice_array_push_wrapper(
    void * array);

globus_result_t
wsp_PolicyAttachmentType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
