/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_POLICYEXPRESSION_H_
#define _WSP_POLICYEXPRESSION_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsp_PolicyExpression complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}PolicyExpression element.
 * @ingroup wsp_PolicyExpression
 */
typedef struct wsp_PolicyExpression_s wsp_PolicyExpression;
/**
 * The wsp_PolicyExpression_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}PolicyExpression element.
 * @ingroup wsp_PolicyExpression
 */
typedef wsp_PolicyExpression * wsp_PolicyExpression_o;

/**
 * Namespace of the wsp_PolicyExpression complex type
 * @ingroup wsp_PolicyExpression
 */
#define WSP_POLICYEXPRESSION_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
/**
 * Local part of the QName of the wsp_PolicyExpression complex type
 * @ingroup wsp_PolicyExpression
 */
#define WSP_POLICYEXPRESSION_LOCAL "PolicyExpression"

/**
 * QName of the wsp_PolicyExpression complex type
 * @ingroup wsp_PolicyExpression
 */
extern xsd_QName wsp_PolicyExpression_qname;
/**
 * Type information for serializing and deserializing wsp_PolicyExpression elements
 * @ingroup wsp_PolicyExpression
 */
extern struct globus_xsd_type_info_s wsp_PolicyExpression_info;
/**
 * Type information for serializing and deserializing arrays of wsp_PolicyExpression
 * elements
 * @ingroup wsp_PolicyExpression
 */
extern struct globus_xsd_type_info_s wsp_PolicyExpression_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsp_PolicyExpression without surrounding elements
 * @ingroup wsp_PolicyExpression
 */
extern struct globus_xsd_type_info_s wsp_PolicyExpression_contents_info;


#include "wsp_CompositorContent_group_array.h"
#include "xsd_anyAttributes.h"
#include "xsd_NCName.h"
#include "xsd_anyURI.h"
#include "xsd_ID.h"
#include "wsp_PolicyExpression_array.h"

/**
 * @defgroup wsp_PolicyExpression Complex type: wsp_PolicyExpression
 * @ingroup types
 */

/**
 * C structure for the wsp_PolicyExpression complex type
 * @ingroup wsp_PolicyExpression
 */
struct wsp_PolicyExpression_s
{
   /** Array of [0 .. Infinity] wsp_CompositorContent_group elements */
    wsp_CompositorContent_group_array CompositorContent;
    xsd_anyAttributes_t anyAttributes;
    xsd_NCName_o _Name;
    xsd_anyURI_o _TargetNamespace;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 *
 * Allocates a new wsp_PolicyExpression and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsp_PolicyExpression_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsp_PolicyExpression_init(
    wsp_PolicyExpression ** inst);

/**
 * Destroy a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 *
 * Frees a wsp_PolicyExpression. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsp_PolicyExpression_destroy(
    wsp_PolicyExpression * inst);

/**
 * Copy a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 *
 * Perform a deep copy of a wsp_PolicyExpression.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsp_PolicyExpression structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsp_PolicyExpression to be copied.
 */
globus_result_t
wsp_PolicyExpression_copy(
    wsp_PolicyExpression ** dest,
    const wsp_PolicyExpression * src);

/**
 * Initialize the contents of a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 *
 * Initialize the contents of a wsp_PolicyExpression. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsp_PolicyExpression_init(). The contents may be freed
 * by calling wsp_PolicyExpression_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsp_PolicyExpression.
 */
globus_result_t
wsp_PolicyExpression_init_contents(
    wsp_PolicyExpression * instance);

/**
 * Destroy the contents of a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 *
 * Destroy the subelements and attributes of the given wsp_PolicyExpression. 
 *
 * @param inst
 *     Pointer to a wsp_PolicyExpression instance to destroy.
 */
void
wsp_PolicyExpression_destroy_contents(
    wsp_PolicyExpression * inst);

/**
 * Copy the contents of a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 *
 * Perform a deep copy of the contents of a wsp_PolicyExpression.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsp_PolicyExpression to be copied.
 */
globus_result_t
wsp_PolicyExpression_copy_contents(
    wsp_PolicyExpression * dest,
    const wsp_PolicyExpression * src);

/**
 * Serialize a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression_array
 * Serialize a wsp_PolicyExpression structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsp_PolicyExpression.
 * @param val
 *     The wsp_PolicyExpression to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_PolicyExpression_serialize(
    xsd_QName *                         element_name,
    wsp_PolicyExpression * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression_array
 * Serialize a wsp_PolicyExpression structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsp_PolicyExpression to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_PolicyExpression_serialize_contents(
    xsd_QName *                         element_name,
    wsp_PolicyExpression * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 * Deserialize an element containing a wsp_PolicyExpression element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_PolicyExpression.
 * @param val
 *     Pointer to the wsp_PolicyExpression which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_PolicyExpression_deserialize(
    xsd_QName *                         element_name,
    wsp_PolicyExpression * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 * Deserialize a wsp_PolicyExpression whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsp_PolicyExpression which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_PolicyExpression_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_PolicyExpression * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsp_PolicyExpression
 * @ingroup wsp_PolicyExpression
 * Deserialize the next element if it contains a wsp_PolicyExpression.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_PolicyExpression.
 * @param instance
 *     Pointer to the <code>wsp_PolicyExpression *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_PolicyExpression_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_PolicyExpression ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsp_PolicyExpression_init_wrapper(
    void **                             object);
    
void
wsp_PolicyExpression_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_PolicyExpression_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_PolicyExpression_init_contents_wrapper(
    void *                              object);
    
void
wsp_PolicyExpression_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_PolicyExpression_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_PolicyExpression_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyExpression_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyExpression_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyExpression_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
