/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSP_POLICYREFERENCETYPE_H_
#define _WSP_POLICYREFERENCETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsp_PolicyReferenceType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}PolicyReferenceType element.
 * @ingroup wsp_PolicyReferenceType
 */
typedef struct wsp_PolicyReferenceType_s wsp_PolicyReferenceType;
/**
 * The wsp_PolicyReferenceType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/12/policy}PolicyReferenceType element.
 * @ingroup wsp_PolicyReferenceType
 */
typedef wsp_PolicyReferenceType * wsp_PolicyReferenceType_o;

/**
 * Namespace of the wsp_PolicyReferenceType complex type
 * @ingroup wsp_PolicyReferenceType
 */
#define WSP_POLICYREFERENCETYPE_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
/**
 * Local part of the QName of the wsp_PolicyReferenceType complex type
 * @ingroup wsp_PolicyReferenceType
 */
#define WSP_POLICYREFERENCETYPE_LOCAL "PolicyReferenceType"

/**
 * QName of the wsp_PolicyReferenceType complex type
 * @ingroup wsp_PolicyReferenceType
 */
extern xsd_QName wsp_PolicyReferenceType_qname;
/**
 * Type information for serializing and deserializing wsp_PolicyReferenceType elements
 * @ingroup wsp_PolicyReferenceType
 */
extern struct globus_xsd_type_info_s wsp_PolicyReferenceType_info;
/**
 * Type information for serializing and deserializing arrays of wsp_PolicyReferenceType
 * elements
 * @ingroup wsp_PolicyReferenceType
 */
extern struct globus_xsd_type_info_s wsp_PolicyReferenceType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsp_PolicyReferenceType without surrounding elements
 * @ingroup wsp_PolicyReferenceType
 */
extern struct globus_xsd_type_info_s wsp_PolicyReferenceType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_base64Binary.h"
#include "xsd_QName.h"
#include "xsd_QName.h"
#include "xsd_anyURI.h"
#include "wsp_PolicyReferenceType_array.h"

/**
 * @defgroup wsp_PolicyReferenceType Complex type: wsp_PolicyReferenceType
 * @ingroup types
 */

/**
 * C structure for the wsp_PolicyReferenceType complex type
 * @ingroup wsp_PolicyReferenceType
 */
struct wsp_PolicyReferenceType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_base64Binary_o _Digest;
    xsd_QName_o _DigestAlgorithm;
    xsd_QName_o _Ref;
    xsd_anyURI_o _URI;

};

/**
 * Initialize a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 *
 * Allocates a new wsp_PolicyReferenceType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsp_PolicyReferenceType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsp_PolicyReferenceType_init(
    wsp_PolicyReferenceType ** inst);

/**
 * Destroy a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 *
 * Frees a wsp_PolicyReferenceType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsp_PolicyReferenceType_destroy(
    wsp_PolicyReferenceType * inst);

/**
 * Copy a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 *
 * Perform a deep copy of a wsp_PolicyReferenceType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsp_PolicyReferenceType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsp_PolicyReferenceType to be copied.
 */
globus_result_t
wsp_PolicyReferenceType_copy(
    wsp_PolicyReferenceType ** dest,
    const wsp_PolicyReferenceType * src);

/**
 * Initialize the contents of a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 *
 * Initialize the contents of a wsp_PolicyReferenceType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsp_PolicyReferenceType_init(). The contents may be freed
 * by calling wsp_PolicyReferenceType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsp_PolicyReferenceType.
 */
globus_result_t
wsp_PolicyReferenceType_init_contents(
    wsp_PolicyReferenceType * instance);

/**
 * Destroy the contents of a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 *
 * Destroy the subelements and attributes of the given wsp_PolicyReferenceType. 
 *
 * @param inst
 *     Pointer to a wsp_PolicyReferenceType instance to destroy.
 */
void
wsp_PolicyReferenceType_destroy_contents(
    wsp_PolicyReferenceType * inst);

/**
 * Copy the contents of a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 *
 * Perform a deep copy of the contents of a wsp_PolicyReferenceType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsp_PolicyReferenceType to be copied.
 */
globus_result_t
wsp_PolicyReferenceType_copy_contents(
    wsp_PolicyReferenceType * dest,
    const wsp_PolicyReferenceType * src);

/**
 * Serialize a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType_array
 * Serialize a wsp_PolicyReferenceType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsp_PolicyReferenceType.
 * @param val
 *     The wsp_PolicyReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_PolicyReferenceType_serialize(
    xsd_QName *                         element_name,
    wsp_PolicyReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType_array
 * Serialize a wsp_PolicyReferenceType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsp_PolicyReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_PolicyReferenceType_serialize_contents(
    xsd_QName *                         element_name,
    wsp_PolicyReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 * Deserialize an element containing a wsp_PolicyReferenceType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_PolicyReferenceType.
 * @param val
 *     Pointer to the wsp_PolicyReferenceType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_PolicyReferenceType_deserialize(
    xsd_QName *                         element_name,
    wsp_PolicyReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 * Deserialize a wsp_PolicyReferenceType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsp_PolicyReferenceType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_PolicyReferenceType_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_PolicyReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsp_PolicyReferenceType
 * @ingroup wsp_PolicyReferenceType
 * Deserialize the next element if it contains a wsp_PolicyReferenceType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_PolicyReferenceType.
 * @param instance
 *     Pointer to the <code>wsp_PolicyReferenceType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_PolicyReferenceType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_PolicyReferenceType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsp_PolicyReferenceType_init_wrapper(
    void **                             object);
    
void
wsp_PolicyReferenceType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_PolicyReferenceType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsp_PolicyReferenceType_init_contents_wrapper(
    void *                              object);
    
void
wsp_PolicyReferenceType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_PolicyReferenceType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsp_PolicyReferenceType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyReferenceType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_PolicyReferenceType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsp_PolicyReferenceType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
