/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDL-to-C Converter
 */

#ifndef _WSP_TPOLICYREFS_H_
#define _WSP_TPOLICYREFS_H_

#include "globus_common.h"

/**
 * @defgroup wsp_tPolicyRefs Simple Type: wsp_tPolicyRefs
 * @ingroup types
 */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */


#include "xsd_QName.h"

/**
 * @ingroup wsp_tPolicyRefs
 */
typedef xsd_QName_array wsp_tPolicyRefs;

/**
 * Optional wsp_tPolicyRefs element
 * @ingroup wsp_tPolicyRefs
 */
typedef wsp_tPolicyRefs * wsp_tPolicyRefs_o;

/**
 * Array of wsp_tPolicyRefs elements
 * @ingroup wsp_tPolicyRefs
 *
 * This structure type is used represent an array of
 * wsp_tPolicyRefs elements.
 *
 * Arrays are allocated by wsp_tPolicyRefs_array_init() and freed by calling
 * wsp_tPolicyRefs_array_destroy(). Elements may be added to an array by calling
 * wsp_tPolicyRefs_array_push().
 */
typedef struct wsp_tPolicyRefs_array_s
{
    /** Dynamic array of elements */
    wsp_tPolicyRefs * elements;
    /** Number of elements in this array */
    int                                 length;
} wsp_tPolicyRefs_array;

/**
 * Namespace of the wsp_tPolicyRefs complex type
 * @ingroup wsp_tPolicyRefs
 */
#define WSP_TPOLICYREFS_NS "http://schemas.xmlsoap.org/ws/2002/12/policy"
/**
 * Local part of the QName of the wsp_tPolicyRefs complex type
 * @ingroup wsp_tPolicyRefs
 */
#define WSP_TPOLICYREFS_LOCAL "tPolicyRefs"

/**
 * QName of the wsp_tPolicyRefs complex type
 * @ingroup wsp_tPolicyRefs
 */
extern xsd_QName wsp_tPolicyRefs_qname;
/**
 * Type information for serializing and deserializing wsp_tPolicyRefs elements
 * @ingroup wsp_tPolicyRefs
 */
extern struct globus_xsd_type_info_s wsp_tPolicyRefs_info;
/**
 * Type information for serializing and deserializing arrays of wsp_tPolicyRefs
 * elements
 * @ingroup wsp_tPolicyRefs
 */
extern struct globus_xsd_type_info_s wsp_tPolicyRefs_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsp_tPolicyRefs without surrounding elements
 * @ingroup wsp_tPolicyRefs
 */
extern struct globus_xsd_type_info_s wsp_tPolicyRefs_contents_info;

/**
 * Initialize a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 *
 * Allocates a new wsp_tPolicyRefs and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsp_tPolicyRefs_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsp_tPolicyRefs_init(
    wsp_tPolicyRefs ** inst);

/**
 * Destroy a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 *
 * Frees a wsp_tPolicyRefs. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsp_tPolicyRefs_destroy(
    wsp_tPolicyRefs * inst);

/**
 * Copy a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 *
 * Perform a deep copy of a wsp_tPolicyRefs.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsp_tPolicyRefs structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsp_tPolicyRefs to be copied.
 */
globus_result_t
wsp_tPolicyRefs_copy(
    wsp_tPolicyRefs ** dest,
    const wsp_tPolicyRefs * src);

/**
 * Initialize the contents of a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 *
 * Initialize the contents of a wsp_tPolicyRefs. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsp_tPolicyRefs_init(). The contents may be freed
 * by calling wsp_tPolicyRefs_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsp_tPolicyRefs.
 */
globus_result_t
wsp_tPolicyRefs_init_contents(
    wsp_tPolicyRefs * instance);

/**
 * Destroy the contents of a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 *
 * Destroy the subelements and attributes of the given wsp_tPolicyRefs. 
 *
 * @param inst
 *     Pointer to a wsp_tPolicyRefs instance to destroy.
 */
void
wsp_tPolicyRefs_destroy_contents(
    wsp_tPolicyRefs * inst);

/**
 * Copy the contents of a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 *
 * Perform a deep copy of the contents of a wsp_tPolicyRefs.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsp_tPolicyRefs to be copied.
 */
globus_result_t
wsp_tPolicyRefs_copy_contents(
    wsp_tPolicyRefs * dest,
    const wsp_tPolicyRefs * src);

/**
 * Initialize an array of wsp_tPolicyRefs elements.
 * @ingroup wsp_tPolicyRefs
 *
 * Allocates a new array of 0 elements. When this array is no longer used,
 * it should be freed by calling 
 * wsp_tPolicyRefs_array_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated array instance.
 */
globus_result_t
wsp_tPolicyRefs_array_init(
    wsp_tPolicyRefs_array ** inst);

/**
 * Destroy an array of wsp_tPolicyRefs elements.
 * @ingroup wsp_tPolicyRefs
 *
 * Frees an array of wsp_tPolicyRefs elements. The contents of each element
 * element in the array be destroyed by calling
 * wsp_tPolicyRefs_destroy_contents().
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wsp_tPolicyRefs_array_destroy(
    wsp_tPolicyRefs_array * inst);

/**
 * Copy an array of wsp_tPolicyRefs elements
 * @ingroup wsp_tPolicyRefs
 *
 * Perform a deep copy of an array of wsp_tPolicyRefs elements.
 * The @a dest array will be allocated, and then a copy of the contents
 * of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wsp_tPolicyRefs_array_copy(
    wsp_tPolicyRefs_array ** dest,
    const wsp_tPolicyRefs_array * src);

/**
 * Initialize the contents of an array of wsp_tPolicyRefs elements
 * @ingroup wsp_tPolicyRefs
 *
 * Initialize the contents of an array of wsp_tPolicyRefs elements. Used
 * when the array is allocated on the stack or by a some allocator besides
 * wsp_tPolicyRefs_array_init(). The contents of the array may be freed
 * by calling wsp_tPolicyRefs_array_destroy_contents().
 *
 * @param inst
 *     Pointer to an allocated but uninitialized array.
 */
globus_result_t
wsp_tPolicyRefs_array_init_contents(
    wsp_tPolicyRefs_array * inst);

/**
 * Destroy the contents of an array of wsp_tPolicyRefs elements
 * @ingroup wsp_tPolicyRefs
 *
 * Destroy the elements in an array of wsp_tPolicyRefs elements. The contents of
 * each element in the array be destroyed by calling
 * wsp_tPolicyRefs_destroy_contents() and the array will be reset to be empty.
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wsp_tPolicyRefs_array_destroy_contents(
    wsp_tPolicyRefs_array * inst);

/**
 * Copy the contents of an array of wsp_tPolicyRefs elements
 * @ingroup wsp_tPolicyRefs
 *
 * Perform a deep copy of an array of wsp_tPolicyRefs elements.
 * The @a dest array must be allocated before making this call.
 * A copy of the contents of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wsp_tPolicyRefs_array_copy_contents(
    wsp_tPolicyRefs_array * dest,
    const wsp_tPolicyRefs_array * src);

/**
 * Append a new wsp_tPolicyRefs to an array
 * @ingroup wsp_tPolicyRefs
 *
 * Allocate and initialize a new wsp_tPolicyRefs structure, adding it
 * to the end of the given @a array.
 * 
 * @param array
 *     Array to be appended to.
 *
 * @return This function returns the newly allocated element.
 */
wsp_tPolicyRefs *
wsp_tPolicyRefs_array_push(
    wsp_tPolicyRefs_array * array);

/**
 * Serialize a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs_array
 * Serialize a wsp_tPolicyRefs structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsp_tPolicyRefs.
 * @param val
 *     The wsp_tPolicyRefs to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_tPolicyRefs_serialize(
    xsd_QName *                         element_name,
    wsp_tPolicyRefs * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs_array
 * Serialize a wsp_tPolicyRefs structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsp_tPolicyRefs to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_tPolicyRefs_serialize_contents(
    xsd_QName *                         element_name,
    wsp_tPolicyRefs * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 * Deserialize an element containing a wsp_tPolicyRefs element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_tPolicyRefs.
 * @param val
 *     Pointer to the wsp_tPolicyRefs which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_tPolicyRefs_deserialize(
    xsd_QName *                         element_name,
    wsp_tPolicyRefs * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 * Deserialize a wsp_tPolicyRefs whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsp_tPolicyRefs which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_tPolicyRefs_deserialize_contents(
    xsd_QName *                         element_name,
    wsp_tPolicyRefs * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 * Deserialize the next element if it contains a wsp_tPolicyRefs.
 *
 * @param element_name
 *     The name of the element which should enclose the wsp_tPolicyRefs.
 * @param instance
 *     Pointer to the <code>wsp_tPolicyRefs *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_tPolicyRefs_deserialize_pointer(
    xsd_QName *                         element_name,
    wsp_tPolicyRefs ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize an array of wsp_tPolicyRefs elements
 * @ingroup wsp_tPolicyRefs
 * Serialize an element containing an array of wsp_tPolicyRefs elements.
 *
 * @param element
 *     The name of the element which will contain the array.
 * @param array_instance
 *     The array to serialize
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_tPolicyRefs_array_serialize(
    xsd_QName *                         element,
    wsp_tPolicyRefs_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an array of wsp_tPolicyRefs elements
 * @ingroup wsp_tPolicyRefs
 * Deserialize an element containing an array of wsp_tPolicyRefs elements.
 *
 * @param element
 *     The name of the element which should enclose the array.
 * @param array_instance
 *     The array to deserialize into
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_tPolicyRefs_array_deserialize(
    xsd_QName *                         element,
    wsp_tPolicyRefs_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);



/**
 * Serialize an attribute of type wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs_array
 * Serialize a wsp_tPolicyRefs as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsp_tPolicyRefs.
 * @param val
 *     The wsp_tPolicyRefs to serialize.
 * @param message
 *     The handle to serialize the attribute on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsp_tPolicyRefs_serialize_attribute(
    xsd_QName *                         attr_qname,
    wsp_tPolicyRefs * val,
    globus_soap_message_handle_t        handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an attribute of type wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 * Deserialize a wsp_tPolicyRefs as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsp_tPolicyRefs.
 * @param instance
 *     Pointer to the wsp_tPolicyRefs which will be initialized with the
 *     value of the attribute.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_tPolicyRefs_deserialize_attribute(
    xsd_QName *                         attr_qname,
    wsp_tPolicyRefs * instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional attribute of type wsp_tPolicyRefs
 * @ingroup wsp_tPolicyRefs
 * Try to deserialize a wsp_tPolicyRefs as an attribute of the current element
 * if it is present. The attribute's name is defined by @ attr_qname.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wsp_tPolicyRefs.
 * @param instance
 *     Pointer to the wsp_tPolicyRefs which will be allocated and initialized
 *     with the value of the attribute if it is present.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsp_tPolicyRefs_deserialize_attribute_pointer(
    xsd_QName *                         attr_qname,
    wsp_tPolicyRefs ** instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);


#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
globus_result_t
wsp_tPolicyRefs_init_wrapper(
    void **                             object);
    
void
wsp_tPolicyRefs_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsp_tPolicyRefs_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);
    
globus_result_t
wsp_tPolicyRefs_init_contents_wrapper(
    void  *                             object);
    
void
wsp_tPolicyRefs_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsp_tPolicyRefs_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);
    
globus_result_t
wsp_tPolicyRefs_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_tPolicyRefs_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_tPolicyRefs_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_tPolicyRefs_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_tPolicyRefs_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsp_tPolicyRefs_array_init_wrapper(
    void **                             arr);
    
void
wsp_tPolicyRefs_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wsp_tPolicyRefs_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);
globus_result_t
wsp_tPolicyRefs_array_init_contents_wrapper(
    void *                              arr);
    
void
wsp_tPolicyRefs_array_destroy_contents_wrapper(
    void *                              arr);
    
globus_result_t
wsp_tPolicyRefs_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);
    
globus_result_t
wsp_tPolicyRefs_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

void *
wsp_tPolicyRefs_array_push_wrapper(
    void * array);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
