/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRL_RESOURCEUNKNOWNFAULTTYPE_H_
#define _WSRL_RESOURCEUNKNOWNFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrl_ResourceUnknownFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}ResourceUnknownFaultType element.
 * @ingroup wsrl_ResourceUnknownFaultType
 */
typedef struct wsrl_ResourceUnknownFaultType_s wsrl_ResourceUnknownFaultType;
/**
 * The wsrl_ResourceUnknownFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}ResourceUnknownFaultType element.
 * @ingroup wsrl_ResourceUnknownFaultType
 */
typedef wsrl_ResourceUnknownFaultType * wsrl_ResourceUnknownFaultType_o;

/**
 * Namespace of the wsrl_ResourceUnknownFaultType complex type
 * @ingroup wsrl_ResourceUnknownFaultType
 */
#define WSRL_RESOURCEUNKNOWNFAULTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrl_ResourceUnknownFaultType complex type
 * @ingroup wsrl_ResourceUnknownFaultType
 */
#define WSRL_RESOURCEUNKNOWNFAULTTYPE_LOCAL "ResourceUnknownFaultType"

/**
 * QName of the wsrl_ResourceUnknownFaultType complex type
 * @ingroup wsrl_ResourceUnknownFaultType
 */
extern xsd_QName wsrl_ResourceUnknownFaultType_qname;
/**
 * Type information for serializing and deserializing wsrl_ResourceUnknownFaultType elements
 * @ingroup wsrl_ResourceUnknownFaultType
 */
extern struct globus_xsd_type_info_s wsrl_ResourceUnknownFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsrl_ResourceUnknownFaultType
 * elements
 * @ingroup wsrl_ResourceUnknownFaultType
 */
extern struct globus_xsd_type_info_s wsrl_ResourceUnknownFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrl_ResourceUnknownFaultType without surrounding elements
 * @ingroup wsrl_ResourceUnknownFaultType
 */
extern struct globus_xsd_type_info_s wsrl_ResourceUnknownFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsrl_ResourceUnknownFaultType_array.h"

/**
 * @defgroup wsrl_ResourceUnknownFaultType Complex type: wsrl_ResourceUnknownFaultType
 * @ingroup types
 */

/**
 * C structure for the wsrl_ResourceUnknownFaultType complex type
 * @ingroup wsrl_ResourceUnknownFaultType
 */
struct wsrl_ResourceUnknownFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 *
 * Allocates a new wsrl_ResourceUnknownFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrl_ResourceUnknownFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_init(
    wsrl_ResourceUnknownFaultType ** inst);

/**
 * Destroy a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 *
 * Frees a wsrl_ResourceUnknownFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrl_ResourceUnknownFaultType_destroy(
    wsrl_ResourceUnknownFaultType * inst);

/**
 * Copy a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 *
 * Perform a deep copy of a wsrl_ResourceUnknownFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrl_ResourceUnknownFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrl_ResourceUnknownFaultType to be copied.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_copy(
    wsrl_ResourceUnknownFaultType ** dest,
    const wsrl_ResourceUnknownFaultType * src);

/**
 * Initialize the contents of a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 *
 * Initialize the contents of a wsrl_ResourceUnknownFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrl_ResourceUnknownFaultType_init(). The contents may be freed
 * by calling wsrl_ResourceUnknownFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrl_ResourceUnknownFaultType.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_init_contents(
    wsrl_ResourceUnknownFaultType * instance);

/**
 * Destroy the contents of a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 *
 * Destroy the subelements and attributes of the given wsrl_ResourceUnknownFaultType. 
 *
 * @param inst
 *     Pointer to a wsrl_ResourceUnknownFaultType instance to destroy.
 */
void
wsrl_ResourceUnknownFaultType_destroy_contents(
    wsrl_ResourceUnknownFaultType * inst);

/**
 * Copy the contents of a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 *
 * Perform a deep copy of the contents of a wsrl_ResourceUnknownFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrl_ResourceUnknownFaultType to be copied.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_copy_contents(
    wsrl_ResourceUnknownFaultType * dest,
    const wsrl_ResourceUnknownFaultType * src);

/**
 * Serialize a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType_array
 * Serialize a wsrl_ResourceUnknownFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrl_ResourceUnknownFaultType.
 * @param val
 *     The wsrl_ResourceUnknownFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_serialize(
    xsd_QName *                         element_name,
    wsrl_ResourceUnknownFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType_array
 * Serialize a wsrl_ResourceUnknownFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrl_ResourceUnknownFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsrl_ResourceUnknownFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 * Deserialize an element containing a wsrl_ResourceUnknownFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_ResourceUnknownFaultType.
 * @param val
 *     Pointer to the wsrl_ResourceUnknownFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_deserialize(
    xsd_QName *                         element_name,
    wsrl_ResourceUnknownFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 * Deserialize a wsrl_ResourceUnknownFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrl_ResourceUnknownFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrl_ResourceUnknownFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrl_ResourceUnknownFaultType
 * @ingroup wsrl_ResourceUnknownFaultType
 * Deserialize the next element if it contains a wsrl_ResourceUnknownFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_ResourceUnknownFaultType.
 * @param instance
 *     Pointer to the <code>wsrl_ResourceUnknownFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_ResourceUnknownFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrl_ResourceUnknownFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrl_ResourceUnknownFaultType_init_wrapper(
    void **                             object);
    
void
wsrl_ResourceUnknownFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrl_ResourceUnknownFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_ResourceUnknownFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsrl_ResourceUnknownFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrl_ResourceUnknownFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_ResourceUnknownFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_ResourceUnknownFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_ResourceUnknownFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrl_ResourceUnknownFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
