/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRL_SETTERMINATIONTIMERESPONSETYPE_H_
#define _WSRL_SETTERMINATIONTIMERESPONSETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrl_SetTerminationTimeResponseType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}complexType 15 element.
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
typedef struct wsrl_SetTerminationTimeResponseType_s wsrl_SetTerminationTimeResponseType;
/**
 * The wsrl_SetTerminationTimeResponseType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}complexType 15 element.
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
typedef wsrl_SetTerminationTimeResponseType * wsrl_SetTerminationTimeResponseType_o;

/**
 * Namespace of the wsrl_SetTerminationTimeResponseType complex type
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
#define WSRL_SETTERMINATIONTIMERESPONSETYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrl_SetTerminationTimeResponseType complex type
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
#define WSRL_SETTERMINATIONTIMERESPONSETYPE_LOCAL "SetTerminationTimeResponseType"

/**
 * QName of the wsrl_SetTerminationTimeResponseType complex type
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
extern xsd_QName wsrl_SetTerminationTimeResponseType_qname;
/**
 * Type information for serializing and deserializing wsrl_SetTerminationTimeResponseType elements
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
extern struct globus_xsd_type_info_s wsrl_SetTerminationTimeResponseType_info;
/**
 * Type information for serializing and deserializing arrays of wsrl_SetTerminationTimeResponseType
 * elements
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
extern struct globus_xsd_type_info_s wsrl_SetTerminationTimeResponseType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrl_SetTerminationTimeResponseType without surrounding elements
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
extern struct globus_xsd_type_info_s wsrl_SetTerminationTimeResponseType_contents_info;


#include "xsd_dateTime.h"
#include "xsd_dateTime.h"
#include "wsrl_SetTerminationTimeResponseType_array.h"

/**
 * @defgroup wsrl_SetTerminationTimeResponseType Complex type: wsrl_SetTerminationTimeResponseType
 * @ingroup types
 */

/**
 * C structure for the wsrl_SetTerminationTimeResponseType complex type
 * @ingroup wsrl_SetTerminationTimeResponseType
 */
struct wsrl_SetTerminationTimeResponseType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime NewTerminationTime;
    /** xsd_dateTime subelement */
    xsd_dateTime CurrentTime;

};

/**
 * Initialize a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 *
 * Allocates a new wsrl_SetTerminationTimeResponseType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrl_SetTerminationTimeResponseType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_init(
    wsrl_SetTerminationTimeResponseType ** inst);

/**
 * Destroy a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 *
 * Frees a wsrl_SetTerminationTimeResponseType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrl_SetTerminationTimeResponseType_destroy(
    wsrl_SetTerminationTimeResponseType * inst);

/**
 * Copy a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 *
 * Perform a deep copy of a wsrl_SetTerminationTimeResponseType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrl_SetTerminationTimeResponseType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrl_SetTerminationTimeResponseType to be copied.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_copy(
    wsrl_SetTerminationTimeResponseType ** dest,
    const wsrl_SetTerminationTimeResponseType * src);

/**
 * Initialize the contents of a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 *
 * Initialize the contents of a wsrl_SetTerminationTimeResponseType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrl_SetTerminationTimeResponseType_init(). The contents may be freed
 * by calling wsrl_SetTerminationTimeResponseType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrl_SetTerminationTimeResponseType.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_init_contents(
    wsrl_SetTerminationTimeResponseType * instance);

/**
 * Destroy the contents of a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 *
 * Destroy the subelements and attributes of the given wsrl_SetTerminationTimeResponseType. 
 *
 * @param inst
 *     Pointer to a wsrl_SetTerminationTimeResponseType instance to destroy.
 */
void
wsrl_SetTerminationTimeResponseType_destroy_contents(
    wsrl_SetTerminationTimeResponseType * inst);

/**
 * Copy the contents of a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 *
 * Perform a deep copy of the contents of a wsrl_SetTerminationTimeResponseType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrl_SetTerminationTimeResponseType to be copied.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_copy_contents(
    wsrl_SetTerminationTimeResponseType * dest,
    const wsrl_SetTerminationTimeResponseType * src);

/**
 * Serialize a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType_array
 * Serialize a wsrl_SetTerminationTimeResponseType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrl_SetTerminationTimeResponseType.
 * @param val
 *     The wsrl_SetTerminationTimeResponseType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_serialize(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType_array
 * Serialize a wsrl_SetTerminationTimeResponseType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrl_SetTerminationTimeResponseType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_serialize_contents(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 * Deserialize an element containing a wsrl_SetTerminationTimeResponseType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_SetTerminationTimeResponseType.
 * @param val
 *     Pointer to the wsrl_SetTerminationTimeResponseType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_deserialize(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 * Deserialize a wsrl_SetTerminationTimeResponseType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrl_SetTerminationTimeResponseType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrl_SetTerminationTimeResponseType
 * @ingroup wsrl_SetTerminationTimeResponseType
 * Deserialize the next element if it contains a wsrl_SetTerminationTimeResponseType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_SetTerminationTimeResponseType.
 * @param instance
 *     Pointer to the <code>wsrl_SetTerminationTimeResponseType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_SetTerminationTimeResponseType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeResponseType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrl_SetTerminationTimeResponseType_init_wrapper(
    void **                             object);
    
void
wsrl_SetTerminationTimeResponseType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrl_SetTerminationTimeResponseType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_SetTerminationTimeResponseType_init_contents_wrapper(
    void *                              object);
    
void
wsrl_SetTerminationTimeResponseType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrl_SetTerminationTimeResponseType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_SetTerminationTimeResponseType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_SetTerminationTimeResponseType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_SetTerminationTimeResponseType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrl_SetTerminationTimeResponseType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
