/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRL_SETTERMINATIONTIMETYPE_H_
#define _WSRL_SETTERMINATIONTIMETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrl_SetTerminationTimeType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}complexType 13 element.
 * @ingroup wsrl_SetTerminationTimeType
 */
typedef struct wsrl_SetTerminationTimeType_s wsrl_SetTerminationTimeType;
/**
 * The wsrl_SetTerminationTimeType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}complexType 13 element.
 * @ingroup wsrl_SetTerminationTimeType
 */
typedef wsrl_SetTerminationTimeType * wsrl_SetTerminationTimeType_o;

/**
 * Namespace of the wsrl_SetTerminationTimeType complex type
 * @ingroup wsrl_SetTerminationTimeType
 */
#define WSRL_SETTERMINATIONTIMETYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrl_SetTerminationTimeType complex type
 * @ingroup wsrl_SetTerminationTimeType
 */
#define WSRL_SETTERMINATIONTIMETYPE_LOCAL "SetTerminationTimeType"

/**
 * QName of the wsrl_SetTerminationTimeType complex type
 * @ingroup wsrl_SetTerminationTimeType
 */
extern xsd_QName wsrl_SetTerminationTimeType_qname;
/**
 * Type information for serializing and deserializing wsrl_SetTerminationTimeType elements
 * @ingroup wsrl_SetTerminationTimeType
 */
extern struct globus_xsd_type_info_s wsrl_SetTerminationTimeType_info;
/**
 * Type information for serializing and deserializing arrays of wsrl_SetTerminationTimeType
 * elements
 * @ingroup wsrl_SetTerminationTimeType
 */
extern struct globus_xsd_type_info_s wsrl_SetTerminationTimeType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrl_SetTerminationTimeType without surrounding elements
 * @ingroup wsrl_SetTerminationTimeType
 */
extern struct globus_xsd_type_info_s wsrl_SetTerminationTimeType_contents_info;


#include "xsd_dateTime.h"
#include "wsrl_SetTerminationTimeType_array.h"

/**
 * @defgroup wsrl_SetTerminationTimeType Complex type: wsrl_SetTerminationTimeType
 * @ingroup types
 */

/**
 * C structure for the wsrl_SetTerminationTimeType complex type
 * @ingroup wsrl_SetTerminationTimeType
 */
struct wsrl_SetTerminationTimeType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime RequestedTerminationTime;

};

/**
 * Initialize a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 *
 * Allocates a new wsrl_SetTerminationTimeType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrl_SetTerminationTimeType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrl_SetTerminationTimeType_init(
    wsrl_SetTerminationTimeType ** inst);

/**
 * Destroy a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 *
 * Frees a wsrl_SetTerminationTimeType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrl_SetTerminationTimeType_destroy(
    wsrl_SetTerminationTimeType * inst);

/**
 * Copy a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 *
 * Perform a deep copy of a wsrl_SetTerminationTimeType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrl_SetTerminationTimeType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrl_SetTerminationTimeType to be copied.
 */
globus_result_t
wsrl_SetTerminationTimeType_copy(
    wsrl_SetTerminationTimeType ** dest,
    const wsrl_SetTerminationTimeType * src);

/**
 * Initialize the contents of a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 *
 * Initialize the contents of a wsrl_SetTerminationTimeType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrl_SetTerminationTimeType_init(). The contents may be freed
 * by calling wsrl_SetTerminationTimeType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrl_SetTerminationTimeType.
 */
globus_result_t
wsrl_SetTerminationTimeType_init_contents(
    wsrl_SetTerminationTimeType * instance);

/**
 * Destroy the contents of a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 *
 * Destroy the subelements and attributes of the given wsrl_SetTerminationTimeType. 
 *
 * @param inst
 *     Pointer to a wsrl_SetTerminationTimeType instance to destroy.
 */
void
wsrl_SetTerminationTimeType_destroy_contents(
    wsrl_SetTerminationTimeType * inst);

/**
 * Copy the contents of a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 *
 * Perform a deep copy of the contents of a wsrl_SetTerminationTimeType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrl_SetTerminationTimeType to be copied.
 */
globus_result_t
wsrl_SetTerminationTimeType_copy_contents(
    wsrl_SetTerminationTimeType * dest,
    const wsrl_SetTerminationTimeType * src);

/**
 * Serialize a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType_array
 * Serialize a wsrl_SetTerminationTimeType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrl_SetTerminationTimeType.
 * @param val
 *     The wsrl_SetTerminationTimeType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_SetTerminationTimeType_serialize(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType_array
 * Serialize a wsrl_SetTerminationTimeType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrl_SetTerminationTimeType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_SetTerminationTimeType_serialize_contents(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 * Deserialize an element containing a wsrl_SetTerminationTimeType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_SetTerminationTimeType.
 * @param val
 *     Pointer to the wsrl_SetTerminationTimeType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_SetTerminationTimeType_deserialize(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 * Deserialize a wsrl_SetTerminationTimeType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrl_SetTerminationTimeType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_SetTerminationTimeType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrl_SetTerminationTimeType
 * @ingroup wsrl_SetTerminationTimeType
 * Deserialize the next element if it contains a wsrl_SetTerminationTimeType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_SetTerminationTimeType.
 * @param instance
 *     Pointer to the <code>wsrl_SetTerminationTimeType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_SetTerminationTimeType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrl_SetTerminationTimeType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrl_SetTerminationTimeType_init_wrapper(
    void **                             object);
    
void
wsrl_SetTerminationTimeType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrl_SetTerminationTimeType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_SetTerminationTimeType_init_contents_wrapper(
    void *                              object);
    
void
wsrl_SetTerminationTimeType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrl_SetTerminationTimeType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_SetTerminationTimeType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_SetTerminationTimeType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_SetTerminationTimeType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrl_SetTerminationTimeType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
