/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRL_TERMINATIONNOTIFICATIONTYPE_H_
#define _WSRL_TERMINATIONNOTIFICATIONTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrl_TerminationNotificationType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}complexType 1 element.
 * @ingroup wsrl_TerminationNotificationType
 */
typedef struct wsrl_TerminationNotificationType_s wsrl_TerminationNotificationType;
/**
 * The wsrl_TerminationNotificationType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd}complexType 1 element.
 * @ingroup wsrl_TerminationNotificationType
 */
typedef wsrl_TerminationNotificationType * wsrl_TerminationNotificationType_o;

/**
 * Namespace of the wsrl_TerminationNotificationType complex type
 * @ingroup wsrl_TerminationNotificationType
 */
#define WSRL_TERMINATIONNOTIFICATIONTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrl_TerminationNotificationType complex type
 * @ingroup wsrl_TerminationNotificationType
 */
#define WSRL_TERMINATIONNOTIFICATIONTYPE_LOCAL "TerminationNotificationType"

/**
 * QName of the wsrl_TerminationNotificationType complex type
 * @ingroup wsrl_TerminationNotificationType
 */
extern xsd_QName wsrl_TerminationNotificationType_qname;
/**
 * Type information for serializing and deserializing wsrl_TerminationNotificationType elements
 * @ingroup wsrl_TerminationNotificationType
 */
extern struct globus_xsd_type_info_s wsrl_TerminationNotificationType_info;
/**
 * Type information for serializing and deserializing arrays of wsrl_TerminationNotificationType
 * elements
 * @ingroup wsrl_TerminationNotificationType
 */
extern struct globus_xsd_type_info_s wsrl_TerminationNotificationType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrl_TerminationNotificationType without surrounding elements
 * @ingroup wsrl_TerminationNotificationType
 */
extern struct globus_xsd_type_info_s wsrl_TerminationNotificationType_contents_info;


#include "xsd_dateTime.h"
#include "xsd_anyType.h"
#include "wsrl_TerminationNotificationType_array.h"

/**
 * @defgroup wsrl_TerminationNotificationType Complex type: wsrl_TerminationNotificationType
 * @ingroup types
 */

/**
 * C structure for the wsrl_TerminationNotificationType complex type
 * @ingroup wsrl_TerminationNotificationType
 */
struct wsrl_TerminationNotificationType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime TerminationTime;
   /** Optional xsd_anyType subelement */
    xsd_anyType_o TerminationReason;

};

/**
 * Initialize a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 *
 * Allocates a new wsrl_TerminationNotificationType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrl_TerminationNotificationType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrl_TerminationNotificationType_init(
    wsrl_TerminationNotificationType ** inst);

/**
 * Destroy a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 *
 * Frees a wsrl_TerminationNotificationType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrl_TerminationNotificationType_destroy(
    wsrl_TerminationNotificationType * inst);

/**
 * Copy a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 *
 * Perform a deep copy of a wsrl_TerminationNotificationType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrl_TerminationNotificationType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrl_TerminationNotificationType to be copied.
 */
globus_result_t
wsrl_TerminationNotificationType_copy(
    wsrl_TerminationNotificationType ** dest,
    const wsrl_TerminationNotificationType * src);

/**
 * Initialize the contents of a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 *
 * Initialize the contents of a wsrl_TerminationNotificationType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrl_TerminationNotificationType_init(). The contents may be freed
 * by calling wsrl_TerminationNotificationType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrl_TerminationNotificationType.
 */
globus_result_t
wsrl_TerminationNotificationType_init_contents(
    wsrl_TerminationNotificationType * instance);

/**
 * Destroy the contents of a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 *
 * Destroy the subelements and attributes of the given wsrl_TerminationNotificationType. 
 *
 * @param inst
 *     Pointer to a wsrl_TerminationNotificationType instance to destroy.
 */
void
wsrl_TerminationNotificationType_destroy_contents(
    wsrl_TerminationNotificationType * inst);

/**
 * Copy the contents of a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 *
 * Perform a deep copy of the contents of a wsrl_TerminationNotificationType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrl_TerminationNotificationType to be copied.
 */
globus_result_t
wsrl_TerminationNotificationType_copy_contents(
    wsrl_TerminationNotificationType * dest,
    const wsrl_TerminationNotificationType * src);

/**
 * Serialize a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType_array
 * Serialize a wsrl_TerminationNotificationType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrl_TerminationNotificationType.
 * @param val
 *     The wsrl_TerminationNotificationType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_TerminationNotificationType_serialize(
    xsd_QName *                         element_name,
    wsrl_TerminationNotificationType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType_array
 * Serialize a wsrl_TerminationNotificationType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrl_TerminationNotificationType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrl_TerminationNotificationType_serialize_contents(
    xsd_QName *                         element_name,
    wsrl_TerminationNotificationType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 * Deserialize an element containing a wsrl_TerminationNotificationType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_TerminationNotificationType.
 * @param val
 *     Pointer to the wsrl_TerminationNotificationType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_TerminationNotificationType_deserialize(
    xsd_QName *                         element_name,
    wsrl_TerminationNotificationType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 * Deserialize a wsrl_TerminationNotificationType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrl_TerminationNotificationType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_TerminationNotificationType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrl_TerminationNotificationType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrl_TerminationNotificationType
 * @ingroup wsrl_TerminationNotificationType
 * Deserialize the next element if it contains a wsrl_TerminationNotificationType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrl_TerminationNotificationType.
 * @param instance
 *     Pointer to the <code>wsrl_TerminationNotificationType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrl_TerminationNotificationType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrl_TerminationNotificationType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrl_TerminationNotificationType_init_wrapper(
    void **                             object);
    
void
wsrl_TerminationNotificationType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrl_TerminationNotificationType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_TerminationNotificationType_init_contents_wrapper(
    void *                              object);
    
void
wsrl_TerminationNotificationType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrl_TerminationNotificationType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrl_TerminationNotificationType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_TerminationNotificationType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrl_TerminationNotificationType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrl_TerminationNotificationType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
