/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_DELETETYPE_H_
#define _WSRP_DELETETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_DeleteType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}DeleteType element.
 * @ingroup wsrp_DeleteType
 */
typedef struct wsrp_DeleteType_s wsrp_DeleteType;
/**
 * The wsrp_DeleteType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}DeleteType element.
 * @ingroup wsrp_DeleteType
 */
typedef wsrp_DeleteType * wsrp_DeleteType_o;

/**
 * Namespace of the wsrp_DeleteType complex type
 * @ingroup wsrp_DeleteType
 */
#define WSRP_DELETETYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_DeleteType complex type
 * @ingroup wsrp_DeleteType
 */
#define WSRP_DELETETYPE_LOCAL "DeleteType"

/**
 * QName of the wsrp_DeleteType complex type
 * @ingroup wsrp_DeleteType
 */
extern xsd_QName wsrp_DeleteType_qname;
/**
 * Type information for serializing and deserializing wsrp_DeleteType elements
 * @ingroup wsrp_DeleteType
 */
extern struct globus_xsd_type_info_s wsrp_DeleteType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_DeleteType
 * elements
 * @ingroup wsrp_DeleteType
 */
extern struct globus_xsd_type_info_s wsrp_DeleteType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_DeleteType without surrounding elements
 * @ingroup wsrp_DeleteType
 */
extern struct globus_xsd_type_info_s wsrp_DeleteType_contents_info;


#include "xsd_QName.h"
#include "wsrp_DeleteType_array.h"

/**
 * @defgroup wsrp_DeleteType Complex type: wsrp_DeleteType
 * @ingroup types
 */

/**
 * C structure for the wsrp_DeleteType complex type
 * @ingroup wsrp_DeleteType
 */
struct wsrp_DeleteType_s
{
    xsd_QName _ResourceProperty;

};

/**
 * Initialize a wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 *
 * Allocates a new wsrp_DeleteType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_DeleteType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_DeleteType_init(
    wsrp_DeleteType ** inst);

/**
 * Destroy a wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 *
 * Frees a wsrp_DeleteType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_DeleteType_destroy(
    wsrp_DeleteType * inst);

/**
 * Copy a wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 *
 * Perform a deep copy of a wsrp_DeleteType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_DeleteType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_DeleteType to be copied.
 */
globus_result_t
wsrp_DeleteType_copy(
    wsrp_DeleteType ** dest,
    const wsrp_DeleteType * src);

/**
 * Initialize the contents of a wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 *
 * Initialize the contents of a wsrp_DeleteType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_DeleteType_init(). The contents may be freed
 * by calling wsrp_DeleteType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_DeleteType.
 */
globus_result_t
wsrp_DeleteType_init_contents(
    wsrp_DeleteType * instance);

/**
 * Destroy the contents of a wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 *
 * Destroy the subelements and attributes of the given wsrp_DeleteType. 
 *
 * @param inst
 *     Pointer to a wsrp_DeleteType instance to destroy.
 */
void
wsrp_DeleteType_destroy_contents(
    wsrp_DeleteType * inst);

/**
 * Copy the contents of a wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 *
 * Perform a deep copy of the contents of a wsrp_DeleteType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_DeleteType to be copied.
 */
globus_result_t
wsrp_DeleteType_copy_contents(
    wsrp_DeleteType * dest,
    const wsrp_DeleteType * src);

/**
 * Serialize a wsrp_DeleteType
 * @ingroup wsrp_DeleteType_array
 * Serialize a wsrp_DeleteType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_DeleteType.
 * @param val
 *     The wsrp_DeleteType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_DeleteType_serialize(
    xsd_QName *                         element_name,
    wsrp_DeleteType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_DeleteType
 * @ingroup wsrp_DeleteType_array
 * Serialize a wsrp_DeleteType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_DeleteType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_DeleteType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_DeleteType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 * Deserialize an element containing a wsrp_DeleteType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_DeleteType.
 * @param val
 *     Pointer to the wsrp_DeleteType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_DeleteType_deserialize(
    xsd_QName *                         element_name,
    wsrp_DeleteType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 * Deserialize a wsrp_DeleteType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_DeleteType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_DeleteType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_DeleteType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_DeleteType
 * @ingroup wsrp_DeleteType
 * Deserialize the next element if it contains a wsrp_DeleteType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_DeleteType.
 * @param instance
 *     Pointer to the <code>wsrp_DeleteType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_DeleteType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_DeleteType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_DeleteType_init_wrapper(
    void **                             object);
    
void
wsrp_DeleteType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_DeleteType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_DeleteType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_DeleteType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_DeleteType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_DeleteType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_DeleteType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_DeleteType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_DeleteType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
