/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_INSERTTYPE_H_
#define _WSRP_INSERTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_InsertType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}InsertType element.
 * @ingroup wsrp_InsertType
 */
typedef struct wsrp_InsertType_s wsrp_InsertType;
/**
 * The wsrp_InsertType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}InsertType element.
 * @ingroup wsrp_InsertType
 */
typedef wsrp_InsertType * wsrp_InsertType_o;

/**
 * Namespace of the wsrp_InsertType complex type
 * @ingroup wsrp_InsertType
 */
#define WSRP_INSERTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_InsertType complex type
 * @ingroup wsrp_InsertType
 */
#define WSRP_INSERTTYPE_LOCAL "InsertType"

/**
 * QName of the wsrp_InsertType complex type
 * @ingroup wsrp_InsertType
 */
extern xsd_QName wsrp_InsertType_qname;
/**
 * Type information for serializing and deserializing wsrp_InsertType elements
 * @ingroup wsrp_InsertType
 */
extern struct globus_xsd_type_info_s wsrp_InsertType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_InsertType
 * elements
 * @ingroup wsrp_InsertType
 */
extern struct globus_xsd_type_info_s wsrp_InsertType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_InsertType without surrounding elements
 * @ingroup wsrp_InsertType
 */
extern struct globus_xsd_type_info_s wsrp_InsertType_contents_info;


#include "xsd_any.h"
#include "wsrp_InsertType_array.h"

/**
 * @defgroup wsrp_InsertType Complex type: wsrp_InsertType
 * @ingroup types
 */

/**
 * C structure for the wsrp_InsertType complex type
 * @ingroup wsrp_InsertType
 */
struct wsrp_InsertType_s
{
   /** Array of [1 .. Infinity] xsd_any elements */
    xsd_any_array any;

};

/**
 * Initialize a wsrp_InsertType
 * @ingroup wsrp_InsertType
 *
 * Allocates a new wsrp_InsertType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_InsertType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_InsertType_init(
    wsrp_InsertType ** inst);

/**
 * Destroy a wsrp_InsertType
 * @ingroup wsrp_InsertType
 *
 * Frees a wsrp_InsertType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_InsertType_destroy(
    wsrp_InsertType * inst);

/**
 * Copy a wsrp_InsertType
 * @ingroup wsrp_InsertType
 *
 * Perform a deep copy of a wsrp_InsertType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_InsertType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_InsertType to be copied.
 */
globus_result_t
wsrp_InsertType_copy(
    wsrp_InsertType ** dest,
    const wsrp_InsertType * src);

/**
 * Initialize the contents of a wsrp_InsertType
 * @ingroup wsrp_InsertType
 *
 * Initialize the contents of a wsrp_InsertType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_InsertType_init(). The contents may be freed
 * by calling wsrp_InsertType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_InsertType.
 */
globus_result_t
wsrp_InsertType_init_contents(
    wsrp_InsertType * instance);

/**
 * Destroy the contents of a wsrp_InsertType
 * @ingroup wsrp_InsertType
 *
 * Destroy the subelements and attributes of the given wsrp_InsertType. 
 *
 * @param inst
 *     Pointer to a wsrp_InsertType instance to destroy.
 */
void
wsrp_InsertType_destroy_contents(
    wsrp_InsertType * inst);

/**
 * Copy the contents of a wsrp_InsertType
 * @ingroup wsrp_InsertType
 *
 * Perform a deep copy of the contents of a wsrp_InsertType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_InsertType to be copied.
 */
globus_result_t
wsrp_InsertType_copy_contents(
    wsrp_InsertType * dest,
    const wsrp_InsertType * src);

/**
 * Serialize a wsrp_InsertType
 * @ingroup wsrp_InsertType_array
 * Serialize a wsrp_InsertType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_InsertType.
 * @param val
 *     The wsrp_InsertType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_InsertType_serialize(
    xsd_QName *                         element_name,
    wsrp_InsertType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_InsertType
 * @ingroup wsrp_InsertType_array
 * Serialize a wsrp_InsertType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_InsertType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_InsertType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_InsertType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_InsertType
 * @ingroup wsrp_InsertType
 * Deserialize an element containing a wsrp_InsertType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_InsertType.
 * @param val
 *     Pointer to the wsrp_InsertType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InsertType_deserialize(
    xsd_QName *                         element_name,
    wsrp_InsertType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_InsertType
 * @ingroup wsrp_InsertType
 * Deserialize a wsrp_InsertType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_InsertType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InsertType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_InsertType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_InsertType
 * @ingroup wsrp_InsertType
 * Deserialize the next element if it contains a wsrp_InsertType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_InsertType.
 * @param instance
 *     Pointer to the <code>wsrp_InsertType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InsertType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_InsertType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_InsertType_init_wrapper(
    void **                             object);
    
void
wsrp_InsertType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_InsertType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_InsertType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_InsertType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_InsertType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_InsertType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_InsertType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_InsertType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_InsertType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
