/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_INVALIDQUERYEXPRESSIONFAULTTYPE_H_
#define _WSRP_INVALIDQUERYEXPRESSIONFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_InvalidQueryExpressionFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}InvalidQueryExpressionFaultType element.
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
typedef struct wsrp_InvalidQueryExpressionFaultType_s wsrp_InvalidQueryExpressionFaultType;
/**
 * The wsrp_InvalidQueryExpressionFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}InvalidQueryExpressionFaultType element.
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
typedef wsrp_InvalidQueryExpressionFaultType * wsrp_InvalidQueryExpressionFaultType_o;

/**
 * Namespace of the wsrp_InvalidQueryExpressionFaultType complex type
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
#define WSRP_INVALIDQUERYEXPRESSIONFAULTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_InvalidQueryExpressionFaultType complex type
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
#define WSRP_INVALIDQUERYEXPRESSIONFAULTTYPE_LOCAL "InvalidQueryExpressionFaultType"

/**
 * QName of the wsrp_InvalidQueryExpressionFaultType complex type
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
extern xsd_QName wsrp_InvalidQueryExpressionFaultType_qname;
/**
 * Type information for serializing and deserializing wsrp_InvalidQueryExpressionFaultType elements
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
extern struct globus_xsd_type_info_s wsrp_InvalidQueryExpressionFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_InvalidQueryExpressionFaultType
 * elements
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
extern struct globus_xsd_type_info_s wsrp_InvalidQueryExpressionFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_InvalidQueryExpressionFaultType without surrounding elements
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
extern struct globus_xsd_type_info_s wsrp_InvalidQueryExpressionFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsrp_InvalidQueryExpressionFaultType_array.h"

/**
 * @defgroup wsrp_InvalidQueryExpressionFaultType Complex type: wsrp_InvalidQueryExpressionFaultType
 * @ingroup types
 */

/**
 * C structure for the wsrp_InvalidQueryExpressionFaultType complex type
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 */
struct wsrp_InvalidQueryExpressionFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 *
 * Allocates a new wsrp_InvalidQueryExpressionFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_InvalidQueryExpressionFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_init(
    wsrp_InvalidQueryExpressionFaultType ** inst);

/**
 * Destroy a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 *
 * Frees a wsrp_InvalidQueryExpressionFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_InvalidQueryExpressionFaultType_destroy(
    wsrp_InvalidQueryExpressionFaultType * inst);

/**
 * Copy a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 *
 * Perform a deep copy of a wsrp_InvalidQueryExpressionFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_InvalidQueryExpressionFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_InvalidQueryExpressionFaultType to be copied.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_copy(
    wsrp_InvalidQueryExpressionFaultType ** dest,
    const wsrp_InvalidQueryExpressionFaultType * src);

/**
 * Initialize the contents of a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 *
 * Initialize the contents of a wsrp_InvalidQueryExpressionFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_InvalidQueryExpressionFaultType_init(). The contents may be freed
 * by calling wsrp_InvalidQueryExpressionFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_InvalidQueryExpressionFaultType.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_init_contents(
    wsrp_InvalidQueryExpressionFaultType * instance);

/**
 * Destroy the contents of a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 *
 * Destroy the subelements and attributes of the given wsrp_InvalidQueryExpressionFaultType. 
 *
 * @param inst
 *     Pointer to a wsrp_InvalidQueryExpressionFaultType instance to destroy.
 */
void
wsrp_InvalidQueryExpressionFaultType_destroy_contents(
    wsrp_InvalidQueryExpressionFaultType * inst);

/**
 * Copy the contents of a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 *
 * Perform a deep copy of the contents of a wsrp_InvalidQueryExpressionFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_InvalidQueryExpressionFaultType to be copied.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_copy_contents(
    wsrp_InvalidQueryExpressionFaultType * dest,
    const wsrp_InvalidQueryExpressionFaultType * src);

/**
 * Serialize a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType_array
 * Serialize a wsrp_InvalidQueryExpressionFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_InvalidQueryExpressionFaultType.
 * @param val
 *     The wsrp_InvalidQueryExpressionFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_serialize(
    xsd_QName *                         element_name,
    wsrp_InvalidQueryExpressionFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType_array
 * Serialize a wsrp_InvalidQueryExpressionFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_InvalidQueryExpressionFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_InvalidQueryExpressionFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 * Deserialize an element containing a wsrp_InvalidQueryExpressionFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_InvalidQueryExpressionFaultType.
 * @param val
 *     Pointer to the wsrp_InvalidQueryExpressionFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_deserialize(
    xsd_QName *                         element_name,
    wsrp_InvalidQueryExpressionFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 * Deserialize a wsrp_InvalidQueryExpressionFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_InvalidQueryExpressionFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_InvalidQueryExpressionFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_InvalidQueryExpressionFaultType
 * @ingroup wsrp_InvalidQueryExpressionFaultType
 * Deserialize the next element if it contains a wsrp_InvalidQueryExpressionFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_InvalidQueryExpressionFaultType.
 * @param instance
 *     Pointer to the <code>wsrp_InvalidQueryExpressionFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_InvalidQueryExpressionFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_InvalidQueryExpressionFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_InvalidQueryExpressionFaultType_init_wrapper(
    void **                             object);
    
void
wsrp_InvalidQueryExpressionFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_InvalidQueryExpressionFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_InvalidQueryExpressionFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_InvalidQueryExpressionFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_InvalidQueryExpressionFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_InvalidQueryExpressionFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_InvalidQueryExpressionFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_InvalidQueryExpressionFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_InvalidQueryExpressionFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
