/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_NEWVALUETYPE_H_
#define _WSRP_NEWVALUETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_NewValueType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}complexType 5 element.
 * @ingroup wsrp_NewValueType
 */
typedef struct wsrp_NewValueType_s wsrp_NewValueType;
/**
 * The wsrp_NewValueType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}complexType 5 element.
 * @ingroup wsrp_NewValueType
 */
typedef wsrp_NewValueType * wsrp_NewValueType_o;

/**
 * Namespace of the wsrp_NewValueType complex type
 * @ingroup wsrp_NewValueType
 */
#define WSRP_NEWVALUETYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_NewValueType complex type
 * @ingroup wsrp_NewValueType
 */
#define WSRP_NEWVALUETYPE_LOCAL "NewValueType"

/**
 * QName of the wsrp_NewValueType complex type
 * @ingroup wsrp_NewValueType
 */
extern xsd_QName wsrp_NewValueType_qname;
/**
 * Type information for serializing and deserializing wsrp_NewValueType elements
 * @ingroup wsrp_NewValueType
 */
extern struct globus_xsd_type_info_s wsrp_NewValueType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_NewValueType
 * elements
 * @ingroup wsrp_NewValueType
 */
extern struct globus_xsd_type_info_s wsrp_NewValueType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_NewValueType without surrounding elements
 * @ingroup wsrp_NewValueType
 */
extern struct globus_xsd_type_info_s wsrp_NewValueType_contents_info;


#include "xsd_any.h"
#include "wsrp_NewValueType_array.h"

/**
 * @defgroup wsrp_NewValueType Complex type: wsrp_NewValueType
 * @ingroup types
 */

/**
 * C structure for the wsrp_NewValueType complex type
 * @ingroup wsrp_NewValueType
 */
struct wsrp_NewValueType_s
{
    /** xsd_any subelement */
    xsd_any any;

};

/**
 * Initialize a wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 *
 * Allocates a new wsrp_NewValueType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_NewValueType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_NewValueType_init(
    wsrp_NewValueType ** inst);

/**
 * Destroy a wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 *
 * Frees a wsrp_NewValueType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_NewValueType_destroy(
    wsrp_NewValueType * inst);

/**
 * Copy a wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 *
 * Perform a deep copy of a wsrp_NewValueType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_NewValueType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_NewValueType to be copied.
 */
globus_result_t
wsrp_NewValueType_copy(
    wsrp_NewValueType ** dest,
    const wsrp_NewValueType * src);

/**
 * Initialize the contents of a wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 *
 * Initialize the contents of a wsrp_NewValueType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_NewValueType_init(). The contents may be freed
 * by calling wsrp_NewValueType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_NewValueType.
 */
globus_result_t
wsrp_NewValueType_init_contents(
    wsrp_NewValueType * instance);

/**
 * Destroy the contents of a wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 *
 * Destroy the subelements and attributes of the given wsrp_NewValueType. 
 *
 * @param inst
 *     Pointer to a wsrp_NewValueType instance to destroy.
 */
void
wsrp_NewValueType_destroy_contents(
    wsrp_NewValueType * inst);

/**
 * Copy the contents of a wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 *
 * Perform a deep copy of the contents of a wsrp_NewValueType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_NewValueType to be copied.
 */
globus_result_t
wsrp_NewValueType_copy_contents(
    wsrp_NewValueType * dest,
    const wsrp_NewValueType * src);

/**
 * Serialize a wsrp_NewValueType
 * @ingroup wsrp_NewValueType_array
 * Serialize a wsrp_NewValueType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_NewValueType.
 * @param val
 *     The wsrp_NewValueType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_NewValueType_serialize(
    xsd_QName *                         element_name,
    wsrp_NewValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_NewValueType
 * @ingroup wsrp_NewValueType_array
 * Serialize a wsrp_NewValueType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_NewValueType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_NewValueType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_NewValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 * Deserialize an element containing a wsrp_NewValueType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_NewValueType.
 * @param val
 *     Pointer to the wsrp_NewValueType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_NewValueType_deserialize(
    xsd_QName *                         element_name,
    wsrp_NewValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 * Deserialize a wsrp_NewValueType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_NewValueType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_NewValueType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_NewValueType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_NewValueType
 * @ingroup wsrp_NewValueType
 * Deserialize the next element if it contains a wsrp_NewValueType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_NewValueType.
 * @param instance
 *     Pointer to the <code>wsrp_NewValueType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_NewValueType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_NewValueType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_NewValueType_init_wrapper(
    void **                             object);
    
void
wsrp_NewValueType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_NewValueType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_NewValueType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_NewValueType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_NewValueType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_NewValueType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_NewValueType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_NewValueType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_NewValueType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
