/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_QUERYEXPRESSIONTYPE_H_
#define _WSRP_QUERYEXPRESSIONTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_QueryExpressionType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}QueryExpressionType element.
 * @ingroup wsrp_QueryExpressionType
 */
typedef struct wsrp_QueryExpressionType_s wsrp_QueryExpressionType;
/**
 * The wsrp_QueryExpressionType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}QueryExpressionType element.
 * @ingroup wsrp_QueryExpressionType
 */
typedef wsrp_QueryExpressionType * wsrp_QueryExpressionType_o;

/**
 * Namespace of the wsrp_QueryExpressionType complex type
 * @ingroup wsrp_QueryExpressionType
 */
#define WSRP_QUERYEXPRESSIONTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_QueryExpressionType complex type
 * @ingroup wsrp_QueryExpressionType
 */
#define WSRP_QUERYEXPRESSIONTYPE_LOCAL "QueryExpressionType"

/**
 * QName of the wsrp_QueryExpressionType complex type
 * @ingroup wsrp_QueryExpressionType
 */
extern xsd_QName wsrp_QueryExpressionType_qname;
/**
 * Type information for serializing and deserializing wsrp_QueryExpressionType elements
 * @ingroup wsrp_QueryExpressionType
 */
extern struct globus_xsd_type_info_s wsrp_QueryExpressionType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_QueryExpressionType
 * elements
 * @ingroup wsrp_QueryExpressionType
 */
extern struct globus_xsd_type_info_s wsrp_QueryExpressionType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_QueryExpressionType without surrounding elements
 * @ingroup wsrp_QueryExpressionType
 */
extern struct globus_xsd_type_info_s wsrp_QueryExpressionType_contents_info;


#include "xsd_any.h"
#include "xsd_anyURI.h"
#include "wsrp_QueryExpressionType_array.h"

/**
 * @defgroup wsrp_QueryExpressionType Complex type: wsrp_QueryExpressionType
 * @ingroup types
 */

/**
 * C structure for the wsrp_QueryExpressionType complex type
 * @ingroup wsrp_QueryExpressionType
 */
struct wsrp_QueryExpressionType_s
{
   /** Optional xsd_any subelement */
    xsd_any_o any;
    xsd_anyURI_o _Dialect;

};

/**
 * Initialize a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 *
 * Allocates a new wsrp_QueryExpressionType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_QueryExpressionType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_QueryExpressionType_init(
    wsrp_QueryExpressionType ** inst);

/**
 * Destroy a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 *
 * Frees a wsrp_QueryExpressionType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_QueryExpressionType_destroy(
    wsrp_QueryExpressionType * inst);

/**
 * Copy a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 *
 * Perform a deep copy of a wsrp_QueryExpressionType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_QueryExpressionType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_QueryExpressionType to be copied.
 */
globus_result_t
wsrp_QueryExpressionType_copy(
    wsrp_QueryExpressionType ** dest,
    const wsrp_QueryExpressionType * src);

/**
 * Initialize the contents of a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 *
 * Initialize the contents of a wsrp_QueryExpressionType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_QueryExpressionType_init(). The contents may be freed
 * by calling wsrp_QueryExpressionType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_QueryExpressionType.
 */
globus_result_t
wsrp_QueryExpressionType_init_contents(
    wsrp_QueryExpressionType * instance);

/**
 * Destroy the contents of a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 *
 * Destroy the subelements and attributes of the given wsrp_QueryExpressionType. 
 *
 * @param inst
 *     Pointer to a wsrp_QueryExpressionType instance to destroy.
 */
void
wsrp_QueryExpressionType_destroy_contents(
    wsrp_QueryExpressionType * inst);

/**
 * Copy the contents of a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 *
 * Perform a deep copy of the contents of a wsrp_QueryExpressionType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_QueryExpressionType to be copied.
 */
globus_result_t
wsrp_QueryExpressionType_copy_contents(
    wsrp_QueryExpressionType * dest,
    const wsrp_QueryExpressionType * src);

/**
 * Serialize a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType_array
 * Serialize a wsrp_QueryExpressionType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_QueryExpressionType.
 * @param val
 *     The wsrp_QueryExpressionType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_QueryExpressionType_serialize(
    xsd_QName *                         element_name,
    wsrp_QueryExpressionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType_array
 * Serialize a wsrp_QueryExpressionType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_QueryExpressionType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_QueryExpressionType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_QueryExpressionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 * Deserialize an element containing a wsrp_QueryExpressionType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_QueryExpressionType.
 * @param val
 *     Pointer to the wsrp_QueryExpressionType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_QueryExpressionType_deserialize(
    xsd_QName *                         element_name,
    wsrp_QueryExpressionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 * Deserialize a wsrp_QueryExpressionType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_QueryExpressionType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_QueryExpressionType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_QueryExpressionType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_QueryExpressionType
 * @ingroup wsrp_QueryExpressionType
 * Deserialize the next element if it contains a wsrp_QueryExpressionType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_QueryExpressionType.
 * @param instance
 *     Pointer to the <code>wsrp_QueryExpressionType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_QueryExpressionType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_QueryExpressionType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_QueryExpressionType_init_wrapper(
    void **                             object);
    
void
wsrp_QueryExpressionType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_QueryExpressionType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_QueryExpressionType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_QueryExpressionType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_QueryExpressionType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_QueryExpressionType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_QueryExpressionType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_QueryExpressionType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_QueryExpressionType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
