/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSRP_RESOURCEUNKNOWNFAULTTYPE_H_
#define _WSRP_RESOURCEUNKNOWNFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsrp_ResourceUnknownFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}ResourceUnknownFaultType element.
 * @ingroup wsrp_ResourceUnknownFaultType
 */
typedef struct wsrp_ResourceUnknownFaultType_s wsrp_ResourceUnknownFaultType;
/**
 * The wsrp_ResourceUnknownFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd}ResourceUnknownFaultType element.
 * @ingroup wsrp_ResourceUnknownFaultType
 */
typedef wsrp_ResourceUnknownFaultType * wsrp_ResourceUnknownFaultType_o;

/**
 * Namespace of the wsrp_ResourceUnknownFaultType complex type
 * @ingroup wsrp_ResourceUnknownFaultType
 */
#define WSRP_RESOURCEUNKNOWNFAULTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wsrp_ResourceUnknownFaultType complex type
 * @ingroup wsrp_ResourceUnknownFaultType
 */
#define WSRP_RESOURCEUNKNOWNFAULTTYPE_LOCAL "ResourceUnknownFaultType"

/**
 * QName of the wsrp_ResourceUnknownFaultType complex type
 * @ingroup wsrp_ResourceUnknownFaultType
 */
extern xsd_QName wsrp_ResourceUnknownFaultType_qname;
/**
 * Type information for serializing and deserializing wsrp_ResourceUnknownFaultType elements
 * @ingroup wsrp_ResourceUnknownFaultType
 */
extern struct globus_xsd_type_info_s wsrp_ResourceUnknownFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wsrp_ResourceUnknownFaultType
 * elements
 * @ingroup wsrp_ResourceUnknownFaultType
 */
extern struct globus_xsd_type_info_s wsrp_ResourceUnknownFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsrp_ResourceUnknownFaultType without surrounding elements
 * @ingroup wsrp_ResourceUnknownFaultType
 */
extern struct globus_xsd_type_info_s wsrp_ResourceUnknownFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wsrp_ResourceUnknownFaultType_array.h"

/**
 * @defgroup wsrp_ResourceUnknownFaultType Complex type: wsrp_ResourceUnknownFaultType
 * @ingroup types
 */

/**
 * C structure for the wsrp_ResourceUnknownFaultType complex type
 * @ingroup wsrp_ResourceUnknownFaultType
 */
struct wsrp_ResourceUnknownFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 *
 * Allocates a new wsrp_ResourceUnknownFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsrp_ResourceUnknownFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_init(
    wsrp_ResourceUnknownFaultType ** inst);

/**
 * Destroy a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 *
 * Frees a wsrp_ResourceUnknownFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsrp_ResourceUnknownFaultType_destroy(
    wsrp_ResourceUnknownFaultType * inst);

/**
 * Copy a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 *
 * Perform a deep copy of a wsrp_ResourceUnknownFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsrp_ResourceUnknownFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsrp_ResourceUnknownFaultType to be copied.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_copy(
    wsrp_ResourceUnknownFaultType ** dest,
    const wsrp_ResourceUnknownFaultType * src);

/**
 * Initialize the contents of a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 *
 * Initialize the contents of a wsrp_ResourceUnknownFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsrp_ResourceUnknownFaultType_init(). The contents may be freed
 * by calling wsrp_ResourceUnknownFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsrp_ResourceUnknownFaultType.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_init_contents(
    wsrp_ResourceUnknownFaultType * instance);

/**
 * Destroy the contents of a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 *
 * Destroy the subelements and attributes of the given wsrp_ResourceUnknownFaultType. 
 *
 * @param inst
 *     Pointer to a wsrp_ResourceUnknownFaultType instance to destroy.
 */
void
wsrp_ResourceUnknownFaultType_destroy_contents(
    wsrp_ResourceUnknownFaultType * inst);

/**
 * Copy the contents of a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 *
 * Perform a deep copy of the contents of a wsrp_ResourceUnknownFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsrp_ResourceUnknownFaultType to be copied.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_copy_contents(
    wsrp_ResourceUnknownFaultType * dest,
    const wsrp_ResourceUnknownFaultType * src);

/**
 * Serialize a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType_array
 * Serialize a wsrp_ResourceUnknownFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsrp_ResourceUnknownFaultType.
 * @param val
 *     The wsrp_ResourceUnknownFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_serialize(
    xsd_QName *                         element_name,
    wsrp_ResourceUnknownFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType_array
 * Serialize a wsrp_ResourceUnknownFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsrp_ResourceUnknownFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wsrp_ResourceUnknownFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 * Deserialize an element containing a wsrp_ResourceUnknownFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_ResourceUnknownFaultType.
 * @param val
 *     Pointer to the wsrp_ResourceUnknownFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_deserialize(
    xsd_QName *                         element_name,
    wsrp_ResourceUnknownFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 * Deserialize a wsrp_ResourceUnknownFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsrp_ResourceUnknownFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wsrp_ResourceUnknownFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsrp_ResourceUnknownFaultType
 * @ingroup wsrp_ResourceUnknownFaultType
 * Deserialize the next element if it contains a wsrp_ResourceUnknownFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsrp_ResourceUnknownFaultType.
 * @param instance
 *     Pointer to the <code>wsrp_ResourceUnknownFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsrp_ResourceUnknownFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsrp_ResourceUnknownFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsrp_ResourceUnknownFaultType_init_wrapper(
    void **                             object);
    
void
wsrp_ResourceUnknownFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsrp_ResourceUnknownFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_ResourceUnknownFaultType_init_contents_wrapper(
    void *                              object);
    
void
wsrp_ResourceUnknownFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsrp_ResourceUnknownFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsrp_ResourceUnknownFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_ResourceUnknownFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsrp_ResourceUnknownFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsrp_ResourceUnknownFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
