/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_ATTRIBUTEDSTRING_H_
#define _WSSE_ATTRIBUTEDSTRING_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_AttributedString complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}AttributedString element.
 * @ingroup wsse_AttributedString
 */
typedef struct wsse_AttributedString_s wsse_AttributedString;
/**
 * The wsse_AttributedString_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}AttributedString element.
 * @ingroup wsse_AttributedString
 */
typedef wsse_AttributedString * wsse_AttributedString_o;

/**
 * Namespace of the wsse_AttributedString complex type
 * @ingroup wsse_AttributedString
 */
#define WSSE_ATTRIBUTEDSTRING_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_AttributedString complex type
 * @ingroup wsse_AttributedString
 */
#define WSSE_ATTRIBUTEDSTRING_LOCAL "AttributedString"

/**
 * QName of the wsse_AttributedString complex type
 * @ingroup wsse_AttributedString
 */
extern xsd_QName wsse_AttributedString_qname;
/**
 * Type information for serializing and deserializing wsse_AttributedString elements
 * @ingroup wsse_AttributedString
 */
extern struct globus_xsd_type_info_s wsse_AttributedString_info;
/**
 * Type information for serializing and deserializing arrays of wsse_AttributedString
 * elements
 * @ingroup wsse_AttributedString
 */
extern struct globus_xsd_type_info_s wsse_AttributedString_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_AttributedString without surrounding elements
 * @ingroup wsse_AttributedString
 */
extern struct globus_xsd_type_info_s wsse_AttributedString_contents_info;


#include "xsd_string.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "wsse_AttributedString_array.h"

/**
 * @defgroup wsse_AttributedString Complex type: wsse_AttributedString
 * @ingroup types
 */

/**
 * C structure for the wsse_AttributedString complex type
 * @ingroup wsse_AttributedString
 */
struct wsse_AttributedString_s
{
    /** xsd_string subelement */
    xsd_string base_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsse_AttributedString
 * @ingroup wsse_AttributedString
 *
 * Allocates a new wsse_AttributedString and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_AttributedString_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_AttributedString_init(
    wsse_AttributedString ** inst);

/**
 * Destroy a wsse_AttributedString
 * @ingroup wsse_AttributedString
 *
 * Frees a wsse_AttributedString. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_AttributedString_destroy(
    wsse_AttributedString * inst);

/**
 * Copy a wsse_AttributedString
 * @ingroup wsse_AttributedString
 *
 * Perform a deep copy of a wsse_AttributedString.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_AttributedString structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_AttributedString to be copied.
 */
globus_result_t
wsse_AttributedString_copy(
    wsse_AttributedString ** dest,
    const wsse_AttributedString * src);

/**
 * Initialize the contents of a wsse_AttributedString
 * @ingroup wsse_AttributedString
 *
 * Initialize the contents of a wsse_AttributedString. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_AttributedString_init(). The contents may be freed
 * by calling wsse_AttributedString_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_AttributedString.
 */
globus_result_t
wsse_AttributedString_init_contents(
    wsse_AttributedString * instance);

/**
 * Destroy the contents of a wsse_AttributedString
 * @ingroup wsse_AttributedString
 *
 * Destroy the subelements and attributes of the given wsse_AttributedString. 
 *
 * @param inst
 *     Pointer to a wsse_AttributedString instance to destroy.
 */
void
wsse_AttributedString_destroy_contents(
    wsse_AttributedString * inst);

/**
 * Copy the contents of a wsse_AttributedString
 * @ingroup wsse_AttributedString
 *
 * Perform a deep copy of the contents of a wsse_AttributedString.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_AttributedString to be copied.
 */
globus_result_t
wsse_AttributedString_copy_contents(
    wsse_AttributedString * dest,
    const wsse_AttributedString * src);

/**
 * Serialize a wsse_AttributedString
 * @ingroup wsse_AttributedString_array
 * Serialize a wsse_AttributedString structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_AttributedString.
 * @param val
 *     The wsse_AttributedString to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_AttributedString_serialize(
    xsd_QName *                         element_name,
    wsse_AttributedString * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_AttributedString
 * @ingroup wsse_AttributedString_array
 * Serialize a wsse_AttributedString structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_AttributedString to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_AttributedString_serialize_contents(
    xsd_QName *                         element_name,
    wsse_AttributedString * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_AttributedString
 * @ingroup wsse_AttributedString
 * Deserialize an element containing a wsse_AttributedString element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_AttributedString.
 * @param val
 *     Pointer to the wsse_AttributedString which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_AttributedString_deserialize(
    xsd_QName *                         element_name,
    wsse_AttributedString * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_AttributedString
 * @ingroup wsse_AttributedString
 * Deserialize a wsse_AttributedString whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_AttributedString which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_AttributedString_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_AttributedString * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_AttributedString
 * @ingroup wsse_AttributedString
 * Deserialize the next element if it contains a wsse_AttributedString.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_AttributedString.
 * @param instance
 *     Pointer to the <code>wsse_AttributedString *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_AttributedString_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_AttributedString ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_AttributedString_init_wrapper(
    void **                             object);
    
void
wsse_AttributedString_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_AttributedString_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_AttributedString_init_contents_wrapper(
    void *                              object);
    
void
wsse_AttributedString_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_AttributedString_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_AttributedString_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_AttributedString_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_AttributedString_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_AttributedString_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
