/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_EMBEDDEDTYPE_H_
#define _WSSE_EMBEDDEDTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_EmbeddedType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}EmbeddedType element.
 * @ingroup wsse_EmbeddedType
 */
typedef struct wsse_EmbeddedType_s wsse_EmbeddedType;
/**
 * The wsse_EmbeddedType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}EmbeddedType element.
 * @ingroup wsse_EmbeddedType
 */
typedef wsse_EmbeddedType * wsse_EmbeddedType_o;

/**
 * Namespace of the wsse_EmbeddedType complex type
 * @ingroup wsse_EmbeddedType
 */
#define WSSE_EMBEDDEDTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_EmbeddedType complex type
 * @ingroup wsse_EmbeddedType
 */
#define WSSE_EMBEDDEDTYPE_LOCAL "EmbeddedType"

/**
 * QName of the wsse_EmbeddedType complex type
 * @ingroup wsse_EmbeddedType
 */
extern xsd_QName wsse_EmbeddedType_qname;
/**
 * Type information for serializing and deserializing wsse_EmbeddedType elements
 * @ingroup wsse_EmbeddedType
 */
extern struct globus_xsd_type_info_s wsse_EmbeddedType_info;
/**
 * Type information for serializing and deserializing arrays of wsse_EmbeddedType
 * elements
 * @ingroup wsse_EmbeddedType
 */
extern struct globus_xsd_type_info_s wsse_EmbeddedType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_EmbeddedType without surrounding elements
 * @ingroup wsse_EmbeddedType
 */
extern struct globus_xsd_type_info_s wsse_EmbeddedType_contents_info;


#include "wsse_EmbeddedType_choice.h"
#include "xsd_anyAttributes.h"
#include "xsd_anyURI.h"
#include "wsse_EmbeddedType_array.h"

/**
 * @defgroup wsse_EmbeddedType Complex type: wsse_EmbeddedType
 * @ingroup types
 */

/**
 * C structure for the wsse_EmbeddedType complex type
 * @ingroup wsse_EmbeddedType
 */
struct wsse_EmbeddedType_s
{
   /** Array of [0 .. Infinity] wsse_EmbeddedType_choice elements */
    wsse_EmbeddedType_choice_array choice_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_anyURI_o _ValueType;

};

/**
 * Initialize a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 *
 * Allocates a new wsse_EmbeddedType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_EmbeddedType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_EmbeddedType_init(
    wsse_EmbeddedType ** inst);

/**
 * Destroy a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 *
 * Frees a wsse_EmbeddedType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_EmbeddedType_destroy(
    wsse_EmbeddedType * inst);

/**
 * Copy a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 *
 * Perform a deep copy of a wsse_EmbeddedType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_EmbeddedType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_EmbeddedType to be copied.
 */
globus_result_t
wsse_EmbeddedType_copy(
    wsse_EmbeddedType ** dest,
    const wsse_EmbeddedType * src);

/**
 * Initialize the contents of a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 *
 * Initialize the contents of a wsse_EmbeddedType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_EmbeddedType_init(). The contents may be freed
 * by calling wsse_EmbeddedType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_EmbeddedType.
 */
globus_result_t
wsse_EmbeddedType_init_contents(
    wsse_EmbeddedType * instance);

/**
 * Destroy the contents of a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 *
 * Destroy the subelements and attributes of the given wsse_EmbeddedType. 
 *
 * @param inst
 *     Pointer to a wsse_EmbeddedType instance to destroy.
 */
void
wsse_EmbeddedType_destroy_contents(
    wsse_EmbeddedType * inst);

/**
 * Copy the contents of a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 *
 * Perform a deep copy of the contents of a wsse_EmbeddedType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_EmbeddedType to be copied.
 */
globus_result_t
wsse_EmbeddedType_copy_contents(
    wsse_EmbeddedType * dest,
    const wsse_EmbeddedType * src);

/**
 * Serialize a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType_array
 * Serialize a wsse_EmbeddedType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_EmbeddedType.
 * @param val
 *     The wsse_EmbeddedType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_EmbeddedType_serialize(
    xsd_QName *                         element_name,
    wsse_EmbeddedType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType_array
 * Serialize a wsse_EmbeddedType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_EmbeddedType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_EmbeddedType_serialize_contents(
    xsd_QName *                         element_name,
    wsse_EmbeddedType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 * Deserialize an element containing a wsse_EmbeddedType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_EmbeddedType.
 * @param val
 *     Pointer to the wsse_EmbeddedType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_EmbeddedType_deserialize(
    xsd_QName *                         element_name,
    wsse_EmbeddedType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 * Deserialize a wsse_EmbeddedType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_EmbeddedType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_EmbeddedType_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_EmbeddedType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_EmbeddedType
 * @ingroup wsse_EmbeddedType
 * Deserialize the next element if it contains a wsse_EmbeddedType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_EmbeddedType.
 * @param instance
 *     Pointer to the <code>wsse_EmbeddedType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_EmbeddedType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_EmbeddedType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_EmbeddedType_init_wrapper(
    void **                             object);
    
void
wsse_EmbeddedType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_EmbeddedType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_EmbeddedType_init_contents_wrapper(
    void *                              object);
    
void
wsse_EmbeddedType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_EmbeddedType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_EmbeddedType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EmbeddedType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EmbeddedType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EmbeddedType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
