/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_ENCODEDSTRING_H_
#define _WSSE_ENCODEDSTRING_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_EncodedString complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}EncodedString element.
 * @ingroup wsse_EncodedString
 */
typedef struct wsse_EncodedString_s wsse_EncodedString;
/**
 * The wsse_EncodedString_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}EncodedString element.
 * @ingroup wsse_EncodedString
 */
typedef wsse_EncodedString * wsse_EncodedString_o;

/**
 * Namespace of the wsse_EncodedString complex type
 * @ingroup wsse_EncodedString
 */
#define WSSE_ENCODEDSTRING_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_EncodedString complex type
 * @ingroup wsse_EncodedString
 */
#define WSSE_ENCODEDSTRING_LOCAL "EncodedString"

/**
 * QName of the wsse_EncodedString complex type
 * @ingroup wsse_EncodedString
 */
extern xsd_QName wsse_EncodedString_qname;
/**
 * Type information for serializing and deserializing wsse_EncodedString elements
 * @ingroup wsse_EncodedString
 */
extern struct globus_xsd_type_info_s wsse_EncodedString_info;
/**
 * Type information for serializing and deserializing arrays of wsse_EncodedString
 * elements
 * @ingroup wsse_EncodedString
 */
extern struct globus_xsd_type_info_s wsse_EncodedString_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_EncodedString without surrounding elements
 * @ingroup wsse_EncodedString
 */
extern struct globus_xsd_type_info_s wsse_EncodedString_contents_info;


#include "xsd_string.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "xsd_anyURI.h"
#include "wsse_EncodedString_array.h"

/**
 * @defgroup wsse_EncodedString Complex type: wsse_EncodedString
 * @ingroup types
 */

/**
 * C structure for the wsse_EncodedString complex type
 * @ingroup wsse_EncodedString
 */
struct wsse_EncodedString_s
{
    /** xsd_string subelement */
    xsd_string base_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;
    xsd_anyURI_o _EncodingType;

};

/**
 * Initialize a wsse_EncodedString
 * @ingroup wsse_EncodedString
 *
 * Allocates a new wsse_EncodedString and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_EncodedString_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_EncodedString_init(
    wsse_EncodedString ** inst);

/**
 * Destroy a wsse_EncodedString
 * @ingroup wsse_EncodedString
 *
 * Frees a wsse_EncodedString. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_EncodedString_destroy(
    wsse_EncodedString * inst);

/**
 * Copy a wsse_EncodedString
 * @ingroup wsse_EncodedString
 *
 * Perform a deep copy of a wsse_EncodedString.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_EncodedString structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_EncodedString to be copied.
 */
globus_result_t
wsse_EncodedString_copy(
    wsse_EncodedString ** dest,
    const wsse_EncodedString * src);

/**
 * Initialize the contents of a wsse_EncodedString
 * @ingroup wsse_EncodedString
 *
 * Initialize the contents of a wsse_EncodedString. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_EncodedString_init(). The contents may be freed
 * by calling wsse_EncodedString_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_EncodedString.
 */
globus_result_t
wsse_EncodedString_init_contents(
    wsse_EncodedString * instance);

/**
 * Destroy the contents of a wsse_EncodedString
 * @ingroup wsse_EncodedString
 *
 * Destroy the subelements and attributes of the given wsse_EncodedString. 
 *
 * @param inst
 *     Pointer to a wsse_EncodedString instance to destroy.
 */
void
wsse_EncodedString_destroy_contents(
    wsse_EncodedString * inst);

/**
 * Copy the contents of a wsse_EncodedString
 * @ingroup wsse_EncodedString
 *
 * Perform a deep copy of the contents of a wsse_EncodedString.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_EncodedString to be copied.
 */
globus_result_t
wsse_EncodedString_copy_contents(
    wsse_EncodedString * dest,
    const wsse_EncodedString * src);

/**
 * Serialize a wsse_EncodedString
 * @ingroup wsse_EncodedString_array
 * Serialize a wsse_EncodedString structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_EncodedString.
 * @param val
 *     The wsse_EncodedString to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_EncodedString_serialize(
    xsd_QName *                         element_name,
    wsse_EncodedString * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_EncodedString
 * @ingroup wsse_EncodedString_array
 * Serialize a wsse_EncodedString structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_EncodedString to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_EncodedString_serialize_contents(
    xsd_QName *                         element_name,
    wsse_EncodedString * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_EncodedString
 * @ingroup wsse_EncodedString
 * Deserialize an element containing a wsse_EncodedString element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_EncodedString.
 * @param val
 *     Pointer to the wsse_EncodedString which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_EncodedString_deserialize(
    xsd_QName *                         element_name,
    wsse_EncodedString * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_EncodedString
 * @ingroup wsse_EncodedString
 * Deserialize a wsse_EncodedString whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_EncodedString which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_EncodedString_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_EncodedString * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_EncodedString
 * @ingroup wsse_EncodedString
 * Deserialize the next element if it contains a wsse_EncodedString.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_EncodedString.
 * @param instance
 *     Pointer to the <code>wsse_EncodedString *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_EncodedString_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_EncodedString ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_EncodedString_init_wrapper(
    void **                             object);
    
void
wsse_EncodedString_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_EncodedString_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_EncodedString_init_contents_wrapper(
    void *                              object);
    
void
wsse_EncodedString_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_EncodedString_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_EncodedString_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EncodedString_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_EncodedString_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_EncodedString_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
