/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_KEYIDENTIFIERTYPE_H_
#define _WSSE_KEYIDENTIFIERTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_KeyIdentifierType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}KeyIdentifierType element.
 * @ingroup wsse_KeyIdentifierType
 */
typedef struct wsse_KeyIdentifierType_s wsse_KeyIdentifierType;
/**
 * The wsse_KeyIdentifierType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}KeyIdentifierType element.
 * @ingroup wsse_KeyIdentifierType
 */
typedef wsse_KeyIdentifierType * wsse_KeyIdentifierType_o;

/**
 * Namespace of the wsse_KeyIdentifierType complex type
 * @ingroup wsse_KeyIdentifierType
 */
#define WSSE_KEYIDENTIFIERTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_KeyIdentifierType complex type
 * @ingroup wsse_KeyIdentifierType
 */
#define WSSE_KEYIDENTIFIERTYPE_LOCAL "KeyIdentifierType"

/**
 * QName of the wsse_KeyIdentifierType complex type
 * @ingroup wsse_KeyIdentifierType
 */
extern xsd_QName wsse_KeyIdentifierType_qname;
/**
 * Type information for serializing and deserializing wsse_KeyIdentifierType elements
 * @ingroup wsse_KeyIdentifierType
 */
extern struct globus_xsd_type_info_s wsse_KeyIdentifierType_info;
/**
 * Type information for serializing and deserializing arrays of wsse_KeyIdentifierType
 * elements
 * @ingroup wsse_KeyIdentifierType
 */
extern struct globus_xsd_type_info_s wsse_KeyIdentifierType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_KeyIdentifierType without surrounding elements
 * @ingroup wsse_KeyIdentifierType
 */
extern struct globus_xsd_type_info_s wsse_KeyIdentifierType_contents_info;


#include "xsd_string.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "xsd_anyURI.h"
#include "xsd_anyURI.h"
#include "wsse_KeyIdentifierType_array.h"

/**
 * @defgroup wsse_KeyIdentifierType Complex type: wsse_KeyIdentifierType
 * @ingroup types
 */

/**
 * C structure for the wsse_KeyIdentifierType complex type
 * @ingroup wsse_KeyIdentifierType
 */
struct wsse_KeyIdentifierType_s
{
    /** xsd_string subelement */
    xsd_string base_value;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;
    xsd_anyURI_o _EncodingType;
    xsd_anyURI_o _ValueType;

};

/**
 * Initialize a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 *
 * Allocates a new wsse_KeyIdentifierType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_KeyIdentifierType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_KeyIdentifierType_init(
    wsse_KeyIdentifierType ** inst);

/**
 * Destroy a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 *
 * Frees a wsse_KeyIdentifierType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_KeyIdentifierType_destroy(
    wsse_KeyIdentifierType * inst);

/**
 * Copy a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 *
 * Perform a deep copy of a wsse_KeyIdentifierType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_KeyIdentifierType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_KeyIdentifierType to be copied.
 */
globus_result_t
wsse_KeyIdentifierType_copy(
    wsse_KeyIdentifierType ** dest,
    const wsse_KeyIdentifierType * src);

/**
 * Initialize the contents of a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 *
 * Initialize the contents of a wsse_KeyIdentifierType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_KeyIdentifierType_init(). The contents may be freed
 * by calling wsse_KeyIdentifierType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_KeyIdentifierType.
 */
globus_result_t
wsse_KeyIdentifierType_init_contents(
    wsse_KeyIdentifierType * instance);

/**
 * Destroy the contents of a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 *
 * Destroy the subelements and attributes of the given wsse_KeyIdentifierType. 
 *
 * @param inst
 *     Pointer to a wsse_KeyIdentifierType instance to destroy.
 */
void
wsse_KeyIdentifierType_destroy_contents(
    wsse_KeyIdentifierType * inst);

/**
 * Copy the contents of a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 *
 * Perform a deep copy of the contents of a wsse_KeyIdentifierType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_KeyIdentifierType to be copied.
 */
globus_result_t
wsse_KeyIdentifierType_copy_contents(
    wsse_KeyIdentifierType * dest,
    const wsse_KeyIdentifierType * src);

/**
 * Serialize a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType_array
 * Serialize a wsse_KeyIdentifierType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_KeyIdentifierType.
 * @param val
 *     The wsse_KeyIdentifierType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_KeyIdentifierType_serialize(
    xsd_QName *                         element_name,
    wsse_KeyIdentifierType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType_array
 * Serialize a wsse_KeyIdentifierType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_KeyIdentifierType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_KeyIdentifierType_serialize_contents(
    xsd_QName *                         element_name,
    wsse_KeyIdentifierType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 * Deserialize an element containing a wsse_KeyIdentifierType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_KeyIdentifierType.
 * @param val
 *     Pointer to the wsse_KeyIdentifierType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_KeyIdentifierType_deserialize(
    xsd_QName *                         element_name,
    wsse_KeyIdentifierType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 * Deserialize a wsse_KeyIdentifierType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_KeyIdentifierType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_KeyIdentifierType_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_KeyIdentifierType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_KeyIdentifierType
 * @ingroup wsse_KeyIdentifierType
 * Deserialize the next element if it contains a wsse_KeyIdentifierType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_KeyIdentifierType.
 * @param instance
 *     Pointer to the <code>wsse_KeyIdentifierType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_KeyIdentifierType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_KeyIdentifierType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_KeyIdentifierType_init_wrapper(
    void **                             object);
    
void
wsse_KeyIdentifierType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_KeyIdentifierType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_KeyIdentifierType_init_contents_wrapper(
    void *                              object);
    
void
wsse_KeyIdentifierType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_KeyIdentifierType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_KeyIdentifierType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_KeyIdentifierType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_KeyIdentifierType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_KeyIdentifierType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
