/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_REFERENCETYPE_H_
#define _WSSE_REFERENCETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_ReferenceType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}ReferenceType element.
 * @ingroup wsse_ReferenceType
 */
typedef struct wsse_ReferenceType_s wsse_ReferenceType;
/**
 * The wsse_ReferenceType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}ReferenceType element.
 * @ingroup wsse_ReferenceType
 */
typedef wsse_ReferenceType * wsse_ReferenceType_o;

/**
 * Namespace of the wsse_ReferenceType complex type
 * @ingroup wsse_ReferenceType
 */
#define WSSE_REFERENCETYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_ReferenceType complex type
 * @ingroup wsse_ReferenceType
 */
#define WSSE_REFERENCETYPE_LOCAL "ReferenceType"

/**
 * QName of the wsse_ReferenceType complex type
 * @ingroup wsse_ReferenceType
 */
extern xsd_QName wsse_ReferenceType_qname;
/**
 * Type information for serializing and deserializing wsse_ReferenceType elements
 * @ingroup wsse_ReferenceType
 */
extern struct globus_xsd_type_info_s wsse_ReferenceType_info;
/**
 * Type information for serializing and deserializing arrays of wsse_ReferenceType
 * elements
 * @ingroup wsse_ReferenceType
 */
extern struct globus_xsd_type_info_s wsse_ReferenceType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_ReferenceType without surrounding elements
 * @ingroup wsse_ReferenceType
 */
extern struct globus_xsd_type_info_s wsse_ReferenceType_contents_info;


#include "xsd_anyAttributes.h"
#include "xsd_anyURI.h"
#include "xsd_anyURI.h"
#include "wsse_ReferenceType_array.h"

/**
 * @defgroup wsse_ReferenceType Complex type: wsse_ReferenceType
 * @ingroup types
 */

/**
 * C structure for the wsse_ReferenceType complex type
 * @ingroup wsse_ReferenceType
 */
struct wsse_ReferenceType_s
{
    xsd_anyAttributes_t anyAttributes;
    xsd_anyURI_o _URI;
    xsd_anyURI_o _ValueType;

};

/**
 * Initialize a wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 *
 * Allocates a new wsse_ReferenceType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_ReferenceType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_ReferenceType_init(
    wsse_ReferenceType ** inst);

/**
 * Destroy a wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 *
 * Frees a wsse_ReferenceType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_ReferenceType_destroy(
    wsse_ReferenceType * inst);

/**
 * Copy a wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 *
 * Perform a deep copy of a wsse_ReferenceType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_ReferenceType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_ReferenceType to be copied.
 */
globus_result_t
wsse_ReferenceType_copy(
    wsse_ReferenceType ** dest,
    const wsse_ReferenceType * src);

/**
 * Initialize the contents of a wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 *
 * Initialize the contents of a wsse_ReferenceType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_ReferenceType_init(). The contents may be freed
 * by calling wsse_ReferenceType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_ReferenceType.
 */
globus_result_t
wsse_ReferenceType_init_contents(
    wsse_ReferenceType * instance);

/**
 * Destroy the contents of a wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 *
 * Destroy the subelements and attributes of the given wsse_ReferenceType. 
 *
 * @param inst
 *     Pointer to a wsse_ReferenceType instance to destroy.
 */
void
wsse_ReferenceType_destroy_contents(
    wsse_ReferenceType * inst);

/**
 * Copy the contents of a wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 *
 * Perform a deep copy of the contents of a wsse_ReferenceType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_ReferenceType to be copied.
 */
globus_result_t
wsse_ReferenceType_copy_contents(
    wsse_ReferenceType * dest,
    const wsse_ReferenceType * src);

/**
 * Serialize a wsse_ReferenceType
 * @ingroup wsse_ReferenceType_array
 * Serialize a wsse_ReferenceType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_ReferenceType.
 * @param val
 *     The wsse_ReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_ReferenceType_serialize(
    xsd_QName *                         element_name,
    wsse_ReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_ReferenceType
 * @ingroup wsse_ReferenceType_array
 * Serialize a wsse_ReferenceType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_ReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_ReferenceType_serialize_contents(
    xsd_QName *                         element_name,
    wsse_ReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 * Deserialize an element containing a wsse_ReferenceType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_ReferenceType.
 * @param val
 *     Pointer to the wsse_ReferenceType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_ReferenceType_deserialize(
    xsd_QName *                         element_name,
    wsse_ReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 * Deserialize a wsse_ReferenceType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_ReferenceType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_ReferenceType_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_ReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_ReferenceType
 * @ingroup wsse_ReferenceType
 * Deserialize the next element if it contains a wsse_ReferenceType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_ReferenceType.
 * @param instance
 *     Pointer to the <code>wsse_ReferenceType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_ReferenceType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_ReferenceType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_ReferenceType_init_wrapper(
    void **                             object);
    
void
wsse_ReferenceType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_ReferenceType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_ReferenceType_init_contents_wrapper(
    void *                              object);
    
void
wsse_ReferenceType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_ReferenceType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_ReferenceType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_ReferenceType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_ReferenceType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_ReferenceType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
