/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_TRANSFORMATIONPARAMETERSTYPE_H_
#define _WSSE_TRANSFORMATIONPARAMETERSTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_TransformationParametersType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}TransformationParametersType element.
 * @ingroup wsse_TransformationParametersType
 */
typedef struct wsse_TransformationParametersType_s wsse_TransformationParametersType;
/**
 * The wsse_TransformationParametersType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}TransformationParametersType element.
 * @ingroup wsse_TransformationParametersType
 */
typedef wsse_TransformationParametersType * wsse_TransformationParametersType_o;

/**
 * Namespace of the wsse_TransformationParametersType complex type
 * @ingroup wsse_TransformationParametersType
 */
#define WSSE_TRANSFORMATIONPARAMETERSTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_TransformationParametersType complex type
 * @ingroup wsse_TransformationParametersType
 */
#define WSSE_TRANSFORMATIONPARAMETERSTYPE_LOCAL "TransformationParametersType"

/**
 * QName of the wsse_TransformationParametersType complex type
 * @ingroup wsse_TransformationParametersType
 */
extern xsd_QName wsse_TransformationParametersType_qname;
/**
 * Type information for serializing and deserializing wsse_TransformationParametersType elements
 * @ingroup wsse_TransformationParametersType
 */
extern struct globus_xsd_type_info_s wsse_TransformationParametersType_info;
/**
 * Type information for serializing and deserializing arrays of wsse_TransformationParametersType
 * elements
 * @ingroup wsse_TransformationParametersType
 */
extern struct globus_xsd_type_info_s wsse_TransformationParametersType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_TransformationParametersType without surrounding elements
 * @ingroup wsse_TransformationParametersType
 */
extern struct globus_xsd_type_info_s wsse_TransformationParametersType_contents_info;


#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "wsse_TransformationParametersType_array.h"

/**
 * @defgroup wsse_TransformationParametersType Complex type: wsse_TransformationParametersType
 * @ingroup types
 */

/**
 * C structure for the wsse_TransformationParametersType complex type
 * @ingroup wsse_TransformationParametersType
 */
struct wsse_TransformationParametersType_s
{
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 *
 * Allocates a new wsse_TransformationParametersType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_TransformationParametersType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_TransformationParametersType_init(
    wsse_TransformationParametersType ** inst);

/**
 * Destroy a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 *
 * Frees a wsse_TransformationParametersType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_TransformationParametersType_destroy(
    wsse_TransformationParametersType * inst);

/**
 * Copy a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 *
 * Perform a deep copy of a wsse_TransformationParametersType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_TransformationParametersType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_TransformationParametersType to be copied.
 */
globus_result_t
wsse_TransformationParametersType_copy(
    wsse_TransformationParametersType ** dest,
    const wsse_TransformationParametersType * src);

/**
 * Initialize the contents of a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 *
 * Initialize the contents of a wsse_TransformationParametersType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_TransformationParametersType_init(). The contents may be freed
 * by calling wsse_TransformationParametersType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_TransformationParametersType.
 */
globus_result_t
wsse_TransformationParametersType_init_contents(
    wsse_TransformationParametersType * instance);

/**
 * Destroy the contents of a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 *
 * Destroy the subelements and attributes of the given wsse_TransformationParametersType. 
 *
 * @param inst
 *     Pointer to a wsse_TransformationParametersType instance to destroy.
 */
void
wsse_TransformationParametersType_destroy_contents(
    wsse_TransformationParametersType * inst);

/**
 * Copy the contents of a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 *
 * Perform a deep copy of the contents of a wsse_TransformationParametersType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_TransformationParametersType to be copied.
 */
globus_result_t
wsse_TransformationParametersType_copy_contents(
    wsse_TransformationParametersType * dest,
    const wsse_TransformationParametersType * src);

/**
 * Serialize a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType_array
 * Serialize a wsse_TransformationParametersType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_TransformationParametersType.
 * @param val
 *     The wsse_TransformationParametersType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_TransformationParametersType_serialize(
    xsd_QName *                         element_name,
    wsse_TransformationParametersType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType_array
 * Serialize a wsse_TransformationParametersType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_TransformationParametersType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_TransformationParametersType_serialize_contents(
    xsd_QName *                         element_name,
    wsse_TransformationParametersType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 * Deserialize an element containing a wsse_TransformationParametersType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_TransformationParametersType.
 * @param val
 *     Pointer to the wsse_TransformationParametersType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_TransformationParametersType_deserialize(
    xsd_QName *                         element_name,
    wsse_TransformationParametersType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 * Deserialize a wsse_TransformationParametersType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_TransformationParametersType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_TransformationParametersType_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_TransformationParametersType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_TransformationParametersType
 * @ingroup wsse_TransformationParametersType
 * Deserialize the next element if it contains a wsse_TransformationParametersType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_TransformationParametersType.
 * @param instance
 *     Pointer to the <code>wsse_TransformationParametersType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_TransformationParametersType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_TransformationParametersType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_TransformationParametersType_init_wrapper(
    void **                             object);
    
void
wsse_TransformationParametersType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_TransformationParametersType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_TransformationParametersType_init_contents_wrapper(
    void *                              object);
    
void
wsse_TransformationParametersType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_TransformationParametersType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_TransformationParametersType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_TransformationParametersType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_TransformationParametersType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_TransformationParametersType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
