/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSE_USERNAMETOKENTYPE_H_
#define _WSSE_USERNAMETOKENTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsse_UsernameTokenType complex type, which represents the
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}UsernameTokenType element.
 * @ingroup wsse_UsernameTokenType
 */
typedef struct wsse_UsernameTokenType_s wsse_UsernameTokenType;
/**
 * The wsse_UsernameTokenType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd}UsernameTokenType element.
 * @ingroup wsse_UsernameTokenType
 */
typedef wsse_UsernameTokenType * wsse_UsernameTokenType_o;

/**
 * Namespace of the wsse_UsernameTokenType complex type
 * @ingroup wsse_UsernameTokenType
 */
#define WSSE_USERNAMETOKENTYPE_NS "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd"
/**
 * Local part of the QName of the wsse_UsernameTokenType complex type
 * @ingroup wsse_UsernameTokenType
 */
#define WSSE_USERNAMETOKENTYPE_LOCAL "UsernameTokenType"

/**
 * QName of the wsse_UsernameTokenType complex type
 * @ingroup wsse_UsernameTokenType
 */
extern xsd_QName wsse_UsernameTokenType_qname;
/**
 * Type information for serializing and deserializing wsse_UsernameTokenType elements
 * @ingroup wsse_UsernameTokenType
 */
extern struct globus_xsd_type_info_s wsse_UsernameTokenType_info;
/**
 * Type information for serializing and deserializing arrays of wsse_UsernameTokenType
 * elements
 * @ingroup wsse_UsernameTokenType
 */
extern struct globus_xsd_type_info_s wsse_UsernameTokenType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsse_UsernameTokenType without surrounding elements
 * @ingroup wsse_UsernameTokenType
 */
extern struct globus_xsd_type_info_s wsse_UsernameTokenType_contents_info;


#include "wsse_AttributedString.h"
#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "wsse_UsernameTokenType_array.h"

/**
 * @defgroup wsse_UsernameTokenType Complex type: wsse_UsernameTokenType
 * @ingroup types
 */

/**
 * C structure for the wsse_UsernameTokenType complex type
 * @ingroup wsse_UsernameTokenType
 */
struct wsse_UsernameTokenType_s
{
    /** wsse_AttributedString subelement */
    wsse_AttributedString Username;
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 *
 * Allocates a new wsse_UsernameTokenType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsse_UsernameTokenType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsse_UsernameTokenType_init(
    wsse_UsernameTokenType ** inst);

/**
 * Destroy a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 *
 * Frees a wsse_UsernameTokenType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsse_UsernameTokenType_destroy(
    wsse_UsernameTokenType * inst);

/**
 * Copy a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 *
 * Perform a deep copy of a wsse_UsernameTokenType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsse_UsernameTokenType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsse_UsernameTokenType to be copied.
 */
globus_result_t
wsse_UsernameTokenType_copy(
    wsse_UsernameTokenType ** dest,
    const wsse_UsernameTokenType * src);

/**
 * Initialize the contents of a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 *
 * Initialize the contents of a wsse_UsernameTokenType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsse_UsernameTokenType_init(). The contents may be freed
 * by calling wsse_UsernameTokenType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsse_UsernameTokenType.
 */
globus_result_t
wsse_UsernameTokenType_init_contents(
    wsse_UsernameTokenType * instance);

/**
 * Destroy the contents of a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 *
 * Destroy the subelements and attributes of the given wsse_UsernameTokenType. 
 *
 * @param inst
 *     Pointer to a wsse_UsernameTokenType instance to destroy.
 */
void
wsse_UsernameTokenType_destroy_contents(
    wsse_UsernameTokenType * inst);

/**
 * Copy the contents of a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 *
 * Perform a deep copy of the contents of a wsse_UsernameTokenType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsse_UsernameTokenType to be copied.
 */
globus_result_t
wsse_UsernameTokenType_copy_contents(
    wsse_UsernameTokenType * dest,
    const wsse_UsernameTokenType * src);

/**
 * Serialize a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType_array
 * Serialize a wsse_UsernameTokenType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsse_UsernameTokenType.
 * @param val
 *     The wsse_UsernameTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_UsernameTokenType_serialize(
    xsd_QName *                         element_name,
    wsse_UsernameTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType_array
 * Serialize a wsse_UsernameTokenType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsse_UsernameTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsse_UsernameTokenType_serialize_contents(
    xsd_QName *                         element_name,
    wsse_UsernameTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 * Deserialize an element containing a wsse_UsernameTokenType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_UsernameTokenType.
 * @param val
 *     Pointer to the wsse_UsernameTokenType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_UsernameTokenType_deserialize(
    xsd_QName *                         element_name,
    wsse_UsernameTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 * Deserialize a wsse_UsernameTokenType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsse_UsernameTokenType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_UsernameTokenType_deserialize_contents(
    xsd_QName *                         element_name,
    wsse_UsernameTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsse_UsernameTokenType
 * @ingroup wsse_UsernameTokenType
 * Deserialize the next element if it contains a wsse_UsernameTokenType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsse_UsernameTokenType.
 * @param instance
 *     Pointer to the <code>wsse_UsernameTokenType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsse_UsernameTokenType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsse_UsernameTokenType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsse_UsernameTokenType_init_wrapper(
    void **                             object);
    
void
wsse_UsernameTokenType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsse_UsernameTokenType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsse_UsernameTokenType_init_contents_wrapper(
    void *                              object);
    
void
wsse_UsernameTokenType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsse_UsernameTokenType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsse_UsernameTokenType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_UsernameTokenType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsse_UsernameTokenType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsse_UsernameTokenType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
