/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSG_CONTENTCREATIONFAILEDFAULTTYPE_H_
#define _WSSG_CONTENTCREATIONFAILEDFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wssg_ContentCreationFailedFaultType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}ContentCreationFailedFaultType element.
 * @ingroup wssg_ContentCreationFailedFaultType
 */
typedef struct wssg_ContentCreationFailedFaultType_s wssg_ContentCreationFailedFaultType;
/**
 * The wssg_ContentCreationFailedFaultType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}ContentCreationFailedFaultType element.
 * @ingroup wssg_ContentCreationFailedFaultType
 */
typedef wssg_ContentCreationFailedFaultType * wssg_ContentCreationFailedFaultType_o;

/**
 * Namespace of the wssg_ContentCreationFailedFaultType complex type
 * @ingroup wssg_ContentCreationFailedFaultType
 */
#define WSSG_CONTENTCREATIONFAILEDFAULTTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wssg_ContentCreationFailedFaultType complex type
 * @ingroup wssg_ContentCreationFailedFaultType
 */
#define WSSG_CONTENTCREATIONFAILEDFAULTTYPE_LOCAL "ContentCreationFailedFaultType"

/**
 * QName of the wssg_ContentCreationFailedFaultType complex type
 * @ingroup wssg_ContentCreationFailedFaultType
 */
extern xsd_QName wssg_ContentCreationFailedFaultType_qname;
/**
 * Type information for serializing and deserializing wssg_ContentCreationFailedFaultType elements
 * @ingroup wssg_ContentCreationFailedFaultType
 */
extern struct globus_xsd_type_info_s wssg_ContentCreationFailedFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wssg_ContentCreationFailedFaultType
 * elements
 * @ingroup wssg_ContentCreationFailedFaultType
 */
extern struct globus_xsd_type_info_s wssg_ContentCreationFailedFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wssg_ContentCreationFailedFaultType without surrounding elements
 * @ingroup wssg_ContentCreationFailedFaultType
 */
extern struct globus_xsd_type_info_s wssg_ContentCreationFailedFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wssg_ContentCreationFailedFaultType_array.h"

/**
 * @defgroup wssg_ContentCreationFailedFaultType Complex type: wssg_ContentCreationFailedFaultType
 * @ingroup types
 */

/**
 * C structure for the wssg_ContentCreationFailedFaultType complex type
 * @ingroup wssg_ContentCreationFailedFaultType
 */
struct wssg_ContentCreationFailedFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 *
 * Allocates a new wssg_ContentCreationFailedFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wssg_ContentCreationFailedFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_init(
    wssg_ContentCreationFailedFaultType ** inst);

/**
 * Destroy a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 *
 * Frees a wssg_ContentCreationFailedFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wssg_ContentCreationFailedFaultType_destroy(
    wssg_ContentCreationFailedFaultType * inst);

/**
 * Copy a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 *
 * Perform a deep copy of a wssg_ContentCreationFailedFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wssg_ContentCreationFailedFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wssg_ContentCreationFailedFaultType to be copied.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_copy(
    wssg_ContentCreationFailedFaultType ** dest,
    const wssg_ContentCreationFailedFaultType * src);

/**
 * Initialize the contents of a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 *
 * Initialize the contents of a wssg_ContentCreationFailedFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wssg_ContentCreationFailedFaultType_init(). The contents may be freed
 * by calling wssg_ContentCreationFailedFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wssg_ContentCreationFailedFaultType.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_init_contents(
    wssg_ContentCreationFailedFaultType * instance);

/**
 * Destroy the contents of a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 *
 * Destroy the subelements and attributes of the given wssg_ContentCreationFailedFaultType. 
 *
 * @param inst
 *     Pointer to a wssg_ContentCreationFailedFaultType instance to destroy.
 */
void
wssg_ContentCreationFailedFaultType_destroy_contents(
    wssg_ContentCreationFailedFaultType * inst);

/**
 * Copy the contents of a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 *
 * Perform a deep copy of the contents of a wssg_ContentCreationFailedFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wssg_ContentCreationFailedFaultType to be copied.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_copy_contents(
    wssg_ContentCreationFailedFaultType * dest,
    const wssg_ContentCreationFailedFaultType * src);

/**
 * Serialize a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType_array
 * Serialize a wssg_ContentCreationFailedFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wssg_ContentCreationFailedFaultType.
 * @param val
 *     The wssg_ContentCreationFailedFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_serialize(
    xsd_QName *                         element_name,
    wssg_ContentCreationFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType_array
 * Serialize a wssg_ContentCreationFailedFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wssg_ContentCreationFailedFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wssg_ContentCreationFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 * Deserialize an element containing a wssg_ContentCreationFailedFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ContentCreationFailedFaultType.
 * @param val
 *     Pointer to the wssg_ContentCreationFailedFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_deserialize(
    xsd_QName *                         element_name,
    wssg_ContentCreationFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 * Deserialize a wssg_ContentCreationFailedFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wssg_ContentCreationFailedFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wssg_ContentCreationFailedFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wssg_ContentCreationFailedFaultType
 * @ingroup wssg_ContentCreationFailedFaultType
 * Deserialize the next element if it contains a wssg_ContentCreationFailedFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ContentCreationFailedFaultType.
 * @param instance
 *     Pointer to the <code>wssg_ContentCreationFailedFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentCreationFailedFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wssg_ContentCreationFailedFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wssg_ContentCreationFailedFaultType_init_wrapper(
    void **                             object);
    
void
wssg_ContentCreationFailedFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wssg_ContentCreationFailedFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wssg_ContentCreationFailedFaultType_init_contents_wrapper(
    void *                              object);
    
void
wssg_ContentCreationFailedFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wssg_ContentCreationFailedFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wssg_ContentCreationFailedFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ContentCreationFailedFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ContentCreationFailedFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wssg_ContentCreationFailedFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
