/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDL-to-C Converter
 */

#ifndef _WSSG_CONTENTELEMENTSTYPE_H_
#define _WSSG_CONTENTELEMENTSTYPE_H_

#include "globus_common.h"

/**
 * @defgroup wssg_ContentElementsType Simple Type: wssg_ContentElementsType
 * @ingroup types
 */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */


#include "xsd_QName.h"

/**
 * @ingroup wssg_ContentElementsType
 */
typedef xsd_QName_array wssg_ContentElementsType;

/**
 * Optional wssg_ContentElementsType element
 * @ingroup wssg_ContentElementsType
 */
typedef wssg_ContentElementsType * wssg_ContentElementsType_o;

/**
 * Array of wssg_ContentElementsType elements
 * @ingroup wssg_ContentElementsType
 *
 * This structure type is used represent an array of
 * wssg_ContentElementsType elements.
 *
 * Arrays are allocated by wssg_ContentElementsType_array_init() and freed by calling
 * wssg_ContentElementsType_array_destroy(). Elements may be added to an array by calling
 * wssg_ContentElementsType_array_push().
 */
typedef struct wssg_ContentElementsType_array_s
{
    /** Dynamic array of elements */
    wssg_ContentElementsType * elements;
    /** Number of elements in this array */
    int                                 length;
} wssg_ContentElementsType_array;

/**
 * Namespace of the wssg_ContentElementsType complex type
 * @ingroup wssg_ContentElementsType
 */
#define WSSG_CONTENTELEMENTSTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wssg_ContentElementsType complex type
 * @ingroup wssg_ContentElementsType
 */
#define WSSG_CONTENTELEMENTSTYPE_LOCAL "ContentElementsType"

/**
 * QName of the wssg_ContentElementsType complex type
 * @ingroup wssg_ContentElementsType
 */
extern xsd_QName wssg_ContentElementsType_qname;
/**
 * Type information for serializing and deserializing wssg_ContentElementsType elements
 * @ingroup wssg_ContentElementsType
 */
extern struct globus_xsd_type_info_s wssg_ContentElementsType_info;
/**
 * Type information for serializing and deserializing arrays of wssg_ContentElementsType
 * elements
 * @ingroup wssg_ContentElementsType
 */
extern struct globus_xsd_type_info_s wssg_ContentElementsType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wssg_ContentElementsType without surrounding elements
 * @ingroup wssg_ContentElementsType
 */
extern struct globus_xsd_type_info_s wssg_ContentElementsType_contents_info;

/**
 * Initialize a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 *
 * Allocates a new wssg_ContentElementsType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wssg_ContentElementsType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wssg_ContentElementsType_init(
    wssg_ContentElementsType ** inst);

/**
 * Destroy a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 *
 * Frees a wssg_ContentElementsType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wssg_ContentElementsType_destroy(
    wssg_ContentElementsType * inst);

/**
 * Copy a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 *
 * Perform a deep copy of a wssg_ContentElementsType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wssg_ContentElementsType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wssg_ContentElementsType to be copied.
 */
globus_result_t
wssg_ContentElementsType_copy(
    wssg_ContentElementsType ** dest,
    const wssg_ContentElementsType * src);

/**
 * Initialize the contents of a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 *
 * Initialize the contents of a wssg_ContentElementsType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wssg_ContentElementsType_init(). The contents may be freed
 * by calling wssg_ContentElementsType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wssg_ContentElementsType.
 */
globus_result_t
wssg_ContentElementsType_init_contents(
    wssg_ContentElementsType * instance);

/**
 * Destroy the contents of a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 *
 * Destroy the subelements and attributes of the given wssg_ContentElementsType. 
 *
 * @param inst
 *     Pointer to a wssg_ContentElementsType instance to destroy.
 */
void
wssg_ContentElementsType_destroy_contents(
    wssg_ContentElementsType * inst);

/**
 * Copy the contents of a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 *
 * Perform a deep copy of the contents of a wssg_ContentElementsType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wssg_ContentElementsType to be copied.
 */
globus_result_t
wssg_ContentElementsType_copy_contents(
    wssg_ContentElementsType * dest,
    const wssg_ContentElementsType * src);

/**
 * Initialize an array of wssg_ContentElementsType elements.
 * @ingroup wssg_ContentElementsType
 *
 * Allocates a new array of 0 elements. When this array is no longer used,
 * it should be freed by calling 
 * wssg_ContentElementsType_array_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated array instance.
 */
globus_result_t
wssg_ContentElementsType_array_init(
    wssg_ContentElementsType_array ** inst);

/**
 * Destroy an array of wssg_ContentElementsType elements.
 * @ingroup wssg_ContentElementsType
 *
 * Frees an array of wssg_ContentElementsType elements. The contents of each element
 * element in the array be destroyed by calling
 * wssg_ContentElementsType_destroy_contents().
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wssg_ContentElementsType_array_destroy(
    wssg_ContentElementsType_array * inst);

/**
 * Copy an array of wssg_ContentElementsType elements
 * @ingroup wssg_ContentElementsType
 *
 * Perform a deep copy of an array of wssg_ContentElementsType elements.
 * The @a dest array will be allocated, and then a copy of the contents
 * of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wssg_ContentElementsType_array_copy(
    wssg_ContentElementsType_array ** dest,
    const wssg_ContentElementsType_array * src);

/**
 * Initialize the contents of an array of wssg_ContentElementsType elements
 * @ingroup wssg_ContentElementsType
 *
 * Initialize the contents of an array of wssg_ContentElementsType elements. Used
 * when the array is allocated on the stack or by a some allocator besides
 * wssg_ContentElementsType_array_init(). The contents of the array may be freed
 * by calling wssg_ContentElementsType_array_destroy_contents().
 *
 * @param inst
 *     Pointer to an allocated but uninitialized array.
 */
globus_result_t
wssg_ContentElementsType_array_init_contents(
    wssg_ContentElementsType_array * inst);

/**
 * Destroy the contents of an array of wssg_ContentElementsType elements
 * @ingroup wssg_ContentElementsType
 *
 * Destroy the elements in an array of wssg_ContentElementsType elements. The contents of
 * each element in the array be destroyed by calling
 * wssg_ContentElementsType_destroy_contents() and the array will be reset to be empty.
 *
 * @param inst
 *     Pointer to array instance to destroy.
 */
void
wssg_ContentElementsType_array_destroy_contents(
    wssg_ContentElementsType_array * inst);

/**
 * Copy the contents of an array of wssg_ContentElementsType elements
 * @ingroup wssg_ContentElementsType
 *
 * Perform a deep copy of an array of wssg_ContentElementsType elements.
 * The @a dest array must be allocated before making this call.
 * A copy of the contents of each element in @a src will be made to @a dest.
 * 
 * @param dest
 *     Array to be initialized with copies of the elements in @a src.
 * @param src
 *     Source array to be copied.
 */
globus_result_t
wssg_ContentElementsType_array_copy_contents(
    wssg_ContentElementsType_array * dest,
    const wssg_ContentElementsType_array * src);

/**
 * Append a new wssg_ContentElementsType to an array
 * @ingroup wssg_ContentElementsType
 *
 * Allocate and initialize a new wssg_ContentElementsType structure, adding it
 * to the end of the given @a array.
 * 
 * @param array
 *     Array to be appended to.
 *
 * @return This function returns the newly allocated element.
 */
wssg_ContentElementsType *
wssg_ContentElementsType_array_push(
    wssg_ContentElementsType_array * array);

/**
 * Serialize a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType_array
 * Serialize a wssg_ContentElementsType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wssg_ContentElementsType.
 * @param val
 *     The wssg_ContentElementsType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ContentElementsType_serialize(
    xsd_QName *                         element_name,
    wssg_ContentElementsType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType_array
 * Serialize a wssg_ContentElementsType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wssg_ContentElementsType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ContentElementsType_serialize_contents(
    xsd_QName *                         element_name,
    wssg_ContentElementsType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 * Deserialize an element containing a wssg_ContentElementsType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ContentElementsType.
 * @param val
 *     Pointer to the wssg_ContentElementsType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentElementsType_deserialize(
    xsd_QName *                         element_name,
    wssg_ContentElementsType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 * Deserialize a wssg_ContentElementsType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wssg_ContentElementsType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentElementsType_deserialize_contents(
    xsd_QName *                         element_name,
    wssg_ContentElementsType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 * Deserialize the next element if it contains a wssg_ContentElementsType.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ContentElementsType.
 * @param instance
 *     Pointer to the <code>wssg_ContentElementsType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentElementsType_deserialize_pointer(
    xsd_QName *                         element_name,
    wssg_ContentElementsType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize an array of wssg_ContentElementsType elements
 * @ingroup wssg_ContentElementsType
 * Serialize an element containing an array of wssg_ContentElementsType elements.
 *
 * @param element
 *     The name of the element which will contain the array.
 * @param array_instance
 *     The array to serialize
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ContentElementsType_array_serialize(
    xsd_QName *                         element,
    wssg_ContentElementsType_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an array of wssg_ContentElementsType elements
 * @ingroup wssg_ContentElementsType
 * Deserialize an element containing an array of wssg_ContentElementsType elements.
 *
 * @param element
 *     The name of the element which should enclose the array.
 * @param array_instance
 *     The array to deserialize into
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentElementsType_array_deserialize(
    xsd_QName *                         element,
    wssg_ContentElementsType_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);



/**
 * Serialize an attribute of type wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType_array
 * Serialize a wssg_ContentElementsType as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wssg_ContentElementsType.
 * @param val
 *     The wssg_ContentElementsType to serialize.
 * @param message
 *     The handle to serialize the attribute on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ContentElementsType_serialize_attribute(
    xsd_QName *                         attr_qname,
    wssg_ContentElementsType * val,
    globus_soap_message_handle_t        handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an attribute of type wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 * Deserialize a wssg_ContentElementsType as an attribute of the current element.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wssg_ContentElementsType.
 * @param instance
 *     Pointer to the wssg_ContentElementsType which will be initialized with the
 *     value of the attribute.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentElementsType_deserialize_attribute(
    xsd_QName *                         attr_qname,
    wssg_ContentElementsType * instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional attribute of type wssg_ContentElementsType
 * @ingroup wssg_ContentElementsType
 * Try to deserialize a wssg_ContentElementsType as an attribute of the current element
 * if it is present. The attribute's name is defined by @ attr_qname.
 *
 * @param attr_qname
 *     The name of the attribute whose value is a wssg_ContentElementsType.
 * @param instance
 *     Pointer to the wssg_ContentElementsType which will be allocated and initialized
 *     with the value of the attribute if it is present.
 * @param message
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ContentElementsType_deserialize_attribute_pointer(
    xsd_QName *                         attr_qname,
    wssg_ContentElementsType ** instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);


#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
globus_result_t
wssg_ContentElementsType_init_wrapper(
    void **                             object);
    
void
wssg_ContentElementsType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wssg_ContentElementsType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);
    
globus_result_t
wssg_ContentElementsType_init_contents_wrapper(
    void  *                             object);
    
void
wssg_ContentElementsType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wssg_ContentElementsType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);
    
globus_result_t
wssg_ContentElementsType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ContentElementsType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ContentElementsType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ContentElementsType_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ContentElementsType_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ContentElementsType_array_init_wrapper(
    void **                             arr);
    
void
wssg_ContentElementsType_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
wssg_ContentElementsType_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);
globus_result_t
wssg_ContentElementsType_array_init_contents_wrapper(
    void *                              arr);
    
void
wssg_ContentElementsType_array_destroy_contents_wrapper(
    void *                              arr);
    
globus_result_t
wssg_ContentElementsType_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);
    
globus_result_t
wssg_ContentElementsType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

void *
wssg_ContentElementsType_array_push_wrapper(
    void * array);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
