/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSSG_SERVICEGROUPREMOVALNOTIFICATIONTYPE_H_
#define _WSSG_SERVICEGROUPREMOVALNOTIFICATIONTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wssg_ServiceGroupRemovalNotificationType complex type, which represents the
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}ServiceGroupRemovalNotificationType element.
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
typedef struct wssg_ServiceGroupRemovalNotificationType_s wssg_ServiceGroupRemovalNotificationType;
/**
 * The wssg_ServiceGroupRemovalNotificationType_o complex type, which represents an optional instance
 * of a
 * {http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd}ServiceGroupRemovalNotificationType element.
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
typedef wssg_ServiceGroupRemovalNotificationType * wssg_ServiceGroupRemovalNotificationType_o;

/**
 * Namespace of the wssg_ServiceGroupRemovalNotificationType complex type
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
#define WSSG_SERVICEGROUPREMOVALNOTIFICATIONTYPE_NS "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
/**
 * Local part of the QName of the wssg_ServiceGroupRemovalNotificationType complex type
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
#define WSSG_SERVICEGROUPREMOVALNOTIFICATIONTYPE_LOCAL "ServiceGroupRemovalNotificationType"

/**
 * QName of the wssg_ServiceGroupRemovalNotificationType complex type
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
extern xsd_QName wssg_ServiceGroupRemovalNotificationType_qname;
/**
 * Type information for serializing and deserializing wssg_ServiceGroupRemovalNotificationType elements
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupRemovalNotificationType_info;
/**
 * Type information for serializing and deserializing arrays of wssg_ServiceGroupRemovalNotificationType
 * elements
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupRemovalNotificationType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wssg_ServiceGroupRemovalNotificationType without surrounding elements
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
extern struct globus_xsd_type_info_s wssg_ServiceGroupRemovalNotificationType_contents_info;


#include "wsa_EndpointReferenceType.h"
#include "wsa_EndpointReferenceType.h"
#include "xsd_anyType.h"
#include "xsd_string.h"
#include "wssg_ServiceGroupRemovalNotificationType_array.h"

/**
 * @defgroup wssg_ServiceGroupRemovalNotificationType Complex type: wssg_ServiceGroupRemovalNotificationType
 * @ingroup types
 */

/**
 * C structure for the wssg_ServiceGroupRemovalNotificationType complex type
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 */
struct wssg_ServiceGroupRemovalNotificationType_s
{
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType ServiceGroupEntryEPR;
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType MemberServiceEPR;
   /** Optional xsd_anyType subelement */
    xsd_anyType_o Content;
   /** Optional xsd_string subelement */
    xsd_string_o Reason;

};

/**
 * Initialize a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 *
 * Allocates a new wssg_ServiceGroupRemovalNotificationType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wssg_ServiceGroupRemovalNotificationType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_init(
    wssg_ServiceGroupRemovalNotificationType ** inst);

/**
 * Destroy a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 *
 * Frees a wssg_ServiceGroupRemovalNotificationType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wssg_ServiceGroupRemovalNotificationType_destroy(
    wssg_ServiceGroupRemovalNotificationType * inst);

/**
 * Copy a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 *
 * Perform a deep copy of a wssg_ServiceGroupRemovalNotificationType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wssg_ServiceGroupRemovalNotificationType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wssg_ServiceGroupRemovalNotificationType to be copied.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_copy(
    wssg_ServiceGroupRemovalNotificationType ** dest,
    const wssg_ServiceGroupRemovalNotificationType * src);

/**
 * Initialize the contents of a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 *
 * Initialize the contents of a wssg_ServiceGroupRemovalNotificationType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wssg_ServiceGroupRemovalNotificationType_init(). The contents may be freed
 * by calling wssg_ServiceGroupRemovalNotificationType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wssg_ServiceGroupRemovalNotificationType.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_init_contents(
    wssg_ServiceGroupRemovalNotificationType * instance);

/**
 * Destroy the contents of a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 *
 * Destroy the subelements and attributes of the given wssg_ServiceGroupRemovalNotificationType. 
 *
 * @param inst
 *     Pointer to a wssg_ServiceGroupRemovalNotificationType instance to destroy.
 */
void
wssg_ServiceGroupRemovalNotificationType_destroy_contents(
    wssg_ServiceGroupRemovalNotificationType * inst);

/**
 * Copy the contents of a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 *
 * Perform a deep copy of the contents of a wssg_ServiceGroupRemovalNotificationType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wssg_ServiceGroupRemovalNotificationType to be copied.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_copy_contents(
    wssg_ServiceGroupRemovalNotificationType * dest,
    const wssg_ServiceGroupRemovalNotificationType * src);

/**
 * Serialize a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType_array
 * Serialize a wssg_ServiceGroupRemovalNotificationType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wssg_ServiceGroupRemovalNotificationType.
 * @param val
 *     The wssg_ServiceGroupRemovalNotificationType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_serialize(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRemovalNotificationType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType_array
 * Serialize a wssg_ServiceGroupRemovalNotificationType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wssg_ServiceGroupRemovalNotificationType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_serialize_contents(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRemovalNotificationType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 * Deserialize an element containing a wssg_ServiceGroupRemovalNotificationType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ServiceGroupRemovalNotificationType.
 * @param val
 *     Pointer to the wssg_ServiceGroupRemovalNotificationType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_deserialize(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRemovalNotificationType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 * Deserialize a wssg_ServiceGroupRemovalNotificationType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wssg_ServiceGroupRemovalNotificationType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_deserialize_contents(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRemovalNotificationType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wssg_ServiceGroupRemovalNotificationType
 * @ingroup wssg_ServiceGroupRemovalNotificationType
 * Deserialize the next element if it contains a wssg_ServiceGroupRemovalNotificationType.
 *
 * @param element_name
 *     The name of the element which should enclose the wssg_ServiceGroupRemovalNotificationType.
 * @param instance
 *     Pointer to the <code>wssg_ServiceGroupRemovalNotificationType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wssg_ServiceGroupRemovalNotificationType_deserialize_pointer(
    xsd_QName *                         element_name,
    wssg_ServiceGroupRemovalNotificationType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wssg_ServiceGroupRemovalNotificationType_init_wrapper(
    void **                             object);
    
void
wssg_ServiceGroupRemovalNotificationType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wssg_ServiceGroupRemovalNotificationType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wssg_ServiceGroupRemovalNotificationType_init_contents_wrapper(
    void *                              object);
    
void
wssg_ServiceGroupRemovalNotificationType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wssg_ServiceGroupRemovalNotificationType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wssg_ServiceGroupRemovalNotificationType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ServiceGroupRemovalNotificationType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wssg_ServiceGroupRemovalNotificationType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wssg_ServiceGroupRemovalNotificationType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
