/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WST_BASETOKENTYPE_H_
#define _WST_BASETOKENTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wst_BaseTokenType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}BaseTokenType element.
 * @ingroup wst_BaseTokenType
 */
typedef struct wst_BaseTokenType_s wst_BaseTokenType;
/**
 * The wst_BaseTokenType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}BaseTokenType element.
 * @ingroup wst_BaseTokenType
 */
typedef wst_BaseTokenType * wst_BaseTokenType_o;

/**
 * Namespace of the wst_BaseTokenType complex type
 * @ingroup wst_BaseTokenType
 */
#define WST_BASETOKENTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_BaseTokenType complex type
 * @ingroup wst_BaseTokenType
 */
#define WST_BASETOKENTYPE_LOCAL "BaseTokenType"

/**
 * QName of the wst_BaseTokenType complex type
 * @ingroup wst_BaseTokenType
 */
extern xsd_QName wst_BaseTokenType_qname;
/**
 * Type information for serializing and deserializing wst_BaseTokenType elements
 * @ingroup wst_BaseTokenType
 */
extern struct globus_xsd_type_info_s wst_BaseTokenType_info;
/**
 * Type information for serializing and deserializing arrays of wst_BaseTokenType
 * elements
 * @ingroup wst_BaseTokenType
 */
extern struct globus_xsd_type_info_s wst_BaseTokenType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_BaseTokenType without surrounding elements
 * @ingroup wst_BaseTokenType
 */
extern struct globus_xsd_type_info_s wst_BaseTokenType_contents_info;


#include "xsd_any.h"
#include "wst_BaseTokenType_array.h"

/**
 * @defgroup wst_BaseTokenType Complex type: wst_BaseTokenType
 * @ingroup types
 */

/**
 * C structure for the wst_BaseTokenType complex type
 * @ingroup wst_BaseTokenType
 */
struct wst_BaseTokenType_s
{
    /** xsd_any subelement */
    xsd_any any;

};

/**
 * Initialize a wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 *
 * Allocates a new wst_BaseTokenType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_BaseTokenType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_BaseTokenType_init(
    wst_BaseTokenType ** inst);

/**
 * Destroy a wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 *
 * Frees a wst_BaseTokenType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_BaseTokenType_destroy(
    wst_BaseTokenType * inst);

/**
 * Copy a wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 *
 * Perform a deep copy of a wst_BaseTokenType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_BaseTokenType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_BaseTokenType to be copied.
 */
globus_result_t
wst_BaseTokenType_copy(
    wst_BaseTokenType ** dest,
    const wst_BaseTokenType * src);

/**
 * Initialize the contents of a wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 *
 * Initialize the contents of a wst_BaseTokenType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_BaseTokenType_init(). The contents may be freed
 * by calling wst_BaseTokenType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_BaseTokenType.
 */
globus_result_t
wst_BaseTokenType_init_contents(
    wst_BaseTokenType * instance);

/**
 * Destroy the contents of a wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 *
 * Destroy the subelements and attributes of the given wst_BaseTokenType. 
 *
 * @param inst
 *     Pointer to a wst_BaseTokenType instance to destroy.
 */
void
wst_BaseTokenType_destroy_contents(
    wst_BaseTokenType * inst);

/**
 * Copy the contents of a wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 *
 * Perform a deep copy of the contents of a wst_BaseTokenType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_BaseTokenType to be copied.
 */
globus_result_t
wst_BaseTokenType_copy_contents(
    wst_BaseTokenType * dest,
    const wst_BaseTokenType * src);

/**
 * Serialize a wst_BaseTokenType
 * @ingroup wst_BaseTokenType_array
 * Serialize a wst_BaseTokenType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_BaseTokenType.
 * @param val
 *     The wst_BaseTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_BaseTokenType_serialize(
    xsd_QName *                         element_name,
    wst_BaseTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_BaseTokenType
 * @ingroup wst_BaseTokenType_array
 * Serialize a wst_BaseTokenType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_BaseTokenType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_BaseTokenType_serialize_contents(
    xsd_QName *                         element_name,
    wst_BaseTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 * Deserialize an element containing a wst_BaseTokenType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_BaseTokenType.
 * @param val
 *     Pointer to the wst_BaseTokenType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_BaseTokenType_deserialize(
    xsd_QName *                         element_name,
    wst_BaseTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 * Deserialize a wst_BaseTokenType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_BaseTokenType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_BaseTokenType_deserialize_contents(
    xsd_QName *                         element_name,
    wst_BaseTokenType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_BaseTokenType
 * @ingroup wst_BaseTokenType
 * Deserialize the next element if it contains a wst_BaseTokenType.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_BaseTokenType.
 * @param instance
 *     Pointer to the <code>wst_BaseTokenType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_BaseTokenType_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_BaseTokenType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wst_BaseTokenType_init_wrapper(
    void **                             object);
    
void
wst_BaseTokenType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_BaseTokenType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wst_BaseTokenType_init_contents_wrapper(
    void *                              object);
    
void
wst_BaseTokenType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_BaseTokenType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wst_BaseTokenType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_BaseTokenType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_BaseTokenType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wst_BaseTokenType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
