/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WST_BINARYSECRETTYPE_H_
#define _WST_BINARYSECRETTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wst_BinarySecretType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}BinarySecretType element.
 * @ingroup wst_BinarySecretType
 */
typedef struct wst_BinarySecretType_s wst_BinarySecretType;
/**
 * The wst_BinarySecretType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}BinarySecretType element.
 * @ingroup wst_BinarySecretType
 */
typedef wst_BinarySecretType * wst_BinarySecretType_o;

/**
 * Namespace of the wst_BinarySecretType complex type
 * @ingroup wst_BinarySecretType
 */
#define WST_BINARYSECRETTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_BinarySecretType complex type
 * @ingroup wst_BinarySecretType
 */
#define WST_BINARYSECRETTYPE_LOCAL "BinarySecretType"

/**
 * QName of the wst_BinarySecretType complex type
 * @ingroup wst_BinarySecretType
 */
extern xsd_QName wst_BinarySecretType_qname;
/**
 * Type information for serializing and deserializing wst_BinarySecretType elements
 * @ingroup wst_BinarySecretType
 */
extern struct globus_xsd_type_info_s wst_BinarySecretType_info;
/**
 * Type information for serializing and deserializing arrays of wst_BinarySecretType
 * elements
 * @ingroup wst_BinarySecretType
 */
extern struct globus_xsd_type_info_s wst_BinarySecretType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_BinarySecretType without surrounding elements
 * @ingroup wst_BinarySecretType
 */
extern struct globus_xsd_type_info_s wst_BinarySecretType_contents_info;


#include "xsd_base64Binary.h"
#include "xsd_anyAttributes.h"
#include "wst_BinarySecretTypeOpenEnum.h"
#include "wst_BinarySecretType_array.h"

/**
 * @defgroup wst_BinarySecretType Complex type: wst_BinarySecretType
 * @ingroup types
 */

/**
 * C structure for the wst_BinarySecretType complex type
 * @ingroup wst_BinarySecretType
 */
struct wst_BinarySecretType_s
{
    /** xsd_base64Binary subelement */
    xsd_base64Binary base_value;
    xsd_anyAttributes_t anyAttributes;
    wst_BinarySecretTypeOpenEnum_o _Type;

};

/**
 * Initialize a wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 *
 * Allocates a new wst_BinarySecretType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_BinarySecretType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_BinarySecretType_init(
    wst_BinarySecretType ** inst);

/**
 * Destroy a wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 *
 * Frees a wst_BinarySecretType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_BinarySecretType_destroy(
    wst_BinarySecretType * inst);

/**
 * Copy a wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 *
 * Perform a deep copy of a wst_BinarySecretType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_BinarySecretType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_BinarySecretType to be copied.
 */
globus_result_t
wst_BinarySecretType_copy(
    wst_BinarySecretType ** dest,
    const wst_BinarySecretType * src);

/**
 * Initialize the contents of a wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 *
 * Initialize the contents of a wst_BinarySecretType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_BinarySecretType_init(). The contents may be freed
 * by calling wst_BinarySecretType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_BinarySecretType.
 */
globus_result_t
wst_BinarySecretType_init_contents(
    wst_BinarySecretType * instance);

/**
 * Destroy the contents of a wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 *
 * Destroy the subelements and attributes of the given wst_BinarySecretType. 
 *
 * @param inst
 *     Pointer to a wst_BinarySecretType instance to destroy.
 */
void
wst_BinarySecretType_destroy_contents(
    wst_BinarySecretType * inst);

/**
 * Copy the contents of a wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 *
 * Perform a deep copy of the contents of a wst_BinarySecretType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_BinarySecretType to be copied.
 */
globus_result_t
wst_BinarySecretType_copy_contents(
    wst_BinarySecretType * dest,
    const wst_BinarySecretType * src);

/**
 * Serialize a wst_BinarySecretType
 * @ingroup wst_BinarySecretType_array
 * Serialize a wst_BinarySecretType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_BinarySecretType.
 * @param val
 *     The wst_BinarySecretType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_BinarySecretType_serialize(
    xsd_QName *                         element_name,
    wst_BinarySecretType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_BinarySecretType
 * @ingroup wst_BinarySecretType_array
 * Serialize a wst_BinarySecretType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_BinarySecretType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_BinarySecretType_serialize_contents(
    xsd_QName *                         element_name,
    wst_BinarySecretType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 * Deserialize an element containing a wst_BinarySecretType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_BinarySecretType.
 * @param val
 *     Pointer to the wst_BinarySecretType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_BinarySecretType_deserialize(
    xsd_QName *                         element_name,
    wst_BinarySecretType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 * Deserialize a wst_BinarySecretType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_BinarySecretType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_BinarySecretType_deserialize_contents(
    xsd_QName *                         element_name,
    wst_BinarySecretType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_BinarySecretType
 * @ingroup wst_BinarySecretType
 * Deserialize the next element if it contains a wst_BinarySecretType.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_BinarySecretType.
 * @param instance
 *     Pointer to the <code>wst_BinarySecretType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_BinarySecretType_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_BinarySecretType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wst_BinarySecretType_init_wrapper(
    void **                             object);
    
void
wst_BinarySecretType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_BinarySecretType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wst_BinarySecretType_init_contents_wrapper(
    void *                              object);
    
void
wst_BinarySecretType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_BinarySecretType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wst_BinarySecretType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_BinarySecretType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_BinarySecretType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wst_BinarySecretType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
