/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WST_USEKEYTYPE_H_
#define _WST_USEKEYTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wst_UseKeyType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}UseKeyType element.
 * @ingroup wst_UseKeyType
 */
typedef struct wst_UseKeyType_s wst_UseKeyType;
/**
 * The wst_UseKeyType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2004/04/trust}UseKeyType element.
 * @ingroup wst_UseKeyType
 */
typedef wst_UseKeyType * wst_UseKeyType_o;

/**
 * Namespace of the wst_UseKeyType complex type
 * @ingroup wst_UseKeyType
 */
#define WST_USEKEYTYPE_NS "http://schemas.xmlsoap.org/ws/2004/04/trust"
/**
 * Local part of the QName of the wst_UseKeyType complex type
 * @ingroup wst_UseKeyType
 */
#define WST_USEKEYTYPE_LOCAL "UseKeyType"

/**
 * QName of the wst_UseKeyType complex type
 * @ingroup wst_UseKeyType
 */
extern xsd_QName wst_UseKeyType_qname;
/**
 * Type information for serializing and deserializing wst_UseKeyType elements
 * @ingroup wst_UseKeyType
 */
extern struct globus_xsd_type_info_s wst_UseKeyType_info;
/**
 * Type information for serializing and deserializing arrays of wst_UseKeyType
 * elements
 * @ingroup wst_UseKeyType
 */
extern struct globus_xsd_type_info_s wst_UseKeyType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wst_UseKeyType without surrounding elements
 * @ingroup wst_UseKeyType
 */
extern struct globus_xsd_type_info_s wst_UseKeyType_contents_info;


#include "xsd_any.h"
#include "xsd_anyURI.h"
#include "wst_UseKeyType_array.h"

/**
 * @defgroup wst_UseKeyType Complex type: wst_UseKeyType
 * @ingroup types
 */

/**
 * C structure for the wst_UseKeyType complex type
 * @ingroup wst_UseKeyType
 */
struct wst_UseKeyType_s
{
   /** Optional xsd_any subelement */
    xsd_any_o any;
    xsd_anyURI_o _Sig;

};

/**
 * Initialize a wst_UseKeyType
 * @ingroup wst_UseKeyType
 *
 * Allocates a new wst_UseKeyType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wst_UseKeyType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wst_UseKeyType_init(
    wst_UseKeyType ** inst);

/**
 * Destroy a wst_UseKeyType
 * @ingroup wst_UseKeyType
 *
 * Frees a wst_UseKeyType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wst_UseKeyType_destroy(
    wst_UseKeyType * inst);

/**
 * Copy a wst_UseKeyType
 * @ingroup wst_UseKeyType
 *
 * Perform a deep copy of a wst_UseKeyType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wst_UseKeyType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wst_UseKeyType to be copied.
 */
globus_result_t
wst_UseKeyType_copy(
    wst_UseKeyType ** dest,
    const wst_UseKeyType * src);

/**
 * Initialize the contents of a wst_UseKeyType
 * @ingroup wst_UseKeyType
 *
 * Initialize the contents of a wst_UseKeyType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wst_UseKeyType_init(). The contents may be freed
 * by calling wst_UseKeyType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wst_UseKeyType.
 */
globus_result_t
wst_UseKeyType_init_contents(
    wst_UseKeyType * instance);

/**
 * Destroy the contents of a wst_UseKeyType
 * @ingroup wst_UseKeyType
 *
 * Destroy the subelements and attributes of the given wst_UseKeyType. 
 *
 * @param inst
 *     Pointer to a wst_UseKeyType instance to destroy.
 */
void
wst_UseKeyType_destroy_contents(
    wst_UseKeyType * inst);

/**
 * Copy the contents of a wst_UseKeyType
 * @ingroup wst_UseKeyType
 *
 * Perform a deep copy of the contents of a wst_UseKeyType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wst_UseKeyType to be copied.
 */
globus_result_t
wst_UseKeyType_copy_contents(
    wst_UseKeyType * dest,
    const wst_UseKeyType * src);

/**
 * Serialize a wst_UseKeyType
 * @ingroup wst_UseKeyType_array
 * Serialize a wst_UseKeyType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wst_UseKeyType.
 * @param val
 *     The wst_UseKeyType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_UseKeyType_serialize(
    xsd_QName *                         element_name,
    wst_UseKeyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wst_UseKeyType
 * @ingroup wst_UseKeyType_array
 * Serialize a wst_UseKeyType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wst_UseKeyType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wst_UseKeyType_serialize_contents(
    xsd_QName *                         element_name,
    wst_UseKeyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_UseKeyType
 * @ingroup wst_UseKeyType
 * Deserialize an element containing a wst_UseKeyType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_UseKeyType.
 * @param val
 *     Pointer to the wst_UseKeyType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_UseKeyType_deserialize(
    xsd_QName *                         element_name,
    wst_UseKeyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wst_UseKeyType
 * @ingroup wst_UseKeyType
 * Deserialize a wst_UseKeyType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wst_UseKeyType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_UseKeyType_deserialize_contents(
    xsd_QName *                         element_name,
    wst_UseKeyType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wst_UseKeyType
 * @ingroup wst_UseKeyType
 * Deserialize the next element if it contains a wst_UseKeyType.
 *
 * @param element_name
 *     The name of the element which should enclose the wst_UseKeyType.
 * @param instance
 *     Pointer to the <code>wst_UseKeyType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wst_UseKeyType_deserialize_pointer(
    xsd_QName *                         element_name,
    wst_UseKeyType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wst_UseKeyType_init_wrapper(
    void **                             object);
    
void
wst_UseKeyType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wst_UseKeyType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wst_UseKeyType_init_contents_wrapper(
    void *                              object);
    
void
wst_UseKeyType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wst_UseKeyType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wst_UseKeyType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_UseKeyType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wst_UseKeyType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wst_UseKeyType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
