/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSU_ATTRIBUTEDDATETIME_H_
#define _WSU_ATTRIBUTEDDATETIME_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsu_AttributedDateTime complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}AttributedDateTime element.
 * @ingroup wsu_AttributedDateTime
 */
typedef struct wsu_AttributedDateTime_s wsu_AttributedDateTime;
/**
 * The wsu_AttributedDateTime_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}AttributedDateTime element.
 * @ingroup wsu_AttributedDateTime
 */
typedef wsu_AttributedDateTime * wsu_AttributedDateTime_o;

/**
 * Namespace of the wsu_AttributedDateTime complex type
 * @ingroup wsu_AttributedDateTime
 */
#define WSU_ATTRIBUTEDDATETIME_NS "http://schemas.xmlsoap.org/ws/2002/07/utility"
/**
 * Local part of the QName of the wsu_AttributedDateTime complex type
 * @ingroup wsu_AttributedDateTime
 */
#define WSU_ATTRIBUTEDDATETIME_LOCAL "AttributedDateTime"

/**
 * QName of the wsu_AttributedDateTime complex type
 * @ingroup wsu_AttributedDateTime
 */
extern xsd_QName wsu_AttributedDateTime_qname;
/**
 * Type information for serializing and deserializing wsu_AttributedDateTime elements
 * @ingroup wsu_AttributedDateTime
 */
extern struct globus_xsd_type_info_s wsu_AttributedDateTime_info;
/**
 * Type information for serializing and deserializing arrays of wsu_AttributedDateTime
 * elements
 * @ingroup wsu_AttributedDateTime
 */
extern struct globus_xsd_type_info_s wsu_AttributedDateTime_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsu_AttributedDateTime without surrounding elements
 * @ingroup wsu_AttributedDateTime
 */
extern struct globus_xsd_type_info_s wsu_AttributedDateTime_contents_info;


#include "xsd_string.h"
#include "xsd_QName.h"
#include "xsd_ID.h"
#include "xsd_anyAttributes.h"
#include "wsu_AttributedDateTime_array.h"

/**
 * @defgroup wsu_AttributedDateTime Complex type: wsu_AttributedDateTime
 * @ingroup types
 */

/**
 * C structure for the wsu_AttributedDateTime complex type
 * @ingroup wsu_AttributedDateTime
 */
struct wsu_AttributedDateTime_s
{
    /** xsd_string subelement */
    xsd_string base_value;
    xsd_QName_o _ValueType;
    xsd_ID_o _Id;
    xsd_anyAttributes_t anyAttributes;

};

/**
 * Initialize a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 *
 * Allocates a new wsu_AttributedDateTime and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsu_AttributedDateTime_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsu_AttributedDateTime_init(
    wsu_AttributedDateTime ** inst);

/**
 * Destroy a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 *
 * Frees a wsu_AttributedDateTime. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsu_AttributedDateTime_destroy(
    wsu_AttributedDateTime * inst);

/**
 * Copy a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 *
 * Perform a deep copy of a wsu_AttributedDateTime.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsu_AttributedDateTime structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsu_AttributedDateTime to be copied.
 */
globus_result_t
wsu_AttributedDateTime_copy(
    wsu_AttributedDateTime ** dest,
    const wsu_AttributedDateTime * src);

/**
 * Initialize the contents of a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 *
 * Initialize the contents of a wsu_AttributedDateTime. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsu_AttributedDateTime_init(). The contents may be freed
 * by calling wsu_AttributedDateTime_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsu_AttributedDateTime.
 */
globus_result_t
wsu_AttributedDateTime_init_contents(
    wsu_AttributedDateTime * instance);

/**
 * Destroy the contents of a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 *
 * Destroy the subelements and attributes of the given wsu_AttributedDateTime. 
 *
 * @param inst
 *     Pointer to a wsu_AttributedDateTime instance to destroy.
 */
void
wsu_AttributedDateTime_destroy_contents(
    wsu_AttributedDateTime * inst);

/**
 * Copy the contents of a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 *
 * Perform a deep copy of the contents of a wsu_AttributedDateTime.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsu_AttributedDateTime to be copied.
 */
globus_result_t
wsu_AttributedDateTime_copy_contents(
    wsu_AttributedDateTime * dest,
    const wsu_AttributedDateTime * src);

/**
 * Serialize a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime_array
 * Serialize a wsu_AttributedDateTime structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsu_AttributedDateTime.
 * @param val
 *     The wsu_AttributedDateTime to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_AttributedDateTime_serialize(
    xsd_QName *                         element_name,
    wsu_AttributedDateTime * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime_array
 * Serialize a wsu_AttributedDateTime structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsu_AttributedDateTime to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_AttributedDateTime_serialize_contents(
    xsd_QName *                         element_name,
    wsu_AttributedDateTime * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 * Deserialize an element containing a wsu_AttributedDateTime element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_AttributedDateTime.
 * @param val
 *     Pointer to the wsu_AttributedDateTime which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_AttributedDateTime_deserialize(
    xsd_QName *                         element_name,
    wsu_AttributedDateTime * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 * Deserialize a wsu_AttributedDateTime whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsu_AttributedDateTime which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_AttributedDateTime_deserialize_contents(
    xsd_QName *                         element_name,
    wsu_AttributedDateTime * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsu_AttributedDateTime
 * @ingroup wsu_AttributedDateTime
 * Deserialize the next element if it contains a wsu_AttributedDateTime.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_AttributedDateTime.
 * @param instance
 *     Pointer to the <code>wsu_AttributedDateTime *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_AttributedDateTime_deserialize_pointer(
    xsd_QName *                         element_name,
    wsu_AttributedDateTime ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsu_AttributedDateTime_init_wrapper(
    void **                             object);
    
void
wsu_AttributedDateTime_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsu_AttributedDateTime_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsu_AttributedDateTime_init_contents_wrapper(
    void *                              object);
    
void
wsu_AttributedDateTime_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsu_AttributedDateTime_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsu_AttributedDateTime_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_AttributedDateTime_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_AttributedDateTime_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_AttributedDateTime_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
