/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSU_PORTREFERENCETYPE_H_
#define _WSU_PORTREFERENCETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsu_PortReferenceType complex type, which represents the
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}PortReferenceType element.
 * @ingroup wsu_PortReferenceType
 */
typedef struct wsu_PortReferenceType_s wsu_PortReferenceType;
/**
 * The wsu_PortReferenceType_o complex type, which represents an optional instance
 * of a
 * {http://schemas.xmlsoap.org/ws/2002/07/utility}PortReferenceType element.
 * @ingroup wsu_PortReferenceType
 */
typedef wsu_PortReferenceType * wsu_PortReferenceType_o;

/**
 * Namespace of the wsu_PortReferenceType complex type
 * @ingroup wsu_PortReferenceType
 */
#define WSU_PORTREFERENCETYPE_NS "http://schemas.xmlsoap.org/ws/2002/07/utility"
/**
 * Local part of the QName of the wsu_PortReferenceType complex type
 * @ingroup wsu_PortReferenceType
 */
#define WSU_PORTREFERENCETYPE_LOCAL "PortReferenceType"

/**
 * QName of the wsu_PortReferenceType complex type
 * @ingroup wsu_PortReferenceType
 */
extern xsd_QName wsu_PortReferenceType_qname;
/**
 * Type information for serializing and deserializing wsu_PortReferenceType elements
 * @ingroup wsu_PortReferenceType
 */
extern struct globus_xsd_type_info_s wsu_PortReferenceType_info;
/**
 * Type information for serializing and deserializing arrays of wsu_PortReferenceType
 * elements
 * @ingroup wsu_PortReferenceType
 */
extern struct globus_xsd_type_info_s wsu_PortReferenceType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsu_PortReferenceType without surrounding elements
 * @ingroup wsu_PortReferenceType
 */
extern struct globus_xsd_type_info_s wsu_PortReferenceType_contents_info;


#include "wsu_AttributedURI.h"
#include "xsd_any.h"
#include "xsd_anyAttributes.h"
#include "xsd_ID.h"
#include "wsu_PortReferenceType_array.h"

/**
 * @defgroup wsu_PortReferenceType Complex type: wsu_PortReferenceType
 * @ingroup types
 */

/**
 * C structure for the wsu_PortReferenceType complex type
 * @ingroup wsu_PortReferenceType
 */
struct wsu_PortReferenceType_s
{
    /** wsu_AttributedURI subelement */
    wsu_AttributedURI Address;
   /** Array of [0 .. Infinity] xsd_any elements */
    xsd_any_array any;
    xsd_anyAttributes_t anyAttributes;
    xsd_ID_o _Id;

};

/**
 * Initialize a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 *
 * Allocates a new wsu_PortReferenceType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsu_PortReferenceType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsu_PortReferenceType_init(
    wsu_PortReferenceType ** inst);

/**
 * Destroy a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 *
 * Frees a wsu_PortReferenceType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsu_PortReferenceType_destroy(
    wsu_PortReferenceType * inst);

/**
 * Copy a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 *
 * Perform a deep copy of a wsu_PortReferenceType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsu_PortReferenceType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsu_PortReferenceType to be copied.
 */
globus_result_t
wsu_PortReferenceType_copy(
    wsu_PortReferenceType ** dest,
    const wsu_PortReferenceType * src);

/**
 * Initialize the contents of a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 *
 * Initialize the contents of a wsu_PortReferenceType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsu_PortReferenceType_init(). The contents may be freed
 * by calling wsu_PortReferenceType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsu_PortReferenceType.
 */
globus_result_t
wsu_PortReferenceType_init_contents(
    wsu_PortReferenceType * instance);

/**
 * Destroy the contents of a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 *
 * Destroy the subelements and attributes of the given wsu_PortReferenceType. 
 *
 * @param inst
 *     Pointer to a wsu_PortReferenceType instance to destroy.
 */
void
wsu_PortReferenceType_destroy_contents(
    wsu_PortReferenceType * inst);

/**
 * Copy the contents of a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 *
 * Perform a deep copy of the contents of a wsu_PortReferenceType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsu_PortReferenceType to be copied.
 */
globus_result_t
wsu_PortReferenceType_copy_contents(
    wsu_PortReferenceType * dest,
    const wsu_PortReferenceType * src);

/**
 * Serialize a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType_array
 * Serialize a wsu_PortReferenceType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsu_PortReferenceType.
 * @param val
 *     The wsu_PortReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_PortReferenceType_serialize(
    xsd_QName *                         element_name,
    wsu_PortReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType_array
 * Serialize a wsu_PortReferenceType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsu_PortReferenceType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsu_PortReferenceType_serialize_contents(
    xsd_QName *                         element_name,
    wsu_PortReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 * Deserialize an element containing a wsu_PortReferenceType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_PortReferenceType.
 * @param val
 *     Pointer to the wsu_PortReferenceType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_PortReferenceType_deserialize(
    xsd_QName *                         element_name,
    wsu_PortReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 * Deserialize a wsu_PortReferenceType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsu_PortReferenceType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_PortReferenceType_deserialize_contents(
    xsd_QName *                         element_name,
    wsu_PortReferenceType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsu_PortReferenceType
 * @ingroup wsu_PortReferenceType
 * Deserialize the next element if it contains a wsu_PortReferenceType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsu_PortReferenceType.
 * @param instance
 *     Pointer to the <code>wsu_PortReferenceType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsu_PortReferenceType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsu_PortReferenceType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsu_PortReferenceType_init_wrapper(
    void **                             object);
    
void
wsu_PortReferenceType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsu_PortReferenceType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsu_PortReferenceType_init_contents_wrapper(
    void *                              object);
    
void
wsu_PortReferenceType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsu_PortReferenceType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsu_PortReferenceType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_PortReferenceType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsu_PortReferenceType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsu_PortReferenceType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
