/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_DELETEREQUESTTYPE_H_
#define _WSTRANSFER_DELETEREQUESTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_DeleteRequestType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}DeleteRequestType element.
 * @ingroup wstransfer_DeleteRequestType
 */
typedef struct wstransfer_DeleteRequestType_s wstransfer_DeleteRequestType;
/**
 * The wstransfer_DeleteRequestType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}DeleteRequestType element.
 * @ingroup wstransfer_DeleteRequestType
 */
typedef wstransfer_DeleteRequestType * wstransfer_DeleteRequestType_o;

/**
 * Namespace of the wstransfer_DeleteRequestType complex type
 * @ingroup wstransfer_DeleteRequestType
 */
#define WSTRANSFER_DELETEREQUESTTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_DeleteRequestType complex type
 * @ingroup wstransfer_DeleteRequestType
 */
#define WSTRANSFER_DELETEREQUESTTYPE_LOCAL "DeleteRequestType"

/**
 * QName of the wstransfer_DeleteRequestType complex type
 * @ingroup wstransfer_DeleteRequestType
 */
extern xsd_QName wstransfer_DeleteRequestType_qname;
/**
 * Type information for serializing and deserializing wstransfer_DeleteRequestType elements
 * @ingroup wstransfer_DeleteRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_DeleteRequestType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_DeleteRequestType
 * elements
 * @ingroup wstransfer_DeleteRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_DeleteRequestType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_DeleteRequestType without surrounding elements
 * @ingroup wstransfer_DeleteRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_DeleteRequestType_contents_info;


#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wstransfer_DeleteType_array.h"
#include "wstransfer_DeleteOptionsType.h"
#include "wstransfer_DeleteRequestType_array.h"

/**
 * @defgroup wstransfer_DeleteRequestType Complex type: wstransfer_DeleteRequestType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_DeleteRequestType complex type
 * @ingroup wstransfer_DeleteRequestType
 */
struct wstransfer_DeleteRequestType_s
{
   /** Optional xsd_int subelement */
    xsd_int_o concurrency;
   /** Optional xsd_int subelement */
    xsd_int_o maxAttempts;
   /** Optional xsd_dateTime subelement */
    xsd_dateTime_o finishBy;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o transferCredentialEndpoint;
   /** Array of [1 .. Infinity] wstransfer_DeleteType elements */
    wstransfer_DeleteType_array deletion;
   /** Optional wstransfer_DeleteOptionsType subelement */
    wstransfer_DeleteOptionsType_o deleteOptions;

};

/**
 * Initialize a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 *
 * Allocates a new wstransfer_DeleteRequestType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_DeleteRequestType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_DeleteRequestType_init(
    wstransfer_DeleteRequestType ** inst);

/**
 * Destroy a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 *
 * Frees a wstransfer_DeleteRequestType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_DeleteRequestType_destroy(
    wstransfer_DeleteRequestType * inst);

/**
 * Copy a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 *
 * Perform a deep copy of a wstransfer_DeleteRequestType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_DeleteRequestType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_DeleteRequestType to be copied.
 */
globus_result_t
wstransfer_DeleteRequestType_copy(
    wstransfer_DeleteRequestType ** dest,
    const wstransfer_DeleteRequestType * src);

/**
 * Initialize the contents of a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 *
 * Initialize the contents of a wstransfer_DeleteRequestType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_DeleteRequestType_init(). The contents may be freed
 * by calling wstransfer_DeleteRequestType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_DeleteRequestType.
 */
globus_result_t
wstransfer_DeleteRequestType_init_contents(
    wstransfer_DeleteRequestType * instance);

/**
 * Destroy the contents of a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 *
 * Destroy the subelements and attributes of the given wstransfer_DeleteRequestType. 
 *
 * @param inst
 *     Pointer to a wstransfer_DeleteRequestType instance to destroy.
 */
void
wstransfer_DeleteRequestType_destroy_contents(
    wstransfer_DeleteRequestType * inst);

/**
 * Copy the contents of a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 *
 * Perform a deep copy of the contents of a wstransfer_DeleteRequestType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_DeleteRequestType to be copied.
 */
globus_result_t
wstransfer_DeleteRequestType_copy_contents(
    wstransfer_DeleteRequestType * dest,
    const wstransfer_DeleteRequestType * src);

/**
 * Serialize a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType_array
 * Serialize a wstransfer_DeleteRequestType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_DeleteRequestType.
 * @param val
 *     The wstransfer_DeleteRequestType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_DeleteRequestType_serialize(
    xsd_QName *                         element_name,
    wstransfer_DeleteRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType_array
 * Serialize a wstransfer_DeleteRequestType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_DeleteRequestType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_DeleteRequestType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_DeleteRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 * Deserialize an element containing a wstransfer_DeleteRequestType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_DeleteRequestType.
 * @param val
 *     Pointer to the wstransfer_DeleteRequestType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_DeleteRequestType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_DeleteRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 * Deserialize a wstransfer_DeleteRequestType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_DeleteRequestType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_DeleteRequestType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_DeleteRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_DeleteRequestType
 * @ingroup wstransfer_DeleteRequestType
 * Deserialize the next element if it contains a wstransfer_DeleteRequestType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_DeleteRequestType.
 * @param instance
 *     Pointer to the <code>wstransfer_DeleteRequestType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_DeleteRequestType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_DeleteRequestType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_DeleteRequestType_init_wrapper(
    void **                             object);
    
void
wstransfer_DeleteRequestType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_DeleteRequestType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_DeleteRequestType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_DeleteRequestType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_DeleteRequestType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_DeleteRequestType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_DeleteRequestType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_DeleteRequestType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_DeleteRequestType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
