/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_OVERALLSTATUS_H_
#define _WSTRANSFER_OVERALLSTATUS_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_OverallStatus complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}OverallStatus element.
 * @ingroup wstransfer_OverallStatus
 */
typedef struct wstransfer_OverallStatus_s wstransfer_OverallStatus;
/**
 * The wstransfer_OverallStatus_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}OverallStatus element.
 * @ingroup wstransfer_OverallStatus
 */
typedef wstransfer_OverallStatus * wstransfer_OverallStatus_o;

/**
 * Namespace of the wstransfer_OverallStatus complex type
 * @ingroup wstransfer_OverallStatus
 */
#define WSTRANSFER_OVERALLSTATUS_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_OverallStatus complex type
 * @ingroup wstransfer_OverallStatus
 */
#define WSTRANSFER_OVERALLSTATUS_LOCAL "OverallStatus"

/**
 * QName of the wstransfer_OverallStatus complex type
 * @ingroup wstransfer_OverallStatus
 */
extern xsd_QName wstransfer_OverallStatus_qname;
/**
 * Type information for serializing and deserializing wstransfer_OverallStatus elements
 * @ingroup wstransfer_OverallStatus
 */
extern struct globus_xsd_type_info_s wstransfer_OverallStatus_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_OverallStatus
 * elements
 * @ingroup wstransfer_OverallStatus
 */
extern struct globus_xsd_type_info_s wstransfer_OverallStatus_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_OverallStatus without surrounding elements
 * @ingroup wstransfer_OverallStatus
 */
extern struct globus_xsd_type_info_s wstransfer_OverallStatus_contents_info;


#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "wstransfer_RFTFaultResourcePropertyType.h"
#include "wstransfer_OverallStatus_array.h"

/**
 * @defgroup wstransfer_OverallStatus Complex type: wstransfer_OverallStatus
 * @ingroup types
 */

/**
 * C structure for the wstransfer_OverallStatus complex type
 * @ingroup wstransfer_OverallStatus
 */
struct wstransfer_OverallStatus_s
{
    /** xsd_int subelement */
    xsd_int transfersFinished;
    /** xsd_int subelement */
    xsd_int transfersRestarted;
    /** xsd_int subelement */
    xsd_int transfersFailed;
    /** xsd_int subelement */
    xsd_int transfersActive;
    /** xsd_int subelement */
    xsd_int transfersPending;
    /** xsd_int subelement */
    xsd_int transfersCancelled;
   /** Optional wstransfer_RFTFaultResourcePropertyType subelement */
    wstransfer_RFTFaultResourcePropertyType_o fault;

};

/**
 * Initialize a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 *
 * Allocates a new wstransfer_OverallStatus and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_OverallStatus_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_OverallStatus_init(
    wstransfer_OverallStatus ** inst);

/**
 * Destroy a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 *
 * Frees a wstransfer_OverallStatus. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_OverallStatus_destroy(
    wstransfer_OverallStatus * inst);

/**
 * Copy a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 *
 * Perform a deep copy of a wstransfer_OverallStatus.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_OverallStatus structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_OverallStatus to be copied.
 */
globus_result_t
wstransfer_OverallStatus_copy(
    wstransfer_OverallStatus ** dest,
    const wstransfer_OverallStatus * src);

/**
 * Initialize the contents of a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 *
 * Initialize the contents of a wstransfer_OverallStatus. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_OverallStatus_init(). The contents may be freed
 * by calling wstransfer_OverallStatus_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_OverallStatus.
 */
globus_result_t
wstransfer_OverallStatus_init_contents(
    wstransfer_OverallStatus * instance);

/**
 * Destroy the contents of a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 *
 * Destroy the subelements and attributes of the given wstransfer_OverallStatus. 
 *
 * @param inst
 *     Pointer to a wstransfer_OverallStatus instance to destroy.
 */
void
wstransfer_OverallStatus_destroy_contents(
    wstransfer_OverallStatus * inst);

/**
 * Copy the contents of a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 *
 * Perform a deep copy of the contents of a wstransfer_OverallStatus.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_OverallStatus to be copied.
 */
globus_result_t
wstransfer_OverallStatus_copy_contents(
    wstransfer_OverallStatus * dest,
    const wstransfer_OverallStatus * src);

/**
 * Serialize a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus_array
 * Serialize a wstransfer_OverallStatus structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_OverallStatus.
 * @param val
 *     The wstransfer_OverallStatus to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_OverallStatus_serialize(
    xsd_QName *                         element_name,
    wstransfer_OverallStatus * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus_array
 * Serialize a wstransfer_OverallStatus structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_OverallStatus to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_OverallStatus_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_OverallStatus * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 * Deserialize an element containing a wstransfer_OverallStatus element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_OverallStatus.
 * @param val
 *     Pointer to the wstransfer_OverallStatus which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_OverallStatus_deserialize(
    xsd_QName *                         element_name,
    wstransfer_OverallStatus * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 * Deserialize a wstransfer_OverallStatus whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_OverallStatus which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_OverallStatus_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_OverallStatus * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_OverallStatus
 * @ingroup wstransfer_OverallStatus
 * Deserialize the next element if it contains a wstransfer_OverallStatus.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_OverallStatus.
 * @param instance
 *     Pointer to the <code>wstransfer_OverallStatus *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_OverallStatus_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_OverallStatus ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_OverallStatus_init_wrapper(
    void **                             object);
    
void
wstransfer_OverallStatus_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_OverallStatus_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_OverallStatus_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_OverallStatus_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_OverallStatus_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_OverallStatus_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_OverallStatus_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_OverallStatus_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_OverallStatus_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
