/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_REQUESTSTATUSTYPE_H_
#define _WSTRANSFER_REQUESTSTATUSTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_RequestStatusType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}RequestStatusType element.
 * @ingroup wstransfer_RequestStatusType
 */
typedef struct wstransfer_RequestStatusType_s wstransfer_RequestStatusType;
/**
 * The wstransfer_RequestStatusType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}RequestStatusType element.
 * @ingroup wstransfer_RequestStatusType
 */
typedef wstransfer_RequestStatusType * wstransfer_RequestStatusType_o;

/**
 * Namespace of the wstransfer_RequestStatusType complex type
 * @ingroup wstransfer_RequestStatusType
 */
#define WSTRANSFER_REQUESTSTATUSTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_RequestStatusType complex type
 * @ingroup wstransfer_RequestStatusType
 */
#define WSTRANSFER_REQUESTSTATUSTYPE_LOCAL "RequestStatusType"

/**
 * QName of the wstransfer_RequestStatusType complex type
 * @ingroup wstransfer_RequestStatusType
 */
extern xsd_QName wstransfer_RequestStatusType_qname;
/**
 * Type information for serializing and deserializing wstransfer_RequestStatusType elements
 * @ingroup wstransfer_RequestStatusType
 */
extern struct globus_xsd_type_info_s wstransfer_RequestStatusType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_RequestStatusType
 * elements
 * @ingroup wstransfer_RequestStatusType
 */
extern struct globus_xsd_type_info_s wstransfer_RequestStatusType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_RequestStatusType without surrounding elements
 * @ingroup wstransfer_RequestStatusType
 */
extern struct globus_xsd_type_info_s wstransfer_RequestStatusType_contents_info;


#include "wstransfer_RequestStatusTypeEnumeration.h"
#include "wstransfer_RFTFaultResourcePropertyType.h"
#include "wstransfer_RequestStatusType_array.h"

/**
 * @defgroup wstransfer_RequestStatusType Complex type: wstransfer_RequestStatusType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_RequestStatusType complex type
 * @ingroup wstransfer_RequestStatusType
 */
struct wstransfer_RequestStatusType_s
{
    /** wstransfer_RequestStatusTypeEnumeration subelement */
    wstransfer_RequestStatusTypeEnumeration requestStatus;
   /** Optional wstransfer_RFTFaultResourcePropertyType subelement */
    wstransfer_RFTFaultResourcePropertyType_o fault;

};

/**
 * Initialize a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 *
 * Allocates a new wstransfer_RequestStatusType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_RequestStatusType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_RequestStatusType_init(
    wstransfer_RequestStatusType ** inst);

/**
 * Destroy a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 *
 * Frees a wstransfer_RequestStatusType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_RequestStatusType_destroy(
    wstransfer_RequestStatusType * inst);

/**
 * Copy a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 *
 * Perform a deep copy of a wstransfer_RequestStatusType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_RequestStatusType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_RequestStatusType to be copied.
 */
globus_result_t
wstransfer_RequestStatusType_copy(
    wstransfer_RequestStatusType ** dest,
    const wstransfer_RequestStatusType * src);

/**
 * Initialize the contents of a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 *
 * Initialize the contents of a wstransfer_RequestStatusType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_RequestStatusType_init(). The contents may be freed
 * by calling wstransfer_RequestStatusType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_RequestStatusType.
 */
globus_result_t
wstransfer_RequestStatusType_init_contents(
    wstransfer_RequestStatusType * instance);

/**
 * Destroy the contents of a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 *
 * Destroy the subelements and attributes of the given wstransfer_RequestStatusType. 
 *
 * @param inst
 *     Pointer to a wstransfer_RequestStatusType instance to destroy.
 */
void
wstransfer_RequestStatusType_destroy_contents(
    wstransfer_RequestStatusType * inst);

/**
 * Copy the contents of a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 *
 * Perform a deep copy of the contents of a wstransfer_RequestStatusType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_RequestStatusType to be copied.
 */
globus_result_t
wstransfer_RequestStatusType_copy_contents(
    wstransfer_RequestStatusType * dest,
    const wstransfer_RequestStatusType * src);

/**
 * Serialize a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType_array
 * Serialize a wstransfer_RequestStatusType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_RequestStatusType.
 * @param val
 *     The wstransfer_RequestStatusType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_RequestStatusType_serialize(
    xsd_QName *                         element_name,
    wstransfer_RequestStatusType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType_array
 * Serialize a wstransfer_RequestStatusType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_RequestStatusType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_RequestStatusType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_RequestStatusType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 * Deserialize an element containing a wstransfer_RequestStatusType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_RequestStatusType.
 * @param val
 *     Pointer to the wstransfer_RequestStatusType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RequestStatusType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_RequestStatusType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 * Deserialize a wstransfer_RequestStatusType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_RequestStatusType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RequestStatusType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_RequestStatusType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_RequestStatusType
 * @ingroup wstransfer_RequestStatusType
 * Deserialize the next element if it contains a wstransfer_RequestStatusType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_RequestStatusType.
 * @param instance
 *     Pointer to the <code>wstransfer_RequestStatusType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_RequestStatusType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_RequestStatusType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_RequestStatusType_init_wrapper(
    void **                             object);
    
void
wstransfer_RequestStatusType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_RequestStatusType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_RequestStatusType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_RequestStatusType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_RequestStatusType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_RequestStatusType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_RequestStatusType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_RequestStatusType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_RequestStatusType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
