/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_TRANSFERREQUESTTYPE_H_
#define _WSTRANSFER_TRANSFERREQUESTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_TransferRequestType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}TransferRequestType element.
 * @ingroup wstransfer_TransferRequestType
 */
typedef struct wstransfer_TransferRequestType_s wstransfer_TransferRequestType;
/**
 * The wstransfer_TransferRequestType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}TransferRequestType element.
 * @ingroup wstransfer_TransferRequestType
 */
typedef wstransfer_TransferRequestType * wstransfer_TransferRequestType_o;

/**
 * Namespace of the wstransfer_TransferRequestType complex type
 * @ingroup wstransfer_TransferRequestType
 */
#define WSTRANSFER_TRANSFERREQUESTTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_TransferRequestType complex type
 * @ingroup wstransfer_TransferRequestType
 */
#define WSTRANSFER_TRANSFERREQUESTTYPE_LOCAL "TransferRequestType"

/**
 * QName of the wstransfer_TransferRequestType complex type
 * @ingroup wstransfer_TransferRequestType
 */
extern xsd_QName wstransfer_TransferRequestType_qname;
/**
 * Type information for serializing and deserializing wstransfer_TransferRequestType elements
 * @ingroup wstransfer_TransferRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferRequestType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_TransferRequestType
 * elements
 * @ingroup wstransfer_TransferRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferRequestType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_TransferRequestType without surrounding elements
 * @ingroup wstransfer_TransferRequestType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferRequestType_contents_info;


#include "xsd_int.h"
#include "xsd_int.h"
#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wstransfer_TransferType_array.h"
#include "wstransfer_RFTOptionsType.h"
#include "xsd_boolean.h"
#include "wstransfer_TransferRequestType_array.h"

/**
 * @defgroup wstransfer_TransferRequestType Complex type: wstransfer_TransferRequestType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_TransferRequestType complex type
 * @ingroup wstransfer_TransferRequestType
 */
struct wstransfer_TransferRequestType_s
{
   /** Optional xsd_int subelement */
    xsd_int_o concurrency;
   /** Optional xsd_int subelement */
    xsd_int_o maxAttempts;
   /** Optional xsd_dateTime subelement */
    xsd_dateTime_o finishBy;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o transferCredentialEndpoint;
   /** Array of [1 .. Infinity] wstransfer_TransferType elements */
    wstransfer_TransferType_array transfer;
   /** Optional wstransfer_RFTOptionsType subelement */
    wstransfer_RFTOptionsType_o rftOptions;
   /** Optional xsd_boolean subelement */
    xsd_boolean_o allOrNone;

};

/**
 * Initialize a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 *
 * Allocates a new wstransfer_TransferRequestType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_TransferRequestType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_TransferRequestType_init(
    wstransfer_TransferRequestType ** inst);

/**
 * Destroy a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 *
 * Frees a wstransfer_TransferRequestType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_TransferRequestType_destroy(
    wstransfer_TransferRequestType * inst);

/**
 * Copy a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 *
 * Perform a deep copy of a wstransfer_TransferRequestType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_TransferRequestType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_TransferRequestType to be copied.
 */
globus_result_t
wstransfer_TransferRequestType_copy(
    wstransfer_TransferRequestType ** dest,
    const wstransfer_TransferRequestType * src);

/**
 * Initialize the contents of a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 *
 * Initialize the contents of a wstransfer_TransferRequestType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_TransferRequestType_init(). The contents may be freed
 * by calling wstransfer_TransferRequestType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_TransferRequestType.
 */
globus_result_t
wstransfer_TransferRequestType_init_contents(
    wstransfer_TransferRequestType * instance);

/**
 * Destroy the contents of a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 *
 * Destroy the subelements and attributes of the given wstransfer_TransferRequestType. 
 *
 * @param inst
 *     Pointer to a wstransfer_TransferRequestType instance to destroy.
 */
void
wstransfer_TransferRequestType_destroy_contents(
    wstransfer_TransferRequestType * inst);

/**
 * Copy the contents of a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 *
 * Perform a deep copy of the contents of a wstransfer_TransferRequestType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_TransferRequestType to be copied.
 */
globus_result_t
wstransfer_TransferRequestType_copy_contents(
    wstransfer_TransferRequestType * dest,
    const wstransfer_TransferRequestType * src);

/**
 * Serialize a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType_array
 * Serialize a wstransfer_TransferRequestType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_TransferRequestType.
 * @param val
 *     The wstransfer_TransferRequestType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_TransferRequestType_serialize(
    xsd_QName *                         element_name,
    wstransfer_TransferRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType_array
 * Serialize a wstransfer_TransferRequestType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_TransferRequestType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_TransferRequestType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_TransferRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 * Deserialize an element containing a wstransfer_TransferRequestType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_TransferRequestType.
 * @param val
 *     Pointer to the wstransfer_TransferRequestType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferRequestType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_TransferRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 * Deserialize a wstransfer_TransferRequestType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_TransferRequestType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferRequestType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_TransferRequestType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_TransferRequestType
 * @ingroup wstransfer_TransferRequestType
 * Deserialize the next element if it contains a wstransfer_TransferRequestType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_TransferRequestType.
 * @param instance
 *     Pointer to the <code>wstransfer_TransferRequestType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferRequestType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_TransferRequestType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_TransferRequestType_init_wrapper(
    void **                             object);
    
void
wstransfer_TransferRequestType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_TransferRequestType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_TransferRequestType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_TransferRequestType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_TransferRequestType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_TransferRequestType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_TransferRequestType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_TransferRequestType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_TransferRequestType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
