/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSTRANSFER_TRANSFERTRANSIENTFAULTTYPE_H_
#define _WSTRANSFER_TRANSFERTRANSIENTFAULTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wstransfer_TransferTransientFaultType complex type, which represents the
 * {http://www.globus.org/namespaces/2004/10/rft}TransferTransientFaultType element.
 * @ingroup wstransfer_TransferTransientFaultType
 */
typedef struct wstransfer_TransferTransientFaultType_s wstransfer_TransferTransientFaultType;
/**
 * The wstransfer_TransferTransientFaultType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/namespaces/2004/10/rft}TransferTransientFaultType element.
 * @ingroup wstransfer_TransferTransientFaultType
 */
typedef wstransfer_TransferTransientFaultType * wstransfer_TransferTransientFaultType_o;

/**
 * Namespace of the wstransfer_TransferTransientFaultType complex type
 * @ingroup wstransfer_TransferTransientFaultType
 */
#define WSTRANSFER_TRANSFERTRANSIENTFAULTTYPE_NS "http://www.globus.org/namespaces/2004/10/rft"
/**
 * Local part of the QName of the wstransfer_TransferTransientFaultType complex type
 * @ingroup wstransfer_TransferTransientFaultType
 */
#define WSTRANSFER_TRANSFERTRANSIENTFAULTTYPE_LOCAL "TransferTransientFaultType"

/**
 * QName of the wstransfer_TransferTransientFaultType complex type
 * @ingroup wstransfer_TransferTransientFaultType
 */
extern xsd_QName wstransfer_TransferTransientFaultType_qname;
/**
 * Type information for serializing and deserializing wstransfer_TransferTransientFaultType elements
 * @ingroup wstransfer_TransferTransientFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferTransientFaultType_info;
/**
 * Type information for serializing and deserializing arrays of wstransfer_TransferTransientFaultType
 * elements
 * @ingroup wstransfer_TransferTransientFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferTransientFaultType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wstransfer_TransferTransientFaultType without surrounding elements
 * @ingroup wstransfer_TransferTransientFaultType
 */
extern struct globus_xsd_type_info_s wstransfer_TransferTransientFaultType_contents_info;


#include "xsd_dateTime.h"
#include "wsa_EndpointReferenceType.h"
#include "wsbf_ErrorCodeType.h"
#include "wsbf_DescriptionType_array.h"
#include "wsbf_BaseFaultType_array.h"
#include "wstransfer_TransferTransientFaultType_array.h"

/**
 * @defgroup wstransfer_TransferTransientFaultType Complex type: wstransfer_TransferTransientFaultType
 * @ingroup types
 */

/**
 * C structure for the wstransfer_TransferTransientFaultType complex type
 * @ingroup wstransfer_TransferTransientFaultType
 */
struct wstransfer_TransferTransientFaultType_s
{
    /** xsd_dateTime subelement */
    xsd_dateTime Timestamp;
   /** Optional wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType_o Originator;
   /** Optional wsbf_ErrorCodeType subelement */
    wsbf_ErrorCodeType_o ErrorCode;
   /** Array of [0 .. Infinity] wsbf_DescriptionType elements */
    wsbf_DescriptionType_array Description;
   /** Array of [0 .. Infinity] wsbf_BaseFaultType elements */
    wsbf_BaseFaultType_array FaultCause;

};

/**
 * Initialize a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 *
 * Allocates a new wstransfer_TransferTransientFaultType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wstransfer_TransferTransientFaultType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wstransfer_TransferTransientFaultType_init(
    wstransfer_TransferTransientFaultType ** inst);

/**
 * Destroy a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 *
 * Frees a wstransfer_TransferTransientFaultType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wstransfer_TransferTransientFaultType_destroy(
    wstransfer_TransferTransientFaultType * inst);

/**
 * Copy a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 *
 * Perform a deep copy of a wstransfer_TransferTransientFaultType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wstransfer_TransferTransientFaultType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wstransfer_TransferTransientFaultType to be copied.
 */
globus_result_t
wstransfer_TransferTransientFaultType_copy(
    wstransfer_TransferTransientFaultType ** dest,
    const wstransfer_TransferTransientFaultType * src);

/**
 * Initialize the contents of a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 *
 * Initialize the contents of a wstransfer_TransferTransientFaultType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wstransfer_TransferTransientFaultType_init(). The contents may be freed
 * by calling wstransfer_TransferTransientFaultType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wstransfer_TransferTransientFaultType.
 */
globus_result_t
wstransfer_TransferTransientFaultType_init_contents(
    wstransfer_TransferTransientFaultType * instance);

/**
 * Destroy the contents of a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 *
 * Destroy the subelements and attributes of the given wstransfer_TransferTransientFaultType. 
 *
 * @param inst
 *     Pointer to a wstransfer_TransferTransientFaultType instance to destroy.
 */
void
wstransfer_TransferTransientFaultType_destroy_contents(
    wstransfer_TransferTransientFaultType * inst);

/**
 * Copy the contents of a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 *
 * Perform a deep copy of the contents of a wstransfer_TransferTransientFaultType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wstransfer_TransferTransientFaultType to be copied.
 */
globus_result_t
wstransfer_TransferTransientFaultType_copy_contents(
    wstransfer_TransferTransientFaultType * dest,
    const wstransfer_TransferTransientFaultType * src);

/**
 * Serialize a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType_array
 * Serialize a wstransfer_TransferTransientFaultType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wstransfer_TransferTransientFaultType.
 * @param val
 *     The wstransfer_TransferTransientFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_TransferTransientFaultType_serialize(
    xsd_QName *                         element_name,
    wstransfer_TransferTransientFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType_array
 * Serialize a wstransfer_TransferTransientFaultType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wstransfer_TransferTransientFaultType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wstransfer_TransferTransientFaultType_serialize_contents(
    xsd_QName *                         element_name,
    wstransfer_TransferTransientFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 * Deserialize an element containing a wstransfer_TransferTransientFaultType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_TransferTransientFaultType.
 * @param val
 *     Pointer to the wstransfer_TransferTransientFaultType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferTransientFaultType_deserialize(
    xsd_QName *                         element_name,
    wstransfer_TransferTransientFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 * Deserialize a wstransfer_TransferTransientFaultType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wstransfer_TransferTransientFaultType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferTransientFaultType_deserialize_contents(
    xsd_QName *                         element_name,
    wstransfer_TransferTransientFaultType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wstransfer_TransferTransientFaultType
 * @ingroup wstransfer_TransferTransientFaultType
 * Deserialize the next element if it contains a wstransfer_TransferTransientFaultType.
 *
 * @param element_name
 *     The name of the element which should enclose the wstransfer_TransferTransientFaultType.
 * @param instance
 *     Pointer to the <code>wstransfer_TransferTransientFaultType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wstransfer_TransferTransientFaultType_deserialize_pointer(
    xsd_QName *                         element_name,
    wstransfer_TransferTransientFaultType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wstransfer_TransferTransientFaultType_init_wrapper(
    void **                             object);
    
void
wstransfer_TransferTransientFaultType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_TransferTransientFaultType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_TransferTransientFaultType_init_contents_wrapper(
    void *                              object);
    
void
wstransfer_TransferTransientFaultType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wstransfer_TransferTransientFaultType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wstransfer_TransferTransientFaultType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_TransferTransientFaultType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wstransfer_TransferTransientFaultType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wstransfer_TransferTransientFaultType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
